Notebook[{Cell[CellGroupData[{Cell["FeynCalc 5.1", "Title", 
      TextAlignment -> Center], 
     Cell["Tools for quantum field theory calculations", "Subtitle", 
      TextAlignment -> Center], Cell[TextData[
       StyleBox["Reference Guide", Rule[FontWeight, "Bold"]]], "Subtitle", 
      PageBreakBelow -> True, TextAlignment -> Center], 
     Cell["Rolf Mertig and Frederik Orellana", "Subsubtitle", 
      TextAlignment -> Center], Cell[TextData[{"HTML version: ", 
        ButtonBox["http://www.feyncalc.org/", 
          RuleDelayed[ButtonData, List[URL["http://www.feyncalc.org/"], 
            None]], Rule[ButtonStyle, "Hyperlink"], 
          Rule[ButtonNote, "http://www.feyncalc.org/"]]}], "Subsubtitle", 
      TextAlignment -> Center], Cell[BoxData[
       ButtonBox[\(Click\ to\ save\ this\ notebook\ without\ cache\ and\ 
           FrontEndVersion\ info\), 
         RuleDelayed[ButtonFunction, 
          CompoundExpression[Module[List[fn], 
            CompoundExpression[SetDirectory[DirectoryName[Set[fn, 
                ToFileName[ReplaceAll["FileName", 
                  NotebookInformation[InputNotebook[]]]]]]], 
             Set[newfn, StringReplace[fn, Rule[".nb", "NoCache.nb"]]], 
             If[UnsameQ[FileNames[newfn], List[]], DeleteFile[newfn]], 
             Put[ReplaceAll[NotebookGet[InputNotebook[]], 
               List[RuleDelayed[Condition[Rule[FrontEndVersion, 
                   Pattern[v, Blank[]]], Equal[Head[v], String]], 
                 Sequence[]], RuleDelayed[Condition[Rule[CellLabel, 
                   Pattern[v, Blank[]]], Equal[Head[v], String]], 
                 Sequence[]]]], "fcr.nb"], CopyFile["fcr.nb", newfn], 
             DeleteFile["fcr.nb"]]]]], Rule[ButtonEvaluator, Automatic]]], 
      "NotebookDefault", Active -> True, CellTags -> "ClickSave"], 
     Cell[CellGroupData[{Cell[BoxData[\(Date[]\)], "Input"], Cell[BoxData[
          \(TraditionalForm\`\({2006, 4, 2, 23, 24, 
                35.4843872`9.302612203248454}\)\)], "Output"]}, Open]], 
     Cell[CellGroupData[{Cell["Functions", "Section", 
         CellTags -> "Functions"], Cell["Evaluation time and memory usage", 
         "Commentary"], 
        Cell["This is only for timing purposes and can be omitted in \
general.", "Text"], Cell[CellGroupData[{Cell[BoxData[
             \(absolutestarttime = \(AbsoluteTime[]\)\)], "Input"], 
           Cell[BoxData[
             \(TraditionalForm\`3.3530090755244448`17.27800971808679*^9\)], 
            "Output"]}, Open]], Cell["<<HighEnergyPhysics`FeynCalc`", 
         "Input"], Cell["Abbreviation", "ObjectName", PageBreakAbove -> True, 
         CellTags -> "Abbreviation"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Abbreviation"], 
           Cell["Abbreviation is a function used by OneLoop and PaVeReduce \
for generating smaller files when saving results to the hard disk. The \
convention is that a definition like GP = GluonPropagator should be \
accompanied by the definition Abbreviation[GluonPropagator] = HoldForm[GP].", 
            "Text", CellTags -> "Abbreviation"], 
           Cell[TextData[{"See also:  ", 
              ButtonBox["$Abbreviations", 
                RuleDelayed[ButtonData, "$Abbreviations"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "$Abbreviations"]], ", ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, ", ", 
              ButtonBox["PaVeReduce", RuleDelayed[ButtonData, "PaVeReduce"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeReduce"]], ", ", 
              ButtonBox["WriteOut", RuleDelayed[ButtonData, "WriteOut"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "WriteOut"]], ", ", 
              ButtonBox["WriteOutPaVe", 
                RuleDelayed[ButtonData, "WriteOutPaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "WriteOutPaVe"]], ", ", 
              ButtonBox["GluonPropagator", 
                RuleDelayed[ButtonData, "GluonPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonPropagator"]], ", ", 
              ButtonBox["GluonVertex", RuleDelayed[ButtonData, 
                 "GluonVertex"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonVertex"]], ", ", 
              ButtonBox["QuarkPropagator", 
                RuleDelayed[ButtonData, "QuarkPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "QuarkPropagator"]], "."}], "Text", 
            CellTags -> "Abbreviation"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Abbreviation"], Cell[CellGroupData[{Cell[BoxData[
                \(GP[\(p,\ \({\[Mu],\ a}\),\ \({\[Nu],\ b}\)\)]\)], "Input", 
               CellTags -> "Abbreviation"], Cell[BoxData[
                \(TraditionalForm\`\(\[CapitalPi]\_\(ab\)\%\(\[Mu]\[Nu]\)(p)
                    \)\)], "Output", CellTags -> "Abbreviation"]}, Open]]}, 
          Open]], Cell["Amplitude", "ObjectName", CellTags -> "Amplitude"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Amplitude"], Cell["Amplitude is a database of \
Feynman amplitudes. Amplitude[\"name\"] returns the amplitude corresponding \
to the string \"name\". A list of all defined names is obtained with \
Amplitude[]. New amplitudes can be added to the file \"Amplitude.m\". It is \
strongly recommended to use names that reflect the process. The option Gauge \
\[Rule] 1 means `t Hooft Feynman gauge; Polarization \[Rule] 0 gives \
unpolarized OPE-type amplitudes, Polarization \[Rule] 1 the polarized ones.", 
            "Text", CellTags -> "Amplitude"], Cell[CellGroupData[
             {Cell[BoxData[\(Options[Amplitude]\)], "Input", CellTags -> 
                "Amplitude"], Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] D\), 
                      \(Gauge \[Rule] 1\), \(QuarkMass \[Rule] 0\), 
                      \(Polarization \[Rule] 1\)}\)\)], "Output", CellTags -> 
                "Amplitude"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynAmp", RuleDelayed[ButtonData, "FeynAmp"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FeynAmp"]]\
, "."}], "Text", CellTags -> "Amplitude"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Amplitude"], Cell[CellGroupData[{Cell[BoxData[
                \(\(Amplitude[]\)//Length\)], "Input", CellTags -> 
                "Amplitude"], Cell[BoxData[\(TraditionalForm\`207\)], 
               "Output", CellTags -> "Amplitude"]}, Open]], 
           Cell["This is the amplitude of a gluon self-energy diagram:", 
            "Text", CellTags -> "Amplitude"], Cell[CellGroupData[
             {Cell[BoxData[\(Amplitude["se1g1"]\)], "Input", CellTags -> 
                "Amplitude"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(\[CapitalPi]\_\(cd\)\%\(\[Alpha]\[Rho]\)\), "(", 
                     FormBox[\(p - q\), "TraditionalForm"], ")"}], " ", 
                   \(\[CapitalPi]\_\(ef\)\%\(\[Beta]\[Sigma]\)(q)\), " ", 
                   RowBox[{SuperscriptBox["V", RowBox[{FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]}]], "(", 
                     RowBox[{FormBox[\(-p\), "TraditionalForm"], \(,\ \), 
                       FormBox[\(p - q\), "TraditionalForm"], \(,\ \), 
                       FormBox["q", "TraditionalForm"]}], ")"}], " ", 
                   RowBox[{SuperscriptBox["V", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Beta]", 
                          "TraditionalForm"], "TraditionalForm"]}]], "(", 
                     RowBox[{FormBox["p", "TraditionalForm"], \(,\ \), 
                       FormBox[\(q - p\), "TraditionalForm"], \(,\ \), 
                       FormBox[\(-q\), "TraditionalForm"]}], ")"}], " ", 
                   SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["e", "TraditionalForm"], 
                       "TraditionalForm"]}]], " ", SubscriptBox["f", 
                    RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["d", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["f", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Amplitude"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Explicit[%]\)], "Input", 
               CellTags -> "Amplitude"], Cell[BoxData[FormBox[RowBox[
                  {"-", RowBox[{\(1\/\(\((p - q)\)\^2\ q\^2\)\), RowBox[
                      {"(", RowBox[{\(g\_s\%2\), " ", 
                         \(g\^\(\[Alpha]\[Rho]\)\), " ", 
                         \(g\^\(\[Beta]\[Sigma]\)\), " ", RowBox[{"(", 
                          RowBox[{RowBox[{RowBox[{"(", RowBox[{RowBox[{"-", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", SuperscriptBox[FormBox[
                          "q", "TraditionalForm"], FormBox[FormBox[
                          "\[Alpha]", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}], " ", 
                          \(g\^\(\[Beta]\[Mu]\)\)}], "+", RowBox[{
                          \(g\^\(\[Alpha]\[Mu]\)\), " ", RowBox[{"(", RowBox[
                          {RowBox[{"2", " ", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Beta]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                          SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Beta]", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}], "+", RowBox[{
                          \(g\^\(\[Alpha]\[Beta]\)\), " ", RowBox[{"(", 
                          RowBox[{RowBox[{"2", " ", SuperscriptBox[FormBox[
                          "q", "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}]}], ")"}], " ", 
                         RowBox[{"(", RowBox[{RowBox[{RowBox[{"(", RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], "-", RowBox[{"2", " ", 
                          SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", 
                          \(g\^\(\[Rho]\[Sigma]\)\)}], "+", RowBox[{
                          \(g\^\(\[Nu]\[Sigma]\)\), " ", RowBox[{"(", RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]], "+", SuperscriptBox[FormBox[
                          "q", "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]]}], ")"}]}], 
                          "+", RowBox[{\(g\^\(\[Nu]\[Rho]\)\), " ", RowBox[
                          {"(", RowBox[{SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]], "-", 
                          RowBox[{"2", " ", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]]}]}], 
                          ")"}]}]}], ")"}], " ", SubscriptBox["\[Delta]", 
                          RowBox[{FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "e", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["f", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["f", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}]}]}], 
                 TraditionalForm]], "Output", CellTags -> "Amplitude"]}, 
             Open]], Cell[TextData[
             {"This is the amplitude for graph 6.2 from the paper Z.Phys C ", 
              StyleBox["70:", Rule[FontWeight, "Bold"]], "637-654, 1996:"}], 
            "Text", CellTags -> "Amplitude"], Cell[CellGroupData[
             {Cell[BoxData[
                \(FeynAmp[\(q1, q2, \(EpsEvaluate[
                       \(Trick[\(Explicit[\(Amplitude["gg2"]\)]\)]\)]\)\)]\)]\
, "Input", CellTags -> "Amplitude"], Cell[BoxData[FormBox[RowBox[
                  {"\[Integral]", RowBox[{StyleBox[RowBox[{
                        \(\[DifferentialD]\^D\), FormBox[
                         \(\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1\), 
                         "TraditionalForm"]}], ZeroWidthTimes -> True], 
                     "\[Integral]", RowBox[{\(\[DifferentialD]\^D\), FormBox[
                        \(\(\*TagBox[StyleBox["\"q\"", 
                               Rule[FontSlant, "Italic"]], 
                              Function[StyleForm[Slot[1], 
                                Rule[FontSlant, "Italic"]]]]\)\_2\), 
                        "TraditionalForm"]}]}], "(", FormBox[RowBox[
                     {RowBox[{"(", RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                          \(g\_s\%4\), " ", SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox[FormBox[\(\[Lambda]\_1\), 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox[\(\[Lambda]\_5\), "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]], " ", RowBox[{"(", RowBox[
                          {RowBox[{RowBox[{"(", RowBox[{RowBox[{"2", " ", 
                          SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], ")"}], 
                          " ", \(g\^\(\[Lambda]\_7 \[Lambda]\_10\)\)}], "+", 
                          RowBox[{\(g\^\(\[Nu] \[Lambda]\_10\)\), " ", RowBox[
                          {"(", RowBox[{RowBox[{"2", " ", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], FormBox[FormBox[
                          \(\[Lambda]\_7\), "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox[\(\[Lambda]\_7\), "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}], "+", RowBox[{
                          \(g\^\(\[Nu] \[Lambda]\_7\)\), " ", RowBox[{"(", 
                          RowBox[{RowBox[{"-", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox[
                          \(\[Lambda]\_10\), "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox[\(\[Lambda]\_10\), "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}]}], ")"}], " ", 
                          RowBox[{"(", RowBox[{RowBox[{RowBox[{"(", RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "-", RowBox[{"2", " ", 
                          SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", 
                          \(g\^\(\[Lambda]\_1 \[Lambda]\_11\)\)}], "+", 
                          RowBox[{\(g\^\(\[Mu] \[Lambda]\_11\)\), " ", RowBox[
                          {"(", RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox[\(\[Lambda]\_1\), "TraditionalForm"], 
                          "TraditionalForm"]], "-", RowBox[{"2", " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox[\(\[Lambda]\_1\), 
                          "TraditionalForm"], "TraditionalForm"]]}]}], 
                          ")"}]}], "+", RowBox[{\(g\^\(\[Mu] \[Lambda]\_1\)\)
                          , " ", RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox[
                          \(\[Lambda]\_11\), "TraditionalForm"], 
                          "TraditionalForm"]], "+", SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox[\(\[Lambda]\_11\), "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}]}], ")"}], " ", 
                          RowBox[{"(", RowBox[{RowBox[{RowBox[{"(", RowBox[
                          {RowBox[{"-", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox[
                          \(\[Lambda]\_10\), "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox[\(\[Lambda]\_10\), "TraditionalForm"], 
                          "TraditionalForm"]], "+", RowBox[{"2", " ", 
                          SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox[\(\[Lambda]\_10\), "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", 
                          \(g\^\(\[Lambda]\_11 \[Lambda]\_12\)\)}], "+", 
                          RowBox[{\(g\^\(\[Lambda]\_10 \[Lambda]\_12\)\), 
                          " ", RowBox[{"(", RowBox[{RowBox[{"-", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox[\(\[Lambda]\_11\), 
                          "TraditionalForm"], "TraditionalForm"]]}], "+", 
                          RowBox[{"2", " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox[\(\[Lambda]\_11\), "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox[\(\[Lambda]\_11\), "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}], "+", RowBox[{
                          \(g\^\(\[Lambda]\_10 \[Lambda]\_11\)\), " ", RowBox[
                          {"(", RowBox[{RowBox[{"2", " ", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], FormBox[FormBox[
                          \(\[Lambda]\_12\), "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox[\(\[Lambda]\_12\), "TraditionalForm"], 
                          "TraditionalForm"]], "-", SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox[\(\[Lambda]\_12\), "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}]}], ")"}], " ", 
                          RowBox[{"(", RowBox[{RowBox[{RowBox[{"(", RowBox[
                          {SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox[\(\[Lambda]\_5\), "TraditionalForm"], 
                          "TraditionalForm"]], "-", RowBox[{"2", " ", 
                          SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox[\(\[Lambda]\_5\), "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", 
                          \(g\^\(\[Lambda]\_7 \[Lambda]\_12\)\)}], "+", 
                          RowBox[{\(g\^\(\[Lambda]\_5 \[Lambda]\_12\)\), " ", 
                          RowBox[{"(", RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox[\(\[Lambda]\_7\), "TraditionalForm"], 
                          "TraditionalForm"]], "-", RowBox[{"2", " ", 
                          SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox[\(\[Lambda]\_7\), "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}]}], "+", RowBox[{
                          \(g\^\(\[Lambda]\_5 \[Lambda]\_7\)\), " ", RowBox[
                          {"(", RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox[\(\[Lambda]\_12\), "TraditionalForm"], 
                          "TraditionalForm"]], "+", SubsuperscriptBox[
                          TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox[\(\[Lambda]\_12\), "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}]}], ")"}], " ", 
                          RowBox[{"(", RowBox[{"1", "-", FormBox[
                          \(\((\(-1\))\)\^m\), "TraditionalForm"]}], ")"}], 
                          " ", FormBox[SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}], ")"}], \(m - 1\)], 
                          "TraditionalForm"], " ", SubscriptBox["f", RowBox[
                          {FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox[\("c"\_5\), 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox[\("c"\_11\), "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox[\("c"\_7\), 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox[\("c"\_10\), "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox[\("c"\_5\), 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox[\("c"\_7\), "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox[\("c"\_12\), 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          SubscriptBox["f", RowBox[{FormBox[FormBox[
                          \("c"\_10\), "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox[\("c"\_11\), 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox[\("c"\_12\), "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}], "/", 
                      \(\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1\%2 . 
                         \(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2\%2 . 
                         \(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2\%2 . 
                         \((\(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^
                          2 . \((\(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_1 - 
                             \(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_2)\)\^2 . 
                         \((\(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^
                          2\)}], "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> "Amplitude"]}, 
             Open]]}, Open]], Cell["Amputate", "ObjectName", 
         CellTags -> "Amputate"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Amputate"], 
           Cell["Amputate[exp,q1,q2,...] amputates Eps and DiracGamma. \
Amputate[exp,q1,q2,Pair\[Rule]{p}] amputates also p.q1 and p.q2; \
Pair\[Rule]All amputates all except OPEDelta.", "Text", CellTags -> 
             "Amputate"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[Amputate]\)], "Input", CellTags -> "Amputate"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] D\), 
                      \(Pair \[Rule] \({}\)\), \(Unique \[Rule] True\)}\)\)], 
               "Output", CellTags -> "Amputate"]}, Open]], 
           Cell[TextData[{"See also:  ", 
              ButtonBox["DiracGamma", RuleDelayed[ButtonData, "DiracGamma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGamma"]], ", ", 
              ButtonBox["DiracMatrix", RuleDelayed[ButtonData, 
                 "DiracMatrix"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracMatrix"]], ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["DiracSlash", RuleDelayed[ButtonData, "DiracSlash"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSlash"]], ", ", 
              ButtonBox["DiracTrick", RuleDelayed[ButtonData, "DiracTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrick"]], "."}], "Text", 
            CellTags -> "Amputate"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Amputate"], Cell[CellGroupData[{Cell[BoxData[
                \(\(DiracSlash[p]\) . \(DiracSlash[q]\)\)], "Input", 
               CellTags -> "Amputate"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                        "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                        "TraditionalForm"]}], ")"}], ".", RowBox[{"(", 
                     RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "Amputate"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Amputate[\(%, q\)]\)], "Input", CellTags -> "Amputate"], 
              Cell[BoxData[FormBox[RowBox[{RowBox[{RowBox[{"(", RowBox[
                        {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                       ")"}], ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        \($AL$20 \[InvisibleApplication] \((1)\)\), 
                        "TraditionalForm"], "TraditionalForm"]]}], " ", 
                   SuperscriptBox[FormBox["q", "TraditionalForm"], FormBox[
                     FormBox[\($AL$20 \[InvisibleApplication] \((1)\)\), 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "Amputate"]}, 
             Open]]}, Open]], Cell["AnomalousDimension", "ObjectName", 
         CellTags -> "AnomalousDimension"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "AnomalousDimension"], Cell["AnomalousDimension[name] \
is a database of anomalous dimensions of twist 2 operators.", "Text", 
            CellTags -> "AnomalousDimension"], Cell[CellGroupData[
             {Cell[BoxData[\(Options[AnomalousDimension]\)], "Input", 
               CellTags -> "AnomalousDimension"], Cell[BoxData[
                \(TraditionalForm\`\({\(Polarization \[Rule] 1\), 
                      \(Simplify \[Rule] FullSimplify\)}\)\)], "Output", 
               CellTags -> "AnomalousDimension"]}, Open]], 
           Cell[TextData[{"See also: ", 
              ButtonBox["SplittingFunction", 
                RuleDelayed[ButtonData, "SplittingFunction"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SplittingFunction"]], ", ", 
              ButtonBox["SumS", RuleDelayed[ButtonData, "SumS"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SumS"]], 
              ", ", 
              ButtonBox["SumT", RuleDelayed[ButtonData, "SumT"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SumT"]], 
              "."}], "Text", CellTags -> "AnomalousDimension"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "AnomalousDimension"], Cell["Polarized case:", 
            "Text", CellTags -> "AnomalousDimension"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\ \(AnomalousDimension, 
                     \(Polarization \[Rule] 1\)\)]\)], "Input", CellTags -> 
                "AnomalousDimension"], Cell[BoxData[
                \(TraditionalForm\`\({\(Polarization \[Rule] 1\), 
                      \(Simplify \[Rule] FullSimplify\)}\)\)], "Output", 
               CellTags -> "AnomalousDimension"]}, Open]], 
           Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\(NS, qq\ \)\%\(\((0)\)\ \)\)]], 
              "polarized:"}], "Text", CellTags -> "AnomalousDimension"], 
           Cell[CellGroupData[{Cell[BoxData[\(AnomalousDimension[gnsqq0]\)], 
               "Input", CellTags -> "AnomalousDimension"], Cell[BoxData[
                FormBox[RowBox[{\(C\_F\), " ", RowBox[{"(", RowBox[
                      {RowBox[{"8", " ", RowBox[{\(S\_1\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], "+", 
                       \(4\/m\), "+", \(4\/\(m + 1\)\), "-", "6"}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "AnomalousDimension"]}, Open]], Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\(S, qg\ \)\%\(\((0)\)\ \)\)]], 
              "polarized:"}], "Text", CellTags -> "AnomalousDimension"], 
           Cell[CellGroupData[{Cell[BoxData[\(AnomalousDimension[gsqg0]\)], 
               "Input", CellTags -> "AnomalousDimension"], Cell[BoxData[
                \(TraditionalForm\`\(\((8\/m - 16\/\(m + 1\))\)\ T\_f\)\)], 
               "Output", CellTags -> "AnomalousDimension"]}, Open]], 
           Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\(S, gq\ \)\%\(\((0)\)\ \)\)]], 
              "polarized:"}], "Text", CellTags -> "AnomalousDimension"], 
           Cell[CellGroupData[{Cell[BoxData[\(AnomalousDimension[gsgq0]\)], 
               "Input", CellTags -> "AnomalousDimension"], Cell[BoxData[
                \(TraditionalForm\`\(C\_F\ \((4\/\(m + 1\) - 8\/m)\)\)\)], 
               "Output", CellTags -> "AnomalousDimension"]}, Open]], 
           Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\(S, gg\ \)\%\(\((0)\)\ \)\)]], 
              "polarized:"}], "Text", CellTags -> "AnomalousDimension"], 
           Cell[CellGroupData[{Cell[BoxData[\(AnomalousDimension[gsgg0]\)], 
               "Input", CellTags -> "AnomalousDimension"], Cell[BoxData[
                FormBox[RowBox[{\(\(8\ T\_f\)\/3\), "+", RowBox[{\(C\_A\), 
                     " ", RowBox[{"(", RowBox[{RowBox[{"8", " ", RowBox[{
                          \(S\_1\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "-", \(8\/m\), "+", 
                         \(16\/\(m + 1\)\), "-", \(22\/3\)}], ")"}]}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "AnomalousDimension"]}, Open]], Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\(PS, qq\ \)\%\(\((0)\)\ \)\)]], 
              "polarized:"}], "Text", CellTags -> "AnomalousDimension"], 
           Cell[CellGroupData[{Cell[BoxData[\(AnomalousDimension[gpsqq1]\)], 
               "Input", CellTags -> "AnomalousDimension"], Cell[BoxData[
                \(TraditionalForm\`\(16\ C\_F\ 
                     \((1\/\(m + 1\) + 3\/\((m + 1)\)\^2 + 2\/\((m + 1)\)\^3 
                        - 1\/m - 1\/m\^2 + 2\/m\^3)\)\ T\_f\)\)], "Output", 
               CellTags -> "AnomalousDimension"]}, Open]], 
           Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\(NS, qq\ \)\%\(\((1)\)\ \)\)]], 
              "polarized:"}], "Text", CellTags -> "AnomalousDimension"], 
           Cell[CellGroupData[{Cell[BoxData[\(AnomalousDimension[gnsqq1]\)], 
               "Input", CellTags -> "AnomalousDimension"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{RowBox[{"-", RowBox[{"(", RowBox[
                          {FractionBox[RowBox[{"16", " ", RowBox[{\(S\_1\), 
                          "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], \(m\^2\)], "+", FractionBox[RowBox[{"16", 
                          " ", RowBox[{\(S\_1\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], \(\((m + 1)\)\^2\)], 
                          "+", FractionBox[RowBox[{"16", " ", RowBox[{\(S\_2\)
                          , "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], "m"], "+", FractionBox[RowBox[{"16", " ", 
                          RowBox[{\(S\_2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], \(m + 1\)], "-", 
                          RowBox[{"24", " ", RowBox[{\(S\_2\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], "+", 
                          RowBox[{"32", " ", RowBox[{\(S\_12\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], "+", 
                          RowBox[{"32", " ", RowBox[{\(S\_21\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], "+", 
                          FractionBox[RowBox[{"32", " ", RowBox[{
                          \(\(S\&~\)\_2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "m"], "+", FractionBox[
                          RowBox[{"32", " ", RowBox[{\(\(S\&~\)\_2\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                          \(m + 1\)], "-", RowBox[{"32", " ", RowBox[{
                          \(\(S\&~\)\_3\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "+", RowBox[{"64", 
                          " ", RowBox[{\(\(S\&~\)\_12\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], "-", 
                          \(40\/m\), "+", \(40\/\(m + 1\)\), "+", 
                          \(16\/\((m + 1)\)\^2\), "+", \(8\/m\^3\), "+", 
                          \(40\/\((m + 1)\)\^3\), "+", "3"}], ")"}]}], " ", 
                     \(C\_F\%2\)}], "-", RowBox[{\(N\_f\), " ", RowBox[
                      {"(", RowBox[{RowBox[{\(80\/9\), " ", RowBox[{\(S\_1\), 
                          "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], "-", RowBox[{\(16\/3\), " ", RowBox[{
                          \(S\_2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "-", \(8\/\(9\ m\)\), 
                         "+", \(88\/\(9\ \((m + 1)\)\)\), "-", 
                         \(8\/\(3\ m\^2\)\), "-", \(8\/\(3\ \((m + 1)\)\^2\)\)
                         , "-", \(2\/3\)}], ")"}], " ", \(C\_F\)}], "-", 
                   RowBox[{\(C\_A\), " ", RowBox[{"(", RowBox[{RowBox[{
                          \(-\(536\/9\)\), " ", RowBox[{\(S\_1\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                         "+", RowBox[{\(88\/3\), " ", RowBox[{\(S\_2\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                         "-", RowBox[{"16", " ", RowBox[{\(S\_3\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                         "-", FractionBox[RowBox[{"16", " ", RowBox[{
                          \(\(S\&~\)\_2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "m"], "-", FractionBox[
                          RowBox[{"16", " ", RowBox[{\(\(S\&~\)\_2\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                          \(m + 1\)], "+", RowBox[{"16", " ", RowBox[{
                          \(\(S\&~\)\_3\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "-", RowBox[{"32", 
                          " ", RowBox[{\(\(S\&~\)\_12\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], "+", 
                         \(212\/\(9\ m\)\), "-", \(748\/\(9\ \((m + 1)\)\)\), 
                         "+", \(44\/\(3\ m\^2\)\), "-", 
                         \(4\/\(3\ \((m + 1)\)\^2\)\), "-", 
                         \(16\/\((m + 1)\)\^3\), "+", \(17\/3\)}], ")"}], 
                     " ", \(C\_F\)}]}], TraditionalForm]], "Output", 
               CellTags -> "AnomalousDimension"]}, Open]], 
           Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\(S, qg\ \)\%\(\((1)\)\ \)\)]], 
              "polarized:"}], "Text", CellTags -> "AnomalousDimension"], 
           Cell[CellGroupData[{Cell[BoxData[\(AnomalousDimension[gsqg1]\)], 
               "Input", CellTags -> "AnomalousDimension"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"8", " ", \(C\_F\), " ", \(T\_f\), 
                     " ", RowBox[{"(", RowBox[{FractionBox[RowBox[{"2", " ", 
                          RowBox[{\(S\_1\%2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "m"], "-", FractionBox[
                          RowBox[{"4", " ", RowBox[{\(S\_1\%2\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], \(m + 1\)], 
                         "-", FractionBox[RowBox[{"2", " ", RowBox[{\(S\_2\), 
                          "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], "m"], "+", FractionBox[RowBox[{"4", " ", 
                          RowBox[{\(S\_2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], \(m + 1\)], "+", 
                         \(14\/m\), "-", \(19\/\(m + 1\)\), "-", \(1\/m\^2\), 
                         "-", \(8\/\((m + 1)\)\^2\), "-", \(2\/m\^3\), "+", 
                         \(4\/\((m + 1)\)\^3\)}], ")"}]}], "+", RowBox[
                    {"16", " ", \(C\_A\), " ", \(T\_f\), " ", RowBox[
                      {"(", RowBox[{RowBox[{"-", FractionBox[RowBox[{
                          \(S\_1\%2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}], "m"]}], "+", FractionBox[
                          RowBox[{"2", " ", RowBox[{\(S\_1\%2\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], \(m + 1\)], 
                         "-", FractionBox[RowBox[{"2", " ", RowBox[{\(S\_1\), 
                          "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], \(m\^2\)], "+", FractionBox[RowBox[
                          {"4", " ", RowBox[{\(S\_1\), "(", FormBox[\(m - 1\)
                          , "TraditionalForm"], ")"}]}], \(\((m + 1)\)\^2\)], 
                         "-", FractionBox[RowBox[{\(S\_2\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}], "m"], "+", 
                         FractionBox[RowBox[{"2", " ", RowBox[{\(S\_2\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                          \(m + 1\)], "-", FractionBox[RowBox[{"2", " ", 
                          RowBox[{\(\(S\&~\)\_2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "m"], "+", FractionBox[
                          RowBox[{"4", " ", RowBox[{\(\(S\&~\)\_2\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                          \(m + 1\)], "-", \(4\/m\), "+", \(3\/\(m + 1\)\), 
                         "-", \(3\/m\^2\), "+", \(8\/\((m + 1)\)\^2\), "+", 
                         \(2\/m\^3\), "+", \(12\/\((m + 1)\)\^3\)}], 
                       ")"}]}]}], TraditionalForm]], "Output", CellTags -> 
                "AnomalousDimension"]}, Open]], Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\(S, gq\ \)\%\(\((1)\)\ \)\)]], 
              "polarized:"}], "Text", CellTags -> "AnomalousDimension"], 
           Cell[CellGroupData[{Cell[BoxData[\(AnomalousDimension[gsgq1]\)], 
               "Input", CellTags -> "AnomalousDimension"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"4", " ", RowBox[{"(", RowBox[
                        {FractionBox[RowBox[{"4", " ", RowBox[{\(S\_1\%2\), 
                          "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], "m"], "-", FractionBox[RowBox[{"2", " ", 
                          RowBox[{\(S\_1\%2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], \(m + 1\)], "-", 
                         FractionBox[RowBox[{"8", " ", RowBox[{\(S\_1\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                          "m"], "+", FractionBox[RowBox[{"2", " ", RowBox[{
                          \(S\_1\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], \(m + 1\)], "+", 
                         FractionBox[RowBox[{"8", " ", RowBox[{\(S\_1\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                          \(m\^2\)], "-", FractionBox[RowBox[{"4", " ", 
                          RowBox[{\(S\_1\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], \(\((m + 1)\)\^2\)], 
                         "+", FractionBox[RowBox[{"4", " ", RowBox[{\(S\_2\), 
                          "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], "m"], "-", FractionBox[RowBox[{"2", " ", 
                          RowBox[{\(S\_2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], \(m + 1\)], "+", 
                         \(15\/m\), "-", \(6\/\(m + 1\)\), "-", \(12\/m\^2\), 
                         "+", \(3\/\((m + 1)\)\^2\), "+", \(4\/m\^3\), "-", 
                         \(2\/\((m + 1)\)\^3\)}], ")"}], " ", \(C\_F\%2\)}], 
                   "+", RowBox[{"32", " ", \(T\_f\), " ", RowBox[{"(", 
                       RowBox[{RowBox[{"-", FractionBox[RowBox[{"2", " ", 
                          RowBox[{\(S\_1\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], \(3\ m\)]}], "+", 
                         FractionBox[RowBox[{\(S\_1\), "(", FormBox[\(m - 1\)
                          , "TraditionalForm"], ")"}], \(3\ \((m + 1)\)\)], 
                         "+", \(7\/\(9\ m\)\), "-", \(2\/\(9\ \((m + 1)\)\)\)
                         , "-", \(2\/\(3\ m\^2\)\), "+", 
                         \(1\/\(3\ \((m + 1)\)\^2\)\)}], ")"}], " ", \(C\_F\)}
                     ], "+", RowBox[{"8", " ", \(C\_A\), " ", RowBox[
                      {"(", RowBox[{RowBox[{"-", FractionBox[RowBox[{"2", 
                          " ", RowBox[{\(S\_1\%2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "m"]}], "+", 
                         FractionBox[RowBox[{\(S\_1\%2\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}], \(m + 1\)], 
                         "+", FractionBox[RowBox[{"16", " ", RowBox[{\(S\_1\)
                          , "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], \(3\ m\)], "-", FractionBox[RowBox[
                          {"5", " ", RowBox[{\(S\_1\), "(", FormBox[\(m - 1\)
                          , "TraditionalForm"], ")"}]}], \(3\ \((m + 1)\)\)], 
                         "+", FractionBox[RowBox[{"2", " ", RowBox[{\(S\_2\), 
                          "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], "m"], "-", FractionBox[RowBox[{\(S\_2\), 
                          "(", FormBox[\(m - 1\), "TraditionalForm"], ")"}], 
                          \(m + 1\)], "+", FractionBox[RowBox[{"4", " ", 
                          RowBox[{\(\(S\&~\)\_2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "m"], "-", FractionBox[
                          RowBox[{"2", " ", RowBox[{\(\(S\&~\)\_2\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                          \(m + 1\)], "-", \(56\/\(9\ m\)\), "-", 
                         \(20\/\(9\ \((m + 1)\)\)\), "+", \(28\/\(3\ m\^2\)\)
                         , "-", \(38\/\(3\ \((m + 1)\)\^2\)\), "-", 
                         \(4\/m\^3\), "-", \(6\/\((m + 1)\)\^3\)}], ")"}], 
                     " ", \(C\_F\)}]}], TraditionalForm]], "Output", 
               CellTags -> "AnomalousDimension"]}, Open]], 
           Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\(S, gg\ \)\%\(\((1)\)\ \)\)]], 
              "polarized:"}], "Text", CellTags -> "AnomalousDimension"], 
           Cell[CellGroupData[{Cell[BoxData[\(AnomalousDimension[gsgg1]\)], 
               "Input", CellTags -> "AnomalousDimension"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"4", " ", RowBox[{"(", RowBox[
                        {FractionBox[RowBox[{"8", " ", RowBox[{\(S\_1\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                          \(m\^2\)], "-", FractionBox[RowBox[{"16", " ", 
                          RowBox[{\(S\_1\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], \(\((m + 1)\)\^2\)], 
                         "+", RowBox[{\(134\/9\), " ", RowBox[{\(S\_1\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                         "+", FractionBox[RowBox[{"8", " ", RowBox[{\(S\_2\), 
                          "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], "m"], "-", FractionBox[RowBox[{"16", " ", 
                          RowBox[{\(S\_2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], \(m + 1\)], "+", 
                         RowBox[{"4", " ", RowBox[{\(S\_3\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], "-", 
                         RowBox[{"8", " ", RowBox[{\(S\_12\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], "-", 
                         RowBox[{"8", " ", RowBox[{\(S\_21\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], "+", 
                         FractionBox[RowBox[{"8", " ", RowBox[{\(\(S\&~\)\_2\)
                          , "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], "m"], "-", FractionBox[RowBox[{"16", " ", 
                          RowBox[{\(\(S\&~\)\_2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], \(m + 1\)], "+", 
                         RowBox[{"4", " ", RowBox[{\(\(S\&~\)\_3\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                         "-", RowBox[{"8", " ", RowBox[{\(\(S\&~\)\_12\), 
                          "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], "-", \(107\/\(9\ m\)\), "+", 
                         \(241\/\(9\ \((m + 1)\)\)\), "+", \(58\/\(3\ m\^2\)\)
                         , "-", \(86\/\(3\ \((m + 1)\)\^2\)\), "-", 
                         \(8\/m\^3\), "-", \(48\/\((m + 1)\)\^3\), "-", 
                         \(16\/3\)}], ")"}], " ", \(C\_A\%2\)}], "+", 
                   RowBox[{"32", " ", \(T\_f\), " ", RowBox[{"(", RowBox[
                        {RowBox[{\(-\(5\/9\)\), " ", RowBox[{\(S\_1\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                         "+", \(14\/\(9\ m\)\), "-", 
                         \(19\/\(9\ \((m + 1)\)\)\), "-", \(1\/\(3\ m\^2\)\), 
                         "-", \(1\/\(3\ \((m + 1)\)\^2\)\), "+", \(1\/3\)}], 
                       ")"}], " ", \(C\_A\)}], "+", 
                   \(8\ C\_F\ \((\(-\(10\/\(m + 1\)\)\) + 2\/\((m + 1)\)\^2 +
                          4\/\((m + 1)\)\^3 + 1 + 10\/m - 10\/m\^2 + 4\/m\^3)
                   \)\ T\_f\)}], TraditionalForm]], "Output", CellTags -> 
                "AnomalousDimension"]}, Open]], Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\(S, gg\ \)\%\(\((1)\)\ \)\)]], 
              "polarized (different representation):"}], "Text", 
            CellTags -> "AnomalousDimension"], Cell[CellGroupData[
             {Cell[BoxData[\(AnomalousDimension[GSGG1]\)], "Input", 
               CellTags -> "AnomalousDimension"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{"4", " ", RowBox[{"(", RowBox[{
                         \(-\(\(\(m\ \((\(m\ \(
                                        (\(m\ 
                                           \((
                                           \(m\ 
                                           \((\(48\ m\ \((m + 3)\)\) + 469)\)
                         \) + 698)\)\) + 7)\)\) + 258)\)\) + 144\)\/
                              \(9\ m\^3\ \((m + 1)\)\^3\)\)\), "+", 
                         FractionBox[RowBox[{"8", " ", RowBox[{\(S\_2\%'\), 
                          "\[NoBreak]", "(", "\[NoBreak]", FormBox[\(m\/2\), 
                          "TraditionalForm"], "\[NoBreak]", ")"}]}], 
                          \(m\ \((m + 1)\)\)], "-", RowBox[{\(S\_3\%'\), 
                          "\[NoBreak]", "(", "\[NoBreak]", FormBox[\(m\/2\), 
                          "TraditionalForm"], "\[NoBreak]", ")"}], "+", 
                         FractionBox[RowBox[{"2", " ", 
                          \((\(m\ \((\(67\ m\ \((m + 1)\)\^2\) + 144)\)\) + 
                              72)\), " ", RowBox[{\(S\_1\), "(", FormBox["m", 
                          "TraditionalForm"], ")"}]}], 
                          \(9\ m\^2\ \((m + 1)\)\^2\)], "-", RowBox[{"4", 
                          " ", RowBox[{\(S\_2\%'\), "\[NoBreak]", "(", 
                          "\[NoBreak]", FormBox[\(m\/2\), "TraditionalForm"], 
                          "\[NoBreak]", ")"}], " ", RowBox[{\(S\_1\), "(", 
                          FormBox["m", "TraditionalForm"], ")"}]}], "+", 
                         RowBox[{"8", " ", RowBox[{\(S\&~\), "(", FormBox[
                          "m", "TraditionalForm"], ")"}]}]}], ")"}], " ", 
                     \(C\_A\%2\)}], "+", RowBox[{"32", " ", \(T\_f\), " ", 
                     RowBox[{"(", RowBox[{
                         \(\(\(m\ \((m + 1)\)\ 
                                \((\(3\ m\ \((m + 1)\)\) + 13)\)\) - 3\)\/
                            \(9\ m\^2\ \((m + 1)\)\^2\)\), "-", FractionBox[
                          RowBox[{"5", " ", RowBox[{\(S\_1\), "(", FormBox[
                          "m", "TraditionalForm"], ")"}]}], "9"]}], ")"}], 
                     " ", \(C\_A\)}], "+", 
                   \(\(8\ C\_F\ \((\(m\ \((
                               \(m\ \((\(m\ 
                                       \((\(m\ \((\(m\ \((m + 3)\)\) + 5)\)\)
                                        + 1)\)\) - 8)\)\) + 2)\)\) + 4)\)\ 
                        T\_f\)\/\(m\^3\ \((m + 1)\)\^3\)\)}], 
                 TraditionalForm]], "Output", CellTags -> 
                "AnomalousDimension"]}, Open]], 
           Cell[TextData[{"Check that all odd moments give the same for the \
two representations of ", Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\(S, gg\ \)\%\(\((1)\)\ \)\)]], 
              ":"}], "Text", CellTags -> "AnomalousDimension"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Table[\(\(\(% - %%\)/.\(OPEm \[Rule] ij\)\), 
                     \({ij, 1, 17, 2}\)\)]\)], "Input", CellTags -> 
                "AnomalousDimension"], Cell[BoxData[
                \(TraditionalForm\`\({0, 0, 0, 0, 0, 0, 0, 0, 0}\)\)], 
               "Output", CellTags -> "AnomalousDimension"]}, Open]]}, Open]], 
        Cell["AntiCommutator", "ObjectName", CellTags -> "AntiCommutator"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "AntiCommutator"], Cell["AntiCommutator[x, y] = c \
defines the anti-commutator of the non commuting objects x and y.", "Text", 
            CellTags -> "AntiCommutator"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Commutator", RuleDelayed[ButtonData, "Commutator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Commutator"]], ", ", 
              ButtonBox["CommutatorExplicit", 
                RuleDelayed[ButtonData, "CommutatorExplicit"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CommutatorExplicit"]], ", ", 
              ButtonBox["DeclareNonCommutative", 
                RuleDelayed[ButtonData, "DeclareNonCommutative"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeclareNonCommutative"]], ", ", 
              ButtonBox["DotSimplify", RuleDelayed[ButtonData, 
                 "DotSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DotSimplify"]], "."}], "Text", 
            CellTags -> "AntiCommutator"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "AntiCommutator"], Cell[TextData[{"This declares ", 
              StyleBox["a", Rule[FontFamily, "Courier"]], " and ", 
              StyleBox["b", Rule[FontFamily, "Courier"]], 
              " as noncommutative variables."}], "Text", CellTags -> 
             "AntiCommutator"], Cell[BoxData[
             \(DeclareNonCommutative[\(a, b\)]\)], "Input", 
            CellTags -> "AntiCommutator"], Cell[CellGroupData[{Cell[BoxData[
                \(AntiCommutator[\(a, b\)]\)], "Input", CellTags -> 
                "AntiCommutator"], Cell[BoxData[
                \(TraditionalForm\`\({a, \[MediumSpace]b}\)\)], "Output", 
               CellTags -> "AntiCommutator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(CommutatorExplicit[%]\)], 
               "Input", CellTags -> "AntiCommutator"], Cell[BoxData[
                \(TraditionalForm\`\(\(a . b\) + \(b . a\)\)\)], "Output", 
               CellTags -> "AntiCommutator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(CommutatorExplicit[\(AntiCommutator[
                     \(\(a + b\), \(a - \(2b\)\ \)\)]\)]\)], "Input", 
               CellTags -> "AntiCommutator"], Cell[BoxData[
                \(TraditionalForm\`\(\(\((a - \(2\ b\))\) . \((a + b)\)\) + 
                     \(\((a + b)\) . \((a - \(2\ b\))\)\)\)\)], "Output", 
               CellTags -> "AntiCommutator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DotSimplify[\(AntiCommutator[
                     \(\(a + b\), \(a - \(2b\)\ \)\)]\)]\)], "Input", 
               CellTags -> "AntiCommutator"], Cell[BoxData[
                \(TraditionalForm\`\(\(2\ \(a . a\)\) - \(a . b\) - \(b . a\)
                      - \(4\ \(b . b\)\)\)\)], "Output", CellTags -> 
                "AntiCommutator"]}, Open]], Cell[BoxData[
             \(DeclareNonCommutative[\(c, d, \(c\&~\), \(d\&~\)\)]\)], 
            "Input", CellTags -> "AntiCommutator"], 
           Cell[
            "Defining {c,d} = z results in replacements of c.d by z-d.c.", 
            "Text", CellTags -> "AntiCommutator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(AntiCommutator[\(c, d\)]\)\ =\ z\)], "Input", CellTags -> 
                "AntiCommutator"], Cell[BoxData[\(TraditionalForm\`z\)], 
               "Output", CellTags -> "AntiCommutator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DotSimplify[\ \(d\ .\ c\ .\ d\)\ ]\)], "Input", CellTags -> 
                "AntiCommutator"], Cell[BoxData[
                \(TraditionalForm\`\(\(d\ z\) - \(d . d . c\)\)\)], "Output", 
               CellTags -> "AntiCommutator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(AntiCommutator[\(\(d\&~\), \(c\&~\)\)]\)\ =\ \(z\&~\)\)], 
               "Input", CellTags -> "AntiCommutator"], Cell[BoxData[
                \(TraditionalForm\`z\&~\)], "Output", CellTags -> 
                "AntiCommutator"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DotSimplify[\ \(\(d\&~\)\ .\ \(c\&~\)\ .\ \(d\&~\)\)\ ]\)], 
               "Input", CellTags -> "AntiCommutator"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(d\&~\)\ \(z\&~\)\) - 
                     \(\(c\&~\) . \(d\&~\) . \(d\&~\)\)\)\)], "Output", 
               CellTags -> "AntiCommutator"]}, Open]], Cell[BoxData[
             \(UnDeclareNonCommutative[\(a, b, c, d, \(c\&~\), \(d\&~\)\)]\)]\
, "Input", CellTags -> "AntiCommutator"], Cell[BoxData[
             \(Unset[\(AntiCommutator[\(c, d\)]\)]\)], "Input", 
            CellTags -> "AntiCommutator"], Cell[BoxData[
             \(Unset[\(AntiCommutator[\(\(d\&~\), \(c\&~\)\)]\)]\)], "Input", 
            CellTags -> "AntiCommutator"]}, Open]], Cell["AntiQuarkField", 
         "ObjectName", CellTags -> "AntiQuarkField"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "AntiQuarkField"], Cell["AntiQuarkField is the name \
of a fermionic field. AntiQuarkField is just a name with no functional \
properties. Only typesetting rules are attached.", "Text", 
            CellTags -> "AntiQuarkField"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["QuantumField", 
                RuleDelayed[ButtonData, "QuantumField"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "QuantumField"]], ", ", 
              ButtonBox["QuarkField", RuleDelayed[ButtonData, "QuarkField"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "QuarkField"]], "."}], "Text", 
            CellTags -> "AntiQuarkField"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "AntiQuarkField"], Cell[CellGroupData[
             {Cell[BoxData["AntiQuarkField"], "Input", CellTags -> 
                "AntiQuarkField"], Cell[BoxData[\(TraditionalForm\`\[Psi]\&_\)
                ], "Output", CellTags -> "AntiQuarkField"]}, Open]]}, Open]], 
        Cell["AntiSymmetrize", "ObjectName", CellTags -> "AntiSymmetrize"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "AntiSymmetrize"], Cell["AntiSymmetrize[expr, {a1, \
a2, ...}] antisymmetrizes expr with respect to the variables a1,a2, ... ", 
            "Text", CellTags -> "AntiSymmetrize"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["Symmetrize", RuleDelayed[ButtonData, "Symmetrize"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Symmetrize"]], "."}], "Text", 
            CellTags -> "AntiSymmetrize"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "AntiSymmetrize"], Cell[CellGroupData[{Cell[BoxData[
                \(AntiSymmetrize[\(\(f[\(a, b\)]\), \({a, b}\)\)]\)], 
               "Input", CellTags -> "AntiSymmetrize"], Cell[BoxData[
                \(TraditionalForm\`\(1\/2\ 
                     \((\(f(\(a, b\))\) - \(f(\(b, a\))\))\)\)\)], "Output", 
               CellTags -> "AntiSymmetrize"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(AntiSymmetrize[\(\(f[\(x, y, z\)]\), \({x, y, z}\)\)]\)], 
               "Input", CellTags -> "AntiSymmetrize"], Cell[BoxData[
                \(TraditionalForm\`\(1\/6\ 
                     \((\(f(\(x, y, z\))\) - \(f(\(x, z, y\))\) - 
                        \(f(\(y, x, z\))\) + \(f(\(y, z, x\))\) + 
                        \(f(\(z, x, y\))\) - \(f(\(z, y, x\))\))\)\)\)], 
               "Output", CellTags -> "AntiSymmetrize"]}, Open]]}, Open]], 
        Cell["Anti5", "ObjectName", CellTags -> "Anti5"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Anti5"], Cell[TextData[
             {"Anti5[exp] anticommutes all ", Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5\)\)]], 
              "in exp to the right. Anti5[exp, n] anticommutes all ", 
              Cell[BoxData[\(TraditionalForm\`\(\[Gamma]\^\(5\ \)\)\)]], 
              "n times to the right. Anti5[exp, -n] anticommutes all ", 
              Cell[BoxData[\(TraditionalForm\`\(\[Gamma]\^5\)\)]], 
              " n times to the left."}], "Text", CellTags -> "Anti5"], 
           Cell[TextData[{"The naive ", Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5\)\)]], "scheme is used."}], 
            "Text", CellTags -> "Anti5"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracOrder", RuleDelayed[ButtonData, "DiracOrder"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracOrder"]], ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["DiracTrick", RuleDelayed[ButtonData, "DiracTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrick"]], "."}], "Text", 
            CellTags -> "Anti5"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Anti5"], Cell[CellGroupData[{Cell[BoxData[
                \(\(DiracMatrix[\(5, \[Mu]\)]\)\ \)], "Input", CellTags -> 
                "Anti5"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5 \[Gamma]\^\[Mu]\)\)], 
               "Output", CellTags -> "Anti5"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Anti5[%]\)], "Input", 
               CellTags -> "Anti5"], Cell[BoxData[FormBox[RowBox[
                  {"-", RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                     ".", \(\[Gamma]\^5\)}]}], TraditionalForm]], "Output", 
               CellTags -> "Anti5"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Anti5[\(%, \(-1\)\)]\)], "Input", CellTags -> 
                "Anti5"], Cell[BoxData[FormBox[RowBox[{\(\[Gamma]\^5\), ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "Anti5"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DiracMatrix[\(5, \[Alpha], \[Beta], \[Gamma], \[Delta]\)]\)]\
, "Input", CellTags -> "Anti5"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5 \[Gamma]\^\[Alpha] 
                     \[Gamma]\^\[Beta] \[Gamma]\^\[Gamma] \[Gamma]\^\[Delta]\
\)\)], "Output", CellTags -> "Anti5"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Anti5[\(%, 2\)]\)], "Input", CellTags -> 
                "Anti5"], Cell[BoxData[FormBox[RowBox[{SuperscriptBox[
                    "\[Gamma]", FormBox[FormBox["\[Alpha]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Beta]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(\[Gamma]\^5\), ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Gamma]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Delta]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "Anti5"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Anti5[\(%%, Infinity\)]\)], "Input", CellTags -> 
                "Anti5"], Cell[BoxData[FormBox[RowBox[{SuperscriptBox[
                    "\[Gamma]", FormBox[FormBox["\[Alpha]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Beta]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Gamma]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Delta]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(\[Gamma]\^5\)}], TraditionalForm]], "Output", 
               CellTags -> "Anti5"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Anti5[\(%, \(-Infinity\)\)]\)], "Input", 
               CellTags -> "Anti5"], Cell[BoxData[FormBox[RowBox[{
                   \(\[Gamma]\^5\), ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Beta]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Gamma]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Delta]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "Anti5"]}, Open]], 
           Cell[TextData[{"In the naive ", Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5\)\)]], 
              "- scheme D-dimensional ", Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\)]], 
              "-matrices anticommute with ", Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5\)\)]], "."}], "Text", 
            CellTags -> "Anti5"], Cell[CellGroupData[{Cell[BoxData[
                \(GAD[\(5, \[Mu]\)]\)], "Input", CellTags -> "Anti5"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5 . \[Gamma]\^\[Mu]\)\)], 
               "Output", CellTags -> "Anti5"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Anti5[%]\)], "Input", 
               CellTags -> "Anti5"], Cell[BoxData[FormBox[RowBox[
                  {"-", RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                     ".", \(\[Gamma]\^5\)}]}], TraditionalForm]], "Output", 
               CellTags -> "Anti5"]}, Open]]}, Open]], 
        Cell["Apart1", "ObjectName", CellTags -> "Apart1"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Apart1"], Cell[TextData[{"Apart1[expr, x] is \
equivalent to Apart[expr, x], but it fixes a ", 
              StyleBox["Mathematica", Rule[FontSlant, "Italic"]], 
              " bug relevant when expr contains complex numbers."}], "Text", 
            CellTags -> "Apart1"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Apart3", RuleDelayed[ButtonData, "Apart3"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Apart3"]], 
              "."}], "Text", CellTags -> "Apart1"]}, Open]], 
        Cell["Apart2", "ObjectName", CellTags -> "Apart2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Apart2"], Cell[
            "Apart2[expr] partial fractions FeynAmpDenominators (and FAD's)."\
, "Text", CellTags -> "Apart2"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[FAD]\)], "Input", CellTags -> "Apart2"], 
              Cell[BoxData[\(TraditionalForm\`\({Dimension \[Rule] D}\)\)], 
               "Output", CellTags -> "Apart2"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FAD", RuleDelayed[ButtonData, "FAD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FAD"]], 
              ", ", 
              ButtonBox["FeynAmpDenominator", 
                RuleDelayed[ButtonData, "FeynAmpDenominator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynAmpDenominator"]], "."}], "Text", 
            CellTags -> "Apart2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Apart2"], Cell[CellGroupData[{Cell[BoxData[
                \(FAD[\(\({q, m}\), \({q, M}\), \(q - p\)\)]\)], "Input", 
               CellTags -> "Apart2"], Cell[BoxData[
                \(TraditionalForm\`\(1\/\(
                      \((\*InterpretationBox[\(
                            "["\[InvisibleSpace] \((q - p)\)\^2 
                             \[InvisibleSpace]"]"\), 
                           SequenceForm["[", 
                            Power[Plus[Times[-1, p], q], 2], "]"], 
                           Rule[Editable, False]])\)\ 
                       \((\*InterpretationBox[\(
                            "["\[InvisibleSpace] q\^2 \[InvisibleSpace]"-"
                             \[InvisibleSpace] m\^2 \[InvisibleSpace]"]"\), 
                           SequenceForm["[", Power[q, 2], "-", Power[m, 2], 
                            "]"], Rule[Editable, False]])\)\ 
                       \((\*InterpretationBox[\(
                            "["\[InvisibleSpace] q\^2 \[InvisibleSpace]"-"
                             \[InvisibleSpace] M\^2 \[InvisibleSpace]"]"\), 
                           SequenceForm["[", Power[q, 2], "-", Power[M, 2], 
                            "]"], Rule[Editable, False]])\)\)\)\)], "Output", 
               CellTags -> "Apart2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Apart2[%]\)], "Input", CellTags -> "Apart2"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(1\/
                        \(\((q\^2 - m\^2)\) . \((q - p)\)\^2\) - 
                       1\/\(\((q\^2 - M\^2)\) . \((q - p)\)\^2\)\)\/
                     \(m\^2 - M\^2\)\)\)], "Output", CellTags -> "Apart2"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(FCE[%]\)]\)], "Input", CellTags -> 
                "Apart2"], Cell[BoxData[
                \(\(\(FAD[\(\({q, m}\), \(\(-p\) + q\)\)]\) - 
                     \(FAD[\(\({q, M}\), \(\(-p\) + q\)\)]\)\)\/
                   \(m\^2 - M\^2\)\)], "Output", CellTags -> "Apart2"]}, 
             Open]]}, Open]], Cell["Apart3", "ObjectName", 
         CellTags -> "Apart3"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Apart3"], 
           Cell["Apart3[expr, x] is equivalent to Map2[Factor2, \
Collect2[Apart1[expr,x],x]].", "Text", CellTags -> "Apart3"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Apart1", RuleDelayed[ButtonData, "Apart1"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Apart1"]], 
              "."}], "Text", CellTags -> "Apart3"]}, Open]], 
        Cell["A0", "ObjectName", PageBreakAbove -> True, CellTags -> "A0"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "A0"], Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`\(A0[\(m\^2\)]\)\)]], 
              "is the Passarino-Veltman one-point integral ", Cell[BoxData[
                \(TraditionalForm\`\(A\_0 .\)\)]]}], "Text", 
            CellTags -> "A0"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[\ A0]\)], "Input", CellTags -> "A0"], Cell[BoxData[
                \(TraditionalForm\`\({A0ToB0 \[Rule] False}\)\)], "Output", 
               CellTags -> "A0"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["B0", RuleDelayed[ButtonData, "B0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B0"]], 
              ", ", 
              ButtonBox["C0", RuleDelayed[ButtonData, "C0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "C0"]], 
              ", ", 
              ButtonBox["D0", RuleDelayed[ButtonData, "D0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "D0"]], 
              ", ", 
              ButtonBox["PaVe", RuleDelayed[ButtonData, "PaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "PaVe"]], 
              "."}], "Text", CellTags -> "A0"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "A0"], Cell[TextData[{"By default ", Cell[BoxData[
                \(TraditionalForm\`A\_0\)]], 
              " is not expressed in terms of ", Cell[BoxData[
                \(TraditionalForm\`B\_0\)]], "."}], "Text", 
            CellTags -> "A0"], Cell[CellGroupData[{Cell[BoxData[
                \(A0[\(m\^2\)]\)], "Input", CellTags -> "A0"], 
              Cell[BoxData[FormBox[RowBox[{FormBox[\("A"\_"0"\), 
                    "TraditionalForm"], "(", FormBox[\(m\^2\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "A0"]}, Open]], Cell[BoxData[
             \(\(SetOptions[\(A0, \(A0ToB0 \[Rule] True\)\)]\) ;\)], "Input", 
            CellTags -> "A0"], Cell[CellGroupData[{Cell[BoxData[
                \(A0[\(m\^2\)]\)], "Input", CellTags -> "A0"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(B\_0 (0, m\^2, m\^2)\)\ m\^2\) + 
                     m\^2\)\)], "Output", CellTags -> "A0"]}, Open]], 
           Cell[BoxData[\(\(SetOptions[\(A0, \(A0ToB0 \[Rule] False\)\)]\) ;\)
             ], "Input", CellTags -> "A0"], Cell[TextData[
             {"According to the rules of dimensional regularization ", 
              Cell[BoxData[\(TraditionalForm\`\(A\_0(0)\)\)]], 
              " is set to 0."}], "Text", CellTags -> "A0"], 
           Cell[CellGroupData[{Cell[BoxData[\(A0[0]\)], "Input", CellTags -> 
                "A0"], Cell[BoxData[\(TraditionalForm\`0\)], "Output", 
               CellTags -> "A0"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(A0[\(SmallVariable[\(M^2\)]\)]\)], "Input", CellTags -> 
                "A0"], Cell[BoxData[\(TraditionalForm\`0\)], "Output", 
               CellTags -> "A0"]}, Open]]}, Open]], Cell["A0ToB0", 
         "ObjectName", PageBreakAbove -> True, CellTags -> "A0ToB0"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "A0ToB0"], Cell[TextData[
             {"A0ToB0 is an option for A0. If set to True, A0[", Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["m", 
                       Rule[FontSlant, "Plain"]]\^2\)\)]], 
              "] is expressed by (1 + B0[0, ", Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["m", 
                       Rule[FontSlant, "Plain"]]\^2\)\)]], ", ", Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["m", 
                       Rule[FontSlant, "Plain"]]\^2\)\)]], "]) ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["m", 
                       Rule[FontSlant, "Plain"]]\^2\)\)]], "."}], "Text", 
            CellTags -> "A0ToB0"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[\ A0]\)], "Input", CellTags -> "A0ToB0"], 
              Cell[BoxData[\(TraditionalForm\`\({A0ToB0 \[Rule] False}\)\)], 
               "Output", CellTags -> "A0ToB0"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["A0", RuleDelayed[ButtonData, "A0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "A0"]], 
              ", ", 
              ButtonBox["B0", RuleDelayed[ButtonData, "B0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B0"]], 
              ", ", 
              ButtonBox["C0", RuleDelayed[ButtonData, "C0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "C0"]], 
              ", ", 
              ButtonBox["D0", RuleDelayed[ButtonData, "D0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "D0"]], 
              ", ", 
              ButtonBox["PaVe", RuleDelayed[ButtonData, "PaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "PaVe"]], 
              "."}], "Text", CellTags -> "A0ToB0"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["BackgroundGluonVertex", "ObjectName", 
         CellTags -> "BackgroundGluonVertex"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "BackgroundGluonVertex"], 
           Cell[TextData[{"BackgroundGluonVertex[{p,mu,a}, {q,nu,b}, \
{k,la,c}] or BackgroundGluonVertex[ p,mu,a , q,nu,b , k,la,c ] yields the \
3-gluon vertex in the background field gauge, where the first set of \
arguments corresponds to the external background field. \
BackgroundGluonVertex[{p,mu,a}, {q,nu,b}, {k,la,c}, {s,si,d}] or \
BackgroundGluonVertex[{mu,a}, {nu,b}, {la,c}, {", "si", ",d}] or \
BackgroundGluonVertex[p,mu,a , q,nu,b , k,la,c , s,si,d] or \
BackgroundGluonVertex[ mu,a , nu,b , la,c , si,d ] yields the 4-gluon vertex, \
with {p,mu,a} and {k,la,c} denoting the external background fields. The \
gauge, dimension and the name of the coupling constant are determined by the \
options Gauge, Dimension and CouplingConstant. The Feynman rules are taken \
from L.Abbot ", StyleBox["NPB ", Rule[FontWeight, "Bold"]], "185 (1981), \
189-203; except that all momenta are incoming. Note that Abbot's coupling \
constant convention is consistent with the default setting of GluonVertex."}]\
, "Text", CellTags -> "BackgroundGluonVertex"], Cell[CellGroupData[
             {Cell[BoxData[\(Options[BackgroundGluonVertex]\)], "Input", 
               CellTags -> "BackgroundGluonVertex"], Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] D\), 
                      \(CouplingConstant \[Rule] g\_s\), \(Gauge \[Rule] 1\)}
                \)\)], "Output", CellTags -> "BackgroundGluonVertex"]}, 
             Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["GluonVertex", RuleDelayed[ButtonData, 
                 "GluonVertex"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonVertex"]], "."}], "Text", 
            CellTags -> "BackgroundGluonVertex"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "BackgroundGluonVertex"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(BackgroundGluonVertex[\(
                    \({p, \[Mu], a}\), \({q, \[Nu], b}\), 
                     \({k, \[Lambda], c}\)\)]\)], "Input", CellTags -> 
                "BackgroundGluonVertex"], Cell[BoxData[FormBox[RowBox[{
                   \(g\_s\), " ", RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[
                          RowBox[{"(", FormBox[RowBox[{"p", "-", FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "q"}], "TraditionalForm"], 
                          ")"}], FormBox[FormBox["\[Lambda]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         \(g\^\(\[Mu]\[Nu]\)\)}], "+", RowBox[{
                         \(g\^\(\[Lambda]\[Nu]\)\), " ", SuperscriptBox[
                          RowBox[{"(", FormBox[RowBox[{"q", "-", FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"]}], "TraditionalForm"], ")"}], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{
                         \(g\^\(\[Lambda]\[Mu]\)\), " ", SuperscriptBox[
                          RowBox[{"(", FormBox[RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "p", "+", "q"}], 
                          "TraditionalForm"], ")"}], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}]}], ")"}], 
                   " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "BackgroundGluonVertex"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(BackgroundGluonVertex[\(
                    \({p, \[Mu], a}\), \({q, \[Nu], b}\), 
                     \({k, \[Lambda], c}\), \({s, \[Sigma], d}\)\)]\)], 
               "Input", CellTags -> "BackgroundGluonVertex"], 
              Cell[BoxData[FormBox[RowBox[{\(-\[ImaginaryI]\), " ", 
                   \(g\_s\%2\), " ", RowBox[{"(", RowBox[{RowBox[{
                         \((\(g\^\(\[Lambda]\[Sigma]\)\ g\^\(\[Mu]\[Nu]\)\) -
                              \(g\^\(\[Lambda]\[Nu]\)\ g\^\(\[Mu]\[Sigma]\)\)
                              - \(g\^\(\[Lambda]\[Mu]\)\ g\^\(\[Nu]\[Sigma]\)
                              \))\), " ", SubscriptBox["f", RowBox[
                          {FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["u6", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["u6", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], "+", RowBox[{
                         \((\(g\^\(\[Lambda]\[Sigma]\)\ g\^\(\[Mu]\[Nu]\)\) -
                              \(g\^\(\[Lambda]\[Nu]\)\ g\^\(\[Mu]\[Sigma]\)\)\
)\), " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["u6", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["u6", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], "+", RowBox[{
                         \((\(g\^\(\[Lambda]\[Sigma]\)\ g\^\(\[Mu]\[Nu]\)\) -
                              \(g\^\(\[Lambda]\[Nu]\)\ g\^\(\[Mu]\[Sigma]\)\)
                              + \(g\^\(\[Lambda]\[Mu]\)\ g\^\(\[Nu]\[Sigma]\)
                              \))\), " ", SubscriptBox["f", RowBox[
                          {FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["u6", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["u6", "TraditionalForm"], 
                          "TraditionalForm"]}]]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "BackgroundGluonVertex"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(BackgroundGluonVertex[\(
                    \({p, \[Mu], a}\), \({q, \[Nu], b}\), 
                     \({k, \[Lambda], c}\), \(Gauge \[Rule] \[Alpha]\)\)]\)], 
               "Input", CellTags -> "BackgroundGluonVertex"], 
              Cell[BoxData[FormBox[RowBox[{\(g\_s\), " ", RowBox[{"(", 
                     RowBox[{RowBox[{SuperscriptBox[RowBox[{"(", FormBox[
                          RowBox[{"p", "-", FractionBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "\[Alpha]"], "-", "q"}], 
                          "TraditionalForm"], ")"}], FormBox[FormBox[
                          "\[Lambda]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(\[Mu]\[Nu]\)\)}], 
                       "+", RowBox[{\(g\^\(\[Lambda]\[Nu]\)\), " ", 
                         SuperscriptBox[RowBox[{"(", FormBox[RowBox[{"q", 
                          "-", FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"]}], "TraditionalForm"], ")"}], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{
                         \(g\^\(\[Lambda]\[Mu]\)\), " ", SuperscriptBox[
                          RowBox[{"(", FormBox[RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "p", "+", \(q\/\[Alpha]\)}]
                          , "TraditionalForm"], ")"}], FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", SubscriptBox[
                    "f", RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "BackgroundGluonVertex"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(BackgroundGluonVertex[\(
                    \({p, \[Mu], a}\), \({q, \[Nu], b}\), 
                     \({k, \[Lambda], c}\), \({s, \[Sigma], d}\), 
                     \(Gauge \[Rule] \[Alpha]\)\)]\)], "Input", CellTags -> 
                "BackgroundGluonVertex"], Cell[BoxData[FormBox[RowBox[{
                   \(-\[ImaginaryI]\), " ", \(g\_s\%2\), " ", RowBox[
                    {"(", RowBox[{RowBox[{
                         \((\(g\^\(\[Lambda]\[Sigma]\)\ g\^\(\[Mu]\[Nu]\)\) -
                              \(g\^\(\[Lambda]\[Nu]\)\ g\^\(\[Mu]\[Sigma]\)\)
                              \/\[Alpha] - \(g\^\(\[Lambda]\[Mu]\)\ 
                               g\^\(\[Nu]\[Sigma]\)\))\), " ", SubscriptBox[
                          "f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u7", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u7", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                       RowBox[{
                         \((\(g\^\(\[Lambda]\[Sigma]\)\ g\^\(\[Mu]\[Nu]\)\) -
                              \(g\^\(\[Lambda]\[Nu]\)\ g\^\(\[Mu]\[Sigma]\)\)\
)\), " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["u7", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["u7", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], "+", RowBox[{
                         \((\(g\^\(\[Lambda]\[Sigma]\)\ g\^\(\[Mu]\[Nu]\)\)\/
                              \[Alpha] - \(g\^\(\[Lambda]\[Nu]\)\ 
                               g\^\(\[Mu]\[Sigma]\)\) + 
                             \(g\^\(\[Lambda]\[Mu]\)\ g\^\(\[Nu]\[Sigma]\)\))
                         \), " ", SubscriptBox["f", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u7", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u7", 
                          "TraditionalForm"], "TraditionalForm"]}]]}]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "BackgroundGluonVertex"]}, Open]]}, Open]], 
        Cell["Bracket", "ObjectName", CellTags -> "Bracket"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Bracket"], Cell["Bracket is an option of Convolute, \
specifying the variable with respect to which the result is collected.", 
            "Text", CellTags -> "Bracket"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Convolute", RuleDelayed[ButtonData, "Convolute"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Convolute"]], "."}], "Text", 
            CellTags -> "Bracket"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["BReduce", "ObjectName", PageBreakAbove -> True, 
         CellTags -> "BReduce"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "BReduce"], 
           Cell["BReduce is an option for B0, B00, B1, B11 determining \
whether reductions to A0 and B0 will be done. ", "Text", CellTags -> 
             "BReduce"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["A0", RuleDelayed[ButtonData, "A0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "A0"]], 
              ", ", 
              ButtonBox["B0", RuleDelayed[ButtonData, "B0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B0"]], 
              ", ", 
              ButtonBox["B00", RuleDelayed[ButtonData, "B00"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B00"]], 
              ", ", 
              ButtonBox["B1", RuleDelayed[ButtonData, "B1"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B1"]], 
              ", ", 
              ButtonBox["B11", RuleDelayed[ButtonData, "B11"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B11"]], 
              "."}], "Text", CellTags -> "BReduce"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "BReduce"], Cell[TextData[{"By default ", 
              Cell[BoxData[\(TraditionalForm\`B\_0\)]], 
              " is not expressed in terms of ", Cell[BoxData[
                \(TraditionalForm\`A\_0\)]], "."}], "Text", 
            CellTags -> "BReduce"], Cell[CellGroupData[{Cell[BoxData[
                \(B0[\(0, s, s\)]\)], "Input", CellTags -> "BReduce"], 
              Cell[BoxData[\(TraditionalForm\`\(B\_0 (0, s, s)\)\)], 
               "Output", CellTags -> "BReduce"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[B0]\)], "Input"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(BReduce \[Rule] False\), 
                      \(B0Unique \[Rule] True\), \(B0Real \[Rule] False\)}\)\
\)], "Output"]}, Open]], Cell[
            "With BReduce\[Rule]True, transformation is done.", "Text", 
            CellTags -> "BReduce"], Cell[CellGroupData[{Cell[BoxData[
                \(B0[\(0, s, s, \(BReduce \[Rule] True\)\)]\)], "Input", 
               CellTags -> "BReduce"], Cell[BoxData[FormBox[RowBox[
                  {FractionBox[RowBox[{FormBox[\("A"\_"0"\), 
                       "TraditionalForm"], "(", "s", ")"}], "s"], "-", "1"}], 
                 TraditionalForm]], "Output", CellTags -> "BReduce"]}, 
             Open]]}, Open]], Cell["B0", "ObjectName", CellTags -> "B0"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "B0"], Cell[TextData[
             {"B0[pp, ma^2, mb^2] is the Passarino-Veltman two-point integral \
", Cell[BoxData[\(TraditionalForm\`B\_0\)]], ". All arguments are scalars and \
have dimension mass^2. If the option BReduce is set to True, certain B0's are \
reduced to A0's. Setting the option B0Unique to True simplifies B0[a,0,a] and \
B0[0,0,a]."}], "Text", CellTags -> "B0"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[B0]\)], "Input", CellTags -> "B0"], Cell[BoxData[
                \(TraditionalForm\`\({\(BReduce \[Rule] False\), 
                      \(B0Unique \[Rule] True\), \(B0Real \[Rule] False\)}\)\
\)], "Output", CellTags -> "B0"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["B1", RuleDelayed[ButtonData, "B1"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B1"]], 
              ", ", 
              ButtonBox["B00", RuleDelayed[ButtonData, "B00"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B00"]], 
              ", ", 
              ButtonBox["B11", RuleDelayed[ButtonData, "B11"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B11"]], 
              ", ", 
              ButtonBox["PaVe", RuleDelayed[ButtonData, "PaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "PaVe"]], 
              "."}], "Text", CellTags -> "B0"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "B0"], Cell[CellGroupData[{Cell[BoxData[
                \(B0[\(\(SP[\(p, p\)]\), m\^2, m\^2\)]\)], "Input", 
               CellTags -> "B0"], Cell[BoxData[FormBox[RowBox[{\(B\_0\), "(", 
                   FormBox[SuperscriptBox[FormBox["p", "TraditionalForm"], 
                     "2"], "TraditionalForm"], ",", \(m\^2\), ",", \(m\^2\), 
                   ")"}], TraditionalForm]], "Output", CellTags -> "B0"]}, 
             Open]], Cell[BoxData[
             \(\(SetOptions[\(B0, \(B0Unique \[Rule] True\), 
                    \(B0Real \[Rule] True\)\)]\) ;\)], "Input", 
            CellTags -> "B0"], Cell[CellGroupData[{Cell[BoxData[
                \(B0[\(0, 0, m\^2\)]\)], "Input", CellTags -> "B0"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(B\_0 (0, m\^2, m\^2)\) + 1\)\)], 
               "Output", CellTags -> "B0"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(B0[\(m\^2, 0, m\^2\)]\)], 
               "Input", CellTags -> "B0"], Cell[BoxData[
                \(TraditionalForm\`\(\(B\_0 (0, m\^2, m\^2)\) + 2\)\)], 
               "Output", CellTags -> "B0"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(B0[\(0, \(m^2\), \(m^2\)\)]\)], 
               "Input", CellTags -> "B0"], Cell[BoxData[
                \(TraditionalForm\`\(B\_0 (0, m\^2, m\^2)\)\)], "Output", 
               CellTags -> "B0"]}, Open]]}, Open]], Cell["B0Real", 
         "ObjectName", PageBreakAbove -> True, CellTags -> "B0Real"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "B0Real"], Cell["B0Real is an option of B0 (default \
False). If set to True, B0 is assumed to be real and the relation B0[a,0,a] = \
2 + B0[0,a,a]  is applied.", "Text", CellTags -> "B0Real"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["B0", RuleDelayed[ButtonData, "B0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B0"]], 
              "."}], "Text", CellTags -> "B0Real"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "B0Real"], Cell[
            "By default the arguments are not assumed real.", "Text", 
            CellTags -> "B0Real"], Cell[CellGroupData[{Cell[BoxData[
                \(B0[\(s, 0, s\)]\)], "Input", CellTags -> "B0Real"], 
              Cell[BoxData[\(TraditionalForm\`\(\(B\_0 (0, s, s)\) + 2\)\)], 
               "Output", CellTags -> "B0Real"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(B0//Options\)], "Input", 
               CellTags -> "B0Real"], Cell[BoxData[
                \(TraditionalForm\`\({\(BReduce \[Rule] False\), 
                      \(B0Unique \[Rule] True\), \(B0Real \[Rule] True\)}\)\)]\
, "Output", CellTags -> "B0Real"]}, Open]], 
           Cell["With B0Real\[Rule]True, transformation is done.", "Text", 
            CellTags -> "B0Real"], Cell[CellGroupData[{Cell[BoxData[
                \(B0[\(s, 0, s, \(B0Real \[Rule] True\)\)]\)], "Input", 
               CellTags -> "B0Real"], Cell[BoxData[
                \(TraditionalForm\`\(\(B\_0 (0, s, s)\) + 2\)\)], "Output", 
               CellTags -> "B0Real"]}, Open]]}, Open]], 
        Cell["B0Unique", "ObjectName", PageBreakAbove -> True, 
         CellTags -> "B0Unique"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "B0Unique"], 
           Cell["B0Unique is an option of B0. If set to True, B0[0,0,m2] is \
replaced with (B0[0,m2,m2]+1) and B0[m2,0,m2] simplifies to (B0[0,m2,m2]+2)."\
, "Text", CellTags -> "B0Unique"], Cell[TextData[{"See also: ", 
              ButtonBox["B0", RuleDelayed[ButtonData, "B0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B0"]], 
              "."}], "Text", CellTags -> "B0Unique"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "B0Unique"], 
           Cell["By default transformation is done.", "Text", 
            CellTags -> "B0Unique"], Cell[CellGroupData[{Cell[BoxData[
                \(B0[\(0, 0, s\)]\)], "Input", CellTags -> "B0Unique"], 
              Cell[BoxData[\(TraditionalForm\`\(\(B\_0 (0, s, s)\) + 1\)\)], 
               "Output", CellTags -> "B0Unique"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(B0//Options\)], "Input", 
               CellTags -> "B0Unique"], Cell[BoxData[
                \(TraditionalForm\`\({\(BReduce \[Rule] False\), 
                      \(B0Unique \[Rule] True\), \(B0Real \[Rule] True\)}\)\)]\
, "Output", CellTags -> "B0Unique"]}, Open]], 
           Cell["With B0Real\[Rule]False, nothing happens.", "Text", 
            CellTags -> "B0Unique"], Cell[CellGroupData[{Cell[BoxData[
                \(B0[\(0, 0, s, \(B0Unique \[Rule] False\)\)]\)], "Input", 
               CellTags -> "B0Unique"], Cell[BoxData[
                \(TraditionalForm\`\(B\_0 (0, 0, s)\)\)], "Output", 
               CellTags -> "B0Unique"]}, Open]]}, Open]], 
        Cell["B00", "ObjectName", CellTags -> "B00"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "B00"], Cell[TextData[
             {"B00[pp, ma^2,mb^2] is the Passarino-Veltman ", Cell[BoxData[
                \(TraditionalForm\`B\_00\)]], "-function, i.e., the \
coefficient function of the metric tensor. All arguments are scalars and have \
dimension mass^2."}], "Text", CellTags -> "B00"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[B00]\)], "Input", 
               CellTags -> "B00"], Cell[BoxData[
                \(TraditionalForm\`\({BReduce \[Rule] True}\)\)], "Output", 
               CellTags -> "B00"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["B0", RuleDelayed[ButtonData, "B0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B0"]], 
              ", ", 
              ButtonBox["B1", RuleDelayed[ButtonData, "B1"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B1"]], 
              ", ", 
              ButtonBox["PaVe", RuleDelayed[ButtonData, "PaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "PaVe"]], 
              "."}], "Text", CellTags -> "B00"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "B00"], Cell[TextData[{"Remember that SP[p] is a \
short hand input for ScalarProduct[p,p], i.e., ", Cell[BoxData[
                \(TraditionalForm\`\(p\^2\)\)]], "."}], "Text", 
            CellTags -> "B00"], Cell[CellGroupData[{Cell[BoxData[\(SP[p]\)], 
               "Input", CellTags -> "B00"], Cell[BoxData[FormBox[
                 SuperscriptBox[FormBox["p", "TraditionalForm"], "2"], 
                 TraditionalForm]], "Output", CellTags -> "B00"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(B00[\(\(SP[p]\), m\^2, M\^2\)]\)
                ], "Input", CellTags -> "B00"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{\(1\/3\), " ", RowBox[{\(B\_0\), "(", 
                       FormBox[SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], "TraditionalForm"], ",", 
                       \(m\^2\), ",", \(M\^2\), ")"}], " ", \(m\^2\)}], "+", 
                   RowBox[{\(1\/18\), " ", RowBox[{"(", RowBox[{\(3\ m\^2\), 
                         "+", \(3\ M\^2\), "-", FormBox[SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"], 
                          "TraditionalForm"]}], ")"}]}], "+", RowBox[{\(1\/6\)
                     , " ", RowBox[{"(", RowBox[{RowBox[{FormBox[\("A"\_"0"\)
                          , "TraditionalForm"], "(", FormBox[\(M\^2\), 
                          "TraditionalForm"], ")"}], "+", RowBox[{RowBox[
                          {"(", RowBox[{FractionBox[RowBox[{\((M\^2 - m\^2)\)
                          , " ", RowBox[{"(", RowBox[{RowBox[{\(B\_0\), "(", 
                          FormBox[SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], "TraditionalForm"], ",", 
                          \(m\^2\), ",", \(M\^2\), ")"}], "-", 
                          \(B\_0 (0, m\^2, M\^2)\)}], ")"}]}], RowBox[{"2", 
                          " ", FormBox[SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], "TraditionalForm"]}]], 
                          "-", RowBox[{\(1\/2\), " ", RowBox[{\(B\_0\), "(", 
                          FormBox[SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], "TraditionalForm"], ",", 
                          \(m\^2\), ",", \(M\^2\), ")"}]}]}], ")"}], " ", 
                          RowBox[{"(", RowBox[{\(m\^2\), "-", \(M\^2\), "+", 
                          FormBox[SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], "TraditionalForm"]}], 
                          ")"}]}]}], ")"}]}]}], TraditionalForm]], "Output", 
               CellTags -> "B00"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(B00[\(\(SP[p]\), m\^2, m\^2\)]\)], "Input", CellTags -> 
                "B00"], Cell[BoxData[FormBox[RowBox[{RowBox[{\(1\/3\), " ", 
                     RowBox[{\(B\_0\), "(", FormBox[SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], "TraditionalForm"], 
                       ",", \(m\^2\), ",", \(m\^2\), ")"}], " ", \(m\^2\)}], 
                   "+", RowBox[{\(1\/18\), " ", RowBox[{"(", RowBox[{
                         \(6\ m\^2\), "-", FormBox[SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], 
                          "TraditionalForm"]}], ")"}]}], "+", RowBox[{\(1\/6\)
                     , " ", RowBox[{"(", RowBox[{RowBox[{FormBox[\("A"\_"0"\)
                          , "TraditionalForm"], "(", FormBox[\(m\^2\), 
                          "TraditionalForm"], ")"}], "-", RowBox[{\(1\/2\), 
                          " ", RowBox[{\(B\_0\), "(", FormBox[SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"], 
                          "TraditionalForm"], ",", \(m\^2\), ",", \(m\^2\), 
                          ")"}], " ", FormBox[SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], "TraditionalForm"]}]}], 
                       ")"}]}]}], TraditionalForm]], "Output", CellTags -> 
                "B00"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(B00[\(\(SP[p]\), m\^2, M\^2, \(BReduce \[Rule] False\)\)]\)]\
, "Input", CellTags -> "B00"], Cell[BoxData[FormBox[RowBox[{FormBox[
                    \("B"\_"00"\), "TraditionalForm"], "(", FormBox[
                    FormBox[SuperscriptBox[FormBox["p", "TraditionalForm"], 
                      "2"], "TraditionalForm"], "TraditionalForm"], \(,\ \), 
                   FormBox[\(m\^2\), "TraditionalForm"], \(,\ \), FormBox[
                    \(M\^2\), "TraditionalForm"], ")"}], TraditionalForm]], 
               "Output", CellTags -> "B00"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(B00[\(0, m\^2, m\^2\)]\)], 
               "Input", CellTags -> "B00"], Cell[BoxData[FormBox[RowBox[{
                   \(1\/3\ \(B\_0 (0, m\^2, m\^2)\)\ m\^2\), "+", \(m\^2\/3\)
                   , "+", RowBox[{\(1\/6\), " ", RowBox[{FormBox[\("A"\_"0"\)
                        , "TraditionalForm"], "(", FormBox[\(m\^2\), 
                        "TraditionalForm"], ")"}]}]}], TraditionalForm]], 
               "Output", CellTags -> "B00"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(B00[\(\(SmallVariable[\(M\^2\)]\), m\^2, m\^2\)]\)], 
               "Input", CellTags -> "B00"], Cell[BoxData[FormBox[RowBox[{
                   \(1\/3\ \(B\_0 (M\^2, m\^2, m\^2)\)\ m\^2\), "+", 
                   \(m\^2\/3\), "+", RowBox[{\(1\/6\), " ", RowBox[{FormBox[
                        \("A"\_"0"\), "TraditionalForm"], "(", FormBox[
                        \(m\^2\), "TraditionalForm"], ")"}]}]}], 
                 TraditionalForm]], "Output", CellTags -> "B00"]}, Open]]}, 
          Open]], Cell["B1", "ObjectName", CellTags -> "B1"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "B1"], Cell[TextData[
             {"B1[pp, ma^2, mb^2] the Passarino-Veltman ", Cell[BoxData[
                \(TraditionalForm\`B\_1\)]], "-function. All arguments are \
scalars and have dimension mass^2."}], "Text", CellTags -> "B1"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[B1]\)], "Input", 
               CellTags -> "B1"], Cell[BoxData[
                \(TraditionalForm\`\({BReduce \[Rule] True}\)\)], "Output", 
               CellTags -> "B1"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["B0", RuleDelayed[ButtonData, "B0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B0"]], 
              ", ", 
              ButtonBox["B00", RuleDelayed[ButtonData, "B00"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B00"]], 
              ", ", 
              ButtonBox["B11", RuleDelayed[ButtonData, "B11"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B11"]], 
              ", ", 
              ButtonBox["PaVe", RuleDelayed[ButtonData, "PaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "PaVe"]], 
              ", ", 
              ButtonBox["PaVeReduce", RuleDelayed[ButtonData, "PaVeReduce"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeReduce"]], "."}], "Text", 
            CellTags -> "B1"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "B1"], 
           Cell[CellGroupData[{Cell[BoxData[\(B1[\(\(SP[p]\), m\^2, M\^2\)]\)]
                , "Input", CellTags -> "B1"], Cell[BoxData[FormBox[
                 RowBox[{FractionBox[RowBox[{\((M\^2 - m\^2)\), " ", 
                      RowBox[{"(", RowBox[{RowBox[{\(B\_0\), "(", FormBox[
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], "TraditionalForm"], ",", \(m\^2\), ",", 
                          \(M\^2\), ")"}], "-", \(B\_0 (0, m\^2, M\^2)\)}], 
                        ")"}]}], RowBox[{"2", " ", FormBox[SuperscriptBox[
                        FormBox["p", "TraditionalForm"], "2"], 
                       "TraditionalForm"]}]], "-", RowBox[{\(1\/2\), " ", 
                     RowBox[{\(B\_0\), "(", FormBox[SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], "TraditionalForm"], 
                       ",", \(m\^2\), ",", \(M\^2\), ")"}]}]}], 
                 TraditionalForm]], "Output", CellTags -> "B1"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(B1[\(\(SP[p]\), m\^2, M\^2, \(BReduce \[Rule] False\)\)]\)]\
, "Input", CellTags -> "B1"], Cell[BoxData[FormBox[RowBox[{\(B\_1\), "(", 
                   FormBox[SuperscriptBox[FormBox["p", "TraditionalForm"], 
                     "2"], "TraditionalForm"], ",", \(m\^2\), ",", \(M\^2\), 
                   ")"}], TraditionalForm]], "Output", CellTags -> "B1"]}, 
             Open]], Cell[BoxData[
             \(\(SetOptions[\(B1, \(BReduce \[Rule] True\)\)]\) ;\)], 
            "Input", CellTags -> "B1"], Cell[CellGroupData[{Cell[BoxData[
                \(B1[\(\(SP[p]\), m\^2, m\^2\)]\)], "Input", CellTags -> 
                "B1"], Cell[BoxData[FormBox[RowBox[{\(-\(1\/2\)\), " ", 
                   RowBox[{\(B\_0\), "(", FormBox[SuperscriptBox[FormBox["p", 
                        "TraditionalForm"], "2"], "TraditionalForm"], ",", 
                     \(m\^2\), ",", \(m\^2\), ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "B1"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(B1[\(m\^2, m\^2, 0\)]\)], 
               "Input", CellTags -> "B1"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/2\ 
                       \((\(-\(B\_0 (0, m\^2, m\^2)\)\) - 2)\)\) - 1\/2\)\)], 
               "Output", CellTags -> "B1"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(B1[\(0, 0, m\^2\)]\)], "Input", 
               CellTags -> "B1"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/2\ 
                       \((\(-\(B\_0 (0, m\^2, m\^2)\)\) - 1)\)\) + 1\/4\)\)], 
               "Output", CellTags -> "B1"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(B1[\(pp, \(SmallVariable[m\_e\%2]\), m\_2\%2\)]\)], 
               "Input", CellTags -> "B1"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                         (\(B\_0 (pp, m\_e\%2, m\_2\%2)\) - 
                           \(B\_0 (0, m\_e\%2, m\_2\%2)\))\)\ m\_2\%2\)\/
                      \(2\ pp\) - \(1\/2\ \(B\_0 (pp, m\_e\%2, m\_2\%2)\)\)\)
                \)], "Output", CellTags -> "B1"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(B1[\(\(SmallVariable[m\_e\%2]\), \(SmallVariable[m\_e\%2]\)
                     , 0\)]\)], "Input", CellTags -> "B1"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/2\ 
                       \((\(-\(B\_0 (0, m\_e\%2, m\_e\%2)\)\) - 2)\)\) - 1\/2
                \)\)], "Output", CellTags -> "B1"]}, Open]]}, Open]], 
        Cell["B11", "ObjectName", CellTags -> "B11"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "B11"], Cell[TextData[
             {"B11[pp, ma^2, mb^2] is the Passarino-Veltman ", Cell[BoxData[
                \(TraditionalForm\`B\_11\)]], 
              "-function, i.e., the coefficient function of ", Cell[BoxData[
                \(TraditionalForm\`\(p\^\[Mu]\ p\^\[Nu]\)\)]], 
              ". All arguments are scalars and have dimension mass", 
              Cell[BoxData[\(TraditionalForm\`\(\[Null]\^2\)\)]], "."}], 
            "Text", CellTags -> "B11"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[B11]\)], "Input", CellTags -> "B11"], Cell[BoxData[
                \(TraditionalForm\`\({BReduce \[Rule] True}\)\)], "Output", 
               CellTags -> "B11"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["B0", RuleDelayed[ButtonData, "B0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B0"]], 
              ", ", 
              ButtonBox["B00", RuleDelayed[ButtonData, "B00"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B00"]], 
              ", ", 
              ButtonBox["B1", RuleDelayed[ButtonData, "B1"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B1"]], 
              ", ", 
              ButtonBox["PaVe", RuleDelayed[ButtonData, "PaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "PaVe"]], 
              "."}], "Text", CellTags -> "B11"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "B11"], Cell[TextData[{"Remember that SP[p] is a \
short hand input for ScalarProduct[p,p], i.e. ", Cell[BoxData[
                \(TraditionalForm\`\(p\^2 .\)\)]]}], "Text", 
            CellTags -> "B11"], Cell[CellGroupData[{Cell[BoxData[\(SP[p]\)], 
               "Input", CellTags -> "B11"], Cell[BoxData[FormBox[
                 SuperscriptBox[FormBox["p", "TraditionalForm"], "2"], 
                 TraditionalForm]], "Output", CellTags -> "B11"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(B11[\(\(SP[p]\), m\^2, M\^2\)]\)
                ], "Input", CellTags -> "B11"], Cell[BoxData[FormBox[
                 RowBox[{FractionBox["1", RowBox[{"3", " ", FormBox[
                       SuperscriptBox[FormBox["p", "TraditionalForm"], "2"], 
                       "TraditionalForm"]}]], RowBox[{"(", RowBox[
                      {RowBox[{RowBox[{"-", RowBox[{\(B\_0\), "(", FormBox[
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], "TraditionalForm"], ",", \(m\^2\), ",", 
                          \(M\^2\), ")"}]}], " ", \(m\^2\)}], "+", RowBox[
                        {FormBox[\("A"\_"0"\), "TraditionalForm"], "(", 
                         FormBox[\(M\^2\), "TraditionalForm"], ")"}], "+", 
                       RowBox[{\(1\/6\), " ", RowBox[{"(", RowBox[{
                          \(\(-3\)\ m\^2\), "-", \(3\ M\^2\), "+", FormBox[
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], "TraditionalForm"]}], ")"}]}], "-", RowBox[
                        {"2", " ", RowBox[{"(", RowBox[{FractionBox[RowBox[{
                          \((M\^2 - m\^2)\), " ", RowBox[{"(", RowBox[
                          {RowBox[{\(B\_0\), "(", FormBox[SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"], 
                          "TraditionalForm"], ",", \(m\^2\), ",", \(M\^2\), 
                          ")"}], "-", \(B\_0 (0, m\^2, M\^2)\)}], ")"}]}], 
                          RowBox[{"2", " ", FormBox[SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], 
                          "TraditionalForm"]}]], "-", RowBox[{\(1\/2\), " ", 
                          RowBox[{\(B\_0\), "(", FormBox[SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"], 
                          "TraditionalForm"], ",", \(m\^2\), ",", \(M\^2\), 
                          ")"}]}]}], ")"}], " ", RowBox[{"(", RowBox[{\(m\^2\)
                          , "-", \(M\^2\), "+", FormBox[SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"], 
                          "TraditionalForm"]}], ")"}]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "B11"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(B11[\(\(SP[p]\), m\^2, m\^2\)]\)
                ], "Input", CellTags -> "B11"], Cell[BoxData[FormBox[
                 FractionBox[RowBox[{RowBox[{FormBox[\("A"\_"0"\), 
                       "TraditionalForm"], "(", FormBox[\(m\^2\), 
                       "TraditionalForm"], ")"}], "+", RowBox[{\(1\/6\), " ", 
                      RowBox[{"(", RowBox[{FormBox[SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], "TraditionalForm"], 
                          "-", \(6\ m\^2\)}], ")"}]}], "+", RowBox[{RowBox[{
                        \(B\_0\), "(", FormBox[SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], "TraditionalForm"], ",", 
                        \(m\^2\), ",", \(m\^2\), ")"}], " ", RowBox[
                       {"(", RowBox[{FormBox[SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], "TraditionalForm"], "-", 
                          \(m\^2\)}], ")"}]}]}], RowBox[{"3", " ", FormBox[
                     SuperscriptBox[FormBox["p", "TraditionalForm"], "2"], 
                     "TraditionalForm"]}]], TraditionalForm]], "Output", 
               CellTags -> "B11"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\(B11, \(BReduce \[Rule] False\)\)]\)], "Input", 
               CellTags -> "B11"], Cell[BoxData[
                \(TraditionalForm\`\({BReduce \[Rule] False}\)\)], "Output", 
               CellTags -> "B11"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(B11[\(\(SP[p]\), m\^2, M\^2\)]\)], "Input", CellTags -> 
                "B11"], Cell[BoxData[FormBox[RowBox[{FormBox[\("B"\_"11"\), 
                    "TraditionalForm"], "(", FormBox[FormBox[SuperscriptBox[
                      FormBox["p", "TraditionalForm"], "2"], 
                     "TraditionalForm"], "TraditionalForm"], \(,\ \), FormBox[
                    \(m\^2\), "TraditionalForm"], \(,\ \), FormBox[\(M\^2\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "B11"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\(B11, \(BReduce \[Rule] True\)\)]\)], "Input", 
               CellTags -> "B11"], Cell[BoxData[
                \(TraditionalForm\`\({BReduce \[Rule] True}\)\)], "Output", 
               CellTags -> "B11"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(B11[\(0, m\^2, m\^2\)]\)], "Input", CellTags -> "B11"], 
              Cell[BoxData[
                \(TraditionalForm\`\(1\/3\ \(B\_0 (0, m\^2, m\^2)\)\)\)], 
               "Output", CellTags -> "B11"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(B11[\(\(SmallVariable[\(M\^2\)]\), m\^2, m\^2\)]\)], 
               "Input", CellTags -> "B11"], Cell[BoxData[
                \(TraditionalForm\`\(1\/3\ \(B\_0 (M\^2, m\^2, m\^2)\)\)\)], 
               "Output", CellTags -> "B11"]}, Open]]}, Open]], 
        Cell["CA", "ObjectName", CellTags -> "CA"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "CA"], Cell[TextData[
             {"CA is one of the Casimir operator eigenvalues of SU(", 
              StyleBox["N", Rule[FontSlant, "Italic"]], ") (CA = ", 
              StyleBox["N", Rule[FontSlant, "Italic"]], ")."}], "Text", 
            CellTags -> "CA"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["CF", RuleDelayed[ButtonData, "CF"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "CF"]], 
              ", ", 
              ButtonBox["SUNSimplify", RuleDelayed[ButtonData, 
                 "SUNSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNSimplify"]], "."}], "Text", 
            CellTags -> "CA"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "CA"], 
           Cell[CellGroupData[{Cell[BoxData["CA"], "Input", CellTags -> 
                "CA"], Cell[BoxData[\(TraditionalForm\`C\_A\)], "Output", 
               CellTags -> "CA"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(CA, \(SUNNToCACF \[Rule] False\)\)]\)], 
               "Input", CellTags -> "CA"], Cell[BoxData[\(TraditionalForm\`N\)
                ], "Output", CellTags -> "CA"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData["SUNN"], "Input", CellTags -> 
                "CA"], Cell[BoxData[\(TraditionalForm\`N\)], "Output", 
               CellTags -> "CA"]}, Open]]}, Open]], 
        Cell["Calc", "ObjectName", CellTags -> "Calc"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Calc"], Cell["Calc[exp] performs several basic \
simplifications. Calc[exp] is the same as \
DotSimplify[DiracSimplify[Contract[DiracSimplify[Explicit[ \
SUNSimplify[Trick[exp], Explicit\[Rule]False] ]]]]].", "Text", 
            CellTags -> "Calc"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["DiracTrick", RuleDelayed[ButtonData, "DiracTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrick"]], ", ", 
              ButtonBox["Trick", RuleDelayed[ButtonData, "Trick"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Trick"]], 
              "."}], "Text", CellTags -> "Calc"]}, Open]], 
        Cell[CellGroupData[{Cell[BoxData["Examples"], "Subsubsection", 
            CellTags -> "Calc"], Cell[TextData[{"This calculates ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] \[Gamma]\_\[Mu]\)\)]], 
              " in 4 dimensions and ", Cell[BoxData[
                \(TraditionalForm\`g\_\[Nu]\%\[Nu]\)]], 
              " in D dimensions."}], "Text", CellTags -> "Calc"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Calc[\({\(GA[\(\[Mu], \[Mu]\)]\),\ 
                      \(MTD[\(\[Nu], \[Nu]\)]\)}\)]\)], "Input", CellTags -> 
                "Calc"], Cell[BoxData[\(TraditionalForm\`\({4, D}\)\)], 
               "Output", CellTags -> "Calc"]}, Open]], 
           Cell[TextData[{"This simplifies ", Cell[BoxData[
                \(TraditionalForm\`\(f\_abc\ \(f\_abe .\)\)\)]]}], "Text", 
            CellTags -> "Calc"], Cell[CellGroupData[{Cell[BoxData[
                \(Calc[\(\(SUNF[\(a, b, c\)]\)\ \(SUNF[\(a, b, e\)]\)\)]\)], 
               "Input", CellTags -> "Calc"], Cell[BoxData[FormBox[RowBox[{
                   \(C\_A\), " ", SubscriptBox["\[Delta]", RowBox[
                     {FormBox[FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["e", 
                        "TraditionalForm"], "TraditionalForm"]}]]}], 
                 TraditionalForm]], "Output", CellTags -> "Calc"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(FV[\(\(p + r\), \[Mu]\)]\)\ \(MT[\(\[Mu], \[Nu]\)]\)\ 
                   \(FV[\(\(q - p\), \[Nu]\)]\)\)], "Input", CellTags -> 
                "Calc"], Cell[BoxData[FormBox[RowBox[{RowBox[{"(", 
                     SuperscriptBox[FormBox[\(q - p\), "TraditionalForm"], 
                      "\[Nu]"], ")"}], " ", RowBox[{"(", SuperscriptBox[
                      FormBox[\(p + r\), "TraditionalForm"], "\[Mu]"], ")"}], 
                   " ", \(g\^\(\[Mu]\[Nu]\)\)}], TraditionalForm]], "Output", 
               CellTags -> "Calc"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Calc[%]\)], "Input", CellTags -> "Calc"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"-", SuperscriptBox[FormBox["p", 
                       "TraditionalForm"], "2"]}], "+", RowBox[{FormBox["p", 
                      "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                      "TraditionalForm"]}], "-", RowBox[{FormBox["p", 
                      "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                      "TraditionalForm"]}], "+", RowBox[{FormBox["q", 
                      "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                      "TraditionalForm"]}]}], TraditionalForm]], "Output", 
               CellTags -> "Calc"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(GluonVertex[\(p, 1, q, 2, \(\(-p\) - q\), 3\)]\)], "Input", 
               CellTags -> "Calc"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{SuperscriptBox["V", RowBox[{FormBox[FormBox["li1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["li2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["li3", 
                          "TraditionalForm"], "TraditionalForm"]}]], "(", 
                     RowBox[{FormBox["p", "TraditionalForm"], \(,\ \), 
                       FormBox["q", "TraditionalForm"], \(,\ \), FormBox[
                        \(\(-p\) - q\), "TraditionalForm"]}], ")"}], " ", 
                   SubscriptBox["f", RowBox[{FormBox[FormBox["ci1", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["ci2", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["ci3", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Calc"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Calc[\(\(%\ \(FVD[\(p, li1\)]\)\)\ \(FVD[\(q, li2\)]\)\ 
                     \(FVD[\(\(\(-p\) - q\), li3\)]\)\)]\)], "Input", 
               CellTags -> "Calc"], Cell[BoxData[\(TraditionalForm\`0\)], 
               "Output", CellTags -> "Calc"]}, Open]]}, Open]], 
        Cell["CalcColorFactor", "ObjectName", CellTags -> "CalcColorFactor"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "CalcColorFactor"], Cell["CalcColorFactor[expr] \
calculates the color factor of expr.  CalcColorFactor is useful for \
application on FeynArts produced amplitudes. CalcColorFactor is just a macro \
function for CalcColorFactor[x_] := \nIf[FreeQ2[FeynCalcInternal[x], \
SUNIndex],  x, \n                    SUNSimplify[SUNSimplify[  (If[ \
!FreeQ[#1, DiracGamma], DiracTrick[#1], #1] & )[  SUNSimplify[x]], Explicit \
-> False], Explicit -> True]].", "Text", CellTags -> "CalcColorFactor"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["SUNSimplify", RuleDelayed[ButtonData, 
                 "SUNSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNSimplify"]], "."}], "Text", 
            CellTags -> "CalcColorFactor"]}, Open]], 
        Cell[CellGroupData[{Cell[BoxData["Examples"], "Subsubsection", 
            CellTags -> "CalcColorFactor"], Cell[CellGroupData[{Cell[BoxData[
                \(CalcColorFactor[\(\(SUNF[\(a, b, c\)]\)\ 
                     \(SUNF[\(a, b, d\)]\)\)]\)], "Input", CellTags -> 
                "CalcColorFactor"], Cell[BoxData[FormBox[RowBox[{\(C\_A\), 
                   " ", SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["d", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "CalcColorFactor"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Amplitude["q2se2"]\)], "Input", 
               CellTags -> "CalcColorFactor"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{"-", RowBox[{"tr", "(", FormBox[RowBox[
                         {"2", " ", \(T\_f\), " ", RowBox[{RowBox[{
                          \(\[CapitalPi]\_q\), "(", FormBox[
                          \(-\(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], ")"}], ".", 
                          \(Q\_\(c\_9\)\%\(\[Lambda]\_9\)\), ".", RowBox[{
                          \(\[CapitalPi]\_q\), "(", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_2 - 
                             \(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], ")"}], ".", 
                          \(Q\_\(c\_3\)\%\(\[Lambda]\_3\)\)}]}], 
                        "TraditionalForm"], ")"}]}], " ", RowBox[{
                     \(Q\_\(c\_11\)\%\(\[Lambda]\_11\)\), ".", RowBox[{
                       \(\[CapitalPi]\_q\), "(", FormBox[
                        \(p - \(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2\), 
                        "TraditionalForm"], ")"}], ".", 
                     \(Q\_\(c\_1\)\%\(\[Lambda]\_1\)\)}], " ", RowBox[{
                     \(\[CapitalPi]\_\(c\_1 c\_3\)\%
                        \(\[Lambda]\_1 \[Lambda]\_3\)\), "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_2\), 
                      "TraditionalForm"], ")"}], " ", RowBox[{
                     \(\[CapitalPi]\_\(c\_9 c\_11\)\%
                        \(\[Lambda]\_9 \[Lambda]\_11\)\), "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_2\), 
                      "TraditionalForm"], ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "CalcColorFactor"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(CalcColorFactor @ \(Explicit @ %\)\)], "Input", CellTags -> 
                "CalcColorFactor"], Cell[BoxData[FormBox[FractionBox[
                  RowBox[{"\[ImaginaryI]", " ", \(C\_F\), " ", \(g\_s\%4\), 
                    " ", \(T\_f\), " ", RowBox[{"tr", "(", FormBox[RowBox[
                        {"-", RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], ")"}], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Lambda]\_9\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", "(", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_1 - 
                             \(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], ")"}], ")"}], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Lambda]\_3\), "TraditionalForm"], 
                          "TraditionalForm"]]}]}], "TraditionalForm"], ")"}], 
                    " ", RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                         \(\[Lambda]\_11\), "TraditionalForm"], 
                        "TraditionalForm"]], ".", RowBox[{"(", RowBox[
                         {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                          "\[CenterDot]", "(", FormBox[
                          \(p - \(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], ")"}], ")"}], ".", 
                      SuperscriptBox["\[Gamma]", FormBox[FormBox[
                         \(\[Lambda]\_1\), "TraditionalForm"], 
                        "TraditionalForm"]]}], " ", 
                    \(\((1\/\(\*TagBox[StyleBox["\"q\"", 
                               Rule[FontSlant, "Italic"]], 
                              Function[StyleForm[Slot[1], 
                                Rule[FontSlant, "Italic"]]]]\)\_2\%2)\)\^2\), 
                    " ", \(g\^\(\[Lambda]\_1 \[Lambda]\_3\)\), " ", 
                    \(g\^\(\[Lambda]\_9 \[Lambda]\_11\)\)}], 
                  \(\(\*TagBox[StyleBox["\"q\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]]\)\_1\%2 . 
                     \((p - \(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2)\)\^2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2 - 
                         \(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2\)], 
                 TraditionalForm]], "Output", CellTags -> 
                "CalcColorFactor"]}, Open]]}, Open]], 
        Cell["CalculateCounterTerm ***unfinished***", "ObjectName", 
         CellTags -> "CalculateCounterTerm"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "CalculateCounterTerm"], 
           Cell[
            "CalculateCounterTerm[exp, k] calculates the residue of exp.", 
            "Text", CellTags -> "CalculateCounterTerm"]}, Open]], 
        Cell[CellGroupData[{Cell[BoxData["Examples"], "Subsubsection", 
            CellTags -> "CalculateCounterTerm"], Cell[CellGroupData[
             {Cell[BoxData[\(? CalculateCounterTerm\)], "Input", CellTags -> 
                "CalculateCounterTerm"], Cell[BoxData["\"CalculateCounterTerm\
[exp, k] calculates the residue of exp.\""], "Print", CellTags -> 
                {"CalculateCounterTerm", "Info3353009088-8660148"}]}, 
             Open]]}, Open]], Cell["CancelQP", "ObjectName", 
         CellTags -> "CancelQP"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "CancelQP"], 
           Cell[TextData[{"CancelQP is an option for OneLoop. If set to True, \
cancelation of all ", StyleBox["q", Rule[FontSlant, "Italic"]], ".", 
              StyleBox["p", Rule[FontSlant, "Italic"]], "'s and ", 
              Cell[BoxData[\(TraditionalForm\`\(q\^2\)\)]], 
              " is performed."}], "Text", CellTags -> "CancelQP"]}, Open]], 
        Cell[CellGroupData[{Cell[BoxData["Examples"], "Subsubsection", 
            CellTags -> "CancelQP"], Cell[CellGroupData[{Cell[BoxData[
                \(t = \(\(\(SPD[\(\(p + \(2q2\)\), \(p + q2\)\)]\)\ 
                       \(FAD[\(\({\(q2 - p\), m}\), \({q2, 0}\), \({q2, M}\)
                          \)]\)\)//FCI\)\)], "Input", CellTags -> 
                "CancelQP"], Cell[BoxData[FormBox[FractionBox[RowBox[
                   {"(", FormBox[
                     \(p + \(\*TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_2\), 
                     "TraditionalForm"], ")", "\[CenterDot]", "(", FormBox[
                     \(p + \(2\ \(\*TagBox[StyleBox["\"q\"", 
                               Rule[FontSlant, "Italic"]], 
                              Function[StyleForm[Slot[1], 
                                Rule[FontSlant, "Italic"]]]]\)\_2\)\), 
                     "TraditionalForm"], ")"}], 
                  \(\((\((\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\
 - m\^2)\) . \(\*TagBox[StyleBox["\"q\"", 
                          Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]]\)\_2\%2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_2\%2 - M\^2)\)\
\)], TraditionalForm]], "Output", CellTags -> "CancelQP"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(OneLoop[\(q2, t, \(CancelQP \[Rule] True\)\)]\)], "Input", 
               CellTags -> "CancelQP"], Cell[BoxData[FormBox[RowBox[
                  {"\[ImaginaryI]", " ", \(\[Pi]\^2\), " ", RowBox[
                    {"(", RowBox[{FractionBox[RowBox[{"3", " ", RowBox[{
                          \(B\_0\), "(", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], ",", "0", ",", \(m\^2\), 
                          ")"}], " ", \(m\^2\)}], \(2\ M\^2\)], "-", 
                       FractionBox[RowBox[{"3", " ", RowBox[{FormBox[
                          \("A"\_"0"\), "TraditionalForm"], "(", FormBox[
                          \(M\^2\), "TraditionalForm"], ")"}]}], \(2\ M\^2\)]
                        , "-", FractionBox[RowBox[{
                          \((\(3\ m\^2\) - \(7\ M\^2\))\), " ", RowBox[{
                          \(B\_0\), "(", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], ",", \(m\^2\), ",", 
                          \(M\^2\), ")"}]}], \(2\ M\^2\)], "-", FractionBox[
                        RowBox[{"5", " ", RowBox[{\(B\_0\), "(", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], ",", "0", ",", \(m\^2\), ")"}], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"]}], \(2\ M\^2\)], "+", FractionBox[RowBox[
                         {"5", " ", RowBox[{\(B\_0\), "(", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"], ",", \(m\^2\)
                          , ",", \(M\^2\), ")"}], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"]}], \(2\ M\^2\)]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "CancelQP"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(OneLoop[\(q2, t, \(CancelQP \[Rule] False\)\)]\)], "Input", 
               CellTags -> "CancelQP"], Cell[BoxData[FormBox[RowBox[
                  {"\[ImaginaryI]", " ", \(\[Pi]\^2\), " ", RowBox[
                    {"(", RowBox[{
                       \(-\(\(3\ \(B\_0 (0, m\^2, m\^2)\)\ m\^2\)\/
                            \(2\ M\^2\)\)\), "+", 
                       \(\(7\ \(B\_0 (0, m\^2, M\^2)\)\ m\^2\)\/\(2\ M\^2\)\)\
, "+", FractionBox[RowBox[{"3", " ", RowBox[{\(B\_0\), "(", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"], ",", "0", 
                          ",", \(m\^2\), ")"}], " ", \(m\^2\)}], \(2\ M\^2\)]
                        , "-", \(\(3\ m\^2\)\/\(2\ M\^2\)\), "-", FractionBox[
                        RowBox[{"2", " ", RowBox[{FormBox[\("A"\_"0"\), 
                          "TraditionalForm"], "(", FormBox[\(m\^2\), 
                          "TraditionalForm"], ")"}]}], \(M\^2\)], "+", 
                       FractionBox[RowBox[{"2", " ", RowBox[{FormBox[
                          \("A"\_"0"\), "TraditionalForm"], "(", FormBox[
                          \(M\^2\), "TraditionalForm"], ")"}]}], \(M\^2\)], 
                       "-", \(7\/2\ \(B\_0 (0, m\^2, M\^2)\)\), "-", 
                       FractionBox[RowBox[{\((\(3\ m\^2\) - \(7\ M\^2\))\), 
                          " ", RowBox[{\(B\_0\), "(", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], ",", \(m\^2\), ",", 
                          \(M\^2\), ")"}]}], \(2\ M\^2\)], "-", FractionBox[
                        RowBox[{"5", " ", RowBox[{\(B\_0\), "(", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], ",", "0", ",", \(m\^2\), ")"}], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"]}], \(2\ M\^2\)], "+", FractionBox[RowBox[
                         {"5", " ", RowBox[{\(B\_0\), "(", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"], ",", \(m\^2\)
                          , ",", \(M\^2\), ")"}], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"]}], \(2\ M\^2\)]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "CancelQP"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t = \(\(\(SPD[\(q2, p\)]\) \(SPD[\(q1, p\)]\)\ 
                       \(FAD[\(\({q1, m}\), \({q2, m}\), \(q1 - p\), 
                           \(q2 - p\), \(q2 - q1\)\)]\)\)//FCI\)\)], "Input", 
               CellTags -> "CancelQP"], Cell[BoxData[FormBox[FractionBox[
                  RowBox[{RowBox[{FormBox["p", "TraditionalForm"], 
                      "\[CenterDot]", FormBox[
                       \(\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1\), 
                       "TraditionalForm"]}], " ", RowBox[{FormBox["p", 
                       "TraditionalForm"], "\[CenterDot]", FormBox[
                       \(\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2\), 
                       "TraditionalForm"]}]}], 
                  \(\((\(\*TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_1\%2 - m\^2)\)\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_2\%2 - m\^2)\)\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2 - 
                         \(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2\)], 
                 TraditionalForm]], "Output", CellTags -> "CancelQP"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(OneLoop[\(q2, t, \(CancelQP \[Rule] True\)\)]\)], "Input", 
               CellTags -> "CancelQP"], Cell[BoxData[FormBox[RowBox[
                  {"\[ImaginaryI]", " ", \(\[Pi]\^2\), " ", RowBox[
                    {"(", RowBox[{RowBox[{"-", FractionBox[RowBox[{RowBox[
                          {FormBox[\("C"\_"0"\), "TraditionalForm"], "(", 
                          FormBox[SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], "TraditionalForm"], ",", 
                          FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\), 
                          "TraditionalForm"], ",", FormBox[RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], "-", RowBox[{"2", " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}], 
                          "TraditionalForm"], ",", FormBox["0", 
                          "TraditionalForm"], ",", FormBox[\(m\^2\), 
                          "TraditionalForm"], ",", FormBox["0", 
                          "TraditionalForm"], ")"}], " ", RowBox[{FormBox[
                          "p", "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], " ", \(m\^2\)}], RowBox[
                          {"2", " ", 
                          \((m\^2 - \(\*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_1\%2)\), 
                          " ", RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], "-", RowBox[{"2", 
                          " ", RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}], 
                          ")"}]}]]}], "+", FractionBox[RowBox[{
                          \(B\_0 (\(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_1\%2, 0, 
                             m\^2)\), " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], RowBox[{"2", " ", 
                          \((m\^2 - \(\*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_1\%2)\), 
                          " ", RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], "-", RowBox[{"2", 
                          " ", RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}], 
                          ")"}]}]], "-", FractionBox[RowBox[{RowBox[{\(B\_0\)
                          , "(", RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], "-", RowBox[{"2", " ", 
                          RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}], 
                          ",", "0", ",", "0", ")"}], " ", RowBox[{FormBox[
                          "p", "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], RowBox[{"2", " ", 
                          \((m\^2 - \(\*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_1\%2)\), 
                          " ", RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], "-", RowBox[{"2", 
                          " ", RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}], 
                          ")"}]}]], "-", FractionBox[RowBox[{RowBox[{FormBox[
                          \("C"\_"0"\), "TraditionalForm"], "(", FormBox[
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], "TraditionalForm"], ",", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\), 
                          "TraditionalForm"], ",", FormBox[RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], "-", RowBox[{"2", " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}], 
                          "TraditionalForm"], ",", FormBox["0", 
                          "TraditionalForm"], ",", FormBox[\(m\^2\), 
                          "TraditionalForm"], ",", FormBox["0", 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"], " ", 
                          RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], RowBox[{"2", " ", 
                          \((m\^2 - \(\*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_1\%2)\), 
                          " ", RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], "-", RowBox[{"2", 
                          " ", RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}], 
                          ")"}]}]]}], ")"}]}], TraditionalForm]], "Output", 
               CellTags -> "CancelQP"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(OneLoop[\(q2, t, \(CancelQP \[Rule] False\)\)]\)]
                , "Input", CellTags -> "CancelQP"], Cell[BoxData[
                FormBox[RowBox[{"\[ImaginaryI]", " ", \(\[Pi]\^2\), " ", 
                   RowBox[{"(", RowBox[{FractionBox[RowBox[{RowBox[{"PaVe", 
                          "(", RowBox[{"2", ",", RowBox[{"{", RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], ",", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\), 
                          ",", RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], "-", RowBox[{"2", " ", 
                          RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}]}], 
                          "}"}], ",", \({0, m\^2, 0}\)}], ")"}], " ", 
                          SuperscriptBox[FormBox[RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                        RowBox[{
                          \((m\^2 - \(\*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_1\%2)\), 
                          " ", RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], "-", RowBox[{"2", 
                          " ", RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}], 
                          ")"}]}]], "-", FractionBox[RowBox[{SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"], " ", 
                          RowBox[{"PaVe", "(", RowBox[{"1", ",", RowBox[
                          {"{", RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], ",", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\), 
                          ",", RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], "-", RowBox[{"2", " ", 
                          RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}]}], 
                          "}"}], ",", \({0, m\^2, 0}\)}], ")"}], " ", 
                          RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], RowBox[{
                          \((m\^2 - \(\*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_1\%2)\), 
                          " ", RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], "-", RowBox[{"2", 
                          " ", RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}], 
                          ")"}]}]], "-", FractionBox[RowBox[{SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"], " ", 
                          RowBox[{"PaVe", "(", RowBox[{"2", ",", RowBox[
                          {"{", RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], ",", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\), 
                          ",", RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], "-", RowBox[{"2", " ", 
                          RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}]}], 
                          "}"}], ",", \({0, m\^2, 0}\)}], ")"}], " ", 
                          RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], RowBox[{
                          \((m\^2 - \(\*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_1\%2)\), 
                          " ", RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], "-", RowBox[{"2", 
                          " ", RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}], 
                          ")"}]}]], "-", FractionBox[RowBox[{RowBox[{FormBox[
                          \("C"\_"0"\), "TraditionalForm"], "(", FormBox[
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], "TraditionalForm"], ",", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\), 
                          "TraditionalForm"], ",", FormBox[RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], "-", RowBox[{"2", " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}], 
                          "TraditionalForm"], ",", FormBox["0", 
                          "TraditionalForm"], ",", FormBox[\(m\^2\), 
                          "TraditionalForm"], ",", FormBox["0", 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"], " ", 
                          RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], RowBox[{
                          \((m\^2 - \(\*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_1\%2)\), 
                          " ", RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], "-", RowBox[{"2", 
                          " ", RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", 
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\%2\)}], 
                          ")"}]}]]}], ")"}]}], TraditionalForm]], "Output", 
               CellTags -> "CancelQP"]}, Open]], Cell[BoxData[\(Clear[t]\)], 
            "Input", CellTags -> "CancelQP"]}, Open]], 
        Cell["Cases2", "ObjectName", CellTags -> "Cases2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Cases2"], Cell["Cases2[expr, f] returns a list of \
all objects in expr with head f. Cases2[expr,f] is equivalent to \
Cases2[{expr},f[___],Infinity]//Union. Cases2[expr, f, g, ...] or \
Cases2[expr, {f,g, ...}] is equivalent to Cases[{expr},f[___] | g[___] ...] \
.", "Text", CellTags -> "Cases2"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[Cases2]\)], "Input", CellTags -> "Cases2"], 
              Cell[BoxData[\(TraditionalForm\`\({Heads \[Rule] False}\)\)], 
               "Output", CellTags -> "Cases2"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell[BoxData["Examples"], "Subsubsection", 
            CellTags -> "Cases2"], Cell[CellGroupData[{Cell[BoxData[
                \(Cases2[\(\(\(f[a]\) + \(f[b]\)\^2 + \(f[\(c, d\)]\)\), f\)]
                  \)], "Input", CellTags -> "Cases2"], Cell[BoxData[
                \(TraditionalForm\`\({\(f(a)\), \(f(b)\), \(f(\(c, d\))\)}\)
                  \)], "Output", CellTags -> "Cases2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Cases2[\(\(\(\(Sin[x]\)\ \(Sin[\(y - z\)]\)\) + \(g[y]\)\),
                      Sin, g\)]\)], "Input", CellTags -> "Cases2"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(g(y)\), \(sin(x)\), 
                      \(sin(\(y - z\))\)}\)\)], "Output", CellTags -> 
                "Cases2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Cases2[\(\(\(\(Sin[x]\)\ \(Sin[\(y - z\)]\)\) + \(g[x]\) + 
                       \(g[\(a, b, c\)]\)\), \({Sin, g}\)\)]\)], "Input", 
               CellTags -> "Cases2"], Cell[BoxData[
                \(TraditionalForm\`\({\(g(x)\), \(g(\(a, b, c\))\), 
                      \(sin(x)\), \(sin(\(y - z\))\)}\)\)], "Output", 
               CellTags -> "Cases2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Cases2[\(\(\(\(DiracSlash[p]\) . \(DiracSlash[q]\)\) + 
                       \(ScalarProduct[\(p, p\)]\)\), Dot\)]\)], "Input", 
               CellTags -> "Cases2"], Cell[BoxData[FormBox[RowBox[
                  {"{", RowBox[{RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], ".", RowBox[{"(", 
                       RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                       ")"}]}], "}"}], TraditionalForm]], "Output", 
               CellTags -> "Cases2"]}, Open]]}, Open]], 
        Cell["CF", "ObjectName", CellTags -> "CF"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "CF"], Cell[TextData[
             {"CF is one of the Casimir operator eigenvalues of SU(", 
              StyleBox["N", Rule[FontSlant, "Italic"]], ") (CF = (", 
              Cell[BoxData[\(TraditionalForm\`\(N\^2\)\)]], "-1)/(2 ", 
              StyleBox["N", Rule[FontSlant, "Italic"]], "))."}], "Text", 
            CellTags -> "CF"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["CA", RuleDelayed[ButtonData, "CA"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "CA"]], 
              ", ", 
              ButtonBox["SUNSimplify", RuleDelayed[ButtonData, 
                 "SUNSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNSimplify"]], "."}], "Text", 
            CellTags -> "CF"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "CF"], 
           Cell[CellGroupData[{Cell[BoxData["CF"], "Input", CellTags -> 
                "CF"], Cell[BoxData[\(TraditionalForm\`C\_F\)], "Output", 
               CellTags -> "CF"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(CF,\ \(SUNNToCACF \[Rule] False\)\)]\)], 
               "Input", CellTags -> "CF"], Cell[BoxData[
                \(TraditionalForm\`\(\(N\^2 - 1\)\/\(2\ N\)\)\)], "Output", 
               CellTags -> "CF"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%//InputForm\)], "Input"], Cell["(-1 + SUNN^2)/(2*SUNN)", 
               "Output"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData["SUNN"], "Input", CellTags -> "CF"], Cell[BoxData[
                \(TraditionalForm\`N\)], "Output", CellTags -> "CF"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(\(SUNN^2\) - 1\),\ 
                     \(SUNNToCACF\ \[Rule] True\)\)]\)], "Input", CellTags -> 
                "CF"], Cell[BoxData[\(TraditionalForm\`\(2\ C\_A\ C\_F\)\)], 
               "Output", CellTags -> "CF"]}, Open]]}, Open]], 
        Cell["ChangeDimension", "ObjectName", CellTags -> "ChangeDimension"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ChangeDimension"], Cell["ChangeDimension[exp, dim] \
changes all LorentzIndex and Momenta in exp to dimension dim (and also \
Levi-Civita-tensors, Dirac slashes and Dirac matrices).", "Text", 
            CellTags -> "ChangeDimension"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["LorentzIndex", 
                RuleDelayed[ButtonData, "LorentzIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LorentzIndex"]], ", ", 
              ButtonBox["Momentum", RuleDelayed[ButtonData, "Momentum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Momentum"]], ", ", 
              ButtonBox["DiracGamma", RuleDelayed[ButtonData, "DiracGamma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGamma"]], ", ", 
              ButtonBox["Eps", RuleDelayed[ButtonData, "Eps"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Eps"]], 
              "."}], "Text", CellTags -> "ChangeDimension"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ChangeDimension"], Cell["Remember that \
LorentzIndex[mu, 4] is simplified to LorentzIndex[mu] and Momentum[p, 4] to \
Momentum[p]. Thus the fullowing objects are defined in four dimensions.", 
            "Text", CellTags -> "ChangeDimension"], 
           Cell[CellGroupData[{Cell[BoxData[
                \({\(LorentzIndex[\[Mu]]\),\ \(Momentum[p]\)}\)], "Input", 
               CellTags -> "ChangeDimension"], Cell[BoxData[FormBox[
                 RowBox[{"{", RowBox[{FormBox["\[Mu]", "TraditionalForm"], 
                     ",", "p"}], "}"}], TraditionalForm]], "Output", 
               CellTags -> "ChangeDimension"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ChangeDimension[\(%,\ D\)]\)], 
               "Input", CellTags -> "ChangeDimension"], Cell[BoxData[
                FormBox[RowBox[{"{", RowBox[{FormBox["\[Mu]", 
                      "TraditionalForm"], ",", "p"}], "}"}], 
                 TraditionalForm]], "Output", CellTags -> 
                "ChangeDimension"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%//StandardForm\)], "Input", CellTags -> 
                "ChangeDimension"], Cell[BoxData[
                \({\(LorentzIndex[\(\[Mu], D\)]\), \(Momentum[\(p, D\)]\)}\)]\
, "Output", CellTags -> "ChangeDimension"]}, Open]], 
           Cell["This changes all non-4-dimensional objects to 4-dimensional \
ones.", "Text", CellTags -> "ChangeDimension"], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(ChangeDimension[\(%%,\ 4\)]\)\ //\ StandardForm\)], 
               "Input", CellTags -> "ChangeDimension"], Cell[BoxData[
                \({\(LorentzIndex[\[Mu]]\), \(Momentum[p]\)}\)], "Output", 
               CellTags -> "ChangeDimension"]}, Open]], 
           Cell[
            "Consider the following list of 4- and D-dimensional object.", 
            "Text", CellTags -> "ChangeDimension"], 
           Cell[CellGroupData[{Cell[BoxData[
                \({\(\(GA[\(\[Mu], \[Nu]\)]\)\ \(MT[\(\[Mu], \[Nu]\)]\)\),\ 
                    \(\(GAD[\(\[Mu], \[Nu]\)]\)\ \(MTD[\(\[Mu], \[Nu]\)]\)\ 
                      \(f[D]\)\)}\)], "Input", CellTags -> 
                "ChangeDimension"], Cell[BoxData[
                \(TraditionalForm\`\({\(\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu]\)
                        \ g\^\(\[Mu]\[Nu]\)\), 
                      \(\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu]\)\ \(f(D)\)\ 
                        g\^\(\[Mu]\[Nu]\)\)}\)\)], "Output", CellTags -> 
                "ChangeDimension"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracTrick[\(Contract[%]\)]\)], "Input", CellTags -> 
                "ChangeDimension"], Cell[BoxData[
                \(TraditionalForm\`\({4, \(D\ \(f(D)\)\)}\)\)], "Output", 
               CellTags -> "ChangeDimension"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DiracTrick[\(Contract[\(ChangeDimension[\(%%, n\)]\)]\)]\)]\
, "Input", CellTags -> "ChangeDimension"], Cell[BoxData[
                \(TraditionalForm\`\({n, \(n\ \(f(D)\)\)}\)\)], "Output", 
               CellTags -> "ChangeDimension"]}, Open]], Cell["Any explicit \
occurence of D (like in f(D)) is not replaced by ChangeDimension.", "Text", 
            CellTags -> "ChangeDimension"], Cell[BoxData[
             \(\(SetOptions[\(LeviCivita, \(Dimension \[Rule] D\)\)]\) ;\)], 
            "Input", CellTags -> "ChangeDimension"], Cell["The option \
Dimension of Eps must be changed too, since with the default setting \
Dimension\[Rule]4 the arguments of Eps are automatically changed to 4 \
dimensions.", "Text", CellTags -> "ChangeDimension"], Cell[BoxData[
             \(\(SetOptions[\(Eps, \(Dimension \[Rule] D\)\)]\) ;\)], 
            "Input", CellTags -> "ChangeDimension"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(a1\ =\ \(LeviCivita[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\)\)]\
, "Input", CellTags -> "ChangeDimension"], Cell[BoxData[FormBox[
                 SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                      "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                    FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["\[Sigma]", "TraditionalForm"], 
                     "TraditionalForm"]}]], TraditionalForm]], "Output", 
               CellTags -> "ChangeDimension"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(a2\ =\ \(ChangeDimension[\(a1, 4\)]\)\)], "Input", 
               CellTags -> "ChangeDimension"], Cell[BoxData[FormBox[
                 SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                      "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                    FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["\[Sigma]", "TraditionalForm"], 
                     "TraditionalForm"]}]], TraditionalForm]], "Output", 
               CellTags -> "ChangeDimension"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Factor2[\(Contract[\(a1\^2\)]\)]\)], "Input", CellTags -> 
                "ChangeDimension"], Cell[BoxData[
                \(TraditionalForm\`\(\((1 - D)\)\ \((2 - D)\)\ \((3 - D)\)\ D
                    \)\)], "Output", CellTags -> "ChangeDimension"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Contract[\(a2\^2\)]\)], 
               "Input", CellTags -> "ChangeDimension"], Cell[BoxData[
                \(TraditionalForm\`\(-24\)\)], "Output", CellTags -> 
                "ChangeDimension"]}, Open]], Cell[BoxData[
             \(\(SetOptions[\(Eps, \(Dimension \[Rule] 4\)\)]\) ;\)], 
            "Input", CellTags -> "ChangeDimension"], Cell[BoxData[
             \(\(Clear[\(a1, a2\)]\) ;\)], "Input", CellTags -> 
             "ChangeDimension"]}, Open]], Cell["ChargeConjugationMatrix", 
         "ObjectName", CellTags -> "ChargeConjugationMatrix"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ChargeConjugationMatrix"], 
           Cell[TextData[
             {"ChargeConjugationMatrix denotes the charge conjugation matrix \
", StyleBox["C", Rule[FontSlant, "Italic"]], "."}], "Text", 
            CellTags -> "ChargeConjugationMatrix"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["ChargeConjugationMatrixInv", 
                RuleDelayed[ButtonData, "ChargeConjugationMatrixInv"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ChargeConjugationMatrixInv"]], "."}], 
            "Text", CellTags -> "ChargeConjugationMatrix"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ChargeConjugationMatrix"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(ChargeConjugationMatrix . \(DiracMatrix[\[Mu]]\) . 
                   ChargeConjugationMatrixInv\)], "Input", CellTags -> 
                "ChargeConjugationMatrix"], Cell[BoxData[FormBox[
                 RowBox[{"C", ".", SuperscriptBox["\[Gamma]", FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", \((\(-C\))\)}], 
                 TraditionalForm]], "Output", CellTags -> 
                "ChargeConjugationMatrix"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Calc[%]\)], "Input", 
               CellTags -> "ChargeConjugationMatrix"], Cell[BoxData[
                FormBox[RowBox[{"-", SubsuperscriptBox["\[Gamma]", FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                    "T"]}], TraditionalForm]], "Output", CellTags -> 
                "ChargeConjugationMatrix"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(ChargeConjugationMatrix . \(DiracGamma[5]\) . 
                   ChargeConjugationMatrixInv\)], "Input", CellTags -> 
                "ChargeConjugationMatrix"], Cell[BoxData[
                \(TraditionalForm\`\(C . \[Gamma]\^5 . \((\(-C\))\)\)\)], 
               "Output", CellTags -> "ChargeConjugationMatrix"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Calc[%]\)], "Input", 
               CellTags -> "ChargeConjugationMatrix"], Cell[BoxData[
                FormBox[SubsuperscriptBox["\[Gamma]", FormBox["5", 
                   "TraditionalForm"], "T"], TraditionalForm]], "Output", 
               CellTags -> "ChargeConjugationMatrix"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ChargeConjugationMatrix^2\)], 
               "Input", CellTags -> "ChargeConjugationMatrix"], Cell[BoxData[
                \(TraditionalForm\`\(-1\)\)], "Output", CellTags -> 
                "ChargeConjugationMatrix"]}, Open]]}, Open]], 
        Cell["ChargeConjugationMatrixInv", "ObjectName", 
         CellTags -> "ChargeConjugationMatrixInv"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ChargeConjugationMatrixInv"], Cell["ChargeConjugatio\
nMatrixInv is the inverse of ChargeConjugationMatrix. It is substituted \
immediately by -ChargeConjugationMatrix.", "Text", CellTags -> 
             "ChargeConjugationMatrixInv"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["ChargeConjugationMatrix", 
                RuleDelayed[ButtonData, "ChargeConjugationMatrix"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ChargeConjugationMatrix"]], "."}], "Text", 
            CellTags -> "ChargeConjugationMatrixInv"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ChargeConjugationMatrixInv"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(ChargeConjugationMatrix . \(DiracMatrix[\[Mu]]\) . 
                   ChargeConjugationMatrixInv\)], "Input", CellTags -> 
                "ChargeConjugationMatrixInv"], Cell[BoxData[FormBox[
                 RowBox[{"C", ".", SuperscriptBox["\[Gamma]", FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", \((\(-C\))\)}], 
                 TraditionalForm]], "Output", CellTags -> 
                "ChargeConjugationMatrixInv"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Calc[%]\)], "Input", 
               CellTags -> "ChargeConjugationMatrixInv"], Cell[BoxData[
                FormBox[RowBox[{"-", SubsuperscriptBox["\[Gamma]", FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                    "T"]}], TraditionalForm]], "Output", CellTags -> 
                "ChargeConjugationMatrixInv"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(ChargeConjugationMatrix . \(DiracGamma[5]\) . 
                   ChargeConjugationMatrixInv\)], "Input", CellTags -> 
                "ChargeConjugationMatrixInv"], Cell[BoxData[
                \(TraditionalForm\`\(C . \[Gamma]\^5 . \((\(-C\))\)\)\)], 
               "Output", CellTags -> "ChargeConjugationMatrixInv"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Calc[%]\)], "Input", 
               CellTags -> "ChargeConjugationMatrixInv"], Cell[BoxData[
                FormBox[SubsuperscriptBox["\[Gamma]", FormBox["5", 
                   "TraditionalForm"], "T"], TraditionalForm]], "Output", 
               CellTags -> "ChargeConjugationMatrixInv"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(ChargeConjugationMatrix . ChargeConjugationMatrixInv\)], 
               "Input", CellTags -> "ChargeConjugationMatrixInv"], 
              Cell[BoxData[\(TraditionalForm\`\(C . \((\(-C\))\)\)\)], 
               "Output", CellTags -> "ChargeConjugationMatrixInv"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//Calc\)], "Input", 
               CellTags -> "ChargeConjugationMatrixInv"], Cell[BoxData[
                \(TraditionalForm\`\(-\(C . C\)\)\)], "Output", CellTags -> 
                "ChargeConjugationMatrixInv"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ChargeConjugationMatrixInv^2\)]
                , "Input", CellTags -> "ChargeConjugationMatrixInv"], 
              Cell[BoxData[\(TraditionalForm\`\(-1\)\)], "Output", 
               CellTags -> "ChargeConjugationMatrixInv"]}, Open]]}, Open]], 
        Cell["CheckContext", "ObjectName", CellTags -> "CheckContext"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "CheckContext"], Cell["CheckContext[string] yields \
True if the packaged associated with string is already loaded, and False \
otherwise.", "Text", CellTags -> "CheckContext"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["MakeContext", RuleDelayed[ButtonData, 
                 "MakeContext"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MakeContext"]], ", ", 
              ButtonBox["$FeynCalcStuff", 
                RuleDelayed[ButtonData, "$FeynCalcStuff"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "$FeynCalcStuff"]], "."}], "Text", 
            CellTags -> "CheckContext"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "CheckContext"], Cell["If a FeynCalc symbol has not \
been used, the corresponding subpackage has not been loaded:", "Text", 
            CellTags -> "CheckContext"], Cell[CellGroupData[{Cell[BoxData[
                \(CheckContext["CompleteSquare"]\)], "Input", CellTags -> 
                "CheckContext"], Cell[BoxData[\(TraditionalForm\`False\)], 
               "Output", CellTags -> "CheckContext"]}, Open]], 
           Cell["Using it makes FeynCalc load the subpackage:", "Text", 
            CellTags -> "CheckContext"], Cell[CellGroupData[
             {Cell[BoxData["CompleteSquare"], "Input", CellTags -> 
                "CheckContext"], Cell[BoxData[
                \(TraditionalForm\`CompleteSquare\)], "Output", CellTags -> 
                "CheckContext"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(CheckContext["CompleteSquare"]\)], "Input", CellTags -> 
                "CheckContext"], Cell[BoxData[\(TraditionalForm\`True\)], 
               "Output", CellTags -> "CheckContext"]}, Open]]}, Open]], 
        Cell["CheckDB", "ObjectName", CellTags -> "CheckDB"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            GeneratedCell -> True, CellAutoOverwrite -> True, 
            CellTags -> "CheckDB"], Cell["CheckDB[exp, fil] saves [with Put] \
or retrieves [with Get] exp from a file fil. It checks if the setting of the \
option Directory is a valid directory name and if fil is a valid file name \
and does exist. If it does, Get[fil] is executed. If fil does not exist, exp \
gets evaluated and saved to  fil. Saving and evaluating can be further \
controlled with the options ForceSave and NoSave. If the option Check is set \
to False  the return value is what is evaluated [see above]. If Check is set \
to True the return value is True or False depending on whether the evaluation \
of exp agrees with what is loaded from fil or fil does not exist.  Default \
value of Check : False.\nNOTICE : If fil ends with \".Gen\" or \".Mod\", the  \
 setting of Directory is ignored and fil is  saved in the \"CouplingVectors\" \
 subdirectory of \"Phi\". If fil ends with  \".Fac\", the setting of \
Directory is  ignored and fil is saved in the \"Factors\" subdirectory of \
\"Phi\". If fil is a file   name with full path, the setting of  Directory is \
also ignored.", "Text", CellTags -> "CheckDB"], Cell[CellGroupData[
             {Cell[BoxData[\(Options[CheckDB]\)], "Input", CellTags -> 
                "CheckDB"], Cell[BoxData[
                \(TraditionalForm\`\({\(Directory \[Rule] "C:\\Program \
Files\\Wolfram \
Research\\Mathematica\\5.2\\AddOns\\Applications\\HighEnergy\
Physics\\Phi\\Storage"\), \(ForceSave \[Rule] False\), 
                      \(NoSave \[Rule] False\), \(Check \[Rule] False\)}\)\)]\
, "Output", CellTags -> "CheckDB"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Attributes[CheckDB]\)], "Input", CellTags -> "CheckDB"], 
              Cell[BoxData[\(TraditionalForm\`\({HoldFirst}\)\)], "Output", 
               CellTags -> "CheckDB"]}, Open]], Cell["The first time the \
Table function is evaluated and the result saved into the test.s file.", 
            "Text", CellTags -> "CheckDB"], Cell[CellGroupData[{Cell[BoxData[
                \(CheckDB[\(\(Table[\(\(\(WriteString[\("stdout", "test "\)]
                            \) ; i\), \({i, 2}\)\)]\), "test.s"\)]\)], 
               "Input", CellTags -> "CheckDB"], Cell["test test ", "Print", 
               CellTags -> "CheckDB"], Cell[BoxData[
                \(TraditionalForm\`\({1, 2}\)\)], "Output", CellTags -> 
                "CheckDB"]}, Open]], Cell["Executing the same a second time \
will just load the result from test.s and not evaluate the Table function.", 
            "Text", CellTags -> "CheckDB"], Cell[CellGroupData[{Cell[BoxData[
                \(CheckDB[\(\(Table[\(\(\(WriteString[\("stdout", "test "\)]
                            \) ; i\), \({i, 2}\)\)]\), "test.s"\)]\)], 
               "Input", CellTags -> "CheckDB"], Cell[BoxData[
                \(TraditionalForm\`\({1, 2}\)\)], "Output", CellTags -> 
                "CheckDB"]}, Open]], 
           Cell["This shows the actual saved value of test.s.", "Text", 
            CellTags -> "CheckDB"], Cell[CellGroupData[{Cell[BoxData[
                \(Import[\(\(ToFileName[\(
                        \(Directory/.\(Options[CheckDB]\)\), "test.s"\)]\),\
 "Text"\)]\)], "Input", CellTags -> "CheckDB"], Cell[BoxData[
                \(TraditionalForm\`"{1, 2}\n"\)], "Output", CellTags -> 
                "CheckDB"]}, Open]], Cell[BoxData[
             \(DeleteFile[\(ToFileName[
                  \(\(Directory/.\(Options[CheckDB]\)\), "test.s"\)]\)]\)], 
            "Input", CellTags -> "CheckDB"]}, Open]], 
        Cell["ChiralityProjector", "ObjectName", CellTags -> 
          "ChiralityProjector"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "ChiralityProjector"], Cell[TextData[
             {"ChiralityProjector[+1] denotes ", Cell[BoxData[
                \(TraditionalForm\`\(\(1/2\) \((1 + \[Gamma]\^5)\)\)\)]], 
              ". ChiralityProjector[-1] denotes ", Cell[BoxData[
                \(TraditionalForm\`\(\(1/2\) \((1 + \[Gamma]\^5)\)\)\)]], 
              "."}], "Text", CellTags -> "ChiralityProjector"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracGamma", RuleDelayed[ButtonData, "DiracGamma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGamma"]], ", ", 
              ButtonBox["DiracMatrix", RuleDelayed[ButtonData, 
                 "DiracMatrix"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracMatrix"]], ", ", 
              ButtonBox["FCI", RuleDelayed[ButtonData, "FCI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCI"]], 
              "."}], "Text", CellTags -> "ChiralityProjector"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ChiralityProjector"], Cell[CellGroupData[
             {Cell[BoxData[
                \({\(ChiralityProjector[\(+1\)]\), 
                    \(ChiralityProjector[\(-1\)]\)}\)], "Input", CellTags -> 
                "ChiralityProjector"], Cell[BoxData[
                \(TraditionalForm\`\({\[Gamma]\^6, \[Gamma]\^7}\)\)], 
               "Output", CellTags -> "ChiralityProjector"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(StandardForm[%]\)], "Input"], 
              Cell[BoxData[\({\(DiracGamma[6]\), \(DiracGamma[7]\)}\)], 
               "Output"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracSimplify[\(%%, \(DiracSubstitute67 \[Rule] True\)\)]\)]\
, "Input", CellTags -> "ChiralityProjector"], Cell[BoxData[
                \(TraditionalForm\`\({\(\[Gamma]\^5\/2 + 1\/2\), 
                      \(1\/2 - \[Gamma]\^5\/2\)}\)\)], "Output", CellTags -> 
                "ChiralityProjector"]}, Open]]}, Open]], 
        Cell["Chisholm", "ObjectName", CellTags -> "Chisholm"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Chisholm"], Cell["Chisholm[x] substitutes products \
of three Dirac matrices or slashes by the Chisholm identity.", "Text", 
            CellTags -> "Chisholm"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["EpsChisholm", RuleDelayed[ButtonData, 
                 "EpsChisholm"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "EpsChisholm"]], ", ", 
              ButtonBox["ChisholmSpinor", 
                RuleDelayed[ButtonData, "ChisholmSpinor"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ChisholmSpinor"]], "."}], "Text", 
            CellTags -> "Chisholm"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Chisholm"], Cell[CellGroupData[{Cell[BoxData[
                \(Chisholm[\(GA[\(\[Alpha], \[Beta], \[Mu], \[Nu]\)]\)]\)], 
               "Input", CellTags -> "Chisholm"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{\(-\[ImaginaryI]\), " ", RowBox[
                      {SuperscriptBox["\[Gamma]", FormBox[FormBox["$MU$111", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       \(\[Gamma]\^5\)}], " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Beta]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["$MU$111", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{SuperscriptBox["\[Gamma]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Alpha]\[Beta]\)\)}], "-", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Beta]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]]}], 
                     " ", \(g\^\(\[Alpha]\[Mu]\)\)}], "+", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Alpha]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Beta]\[Mu]\)\)}]
                     }], TraditionalForm]], "Output", CellTags -> 
                "Chisholm"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(DiracMatrix[\(\[Mu], \[Nu], \[Rho]\)]\)\)], "Input", 
               CellTags -> "Chisholm"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] \[Gamma]\^\[Nu] 
                     \[Gamma]\^\[Rho]\)\)], "Output", CellTags -> 
                "Chisholm"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t2\ = \(Chisholm[t1]\)\)], "Input", CellTags -> 
                "Chisholm"], Cell[BoxData[FormBox[RowBox[{RowBox[
                    {"\[ImaginaryI]", " ", RowBox[{SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["$MU$132", "TraditionalForm"], 
                         "TraditionalForm"]], ".", \(\[Gamma]\^5\)}], " ", 
                     SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["$MU$132", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{SuperscriptBox[
                      "\[Gamma]", FormBox[FormBox["\[Rho]", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     \(g\^\(\[Mu]\[Nu]\)\)}], "-", RowBox[{SuperscriptBox[
                      "\[Gamma]", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     \(g\^\(\[Mu]\[Rho]\)\)}], "+", RowBox[{SuperscriptBox[
                      "\[Gamma]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     \(g\^\(\[Nu]\[Rho]\)\)}]}], TraditionalForm]], "Output", 
               CellTags -> "Chisholm"]}, Open]], 
           Cell["The $MU$ variables are unique indices.", "Text", 
            CellTags -> "Chisholm"], Cell[CellGroupData[{Cell[BoxData[
                \(Calc[\(t1 . t1\)]\)], "Input", CellTags -> "Chisholm"], 
              Cell[BoxData[\(TraditionalForm\`16\)], "Output", CellTags -> 
                "Chisholm"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t3\ = \(Chisholm[t1]\)\)], "Input", CellTags -> 
                "Chisholm"], Cell[BoxData[FormBox[RowBox[{RowBox[
                    {"\[ImaginaryI]", " ", RowBox[{SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["$MU$151", "TraditionalForm"], 
                         "TraditionalForm"]], ".", \(\[Gamma]\^5\)}], " ", 
                     SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["$MU$151", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{SuperscriptBox[
                      "\[Gamma]", FormBox[FormBox["\[Rho]", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     \(g\^\(\[Mu]\[Nu]\)\)}], "-", RowBox[{SuperscriptBox[
                      "\[Gamma]", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     \(g\^\(\[Mu]\[Rho]\)\)}], "+", RowBox[{SuperscriptBox[
                      "\[Gamma]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     \(g\^\(\[Nu]\[Rho]\)\)}]}], TraditionalForm]], "Output", 
               CellTags -> "Chisholm"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Calc[\(t2 . t3\)]\)], "Input", CellTags -> 
                "Chisholm"], Cell[BoxData[\(TraditionalForm\`16\)], "Output", 
               CellTags -> "Chisholm"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(t4 = \(DiracSlash[\(a, b, c\)]\)\)], "Input", 
               CellTags -> "Chisholm"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                        "TraditionalForm"], "\[CenterDot]", FormBox["a", 
                        "TraditionalForm"]}], ")"}], ".", RowBox[{"(", 
                     RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["b", "TraditionalForm"]}], 
                     ")"}], ".", RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                        "TraditionalForm"], "\[CenterDot]", FormBox["c", 
                        "TraditionalForm"]}], ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "Chisholm"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Chisholm[t4]\)], "Input", 
               CellTags -> "Chisholm"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(-\[ImaginaryI]\), " ", RowBox[{SuperscriptBox[
                        "\[Gamma]", FormBox[FormBox["$MU$177", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       \(\[Gamma]\^5\)}], " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["$MU$177", "TraditionalForm"], 
                         "TraditionalForm"], FormBox["a", "TraditionalForm"], 
                        FormBox["b", "TraditionalForm"], FormBox["c", 
                         "TraditionalForm"]}]]}], "+", RowBox[
                    {RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["c", "TraditionalForm"]}], 
                     " ", RowBox[{FormBox["a", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["b", "TraditionalForm"]}]}], 
                   "-", RowBox[{RowBox[{FormBox["\"\[Gamma]\"", 
                        "TraditionalForm"], "\[CenterDot]", FormBox["b", 
                        "TraditionalForm"]}], " ", RowBox[{FormBox["a", 
                        "TraditionalForm"], "\[CenterDot]", FormBox["c", 
                        "TraditionalForm"]}]}], "+", RowBox[{RowBox[
                      {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["a", "TraditionalForm"]}], 
                     " ", RowBox[{FormBox["b", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["c", "TraditionalForm"]}]}]}], 
                 TraditionalForm]], "Output", CellTags -> "Chisholm"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(a1 = \(GA[\(\[Mu], \[Nu], \[Rho], \[Sigma], \[Tau], 
                       \[Kappa]\)]\)\)], "Input", CellTags -> "Chisholm"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . 
                     \[Gamma]\^\[Rho] . \[Gamma]\^\[Sigma] . \[Gamma]\^\[Tau]
                      . \[Gamma]\^\[Kappa]\)\)], "Output", CellTags -> 
                "Chisholm"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(a2\ = \(Chisholm[a1]\)\)], "Input", CellTags -> 
                "Chisholm"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(-\[ImaginaryI]\), " ", RowBox[{SuperscriptBox[
                        "\[Gamma]", FormBox[FormBox["\[Tau]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Kappa]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       \(\[Gamma]\^5\)}], " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{"\[ImaginaryI]", " ", RowBox[{SuperscriptBox[
                        "\[Gamma]", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Kappa]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       \(\[Gamma]\^5\)}], " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Tau]", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "-", 
                   RowBox[{"\[ImaginaryI]", " ", RowBox[{SuperscriptBox[
                        "\[Gamma]", FormBox[FormBox["$MU$208", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Kappa]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       \(\[Gamma]\^5\)}], " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Tau]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["$MU$208", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     \(g\^\(\[Mu]\[Nu]\)\)}], "+", RowBox[{"\[ImaginaryI]", 
                     " ", RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "$MU$219", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", \(\[Gamma]\^5\)}], " ", 
                     SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Tau]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["$MU$219", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", \(g\^\(\[Mu]\[Rho]\)\)}]
                     , "-", RowBox[{"\[ImaginaryI]", " ", RowBox[
                      {SuperscriptBox["\[Gamma]", FormBox[FormBox["$MU$230", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Kappa]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       \(\[Gamma]\^5\)}], " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Tau]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["$MU$230", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     \(g\^\(\[Nu]\[Rho]\)\)}], "+", RowBox[{RowBox[
                      {SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Tau]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Kappa]", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Mu]\[Sigma]\)\), " ", \(g\^\(\[Nu]\[Rho]\)\)}], 
                   "-", RowBox[{RowBox[{SuperscriptBox["\[Gamma]", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Tau]\)\), 
                     " ", \(g\^\(\[Nu]\[Rho]\)\)}], "-", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Tau]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Rho]\)\), 
                     " ", \(g\^\(\[Nu]\[Sigma]\)\)}], "+", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Rho]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Tau]\)\), 
                     " ", \(g\^\(\[Nu]\[Sigma]\)\)}], "+", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Rho]\)\), 
                     " ", \(g\^\(\[Nu]\[Tau]\)\)}], "-", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Rho]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Sigma]\)\)
                     , " ", \(g\^\(\[Nu]\[Tau]\)\)}], "+", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Tau]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Nu]\)\), 
                     " ", \(g\^\(\[Rho]\[Sigma]\)\)}], "-", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Tau]\)\), 
                     " ", \(g\^\(\[Rho]\[Sigma]\)\)}], "+", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Nu]\[Tau]\)\), 
                     " ", \(g\^\(\[Rho]\[Sigma]\)\)}], "-", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Nu]\)\), 
                     " ", \(g\^\(\[Rho]\[Tau]\)\)}], "+", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Sigma]\)\)
                     , " ", \(g\^\(\[Rho]\[Tau]\)\)}], "-", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Nu]\[Sigma]\)\)
                     , " ", \(g\^\(\[Rho]\[Tau]\)\)}], "-", RowBox[
                    {"\[ImaginaryI]", " ", RowBox[{SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["$MU$186", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", \(\[Gamma]\^5\)}], " ", 
                     SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["$MU$186", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", \(g\^\(\[Sigma]\[Tau]\)\)
                     }], "+", RowBox[{RowBox[{SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Nu]\)\), 
                     " ", \(g\^\(\[Sigma]\[Tau]\)\)}], "-", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Rho]\)\), 
                     " ", \(g\^\(\[Sigma]\[Tau]\)\)}], "+", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Nu]\[Rho]\)\), 
                     " ", \(g\^\(\[Sigma]\[Tau]\)\)}]}], TraditionalForm]], 
               "Output", CellTags -> "Chisholm"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(a3\ = \(Chisholm[a1]\)\)], 
               "Input", CellTags -> "Chisholm"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{\(-\[ImaginaryI]\), " ", RowBox[
                      {SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Tau]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Kappa]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       \(\[Gamma]\^5\)}], " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{"\[ImaginaryI]", " ", RowBox[{SuperscriptBox[
                        "\[Gamma]", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Kappa]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       \(\[Gamma]\^5\)}], " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Tau]", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "-", 
                   RowBox[{"\[ImaginaryI]", " ", RowBox[{SuperscriptBox[
                        "\[Gamma]", FormBox[FormBox["$MU$290", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Kappa]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       \(\[Gamma]\^5\)}], " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Tau]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["$MU$290", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     \(g\^\(\[Mu]\[Nu]\)\)}], "+", RowBox[{"\[ImaginaryI]", 
                     " ", RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "$MU$301", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", \(\[Gamma]\^5\)}], " ", 
                     SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Tau]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["$MU$301", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", \(g\^\(\[Mu]\[Rho]\)\)}]
                     , "-", RowBox[{"\[ImaginaryI]", " ", RowBox[
                      {SuperscriptBox["\[Gamma]", FormBox[FormBox["$MU$312", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Kappa]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       \(\[Gamma]\^5\)}], " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Tau]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["$MU$312", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     \(g\^\(\[Nu]\[Rho]\)\)}], "+", RowBox[{RowBox[
                      {SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Tau]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Kappa]", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Mu]\[Sigma]\)\), " ", \(g\^\(\[Nu]\[Rho]\)\)}], 
                   "-", RowBox[{RowBox[{SuperscriptBox["\[Gamma]", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Tau]\)\), 
                     " ", \(g\^\(\[Nu]\[Rho]\)\)}], "-", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Tau]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Rho]\)\), 
                     " ", \(g\^\(\[Nu]\[Sigma]\)\)}], "+", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Rho]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Tau]\)\), 
                     " ", \(g\^\(\[Nu]\[Sigma]\)\)}], "+", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Rho]\)\), 
                     " ", \(g\^\(\[Nu]\[Tau]\)\)}], "-", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Rho]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Sigma]\)\)
                     , " ", \(g\^\(\[Nu]\[Tau]\)\)}], "+", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Tau]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Nu]\)\), 
                     " ", \(g\^\(\[Rho]\[Sigma]\)\)}], "-", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Tau]\)\), 
                     " ", \(g\^\(\[Rho]\[Sigma]\)\)}], "+", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Nu]\[Tau]\)\), 
                     " ", \(g\^\(\[Rho]\[Sigma]\)\)}], "-", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Nu]\)\), 
                     " ", \(g\^\(\[Rho]\[Tau]\)\)}], "+", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Sigma]\)\)
                     , " ", \(g\^\(\[Rho]\[Tau]\)\)}], "-", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Nu]\[Sigma]\)\)
                     , " ", \(g\^\(\[Rho]\[Tau]\)\)}], "-", RowBox[
                    {"\[ImaginaryI]", " ", RowBox[{SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["$MU$268", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", \(\[Gamma]\^5\)}], " ", 
                     SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["$MU$268", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", \(g\^\(\[Sigma]\[Tau]\)\)
                     }], "+", RowBox[{RowBox[{SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Nu]\)\), 
                     " ", \(g\^\(\[Sigma]\[Tau]\)\)}], "-", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Rho]\)\), 
                     " ", \(g\^\(\[Sigma]\[Tau]\)\)}], "+", RowBox[
                    {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                       ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Kappa]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Nu]\[Rho]\)\), 
                     " ", \(g\^\(\[Sigma]\[Tau]\)\)}]}], TraditionalForm]], 
               "Output", CellTags -> "Chisholm"]}, Open]], 
           Cell["Check that both a1.a1 and a2.a3 give the same.", "Text", 
            CellTags -> "Chisholm"], Cell[CellGroupData[{Cell[BoxData[
                \(Calc[\(a1 . a1\)]\)], "Input", CellTags -> "Chisholm"], 
              Cell[BoxData[\(TraditionalForm\`\(-2048\)\)], "Output", 
               CellTags -> "Chisholm"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Calc[\(a2 . a3\)]\)], "Input", CellTags -> 
                "Chisholm"], Cell[BoxData[\(TraditionalForm\`\(-2048\)\)], 
               "Output", CellTags -> "Chisholm"]}, Open]], Cell[BoxData[
             \(Clear[\(t1, t2, t3, t4, a1, a2, a3\)]\)], "Input", 
            CellTags -> "Chisholm"]}, Open]], Cell["ChisholmSpinor", 
         "ObjectName", CellTags -> "ChisholmSpinor"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ChisholmSpinor"], Cell["ChisholmSpinor[x] uses the \
Chisholm identity on a DiraGamma between spinors. As an optional second \
argument 1 or 2 may be given, indicating that ChisholmSpinor should only act \
on the first resp. second part of a product of spinor chains.", "Text", 
            CellTags -> "ChisholmSpinor"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["EpsChisholm", RuleDelayed[ButtonData, 
                 "EpsChisholm"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "EpsChisholm"]], ", ", 
              ButtonBox["Chisholm", RuleDelayed[ButtonData, "Chisholm"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Chisholm"]], "."}], "Text", 
            CellTags -> "ChisholmSpinor"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ChisholmSpinor"], Cell[CellGroupData[{Cell[BoxData[
                \(\(Spinor[\(p1, m1\)]\) . 
                   \(DiracGamma[\(LorentzIndex[\[Mu]]\)]\) . 
                   \(Spinor[\(p2, m2\)]\)\)], "Input", CellTags -> 
                "ChisholmSpinor"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"\[CurlyPhi]", "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_1\), 
                      "TraditionalForm"], ",", "m1", ")"}], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   RowBox[{"\[CurlyPhi]", "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_2\), 
                      "TraditionalForm"], ",", "m2", ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "ChisholmSpinor"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(%//ChisholmSpinor\)], 
               "Input", CellTags -> "ChisholmSpinor"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"-", FractionBox[RowBox[{"m1", " ", 
                        "m2", " ", RowBox[{RowBox[{"\[CurlyPhi]", "(", 
                          FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], ",", "m1", ")"}], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          RowBox[{"\[CurlyPhi]", "(", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], ",", "m2", ")"}]}]}], 
                      RowBox[{FormBox[
                         \(\(\*TagBox[StyleBox["\"p\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1\), 
                         "TraditionalForm"], "\[CenterDot]", FormBox[
                         \(\(\*TagBox[StyleBox["\"p\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2\), 
                         "TraditionalForm"]}]]}], "+", FractionBox[
                    RowBox[{"\[ImaginaryI]", " ", RowBox[{RowBox[
                         {"\[CurlyPhi]", "(", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], ",", "m1", ")"}], ".", 
                        SuperscriptBox["\[Gamma]", FormBox[FormBox["alpha1", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                        \(\[Gamma]\^5\), ".", RowBox[{"\[CurlyPhi]", "(", 
                          FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], ",", "m2", ")"}]}], " ", 
                      SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "alpha1", "TraditionalForm"], "TraditionalForm"], 
                         FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]]}], RowBox[{FormBox[
                       \(\(\*TagBox[StyleBox["\"p\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1\), 
                       "TraditionalForm"], "\[CenterDot]", FormBox[
                       \(\(\*TagBox[StyleBox["\"p\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2\), 
                       "TraditionalForm"]}]], "+", FractionBox[RowBox[
                     {"m2", " ", RowBox[{RowBox[{"\[CurlyPhi]", "(", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], ",", "m1", ")"}], ".", 
                        RowBox[{"\[CurlyPhi]", "(", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], ",", "m2", ")"}]}], " ", 
                      SubsuperscriptBox[
                       TagBox[StyleBox["\"p\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]], "1", FormBox[
                        FormBox["\[Mu]", "TraditionalForm"], 
                        "TraditionalForm"]]}], RowBox[{FormBox[
                       \(\(\*TagBox[StyleBox["\"p\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1\), 
                       "TraditionalForm"], "\[CenterDot]", FormBox[
                       \(\(\*TagBox[StyleBox["\"p\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2\), 
                       "TraditionalForm"]}]], "+", FractionBox[RowBox[
                     {"m1", " ", RowBox[{RowBox[{"\[CurlyPhi]", "(", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], ",", "m1", ")"}], ".", 
                        RowBox[{"\[CurlyPhi]", "(", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], ",", "m2", ")"}]}], " ", 
                      SubsuperscriptBox[
                       TagBox[StyleBox["\"p\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]], "2", FormBox[
                        FormBox["\[Mu]", "TraditionalForm"], 
                        "TraditionalForm"]]}], RowBox[{FormBox[
                       \(\(\*TagBox[StyleBox["\"p\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1\), 
                       "TraditionalForm"], "\[CenterDot]", FormBox[
                       \(\(\*TagBox[StyleBox["\"p\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2\), 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "ChisholmSpinor"]}, Open]]}, Open]], 
        Cell["ClearScalarProducts", "ObjectName", CellTags -> 
          "ClearScalarProducts"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "ClearScalarProducts"], Cell["ClearScalarProducts removes all \
user-performed specific settings for ScalarProduct's.", "Text", 
            CellTags -> "ClearScalarProducts"], Cell[TextData[{"See also: ", 
              ButtonBox["ScalarProduct", 
                RuleDelayed[ButtonData, "ScalarProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ScalarProduct"]], ", ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              ", ", 
              ButtonBox["SP", RuleDelayed[ButtonData, "SP"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SP"]], 
              ", ", 
              ButtonBox["SPD", RuleDelayed[ButtonData, "SPD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SPD"]], 
              "."}], "Text", CellTags -> "ClearScalarProducts"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ClearScalarProducts"], Cell[CellGroupData[
             {Cell[BoxData[\(\(ScalarProduct[\(p, p\)]\) = \(m^2\)\)], 
               "Input", CellTags -> "ClearScalarProducts"], Cell[BoxData[
                \(TraditionalForm\`\(m\^2\)\)], "Output", CellTags -> 
                "ClearScalarProducts"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Pair[\(\(Momentum[p]\), \(Momentum[p]\)\)]\)], 
               "Input", CellTags -> "ClearScalarProducts"], Cell[BoxData[
                \(TraditionalForm\`\(m\^2\)\)], "Output", CellTags -> 
                "ClearScalarProducts"]}, Open]], 
           Cell[BoxData["ClearScalarProducts"], "Input", CellTags -> 
             "ClearScalarProducts"], Cell[CellGroupData[{Cell[BoxData[
                \(Pair[\(\(Momentum[p]\), \(Momentum[p]\)\)]\)], "Input", 
               CellTags -> "ClearScalarProducts"], Cell[BoxData[
                FormBox[SuperscriptBox[FormBox["p", "TraditionalForm"], "2"], 
                 TraditionalForm]], "Output", CellTags -> 
                "ClearScalarProducts"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(ScalarProduct[\(p, p\)]\)], "Input", CellTags -> 
                "ClearScalarProducts"], Cell[BoxData[FormBox[SuperscriptBox[
                  FormBox["p", "TraditionalForm"], "2"], TraditionalForm]], 
               "Output", CellTags -> "ClearScalarProducts"]}, Open]]}, 
          Open]], Cell["Collecting", "ObjectName", CellTags -> "Collecting"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Collecting"], Cell["Collecting is an option of \
ScalarProductCancel, Series2, TID and related functions. Setting it to True \
will trigger some kind of collecting of the result.", "Text", 
            CellTags -> "Collecting"], Cell[TextData[{"See also:  ", 
              ButtonBox["ScalarProductCancel", 
                RuleDelayed[ButtonData, "ScalarProductCancel"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ScalarProductCancel"]], ", ", 
              ButtonBox["Series2", RuleDelayed[ButtonData, "Series2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Series2"]]\
, ", ", 
              ButtonBox["TID", RuleDelayed[ButtonData, "TID"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TID"]], 
              "."}], "Text", CellTags -> "Collecting"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["Collect2", "ObjectName", 
         CellTags -> "Collect2"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Collect2"], 
           Cell["Collect2[expr, x] collects together terms which are not free \
of any occurrence of x. Collect2[expr, {x1, x2, ...}] (or also Collect2[expr, \
x1, x2, ...]) collects together terms which are not free of any occurrence of \
x1, x2, .... The coefficients are put over a common denominator. If expr is \
expanded before collecting depends on the option Factoring, which may be set \
to Factor, Factor2, or any other function, which is applied to the \
coefficients. If expr is already expanded with respect to x (x1,x2, ...), the \
option Expanding can be set to False.", "Text", CellTags -> "Collect2"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[Collect2]\)], "Input", 
               CellTags -> "Collect2"], Cell[BoxData[
                \(TraditionalForm\`\({\(Denominator \[Rule] False\), 
                      \(Dot \[Rule] False\), \(Expanding \[Rule] True\), 
                      \(Factoring \[Rule] Factor2\), 
                      \(IsolateNames \[Rule] False\)}\)\)], "Output", 
               CellTags -> "Collect2"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Isolate", RuleDelayed[ButtonData, "Isolate"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Isolate"]]\
, "."}], "Text", CellTags -> "Collect2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Collect2"], Cell[CellGroupData[{Cell[BoxData[
                \(Collect2[\(\(t1 = \(a + \(r\ a\) + \(k\^2\ \(f[a]\)\) - 
                         \(k\ \(f[a]\)\) + x\/2 - y\/w\)\), a\)]\)], "Input", 
               CellTags -> "Collect2"], Cell[BoxData[FormBox[RowBox[{
                   \(a\ \((r + 1)\)\), "+", 
                   \(\(\(w\ x\) - \(2\ y\)\)\/\(2\ w\)\), "-", RowBox[
                    {RowBox[{"(", RowBox[{"1", "-", FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"]}], ")"}], " ", FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     " ", \(f(a)\)}]}], TraditionalForm]], "Output", 
               CellTags -> "Collect2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Collect2[\(t1, a, \(Factoring \[Rule] False\)\)]\)], 
               "Input", CellTags -> "Collect2"], Cell[BoxData[FormBox[RowBox[{
                   \(a\ \((r + 1)\)\), "+", \(x\/2\), "-", \(y\/w\), "+", 
                   RowBox[{RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], "-", FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"]}], ")"}], " ", \(f(a)\)}]}], 
                 TraditionalForm]], "Output", CellTags -> "Collect2"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Collect2[\(t1, a, \(Factoring \[Rule] Factor\)\)]\)], 
               "Input", CellTags -> "Collect2"], Cell[BoxData[FormBox[RowBox[{
                   \(a\ \((r + 1)\)\), "+", 
                   \(\(\(w\ x\) - \(2\ y\)\)\/\(2\ w\)\), "+", RowBox[
                    {RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "1"}], ")"}], " ", FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     " ", \(f(a)\)}]}], TraditionalForm]], "Output", 
               CellTags -> "Collect2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Collect2[\(\(\(2\ a\ \((b - a)\)\ \((h - 1)\)\) - 
                       \(b\^2\ \((\(e\ a\) - c)\)\) + b\^2\), \({a, b}\)\)]\)]\
, "Input", CellTags -> "Collect2"], Cell[BoxData[
                \(TraditionalForm\`\(\(2\ \((1 - h)\)\ a\^2\) - 
                     \(b\^2\ e\ a\) - \(2\ b\ \((1 - h)\)\ a\) + 
                     \(b\^2\ \((c + 1)\)\)\)\)], "Output", CellTags -> 
                "Collect2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Collect2[\(\(Expand[\(\((a - b - c - d)\)\^5\)]\), a, 
                     \(IsolateNames \[Rule] l\)\)]\)], "Input", CellTags -> 
                "Collect2"], Cell[BoxData[
                \(TraditionalForm\`\(a\^5 - 
                     \(5\ \*TagBox[\(l(1)\), HoldForm]\ a\^4\) + 
                     \(10\ \*TagBox[\(l(1)\), HoldForm]\^2\ a\^3\) - 
                     \(10\ \*TagBox[\(l(1)\), HoldForm]\^3\ a\^2\) + 
                     \(5\ \*TagBox[\(l(1)\), HoldForm]\^4\ a\) - 
                     \*TagBox[\(l(1)\), HoldForm]\^5\)\)], "Output", 
               CellTags -> "Collect2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(ReleaseHold[%]\)], "Input", CellTags -> 
                "Collect2"], Cell[BoxData[
                \(TraditionalForm\`\(a\^5 - \(5\ \((b + c + d)\)\ a\^4\) + 
                     \(10\ \((b + c + d)\)\^2\ a\^3\) - 
                     \(10\ \((b + c + d)\)\^3\ a\^2\) + 
                     \(5\ \((b + c + d)\)\^4\ a\) - \((b + c + d)\)\^5\)\)], 
               "Output", CellTags -> "Collect2"]}, Open]], Cell[BoxData[
             \(Clear[\(t1, l\)]\)], "Input", CellTags -> "Collect2"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Collect2[\(\(Expand[\(\((a - b - c)\)\^3\)]\), a, 
                     \(Factoring \[Rule] fun\)\)]\)], "Input", CellTags -> 
                "Collect2"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(fun(1)\)\ a\^3\) + 
                     \(\(fun(\(\(\(-3\)\ b\) - \(3\ c\)\))\)\ a\^2\) + 
                     \(\(fun(\(\(3\ b\^2\) + \(6\ c\ b\) + \(3\ c\^2\)\))\)\ 
                       a\) + \(fun(\(\(-b\^3\) - \(3\ c\ b\^2\) - 
                         \(3\ c\^2\ b\) - c\^3\))\)\)\)], "Output", 
               CellTags -> "Collect2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(%\ /.\ \(fun \[Rule] FactorTerms\)\)], "Input", 
               CellTags -> "Collect2"], Cell[BoxData[
                \(TraditionalForm\`\(a\^3 - \(3\ \((b + c)\)\ a\^2\) + 
                     \(3\ \((b\^2 + \(2\ c\ b\) + c\^2)\)\ a\) - b\^3 - c\^3 
                     - \(3\ b\ c\^2\) - \(3\ b\^2\ c\)\)\)], "Output", 
               CellTags -> "Collect2"]}, Open]]}, Open]], 
        Cell["Collect3", "ObjectName", CellTags -> "Collect3"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Collect3"], Cell[TextData[{"Collect3[expr, {x, y, \
...}] collects terms involving the same powers of monomials ", Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["x", 
                       Rule[FontSlant, "Plain"]]\^
                     \(\(\*StyleBox["n", Rule[FontSlant, "Plain"]]\)\_1\)\)\)]\
], Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["y", 
                       Rule[FontSlant, "Plain"]]\^
                     \(\(\*StyleBox["n", Rule[FontSlant, "Plain"]]\)\_2\)\)\)]\
], " ... An option Factor \[Rule] True/False can be  given, which factors the \
coefficients. The option Head (default Plus) determines the applied function \
to the list of monomials  mulitplied by their coefficients."}], "Text", 
            CellTags -> "Collect3"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[Collect3]\)], "Input", CellTags -> "Collect3"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(Factoring \[Rule] False\), 
                      \(Head \[Rule] Plus\)}\)\)], "Output", CellTags -> 
                "Collect3"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Collect2", RuleDelayed[ButtonData, "Collect2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Collect2"]], ", ", 
              ButtonBox["Isolate", RuleDelayed[ButtonData, "Isolate"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Isolate"]]\
, "."}], "Text", CellTags -> "Collect3"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Collect3"], Cell[CellGroupData[{Cell[BoxData[
                \(Collect3[\(\(\(2\ a\ \((b - a)\)\ \((h - 1)\)\) - 
                       \(b\^2\ \((\(e\ a\) - c)\)\) + b\^2\), \({a, b}\)\)]\)]\
, "Input", CellTags -> "Collect3"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(-2\)\ h\ a\^2\) + \(2\ a\^2\) - 
                     \(2\ b\ a\) - \(b\^2\ e\ a\) + \(2\ b\ h\ a\) + b\^2 + 
                     \(b\^2\ c\)\)\)], "Output", CellTags -> "Collect3"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Collect3[\(\(Expand[\(\((a - b - c - d)\)\^5\)]\), \({a}\)
                    \)]\)], "Input", CellTags -> "Collect3"], Cell[BoxData[
                \(TraditionalForm\`\(a\^5 - \(5\ b\ a\^4\) - \(5\ c\ a\^4\) -
                      \(5\ d\ a\^4\) + \(10\ b\^2\ a\^3\) + 
                     \(10\ c\^2\ a\^3\) + \(10\ d\^2\ a\^3\) + 
                     \(20\ b\ c\ a\^3\) + \(20\ b\ d\ a\^3\) + 
                     \(20\ c\ d\ a\^3\) - \(10\ b\^3\ a\^2\) - 
                     \(10\ c\^3\ a\^2\) - \(10\ d\^3\ a\^2\) - 
                     \(30\ b\ c\^2\ a\^2\) - \(30\ b\ d\^2\ a\^2\) - 
                     \(30\ c\ d\^2\ a\^2\) - \(30\ b\^2\ c\ a\^2\) - 
                     \(30\ b\^2\ d\ a\^2\) - \(30\ c\^2\ d\ a\^2\) - 
                     \(60\ b\ c\ d\ a\^2\) + \(5\ b\^4\ a\) + \(5\ c\^4\ a\) 
                     + \(5\ d\^4\ a\) + \(20\ b\ c\^3\ a\) + 
                     \(20\ b\ d\^3\ a\) + \(20\ c\ d\^3\ a\) + 
                     \(30\ b\^2\ c\^2\ a\) + \(30\ b\^2\ d\^2\ a\) + 
                     \(30\ c\^2\ d\^2\ a\) + \(60\ b\ c\ d\^2\ a\) + 
                     \(20\ b\^3\ c\ a\) + \(20\ b\^3\ d\ a\) + 
                     \(20\ c\^3\ d\ a\) + \(60\ b\ c\^2\ d\ a\) + 
                     \(60\ b\^2\ c\ d\ a\) - b\^5 - c\^5 - d\^5 - 
                     \(5\ b\ c\^4\) - \(5\ b\ d\^4\) - \(5\ c\ d\^4\) - 
                     \(10\ b\^2\ c\^3\) - \(10\ b\^2\ d\^3\) - 
                     \(10\ c\^2\ d\^3\) - \(20\ b\ c\ d\^3\) - 
                     \(10\ b\^3\ c\^2\) - \(10\ b\^3\ d\^2\) - 
                     \(10\ c\^3\ d\^2\) - \(30\ b\ c\^2\ d\^2\) - 
                     \(30\ b\^2\ c\ d\^2\) - \(5\ b\^4\ c\) - \(5\ b\^4\ d\) 
                     - \(5\ c\^4\ d\) - \(20\ b\ c\^3\ d\) - 
                     \(30\ b\^2\ c\^2\ d\) - \(20\ b\^3\ c\ d\)\)\)], 
               "Output", CellTags -> "Collect3"]}, Open]]}, Open]], 
        Cell["Combine", "ObjectName", CellTags -> "Combine"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Combine"], Cell["Combine[expr]puts terms in a sum \
over a common denominator,and cancels factors in the result. Combine is \
similar to Together, but accepts the option Expanding and works usually \
better than Together for polynomials involving rationals with sums in the \
denominator.", "Text", CellTags -> "Combine"], Cell[CellGroupData[
             {Cell[BoxData[\(Options[Combine]\)], "Input", CellTags -> 
                "Combine"], Cell[BoxData[
                \(TraditionalForm\`\({Expanding \[Rule] False}\)\)], 
               "Output", CellTags -> "Combine"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Factor2", RuleDelayed[ButtonData, "Factor2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Factor2"]]\
, "."}], "Text", CellTags -> "Combine"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Combine"], Cell[CellGroupData[{Cell[BoxData[
                \(Combine[\(\(\((a - b)\)\ \((c - d)\)\)\/e + g\)]\)], 
               "Input", CellTags -> "Combine"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(\((a - b)\)\ \((c - d)\)\) + 
                       \(e\ g\)\)\/e\)\)], "Output", CellTags -> "Combine"]}, 
             Open]], Cell["Here the result from Together where the numerator \
is automatically expanded.", "Text", CellTags -> "Combine"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Together[\(\(\((a - b)\)\ \((c - d)\)\)\/e + g\)]\)], 
               "Input", CellTags -> "Combine"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(a\ c\) - \(b\ c\) - \(a\ d\) + 
                       \(b\ d\) + \(e\ g\)\)\/e\)\)], "Output", CellTags -> 
                "Combine"]}, Open]], Cell["If the option Expanding is set to \
True, the result of Combine is the same as Together, but uses a slightly \
different algorithm.", "Text", CellTags -> "Combine"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Combine[\(\(\(\((a - b)\)\ \((c - d)\)\)\/e + g\), 
                     \(Expanding \[Rule] True\)\)]\)], "Input", CellTags -> 
                "Combine"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(a\ c\) - \(b\ c\) - \(a\ d\) + 
                       \(b\ d\) + \(e\ g\)\)\/e\)\)], "Output", CellTags -> 
                "Combine"]}, Open]]}, Open]], Cell["CombineGraphs", 
         "ObjectName", CellTags -> "CombineGraphs"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "CombineGraphs"], 
           Cell["CombineGraphs is an option for OneLoopSum.", "Text", 
            CellTags -> "CombineGraphs"], Cell[TextData[{"See also:  ", 
              ButtonBox["OneLoopSum", RuleDelayed[ButtonData, "OneLoopSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSum"]], "."}], "Text", 
            CellTags -> "CombineGraphs"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["Commutator", "ObjectName", CellTags -> "Commutator"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Commutator"], Cell["Commutator[x, y] = c defines the \
commutator between the (non-commuting) objects x and y. ", "Text", 
            CellTags -> "Commutator"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["AntiCommutator", 
                RuleDelayed[ButtonData, "AntiCommutator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "AntiCommutator"]], ", ", 
              ButtonBox["CommutatorExplicit", 
                RuleDelayed[ButtonData, "CommutatorExplicit"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CommutatorExplicit"]], ", ", 
              ButtonBox["DeclareNonCommutative", 
                RuleDelayed[ButtonData, "DeclareNonCommutative"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeclareNonCommutative"]], ", ", 
              ButtonBox["DotSimplify", RuleDelayed[ButtonData, 
                 "DotSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DotSimplify"]], "."}], "Text", 
            CellTags -> "Commutator"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Commutator"], Cell[BoxData[
             \(DeclareNonCommutative[\(a, b, c, d\)]\)], "Input", 
            CellTags -> "Commutator"], Cell[CellGroupData[{Cell[BoxData[
                \(Commutator[\(a, b\)]\)], "Input", CellTags -> 
                "Commutator"], Cell[BoxData[
                \(TraditionalForm\`\([\[NoBreak]a\[NoBreak], b\[NoBreak]]\)\)]\
, "Output", CellTags -> "Commutator"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(CommutatorExplicit[%]\)], "Input", CellTags -> 
                "Commutator"], Cell[BoxData[
                \(TraditionalForm\`\(\(a . b\) - \(b . a\)\)\)], "Output", 
               CellTags -> "Commutator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(DotSimplify[\(Commutator[\(\(a + b\), \(c + d\)\)]\)]\)\ 
                  \)], "Input", CellTags -> "Commutator"], Cell[BoxData[
                \(TraditionalForm\`\(\(a . c\) + \(a . d\) + \(b . c\) + 
                     \(b . d\) - \(c . a\) - \(c . b\) - \(d . a\) - 
                     \(d . b\)\)\)], "Output", CellTags -> "Commutator"]}, 
             Open]], Cell[BoxData[\(UnDeclareNonCommutative[\(a, b, c, d\)]\)]
             , "Input", CellTags -> "Commutator"], 
           Cell["Verify the Jacobi identity.", "Text", CellTags -> 
             "Commutator"], Cell[BoxData[
             \(\(\[Chi] = Commutator\) ;\ 
                \(DeclareNonCommutative[\(x, y, z\)]\) ;\)], "Input", 
            CellTags -> "Commutator"], Cell[CellGroupData[{Cell[BoxData[
                \(\(\[Chi][\(x, \(\[Chi][\(y, z\)]\)\)]\) + 
                   \(\[Chi][\(y, \(\[Chi][\(z, x\)]\)\)]\) + 
                   \(\[Chi][\(z, \(\[Chi][\(x, y\)]\)\)]\)\)], "Input", 
               CellTags -> "Commutator"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"[", "\[NoBreak]", "x", "\[NoBreak]", ",", FormBox[
                      \([\[NoBreak]y\[NoBreak], z\[NoBreak]]\), 
                      "TraditionalForm"], "\[NoBreak]", "]"}], "+", 
                   RowBox[{"[", "\[NoBreak]", "y", "\[NoBreak]", ",", FormBox[
                      \([\[NoBreak]z\[NoBreak], x\[NoBreak]]\), 
                      "TraditionalForm"], "\[NoBreak]", "]"}], "+", 
                   RowBox[{"[", "\[NoBreak]", "z", "\[NoBreak]", ",", FormBox[
                      \([\[NoBreak]x\[NoBreak], y\[NoBreak]]\), 
                      "TraditionalForm"], "\[NoBreak]", "]"}]}], 
                 TraditionalForm]], "Output", CellTags -> "Commutator"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(DotSimplify[%]\)], 
               "Input", CellTags -> "Commutator"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> 
                "Commutator"]}, Open]], Cell[BoxData[\(Clear[\[Chi]]\)], 
            "Input", CellTags -> "Commutator"], Cell[BoxData[
             \(UnDeclareNonCommutative[\(x, y, z\)]\)], "Input", 
            CellTags -> "Commutator"]}, Open]], Cell["CommutatorExplicit", 
         "ObjectName", CellTags -> "CommutatorExplicit"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "CommutatorExplicit"], Cell["CommutatorExplicit[exp] \
substitutes any Commutator and AntiCommutator in exp by their definitions.", 
            "Text", CellTags -> "CommutatorExplicit"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Calc", RuleDelayed[ButtonData, "Calc"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Calc"]], 
              ", ", 
              ButtonBox["DotSimplify", RuleDelayed[ButtonData, 
                 "DotSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DotSimplify"]], "."}], "Text", 
            CellTags -> "CommutatorExplicit"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "CommutatorExplicit"], Cell[BoxData[
             \(DeclareNonCommutative[\(a, b, c, d\)]\)], "Input", 
            CellTags -> "CommutatorExplicit"], Cell[CellGroupData[
             {Cell[BoxData[\(Commutator[\(a, b\)]\)], "Input", CellTags -> 
                "CommutatorExplicit"], Cell[BoxData[
                \(TraditionalForm\`\([\[NoBreak]a\[NoBreak], b\[NoBreak]]\)\)]\
, "Output", CellTags -> "CommutatorExplicit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(CommutatorExplicit[%]\)], 
               "Input", CellTags -> "CommutatorExplicit"], Cell[BoxData[
                \(TraditionalForm\`\(\(a . b\) - \(b . a\)\)\)], "Output", 
               CellTags -> "CommutatorExplicit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(AntiCommutator[\(\(a - c\), \(b - d\)\)]\)], "Input", 
               CellTags -> "CommutatorExplicit"], Cell[BoxData[FormBox[
                 RowBox[{"{", FormBox[\(a - c\), "TraditionalForm"], ",", 
                   "\[MediumSpace]", FormBox[\(b - d\), "TraditionalForm"], 
                   "}"}], TraditionalForm]], "Output", CellTags -> 
                "CommutatorExplicit"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(CommutatorExplicit[%]\)], "Input", CellTags -> 
                "CommutatorExplicit"], Cell[BoxData[
                \(TraditionalForm\`\(\(\((a - c)\) . \((b - d)\)\) + 
                     \(\((b - d)\) . \((a - c)\)\)\)\)], "Output", 
               CellTags -> "CommutatorExplicit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(CommutatorExplicit[%%]\)//DotSimplify\)], "Input", 
               CellTags -> "CommutatorExplicit"], Cell[BoxData[
                \(TraditionalForm\`\(\(a . b\) - \(a . d\) + \(b . a\) - 
                     \(b . c\) - \(c . b\) + \(c . d\) - \(d . a\) + 
                     \(d . c\)\)\)], "Output", CellTags -> 
                "CommutatorExplicit"]}, Open]], Cell[BoxData[
             \(UnDeclareNonCommutative[\(a, b, c, d\)]\)], "Input", 
            CellTags -> "CommutatorExplicit"]}, Open]], 
        Cell["CompleteSquare", "ObjectName", CellTags -> "CompleteSquare"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "CompleteSquare"], Cell[TextData[{"Completes the \
square of a second order polynomial in the momentum x. CompleteSquare[", "a", 
              " ", Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["p", 
                       Rule[FontSlant, "Plain"]]\^2\)\)]], "+", "b", " ", 
              "p", "+", "c", ", ", "p", "] \[Rule] -", Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["b", 
                       Rule[FontSlant, "Plain"]]\^2\)\)]], "/(4 ", "a", ")+", 
              "c", "+", "a", " (", "b", "/(2 ", "a", ")+", "x", 
              ")^2. CompleteSquare[", "a", " ", Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["p", 
                       Rule[FontSlant, "Plain"]]\^2\)\)]], "+", "b", " ", 
              "p", "+", "c", ", ", "p", ", ", "q", "] \[Rule] {-", 
              Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["b", 
                       Rule[FontSlant, "Plain"]]\^2\)\)]], "/(4 ", "a", ")+", 
              "c", "+", "a", " ", Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["q", 
                       Rule[FontSlant, "Plain"]]\^2\)\)]], ", ", "q", 
              "\[Rule]", "b", "/(2 ", "a", ")+", "p", "}."}], "Text", 
            CellTags -> "CompleteSquare"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "CompleteSquare"], Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(\(5\(SP[\(\(\(2p\) + \(3r\)\), \(p + r\)\)]\)\)//FCI
                    \)\)], "Input"], Cell[BoxData[FormBox[RowBox[{"5", " ", 
                   RowBox[{"(", FormBox[\(p + r\), "TraditionalForm"], ")", 
                     "\[CenterDot]", "(", FormBox[\(\(2\ p\) + \(3\ r\)\), 
                      "TraditionalForm"], ")"}]}], TraditionalForm]], 
               "Output"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t2 = \(CompleteSquare[\(t1, p\)]\)\)], "Input", CellTags -> 
                "CompleteSquare"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"10", " ", RowBox[{"(", TagBox[FormBox[
                         \(p + \(5\ r\)\/4\), "TraditionalForm"], 
                        TraditionalForm, Editable -> True], ")", ".", "(", 
                       TagBox[FormBox[\(p + \(5\ r\)\/4\), 
                         "TraditionalForm"], TraditionalForm, Editable -> 
                         True], ")"}]}], "-", FractionBox[RowBox[{"5", " ", 
                      SuperscriptBox[FormBox["r", "TraditionalForm"], "2"]}], 
                    "8"]}], TraditionalForm]], "Output", CellTags -> 
                "CompleteSquare"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(t1 - t2\)//ScalarProductExpand\)//Expand\)], "Input", 
               CellTags -> "CompleteSquare"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> 
                "CompleteSquare"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(CompleteSquare[\(t1, p, q\)]\)], "Input", CellTags -> 
                "CompleteSquare"], Cell[BoxData[FormBox[RowBox[{"{", 
                   RowBox[{RowBox[{RowBox[{"10", " ", SuperscriptBox[FormBox[
                          "q", "TraditionalForm"], "2"]}], "-", FractionBox[
                        RowBox[{"5", " ", SuperscriptBox[FormBox["r", 
                          "TraditionalForm"], "2"]}], "8"]}], ",", 
                     \(q \[Rule] \(p + \(5\ r\)\/4\)\)}], "}"}], 
                 TraditionalForm]], "Output", CellTags -> "CompleteSquare"]}, 
             Open]], Cell[BoxData[\(Clear[\(t1, t2\)]\)], "Input", 
            CellTags -> "CompleteSquare"]}, Open]], Cell["ComplexConjugate", 
         "ObjectName", CellTags -> "ComplexConjugate"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ComplexConjugate"], Cell["ComplexConjugate[expr] \
complex conjugates expr. It operates on fermion lines, i.e., products of \
Spinor[..] .DiracMatrix[..] . Spinor[..], and changes all occuring \
LorentzIndex[mu] into LorentzIndex[ComplexIndex[mu]]. For taking the spin sum \
(i.e. constructing the traces) use FermionSpinSum. WARNING: In expr should be \
NO explicit I's in denominators!", "Text", CellTags -> "ComplexConjugate"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["ComplexIndex", 
                RuleDelayed[ButtonData, "ComplexIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ComplexIndex"]], ", ", 
              ButtonBox["FermionSpinSum", 
                RuleDelayed[ButtonData, "FermionSpinSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FermionSpinSum"]], ", ", 
              ButtonBox["LorentzIndex", 
                RuleDelayed[ButtonData, "LorentzIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LorentzIndex"]], "."}], "Text", 
            CellTags -> "ComplexConjugate"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ComplexConjugate"], Cell[CellGroupData[{Cell[BoxData[
                \(ComplexConjugate[\(MetricTensor[\(\[Mu], \[Nu]\)]\)]\)], 
               "Input", CellTags -> "ComplexConjugate"], Cell[BoxData[
                \(TraditionalForm\`\(g\^\(\[Mu]\[Nu]\)\)\)], "Output", 
               CellTags -> "ComplexConjugate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(StandardForm[%]\)], "Input", 
               CellTags -> "ComplexConjugate"], Cell[BoxData[
                \(Pair[\(\(LorentzIndex[\[Mu]]\), \(LorentzIndex[\[Nu]]\)\)]
                  \)], "Output", CellTags -> "ComplexConjugate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(GA[\(\[Mu], \[Nu], 5\)]\)], 
               "Input", CellTags -> "ComplexConjugate"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . 
                     \[Gamma]\^5\)\)], "Output", CellTags -> 
                "ComplexConjugate"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(ComplexConjugate[%]\)], "Input", CellTags -> 
                "ComplexConjugate"], Cell[BoxData[FormBox[RowBox[
                  {"-", RowBox[{\(\[Gamma]\^5\), ".", SuperscriptBox[
                      "\[Gamma]", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]]}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "ComplexConjugate"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SUNTrace[\(SUNT[\(a, b, c\)]\)]\)], "Input", 
               CellTags -> "ComplexConjugate"], Cell[BoxData[FormBox[
                 RowBox[{"tr", "(", FormBox[RowBox[{SubscriptBox["T", 
                       FormBox[FormBox["a", "TraditionalForm"], 
                        "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                        FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                      ".", SubscriptBox["T", FormBox[FormBox["c", 
                         "TraditionalForm"], "TraditionalForm"]]}], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "ComplexConjugate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ComplexConjugate[%]\)], 
               "Input", CellTags -> "ComplexConjugate"], Cell[BoxData[
                FormBox[RowBox[{"tr", "(", FormBox[RowBox[{SubscriptBox["T", 
                       FormBox[FormBox["c", "TraditionalForm"], 
                        "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                        FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                      ".", SubscriptBox["T", FormBox[FormBox["a", 
                         "TraditionalForm"], "TraditionalForm"]]}], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "ComplexConjugate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(ComplexConjugate[\(SUNF[\(a, b, c\)]\)]\)], "Input", 
               CellTags -> "ComplexConjugate"], Cell[BoxData[FormBox[
                 SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                    FormBox[FormBox["c", "TraditionalForm"], 
                     "TraditionalForm"]}]], TraditionalForm]], "Output", 
               CellTags -> "ComplexConjugate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(FCE[\(ComplexConjugate[
                       \(MetricTensor[\(\[Mu], \[Nu]\)]\)]\)]\)]\)], "Input", 
               CellTags -> "ComplexConjugate"], Cell[BoxData[
                \(MT[\(\[Mu], \[Nu]\)]\)], "Output", CellTags -> 
                "ComplexConjugate"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(SpinorUBar[\(k1, m\)]\) . \(GA[\[Lambda]]\) . 
                   \(SpinorU[\(p1, m\)]\)\)], "Input", CellTags -> 
                "ComplexConjugate"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{FormBox[\("u"\&_\), "TraditionalForm"], "(", 
                     FormBox[
                      \(\(\*TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_1\), 
                      "TraditionalForm"], ",", "m", ")"}], ".", 
                   \(\[Gamma]\^\[Lambda]\), ".", RowBox[{"u", "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_1\), 
                      "TraditionalForm"], ",", "m", ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "ComplexConjugate"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(ComplexConjugate[%]\)], "Input", CellTags -> 
                "ComplexConjugate"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"\[CurlyPhi]", "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_1\), 
                      "TraditionalForm"], ",", "m", ")"}], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Lambda]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   RowBox[{"\[CurlyPhi]", "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_1\), 
                      "TraditionalForm"], ",", "m", ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "ComplexConjugate"]}, Open]], Cell["Notice that SpinorUBar \
and SpinorU are only input functions. Internally they are converted to Spinor \
objects.", "Text", CellTags -> "ComplexConjugate"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["Contract", "ObjectName", 
         CellTags -> "Contract"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Contract"], 
           Cell["Contract[expr] contracts pairs of Lorentz indices of metric \
tensors, four-vectors and (depending on the optionEpsContract) of Levi-Civita \
tensors in expr. For the contraction of Dirac matrices with each other use \
DiracSimplify. Contract[exp1, exp2] contracts (exp1*exp2), where exp1 and \
exp2 may be larger products of sums of metric tensors and 4-vectors. ", 
            "Text", CellTags -> "Contract"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[Contract]\)], "Input", CellTags -> "Contract"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(Collecting \[Rule] True\), 
                      \(Contract3 \[Rule] True\), 
                      \(EpsContract \[Rule] True\), 
                      \(Expanding \[Rule] True\), \(Factoring \[Rule] False\)
                      , \(FeynCalcInternal \[Rule] True\), 
                      \(MomentumCombine \[Rule] True\), 
                      \(Rename \[Rule] False\), \(Schouten \[Rule] 0\)}\)\)], 
               "Output", CellTags -> "Contract"]}, Open]], 
           Cell["The option setting Contract3 can be set to True resulting in \
a faster algorithm to contract products of tensors.", "Text"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["MomentumCombine", 
                RuleDelayed[ButtonData, "MomentumCombine"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MomentumCombine"]], "."}], "Text", 
            CellTags -> "Contract"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Contract"], Cell[CellGroupData[{Cell[BoxData[
                \(\(MetricTensor[\(\[Mu], \[Nu]\)]\)\ 
                   \(FourVector[\(p, \[Mu]\)]\)\)], "Input", CellTags -> 
                "Contract"], Cell[BoxData[
                \(TraditionalForm\`\(p\_\[Mu]\ g\^\(\[Mu]\[Nu]\)\)\)], 
               "Output", CellTags -> "Contract"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Contract[%]\)], "Input", 
               CellTags -> "Contract"], Cell[BoxData[FormBox[SuperscriptBox[
                  FormBox["p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                    "TraditionalForm"], "TraditionalForm"]], 
                 TraditionalForm]], "Output", CellTags -> "Contract"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(FourVector[\(p, \[Mu]\)]\) \(DiracMatrix[\[Mu]]\)\)], 
               "Input", CellTags -> "Contract"], Cell[BoxData[FormBox[
                 RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   \(p\_\[Mu]\)}], TraditionalForm]], "Output", CellTags -> 
                "Contract"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Contract[%]\)], "Input", CellTags -> "Contract"], 
              Cell[BoxData[FormBox[RowBox[{FormBox["\"\[Gamma]\"", 
                    "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                    "TraditionalForm"]}], TraditionalForm]], "Output", 
               CellTags -> "Contract"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(MetricTensor[\(\[Mu], \[Mu]\)]\)], "Input", 
               CellTags -> "Contract"], Cell[BoxData[
                \(TraditionalForm\`\(g\^\(\[Mu]\[Mu]\)\)\)], "Output", 
               CellTags -> "Contract"]}, Open]], 
           Cell["The default dimension for MetricTensor is 4.", "Text", 
            CellTags -> "Contract"], Cell[CellGroupData[{Cell[BoxData[
                \(Contract[%]\)], "Input", CellTags -> "Contract"], 
              Cell[BoxData[\(TraditionalForm\`4\)], "Output", CellTags -> 
                "Contract"]}, Open]], Cell["A short way to enter \
D-dimensional metric tensors is given by MTD. The \".\" as multiplication \
operator is not necessary but just convenient for typesetting.", "Text", 
            CellTags -> "Contract"], Cell[CellGroupData[{Cell[BoxData[
                \(\(MTD[\(\[Mu], \[Nu]\)]\)\ .\ \(MTD[\(\[Mu], \[Nu]\)]\)\)], 
               "Input", CellTags -> "Contract"], Cell[BoxData[
                \(TraditionalForm\`\(g\^\(\[Mu]\[Nu]\) . g\^\(\[Mu]\[Nu]\)\)
                  \)], "Output", CellTags -> "Contract"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Contract[%]\)], "Input", 
               CellTags -> "Contract"], Cell[BoxData[\(TraditionalForm\`D\)], 
               "Output", CellTags -> "Contract"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(MTD[\(\[Mu], \[Nu]\)]\)\ .\ \(MTD[\(\[Mu], \[Nu]\)]\)\)], 
               "Input", CellTags -> "Contract"], Cell[BoxData[
                \(TraditionalForm\`\(g\^\(\[Mu]\[Nu]\) . g\^\(\[Mu]\[Nu]\)\)
                  \)], "Output", CellTags -> "Contract"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(FourVector[\(p, \[Mu]\)]\)\ \(FourVector[\(q, \[Mu]\)]\)
                  \)], "Input", CellTags -> "Contract"], Cell[BoxData[
                \(TraditionalForm\`\(p\_\[Mu]\ q\_\[Mu]\)\)], "Output", 
               CellTags -> "Contract"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Contract[%\ ]\)], "Input", CellTags -> 
                "Contract"], Cell[BoxData[FormBox[RowBox[{FormBox["p", 
                    "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                    "TraditionalForm"]}], TraditionalForm]], "Output", 
               CellTags -> "Contract"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(FourVector[\(\(p - q\), \[Mu]\)]\)\ 
                   \(FourVector[\(\(a - b\), \[Mu]\)]\)\)], "Input", 
               CellTags -> "Contract"], Cell[BoxData[FormBox[RowBox[
                  {SubscriptBox[RowBox[{"(", FormBox[
                       TagBox[\(a - b\), HoldForm], "TraditionalForm"], 
                      ")"}], "\[Mu]"], " ", SubscriptBox[RowBox[{"(", FormBox[
                       TagBox[\(p - q\), HoldForm], "TraditionalForm"], 
                      ")"}], "\[Mu]"]}], TraditionalForm]], "Output", 
               CellTags -> "Contract"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Contract[%]\)], "Input", CellTags -> 
                "Contract"], Cell[BoxData[FormBox[RowBox[{RowBox[
                    {FormBox["a", "TraditionalForm"], "\[CenterDot]", 
                     FormBox["p", "TraditionalForm"]}], "-", RowBox[
                    {FormBox["a", "TraditionalForm"], "\[CenterDot]", 
                     FormBox["q", "TraditionalForm"]}], "-", RowBox[
                    {FormBox["b", "TraditionalForm"], "\[CenterDot]", 
                     FormBox["p", "TraditionalForm"]}], "+", RowBox[
                    {FormBox["b", "TraditionalForm"], "\[CenterDot]", 
                     FormBox["q", "TraditionalForm"]}]}], TraditionalForm]], 
               "Output", CellTags -> "Contract"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(LeviCivita[\(\[Mu], \[Nu], \[Alpha], \[Sigma]\)]\)\ 
                   \(FourVector[\(p, \[Sigma]\)]\)\)], "Input", CellTags -> 
                "Contract"], Cell[BoxData[FormBox[RowBox[{SuperscriptBox[
                    "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Alpha]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"]}]], " ", \(p\_\[Sigma]\)}], 
                 TraditionalForm]], "Output", CellTags -> "Contract"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(Contract[%]\)], 
               "Input", CellTags -> "Contract"], Cell[BoxData[FormBox[
                 SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                      "\[Alpha]", "TraditionalForm"], "TraditionalForm"], 
                    FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox["p", 
                     "TraditionalForm"]}]], TraditionalForm]], "Output", 
               CellTags -> "Contract"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(LeviCivita[\(\[Mu], \[Nu], \[Alpha], \[Beta]\)]\)\ 
                   \(LeviCivita[\(\[Mu], \[Nu], \[Alpha], \[Sigma]\)]\)\ \)], 
               "Input", CellTags -> "Contract"], Cell[BoxData[FormBox[
                 RowBox[{SuperscriptBox["\[Epsilon]", RowBox[{FormBox[
                       FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Alpha]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Beta]", 
                        "TraditionalForm"], "TraditionalForm"]}]], " ", 
                   SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Alpha]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Contract"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Contract[%]\)], "Input", CellTags -> 
                "Contract"], Cell[BoxData[
                \(TraditionalForm\`\(\(-6\)\ g\^\(\[Beta]\[Sigma]\)\)\)], 
               "Output", CellTags -> "Contract"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SetOptions[\(Eps, \(Dimension \[Rule] D\)\)]\) ; 
                   \(\(LCD[\(\[Mu], \[Nu], \[Alpha], \[Beta]\)]\)\ 
                     \(LCD[\(\[Mu], \[Nu], \[Alpha], \[Sigma]\)]\)\)\)], 
               "Input", CellTags -> "Contract"], Cell[BoxData[
                \(TraditionalForm\`\(\[Epsilon]\^
                      \(\[Mu]\[Nu]\[Alpha]\[Beta]\)\ 
                     \[Epsilon]\^\(\[Mu]\[Nu]\[Alpha]\[Sigma]\)\)\)], 
               "Output", CellTags -> "Contract"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(Contract[%]\)//Factor2\)], 
               "Input", CellTags -> "Contract"], Cell[BoxData[
                \(TraditionalForm\`\(\((1 - D)\)\ \((2 - D)\)\ \((3 - D)\)\ 
                     g\^\(\[Beta]\[Sigma]\)\)\)], "Output", CellTags -> 
                "Contract"]}, Open]], Cell[BoxData[
             \(\(SetOptions[\(Eps, \(Dimension \[Rule] 4\)\)]\) ;\)], 
            "Input", CellTags -> "Contract"]}, Open]], 
        Cell["Contract1", "ObjectName", CellTags -> "Contract1"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Contract1"], Cell["For covariant calculations it is \
not necessary to distinguish between co- and contravariant indices (except \
for the Levi-Civita tensor).\nTherefore normally no distinction is made \
between upper and lower indices.\nHowere, if needed, one can use Upper and \
Lower and then a distuction is made:\nContract1[exp] contracts Upper and \
Lower indices. Neither Upper and Upper nor Lower and Lower indices are \
contracted.", "Text", CellTags -> "Contract1"], Cell[TextData[{"See also:  ", 
              ButtonBox["LorentzIndex", 
                RuleDelayed[ButtonData, "LorentzIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LorentzIndex"]], ", ", 
              ButtonBox["Lower", RuleDelayed[ButtonData, "Lower"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Lower"]], 
              ", ", 
              ButtonBox["Upper", RuleDelayed[ButtonData, "Upper"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Upper"]], 
              "."}], "Text", CellTags -> "Contract1"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Contract1"], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(FV[\(p, \(Lower[\[Mu]]\)\)]\) 
                       \(FV[\(q, \(Upper[\[Mu]]\)\)]\)\)//FCI\)//Contract1\)]\
, "Input", CellTags -> "Contract1"], Cell[BoxData[FormBox[RowBox[
                  {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                   FormBox["q", "TraditionalForm"]}], TraditionalForm]], 
               "Output", CellTags -> "Contract1"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(FV[\(p, \(Upper[\[Mu]]\)\)]\) 
                       \(FV[\(q, \(Upper[\[Mu]]\)\)]\)\)//FCI\)//Contract1\)]\
, "Input", CellTags -> "Contract1"], Cell[BoxData[FormBox[RowBox[
                  {SuperscriptBox[FormBox["p", "TraditionalForm"], FormBox[
                     FormBox[\(Upper(\[Mu])\), "TraditionalForm"], 
                     "TraditionalForm"]], " ", SuperscriptBox[FormBox["q", 
                     "TraditionalForm"], FormBox[FormBox[\(Upper(\[Mu])\), 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "Contract1"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(MT[\(\(Lower[\[Mu]]\), \(Upper[\[Mu]]\)\)]\)//FCI\)//
                   Contract1\)], "Input", CellTags -> "Contract1"], 
              Cell[BoxData[\(TraditionalForm\`4\)], "Output", CellTags -> 
                "Contract1"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(MT[\(\(Upper[\[Mu]]\), \(Upper[\[Mu]]\)\)]\)//FCI\)//
                   Contract1\)], "Input", CellTags -> "Contract1"], 
              Cell[BoxData[FormBox[SuperscriptBox["g", RowBox[{FormBox[
                     \(Upper(\[Mu])\), "TraditionalForm"], FormBox[
                     \(Upper(\[Mu])\), "TraditionalForm"]}]], 
                 TraditionalForm]], "Output", CellTags -> "Contract1"]}, 
             Open]]}, Open]], Cell["Convolute", "ObjectName", 
         CellTags -> "Convolute"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Convolute"], 
           Cell[TextData[{"Convolute[f, g, x] convolutes ", 
              StyleBox["f", Rule[FontSlant, "Italic"]], "(", 
              StyleBox["x", Rule[FontSlant, "Italic"]], ") and ", 
              StyleBox["g", Rule[FontSlant, "Italic"]], "(", 
              StyleBox["x", Rule[FontSlant, "Italic"]], "), i.e., ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\[Integral]\_0\%1 
                     \(\(\*StyleBox[\(\*StyleBox["d", 
                               Rule[FontSlant, "Plain"]]\*
                              StyleBox["x", Rule[FontSlant, "Italic"]]\)]\)\_
                        1\ \(\[Integral]\_0\%1 
                         \(\(\*StyleBox[\(
                                \*StyleBox["d", Rule[FontSlant, "Plain"]]x\)]
                \)\_2\ \(\[Delta](\(x\ -\ \(x\_1\ x\_2\)\))\)\ \(f(x\_1)\)\ 
                           \(\(g(x\_2)\)\ .\)\)\)\)\)\)]], " Convolute[f, g] \
is equivalent to Convolute[f, g, x]. Convolute[exp, {x1, x2}] assumes that \
exp is polynomial in x1 and x2. Convolute uses table-look-up and does not do \
any integral calculations, only linear algebra."}], "Text", 
            CellTags -> "Convolute"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[Convolute]\)], "Input", CellTags -> "Convolute"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(Bracket \[Rule] 
                        \({\*TagBox["\[CurlyEpsilon]", TraditionalForm]}\)\),
                       \(FinalSubstitutions \[Rule] 
                        \({PlusDistribution \[Rule] Identity}\)\)}\)\)], 
               "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["PlusDistribution", 
                RuleDelayed[ButtonData, "PlusDistribution"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PlusDistribution"]], ", ", 
              ButtonBox["ConvoluteTable", 
                RuleDelayed[ButtonData, "ConvoluteTable"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ConvoluteTable"]], "."}], "Text", 
            CellTags -> "Convolute"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Convolute"], Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(1, 1\)]\)], "Input", CellTags -> "Convolute"], 
              Cell[BoxData[\(TraditionalForm\`\(-\(log(x)\)\)\)], "Output", 
               CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Convolute[\(x, x\)]\)], 
               "Input", CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(-x\)\ \(log(x)\)\)\)], "Output", 
               CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Convolute[\(1, x\)]\)], 
               "Input", CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(1 - x\)\)], "Output", CellTags -> 
                "Convolute"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(1, 1\/\(1 - x\)\)]\)], "Input", CellTags -> 
                "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(log(\(1 - x\))\) - \(log(x)\)\)\)], 
               "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(1, \(PlusDistribution[\(1\/\(1 - x\)\)]\)\)]\)]\
, "Input", CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(log(\(1 - x\))\) - \(log(x)\)\)\)], 
               "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Convolute[\(1\/\(1 - x\), x\)]\)
                ], "Input", CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(log(\(1 - x\))\)\ x\) - 
                     \(\(log(x)\)\ x\) - x + 1\)\)], "Output", CellTags -> 
                "Convolute"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(1\/\(1 - x\), 1\/\(1 - x\)\)]\)], "Input", 
               CellTags -> "Convolute"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(-\(\[Zeta](2)\)\), " ", RowBox[{"\[Delta]", "(", 
                       FormBox[\(1 - x\), "TraditionalForm"], ")"}]}], "+", 
                   \(\(2\ \(log(1 - x)\)\)\/\(1 - x\)\), "-", 
                   \(\(log(x)\)\/\(1 - x\)\)}], TraditionalForm]], "Output", 
               CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(1, \(Log[\(1 - x\)]\)\)]\)], "Input", 
               CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(-\(log(\(1 - x\))\)\)\ \(log(x)\)\) 
                     - \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(1 - x\))\)\)\)], "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(1, \(x\ \(Log[\(1 - x\)]\)\)\)]\)], "Input", 
               CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(x + \(\((1 - x)\)\ \(log(\(1 - x\))\)\) 
                     - 1\)\)], "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(1\/\(1 - x\), \(Log[\(1 - x\)]\)\)]\)], 
               "Input", CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(log\^2\)(\(1 - x\))\) - 
                     \(\(log(x)\)\ \(log(\(1 - x\))\)\) - \(\[Zeta](2)\)\)\)]\
, "Output", CellTags -> "Convolute"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Convolute[\(1\/\(1 - x\), \(x\ \(Log[\(1 - x\)]\)\)\)]\)], 
               "Input", CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(x\ \(\(log\^2\)(\(1 - x\))\)\) + 
                     \(\((1 - x)\)\ \(log(\(1 - x\))\)\) - 
                     \(x\ \(log(x)\)\ \(log(\(1 - x\))\)\) + x - 
                     \(x\ \(\[Zeta](2)\)\) - 1\)\)], "Output", CellTags -> 
                "Convolute"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(\(Log[\(1 - x\)]\)\/\(1 - x\), x\)]\)], 
               "Input", CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/2\ x\ \(\(log\^2\)(\(1 - x\))\)\) +
                      \(\((1 - x)\)\ \(log(\(1 - x\))\)\) - 
                     \(x\ \(log(x)\)\ \(log(\(1 - x\))\)\) + 
                     \(x\ \(log(x)\)\) - 
                     \(x\ \(\(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_2(\(1 - x\))\)\)\)\)], "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(1, \(x\ \(Log[x]\)\)\)]\)], "Input", 
               CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(-\(log(x)\)\)\ x\) + x - 1\)\)], 
               "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(\(Log[\(1 - x\)]\), x\)]\)], "Input", 
               CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(\((1 - x)\)\ \(log(\(1 - x\))\)\) + 
                     \(x\ \(log(x)\)\)\)\)], "Output", CellTags -> 
                "Convolute"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(1\/\(1 - x\), \(Log[x]\)\/\(1 - x\)\)]\)], 
               "Input", CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(log(\(1 - x\))\)\ \(log(x)\)\)\/
                      \(1 - x\) - \(\(log\^2\)(x)\)\/\(2\ \((1 - x)\)\)\)\)], 
               "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Convolute[\(1, \(Log[x]\)\)]\)]
                , "Input", CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(-\(1\/2\)\)\ \(\(log\^2\)(x)\)\)\)], 
               "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(x,\ \(x\ \(Log[x]\)\)\)]\)], "Input", 
               CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(-\(1\/2\)\)\ x\ \(\(log\^2\)(x)\)\)\)]\
, "Output", CellTags -> "Convolute"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Convolute[\(1\/\(1 - x\), \(Log[x]\)\)]\)], 
               "Input", CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(-\(1\/2\)\)\ \(\(log\^2\)(x)\)\) + 
                     \(\(log(\(1 - x\))\)\ \(log(x)\)\) + 
                     \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(1 - x\))\)\)\)], "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(1, \(Log[x]\)\/\(1 - x\)\)]\)], "Input", 
               CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(-\(1\/2\)\)\ \(\(log\^2\)(x)\)\) - 
                     \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(1 - x\))\)\)\)], "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(1\/\(1 - x\), \(x\ \(Log[x]\)\)\)]\)], "Input", 
               CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(-\(1\/2\)\)\ x\ \(\(log\^2\)(x)\)\) 
                     - \(x\ \(log(x)\)\) + 
                     \(x\ \(log(\(1 - x\))\)\ \(log(x)\)\) + x + 
                     \(x\ \(\(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_2(\(1 - x\))\)\) - 1\)\)], "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(\(Log[x]\)\/\(1 - x\), x\)]\)], "Input", 
               CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(-\(1\/2\)\)\ x\ \(\(log\^2\)(x)\)\) 
                     + \(log(x)\) - x - \(
                      x\ \(\(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_2(\(1 - x\))\)\) + 1\)\)], "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(1, \(x\ \(Log[x]\)\)\)]\)], "Input", 
               CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(-\(log(x)\)\)\ x\) + x - 1\)\)], 
               "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Convolute[\(\(Log[x]\), x\)]\)]
                , "Input", CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(-x\) + \(log(x)\) + 1\)\)], "Output", 
               CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(1\/\(1 - x\), \(Log[\(1 - x\)]\)\/\(1 - x\)\)]
                  \)], "Input", CellTags -> "Convolute"], Cell[BoxData[
                FormBox[RowBox[{
                   \(\(3\ \(log\^2(1 - x)\)\)\/\(2\ \((1 - x)\)\)\), "-", 
                   \(\(\(log(x)\)\ \(log(1 - x)\)\)\/\(1 - x\)\), "-", 
                   \(\(\[Zeta](2)\)\/\(1 - x\)\), "+", RowBox[
                    {RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                        "TraditionalForm"], ")"}], " ", 
                     TagBox[\(\[Zeta](\*TagBox["3", Zeta, 
                           Rule[Editable, True]])\), 
                       InterpretTemplate[Function[BoxForm`e$, 
                         Zeta[BoxForm`e$]]]]}]}], TraditionalForm]], 
               "Output", CellTags -> "Convolute"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(\(Log[\(1 - x\)]\)\/\(1 - x\), 
                     \(Log[\(1 - x\)]\)\)]\)], "Input", CellTags -> 
                "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/2\ \(\(log\^3\)(\(1 - x\))\)\) - 
                     \(\(log(x)\)\ \(\(log\^2\)(\(1 - x\))\)\) + 
                     \(\(\(log\^2\)(x)\)\ \(log(\(1 - x\))\)\) - 
                     \(\(\[Zeta](2)\)\ \((\(log(\(1 - x\))\) + \(log(x)\))\)
                      \) + \(\((\(log(x)\) - \(log(\(1 - x\))\))\)\ 
                       \(\(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_2(\(1 - x\))\)\) + \(
                      \(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_3(\(1 - x\))\) + \(2\ \(
                        \(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_3(x)\)\) - \*TagBox[\(
                        \[Zeta](\(\*TagBox["3", Zeta, Rule[Editable, True]]
                          \))\), InterpretTemplate[Function[BoxForm`e$, 
                         Zeta[BoxForm`e$]]]]\)\)], "Output", CellTags -> 
                "Convolute"]}, Open]]}, Open]], Cell["ConvoluteTable ", 
         "ObjectName", CellTags -> "ConvoluteTable"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ConvoluteTable"], Cell["ConvoluteTable[f, g, x] \
yields the convolution of f and g. ConvoluteTable is called by Convolute.", 
            "Text", CellTags -> "ConvoluteTable"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[Convolute]\)], "Input", 
               CellTags -> "ConvoluteTable"], Cell[BoxData[
                \(TraditionalForm\`\({\(Bracket \[Rule] 
                        \({\*TagBox["\[CurlyEpsilon]", TraditionalForm]}\)\),
                       \(FinalSubstitutions \[Rule] 
                        \({PlusDistribution \[Rule] Identity}\)\)}\)\)], 
               "Output", CellTags -> "ConvoluteTable"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["PlusDistribution", 
                RuleDelayed[ButtonData, "PlusDistribution"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PlusDistribution"]], ", ", 
              ButtonBox["Convolute", RuleDelayed[ButtonData, "Convolute"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Convolute"]], "."}], "Text", 
            CellTags -> "ConvoluteTable"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ConvoluteTable"], Cell[CellGroupData[{Cell[BoxData[
                \(ConvoluteTable[\(1, 1\)]\)], "Input", CellTags -> 
                "ConvoluteTable"], Cell[BoxData[
                \(TraditionalForm\`\(-\(log(x)\)\)\)], "Output", CellTags -> 
                "ConvoluteTable"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ConvoluteTable[\(x, x\)]\)], "Input", CellTags -> 
                "ConvoluteTable"], Cell[BoxData[
                \(TraditionalForm\`\(\(-x\)\ \(log(x)\)\)\)], "Output", 
               CellTags -> "ConvoluteTable"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ConvoluteTable[\(1, x\)]\)], 
               "Input", CellTags -> "ConvoluteTable"], Cell[BoxData[
                \(TraditionalForm\`\(1 - x\)\)], "Output", CellTags -> 
                "ConvoluteTable"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ConvoluteTable[\(\(Log[\(1 - x\)]\)\/\(1 - x\), 1\)]\)], 
               "Input", CellTags -> "Convolute"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/2\ \(\(log\^2\)(\(1 - x\))\)\) - 
                     \(\(log(x)\)\ \(log(\(1 - x\))\)\) - 
                     \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(1 - x\))\)\)\)], "Output", CellTags -> "Convolute"]}, Open]]}, Open]], 
        Cell["CovariantFieldDerivative", "ObjectName", 
         CellTags -> "CovariantFieldDerivative"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "CovariantFieldDerivative"], Cell["CovariantFieldDeri\
vative[f[x],x,{li1,li2,...},opts] is a covariant derivative of f[x] with \
respect to space-time variables x and with Lorentz indices li1, li2,... \
CovariantFieldDerivative has only typesetting definitions by default. The \
user is must supply his/her own definition of the actual function.", "Text", 
            CellTags -> "CovariantFieldDerivative"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["CovariantD", RuleDelayed[ButtonData, "CovariantD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CovariantD"]], ", ", 
              ButtonBox["ExpandPartialD", 
                RuleDelayed[ButtonData, "ExpandPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandPartialD"]], ", ", 
              ButtonBox["FieldDerivative", 
                RuleDelayed[ButtonData, "FieldDerivative"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FieldDerivative"]], "."}], "Text", 
            CellTags -> "CovariantFieldDerivative"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "CovariantFieldDerivative"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(CovariantFieldDerivative[
                   \(\(\(QuantumField[\(A, \({\[Mu]}\)\)]\)[x]\), x, 
                     \({\[Mu]}\)\)]\)], "Input", CellTags -> 
                "CovariantFieldDerivative"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{\(1\/2\), " ", "\[ImaginaryI]", " ", 
                     RowBox[{"(", RowBox[{RowBox[{"(", RowBox[{RowBox[
                          {OverscriptBox[TagBox[FormBox[SubscriptBox[FormBox[
                          SuperscriptBox[
                          TagBox[StyleBox["\"A\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], RowBox[{TagBox[
                          FormBox["", "TraditionalForm"], TraditionalForm, 
                          Editable -> True], TagBox[FormBox["", 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True]}]], "TraditionalForm"], "\[Mu]"], 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True], TagBox["\"\[Rule]\"", StyleForm]], 
                          "\[CenterDot]", OverscriptBox[TagBox[FormBox[
                          StyleBox[TagBox[StyleBox["\"\[Sigma]\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]], 
                            Rule[SingleLetterItalics, False], 
                            Rule[FontWeight, "Bold"]], "TraditionalForm"], 
                          TraditionalForm, Editable -> True], 
                          TagBox["\"\[Rule]\"", StyleForm]]}], "+", RowBox[
                          {OverscriptBox[TagBox[FormBox[SubscriptBox[FormBox[
                          SuperscriptBox[
                          TagBox[StyleBox["\"V\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], RowBox[{TagBox[
                          FormBox["", "TraditionalForm"], TraditionalForm, 
                          Editable -> True], TagBox[FormBox["", 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True]}]], "TraditionalForm"], "\[Mu]"], 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True], TagBox["\"\[Rule]\"", StyleForm]], 
                          "\[CenterDot]", OverscriptBox[TagBox[FormBox[
                          StyleBox[TagBox[StyleBox["\"\[Sigma]\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]], 
                            Rule[SingleLetterItalics, False], 
                            Rule[FontWeight, "Bold"]], "TraditionalForm"], 
                          TraditionalForm, Editable -> True], 
                          TagBox["\"\[Rule]\"", StyleForm]]}]}], ")"}], 
                         "\[SixPointedStar]", \(A\_\[Mu]\)}], ")"}]}], "-", 
                   RowBox[{\(1\/2\), " ", "\[ImaginaryI]", " ", RowBox[
                      {"(", RowBox[{\(A\_\[Mu]\), "\[SixPointedStar]", "(", 
                         RowBox[{RowBox[{OverscriptBox[TagBox[FormBox[
                          SubscriptBox[FormBox[SuperscriptBox[
                          TagBox[StyleBox["\"V\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], RowBox[{TagBox[
                          FormBox["", "TraditionalForm"], TraditionalForm, 
                          Editable -> True], TagBox[FormBox["", 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True]}]], "TraditionalForm"], "\[Mu]"], 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True], TagBox["\"\[Rule]\"", StyleForm]], 
                          "\[CenterDot]", OverscriptBox[TagBox[FormBox[
                          StyleBox[TagBox[StyleBox["\"\[Sigma]\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]], 
                            Rule[SingleLetterItalics, False], 
                            Rule[FontWeight, "Bold"]], "TraditionalForm"], 
                          TraditionalForm, Editable -> True], 
                          TagBox["\"\[Rule]\"", StyleForm]]}], "-", RowBox[
                          {OverscriptBox[TagBox[FormBox[SubscriptBox[FormBox[
                          SuperscriptBox[
                          TagBox[StyleBox["\"A\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], RowBox[{TagBox[
                          FormBox["", "TraditionalForm"], TraditionalForm, 
                          Editable -> True], TagBox[FormBox["", 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True]}]], "TraditionalForm"], "\[Mu]"], 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True], TagBox["\"\[Rule]\"", StyleForm]], 
                          "\[CenterDot]", OverscriptBox[TagBox[FormBox[
                          StyleBox[TagBox[StyleBox["\"\[Sigma]\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]], 
                            Rule[SingleLetterItalics, False], 
                            Rule[FontWeight, "Bold"]], "TraditionalForm"], 
                          TraditionalForm, Editable -> True], 
                          TagBox["\"\[Rule]\"", StyleForm]]}]}], ")"}], 
                       ")"}]}], "+", RowBox[{SubscriptBox["\[PartialD]", 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                       FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], "\[Null]"]}]}], TraditionalForm]], 
               "Output", CellTags -> "CovariantFieldDerivative"]}, Open]]}, 
          Open]], Cell["CounterT", "ObjectName", CellTags -> "CounterT"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "CounterT"], Cell["CounterT is a factor used by \
GluonPropagator and QuarkPropagator when CounterTerms is set to All.", 
            "Text", CellTags -> "CounterT"], Cell[TextData[{"See also: ", 
              " ", 
              ButtonBox["CounterTerm", RuleDelayed[ButtonData, 
                 "CounterTerm"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CounterTerm"]], ", ", 
              ButtonBox["GluonPropagator", 
                RuleDelayed[ButtonData, "GluonPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonPropagator"]], ", ", 
              ButtonBox["QuarkPropagator", 
                RuleDelayed[ButtonData, "QuarkPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "QuarkPropagator"]], "."}], "Text", 
            CellTags -> "CounterT"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "CounterT"], Cell[CellGroupData[{Cell[BoxData[
                \(GluonPropagator[\(p, \[Mu], a, \[Nu], b, 
                     \(Explicit \[Rule] True\), \(CounterTerm \[Rule]\ All\)\
\)]\)], "Input", CellTags -> "CounterT"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"CounterT", " ", RowBox[{"(", RowBox[{FractionBox[
                          RowBox[{"\[ImaginaryI]", " ", \(C\_A\), " ", 
                          \(S\_n\), " ", RowBox[{"(", RowBox[{FractionBox[
                          RowBox[{"10", " ", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "3"], "-", RowBox[{\(10\/3\)
                          , " ", \(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"]}]}], ")"}], 
                          " ", SubscriptBox["\[Delta]", RowBox[{FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          \(g\_s\%2\)}], 
                          TagBox["\[CurlyEpsilon]", TraditionalForm]], "+", 
                         FractionBox[RowBox[{"\[ImaginaryI]", " ", \(S\_n\), 
                          " ", \(T\_f\), " ", RowBox[{"(", RowBox[{RowBox[{
                          \(4\/3\), " ", \(g\^\(\[Mu]\[Nu]\)\), " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"]}], "-", FractionBox[RowBox[{"4", " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "3"]}], 
                          ")"}], " ", SubscriptBox["\[Delta]", RowBox[
                          {FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          \(g\_s\%2\)}], 
                          TagBox["\[CurlyEpsilon]", TraditionalForm]]}], 
                       ")"}]}], "-", FractionBox[RowBox[{"\[ImaginaryI]", 
                      " ", \(g\^\(\[Mu]\[Nu]\)\), " ", SubscriptBox[
                       "\[Delta]", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], \(p\^2\)]}], 
                 TraditionalForm]], "Output", CellTags -> "CounterT"]}, 
             Open]]}, Open]], Cell["CounterTerm", "ObjectName", 
         CellTags -> "CounterTerm"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "CounterTerm"], 
           Cell["CounterTerm[name] is a database of counter terms. \
CounterTerm is also an option for the Feynman rule functions \
QuarkGluonVertex, GluonPropagator, QuarkPropagator.", "Text", 
            CellTags -> "CounterTerm"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["CounterT", RuleDelayed[ButtonData, "CounterT"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CounterT"]], ", ", 
              ButtonBox["QuarkGluonVertex", 
                RuleDelayed[ButtonData, "QuarkGluonVertex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "QuarkGluonVertex"]], ", ", 
              ButtonBox["GluonPropagator", 
                RuleDelayed[ButtonData, "GluonPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonPropagator"]], ", ", 
              ButtonBox["QuarkPropagator", 
                RuleDelayed[ButtonData, "QuarkPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "QuarkPropagator"]], "."}], "Text", 
            CellTags -> "CounterTerm"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "CounterTerm"], Cell[CellGroupData[{Cell[BoxData[
                \(CounterTerm[Zm]\)], "Input", CellTags -> "CounterTerm"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(C\_F\ 
                        \((\(4\ \((\(11\ C\_A\)\/2 + \(9\ C\_F\)\/2 - 
                                 \(2\ N\_f\ T\_f\))\)\)\/
                            \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^2 +
                            \(2\ \((\(97\ C\_A\)\/12 + \(3\ C\_F\)\/4 - 
                                 \(5\ N\_f\ T\_f\)\/3)\)\)\/
                            \*TagBox["\[CurlyEpsilon]", TraditionalForm])\)\ 
                        g\_s\%4\)\/\(256\ \[Pi]\^4\) + 
                     \(3\ C\_F\ g\_s\%2\)\/
                      \(8\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]\ 
                        \[Pi]\^2\) + 1\)\)], "Output", CellTags -> 
                "CounterTerm"]}, Open]]}, Open]], Cell["CouplingConstant", 
         "ObjectName", CellTags -> "CouplingConstant"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "CouplingConstant"], Cell["In general, \
CouplingConstant is an option for several Feynman rule functions and for \
CovariantD and FieldStrength.\nIn the convention of the subpackage PHI, \
CouplingConstant is also the head of coupling constants.  CouplingConstant \
takes three extra optional arguments, with head RenormalizationState, \
RenormalizationScheme and ExpansionState respectively.  E.g. \
CouplingConstant[QED[1]] is the unit charge, CouplingConstant[ChPT2[4],1] is \
the first of the coupling constants of the lagrangian ChPT2[4].  \
CouplingConstant[a_,b_,c___][i_] := \
CouplingConstant[a,b,RenormalizationState[i],c].", "Text", 
            CellTags -> "CouplingConstant"], Cell[TextData[{"See also: ", 
              " ", 
              ButtonBox["CovariantD", RuleDelayed[ButtonData, "CovariantD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CovariantD"]], ", ", 
              ButtonBox["FieldStrength", 
                RuleDelayed[ButtonData, "FieldStrength"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FieldStrength"]], ", ", 
              ButtonBox["\"PHI - A Mathematica package for ChPT \
calculations\"", RuleDelayed[ButtonData, "phi"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "phi"]], 
              "."}], "Text", CellTags -> "CouplingConstant"], 
           Cell[BoxData[""], "Input"]}, Open]], Cell["CovariantD", 
         "ObjectName", CellTags -> "CovariantD"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "CovariantD"], Cell["CovariantD[mu] is a generic \
covariant derivative with Lorentz index mu. With the option-setting Explicit \
\[Rule] True, an explicit expression for a fermionic field is returned, \
depending on the setting on the other options.\nCovariantD[x, mu] is a \
generic covariant derivative with respect to x^mu.\nCovariantD[mu, a, b] is a \
covariant derivative for a bosonic field; acting on QuantumField[f,{},{a,b}], \
where f is some field name and a and b are two SU(N) indices. Again, with the \
option-setting Explicit \[Rule] True, an explicit expression is returned, \
depending on the setting on the other options.\nCovariantD[OPEDelta, a, b] is \
a short form for  CovariantD[mu,a,b]*FourVector[OPEDelta, mu]. \
CovariantD[{OPEDelta, a, b}, {n}] yields the product of n operators, where n \
is an integer.  CovariantD[OPEDelta, a, b, {m, n}]  gives the expanded form \
of CovariantD[OPEDelta, a, b]^m up to order g^n for the gluon, where n is an \
integer and g the coupling constant  indicated by the setting of the option \
CouplingConstant. CovariantD[OPEDelta, {m, n}] gives the expanded form of  \
CovariantD[OPEDelta]^m up to order g^n of the fermionic field.", "Text", 
            CellTags -> "CovariantD"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[CovariantD]\)], "Input", CellTags -> "CovariantD"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(DummyIndex \[Rule] Automatic\), 
                      \(Explicit \[Rule] False\), 
                      \(PartialD \[Rule] RightPartialD\), 
                      \(QuantumField \[Rule] A\)}\)\)], "Output", CellTags -> 
                "CovariantD"]}, Open]], Cell[" Possible settings of PartialD \
are: LeftPartialD, LeftRigthPartialD, RightPartialD. The default setting of \
QuantumField is GaugeField.", "Text", CellTags -> "CovariantD"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["LeftPartialD", 
                RuleDelayed[ButtonData, "LeftPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftPartialD"]], ", ", 
              ButtonBox["LeftRightPartialD", 
                RuleDelayed[ButtonData, "LeftRightPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftRightPartialD"]], ", ", 
              ButtonBox["RightPartialD", 
                RuleDelayed[ButtonData, "RightPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "RightPartialD"]], "."}], "Text", 
            CellTags -> "CovariantD"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "CovariantD"], Cell[CellGroupData[{Cell[BoxData[
                \(CovariantD[\[Mu]]\)], "Input", CellTags -> "CovariantD"], 
              Cell[BoxData[\(TraditionalForm\`D\_\[Mu]\)], "Output", 
               CellTags -> "CovariantD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(CovariantD[\(\[Mu], a, b\)]\)], 
               "Input", CellTags -> "CovariantD"], Cell[BoxData[
                \(TraditionalForm\`D\_\[Mu]\%\(ab\)\)], "Output", CellTags -> 
                "CovariantD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(CovariantD[\(\[Mu], \(Explicit \[Rule] True\)\)]\)], 
               "Input", CellTags -> "CovariantD"], Cell[BoxData[
                FormBox[RowBox[{SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                    FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], "-", RowBox[{"\[ImaginaryI]", " ", 
                     \(g\_s\), " ", RowBox[{SubscriptBox["T", FormBox[FormBox[
                          InterpretationBox[\(c\_1\), Subscripted[c[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                         "TraditionalForm"]], ".", SubsuperscriptBox[FormBox[
                         "A", "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox[
                          InterpretationBox[\(c\_1\), Subscripted[c[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                         "TraditionalForm"]]}]}]}], TraditionalForm]], 
               "Output", CellTags -> "CovariantD"]}, Open]], 
           Cell["The first argument of CovariantD is intepreted as type \
LorentzIndex, except for OPEDelta, which is type Momentum.", "Text", 
            CellTags -> "CovariantD"], Cell[CellGroupData[{Cell[BoxData[
                \(CovariantD[OPEDelta]\)], "Input", CellTags -> 
                "CovariantD"], Cell[BoxData[FormBox[SubscriptBox["D", 
                  FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                 TraditionalForm]], "Output", CellTags -> "CovariantD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(CovariantD[\(OPEDelta, a, b\)]\)], "Input", CellTags -> 
                "CovariantD"], Cell[BoxData[FormBox[SubsuperscriptBox["D", 
                  FormBox["\[CapitalDelta]", "TraditionalForm"], \(ab\)], 
                 TraditionalForm]], "Output", CellTags -> "CovariantD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(CovariantD[\(OPEDelta, a, b, \(Explicit \[Rule] True\)\)]\)]\
, "Input", CellTags -> "CovariantD"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                      FormBox["\[CapitalDelta]", "TraditionalForm"]], " ", 
                     \(\[Delta]\_\(ab\)\)}], "-", RowBox[{\(g\_s\), " ", 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox[
                        InterpretationBox[\(c\_2\), Subscripted[c[2]], 
                          Rule[Editable, False]], "TraditionalForm"], 
                       "TraditionalForm"]], " ", SubscriptBox["f", RowBox[
                       {"a", "b", FormBox[
                         InterpretationBox[\(c\_2\), Subscripted[c[2]], 
                           Rule[Editable, False]], "TraditionalForm"]}]]}]}], 
                 TraditionalForm]], "Output", CellTags -> "CovariantD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(CovariantD[\(OPEDelta, \(Explicit \[Rule] True\)\)]\)], 
               "Input", CellTags -> "CovariantD"], Cell[BoxData[
                FormBox[RowBox[{SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                    FormBox["\[CapitalDelta]", "TraditionalForm"]], "-", 
                   RowBox[{"\[ImaginaryI]", " ", \(g\_s\), " ", RowBox[
                      {SubscriptBox["T", FormBox[FormBox[
                          InterpretationBox[\(c\_3\), Subscripted[c[3]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                         "TraditionalForm"]], ".", SubsuperscriptBox[FormBox[
                         "A", "TraditionalForm"], FormBox["\[CapitalDelta]", 
                         "TraditionalForm"], FormBox[FormBox[
                          InterpretationBox[\(c\_3\), Subscripted[c[3]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                         "TraditionalForm"]]}]}]}], TraditionalForm]], 
               "Output", CellTags -> "CovariantD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(CovariantD[\(OPEDelta, a, b, \({2}\)\)]\)], "Input", 
               CellTags -> "CovariantD"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"(", RowBox[{RowBox[{SubscriptBox[
                          \(\[PartialD]\&\[RightArrow]\), FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]], " ", 
                         \(\[Delta]\_\(ac14\)\)}], "-", RowBox[{\(g\_s\), 
                         " ", SubsuperscriptBox[FormBox["A", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["e1", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         \(f\_\(ac14e1\)\)}]}], ")"}], ".", RowBox[
                    {"(", RowBox[{RowBox[{SubscriptBox[
                          \(\[PartialD]\&\[RightArrow]\), FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]], " ", 
                         \(\[Delta]\_\(bc14\)\)}], "-", RowBox[{\(g\_s\), 
                         " ", SubsuperscriptBox[FormBox["A", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["e2", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         \(f\_\(c14be2\)\)}]}], ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "CovariantD"]}, Open]], 
           Cell[TextData[{"This gives", Cell[BoxData[
                \(TraditionalForm\`\(\ \(
                      \(m\ times\ \(\[PartialD]\&\[RightArrow]\)\_
                          \[CapitalDelta]\),\ \)\)\)]], 
              "the partial derivative ", Cell[BoxData[
                \(TraditionalForm\`\(\[PartialD]\&\[RightArrow]\)\_
                    \(\[Mu]\ \)\)]], "contracted with ", Cell[BoxData[
                \(TraditionalForm\`\(\[CapitalDelta]\^\[Mu] .\)\)]]}], 
            "Text", CellTags -> "CovariantD"], Cell[CellGroupData[
             {Cell[BoxData[\(CovariantD[\(OPEDelta, a, b, \({OPEm, 0}\)\)]\)]
                , "Input", CellTags -> "CovariantD"], Cell[BoxData[
                FormBox[RowBox[{SuperscriptBox[RowBox[{"(", SubscriptBox[
                       \(\[PartialD]\&\[RightArrow]\), FormBox[
                        "\[CapitalDelta]", "TraditionalForm"]], ")"}], "m"], 
                   " ", SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "CovariantD"]}, Open]], 
           Cell[TextData[
             {"The expansion up to first order in the coupling constant ", 
              Cell[BoxData[
                \(TraditionalForm\`\(g\_s\ 
                     \(\((thesumistheFeynCalcOPESum)\) .\)\)\)]]}], "Text", 
            CellTags -> "CovariantD"], Cell[CellGroupData[{Cell[BoxData[
                \(CovariantD[\(OPEDelta, a, b, \({OPEm, 1}\)\)]\)], "Input", 
               CellTags -> "CovariantD"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{SuperscriptBox[RowBox[{"(", SubscriptBox[
                         \(\[PartialD]\&\[RightArrow]\), FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]], ")"}], 
                      "m"], " ", SubscriptBox["\[Delta]", RowBox[
                       {FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "-", 
                   RowBox[{\(g\_s\), " ", FormBox[TagBox[RowBox[{
                         \(\[Sum]\+\(i = 0\)\%\(m - 1\)\), RowBox[
                          {RowBox[{SuperscriptBox[RowBox[{"(", SubscriptBox[
                          \(\[PartialD]\&\[RightArrow]\), FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]], ")"}], 
                          "i"], ".", SubsuperscriptBox[FormBox["A", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox[
                          InterpretationBox[\(c\_1\), Subscripted[c[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[RowBox[
                          {"(", SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                          FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                          ")"}], \(\(-i\) + m - 1\)]}], " ", SubscriptBox[
                          "f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox[
                          InterpretationBox[\(c\_1\), Subscripted[c[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]}]]}]}], HoldForm], 
                      "TraditionalForm"]}]}], TraditionalForm]], "Output", 
               CellTags -> "CovariantD"]}, Open]], 
           Cell[TextData[{"The expansion up to second order in the ", 
              Cell[BoxData[\(TraditionalForm\`\(g\_s .\)\)]]}], "Text", 
            CellTags -> "CovariantD"], Cell[CellGroupData[{Cell[BoxData[
                \(CovariantD[\(OPEDelta, a, b, \({OPEm, 2}\)\)]\)], "Input", 
               CellTags -> "CovariantD"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SuperscriptBox[
                      RowBox[{"(", SubscriptBox[\(\[PartialD]\&\[RightArrow]\)
                         , FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                        ")"}], "m"]}], "-", RowBox[{\(g\_s\%2\), " ", 
                     FormBox[TagBox[RowBox[{\(\[Sum]\+\(j = 0\)\%\(m - 2\)\), 
                         FormBox[TagBox[RowBox[{\(\[Sum]\+\(i = 0\)\%j\), 
                          RowBox[{RowBox[{SuperscriptBox[RowBox[{"(", 
                          SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                          FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                          ")"}], "i"], ".", SubsuperscriptBox[FormBox["A", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox[
                          InterpretationBox[\(c\_1\), Subscripted[c[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[RowBox[
                          {"(", SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                          FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                          ")"}], \(j - i\)], ".", SubsuperscriptBox[FormBox[
                          "A", "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox[
                          InterpretationBox[\(c\_2\), Subscripted[c[2]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[RowBox[
                          {"(", SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                          FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                          ")"}], \(\(-j\) + m - 2\)]}], " ", SubscriptBox[
                          "f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox[
                          InterpretationBox[\(c\_1\), Subscripted[c[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox[
                          InterpretationBox[\(e\_1\), Subscripted[e[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox[
                          InterpretationBox[\(c\_2\), Subscripted[c[2]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox[
                          InterpretationBox[\(e\_1\), Subscripted[e[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]}]]}]}], HoldForm], 
                          "TraditionalForm"]}], HoldForm], 
                      "TraditionalForm"]}], "-", RowBox[{\(g\_s\), " ", 
                     FormBox[TagBox[RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 1\)\), 
                         RowBox[{RowBox[{SuperscriptBox[RowBox[{"(", 
                          SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                          FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                          ")"}], "i"], ".", SubsuperscriptBox[FormBox["A", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox[
                          InterpretationBox[\(c\_1\), Subscripted[c[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[RowBox[
                          {"(", SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                          FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                          ")"}], \(\(-i\) + m - 1\)]}], " ", SubscriptBox[
                          "f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox[
                          InterpretationBox[\(c\_1\), Subscripted[c[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]}]]}]}], HoldForm], 
                      "TraditionalForm"]}]}], TraditionalForm]], "Output", 
               CellTags -> "CovariantD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(CovariantD[\(OPEDelta, a, b\)]\)\^OPEm\)], "Input", 
               CellTags -> "CovariantD"], Cell[BoxData[FormBox[SuperscriptBox[
                  RowBox[{"(", SubsuperscriptBox["D", FormBox[
                      "\[CapitalDelta]", "TraditionalForm"], \(ab\)], ")"}], 
                  "m"], TraditionalForm]], "Output", CellTags -> 
                "CovariantD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(CovariantD[\(OPEDelta, \({OPEm, 2}\)\)]\)], "Input", 
               CellTags -> "CovariantD"], Cell[BoxData[FormBox[RowBox[
                  {SuperscriptBox[RowBox[{"(", SubscriptBox[
                       \(\[PartialD]\&\[RightArrow]\), FormBox[
                        "\[CapitalDelta]", "TraditionalForm"]], ")"}], "m"], 
                   "-", RowBox[{"\[ImaginaryI]", " ", \(g\_s\), " ", 
                     FormBox[TagBox[RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 1\)\), 
                         RowBox[{SubscriptBox["T", FormBox[FormBox[
                          InterpretationBox[\(c\_1\), Subscripted[c[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[RowBox[
                          {"(", SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                          FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                          ")"}], "i"], ".", SubsuperscriptBox[FormBox["A", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox[
                          InterpretationBox[\(c\_1\), Subscripted[c[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[RowBox[
                          {"(", SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                          FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                          ")"}], \(\(-i\) + m - 1\)]}]}], HoldForm], 
                      "TraditionalForm"]}], "-", RowBox[{\(g\_s\%2\), " ", 
                     FormBox[TagBox[RowBox[{\(\[Sum]\+\(j = 0\)\%\(m - 2\)\), 
                         FormBox[TagBox[RowBox[{\(\[Sum]\+\(i = 0\)\%j\), 
                          RowBox[{SubscriptBox["T", FormBox[FormBox[
                          InterpretationBox[\(c\_1\), Subscripted[c[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox[
                          InterpretationBox[\(c\_2\), Subscripted[c[2]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[RowBox[
                          {"(", SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                          FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                          ")"}], "i"], ".", SubsuperscriptBox[FormBox["A", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox[
                          InterpretationBox[\(c\_1\), Subscripted[c[1]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[RowBox[
                          {"(", SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                          FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                          ")"}], \(j - i\)], ".", SubsuperscriptBox[FormBox[
                          "A", "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox[
                          InterpretationBox[\(c\_2\), Subscripted[c[2]], 
                            Rule[Editable, False]], "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[RowBox[
                          {"(", SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                          FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                          ")"}], \(\(-j\) + m - 2\)]}]}], HoldForm], 
                          "TraditionalForm"]}], HoldForm], 
                      "TraditionalForm"]}]}], TraditionalForm]], "Output", 
               CellTags -> "CovariantD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(CovariantD[\(OPEDelta, \(Explicit \[Rule] True\)\)]\)//
                   StandardForm\)], "Input", CellTags -> "CovariantD"], 
              Cell[BoxData[
                \(\(\(-\[ImaginaryI]\)\ Gstrong\ 
                     \(\(SUNT[\(SUNIndex[
                           \(\*InterpretationBox[\(c\_4\), 
                              Subscripted[c[4]], Rule[Editable, False]]\)]\)]
                \) . \(QuantumField[\(GaugeField, \(Momentum[OPEDelta]\), 
                           \(SUNIndex[\(\*
                               InterpretationBox[\(c\_4\), 
                                Subscripted[c[4]], Rule[Editable, False]]\)]\
\)\)]\)\)\) + \(RightPartialD[\(Momentum[OPEDelta]\)]\)\)], "Output", 
               CellTags -> "CovariantD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(CovariantD[\(\[Mu], a, b, \(Explicit \[Rule] True\)\)]\)
                   //StandardForm\)], "Input", CellTags -> "CovariantD"], 
              Cell[BoxData[
                \(\(\(RightPartialD[\(LorentzIndex[\[Mu]]\)]\)\ 
                     \(SUNDelta[\(a, b\)]\)\) - 
                   \(Gstrong\ \(QuantumField[
                       \(GaugeField, \(LorentzIndex[\[Mu]]\), 
                         \(SUNIndex[\(\*InterpretationBox[\(c\_5\), 
                              Subscripted[c[5]], Rule[Editable, False]]\)]\)\
\)]\)\ \(SUNF[\(a, b, \*InterpretationBox[\(c\_5\), 
                           Subscripted[c[5]], Rule[Editable, False]]\)]\)\)\)]\
, "Output", CellTags -> "CovariantD"]}, Open]]}, Open]], 
        Cell["CrossProduct", "ObjectName", CellTags -> "CrossProduct"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "CrossProduct"], Cell["CrossProduct[a, b] denotes the \
three-dimensional cross-product of the three-vectors a and b.", "Text", 
            CellTags -> "CrossProduct"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DotProduct", RuleDelayed[ButtonData, "DotProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DotProduct"]], ", ", 
              ButtonBox["ThreeVector", RuleDelayed[ButtonData, 
                 "ThreeVector"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ThreeVector"]], "."}], "Text", 
            CellTags -> "CrossProduct"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "CrossProduct"], Cell[CellGroupData[{Cell[BoxData[
                \(CrossProduct[\(\(ThreeVector[a]\), 
                     \(CrossProduct[\(\(ThreeVector[b]\), \(ThreeVector[c]\)
                        \)]\)\)]\)], "Input", CellTags -> "CrossProduct"], 
              Cell[BoxData[FormBox[RowBox[{RowBox[{RowBox[{FormBox[
                        \(a\&\[RightVector]\), "TraditionalForm"], 
                       "\[CenterDot]", FormBox[\(c\&\[RightVector]\), 
                        "TraditionalForm"]}], " ", \(b\&\[RightVector]\)}], 
                   "-", RowBox[{RowBox[{FormBox[\(a\&\[RightVector]\), 
                        "TraditionalForm"], "\[CenterDot]", FormBox[
                        \(b\&\[RightVector]\), "TraditionalForm"]}], " ", 
                     \(c\&\[RightVector]\)}]}], TraditionalForm]], "Output", 
               CellTags -> "CrossProduct"]}, Open]]}, Open]], 
        Cell["C0", "ObjectName", CellTags -> "C0"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "C0"], Cell[TextData[{"C0[p10, p12, p20, m1^2, m2^2, \
m3^2] is the scalar Passarino-Veltman ", Cell[BoxData[
                \(TraditionalForm\`C\_0\)]], "function. The convention for \
the arguments is that if the denominator of the integrand has the form \
([q^2-m1^2] [(q+p1)^2-m2^2] [(q+p2)^2-m3^2]), the first three arguments of C0 \
are the scalar products p10 = p1^2, p12 = (p1-p2).(p1-p2), p20 = p2^2."}], 
            "Text", CellTags -> "C0"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["B0", RuleDelayed[ButtonData, "B0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B0"]], 
              ", ", 
              ButtonBox["D0", RuleDelayed[ButtonData, "D0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "D0"]], 
              ", ", 
              ButtonBox["PaVe", RuleDelayed[ButtonData, "PaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "PaVe"]], 
              ", ", 
              ButtonBox["PaVeOrder", RuleDelayed[ButtonData, "PaVeOrder"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeOrder"]], "."}], "Text", 
            CellTags -> "C0"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "C0"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(C0[\(a, b, c,\ m12, m22, m32\)]\)], "Input", CellTags -> 
                "C0"], Cell[BoxData[FormBox[RowBox[{FormBox[\("C"\_"0"\), 
                    "TraditionalForm"], "(", "a", ",", "b", ",", "c", ",", 
                   "m12", ",", "m22", ",", "m32", ")"}], TraditionalForm]], 
               "Output", CellTags -> "C0"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(C0[\(b, a, c, m32, m22, m12\)]\)//PaVeOrder\)], "Input", 
               CellTags -> "C0"], Cell[BoxData[FormBox[RowBox[{FormBox[
                    \("C"\_"0"\), "TraditionalForm"], "(", "a", ",", "b", 
                   ",", "c", ",", "m12", ",", "m22", ",", "m32", ")"}], 
                 TraditionalForm]], "Output", CellTags -> "C0"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PaVeOrder[\(\(C0[\(b, a, c, m32, m22, m12\)]\), 
                     \(PaVeOrderList \[Rule] \({c, a}\)\)\)]\)], "Input", 
               CellTags -> "C0"], Cell[BoxData[FormBox[RowBox[{FormBox[
                    \("C"\_"0"\), "TraditionalForm"], "(", "b", ",", "c", 
                   ",", "a", ",", "m22", ",", "m32", ",", "m12", ")"}], 
                 TraditionalForm]], "Output", CellTags -> "C0"]}, Open]]}, 
          Open]], Cell["DataType", "ObjectName", CellTags -> "DataType"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DataType"], Cell["DataType[exp, type] = True defines \
the object exp to have data-type type. DataType[exp1, exp2, ..., type] \
defines the objects exp1, exp2, ...to have data-type type. The default \
setting is DataType[__, _] := False. To assign a certain data-type, do, e.g., \
DataType[x, PositiveInteger] = True.", "Text", CellTags -> "DataType"], 
           Cell[TextData[{"Currently used DataTypes: ", 
              ButtonBox["NonCommutative", 
                RuleDelayed[ButtonData, "NonCommutative"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "NonCommutative"]], ", ", 
              ButtonBox["PositiveInteger", 
                RuleDelayed[ButtonData, "PositiveInteger"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PositiveInteger"]], ", ", 
              ButtonBox["NegativeInteger", 
                RuleDelayed[ButtonData, "NegativeInteger"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "NegativeInteger"]], ", ", 
              ButtonBox["PositiveNumber", 
                RuleDelayed[ButtonData, "PositiveNumber"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PositiveNumber"]], ", ", 
              ButtonBox["FreeIndex", RuleDelayed[ButtonData, "FreeIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FreeIndex"]], ", ", 
              ButtonBox["GrassmannParity", 
                RuleDelayed[ButtonData, "GrassmannParity"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GrassmannParity"]]}], "Text", 
            CellTags -> "DataType"], Cell[TextData[
             {"PHI adds the DataTypes: ", 
              ButtonBox["UMatrix", RuleDelayed[ButtonData, "UMatrix"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "UMatrix"]]\
, ", ", 
              ButtonBox["UScalar", RuleDelayed[ButtonData, "UScalar"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "UScalar"]]\
, "."}], "Text", CellTags -> "DataType"], Cell[TextData[{"See also:  ", 
              ButtonBox["DeclareNonCommutative", 
                RuleDelayed[ButtonData, "DeclareNonCommutative"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeclareNonCommutative"]], ", ", 
              ButtonBox["\"PHI - A Mathematica package for ChPT \
calculations\"", RuleDelayed[ButtonData, "phi"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "phi"]], 
              "."}], "Text", CellTags -> "DataType"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DataType"], 
           Cell["NonCommutative is just a data-type.", "Text", 
            CellTags -> "DataType"], Cell[BoxData[
             \(\(\(DataType[\(f, g,\ NonCommutative\)]\)\ =\ True\) ;\)], 
            "Input", CellTags -> "DataType"], Cell[CellGroupData[
             {Cell[BoxData[\(t = \(\(f . g\) - \(g . \((2a)\) . f\)\)\)], 
               "Input", CellTags -> "DataType"], Cell[BoxData[
                \(TraditionalForm\`\(\(f . g\) - \(g . \((2\ a)\) . f\)\)\)], 
               "Output", CellTags -> "DataType"]}, Open]], 
           Cell["Since \"f \"and \"g\" have DataType NonCommutative the \
function DotSimplify extracts only \"a\" out of the noncommutative product.", 
            "Text", CellTags -> "DataType"], Cell[CellGroupData[{Cell[BoxData[
                \(DotSimplify[t]\)], "Input", CellTags -> "DataType"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(f . g\) - \(2\ a\ \(g . f\)\)\)\)], 
               "Output", CellTags -> "DataType"]}, Open]], Cell[BoxData[
             \(\(\(DataType[\(m, odd\)]\) = 
                  \(\(DataType[\(a, even\)]\) = True\)\) ;\)], "Input", 
            CellTags -> "DataType"], Cell[BoxData[
             \(\(\(ptest1[x_]\) := \(x/.
                    \(\(\((\(-1\))\)\^n_/;\(DataType[\(n, odd\)]\)\) 
                      \[RuleDelayed] \(-1\)\)\)\) ;\)], "Input", 
            CellTags -> "DataType"], Cell[BoxData[
             \(\(\(ptest2[x_]\) := \(x/.
                    \(\(\((\(-1\))\)\^n_/;\(DataType[\(n, even\)]\)\) 
                      \[RuleDelayed] 1\)\)\) ;\)], "Input", 
            CellTags -> "DataType"], Cell[CellGroupData[{Cell[BoxData[
                \(t = \(\(\((\(-1\))\)^m\) + \(\((\(-1\))\)^a\) + 
                     \(\((\(-1\))\)^z\)\)\)], "Input", CellTags -> 
                "DataType"], Cell[BoxData[
                \(TraditionalForm\`\(\((\(-1\))\)\^a + \((\(-1\))\)\^m + 
                     \((\(-1\))\)\^z\)\)], "Output", CellTags -> 
                "DataType"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ptest1[t]\)], "Input", CellTags -> "DataType"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(-1\) + \((\(-1\))\)\^a + 
                     \((\(-1\))\)\^z\)\)], "Output", CellTags -> 
                "DataType"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ptest2[%]\)], "Input", CellTags -> "DataType"], 
              Cell[BoxData[\(TraditionalForm\`\(\((\(-1\))\)\^z\)\)], 
               "Output", CellTags -> "DataType"]}, Open]], Cell[BoxData[
             \(\(Clear[\(ptest1, ptest2, t, a, m\)]\) ;\)], "Input", 
            CellTags -> "DataType"], Cell[BoxData[
             \(\(\(DataType[\(m, ganzeZahl\)]\) = True\) ;\)], "Input", 
            CellTags -> "DataType"], Cell[BoxData[
             \(\(\(f[x_]\) := \(x/.\({\(
                        \(\((\(-1\))\)^p_\)/;\(DataType[\(p, ganzeZahl\)]\)\)\
 \[RuleDelayed] 1}\)\)\) ;\)], "Input", CellTags -> "DataType"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(test = \(\(\((\(-1\))\)^m\) + \(\(\((\(-1\))\)^n\)\ x\)\)\)]\
, "Input", CellTags -> "DataType"], Cell[BoxData[
                \(TraditionalForm\`\(\(\((\(-1\))\)\^n\ x\) + \((\(-1\))\)\^m
                    \)\)], "Output", CellTags -> "DataType"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(f[test]\)], "Input", 
               CellTags -> "DataType"], Cell[BoxData[
                \(TraditionalForm\`\(\(\((\(-1\))\)\^n\ x\) + 1\)\)], 
               "Output", CellTags -> "DataType"]}, Open]], Cell[BoxData[
             \(\(Clear[\(f, test\)]\) ;\)], "Input", CellTags -> "DataType"], 
           Cell[BoxData[
             \(\(\(DataType[\(f, g,\ NonCommutative\)]\)\ =\ False\) ;\)], 
            "Input", CellTags -> "DataType"], Cell[BoxData[
             \(\(\(DataType[\(m, odd\)]\) = 
                  \(\(DataType[\(a, even\)]\) = False\)\) ;\)], "Input", 
            CellTags -> "DataType"], Cell["Certain FeynCalc objects have \
DataType PositiveInteger set to True.", "Text", CellTags -> "DataType"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DataType[\(OPEm, PositiveInteger\)]\)], "Input", 
               CellTags -> "DataType"], Cell[BoxData[\(TraditionalForm\`True\)
                ], "Output", CellTags -> "DataType"]}, Open]], 
           Cell["PowerSimplify uses the DataType information.", "Text", 
            CellTags -> "DataType"], Cell[CellGroupData[{Cell[BoxData[
                \(PowerSimplify[\ \(\((\(-1\))\)^\((2OPEm)\)\)]\)], "Input", 
               CellTags -> "DataType"], Cell[BoxData[\(TraditionalForm\`1\)], 
               "Output", CellTags -> "DataType"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PowerSimplify[\ \(\((\(-\ \(SO[q]\)\))\)^OPEm\)]\)], 
               "Input", CellTags -> "DataType"], Cell[BoxData[FormBox[RowBox[{
                   \(\((\(-1\))\)\^m\), " ", SuperscriptBox[RowBox[
                     {"(", RowBox[{FormBox["\"\[CapitalDelta]\"", 
                         "TraditionalForm"], FormBox["\"\[CenterDot]\"", 
                         "TraditionalForm"], FormBox["q", 
                         "TraditionalForm"]}], ")"}], "m"]}], 
                 TraditionalForm]], "Output", CellTags -> "DataType"]}, 
             Open]]}, Open]], Cell["DB0", "ObjectName", CellTags -> "DB0"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DB0"], Cell["DB0[p2, m1^2, m2^2] is the derivative \
of the two-point function B0[p2, m1^2, m2^2] with respect to p2.", "Text", 
            CellTags -> "DB0"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["B0", RuleDelayed[ButtonData, "B0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B0"]], 
              "."}], "Text", CellTags -> "DB0"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DB0"], Cell[CellGroupData[{Cell[BoxData[
                \(D[\(\(B0[\(p\_2, \(m\_1\)\^2, \(m\_2\)\^2\)]\), p\_2\)]\)], 
               "Input", CellTags -> "DB0"], Cell[BoxData[
                \(TraditionalForm\`\(DB0(\(p\_2, m\_1\%2, m\_2\%2\))\)\)], 
               "Output", CellTags -> "DB0"]}, Open]]}, Open]], 
        Cell["DB1", "ObjectName", CellTags -> "DB1"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DB1"], Cell["DB1[p2,m1^2,m2^2] is the derivative of \
B1[p2,m1^2,m2^2] with respect to p2.", "Text", CellTags -> "DB1"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["B1", RuleDelayed[ButtonData, "B1"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B1"]], 
              "."}], "Text", CellTags -> "DB1"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DB1"], Cell[CellGroupData[{Cell[BoxData[
                \(D[\(\(B1[\(p\_2, \(m\_1\)\^2, \(m\_2\)\^2\)]\), p\_2\)]\)], 
               "Input", CellTags -> "DB1"], Cell[BoxData[
                \(TraditionalForm\`\(\(\((m\_2\%2 - m\_1\%2)\)\ 
                        \(DB0(\(p\_2, m\_1\%2, m\_2\%2\))\)\)\/\(2\ p\_2\) - 
                     \(1\/2\ \(DB0(\(p\_2, m\_1\%2, m\_2\%2\))\)\) - 
                     \(\((\(B\_0 (p\_2, m\_1\%2, m\_2\%2)\) - 
                           \(B\_0 (0, m\_1\%2, m\_2\%2)\))\)\ 
                        \((m\_2\%2 - m\_1\%2)\)\)\/\(2\ p\_2\%2\)\)\)], 
               "Output", CellTags -> "DB1"]}, Open]]}, Open]], 
        Cell["DeclareNonCommutative", "ObjectName", CellTags -> 
          "DeclareNonCommutative"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "DeclareNonCommutative"], Cell["DeclareNonCommutative[a, b, ...] \
declares a,b, ... to be non-commutative, i.e., DataType[a,b, ..., \
NonCommutative] is set to True.", "Text", CellTags -> 
             "DeclareNonCommutative"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DataType", RuleDelayed[ButtonData, "DataType"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DataType"]], ", ", 
              ButtonBox["UnDeclareNonCommutative", 
                RuleDelayed[ButtonData, "UnDeclareNonCommutative"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "UnDeclareNonCommutative"]], "."}], "Text", 
            CellTags -> "DeclareNonCommutative"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DeclareNonCommutative"], Cell[BoxData[
             \(DeclareNonCommutative[x]\)], "Input", CellTags -> 
             "DeclareNonCommutative"], Cell["As a side effect of \
DeclareNonCommutative x is declared to be of data type NonCommutative.", 
            "Text", CellTags -> "DeclareNonCommutative"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DataType[\(x, NonCommutative\)]\)], "Input", CellTags -> 
                "DeclareNonCommutative"], Cell[BoxData[
                \(TraditionalForm\`True\)], "Output", CellTags -> 
                "DeclareNonCommutative"]}, Open]], Cell[BoxData[
             \(DeclareNonCommutative[\(y, z\)]\)], "Input", 
            CellTags -> "DeclareNonCommutative"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DataType[\(a, x, y, z, NonCommutative\)]\)], "Input", 
               CellTags -> "DeclareNonCommutative"], Cell[BoxData[
                \(TraditionalForm\`\({True, True, True, True}\)\)], "Output", 
               CellTags -> "DeclareNonCommutative"]}, Open]], Cell[BoxData[
             \(UnDeclareNonCommutative[\(x, y, z\)]\)], "Input", 
            CellTags -> "DeclareNonCommutative"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DataType[\(a, x, y, z, NonCommutative\)]\)], "Input", 
               CellTags -> "DeclareNonCommutative"], Cell[BoxData[
                \(TraditionalForm\`\({True, True, True, True}\)\)], "Output", 
               CellTags -> "DeclareNonCommutative"]}, Open]]}, Open]], 
        Cell["DeltaFunction", "ObjectName", CellTags -> "DeltaFunction"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DeltaFunction"], Cell[TextData[
             {" DeltaFunction[x] is the Dirac delta-function ", Cell[BoxData[
                \(TraditionalForm\`\(\[Delta](x)\)\)]], 
              ".\nNOTICE: After version 4 of ", 
              StyleBox["Mathematica", Rule[FontSlant, "Italic"]], " there is \
a built-in function, DiracDelta, with comparable properties."}], "Text", 
            CellTags -> "DeltaFunction"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Convolute", RuleDelayed[ButtonData, "Convolute"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Convolute"]], ", ", 
              ButtonBox["DeltaFunctionPrime", 
                RuleDelayed[ButtonData, "DeltaFunctionPrime"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeltaFunctionPrime"]], ", ", 
              ButtonBox["Integrate2", RuleDelayed[ButtonData, "Integrate2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Integrate2"]], ", ", 
              ButtonBox["SimplifyDeltaFunction", 
                RuleDelayed[ButtonData, "SimplifyDeltaFunction"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SimplifyDeltaFunction"]], "."}], "Text", 
            CellTags -> "DeltaFunction"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DeltaFunction"], Cell[CellGroupData[{Cell[BoxData[
                \(DeltaFunction[\(1 - x\)]\)], "Input", CellTags -> 
                "DeltaFunction"], Cell[BoxData[FormBox[RowBox[{"\[Delta]", 
                   "(", FormBox[\(1 - x\), "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> "DeltaFunction"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(DeltaFunction[\(1 - x\)]\)\ \(f[x]\)\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> 
                "DeltaFunction"], Cell[BoxData[\(TraditionalForm\`\(f(1)\)\)]
                , "Output", CellTags -> "DeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(DeltaFunction[x]\)\ \(f[x]\)\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> 
                "DeltaFunction"], Cell[BoxData[\(TraditionalForm\`\(f(0)\)\)]
                , "Output", CellTags -> "DeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(DeltaFunction[\(1 - x\)]\)\ \(f[x]\)\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> 
                "DeltaFunction"], Cell[BoxData[\(TraditionalForm\`\(f(1)\)\)]
                , "Output", CellTags -> "DeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Convolute[\(\(DeltaFunction[\(1 - x\)]\), x\)]\)], "Input", 
               CellTags -> "DeltaFunction"], Cell[BoxData[
                \(TraditionalForm\`x\)], "Output", CellTags -> 
                "DeltaFunction"]}, Open]]}, Open]], 
        Cell["DeltaFunctionDoublePrime", "ObjectName", 
         CellTags -> "DeltaFunctionDoublePrime"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DeltaFunctionDoublePrime"], 
           Cell[TextData[{" DeltaFunctionDoublePrime[1-x] is the second \
derivative of the Dirac delta-function ", Cell[BoxData[
                \(TraditionalForm\`\(\[Delta](x)\)\)]], "."}], "Text", 
            CellTags -> "DeltaFunctionDoublePrime"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["DeltaFunctionPrime", 
                RuleDelayed[ButtonData, "DeltaFunctionPrime"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeltaFunctionPrime"]], "."}], "Text", 
            CellTags -> "DeltaFunctionDoublePrime"]}, Open]], 
        Cell["DeltaFunctionPrime", "ObjectName", CellTags -> 
          "DeltaFunctionPrime"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "DeltaFunctionPrime"], Cell[TextData[{" DeltaFunctionPrime[1-x] \
is the derivative of the Dirac delta-function ", Cell[BoxData[
                \(TraditionalForm\`\(\[Delta](x)\)\)]], "."}], "Text", 
            CellTags -> "DeltaFunctionPrime"], Cell[TextData[{"See also: ", 
              ButtonBox["Convolute", RuleDelayed[ButtonData, "Convolute"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Convolute"]], ", ", 
              ButtonBox["DeltaFunction", 
                RuleDelayed[ButtonData, "DeltaFunction"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeltaFunction"]], ", ", 
              ButtonBox["DeltaFunctionDoublePrime", 
                RuleDelayed[ButtonData, "DeltaFunctionDoublePrime"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeltaFunctionDoublePrime"]], ", ", 
              ButtonBox["Integrate2", RuleDelayed[ButtonData, "Integrate2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Integrate2"]], ", ", 
              ButtonBox["SimplifyDeltaFunction", 
                RuleDelayed[ButtonData, "SimplifyDeltaFunction"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SimplifyDeltaFunction"]], "."}], "Text", 
            CellTags -> "DeltaFunctionPrime"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DeltaFunctionPrime"], Cell[CellGroupData[
             {Cell[BoxData[\(DeltaFunctionPrime[\(1 - x\)]\)], "Input", 
               CellTags -> "DeltaFunctionPrime"], Cell[BoxData[FormBox[
                 RowBox[{\(\[Delta]\^\[Prime]\), "(", FormBox[\(1 - x\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "DeltaFunctionPrime"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(DeltaFunctionPrime[\(1 - x\)]\)\ \(f[x]\)
                      \), \({x, 0, 1}\)\)]\)], "Input", CellTags -> 
                "DeltaFunctionPrime"], Cell[BoxData[
                \(TraditionalForm\`\(\(\*
                       SuperscriptBox["f", "\[Prime]", 
                        Rule[MultilineFunction, None]]\)(1)\)\)], "Output", 
               CellTags -> "DeltaFunctionPrime"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(DeltaFunctionPrime[\(1 - x\)]\)\ x\^2\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> 
                "DeltaFunctionPrime"], Cell[BoxData[\(TraditionalForm\`2\)], 
               "Output", CellTags -> "DeltaFunctionPrime"]}, Open]]}, Open]], 
        Cell["DenominatorOrder", "ObjectName", CellTags -> 
          "DenominatorOrder"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "DenominatorOrder"], Cell["DenominatorOrder is an option for \
OneLoop, if set to True the PropagatorDenominator will be ordered in a \
standard way.", "Text", CellTags -> "DenominatorOrder"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, ", ", 
              ButtonBox["PropagatorDenominator", 
                RuleDelayed[ButtonData, "PropagatorDenominator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PropagatorDenominator"]], "."}], "Text", 
            CellTags -> "DenominatorOrder"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["Dimension", "ObjectName", CellTags -> "Dimension"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Dimension"], Cell["Dimension is an option of several \
functions and denotes the number of space-time dimensions. Possible settings \
are: 4, n, d, D, ... ,the variable does not matter, but it should have Head \
Symbol.", "Text", CellTags -> "Dimension"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[MetricTensor]\)], "Input", CellTags -> 
                "Dimension"], Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] 4\), 
                      \(FeynCalcInternal \[Rule] False\)}\)\)], "Output", 
               CellTags -> "Dimension"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(MetricTensor[\(m, n, \(Dimension \[Rule] d\)\)]\) 
                   \(DiracMatrix[\(\[Alpha], \(Dimension \[Rule] d\)\)]\)\)], 
               "Input", CellTags -> "Dimension"], Cell[BoxData[FormBox[
                 RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                      "\[Alpha]", "TraditionalForm"], "TraditionalForm"]], 
                   " ", \(g\^\(mn\)\)}], TraditionalForm]], "Output", 
               CellTags -> "Dimension"]}, Open]], Cell["The dimension of the \
indices is not shown by default but can be inspected easily.", "Text", 
            CellTags -> "Dimension"], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(MetricTensor[\(m, n, \(Dimension \[Rule] d\)\)]\) 
                     \(DiracMatrix[\(\[Alpha], \(Dimension \[Rule] d\)\)]\)\)
                //StandardForm\)], "Input", CellTags -> "Dimension"], 
              Cell[BoxData[
                \(\(DiracGamma[\(\(LorentzIndex[\(\[Alpha], d\)]\), d\)]\)\ 
                   \(MetricTensor[\(m, n, \(Dimension \[Rule] d\)\)]\)\)], 
               "Output", CellTags -> "Dimension"]}, Open]], 
           Cell["Setting the global variable $LorentzIndices to True will \
display the dimension (if different from 4) as a subscript.", "Text", 
            CellTags -> "Dimension"], Cell[BoxData[
             \(\($LorentzIndices = True\) ;\)], "Input", CellTags -> 
             "Dimension"], Cell[CellGroupData[{Cell[BoxData[
                \(\(MetricTensor[\(\[Alpha], \[Beta], \(Dimension \[Rule] n\)
                      \)]\) \(DiracMatrix[
                     \(\[Alpha], \(Dimension \[Rule] n\)\)]\)\)], "Input", 
               CellTags -> "Dimension"], Cell[BoxData[FormBox[RowBox[
                  {SuperscriptBox["\[Gamma]", FormBox[SubscriptBox[FormBox[
                       "\[Alpha]", "TraditionalForm"], FormBox["n", 
                       "TraditionalForm"]], "TraditionalForm"]], " ", 
                   SuperscriptBox["g", RowBox[{FormBox[SubscriptBox[FormBox[
                         "\[Alpha]", "TraditionalForm"], FormBox["n", 
                         "TraditionalForm"]], "TraditionalForm"], FormBox[
                       SubscriptBox[FormBox["\[Beta]", "TraditionalForm"], 
                        FormBox["n", "TraditionalForm"]], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Dimension"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "Dimension"], Cell[BoxData[
                \(\(DiracGamma[\(\(LorentzIndex[\(\[Alpha], n\)]\), n\)]\)\ 
                   \(MetricTensor[\(\[Alpha], \[Beta], 
                       \(Dimension \[Rule] n\)\)]\)\)], "Output", CellTags -> 
                "Dimension"]}, Open]], Cell[BoxData[
             \(\($LorentzIndices = False\) ;\)], "Input", 
            CellTags -> "Dimension"]}, Open]], Cell["DimensionalReduction", 
         "ObjectName", CellTags -> "DimensionalReduction"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DimensionalReduction"], 
           Cell[
            "DimensionalReduction is an option for TID and OneLoopSimplify.", 
            "Text", CellTags -> "DimensionalReduction"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["TID", RuleDelayed[ButtonData, "TID"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TID"]], 
              ", ", 
              ButtonBox["OneLoopSimplify", 
                RuleDelayed[ButtonData, "OneLoopSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSimplify"]], "."}], "Text", 
            CellTags -> "DimensionalReduction"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["DiracBasis", "ObjectName", CellTags -> "DiracBasis"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracBasis"], Cell["DiracBasis[any] is a head which \
is wrapped around Dirac structures (and the 1) as a result of the function \
DiracReduce. Eventually you want to substitute DiracBasis by Identity (or \
set: DiracBasis[1] = S; DiracBasis[DiracMatrix[mu]] = P; etc.).", "Text", 
            CellTags -> "DiracBasis"], Cell[TextData[{"See also: ", 
              ButtonBox["DiracReduce", RuleDelayed[ButtonData, 
                 "DiracReduce"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracReduce"]], "."}], "Text", 
            CellTags -> "DiracBasis"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["DiracCanonical", "ObjectName", CellTags -> "DiracCanonical"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracCanonical"], Cell["DiracCanonical is an option \
for DiracSimplify. If set to True DiracSimplify uses the function DiracOrder \
internally.", "Text", CellTags -> "DiracCanonical"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], "."}], "Text", 
            CellTags -> "DiracCanonical"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["DiracEquation", "ObjectName", 
         CellTags -> "DiracEquation"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "DiracEquation"], 
           Cell["DiracEquation[exp] applies the Dirac equation without \
expanding exp. If that is needed, use DiracSimplify.", "Text", 
            CellTags -> "DiracEquation"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], "."}], "Text", 
            CellTags -> "DiracEquation"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracEquation"], Cell[CellGroupData[{Cell[BoxData[
                \(\(Spinor[\(\(Momentum[p]\), m, 1\)]\) . 
                   \(DiracGamma[\(Momentum[p]\)]\)\)], "Input", CellTags -> 
                "DiracEquation"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"\[CurlyPhi]", "(", FormBox["p", 
                      "TraditionalForm"], ",", "m", ")"}], ".", RowBox[
                    {"(", RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "DiracEquation"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracEquation[%]\)], "Input", CellTags -> "DiracEquation"], 
              Cell[BoxData[FormBox[RowBox[{"m", " ", RowBox[{"\[CurlyPhi]", 
                     "(", FormBox["p", "TraditionalForm"], ",", "m", ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracEquation"]}, 
             Open]]}, Open]], Cell["DiracGamma", "ObjectName", 
         CellTags -> "DiracGamma"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "DiracGamma"], 
           Cell[TextData[{"DiracGamma[x, dim] is the head of all Dirac \
matrices and slashes (in the internal representation). Use DiracMatrix (or \
GA, GAD) and DiracSlash (or GS, GSD) for manual (short) input. DiracGamma[x, \
4] simplifies to DiracGamma[x]. DiracGamma[5] is ", Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5\)\)]], 
              ". DiracGamma[6] is ", Cell[BoxData[
                \(TraditionalForm\`\(\((1 + \[Gamma]\^5)\)/2.\)\)]], 
              " DiracGamma[7] is ", Cell[BoxData[
                \(TraditionalForm\`\(\((1 - \[Gamma]\^5)\)/2.\)\)]]}], 
            "Text", CellTags -> "DiracGamma"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracGammaExpand", 
                RuleDelayed[ButtonData, "DiracGammaExpand"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGammaExpand"]], ", ", 
              ButtonBox["DiracMatrix", RuleDelayed[ButtonData, 
                 "DiracMatrix"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracMatrix"]], ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["DiracSlash", RuleDelayed[ButtonData, "DiracSlash"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSlash"]], ", ", 
              ButtonBox["DiracTrick", RuleDelayed[ButtonData, "DiracTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrick"]], "."}], "Text", 
            CellTags -> "DiracGamma"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracGamma"], Cell[CellGroupData[{Cell[BoxData[
                \(DiracGamma[5]\)], "Input", CellTags -> "DiracGamma"], 
              Cell[BoxData[\(TraditionalForm\`\(\[Gamma]\^5\)\)], "Output", 
               CellTags -> "DiracGamma"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DiracGamma[\(LorentzIndex[\[Alpha]]\)]\)], "Input", 
               CellTags -> "DiracGamma"], Cell[BoxData[FormBox[SuperscriptBox[
                  "\[Gamma]", FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                   "TraditionalForm"]], TraditionalForm]], "Output", 
               CellTags -> "DiracGamma"]}, Open]], 
           Cell[TextData[{"A Dirac-slash, i.e., ", Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] q\_\[Mu]\)\)]], 
              ", is displayed as ", Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma] \[CenterDot] q\)\)]], "."}], 
            "Text", CellTags -> "DiracGamma"], Cell[CellGroupData[
             {Cell[BoxData[\(\(DiracGamma[\(Momentum[q]\)]\)\ \)], "Input", 
               CellTags -> "DiracGamma"], Cell[BoxData[FormBox[RowBox[
                  {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                   "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracGamma"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(DiracGamma[\(Momentum[q]\)]\)\ .\ 
                   \(DiracGamma[\(Momentum[\(p - q\)]\)]\)\)], "Input", 
               CellTags -> "DiracGamma"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                        "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                        "TraditionalForm"]}], ")"}], ".", RowBox[{"(", 
                     RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", "(", FormBox[\(p - q\), 
                        "TraditionalForm"], ")"}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracGamma"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(DiracGamma[\(\(Momentum[\(q, D\)]\), D\)]\)\ \)], 
               "Input", CellTags -> "DiracGamma"], Cell[BoxData[
                FormBox[RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                   "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracGamma"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(a1 = \(\(GS[\(p - q\)]\) . \(GS[p]\)\)\)], "Input", 
               CellTags -> "DiracGamma"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"(", RowBox[{"\[Gamma]", "\[CenterDot]", "(", 
                       FormBox[\(p - q\), "TraditionalForm"], ")"}], ")"}], 
                   ".", \((\[Gamma] \[CenterDot] p)\)}], TraditionalForm]], 
               "Output", CellTags -> "DiracGamma"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(a2 = \(DiracGammaExpand[a1]\)\)]
                , "Input", CellTags -> "DiracGamma"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                         FormBox["p", "TraditionalForm"]}], "-", RowBox[
                        {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["q", "TraditionalForm"]}]}], 
                     ")"}], ".", RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                        "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                        "TraditionalForm"]}], ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "DiracGamma"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(a3 = \(\(GAD[\[Mu]]\) . \(GSD[\(p - q\)]\) . \(GSD[q]\) . 
                     \(GAD[\[Mu]]\)\)\)], "Input", CellTags -> "DiracGamma"], 
              Cell[BoxData[FormBox[RowBox[{\(\[Gamma]\^\[Mu]\), ".", 
                   RowBox[{"(", RowBox[{"\[Gamma]", "\[CenterDot]", "(", 
                       FormBox[\(p - q\), "TraditionalForm"], ")"}], ")"}], 
                   ".", \((\[Gamma] \[CenterDot] q)\), ".", 
                   \(\[Gamma]\^\[Mu]\)}], TraditionalForm]], "Output", 
               CellTags -> "DiracGamma"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(a4 = \(DiracTrick[a3]\)\)], 
               "Input", CellTags -> "DiracGamma"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{\((D - 4)\), " ", RowBox[
                      {RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", "(", FormBox[
                          \(p - q\), "TraditionalForm"], ")"}], ")"}], ".", 
                       RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}]}]}], "+", RowBox[
                    {"4", " ", RowBox[{"(", FormBox[\(p - q\), 
                        "TraditionalForm"], ")", "\[CenterDot]", FormBox["q", 
                        "TraditionalForm"]}]}]}], TraditionalForm]], 
               "Output", CellTags -> "DiracGamma"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(a5 = \(DiracSimplify[a4]\)\)], 
               "Input", CellTags -> "DiracGamma"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"D", " ", RowBox[{RowBox[{"(", 
                         RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                         ")"}], ".", RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["q", "TraditionalForm"]}], ")"}]}]}], "-", 
                   RowBox[{"4", " ", RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["p", "TraditionalForm"]}], ")"}], ".", 
                       RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}]}]}], "+", RowBox[
                    {"4", " ", RowBox[{FormBox["p", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["q", "TraditionalForm"]}]}], 
                   "-", RowBox[{"D", " ", SuperscriptBox[FormBox["q", 
                       "TraditionalForm"], "2"]}]}], TraditionalForm]], 
               "Output", CellTags -> "DiracGamma"]}, Open]], Cell[BoxData[
             \(Clear[\(a1, a2, a3, a4, a5\)]\)], "Input", 
            CellTags -> "DiracGamma"]}, Open]], Cell["DiracGammaCombine", 
         "ObjectName", CellTags -> "DiracGammaCombine"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracGammaCombine"], Cell["DiracGammaCombine[exp] is \
(nearly) the inverse operation to DiracGammaExpand.", "Text", 
            CellTags -> "DiracGammaCombine"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracGamma", RuleDelayed[ButtonData, "DiracGamma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGamma"]], ", ", 
              ButtonBox["DiracGammaExpand", 
                RuleDelayed[ButtonData, "DiracGammaExpand"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGammaExpand"]], ", ", 
              ButtonBox["DiracMatrix", RuleDelayed[ButtonData, 
                 "DiracMatrix"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracMatrix"]], ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["DiracSlash", RuleDelayed[ButtonData, "DiracSlash"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSlash"]], ", ", 
              ButtonBox["DiracTrick", RuleDelayed[ButtonData, "DiracTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrick"]], "."}], "Text", 
            CellTags -> "DiracGammaCombine"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracGammaCombine"], Cell[CellGroupData[
             {Cell[BoxData[\(DiracGammaCombine[\(\(GS[p]\)\ +\ \(GS[q]\)\)]\)]
                , "Input", CellTags -> "DiracGammaCombine"], Cell[BoxData[
                FormBox[RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                   "\[CenterDot]", "(", FormBox[\(p + q\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "DiracGammaCombine"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(StandardForm[%]\)], "Input", 
               CellTags -> "DiracGammaCombine"], Cell[BoxData[
                \(DiracGamma[\(Momentum[\(p + q\)]\)]\)], "Output", 
               CellTags -> "DiracGammaCombine"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DiracGammaCombine[\(\(2\ \(GS[p]\)\)\ -\ \(2\ \(GS[q]\)\)\)
                   ]\)], "Input", CellTags -> "DiracGammaCombine"], 
              Cell[BoxData[FormBox[RowBox[{FormBox["\"\[Gamma]\"", 
                    "TraditionalForm"], "\[CenterDot]", "(", FormBox[
                    \(\(2\ p\) - \(2\ q\)\), "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> 
                "DiracGammaCombine"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(StandardForm[%]\)], "Input", CellTags -> 
                "DiracGammaCombine"], Cell[BoxData[
                \(DiracGamma[\(Momentum[\(\(2\ p\) - \(2\ q\)\)]\)]\)], 
               "Output", CellTags -> "DiracGammaCombine"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracGammaExpand[%%]\)], 
               "Input", CellTags -> "DiracGammaCombine"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"2", " ", RowBox[{FormBox[
                        "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                       FormBox["p", "TraditionalForm"]}]}], "-", RowBox[
                    {"2", " ", RowBox[{FormBox["\"\[Gamma]\"", 
                        "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                        "TraditionalForm"]}]}]}], TraditionalForm]], 
               "Output", CellTags -> "DiracGammaCombine"]}, Open]]}, Open]], 
        Cell["DiracGammaExpand", "ObjectName", CellTags -> 
          "DiracGammaExpand"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "DiracGammaExpand"], Cell["DiracGammaExpand[exp] expands all \
DiracGamma[Momentum[a+b+..]] in exp into (DiracGamma[Momentum[a]] + \
DiracGamma[Momentum[b]] + ...).", "Text", CellTags -> "DiracGammaExpand"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracGamma", RuleDelayed[ButtonData, "DiracGamma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGamma"]], ", ", 
              ButtonBox["DiracGammaCombine", 
                RuleDelayed[ButtonData, "DiracGammaCombine"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGammaCombine"]], ", ", 
              ButtonBox["DiracMatrix", RuleDelayed[ButtonData, 
                 "DiracMatrix"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracMatrix"]], ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["DiracSlash", RuleDelayed[ButtonData, "DiracSlash"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSlash"]], ", ", 
              ButtonBox["DiracTrick", RuleDelayed[ButtonData, "DiracTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrick"]], "."}], "Text", 
            CellTags -> "DiracGammaExpand"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracGammaExpand"], Cell[CellGroupData[{Cell[BoxData[
                \(t = \(\(DiracGamma[\(Momentum[q]\)]\)\ .\ 
                     \(DiracGamma[\(Momentum[\(p - q\)]\)]\)\)\)], "Input", 
               CellTags -> "DiracGammaExpand"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                        "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                        "TraditionalForm"]}], ")"}], ".", RowBox[{"(", 
                     RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", "(", FormBox[\(p - q\), 
                        "TraditionalForm"], ")"}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "DiracGammaExpand"]}, Open]], Cell["Momentum is the head of \
p-q, i.e., it is treated as one four-momentum.", "Text", CellTags -> 
             "DiracGammaExpand"], Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[t]\)], "Input", CellTags -> 
                "DiracGammaExpand"], Cell[BoxData[
                \(\(DiracGamma[\(Momentum[q]\)]\) . 
                   \(DiracGamma[\(Momentum[\(p - q\)]\)]\)\)], "Output", 
               CellTags -> "DiracGammaExpand"]}, Open]], 
           Cell["With DiracGammaExpand the Momentum[p-q] gets expanded.", 
            "Text", CellTags -> "DiracGammaExpand"], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracGammaExpand[t]\)], 
               "Input", CellTags -> "DiracGammaExpand"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                        "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                        "TraditionalForm"]}], ")"}], ".", RowBox[{"(", 
                     RowBox[{RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "-", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                         FormBox["q", "TraditionalForm"]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "DiracGammaExpand"]}, Open]], 
           Cell["The inverse operation is DiracGammaCombine.", "Text", 
            CellTags -> "DiracGammaExpand"], Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(DiracGammaCombine[\(DiracGammaExpand[t]\)]\)
                   ]\)], "Input", CellTags -> "DiracGammaExpand"], 
              Cell[BoxData[
                \(\(DiracGamma[\(Momentum[q]\)]\) . 
                   \(DiracGamma[\(Momentum[\(p - q\)]\)]\)\)], "Output", 
               CellTags -> "DiracGammaExpand"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(DiracGammaExpand[t]\)]\)], "Input", 
               CellTags -> "DiracGammaExpand"], Cell[BoxData[
                \(\(DiracGamma[\(Momentum[q]\)]\) . 
                   \((\(DiracGamma[\(Momentum[p]\)]\) - 
                      \(DiracGamma[\(Momentum[q]\)]\))\)\)], "Output", 
               CellTags -> "DiracGammaExpand"]}, Open]], 
           Cell[
            "In order to do non-commutative expansion use DiracSimplify.", 
            "Text", CellTags -> "DiracGammaExpand"], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracSimplify[t]\)], "Input", 
               CellTags -> "DiracGammaExpand"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], ".", RowBox[{"(", 
                       RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                       ")"}]}], "-", SuperscriptBox[FormBox["q", 
                     "TraditionalForm"], "2"]}], TraditionalForm]], "Output", 
               CellTags -> "DiracGammaExpand"]}, Open]], Cell[BoxData[
             \(Clear[t]\)], "Input", CellTags -> "DiracGammaExpand"]}, 
          Open]], Cell["DiracGammaT", "ObjectName", CellTags -> 
          "DiracGammaT"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "DiracGammaT"], Cell["DiracGammaT[x] \
denotes the transpose of DiracGamma[x]. Transpose[DiracGammaT[x]] gives \
DiracGamma[x]. Note that x must have Head LorentzIndex or Momentum.", "Text", 
            CellTags -> "DiracGammaT"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracGamma", RuleDelayed[ButtonData, "DiracGamma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGamma"]], "."}], "Text", 
            CellTags -> "DiracGammaT"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracGammaT"], Cell[CellGroupData[{Cell[BoxData[
                \(DiracGammaT[\(LorentzIndex[\[Mu]]\)]\)], "Input", 
               CellTags -> "DiracGammaT"], Cell[BoxData[FormBox[
                 SubsuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                    "TraditionalForm"], "TraditionalForm"], "T"], 
                 TraditionalForm]], "Output", CellTags -> "DiracGammaT"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(Transpose[%]\)], 
               "Input", CellTags -> "DiracGammaT"], Cell[BoxData[
                FormBox[SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                    "TraditionalForm"], "TraditionalForm"]], 
                 TraditionalForm]], "Output", CellTags -> "DiracGammaT"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(GS[p]\)//FCI\)//Transpose\)], "Input", CellTags -> 
                "DiracGammaT"], Cell[BoxData[FormBox[SuperscriptBox[
                  RowBox[{"(", "\[Gamma]", "\[CenterDot]", FormBox["p", 
                     "TraditionalForm"], ")"}], "T"], TraditionalForm]], 
               "Output", CellTags -> "DiracGammaT"]}, Open]]}, Open]], 
        Cell["DiracMatrix", "ObjectName", CellTags -> "DiracMatrix"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracMatrix"], Cell[TextData[{"DiracMatrix[", 
              Cell[BoxData[\(TraditionalForm\`\[Mu]\)]], 
              "] denotes a Dirac gamma matrix with Lorentz index ", 
              Cell[BoxData[\(TraditionalForm\`\[Mu]\)]], ". DiracMatrix[", 
              Cell[BoxData[\(TraditionalForm\`\(\(\[Mu], \[Nu],\)\ \)\)]], 
              "...] is a product of ", Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\)]], 
              " matrices with Lorentz indices ", Cell[BoxData[
                \(TraditionalForm\`\(\[Mu],\ \[Nu],\ ...\)\)]], 
              " DiracMatrix[5] is ", Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5\)\)]], 
              ". DiracMatrix[6] is ", Cell[BoxData[
                \(TraditionalForm\`\(1/2\)\)]], Cell[BoxData[
                \(TraditionalForm\`\(\ \(\(+\ \[Gamma]\^5\)/2\)\)\)]], 
              ". DiracMatrix[7] is", Cell[BoxData[
                \(TraditionalForm\`\(\ \(1/2\)\)\)]], Cell[BoxData[
                \(TraditionalForm\`\(\ \(\(-\ \[Gamma]\^5\)/2\)\)\)]], "."}], 
            "Text", CellTags -> "DiracMatrix"], Cell[CellGroupData[
             {Cell[BoxData[\(Options[DiracMatrix]\)], "Input", CellTags -> 
                "DiracMatrix"], Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] 4\), 
                      \(FeynCalcInternal \[Rule] True\)}\)\)], "Output", 
               CellTags -> "DiracMatrix"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracGammaExpand", 
                RuleDelayed[ButtonData, "DiracGammaExpand"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGammaExpand"]], ", ", 
              ButtonBox["DiracGamma", RuleDelayed[ButtonData, "DiracGamma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGamma"]], ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["DiracSlash", RuleDelayed[ButtonData, "DiracSlash"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSlash"]], ", ", 
              ButtonBox["DiracTrick", RuleDelayed[ButtonData, "DiracTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrick"]], ", ", 
              ButtonBox["GA", RuleDelayed[ButtonData, "GA"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GA"]], 
              ", ", 
              ButtonBox["GAD", RuleDelayed[ButtonData, "GAD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GAD"]], 
              ", ", 
              ButtonBox["GS", RuleDelayed[ButtonData, "GS"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GS"]], 
              ", ", 
              ButtonBox["GSD", RuleDelayed[ButtonData, "GSD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GSD"]], 
              "."}], "Text", CellTags -> "DiracMatrix"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracMatrix"], Cell[CellGroupData[{Cell[BoxData[
                \(DiracMatrix[\[Mu]]\)], "Input", CellTags -> "DiracMatrix"], 
              Cell[BoxData[FormBox[SuperscriptBox["\[Gamma]", FormBox[
                   FormBox["\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                 TraditionalForm]], "Output", CellTags -> "DiracMatrix"]}, 
             Open]], Cell[TextData[
             {"This is how to enter the non-commutative product of two ", 
              Cell[BoxData[FormBox[RowBox[{SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]]], ". The ", 
              StyleBox["Mathematica", Rule[FontSlant, "Italic"]], " Dot \".\" \
is used as non-commutative multiplication operator."}], "Text", 
            CellTags -> "DiracMatrix"], Cell[CellGroupData[{Cell[BoxData[
                \(\(DiracMatrix[\[Mu]]\) . \(DiracMatrix[\[Nu]]\)\)], 
               "Input", CellTags -> "DiracMatrix"], Cell[BoxData[
                FormBox[RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                      "\[Mu]", "TraditionalForm"], "TraditionalForm"]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracMatrix"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(DiracMatrix[\[Alpha]]\)//StandardForm\)], "Input", 
               CellTags -> "DiracMatrix"], Cell[BoxData[
                \(DiracGamma[\(LorentzIndex[\[Alpha]]\)]\)], "Output", 
               CellTags -> "DiracMatrix"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(DiracMatrix[\[Mu]]\)//FCE\)], 
               "Input", CellTags -> "DiracMatrix"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu]\)\)], "Output", 
               CellTags -> "DiracMatrix"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "DiracMatrix"], Cell[BoxData[\(GA[\[Mu]]\)], 
               "Output", CellTags -> "DiracMatrix"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(GAD[\[Mu]]\)], "Input", 
               CellTags -> "DiracMatrix"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu]\)\)], "Output", 
               CellTags -> "DiracMatrix"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(%//FCI\)//StandardForm\)], 
               "Input", CellTags -> "DiracMatrix"], Cell[BoxData[
                \(DiracGamma[\(\(LorentzIndex[\(\[Mu], D\)]\), D\)]\)], 
               "Output", CellTags -> "DiracMatrix"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(GA[\(\[Mu], \[Nu], \[Rho]\)]\)]
                , "Input", CellTags -> "DiracMatrix"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . 
                     \[Gamma]\^\[Rho]\)\)], "Output", CellTags -> 
                "DiracMatrix"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GA[\(a\ .\ b\)]\)//FCI\)], "Input", CellTags -> 
                "DiracMatrix"], Cell[BoxData[FormBox[RowBox[{SuperscriptBox[
                    "\[Gamma]", FormBox[FormBox["a", "TraditionalForm"], 
                     "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["b", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "DiracMatrix"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "DiracMatrix"], Cell[BoxData[
                \(\(DiracGamma[\(LorentzIndex[a]\)]\) . 
                   \(DiracGamma[\(LorentzIndex[b]\)]\)\)], "Output", 
               CellTags -> "DiracMatrix"]}, Open]]}, Open]], 
        Cell["DiracOrder", "ObjectName", CellTags -> "DiracOrder"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracOrder"], Cell["DiracOrder[expr] orders the \
Dirac matrices in expr alphabetically. DiracOrder[expr,orderlist] orders the \
Dirac matrices in expr according to orderlist.", "Text", CellTags -> 
             "DiracOrder"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["DiracTrick", RuleDelayed[ButtonData, "DiracTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrick"]], "."}], "Text", 
            CellTags -> "DiracOrder"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracOrder"], Cell[CellGroupData[{Cell[BoxData[
                \(t1\ =\ \(GA[\(\[Beta], \[Alpha]\)]\)\)], "Input", 
               CellTags -> "DiracOrder"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Beta] . \[Gamma]\^\[Alpha]\)
                  \)], "Output", CellTags -> "DiracOrder"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracOrder[t1]\)], "Input", 
               CellTags -> "DiracOrder"], Cell[BoxData[FormBox[RowBox[{
                   \(2\ g\^\(\[Alpha]\[Beta]\)\), "-", RowBox[{SuperscriptBox[
                      "\[Gamma]", FormBox[FormBox["\[Alpha]", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Beta]", 
                        "TraditionalForm"], "TraditionalForm"]]}]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracOrder"]}, 
             Open]], Cell[
            "This is a string of Dirac matrices in D dimensions. ", "Text", 
            CellTags -> "DiracOrder"], Cell[CellGroupData[{Cell[BoxData[
                \(t2 = \(GAD[\(\[Mu], \[Nu], \[Mu]\)]\)\)], "Input", 
               CellTags -> "DiracOrder"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . 
                     \[Gamma]\^\[Mu]\)\)], "Output", CellTags -> 
                "DiracOrder"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracOrder[t1]\)], "Input", CellTags -> "DiracOrder"], 
              Cell[BoxData[FormBox[RowBox[{\(2\ g\^\(\[Alpha]\[Beta]\)\), 
                   "-", RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        "\[Alpha]", "TraditionalForm"], "TraditionalForm"]], 
                     ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        "\[Beta]", "TraditionalForm"], 
                       "TraditionalForm"]]}]}], TraditionalForm]], "Output", 
               CellTags -> "DiracOrder"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t3 = \(GA[\(5, \[Mu], \[Nu]\)]\)\)], "Input", CellTags -> 
                "DiracOrder"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5 . \[Gamma]\^\[Mu] . 
                     \[Gamma]\^\[Nu]\)\)], "Output", CellTags -> 
                "DiracOrder"]}, Open]], Cell[TextData[{"By default ", 
              Cell[BoxData[\(TraditionalForm\`\(\[Gamma]\^\(5\ \)\)\)]], 
              "is moved to the right."}], "Text", CellTags -> "DiracOrder"], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracOrder[t3]\)], "Input", 
               CellTags -> "DiracOrder"], Cell[BoxData[FormBox[RowBox[
                  {SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(\[Gamma]\^5\)}], TraditionalForm]], "Output", 
               CellTags -> "DiracOrder"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(t4 = \(GA[\(6, \[Mu], 7\)]\)\)]
                , "Input", CellTags -> "DiracOrder"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^6 . \[Gamma]\^\[Mu] . 
                     \[Gamma]\^7\)\)], "Output", CellTags -> "DiracOrder"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(DiracOrder[t4]\)], 
               "Input", CellTags -> "DiracOrder"], Cell[BoxData[
                FormBox[RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                      "\[Mu]", "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(\[Gamma]\^7\)}], TraditionalForm]], "Output", 
               CellTags -> "DiracOrder"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t5 = \(GA[\(\[Alpha], \[Beta], \[Delta]\)]\)\)], "Input", 
               CellTags -> "DiracOrder"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Alpha] . \[Gamma]\^\[Beta] .
                      \[Gamma]\^\[Delta]\)\)], "Output", CellTags -> 
                "DiracOrder"]}, Open]], Cell[TextData[{"This orders the ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Alpha] \[Gamma]\^\[Beta] 
                     \[Gamma]\^\[Delta]\)\)]], " in reverse order."}], 
            "Text", CellTags -> "DiracOrder"], Cell[CellGroupData[
             {Cell[BoxData[
                \(DiracOrder[\(t5, \({\[Delta], \[Beta], \[Alpha]}\)\)]\)], 
               "Input", CellTags -> "DiracOrder"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"-", RowBox[{SuperscriptBox[
                        "\[Gamma]", FormBox[FormBox["\[Delta]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Beta]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Alpha]", 
                          "TraditionalForm"], "TraditionalForm"]]}]}], "+", 
                   RowBox[{"2", " ", SuperscriptBox["\[Gamma]", FormBox[
                       FormBox["\[Delta]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", \(g\^\(\[Alpha]\[Beta]\)\)}]
                     , "-", RowBox[{"2", " ", SuperscriptBox["\[Gamma]", 
                      FormBox[FormBox["\[Beta]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", \(g\^\(\[Alpha]\[Delta]\)\)}]
                     , "+", RowBox[{"2", " ", SuperscriptBox["\[Gamma]", 
                      FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", \(g\^\(\[Beta]\[Delta]\)\)}]}
                     ], TraditionalForm]], "Output", CellTags -> 
                "DiracOrder"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracOrder[%]\)], "Input", CellTags -> "DiracOrder"], 
              Cell[BoxData[FormBox[RowBox[{SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Beta]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Delta]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "DiracOrder"]}, Open]], Cell[BoxData[
             \(\(Clear[\(t1, t2, t3, t4, t5\)]\) ;\)], "Input", 
            CellTags -> "DiracOrder"]}, Open]], Cell["DiracReduce", 
         "ObjectName", CellTags -> "DiracReduce"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracReduce"], Cell["DiracReduce[exp] reduces all \
four-dimensional Dirac matrices in exp to the standard basis (S,P,V,A,T) \
using the Chisholm identity (see Chisholm). In the result the basic Dirac \
structures are wrapped with a head DiracBasis. I.e., S corresponds to \
DiracBasis[1], P : DiracBasis[DiracMatrix[5]], V: \
DiracBasis[DiracMatrix[mu]], A: DiracBasis[DiracMatrix[mu, 5]], T: \
DiracBasis[DiracSigma[DiracMatrix[mu, nu]]]. By default DiracBasis is \
substituted to Identity. Notice that the result of DiracReduce is given in \
the FeynCalcExternal-way, i.e.,evtl. you may have to use FeynCalcInternal on \
the result.", "Text", CellTags -> "DiracReduce"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[DiracReduce]\)], 
               "Input", CellTags -> "DiracReduce"], Cell[BoxData[
                \(TraditionalForm\`\({\(Factoring \[Rule] False\), 
                      \(FinalSubstitutions \[Rule] 
                        \({DiracBasis \[Rule] Identity}\)\)}\)\)], "Output", 
               CellTags -> "DiracReduce"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], "."}], "Text", 
            CellTags -> "DiracReduce"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracReduce"], Cell[CellGroupData[{Cell[BoxData[
                \(t1\ =\ \(GA[\(\[Mu], \[Nu]\)]\)\)], "Input", CellTags -> 
                "DiracReduce"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu]\)\)], 
               "Output", CellTags -> "DiracReduce"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracReduce[t1]\)], "Input", 
               CellTags -> "DiracReduce"], Cell[BoxData[
                \(TraditionalForm\`\(g\^\(\[Mu]\[Nu]\) - 
                     \(\[ImaginaryI]\ \[Sigma]\^\(\[Mu]\[Nu]\)\)\)\)], 
               "Output", CellTags -> "DiracReduce"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t2 = \(DiracMatrix[\(\[Mu], \[Nu], \[Rho]\)]\)\)], "Input", 
               CellTags -> "DiracReduce"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] \[Gamma]\^\[Nu] 
                     \[Gamma]\^\[Rho]\)\)], "Output", CellTags -> 
                "DiracReduce"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracReduce[t2]\)], "Input", CellTags -> "DiracReduce"], 
              Cell[BoxData[FormBox[RowBox[{RowBox[{"\[ImaginaryI]", " ", 
                     \(\[Gamma]\^\($MU \[InvisibleApplication] \((1)\)\) . 
                        \[Gamma]\^5\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{"\[Mu]", "\[Nu]", "\[Rho]", FormBox[
                         \($MU \[InvisibleApplication] \((1)\)\), 
                         "TraditionalForm"]}]]}], "+", 
                   \(\[Gamma]\^\[Rho]\ g\^\(\[Mu]\[Nu]\)\), "-", 
                   \(\[Gamma]\^\[Nu]\ g\^\(\[Mu]\[Rho]\)\), "+", 
                   \(\[Gamma]\^\[Mu]\ g\^\(\[Nu]\[Rho]\)\)}], 
                 TraditionalForm]], "Output", CellTags -> "DiracReduce"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t3 = \(DiracMatrix[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\)\)]\
, "Input", CellTags -> "DiracReduce"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] \[Gamma]\^\[Nu] 
                     \[Gamma]\^\[Rho] \[Gamma]\^\[Sigma]\)\)], "Output", 
               CellTags -> "DiracReduce"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(t4 = \(DiracReduce[t3]\)\)], 
               "Input", CellTags -> "DiracReduce"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(-\[ImaginaryI]\)\ \[Gamma]\^5\ 
                       \[Epsilon]\^\(\[Mu]\[Nu]\[Rho]\[Sigma]\)\) - 
                     \(\[ImaginaryI]\ \[Sigma]\^\(\[Rho]\[Sigma]\)\ 
                       g\^\(\[Mu]\[Nu]\)\) + 
                     \(\[ImaginaryI]\ \[Sigma]\^\(\[Nu]\[Sigma]\)\ 
                       g\^\(\[Mu]\[Rho]\)\) - 
                     \(\[ImaginaryI]\ \[Sigma]\^\(\[Nu]\[Rho]\)\ 
                       g\^\(\[Mu]\[Sigma]\)\) - 
                     \(\[ImaginaryI]\ \[Sigma]\^\(\[Mu]\[Sigma]\)\ 
                       g\^\(\[Nu]\[Rho]\)\) + 
                     \(g\^\(\[Mu]\[Sigma]\)\ g\^\(\[Nu]\[Rho]\)\) + 
                     \(\[ImaginaryI]\ \[Sigma]\^\(\[Mu]\[Rho]\)\ 
                       g\^\(\[Nu]\[Sigma]\)\) - 
                     \(g\^\(\[Mu]\[Rho]\)\ g\^\(\[Nu]\[Sigma]\)\) - 
                     \(\[ImaginaryI]\ \[Sigma]\^\(\[Mu]\[Nu]\)\ 
                       g\^\(\[Rho]\[Sigma]\)\) + 
                     \(g\^\(\[Mu]\[Nu]\)\ g\^\(\[Rho]\[Sigma]\)\)\)\)], 
               "Output", CellTags -> "DiracReduce"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t5\ = \(Calc[\(DiracSimplify[
                       \(DiracSigmaExplicit[\(t4 . t4\)]\)]\)]\)\)], "Input", 
               CellTags -> "DiracReduce"], Cell[BoxData[
                \(TraditionalForm\`\(-128\)\)], "Output", CellTags -> 
                "DiracReduce"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Calc[\(t4 . t4\)]\)], "Input", CellTags -> "DiracReduce"], 
              Cell[BoxData[\(TraditionalForm\`\(-128\)\)], "Output", 
               CellTags -> "DiracReduce"]}, Open]], Cell[BoxData[
             \(Clear[\(t1, t2, t3, t4\)]\)], "Input", CellTags -> 
             "DiracReduce"]}, Open]], Cell["DiracSigma", "ObjectName", 
         CellTags -> "DiracSigma"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "DiracSigma"], 
           Cell["DiracSigma[a, b] stands for i/2*(a . b - b . a) in 4 \
dimensions. a and b must have Head DiracGamma, DiracMatrix or DiracSlash. \
Only antisymmetry is implemented.", "Text", CellTags -> "DiracSigma"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracSigmaExplicit", 
                RuleDelayed[ButtonData, "DiracSigmaExplicit"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSigmaExplicit"]], "."}], "Text", 
            CellTags -> "DiracSigma"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracSigma"], Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(DiracSigma[\(\(GA[\[Alpha]]\), \(GA[\[Beta]]\)\)]\)
                  \)], "Input", CellTags -> "DiracSigma"], Cell[BoxData[
                \(TraditionalForm\`\(\[Sigma]\^\(\[Alpha]\[Beta]\)\)\)], 
               "Output", CellTags -> "DiracSigma"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracSigmaExplicit[t1]\)], 
               "Input", CellTags -> "DiracSigma"], Cell[BoxData[
                FormBox[RowBox[{\(1\/2\), " ", "\[ImaginaryI]", " ", 
                   RowBox[{"(", RowBox[{RowBox[{SuperscriptBox["\[Gamma]", 
                          FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox["\[Beta]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                       RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Beta]", "TraditionalForm"], "TraditionalForm"]], 
                         ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Alpha]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracSigma"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t2 = \(DiracSigma[\(\(GA[\[Beta]]\), \(GA[\[Alpha]]\)\)]\)
                  \)], "Input", CellTags -> "DiracSigma"], Cell[BoxData[
                \(TraditionalForm\`\(-\[Sigma]\^\(\[Alpha]\[Beta]\)\)\)], 
               "Output", CellTags -> "DiracSigma"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t3 = \(DiracSigma[\(\(GS[p]\), \(GS[q]\)\)]\)\)], "Input", 
               CellTags -> "DiracSigma"], Cell[BoxData[
                \(TraditionalForm\`\(\[Sigma]\^\(pq\)\)\)], "Output", 
               CellTags -> "DiracSigma"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracSigmaExplicit[t3]\)], 
               "Input", CellTags -> "DiracSigma"], Cell[BoxData[
                FormBox[RowBox[{\(1\/2\), " ", "\[ImaginaryI]", " ", 
                   RowBox[{"(", RowBox[{RowBox[{RowBox[{"(", RowBox[
                          {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], ".", RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["q", "TraditionalForm"]}], ")"}]}], "-", 
                       RowBox[{RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], ".", RowBox[{"(", 
                          RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}]}]}], ")"}]}], TraditionalForm]], "Output", 
               CellTags -> "DiracSigma"]}, Open]], Cell[BoxData[
             \(Clear[\(t1, t2, t3\)]\)], "Input", CellTags -> "DiracSigma"]}, 
          Open]], Cell["DiracSigmaExplicit", "ObjectName", 
         CellTags -> "DiracSigmaExplicit"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracSigmaExplicit"], Cell["DiracSigmaExplicit[exp] \
inserts in exp for all DiracSigma its definition. DiracSigmaExplict is also \
an option of DiracSimplify.", "Text", CellTags -> "DiracSigmaExplicit"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracSigma", RuleDelayed[ButtonData, "DiracSigma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSigma"]], "."}], "Text", 
            CellTags -> "DiracSigmaExplicit"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracSigmaExplicit"], Cell[CellGroupData[
             {Cell[BoxData[
                \(DiracSigma[\(\(GA[\[Alpha]]\), \(GA[\[Beta]]\)\)]\)], 
               "Input", CellTags -> "DiracSigmaExplicit"], Cell[BoxData[
                \(TraditionalForm\`\(\[Sigma]\^\(\[Alpha]\[Beta]\)\)\)], 
               "Output", CellTags -> "DiracSigmaExplicit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracSigmaExplicit[%]\)], 
               "Input", CellTags -> "DiracSigmaExplicit"], Cell[BoxData[
                FormBox[RowBox[{\(1\/2\), " ", "\[ImaginaryI]", " ", 
                   RowBox[{"(", RowBox[{RowBox[{SuperscriptBox["\[Gamma]", 
                          FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox["\[Beta]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                       RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Beta]", "TraditionalForm"], "TraditionalForm"]], 
                         ".", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          "\[Alpha]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "DiracSigmaExplicit"]}, Open]]}, Open]], 
        Cell["DiracSimpCombine", "ObjectName", CellTags -> 
          "DiracSimpCombine"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "DiracSimpCombine"], Cell["DiracSimpCombine is an option for \
DiracSimplify. If set to True, sums of DiracGamma's will be merged as much as \
possible in DiracGamma[ .. + .. + ]'s.", "Text", CellTags -> 
             "DiracSimpCombine"], Cell[TextData[{"See also: ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], "."}], "Text", 
            CellTags -> "DiracSimpCombine"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["DiracSimplify", "ObjectName", 
         CellTags -> "DiracSimplify"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "DiracSimplify"], 
           Cell["DiracSimplify[expr] simplifies products of Dirac matrices in \
expr and expands non-commutative products. Double Lorentz indices and four \
vectors are contracted. The Dirac equation is applied. All DiracMatrix[5], \
DiracMatrix[6] and DiracMatrix[7] are moved to the right. The order of the \
other Dirac matrices is not changed.", "Text", CellTags -> "DiracSimplify"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[DiracSimplify]\)], 
               "Input", CellTags -> "DiracSimplify"], Cell[BoxData[
                \(TraditionalForm\`\({\(DiracCanonical \[Rule] False\), 
                      \(DiracSigmaExplicit \[Rule] True\), 
                      \(DiracSimpCombine \[Rule] False\), 
                      \(DiracSubstitute67 \[Rule] False\), 
                      \(Expanding \[Rule] True\), \(Factoring \[Rule] False\)
                      , \(FeynCalcInternal \[Rule] False\), 
                      \(InsideDiracTrace \[Rule] False\)}\)\)], "Output", 
               CellTags -> "DiracSimplify"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Calc", RuleDelayed[ButtonData, "Calc"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Calc"]], 
              ", ", 
              ButtonBox["DiracGammaExpand", 
                RuleDelayed[ButtonData, "DiracGammaExpand"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGammaExpand"]], ", ", 
              ButtonBox["DiracTrick", RuleDelayed[ButtonData, "DiracTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrick"]], "."}], "Text", 
            CellTags -> "DiracSimplify"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracSimplify"], 
           Cell["This is a string of Dirac matrices in four dimensions. ", 
            "Text", CellTags -> "DiracSimplify"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(GA[\(\[Mu], \[Nu], \[Mu]\)]\)\)], "Input", 
               CellTags -> "DiracSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . 
                     \[Gamma]\^\[Mu]\)\)], "Output", CellTags -> 
                "DiracSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracSimplify[t1]\)], "Input", CellTags -> 
                "DiracSimplify"], Cell[BoxData[FormBox[RowBox[{\(-2\), " ", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracSimplify"]}, 
             Open]], Cell[
            "This is a string of Dirac matrices in D dimensions. ", "Text", 
            CellTags -> "DiracSimplify"], Cell[CellGroupData[{Cell[BoxData[
                \(t2 = \(GAD[\(\[Mu], \[Nu], \[Mu]\)]\)\)], "Input", 
               CellTags -> "DiracSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . 
                     \[Gamma]\^\[Mu]\)\)], "Output", CellTags -> 
                "DiracSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracSimplify[t1]\)], "Input", CellTags -> 
                "DiracSimplify"], Cell[BoxData[FormBox[RowBox[{\(-2\), " ", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracSimplify"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t3 = \(GA[\(5, \[Mu], \[Nu]\)]\)\)], "Input", CellTags -> 
                "DiracSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5 . \[Gamma]\^\[Mu] . 
                     \[Gamma]\^\[Nu]\)\)], "Output", CellTags -> 
                "DiracSimplify"]}, Open]], Cell[TextData[{"By default ", 
              Cell[BoxData[\(TraditionalForm\`\(\[Gamma]\^5\)\)]], 
              "is moved to the right."}], "Text", CellTags -> 
             "DiracSimplify"], Cell[CellGroupData[{Cell[BoxData[
                \(DiracSimplify[t3]\)], "Input", CellTags -> 
                "DiracSimplify"], Cell[BoxData[FormBox[RowBox[
                  {SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(\[Gamma]\^5\)}], TraditionalForm]], "Output", 
               CellTags -> "DiracSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(t4 = \(GA[\(6, \[Mu], 7\)]\)\)]
                , "Input", CellTags -> "DiracSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^6 . \[Gamma]\^\[Mu] . 
                     \[Gamma]\^7\)\)], "Output", CellTags -> 
                "DiracSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracSimplify[t4]\)], "Input", CellTags -> 
                "DiracSimplify"], Cell[BoxData[FormBox[RowBox[
                  {SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(\[Gamma]\^7\)}], TraditionalForm]], "Output", 
               CellTags -> "DiracSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t5 = \(\(GS[\(a + b\)]\)\ .\ \(GS[p]\) . \(GS[p]\) . 
                     \(GS[\(c + d\)]\)\)\)], "Input", CellTags -> 
                "DiracSimplify"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"(", RowBox[{"\[Gamma]", "\[CenterDot]", "(", 
                       FormBox[\(a + b\), "TraditionalForm"], ")"}], ")"}], 
                   ".", \((\[Gamma] \[CenterDot] p)\), ".", 
                   \((\[Gamma] \[CenterDot] p)\), ".", RowBox[{"(", 
                     RowBox[{"\[Gamma]", "\[CenterDot]", "(", FormBox[
                        \(c + d\), "TraditionalForm"], ")"}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracSimplify"]}, 
             Open]], Cell["Contrary to DiracTrick DiracSimplify does \
non-commutative expansion.", "Text", CellTags -> "DiracSimplify"], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracSimplify[t5]\)], "Input", 
               CellTags -> "DiracSimplify"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["a", "TraditionalForm"]}], ")"}], ".", 
                       RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["c", 
                          "TraditionalForm"]}], ")"}]}], " ", SuperscriptBox[
                      FormBox["p", "TraditionalForm"], "2"]}], "+", 
                   RowBox[{RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["a", "TraditionalForm"]}], ")"}], ".", 
                       RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["d", 
                          "TraditionalForm"]}], ")"}]}], " ", SuperscriptBox[
                      FormBox["p", "TraditionalForm"], "2"]}], "+", 
                   RowBox[{RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["b", "TraditionalForm"]}], ")"}], ".", 
                       RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["c", 
                          "TraditionalForm"]}], ")"}]}], " ", SuperscriptBox[
                      FormBox["p", "TraditionalForm"], "2"]}], "+", 
                   RowBox[{RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["b", "TraditionalForm"]}], ")"}], ".", 
                       RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["d", 
                          "TraditionalForm"]}], ")"}]}], " ", SuperscriptBox[
                      FormBox["p", "TraditionalForm"], "2"]}]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracSimplify"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(DiracTrick[t5]\)], 
               "Input", CellTags -> "DiracSimplify"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                         "(", FormBox[\(a + b\), "TraditionalForm"], ")"}], 
                       ")"}], ".", RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                         "(", FormBox[\(c + d\), "TraditionalForm"], ")"}], 
                       ")"}]}], " ", SuperscriptBox[FormBox["p", 
                     "TraditionalForm"], "2"]}], TraditionalForm]], "Output", 
               CellTags -> "DiracSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t6\ =\ \(\(SpinorVBar[p]\)\ .\ \(GS[p]\)\ .\ 
                     \(SpinorUBar[q]\)\)\)], "Input", CellTags -> 
                "DiracSimplify"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{FormBox[\("v"\&_\), "TraditionalForm"], "(", "p", 
                     ")"}], ".", \((\[Gamma] \[CenterDot] p)\), ".", 
                   RowBox[{FormBox[\("u"\&_\), "TraditionalForm"], "(", "q", 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "DiracSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracSimplify[t6]\)], "Input", CellTags -> 
                "DiracSimplify"], Cell[BoxData[\(TraditionalForm\`0\)], 
               "Output", CellTags -> "DiracSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(GAD @@ \(Join[\(\({\[Mu]}\), 
                       \(Table[\(\[Nu]\_i, \({i, 6}\)\)]\), \({\[Mu]}\)\)]\)\
\)], "Input", CellTags -> "DiracSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\(\[Nu]\_1\)
                      . \[Gamma]\^\(\[Nu]\_2\) . \[Gamma]\^\(\[Nu]\_3\) . 
                     \[Gamma]\^\(\[Nu]\_4\) . \[Gamma]\^\(\[Nu]\_5\) . 
                     \[Gamma]\^\(\[Nu]\_6\) . \[Gamma]\^\[Mu]\)\)], "Output", 
               CellTags -> "DiracSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracSimplify[%]\)], "Input", 
               CellTags -> "DiracSimplify"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{"D", " ", RowBox[{SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_1\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_2\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_3\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_4\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_5\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_6\), "TraditionalForm"], 
                         "TraditionalForm"]]}]}], "-", RowBox[{"12", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_2\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_3\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_4\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_5\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_6\), "TraditionalForm"], 
                         "TraditionalForm"]]}]}], "+", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_3\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_4\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_5\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_6\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_1 \[Nu]\_2\)\)}], "-", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_2\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_4\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_5\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_6\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_1 \[Nu]\_3\)\)}], "+", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_2\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_3\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_5\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_6\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_1 \[Nu]\_4\)\)}], "-", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_2\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_3\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_4\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_6\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_1 \[Nu]\_5\)\)}], "+", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_2\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_3\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_4\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_5\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_1 \[Nu]\_6\)\)}], "+", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_4\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_5\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_6\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_2 \[Nu]\_3\)\)}], "-", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_3\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_5\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_6\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_2 \[Nu]\_4\)\)}], "+", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_3\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_4\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_6\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_2 \[Nu]\_5\)\)}], "-", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_3\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_4\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_5\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_2 \[Nu]\_6\)\)}], "+", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_2\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_5\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_6\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_3 \[Nu]\_4\)\)}], "-", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_2\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_4\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_6\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_3 \[Nu]\_5\)\)}], "+", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_2\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_4\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_5\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_3 \[Nu]\_6\)\)}], "+", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_2\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_3\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_6\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_4 \[Nu]\_5\)\)}], "-", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_2\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_3\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_5\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_4 \[Nu]\_6\)\)}], "+", RowBox[{"4", " ", 
                     RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_2\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_3\), "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox[\(\[Nu]\_4\), "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", 
                     \(g\^\(\[Nu]\_5 \[Nu]\_6\)\)}]}], TraditionalForm]], 
               "Output", CellTags -> "DiracSimplify"]}, Open]], 
           Cell[
            " With the option DiracCanonical an alphabetic ordering is done."\
, "Text", CellTags -> "DiracSimplify"], Cell[CellGroupData[{Cell[BoxData[
                \(DiracSimplify[\(\(GA[\(\[Nu], \[Mu]\)]\), 
                     \(DiracCanonical \[Rule] True\)\)]\)], "Input", 
               CellTags -> "DiracSimplify"], Cell[BoxData[FormBox[RowBox[{
                   \(2\ g\^\(\[Mu]\[Nu]\)\), "-", RowBox[{SuperscriptBox[
                      "\[Gamma]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"]]}]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracSimplify"]}, 
             Open]], Cell["Setting InsideDiracTrace\[Rule]True assumes that a \
trace is still to be taken later on.", "Text", CellTags -> "DiracSimplify"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DiracSimplify[\(\(GA[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\),
                      \(InsideDiracTrace \[Rule] True\)\)]\)], "Input", 
               CellTags -> "DiracSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\(g\^\(\[Mu]\[Sigma]\)\ 
                       g\^\(\[Nu]\[Rho]\)\) - 
                     \(g\^\(\[Mu]\[Rho]\)\ g\^\(\[Nu]\[Sigma]\)\) + 
                     \(g\^\(\[Mu]\[Nu]\)\ g\^\(\[Rho]\[Sigma]\)\)\)\)], 
               "Output", CellTags -> "DiracSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DiracSimplify[\(\(GA[\(\[Mu], \[Nu], \[Rho]\)]\), 
                     \(InsideDiracTrace \[Rule] True\)\)]\)], "Input", 
               CellTags -> "DiracSimplify"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> 
                "DiracSimplify"]}, Open]], Cell[BoxData[
             \(Clear[\(t1, t2, t3, t4, t5, t6\)]\)], "Input", 
            CellTags -> "DiracSimplify"]}, Open]], Cell["DiracSimplify2", 
         "ObjectName", CellTags -> "DiracSimplify2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracSimplify2"], Cell[TextData[{"DiracSimplify2[exp\
] simplifies the Dirac structure but leaves any ", Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5\)\)]], " untouched."}], 
            "Text", CellTags -> "DiracSimplify2"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], "."}], "Text", 
            CellTags -> "DiracSimplify2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracSimplify2"], Cell[CellGroupData[{Cell[BoxData[
                \(GAD[\(\[Mu], \[Nu], \[Mu], 5, \[Alpha], \[Beta], \[Alpha]\)
                   ]\)], "Input", CellTags -> "DiracSimplify2"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . 
                     \[Gamma]\^\[Mu] . \[Gamma]\^5 . \[Gamma]\^\[Alpha] . 
                     \[Gamma]\^\[Beta] . \[Gamma]\^\[Alpha]\)\)], "Output", 
               CellTags -> "DiracSimplify2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracSimplify2[%]\)], "Input", 
               CellTags -> "DiracSimplify2"], Cell[BoxData[FormBox[
                 RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(\[Gamma]\^5\), ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Beta]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "DiracSimplify2"]}, Open]]}, Open]], 
        Cell["DiracSlash", "ObjectName", CellTags -> "DiracSlash"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracSlash"], Cell[TextData[
             {"DiracSlash[p] is the contraction ", Cell[BoxData[
                \(TraditionalForm\`\(p\^\[Mu] \[Gamma]\_\(\[Mu]\ \)\)\)]], 
              "(FourVector[p, ", Cell[BoxData[\(TraditionalForm\`\[Mu]\)]], 
              "] DiracMatrix[", Cell[BoxData[\(TraditionalForm\`\[Mu]\)]], "]\
). Products of those can be entered in the form DiracSlash[p1, p2, ...]."}], 
            "Text", CellTags -> "DiracSlash"], Cell[CellGroupData[
             {Cell[BoxData[\(Options[DiracSlash]\)], "Input", CellTags -> 
                "DiracSlash"], Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] 4\), 
                      \(FeynCalcInternal \[Rule] False\)}\)\)], "Output", 
               CellTags -> "DiracSlash"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracGammaExpand", 
                RuleDelayed[ButtonData, "DiracGammaExpand"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGammaExpand"]], ", ", 
              ButtonBox["DiracGamma", RuleDelayed[ButtonData, "DiracGamma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGamma"]], ", ", 
              ButtonBox["DiracMatrix", RuleDelayed[ButtonData, 
                 "DiracMatrix"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracMatrix"]], ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["DiracTrick", RuleDelayed[ButtonData, "DiracTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrick"]], ", ", 
              ButtonBox["GS", RuleDelayed[ButtonData, "GS"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GS"]], 
              ", ", 
              ButtonBox["GSD", RuleDelayed[ButtonData, "GSD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GSD"]], 
              "."}], "Text", CellTags -> "DiracSlash"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracSlash"], Cell[TextData[
             {"This is q-slash, i.e., ", Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] \(q\_\[Mu] .\)\)\)]]}], 
            "Text", CellTags -> "DiracSlash"], Cell[CellGroupData[
             {Cell[BoxData[\(DiracSlash[q]\)], "Input", CellTags -> 
                "DiracSlash"], Cell[BoxData[FormBox[RowBox[
                  {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                   "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracSlash"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(DiracSlash[p]\) . \(DiracSlash[q]\)\)], "Input", 
               CellTags -> "DiracSlash"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                        "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                        "TraditionalForm"]}], ")"}], ".", RowBox[{"(", 
                     RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "DiracSlash"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracSlash[\(p, q\)]\)], "Input", CellTags -> 
                "DiracSlash"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                        "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                        "TraditionalForm"]}], ")"}], ".", RowBox[{"(", 
                     RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "DiracSlash"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(GS[p]\)], "Input", CellTags -> "DiracSlash"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma] \[CenterDot] p\)\)], "Output", 
               CellTags -> "DiracSlash"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(DiracSlash[q]\)//StandardForm\)], "Input", CellTags -> 
                "DiracSlash"], Cell[BoxData[\(DiracSlash[q]\)], "Output", 
               CellTags -> "DiracSlash"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(DiracSlash[\(q, \(Dimension \[Rule] n\)\)]\)//
                   StandardForm\)], "Input", CellTags -> "DiracSlash"], 
              Cell[BoxData[\(DiracSlash[\(q, \(Dimension \[Rule] n\)\)]\)], 
               "Output", CellTags -> "DiracSlash"]}, Open]]}, Open]], 
        Cell["DiracSpinor", "ObjectName", CellTags -> "DiracSpinor"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracSpinor"], Cell["DiracSpinor is simply a \
quantity defined as noncommutative (with DeclareNonCommutative[DiracSpinor]). \
The convention intended is that DiracSpinor[p, m, ind] is a Dirac spinor for \
a fermion with momentum p and mass m and indices ind.", "Text", 
            CellTags -> "DiracSpinor"], Cell[TextData[{"See also: ", 
              ButtonBox["Spinor", RuleDelayed[ButtonData, "Spinor"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Spinor"]], 
              "."}], "Text", CellTags -> "DiracSpinor"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["DiracSubstitute67", "ObjectName", 
         CellTags -> "DiracSubstitute67"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracSubstitute67"], Cell["DiracSubstitute67 is an \
option for DiracSimplify. If set to True the chirality-projectors \
DiracGamma[6] and DiracGamma[7] are substituted by their definitions.", 
            "Text", CellTags -> "DiracSubstitute67"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["DiracGamma", RuleDelayed[ButtonData, "DiracGamma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGamma"]], ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], "."}], "Text", 
            CellTags -> "DiracSubstitute67"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["DiracTrace", "ObjectName", CellTags -> "DiracTrace"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracTrace"], Cell["DiracTrace[expr] is the head of \
Dirac traces. Whether the trace is evaluated depends on the option \
DiracTraceEvaluate. Direct trace evaluation should be performed with TR (or \
Tr). The argument expr may be a product of Dirac matrices or slashes \
separated by the Mathematica Dot (.).", "Text", CellTags -> "DiracTrace"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[DiracTrace]\)], 
               "Input", CellTags -> "DiracTrace"], Cell[BoxData[
                \(TraditionalForm\`\({\(EpsContract \[Rule] False\), 
                      \(Factoring \[Rule] False\), 
                      \(FeynCalcExternal \[Rule] False\), 
                      \(Mandelstam \[Rule] \({}\)\), 
                      \(PairCollect \[Rule] True\), 
                      \(DiracTraceEvaluate \[Rule] False\), 
                      \(Schouten \[Rule] 0\), 
                      \(LeviCivitaSign \[RuleDelayed] $LeviCivitaSign\), 
                      \(TraceOfOne \[Rule] 4\)}\)\)], "Output", CellTags -> 
                "DiracTrace"]}, Open]], Cell[TextData[
             {"For comments regarding ", Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5\)\)]], 
              "schemes see the notes for ", 
              ButtonBox["TR", RuleDelayed[ButtonData, "TR"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TR"]], 
              "."}], "Text", CellTags -> "DiracTrace"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["TR", RuleDelayed[ButtonData, "TR"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TR"]], 
              "."}], "Text", CellTags -> "DiracTrace"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracTrace"], Cell[CellGroupData[{Cell[BoxData[
                \(DiracTrace[\(GA[\(\[Mu], \[Nu]\)]\)]\)], "Input", 
               CellTags -> "DiracTrace"], Cell[BoxData[FormBox[RowBox[
                  {"tr", "(", FormBox[\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu]\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "DiracTrace"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DiracTrace[\(GA[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\)]\)], 
               "Input", CellTags -> "DiracTrace"], Cell[BoxData[
                FormBox[RowBox[{"tr", "(", FormBox[
                    \(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . \[Gamma]\^\[Rho] . 
                       \[Gamma]\^\[Sigma]\), "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> "DiracTrace"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%\ /.\ \(DiracTrace \[Rule] Tr\)\)], "Input", CellTags -> 
                "DiracTrace"], Cell[BoxData[
                \(TraditionalForm\`\(4\ \(
                      (\(g\^\(\[Mu]\[Sigma]\)\ g\^\(\[Nu]\[Rho]\)\) - 
                        \(g\^\(\[Mu]\[Rho]\)\ g\^\(\[Nu]\[Sigma]\)\) + 
                        \(g\^\(\[Mu]\[Nu]\)\ g\^\(\[Rho]\[Sigma]\)\))\)\)\)], 
               "Output", CellTags -> "DiracTrace"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DiracTrace[\(\(GA[\(\[Mu], \[Nu], \[Rho], \[Sigma], 5\)]\),
                      \(DiracTraceEvaluate \[Rule] True\)\)]\)], "Input", 
               CellTags -> "DiracTrace"], Cell[BoxData[FormBox[RowBox[{\(-4\)
                   , " ", "\[ImaginaryI]", " ", SuperscriptBox["\[Epsilon]", 
                    RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"]}]]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracTrace"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracTrace[\(\(GA[\(\[Mu], \[Nu], \[Rho], \[Sigma], 
                         \[Delta], \[Tau], 5\)]\), 
                     \(DiracTraceEvaluate \[Rule] True\)\)]\)], "Input", 
               CellTags -> "DiracTrace"], Cell[BoxData[FormBox[RowBox[
                  {"4", " ", RowBox[{"(", RowBox[{RowBox[{"\[ImaginaryI]", 
                         " ", SuperscriptBox["\[Epsilon]", RowBox[{FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Tau]", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         \(g\^\(\[Delta]\[Mu]\)\)}], "-", RowBox[
                        {"\[ImaginaryI]", " ", SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Delta]\[Nu]\)\)
                         }], "+", RowBox[{"\[ImaginaryI]", " ", 
                         SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", 
                         \(g\^\(\[Delta]\[Rho]\)\)}], "-", RowBox[
                        {"\[ImaginaryI]", " ", SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", 
                         \(g\^\(\[Delta]\[Sigma]\)\)}], "-", RowBox[
                        {"\[ImaginaryI]", " ", SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", 
                         \(g\^\(\[Delta]\[Tau]\)\)}], "-", RowBox[
                        {"\[ImaginaryI]", " ", SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox[FormBox["\[Delta]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Mu]\[Nu]\)\)}]
                         , "+", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Delta]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Mu]\[Rho]\)\)}]
                         , "-", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Delta]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Mu]\[Sigma]\)\)
                         }], "+", RowBox[{"\[ImaginaryI]", " ", 
                         SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Delta]", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Mu]\[Tau]\)\)}]
                         , "-", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Delta]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Nu]\[Rho]\)\)}]
                         , "+", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Delta]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Nu]\[Sigma]\)\)
                         }], "-", RowBox[{"\[ImaginaryI]", " ", 
                         SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Delta]", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Nu]\[Tau]\)\)}]
                         , "-", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Delta]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", 
                         \(g\^\(\[Rho]\[Sigma]\)\)}], "+", RowBox[
                        {"\[ImaginaryI]", " ", SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox[FormBox["\[Delta]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Rho]\[Tau]\)\)}
                         ], "-", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Delta]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", 
                         \(g\^\(\[Sigma]\[Tau]\)\)}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracTrace"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracTrace[\(GS[\(p, q, r, s\)]\)]\)], "Input", CellTags -> 
                "DiracTrace"], Cell[BoxData[FormBox[RowBox[{"tr", "(", 
                   FormBox[
                    \(\((\[Gamma] \[CenterDot] p)\) . 
                       \((\[Gamma] \[CenterDot] q)\) . 
                       \((\[Gamma] \[CenterDot] r)\) . 
                       \((\[Gamma] \[CenterDot] s)\)\), "TraditionalForm"], 
                   ")"}], TraditionalForm]], "Output", CellTags -> 
                "DiracTrace"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracTrace[\(\(GA[\(\[Mu], \[Nu]\)]\), 
                     \(DiracTraceEvaluate \[Rule] True\), 
                     \(FCE \[Rule] True\)\)]\)], "Input", CellTags -> 
                "DiracTrace"], Cell[BoxData[
                \(TraditionalForm\`\(4\ g\^\(\[Mu]\[Nu]\)\)\)], "Output", 
               CellTags -> "DiracTrace"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "DiracTrace"], Cell[BoxData[
                \(4\ \(MT[\(\[Mu], \[Nu]\)]\)\)], "Output", CellTags -> 
                "DiracTrace"]}, Open]]}, Open]], Cell["DiracTraceEvaluate", 
         "ObjectName", CellTags -> "DiracTraceEvaluate"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracTraceEvaluate"], Cell["DiracTraceEvaluate is an \
option for DiracTrace and Tr. If set to False, DiracTrace remains \
unevaluated.", "Text", CellTags -> "DiracTraceEvaluate"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["DiracTrace", RuleDelayed[ButtonData, "DiracTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrace"]], ", ", 
              ButtonBox["TR", RuleDelayed[ButtonData, "TR"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TR"]], 
              "."}], "Text", CellTags -> "DiracTraceEvaluate"], 
           Cell[BoxData[""], "Input"]}, Open]], Cell["DiracTrick", 
         "ObjectName", CellTags -> "DiracTrick"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DiracTrick"], Cell["DiracTrick[exp] contracts gamma \
matrices with each other and performs several simplifications, but no \
expansion, use Calc or DiracSimplify for non-commutative expansion.", "Text", 
            CellTags -> "DiracTrick"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[DiracTrick]\)], "Input", CellTags -> "DiracTrick"], 
              Cell[BoxData[\(TraditionalForm\`\({Expanding \[Rule] False}\)\)]
                , "Output", CellTags -> "DiracTrick"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Calc", RuleDelayed[ButtonData, "Calc"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Calc"]], 
              ", ", 
              ButtonBox["DiracGammaExpand", 
                RuleDelayed[ButtonData, "DiracGammaExpand"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGammaExpand"]], ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], "."}], "Text", 
            CellTags -> "DiracTrick"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DiracTrick"], 
           Cell["This is a string of Dirac matrices in four dimensions. ", 
            "Text", CellTags -> "DiracTrick"], Cell[CellGroupData[
             {Cell[BoxData[\(t1 = \(GA[\(\[Mu], \[Nu], \[Mu]\)]\)\)], 
               "Input", CellTags -> "DiracTrick"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . 
                     \[Gamma]\^\[Mu]\)\)], "Output", CellTags -> 
                "DiracTrick"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracTrick[t1]\)], "Input", CellTags -> "DiracTrick"], 
              Cell[BoxData[FormBox[RowBox[{\(-2\), " ", SuperscriptBox[
                    "\[Gamma]", FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "DiracTrick"]}, Open]], 
           Cell["This is a string of Dirac matrices in D dimensions. ", 
            "Text", CellTags -> "DiracTrick"], Cell[CellGroupData[
             {Cell[BoxData[\(t2 = \(GAD[\(\[Mu], \[Nu], \[Mu]\)]\)\)], 
               "Input", CellTags -> "DiracTrick"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . 
                     \[Gamma]\^\[Mu]\)\)], "Output", CellTags -> 
                "DiracTrick"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracTrick[t2]\)], "Input", CellTags -> "DiracTrick"], 
              Cell[BoxData[FormBox[RowBox[{\((2 - D)\), " ", SuperscriptBox[
                    "\[Gamma]", FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "DiracTrick"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t3 = \(GA[\(5, \[Mu], \[Nu]\)]\)\)], "Input", CellTags -> 
                "DiracTrick"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5 . \[Gamma]\^\[Mu] . 
                     \[Gamma]\^\[Nu]\)\)], "Output", CellTags -> 
                "DiracTrick"]}, Open]], Cell[TextData[{"By default ", 
              Cell[BoxData[\(TraditionalForm\`\(\[Gamma]\^5\)\)]], 
              "is moved to the right."}], "Text", CellTags -> "DiracTrick"], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracTrick[t3]\)], "Input", 
               CellTags -> "DiracTrick"], Cell[BoxData[FormBox[RowBox[
                  {SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(\[Gamma]\^5\)}], TraditionalForm]], "Output", 
               CellTags -> "DiracTrick"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(t4 = \(GA[\(6, \[Mu], 7\)]\)\)]
                , "Input", CellTags -> "DiracTrick"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^6 . \[Gamma]\^\[Mu] . 
                     \[Gamma]\^7\)\)], "Output", CellTags -> "DiracTrick"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(DiracTrick[t4]\)], 
               "Input", CellTags -> "DiracTrick"], Cell[BoxData[
                FormBox[RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                      "\[Mu]", "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(\[Gamma]\^7\)}], TraditionalForm]], "Output", 
               CellTags -> "DiracTrick"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t5 = \(\(GS[\(a + b\)]\)\ .\ \(GS[p]\) . \(GS[p]\) . 
                     \(GS[\(c + d\)]\)\)\)], "Input", CellTags -> 
                "DiracTrick"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"(", RowBox[{"\[Gamma]", "\[CenterDot]", "(", 
                       FormBox[\(a + b\), "TraditionalForm"], ")"}], ")"}], 
                   ".", \((\[Gamma] \[CenterDot] p)\), ".", 
                   \((\[Gamma] \[CenterDot] p)\), ".", RowBox[{"(", 
                     RowBox[{"\[Gamma]", "\[CenterDot]", "(", FormBox[
                        \(c + d\), "TraditionalForm"], ")"}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracTrick"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(DiracTrick[t5]\)], 
               "Input", CellTags -> "DiracTrick"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                         "(", FormBox[\(a + b\), "TraditionalForm"], ")"}], 
                       ")"}], ".", RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                         "(", FormBox[\(c + d\), "TraditionalForm"], ")"}], 
                       ")"}]}], " ", SuperscriptBox[FormBox["p", 
                     "TraditionalForm"], "2"]}], TraditionalForm]], "Output", 
               CellTags -> "DiracTrick"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Calc[t5]\)], "Input", 
               CellTags -> "DiracTrick"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["a", "TraditionalForm"]}], ")"}], ".", 
                       RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["c", 
                          "TraditionalForm"]}], ")"}]}], " ", SuperscriptBox[
                      FormBox["p", "TraditionalForm"], "2"]}], "+", 
                   RowBox[{RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["a", "TraditionalForm"]}], ")"}], ".", 
                       RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["d", 
                          "TraditionalForm"]}], ")"}]}], " ", SuperscriptBox[
                      FormBox["p", "TraditionalForm"], "2"]}], "+", 
                   RowBox[{RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["b", "TraditionalForm"]}], ")"}], ".", 
                       RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["c", 
                          "TraditionalForm"]}], ")"}]}], " ", SuperscriptBox[
                      FormBox["p", "TraditionalForm"], "2"]}], "+", 
                   RowBox[{RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["b", "TraditionalForm"]}], ")"}], ".", 
                       RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["d", 
                          "TraditionalForm"]}], ")"}]}], " ", SuperscriptBox[
                      FormBox["p", "TraditionalForm"], "2"]}]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracTrick"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(GAD @@ \(Join[\(\({\[Mu]}\), 
                       \(Table[\(\[Nu]\_i, \({i, 6}\)\)]\), \({\[Mu]}\)\)]\)\
\)], "Input", CellTags -> "DiracTrick"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\(\[Nu]\_1\)
                      . \[Gamma]\^\(\[Nu]\_2\) . \[Gamma]\^\(\[Nu]\_3\) . 
                     \[Gamma]\^\(\[Nu]\_4\) . \[Gamma]\^\(\[Nu]\_5\) . 
                     \[Gamma]\^\(\[Nu]\_6\) . \[Gamma]\^\[Mu]\)\)], "Output", 
               CellTags -> "DiracTrick"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(DiracTrick[%]\)], "Input", 
               CellTags -> "DiracTrick"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{\((D - 12)\), " ", RowBox[{SuperscriptBox[
                        "\[Gamma]", FormBox[FormBox[\(\[Nu]\_1\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox[\(\[Nu]\_2\)
                          , "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox[\(\[Nu]\_3\)
                          , "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox[\(\[Nu]\_4\)
                          , "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox[\(\[Nu]\_5\)
                          , "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox[\(\[Nu]\_6\)
                          , "TraditionalForm"], "TraditionalForm"]]}]}], "-", 
                   RowBox[{"4", " ", RowBox[{"(", RowBox[{RowBox[{RowBox[
                          {"-", RowBox[{SuperscriptBox["\[Gamma]", FormBox[
                          FormBox[\(\[Nu]\_3\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_4\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_5\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_6\), 
                          "TraditionalForm"], "TraditionalForm"]]}]}], " ", 
                          \(g\^\(\[Nu]\_1 \[Nu]\_2\)\)}], "+", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_2\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_4\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_5\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_6\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_1 \[Nu]\_3\)\)}], "-", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_2\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_3\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_5\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_6\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_1 \[Nu]\_4\)\)}], "+", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_2\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_3\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_4\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_6\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_1 \[Nu]\_5\)\)}], "-", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_2\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_3\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_4\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_5\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_1 \[Nu]\_6\)\)}], "-", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_4\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_5\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_6\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_2 \[Nu]\_3\)\)}], "+", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_3\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_5\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_6\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_2 \[Nu]\_4\)\)}], "-", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_3\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_4\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_6\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_2 \[Nu]\_5\)\)}], "+", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_3\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_4\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_5\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_2 \[Nu]\_6\)\)}], "-", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_2\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_5\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_6\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_3 \[Nu]\_4\)\)}], "+", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_2\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_4\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_6\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_3 \[Nu]\_5\)\)}], "-", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_2\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_4\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_5\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_3 \[Nu]\_6\)\)}], "-", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_2\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_3\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_6\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_4 \[Nu]\_5\)\)}], "+", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_2\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_3\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_5\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_4 \[Nu]\_6\)\)}], "-", RowBox[
                          {RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_1\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_2\), 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SuperscriptBox["\[Gamma]", FormBox[FormBox[
                          \(\[Nu]\_3\), "TraditionalForm"], 
                          "TraditionalForm"]], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox[\(\[Nu]\_4\), 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(g\^\(\[Nu]\_5 \[Nu]\_6\)\)}]}], ")"}]}]}], 
                 TraditionalForm]], "Output", CellTags -> "DiracTrick"]}, 
             Open]]}, Open]], Cell["Divideout", "ObjectName", 
         CellTags -> "Divideout"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Divideout"], 
           Cell["Divideout is an option for OPEInt and OPEIntegrate. The \
setting is divided out at the end.", "Text", CellTags -> "Divideout"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["OPEInt", RuleDelayed[ButtonData, "OPEInt"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OPEInt"]], 
              ", ", 
              ButtonBox["OPEIntegrate", 
                RuleDelayed[ButtonData, "OPEIntegrate"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OPEIntegrate"]], "."}], "Text", 
            CellTags -> "Divideout"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["DOT", "ObjectName", CellTags -> "DOT"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DOT"], Cell["DOT[a, b, ...] is the FeynCalc function \
for non-commutative multiplication. By default it is set to the Mathematica \
Dot function. this can in principle be disabled (by editing the file \
\"FeynCalc.m\"), but then non-commutative products should to be entered like \
DOT[ DiracMatrix[mu], m + DiracSlash[p], DiracMatrix[mu] ] etc.", "Text", 
            CellTags -> "DOT"], Cell[TextData[{"See also: ", 
              ButtonBox["DotSimplify", RuleDelayed[ButtonData, 
                 "DotSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DotSimplify"]], "."}], "Text", 
            CellTags -> "DOT"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["DotExpand", "ObjectName", CellTags -> "DotExpand"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DotExpand"], 
           Cell["DotExpand[expr] expands DOT products in expr.", "Text", 
            CellTags -> "DotExpand"], Cell[TextData[{"See also: ", 
              ButtonBox["DOT", RuleDelayed[ButtonData, "DOT"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "DOT"]], 
              ", ", 
              ButtonBox["DotSimplify", RuleDelayed[ButtonData, 
                 "DotSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DotSimplify"]], ", ", 
              ButtonBox["DeclareNonCommutative", 
                RuleDelayed[ButtonData, "DeclareNonCommutative"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeclareNonCommutative"]], ", ", 
              ButtonBox["UnDeclareNonCommutative", 
                RuleDelayed[ButtonData, "UnDeclareNonCommutative"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "UnDeclareNonCommutative"]], "."}], "Text", 
            CellTags -> "DotExpand"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DotExpand"], Cell[CellGroupData[{Cell[BoxData[
                \(DotExpand[\(DOT[\(\(\(a\ x\) + \(b\ y\) + \(c\ z\)\), 
                       \(d + e + f\)\)]\)]\)], "Input", CellTags -> 
                "DotExpand"], Cell[BoxData[
                \(TraditionalForm\`\(\(a\ d\ x\) + \(a\ e\ x\) + \(a\ f\ x\) 
                     + \(b\ d\ y\) + \(b\ e\ y\) + \(b\ f\ y\) + \(c\ d\ z\) 
                     + \(c\ e\ z\) + \(c\ f\ z\)\)\)], "Output", CellTags -> 
                "DotExpand"]}, Open]], Cell[BoxData[
             \(\(DeclareNonCommutative/@\({a, b, c, d, e, f}\)\) ;\)], 
            "Input", CellTags -> "DotExpand"], Cell[CellGroupData[
             {Cell[BoxData[
                \(DotExpand[\(DOT[\(\(\(a\ x\) + \(b\ y\) + \(c\ z\)\), 
                       \(d + e + f\)\)]\)]\)], "Input", CellTags -> 
                "DotExpand"], Cell[BoxData[
                \(TraditionalForm\`\(\(x\ \(a . d\)\) + \(x\ \(a . e\)\) + 
                     \(x\ \(a . f\)\) + \(y\ \(b . d\)\) + \(y\ \(b . e\)\) +
                      \(y\ \(b . f\)\) + \(z\ \(c . d\)\) + \(z\ \(c . e\)\) 
                     + \(z\ \(c . f\)\)\)\)], "Output", CellTags -> 
                "DotExpand"]}, Open]], Cell[BoxData[
             \(\(UnDeclareNonCommutative/@\({a, b, c, d, e, f}\)\) ;\)], 
            "Input", CellTags -> "DotExpand"], Cell[CellGroupData[
             {Cell[BoxData[
                \(DotExpand[\(DOT[\(\(\(a\ x\) + \(b\ y\) + \(c\ z\)\), 
                       \(d + e + f\)\)]\)]\)], "Input", CellTags -> 
                "DotExpand"], Cell[BoxData[
                \(TraditionalForm\`\(\(a\ d\ x\) + \(a\ e\ x\) + \(a\ f\ x\) 
                     + \(b\ d\ y\) + \(b\ e\ y\) + \(b\ f\ y\) + \(c\ d\ z\) 
                     + \(c\ e\ z\) + \(c\ f\ z\)\)\)], "Output", CellTags -> 
                "DotExpand"]}, Open]]}, Open]], Cell["DotPower", 
         "ObjectName", CellTags -> "DotPower"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DotPower"], Cell["DotPower is an option for \
DotSimplify. It determines whether non-commutative powers are represented by \
succesive multiplication or by Power.", "Text", CellTags -> "DotPower"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["DotSimplify", RuleDelayed[ButtonData, 
                 "DotSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DotSimplify"]], "."}], "Text", 
            CellTags -> "DotPower"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["DotProduct", "ObjectName", CellTags -> "DotProduct"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DotProduct"], Cell["DotProduct[x, y] denotes the \
three-dimensional dot-product. If x and y have Head List, DotProduct[x, a] \
(where a is a vector) performs Sum[ x[[k]] a[[k]], {k, 0, 3}].", "Text", 
            CellTags -> "DotProduct"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["CrossProduct", 
                RuleDelayed[ButtonData, "CrossProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CrossProduct"]], ", ", 
              ButtonBox["ThreeVector", RuleDelayed[ButtonData, 
                 "ThreeVector"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ThreeVector"]], "."}], "Text", 
            CellTags -> "DotProduct"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DotProduct"], Cell[CellGroupData[{Cell[BoxData[
                \(DotProduct[\(\(ThreeVector[a]\), \(3\(ThreeVector[b]\)\)\)]
                  \)], "Input", CellTags -> "DotProduct"], Cell[BoxData[
                FormBox[RowBox[{"3", " ", RowBox[{FormBox[
                      \(a\&\[RightVector]\), "TraditionalForm"], 
                     "\[CenterDot]", FormBox[\(b\&\[RightVector]\), 
                      "TraditionalForm"]}]}], TraditionalForm]], "Output", 
               CellTags -> "DotProduct"]}, Open]]}, Open]], 
        Cell["DotSimplifyRelations", "ObjectName", CellTags -> 
          "DotSimplifyRelations"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "DotSimplifyRelations"], Cell["DotSimplifyRelations is an option \
for DotSimplify. Its setting may be a list of substitution rules of the form \
DotSimplifyRelations \[Rule] {a . b \[Rule] c, b^2 \[Rule] 0, ...}.", "Text", 
            CellTags -> "DotSimplifyRelations"], Cell[TextData[{"See also: ", 
              ButtonBox["DotSimplify", RuleDelayed[ButtonData, 
                 "DotSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DotSimplify"]], "."}], "Text", 
            CellTags -> "DotSimplifyRelations"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["DotSimplify", "ObjectName", CellTags -> 
          "DotSimplify"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "DotSimplify"], Cell["DotSimplify[ex\
pr] expands and reorders noncommutative terms in expr. Simplifying relations \
may be specified by the option DotSimplifyRelations or by Commutator and \
AntiCommutator definitions. Whether expr is expanded noncommutatively depends \
on the option Expanding.", "Text", CellTags -> "DotSimplify"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[DotSimplify]\)], 
               "Input", CellTags -> "DotSimplify"], Cell[BoxData[
                \(TraditionalForm\`\({\(Expanding \[Rule] True\), 
                      \(DotSimplifyRelations \[Rule] \({}\)\), 
                      \(DotPower \[Rule] False\), 
                      \(FeynCalcInternal \[Rule] True\)}\)\)], "Output", 
               CellTags -> "DotSimplify"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["AntiCommutator", 
                RuleDelayed[ButtonData, "AntiCommutator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "AntiCommutator"]], ", ", 
              ButtonBox["Commutator", RuleDelayed[ButtonData, "Commutator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Commutator"]], ", ", 
              ButtonBox["Calc", RuleDelayed[ButtonData, "Calc"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Calc"]], 
              "."}], "Text", CellTags -> "DotSimplify"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DotSimplify"], Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(\(GA[\[Mu]]\) . \((\(2\ \(GS[p]\)\) - \(GS[q]\))\) .
                      \(GA[\[Nu]]\)\)\)], "Input", CellTags -> 
                "DotSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . 
                     \((\(2\ \(\[Gamma] \[CenterDot] p\)\) - 
                        \(\[Gamma] \[CenterDot] q\))\) . \[Gamma]\^\[Nu]\)\)]\
, "Output", CellTags -> "DotSimplify"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(DotSimplify[t1]\)], "Input", CellTags -> 
                "DotSimplify"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"2", " ", RowBox[{SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", RowBox[{"(", RowBox[
                          {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                         ")"}], ".", SuperscriptBox["\[Gamma]", FormBox[
                         FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"]]}]}], "-", RowBox[{SuperscriptBox[
                      "\[Gamma]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], ".", SuperscriptBox[
                      "\[Gamma]", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"]]}]}], 
                 TraditionalForm]], "Output", CellTags -> "DotSimplify"]}, 
             Open]], Cell[BoxData[\(DeclareNonCommutative[\(a, b, c\)]\)], 
            "Input", CellTags -> "DotSimplify"], Cell[CellGroupData[
             {Cell[BoxData[\(t2 = \(a . \((b - \(z\ c\))\) . a\)\)], "Input", 
               CellTags -> "DotSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(a . \((b - \(c\ z\))\) . a\)\)], 
               "Output", CellTags -> "DotSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(DotSimplify[t2]\)], "Input", 
               CellTags -> "DotSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\(a . b . a\) - \(z\ \(a . c . a\)\)\)\)]\
, "Output", CellTags -> "DotSimplify"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(\(Commutator[\(a, c\)]\) = 1\)], "Input", 
               CellTags -> "DotSimplify"], Cell[BoxData[\(TraditionalForm\`1\)
                ], "Output", CellTags -> "DotSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(DotSimplify[t2]\)], "Input", 
               CellTags -> "DotSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\(a . b . a\) - 
                     \(z\ \((a + \(c . a . a\))\)\)\)\)], "Output", 
               CellTags -> "DotSimplify"]}, Open]], Cell[BoxData[
             \(\(Commutator[\(a, c\)]\) = .\)], "Input", CellTags -> 
             "DotSimplify"], Cell[CellGroupData[{Cell[BoxData[
                \(DotSimplify[t2]\)], "Input", CellTags -> "DotSimplify"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(a . b . a\) - \(z\ \(a . c . a\)\)\)\)]\
, "Output", CellTags -> "DotSimplify"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(\(AntiCommutator[\(b, a\)]\) = c\)], "Input", 
               CellTags -> "DotSimplify"], Cell[BoxData[\(TraditionalForm\`c\)
                ], "Output", CellTags -> "DotSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(DotSimplify[t2]\)], "Input", 
               CellTags -> "DotSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\(a . c\) - \(a . a . b\) - 
                     \(z\ \(a . c . a\)\)\)\)], "Output", CellTags -> 
                "DotSimplify"]}, Open]], Cell[BoxData[
             \(\(AntiCommutator[\(b, a\)]\) = .\)], "Input", 
            CellTags -> "DotSimplify"], Cell[CellGroupData[{Cell[BoxData[
                \(DotSimplify[\(t2, \(DotSimplifyRelations \[Rule] 
                       \({\(a . c\) \[Rule] \(1/z\)}\)\)\)]\)], "Input", 
               CellTags -> "DotSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\(a . b . a\) - a\)\)], "Output", 
               CellTags -> "DotSimplify"]}, Open]], Cell[BoxData[
             \(DeclareNonCommutative[x]\)], "Input", CellTags -> 
             "DotSimplify"], Cell[CellGroupData[{Cell[BoxData[
                \(DotSimplify[\(x . x . x\)]\)], "Input", CellTags -> 
                "DotSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(x . x . x\)\)], "Output", CellTags -> 
                "DotSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DotSimplify[\(\(x . x . x\), \(DotPower \[Rule] False\)\)]
                  \)], "Input", CellTags -> "DotSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(x . x . x\)\)], "Output", CellTags -> 
                "DotSimplify"]}, Open]], Cell[BoxData[
             \(UnDeclareNonCommutative[\(a, b, c, x\)]\)], "Input", 
            CellTags -> "DotSimplify"]}, Open]], Cell["DummyIndex", 
         "ObjectName", CellTags -> "DummyIndex"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DummyIndex"], Cell["DummyIndex is an option of \
CovariantD specifying an index to use as dummy summation index. If set to \
Automatic, unique indices are generated", "Text", CellTags -> "DummyIndex"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["CovariantD", RuleDelayed[ButtonData, "CovariantD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CovariantD"]], "."}], "Text", 
            CellTags -> "DummyIndex"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["D0", "ObjectName", CellTags -> "D0"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "D0"], Cell[TextData[{"D0[ p10, p12, p23, p30, p20, \
p13, m1^2, m2^2, m3^2, m4^2 ] is the Passarino-Veltman ", Cell[BoxData[
                \(TraditionalForm\`D\_0\)]], " function. The convention for \
the arguments is that if the denominator of the integrand has the form \
([q^2-m1^2] [(q+p1)^2-m2^2] [(q+p2)^2-m3^2] [(q+p3)^2-m4^2] ), the first six \
arguments of D0 are the scalar products p10 = p1^2, p12 = (p1-p2)^2, p23 = \
(p2-p3)^2, p30 = p3^2, p20 = p2^2, p13 = (p1-p3)^2."}], "Text", 
            CellTags -> "D0"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["B0", RuleDelayed[ButtonData, "B0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B0"]], 
              ", ", 
              ButtonBox["C0", RuleDelayed[ButtonData, "C0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "C0"]], 
              ", ", 
              ButtonBox["PaVe", RuleDelayed[ButtonData, "PaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "PaVe"]], 
              ", ", 
              ButtonBox["PaVeOrder", RuleDelayed[ButtonData, "PaVeOrder"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeOrder"]], "."}], "Text", 
            CellTags -> "D0"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "D0"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(D0[\(p10, p12, p23, p30, p20, p13, \(m1^2\), \(m2^2\), 
                     \(m3^2\), \(m4^2\)\)]\)], "Input", CellTags -> "D0"], 
              Cell[BoxData[FormBox[RowBox[{FormBox[\("D"\_"0"\), 
                    "TraditionalForm"], "(", FormBox[
                    \(\(\*TagBox[StyleBox["\"p\"", 
                           Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]]\)\_10\), 
                    "TraditionalForm"], ",", FormBox[
                    \(\(\*TagBox[StyleBox["\"p\"", 
                           Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]]\)\_12\), 
                    "TraditionalForm"], ",", "p23", ",", "p30", ",", "p20", 
                   ",", "p13", ",", FormBox[\(m1\^2\), "TraditionalForm"], 
                   ",", FormBox[\(m2\^2\), "TraditionalForm"], ",", FormBox[
                    \(m3\^2\), "TraditionalForm"], ",", FormBox[\(m4\^2\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "D0"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(PaVeOrder[\(\(D0[\(p10, p12, p23, p30, p20, p13, \(m1^2\), 
                         \(m2^2\), \(m3^2\), \(m4^2\)\)]\), 
                     \(PaVeOrderList \[Rule] \({p13, p20}\)\)\)]\)], "Input", 
               CellTags -> "D0"], Cell[BoxData[FormBox[RowBox[{FormBox[
                    \("D"\_"0"\), "TraditionalForm"], "(", FormBox[
                    \(\(\*TagBox[StyleBox["\"p\"", 
                           Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]]\)\_10\), 
                    "TraditionalForm"], ",", "p30", ",", "p23", ",", FormBox[
                    \(\(\*TagBox[StyleBox["\"p\"", 
                           Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]]\)\_12\), 
                    "TraditionalForm"], ",", "p13", ",", "p20", ",", FormBox[
                    \(m2\^2\), "TraditionalForm"], ",", FormBox[\(m1\^2\), 
                    "TraditionalForm"], ",", FormBox[\(m4\^2\), 
                    "TraditionalForm"], ",", FormBox[\(m3\^2\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "D0"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(PaVeOrder[%]\)], "Input", CellTags -> "D0"], 
              Cell[BoxData[FormBox[RowBox[{FormBox[\("D"\_"0"\), 
                    "TraditionalForm"], "(", FormBox[
                    \(\(\*TagBox[StyleBox["\"p\"", 
                           Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]]\)\_10\), 
                    "TraditionalForm"], ",", FormBox[
                    \(\(\*TagBox[StyleBox["\"p\"", 
                           Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]]\)\_12\), 
                    "TraditionalForm"], ",", "p23", ",", "p30", ",", "p20", 
                   ",", "p13", ",", FormBox[\(m1\^2\), "TraditionalForm"], 
                   ",", FormBox[\(m2\^2\), "TraditionalForm"], ",", FormBox[
                    \(m3\^2\), "TraditionalForm"], ",", FormBox[\(m4\^2\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "D0"]}, Open]]}, Open]], Cell["D0Convention", 
         "ObjectName", CellTags -> "D0Convention"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "D0Convention"], Cell["D0Convention is an option for \
Write2. If set to 1, the convention for the arguments of D0 is changed when \
writing a Fortran file with Write2: The fifth and sixth argument of D0 are \
interchanged and the square root is taken of the last four arguments.", 
            "Text", CellTags -> "D0Convention"], Cell[TextData[{"See also: ", 
              ButtonBox["D0", RuleDelayed[ButtonData, "D0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "D0"]], 
              ", ", 
              ButtonBox["Write2", RuleDelayed[ButtonData, "Write2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Write2"]], 
              "."}], "Text", CellTags -> "D0Convention"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["Eps", "ObjectName", CellTags -> "Eps"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Eps"], Cell[TextData[
             {"Eps[a, b, c, d] is the head of the totally antisymmetric ", 
              Cell[BoxData[\(TraditionalForm\`\(\ \[Epsilon]\)\)]], " \
(Levi-Civita) tensor. The a,b, ... may have head LorentzIndex, Momentum or \
Integer. In case of integers the Levi-Civita tensor is evaluated immediately. \
"}], "Text", CellTags -> "Eps"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[Eps]\)], "Input", CellTags -> "Eps"], Cell[BoxData[
                \(TraditionalForm\`\({Dimension \[Rule] 4}\)\)], "Output", 
               CellTags -> "Eps"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["EpsEvaluate", RuleDelayed[ButtonData, 
                 "EpsEvaluate"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "EpsEvaluate"]], ", ", 
              ButtonBox["LC", RuleDelayed[ButtonData, "LC"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "LC"]], 
              ", ", 
              ButtonBox["LCD", RuleDelayed[ButtonData, "LCD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "LCD"]], 
              ", ", 
              ButtonBox["LeviCivita", RuleDelayed[ButtonData, "LeviCivita"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeviCivita"]], "."}], "Text", 
            CellTags -> "Eps"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "Eps"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Eps[\(\(LorentzIndex[\[Mu]]\), \(LorentzIndex[\[Nu]]\), 
                     \(LorentzIndex[\[Rho]]\), \(LorentzIndex[\[Sigma]]\)\)]\
\)], "Input", CellTags -> "Eps"], Cell[BoxData[FormBox[SuperscriptBox[
                  "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["\[Nu]", "TraditionalForm"], "TraditionalForm"], 
                    FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                      "TraditionalForm"], "TraditionalForm"]}]], 
                 TraditionalForm]], "Output", CellTags -> "Eps"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Eps[\(\(Momentum[p]\), \(LorentzIndex[\[Nu]]\), 
                     \(LorentzIndex[\[Rho]]\), \(LorentzIndex[\[Sigma]]\)\)]\
\)], "Input", CellTags -> "Eps"], Cell[BoxData[FormBox[SuperscriptBox[
                  "\[Epsilon]", RowBox[{FormBox["p", "TraditionalForm"], 
                    FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["\[Sigma]", "TraditionalForm"], 
                     "TraditionalForm"]}]], TraditionalForm]], "Output", 
               CellTags -> "Eps"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(Eps[\(b, a, c, d\)]\)//StandardForm\)], "Input", 
               CellTags -> "Eps"], Cell[BoxData[\(-\(Eps[\(a, b, c, d\)]\)\)]
                , "Output", CellTags -> "Eps"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Eps[\(0, 1, 2, 3\)]\)], 
               "Input", CellTags -> "Eps"], Cell[BoxData[
                \(TraditionalForm\`1\)], "Output", CellTags -> "Eps"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(Eps[\(1, 0, 2, 3\)]\)]
                , "Input", CellTags -> "Eps"], Cell[BoxData[
                \(TraditionalForm\`\(-1\)\)], "Output", CellTags -> "Eps"]}, 
             Open]], Cell[BoxData[
             \(\(SetOptions[\(Eps, \(Dimension \[Rule] 4\)\)]\) ;\)], 
            "Input", CellTags -> "Eps"], Cell[CellGroupData[{Cell[BoxData[
                \(a1\ = \(Eps[\(\(LorentzIndex[\(\[Mu], D\)]\), 
                       \(LorentzIndex[\(\[Nu], D\)]\), 
                       \(LorentzIndex[\(\[Rho], D\)]\), 
                       \(LorentzIndex[\(\[Sigma], D\)]\)\)]\)\)], "Input", 
               CellTags -> "Eps"], Cell[BoxData[FormBox[SuperscriptBox[
                  "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["\[Nu]", "TraditionalForm"], "TraditionalForm"], 
                    FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                      "TraditionalForm"], "TraditionalForm"]}]], 
                 TraditionalForm]], "Output", CellTags -> "Eps"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Contract[a1a1]\)], "Input", 
               CellTags -> "Eps"], Cell[BoxData[\(TraditionalForm\`a1a1\)], 
               "Output", CellTags -> "Eps"]}, Open]], Cell[BoxData[
             \(\(SetOptions[\(Eps, \(Dimension \[Rule] D\)\)]\) ;\)], 
            "Input", CellTags -> "Eps"], Cell[CellGroupData[{Cell[BoxData[
                \(a2\ = \(Eps[\(\(LorentzIndex[\(\[Mu], D\)]\), 
                       \(LorentzIndex[\(\[Nu], D\)]\), 
                       \(LorentzIndex[\(\[Rho], D\)]\), 
                       \(LorentzIndex[\(\[Sigma], D\)]\)\)]\)\)], "Input", 
               CellTags -> "Eps"], Cell[BoxData[FormBox[SuperscriptBox[
                  "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["\[Nu]", "TraditionalForm"], "TraditionalForm"], 
                    FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                      "TraditionalForm"], "TraditionalForm"]}]], 
                 TraditionalForm]], "Output", CellTags -> "Eps"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(Contract[a2a2]\)//Factor2\)], 
               "Input", CellTags -> "Eps"], Cell[BoxData[
                \(TraditionalForm\`a2a2\)], "Output", CellTags -> "Eps"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\ \(\(LCD[\(\[Mu], \[Nu], \[Rho], \[Alpha]\)]\) . 
                     \(GAD[\(\[Mu], \[Nu], \[Rho], \[Alpha]\)]\)\)\)], 
               "Input"], Cell[BoxData[
                \(TraditionalForm\`\(\[Epsilon]\^\(\[Mu]\[Nu]\[Rho]\[Alpha]\)
                      . \[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . \[Gamma]\^
                      \[Rho] . \[Gamma]\^\[Alpha]\)\)], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//FCI\)], "Input"], 
              Cell[BoxData[FormBox[RowBox[{SuperscriptBox["\[Epsilon]", 
                    RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Alpha]", 
                        "TraditionalForm"], "TraditionalForm"]}]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Rho]", 
                      "TraditionalForm"], "TraditionalForm"]], ".", 
                   SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Alpha]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(g5 = \(\(\(-\(\[ImaginaryI]\/24\)\) 
                       \(\(LCD[\(\[Mu], \[Nu], \[Rho], \[Alpha]\)]\) . 
                         \(GAD[\(\[Mu], \[Nu], \[Rho], \[Alpha]\)]\)\)\)//FCI
                \)\)], "Input", CellTags -> "Eps"], Cell[BoxData[
                FormBox[RowBox[{\(-\(1\/24\)\), " ", "\[ImaginaryI]", " ", 
                   RowBox[{SuperscriptBox["\[Epsilon]", RowBox[{FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Alpha]", 
                          "TraditionalForm"], "TraditionalForm"]}]], ".", 
                     SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Rho]", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Alpha]", 
                        "TraditionalForm"], "TraditionalForm"]]}]}], 
                 TraditionalForm]], "Output", CellTags -> "Eps"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(g5p = \(\(\(-\(\[ImaginaryI]\/24\)\)\ 
                       \(\(LCD[\(\*SuperscriptBox["\[Mu]", "\[Prime]", 
                               Rule[MultilineFunction, None]], 
                             \*SuperscriptBox["\[Nu]", "\[Prime]", 
                               Rule[MultilineFunction, None]], 
                             \*SuperscriptBox["\[Rho]", "\[Prime]", 
                               Rule[MultilineFunction, None]], 
                             \*SuperscriptBox["\[Alpha]", "\[Prime]", 
                               Rule[MultilineFunction, None]]\)]\) . 
                         \(GAD[\(\*SuperscriptBox["\[Mu]", "\[Prime]", 
                               Rule[MultilineFunction, None]], 
                             \*SuperscriptBox["\[Nu]", "\[Prime]", 
                               Rule[MultilineFunction, None]], 
                             \*SuperscriptBox["\[Rho]", "\[Prime]", 
                               Rule[MultilineFunction, None]], 
                             \*SuperscriptBox["\[Alpha]", "\[Prime]", 
                               Rule[MultilineFunction, None]]\)]\)\)\)//FCI\)
                \)], "Input", CellTags -> "Eps"], Cell[BoxData[FormBox[
                 RowBox[{\(-\(1\/24\)\), " ", "\[ImaginaryI]", " ", 
                   RowBox[{SuperscriptBox["\[Epsilon]", RowBox[{FormBox[
                         FormBox[
                          SuperscriptBox["\[Mu]", "\[Prime]", 
                            Rule[MultilineFunction, None]], 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox[
                          SuperscriptBox["\[Nu]", "\[Prime]", 
                            Rule[MultilineFunction, None]], 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox[
                          SuperscriptBox["\[Rho]", "\[Prime]", 
                            Rule[MultilineFunction, None]], 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox[
                          SuperscriptBox["\[Alpha]", "\[Prime]", 
                            Rule[MultilineFunction, None]], 
                          "TraditionalForm"], "TraditionalForm"]}]], ".", 
                     SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        SuperscriptBox["\[Mu]", "\[Prime]", 
                          Rule[MultilineFunction, None]], "TraditionalForm"], 
                       "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                      FormBox[FormBox[
                        SuperscriptBox["\[Nu]", "\[Prime]", 
                          Rule[MultilineFunction, None]], "TraditionalForm"], 
                       "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                      FormBox[FormBox[
                        SuperscriptBox["\[Rho]", "\[Prime]", 
                          Rule[MultilineFunction, None]], "TraditionalForm"], 
                       "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                      FormBox[FormBox[
                        SuperscriptBox["\[Alpha]", "\[Prime]", 
                          Rule[MultilineFunction, None]], "TraditionalForm"], 
                       "TraditionalForm"]]}]}], TraditionalForm]], "Output", 
               CellTags -> "Eps"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(g52 = \(Factor2[\(Calc[\(g5 . g5p\)]\)]\)\)], "Input", 
               CellTags -> "Eps"], Cell[BoxData[
                \(TraditionalForm\`\(\(-\(1\/24\)\)\ \((1 - D)\)\ \((2 - D)\)
                     \ \((3 - D)\)\ D\)\)], "Output", CellTags -> "Eps"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(g52/.\(D \[Rule] 4\)\)
                ], "Input", CellTags -> "Eps"], Cell[BoxData[
                \(TraditionalForm\`1\)], "Output", CellTags -> "Eps"]}, 
             Open]], Cell[BoxData[\(Clear[\(a1, a2, g5, g5p, g52\)]\)], 
            "Input", CellTags -> "Eps"]}, Open]], Cell["EpsChisholm", 
         "ObjectName", CellTags -> "EpsChisholm"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "EpsChisholm"], Cell["EpsChisholm[expr] substitutes \
for a gamma matrix contracted with a Levi-Civita tensor (Eps) the Chisholm \
identity.", "Text", CellTags -> "EpsChisholm"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Chisholm", RuleDelayed[ButtonData, "Chisholm"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Chisholm"]], "."}], "Text", 
            CellTags -> "EpsChisholm"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "EpsChisholm"], Cell[CellGroupData[{Cell[BoxData[
                \(Chisholm[\(GA[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\)]\)], 
               "Input", CellTags -> "EpsChisholm"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{\(-\[ImaginaryI]\), " ", RowBox[
                      {SuperscriptBox["\[Gamma]", FormBox[FormBox["$MU$799", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       \(\[Gamma]\^5\)}], " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["$MU$799", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{SuperscriptBox["\[Gamma]", FormBox[
                         FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Nu]\)\)}], 
                   "-", RowBox[{RowBox[{SuperscriptBox["\[Gamma]", FormBox[
                         FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Mu]\[Rho]\)\)}]
                     , "+", RowBox[{RowBox[{SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                        FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(g\^\(\[Nu]\[Rho]\)\)}]}
                     ], TraditionalForm]], "Output", CellTags -> 
                "EpsChisholm"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(EpsChisholm[%]\)], "Input", CellTags -> "EpsChisholm"], 
              Cell[BoxData[FormBox[RowBox[{SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "EpsChisholm"]}, Open]]}, Open]], 
        Cell["EpsContract", "ObjectName", CellTags -> "EpsContract"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "EpsContract"], Cell["EpsContract is an option of \
Contract specifying whether Levi-Civita tensors Eps[...] will be contracted, \
i.e., products of two  Eps are replaced via the determinant formula.", 
            "Text", CellTags -> "EpsContract"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Eps", RuleDelayed[ButtonData, "Eps"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Eps"]], 
              ", ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], "."}], "Text", 
            CellTags -> "EpsContract"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "EpsContract"], Cell[CellGroupData[{Cell[BoxData[
                \(a1\ = \(Eps[\(\(LorentzIndex[\(\[Mu], D\)]\), 
                       \(LorentzIndex[\(\[Nu], D\)]\), 
                       \(LorentzIndex[\(\[Rho], D\)]\), 
                       \(LorentzIndex[\(\[Sigma], D\)]\)\)]\)\)], "Input", 
               CellTags -> "EpsContract"], Cell[BoxData[FormBox[
                 SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                      "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                    FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["\[Sigma]", "TraditionalForm"], 
                     "TraditionalForm"]}]], TraditionalForm]], "Output", 
               CellTags -> "EpsContract"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Contract[\(\(a1\ a1\), \(EpsContract \[Rule] False\)\)]\)], 
               "Input", CellTags -> "EpsContract"], Cell[BoxData[
                FormBox[SuperscriptBox[RowBox[{"(", SuperscriptBox[
                     "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["\[Nu]", "TraditionalForm"], 
                        "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["\[Sigma]", "TraditionalForm"], 
                        "TraditionalForm"]}]], ")"}], "2"], 
                 TraditionalForm]], "Output", CellTags -> "EpsContract"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Contract[\(\(a1\ a1\), \(EpsContract \[Rule] True\)\)]\)], 
               "Input", CellTags -> "EpsContract"], Cell[BoxData[
                \(TraditionalForm\`\(\(-D\^4\) + \(6\ D\^3\) - \(11\ D\^2\) +
                      \(6\ D\)\)\)], "Output", CellTags -> "EpsContract"]}, 
             Open]], Cell[BoxData[\(Clear[a1]\)], "Input"]}, Open]], 
        Cell["EpsDiscard", "ObjectName", CellTags -> "EpsDiscard"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "EpsDiscard"], Cell["EpsDiscard is an option for \
FeynCalc2FORM. If set to True all Levi-Civita tensors are replaced by 0 after \
contraction.", "Text", CellTags -> "EpsDiscard"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalc2FORM", 
                RuleDelayed[ButtonData, "FeynCalc2FORM"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalc2FORM"]], "."}], "Text", 
            CellTags -> "EpsDiscard"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["EpsEvaluate", "ObjectName", CellTags -> "EpsEvaluate"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "EpsEvaluate"], Cell["EpsEvaluate[expr] applies total \
antisymmetry and linearity (w.r.t. Momentum's) to all Levi-Civita tensors \
(Eps') in expr.", "Text", CellTags -> "EpsEvaluate"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], ", ", 
              ButtonBox["Eps", RuleDelayed[ButtonData, "Eps"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Eps"]], 
              ", ", 
              ButtonBox["LeviCivita", RuleDelayed[ButtonData, "LeviCivita"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeviCivita"]], ", ", 
              ButtonBox["Trick", RuleDelayed[ButtonData, "Trick"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Trick"]], 
              "."}], "Text", CellTags -> "EpsEvaluate"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "EpsEvaluate"], Cell[CellGroupData[{Cell[BoxData[
                \(Trick[\(\(LeviCivita[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\)
                     \ \(FourVector[\(\(p + q\), \[Sigma]\)]\)\)]\)], 
               "Input", CellTags -> "EpsEvaluate"], Cell[BoxData[
                FormBox[SuperscriptBox["\[Epsilon]", RowBox[{FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                    FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     \(p + q\), "TraditionalForm"]}]], TraditionalForm]], 
               "Output", CellTags -> "EpsEvaluate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(EpsEvaluate[%]\)], "Input", 
               CellTags -> "EpsEvaluate"], Cell[BoxData[FormBox[
                 SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                      "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                    FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     \(p + q\), "TraditionalForm"]}]], TraditionalForm]], 
               "Output", CellTags -> "EpsEvaluate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(StandardForm[%]\)], "Input", 
               CellTags -> "EpsEvaluate"], Cell[BoxData[
                \(Eps[\(\(LorentzIndex[\(\[Mu], D\)]\), 
                     \(LorentzIndex[\(\[Nu], D\)]\), 
                     \(LorentzIndex[\(\[Rho], D\)]\), \(Momentum[\(p + q\)]\)
                \)]\)], "Output", CellTags -> "EpsEvaluate"]}, Open]]}, 
          Open]], Cell["EpsUncontract", "ObjectName", 
         CellTags -> "EpsUncontract"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "EpsUncontract"], 
           Cell[
            "EpsUncontract does Uncontract on scalar products involving Eps."\
, "Text", CellTags -> "EpsUncontract"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Eps", RuleDelayed[ButtonData, "Eps"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Eps"]], 
              ", ", 
              ButtonBox["Uncontract", RuleDelayed[ButtonData, "Uncontract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Uncontract"]], "."}], "Text", 
            CellTags -> "EpsUncontract"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["Epsilon", "ObjectName", CellTags -> "Epsilon"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Epsilon"], Cell[TextData[{"Epsilon is (", 
              StyleBox["n", Rule[FontSlant, "Italic"]], "-4), where ", 
              StyleBox["n", Rule[FontSlant, "Italic"]], " is the space-time \
dimension. Epsilon stands for a small positive number."}], "Text", 
            CellTags -> "Epsilon"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Series2", RuleDelayed[ButtonData, "Series2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Series2"]]\
, "."}], "Text", CellTags -> "Epsilon"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Epsilon"], Cell[CellGroupData[
             {Cell[BoxData["Epsilon"], "Input", CellTags -> "Epsilon"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox["\[CurlyEpsilon]", 
                      TraditionalForm]\)\)], "Output", CellTags -> 
                "Epsilon"]}, Open]], Cell["Epsilon has no functional \
properties, but some upvalues are changed:", "Text", CellTags -> "Epsilon"], 
           Cell[CellGroupData[{Cell[BoxData[
                \({\(\(Re[Epsilon]\)\ >\ \(-4\)\), 
                    \(\(Re[Epsilon]\)\ >\ \(-3\)\), 
                    \(\(Re[Epsilon]\)\ >\ \(-2\)\), 
                    \(\(Re[Epsilon]\)\ >\ \(-1\)\), \(\(Re[Epsilon]\)\ >\ 0\)\
}\)], "Input", CellTags -> "Epsilon"], Cell[BoxData[
                \(TraditionalForm\`\({True, True, True, True, True}\)\)], 
               "Output", CellTags -> "Epsilon"]}, Open]]}, Open]], 
        Cell["EpsilonOrder", "ObjectName", CellTags -> "EpsilonOrder"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "EpsilonOrder"], Cell[TextData[{"EpsilonOrder is an \
option of OPEIntegrateDelta and RHI. The setting determines the order ", "n", 
              " (", Cell[BoxData[
                \(TraditionalForm\`\(Epsilon\^
                     \*StyleBox["n", Rule[FontSlant, "Plain"]]\)\)]], 
              ") which should be kept."}], "Text", CellTags -> 
             "EpsilonOrder"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OPEIntegrateDelta", 
                RuleDelayed[ButtonData, "OPEIntegrateDelta"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OPEIntegrateDelta"]], ", ", 
              ButtonBox["RHI", RuleDelayed[ButtonData, "RHI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "RHI"]], 
              "."}], "Text", CellTags -> "EpsilonOrder"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["Expanding", "ObjectName", 
         CellTags -> "Expanding"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Expanding"], 
           Cell["Expanding is an option for Calc, Contract, \
DiracSimplify,DotSimplify, SUNSimplify etc. As option for Contract it \
specifies whether expansion w.r.t. LorentzIndex is done BEFORE contraction. \
If set to False in DiracSimplify or SUNSimplify, only a limited set of \
simplifications (multiplicative linearity etc.) is performed.", "Text", 
            CellTags -> "Expanding"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Calc", RuleDelayed[ButtonData, "Calc"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Calc"]], 
              ", ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["DotSimplify", RuleDelayed[ButtonData, 
                 "DotSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DotSimplify"]], ", ", 
              ButtonBox["SUNSimplify", RuleDelayed[ButtonData, 
                 "SUNSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNSimplify"]], "."}], "Text", 
            CellTags -> "Expanding"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["ExpandPartialD", "ObjectName", CellTags -> "ExpandPartialD"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ExpandPartialD"], Cell["ExpandPartialD[exp] expands \
all products of QuantumField's and partial differentiation operators in exp \
and applies the Leibniz rule.", "Text", CellTags -> "ExpandPartialD"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[ExpandPartialD]\)], 
               "Input"], Cell[BoxData[FormBox[RowBox[{"{", RowBox[
                    {"PartialDRelations", "\[Rule]", RowBox[{"{", RowBox[
                        {RowBox[{RowBox[{"a$___", ".", RowBox[{"\[PartialD]", 
                          "/", "\[PartialD]", SuperscriptBox[FormBox["x$_", 
                          "TraditionalForm"], FormBox[FormBox["mu$_", 
                          "TraditionalForm"], "TraditionalForm"]]}], ".", 
                          "b$___"}], "\[RuleDelayed]", RowBox[{"a$", ".", 
                          RowBox[{SubscriptBox[
                          TagBox[StyleBox["\"\[PartialD]\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], TagBox[FormBox[
                          FormBox["mu$", "TraditionalForm"], 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True]], "(", TagBox[FormBox[\(Dot[b$]\), 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True], ")"}]}]}], ",", RowBox[{RowBox[{RowBox[
                          {"UMatrix", "(", RowBox[{FormBox[
                          TagBox[StyleBox["\"\[DoubleStruckCapitalI]\[Doub\
leStruckD]\"", Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], ",", "___"}], ")"}], 
                          "\[SixPointedStar]", 
                          \(\((PartialD | RightPartialD | LeftPartialD)\)[__]
                            \)}], "\[RuleDelayed]", "0"}], ",", RowBox[
                          {RowBox[{RowBox[{"a___", "\[SixPointedStar]", 
                          SubscriptBox["D", FormBox[FormBox["mu_", 
                          "TraditionalForm"], "TraditionalForm"]]}], 
                          "\[SixPointedStar]", "b___"}], "\[RuleDelayed]", 
                          RowBox[{RowBox[{"a", "\[SixPointedStar]", RowBox[
                          {SubscriptBox[
                          TagBox[StyleBox["\"\[ScriptCapitalD]\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], TagBox[FormBox[
                          FormBox["mu", "TraditionalForm"], 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True]], "(", TagBox[FormBox["b", 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True], ")"}]}], "/;", RowBox[{"(", RowBox[{
                          \(go = False\), ";", RowBox[{\({b}\), "/.", 
                          "\[InvisibleSpace]", RowBox[{RowBox[{FormBox["__", 
                          "TraditionalForm"], "|", RowBox[{RowBox[{"_", "[", 
                          RowBox[{"___", ",", FormBox["__", 
                          "TraditionalForm"], ",", "___"}], "]"}], "[", 
                          \(y_ ? AtomQ\), "]"}]}], "\[RuleDelayed]", 
                          \((\(go = True\) ; \(z = y\))\)}]}], ";", "go"}], 
                          ")"}]}]}], ",", RowBox[{RowBox[{RowBox[{"a___", 
                          "\[SixPointedStar]", RowBox[{"\[PartialD]", "/", 
                          "D", SuperscriptBox[FormBox["x_", 
                          "TraditionalForm"], FormBox[FormBox["mu_", 
                          "TraditionalForm"], "TraditionalForm"]]}]}], 
                          "\[SixPointedStar]", "b___"}], "\[RuleDelayed]", 
                          RowBox[{"a", "\[SixPointedStar]", RowBox[
                          {SubscriptBox[
                          TagBox[StyleBox["\"\[ScriptCapitalD]\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], TagBox[FormBox[
                          FormBox["mu", "TraditionalForm"], 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True]], "(", TagBox[FormBox["b", 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True], ")"}]}]}], ",", RowBox[{RowBox[{RowBox[
                          {"a___", "\[SixPointedStar]", SubscriptBox[
                          \(\[PartialD]\&\[LeftArrow]\), FormBox[FormBox[
                          "mu_", "TraditionalForm"], "TraditionalForm"]]}], 
                          "\[SixPointedStar]", "b___"}], "\[RuleDelayed]", 
                          RowBox[{RowBox[{RowBox[{SubscriptBox[
                          TagBox[StyleBox["\"\[PartialD]\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], TagBox[FormBox[
                          FormBox["mu", "TraditionalForm"], 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True]], "(", TagBox[FormBox["a", 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True], ")"}], "\[SixPointedStar]", "b"}], "/;", 
                          RowBox[{"(", RowBox[{\(go = False\), ";", RowBox[{
                          \({a}\), "/.", "\[InvisibleSpace]", RowBox[{RowBox[
                          {FormBox["__", "TraditionalForm"], "|", RowBox[
                          {RowBox[{"_", "[", RowBox[{"___", ",", FormBox[
                          "__", "TraditionalForm"], ",", "___"}], "]"}], "[", 
                          \(y_ ? AtomQ\), "]"}]}], "\[RuleDelayed]", 
                          \((\(go = True\) ; \(z = y\))\)}]}], ";", "go"}], 
                          ")"}]}]}], ",", RowBox[{RowBox[{RowBox[{"a___", 
                          "\[SixPointedStar]", RowBox[{"LeftPartialD", "(", 
                          RowBox[{"x_", ",", FormBox["mu_", 
                          "TraditionalForm"]}], ")"}]}], "\[SixPointedStar]", 
                          "b___"}], "\[RuleDelayed]", RowBox[{RowBox[
                          {SubscriptBox[
                          TagBox[StyleBox["\"\[PartialD]\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], TagBox[FormBox[
                          FormBox["mu", "TraditionalForm"], 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True]], "(", TagBox[FormBox["a", 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True], ")"}], "\[SixPointedStar]", "b"}]}], ",", 
                         RowBox[{RowBox[{RowBox[{"a___", "\[SixPointedStar]", 
                          RowBox[{\((PartialD | RightPartialD)\), "[", 
                          FormBox["mu_", "TraditionalForm"], "]"}]}], 
                          "\[SixPointedStar]", "b___"}], "\[RuleDelayed]", 
                          RowBox[{RowBox[{"a", "\[SixPointedStar]", RowBox[
                          {SubscriptBox[
                          TagBox[StyleBox["\"\[PartialD]\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], TagBox[FormBox[
                          FormBox["mu", "TraditionalForm"], 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True]], "(", TagBox[FormBox["b", 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True], ")"}]}], "/;", RowBox[{"(", RowBox[{
                          \(go = False\), ";", RowBox[{\({b}\), "/.", 
                          "\[InvisibleSpace]", RowBox[{RowBox[{FormBox["__", 
                          "TraditionalForm"], "|", RowBox[{RowBox[{"_", "[", 
                          RowBox[{"___", ",", FormBox["__", 
                          "TraditionalForm"], ",", "___"}], "]"}], "[", 
                          \(y_ ? AtomQ\), "]"}]}], "\[RuleDelayed]", 
                          \((\(go = True\) ; \(z = y\))\)}]}], ";", "go"}], 
                          ")"}]}]}], ",", RowBox[{RowBox[{RowBox[{"a___", 
                          "\[SixPointedStar]", RowBox[{
                          \((PartialD | RightPartialD)\), "[", RowBox[{"x_", 
                          ",", FormBox["mu_", "TraditionalForm"]}], "]"}]}], 
                          "\[SixPointedStar]", "b___"}], "\[RuleDelayed]", 
                          RowBox[{"a", "\[SixPointedStar]", RowBox[
                          {SubscriptBox[
                          TagBox[StyleBox["\"\[PartialD]\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], TagBox[FormBox[
                          FormBox["mu", "TraditionalForm"], 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True]], "(", TagBox[FormBox["b", 
                          "TraditionalForm"], TraditionalForm, Editable -> 
                          True], ")"}]}]}]}], "}"}]}], "}"}], 
                 TraditionalForm]], "Output"]}, Open]], 
           Cell[TextData[{"See also: ", 
              ButtonBox["ExplicitPartialD", 
                RuleDelayed[ButtonData, "ExplicitPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExplicitPartialD"]], ", ", 
              ButtonBox["LeftPartialD", 
                RuleDelayed[ButtonData, "LeftPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftPartialD"]], ", ", 
              ButtonBox["LeftRightPartialD", 
                RuleDelayed[ButtonData, "LeftRightPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftRightPartialD"]], ", ", 
              ButtonBox["PartialDRelations", 
                RuleDelayed[ButtonData, "PartialDRelations"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PartialDRelations"]], ", ", 
              ButtonBox["RightPartialD", 
                RuleDelayed[ButtonData, "RightPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "RightPartialD"]], "."}], "Text", 
            CellTags -> "ExpandPartialD"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ExpandPartialD"], Cell[CellGroupData[{Cell[BoxData[
                \(\(RightPartialD[\[Mu]]\) . 
                   \(QuantumField[\(A, \(LorentzIndex[\[Mu]]\)\)]\) . 
                   \(QuantumField[\(A, \(LorentzIndex[\[Nu]]\)\)]\)\)], 
               "Input", CellTags -> "ExpandPartialD"], Cell[BoxData[
                FormBox[RowBox[{SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                    FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", \(A\_\[Mu]\), ".", \(A\_\[Nu]\)
                   }], TraditionalForm]], "Output", CellTags -> 
                "ExpandPartialD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ExpandPartialD[%]\)], "Input", CellTags -> 
                "ExpandPartialD"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(A\_\[Mu]\), ".", RowBox[{SubscriptBox["\[PartialD]", 
                        FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], "\[Null]"]}]}], "+", 
                   RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], "\[Null]"]}], ".", \(A\_\[Nu]\)}]
                     }], TraditionalForm]], "Output", CellTags -> 
                "ExpandPartialD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%//StandardForm\)], "Input", CellTags -> "ExpandPartialD"], 
              Cell[BoxData[
                \(\(\(QuantumField[\(A, \(LorentzIndex[\[Mu]]\)\)]\) . 
                     \(QuantumField[\(\(PartialD[\(LorentzIndex[\[Mu]]\)]\), 
                         A, \(LorentzIndex[\[Nu]]\)\)]\)\) + 
                   \(\(QuantumField[\(\(PartialD[\(LorentzIndex[\[Mu]]\)]\), 
                         A, \(LorentzIndex[\[Mu]]\)\)]\) . 
                     \(QuantumField[\(A, \(LorentzIndex[\[Nu]]\)\)]\)\)\)], 
               "Output", CellTags -> "ExpandPartialD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(LeftRightPartialD[\[Mu]]\) . 
                   \(QuantumField[\(A, \(LorentzIndex[\[Nu]]\)\)]\)\)], 
               "Input", CellTags -> "ExpandPartialD"], Cell[BoxData[
                FormBox[RowBox[{SubscriptBox[
                    \(\[PartialD]\&\[LeftRightArrow]\), FormBox[FormBox[
                      "\[Mu]", "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(A\_\[Nu]\)}], TraditionalForm]], "Output", CellTags -> 
                "ExpandPartialD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ExpandPartialD[%]\)], "Input", CellTags -> 
                "ExpandPartialD"], Cell[BoxData[FormBox[RowBox[{\(1\/2\), 
                   " ", RowBox[{"(", RowBox[{RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[Null]"]}], "-", RowBox[{SubscriptBox[
                          \(\[PartialD]\&\[LeftArrow]\), FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                         ".", \(A\_\[Nu]\)}]}], ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "ExpandPartialD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(QuantumField[\(A, \(LorentzIndex[\[Mu]]\)\)]\) . 
                   \((\(LeftRightPartialD[OPEDelta]\)^2)\) . 
                   \(QuantumField[\(A, \(LorentzIndex[\[Rho]]\)\)]\)\)], 
               "Input", CellTags -> "ExpandPartialD"], Cell[BoxData[
                FormBox[RowBox[{\(A\_\[Mu]\), ".", SubsuperscriptBox[
                    \(\[PartialD]\&\[LeftRightArrow]\), FormBox[
                     "\[CapitalDelta]", "TraditionalForm"], "2"], ".", 
                   \(A\_\[Rho]\)}], TraditionalForm]], "Output", CellTags -> 
                "ExpandPartialD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ExpandPartialD[%]\)], "Input", CellTags -> 
                "ExpandPartialD"], Cell[BoxData[FormBox[RowBox[{\(1\/4\), 
                   " ", RowBox[{"(", RowBox[{RowBox[{\(A\_\[Mu]\), ".", 
                         RowBox[{"(", RowBox[{RowBox[{FormBox[SubscriptBox[
                          "\[PartialD]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                          SubscriptBox["\[PartialD]", FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]], 
                          "TraditionalForm"]}], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], "\[Null]"]}], ")"}]}], "-", 
                       RowBox[{"2", " ", RowBox[{RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[Null]"]}], ".", RowBox[
                          {SubscriptBox["\[PartialD]", FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]], 
                          SubsuperscriptBox["A", FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[Null]"]}]}]}], "+", RowBox[{RowBox[{"(", RowBox[
                          {RowBox[{FormBox[SubscriptBox["\[PartialD]", 
                          FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                          "TraditionalForm"], FormBox[SubscriptBox[
                          "\[PartialD]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]], "TraditionalForm"]}], 
                          SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[Null]"]}], ")"}], ".", \(A\_\[Rho]\)}]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "ExpandPartialD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(8\ \(\(LeftRightPartialD[OPEDelta]\)^3\)\)], "Input", 
               CellTags -> "ExpandPartialD"], Cell[BoxData[FormBox[
                 RowBox[{"8", " ", SubsuperscriptBox[
                    \(\[PartialD]\&\[LeftRightArrow]\), FormBox[
                     "\[CapitalDelta]", "TraditionalForm"], "3"]}], 
                 TraditionalForm]], "Output", CellTags -> "ExpandPartialD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(ExplicitPartialD[%]\)]
                , "Input", CellTags -> "ExpandPartialD"], Cell[BoxData[
                FormBox[SuperscriptBox[RowBox[{"(", RowBox[{SubscriptBox[
                       \(\[PartialD]\&\[RightArrow]\), FormBox[
                        "\[CapitalDelta]", "TraditionalForm"]], "-", 
                      SubscriptBox[\(\[PartialD]\&\[LeftArrow]\), FormBox[
                        "\[CapitalDelta]", "TraditionalForm"]]}], ")"}], 
                  "3"], TraditionalForm]], "Output", CellTags -> 
                "ExpandPartialD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ExpandPartialD[%]\)], "Input", CellTags -> 
                "ExpandPartialD"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"-", RowBox[{SubscriptBox[
                        \(\[PartialD]\&\[LeftArrow]\), FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]], ".", 
                       SubscriptBox[\(\[PartialD]\&\[LeftArrow]\), FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]], ".", 
                       SubscriptBox[\(\[PartialD]\&\[LeftArrow]\), FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]]}]}], "+", 
                   RowBox[{"3", " ", RowBox[{SubscriptBox[
                        \(\[PartialD]\&\[LeftArrow]\), FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]], ".", 
                       SubscriptBox[\(\[PartialD]\&\[LeftArrow]\), FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]], ".", 
                       SubscriptBox[\(\[PartialD]\&\[RightArrow]\), FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]]}]}], "-", 
                   RowBox[{"3", " ", RowBox[{SubscriptBox[
                        \(\[PartialD]\&\[LeftArrow]\), FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]], ".", 
                       SubscriptBox[\(\[PartialD]\&\[RightArrow]\), FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]], ".", 
                       SubscriptBox[\(\[PartialD]\&\[RightArrow]\), FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]]}]}], "+", 
                   RowBox[{SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                      FormBox["\[CapitalDelta]", "TraditionalForm"]], ".", 
                     SubscriptBox[\(\[PartialD]\&\[RightArrow]\), FormBox[
                       "\[CapitalDelta]", "TraditionalForm"]], ".", 
                     SubscriptBox[\(\[PartialD]\&\[RightArrow]\), FormBox[
                       "\[CapitalDelta]", "TraditionalForm"]]}]}], 
                 TraditionalForm]], "Output", CellTags -> "ExpandPartialD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(LeviCivita[\(\[Mu], \[Nu], \[Rho], \[Tau]\)]\)\ 
                   \(RightPartialD[\(\[Alpha], \[Mu], \[Beta], \[Nu]\)]\)\)], 
               "Input", CellTags -> "ExpandPartialD"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{SubscriptBox[
                      \(\[PartialD]\&\[RightArrow]\), FormBox[FormBox[
                        "\[Alpha]", "TraditionalForm"], "TraditionalForm"]], 
                     ".", SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], ".", SubscriptBox[
                      \(\[PartialD]\&\[RightArrow]\), FormBox[FormBox[
                        "\[Beta]", "TraditionalForm"], "TraditionalForm"]], 
                     ".", SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"]]}], " ", SuperscriptBox[
                    "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Tau]", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "ExpandPartialD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ExpandPartialD[%]\)], "Input", 
               CellTags -> "ExpandPartialD"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> 
                "ExpandPartialD"]}, Open]]}, Open]], 
        Cell["ExpandScalarProduct, ScalarProductExpand", "ObjectName", 
         CellTags -> {"ExpandScalarProduct", "ScalarProductExpand"}], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> {"ExpandScalarProduct", "ScalarProductExpand"}], 
           Cell["ExpandScalarProduct[expr] expands scalar products of sums of \
momenta in expr. ExpandScalarProduct does not use Expand on \
expr.\nScalarProductExpand=ExpandScalarProduct.", "Text", 
            CellTags -> {"ExpandScalarProduct", "ScalarProductExpand"}], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[ExpandScalarProduct]\)]
                , "Input", CellTags -> {"ExpandScalarProduct", 
                 "ScalarProductExpand"}], Cell[BoxData[
                \(TraditionalForm\`\({FeynCalcInternal \[Rule] True}\)\)], 
               "Output", CellTags -> {"ExpandScalarProduct", 
                 "ScalarProductExpand"}]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Calc", RuleDelayed[ButtonData, "Calc"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Calc"]], 
              ", ", 
              ButtonBox["MomentumExpand", 
                RuleDelayed[ButtonData, "MomentumExpand"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MomentumExpand"]], ", ", 
              ButtonBox["MomentumCombine", 
                RuleDelayed[ButtonData, "MomentumCombine"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MomentumCombine"]], "."}], "Text", 
            CellTags -> {"ExpandScalarProduct", "ScalarProductExpand"}]}, 
          Open]], Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> {"ExpandScalarProduct", "ScalarProductExpand"}], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\ \(SP[\(\(p1 + p2 + p3\), \(p4 + p5 + p6\)\)]\)\)], 
               "Input", CellTags -> {"ExpandScalarProduct", 
                 "ScalarProductExpand"}], Cell[BoxData[FormBox[RowBox[
                  {"(", FormBox[
                    \(\(\*TagBox[StyleBox["\"p\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_1 + 
                       \(\*TagBox[StyleBox["\"p\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_2 + 
                       \(\*TagBox[StyleBox["\"p\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_3\), 
                    "TraditionalForm"], ")", "\[CenterDot]", "(", FormBox[
                    \(\(\*TagBox[StyleBox["\"p\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_4 + 
                       \(\*TagBox[StyleBox["\"p\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_5 + 
                       \(\*TagBox[StyleBox["\"p\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_6\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> {"ExpandScalarProduct", "ScalarProductExpand"}]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%//ScalarProductExpand\)], "Input", CellTags -> 
                {"ExpandScalarProduct", "ScalarProductExpand"}], 
              Cell[BoxData[FormBox[RowBox[{"(", FormBox[
                    \(\(\*TagBox[StyleBox["\"p\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_1 + 
                       \(\*TagBox[StyleBox["\"p\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_2 + 
                       \(\*TagBox[StyleBox["\"p\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_3\), 
                    "TraditionalForm"], ")", "\[CenterDot]", "(", FormBox[
                    \(\(\*TagBox[StyleBox["\"p\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_4 + 
                       \(\*TagBox[StyleBox["\"p\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_5 + 
                       \(\*TagBox[StyleBox["\"p\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_6\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> {"ExpandScalarProduct", "ScalarProductExpand"}]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(SP[\(p, \(p - q\)\)]\)
                ], "Input", CellTags -> {"ExpandScalarProduct", 
                 "ScalarProductExpand"}], Cell[BoxData[FormBox[RowBox[
                  {FormBox["p", "TraditionalForm"], "\[CenterDot]", "(", 
                   FormBox[\(p - q\), "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> 
                {"ExpandScalarProduct", "ScalarProductExpand"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ExpandScalarProduct[%]\)], 
               "Input", CellTags -> {"ExpandScalarProduct", 
                 "ScalarProductExpand"}], Cell[BoxData[FormBox[RowBox[
                  {FormBox["p", "TraditionalForm"], "\[CenterDot]", "(", 
                   FormBox[\(p - q\), "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> 
                {"ExpandScalarProduct", "ScalarProductExpand"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(FV[\(\(p - q\), \[Mu]\)]\)], 
               "Input", CellTags -> {"ExpandScalarProduct", 
                 "ScalarProductExpand"}], Cell[BoxData[FormBox[SuperscriptBox[
                  FormBox[\(p - q\), "TraditionalForm"], "\[Mu]"], 
                 TraditionalForm]], "Output", CellTags -> 
                {"ExpandScalarProduct", "ScalarProductExpand"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ExpandScalarProduct[%]\)], 
               "Input", CellTags -> {"ExpandScalarProduct", 
                 "ScalarProductExpand"}], Cell[BoxData[FormBox[SuperscriptBox[
                  FormBox[\(p - q\), "TraditionalForm"], "\[Mu]"], 
                 TraditionalForm]], "Output", CellTags -> 
                {"ExpandScalarProduct", "ScalarProductExpand"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SP[\(\(p - q\), \(q - r\)\)]\)//FCI\)], "Input", 
               CellTags -> {"ExpandScalarProduct", "ScalarProductExpand"}], 
              Cell[BoxData[FormBox[RowBox[{"(", FormBox[\(p - q\), 
                    "TraditionalForm"], ")", "\[CenterDot]", "(", FormBox[
                    \(q - r\), "TraditionalForm"], ")"}], TraditionalForm]], 
               "Output", CellTags -> {"ExpandScalarProduct", 
                 "ScalarProductExpand"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(%/.\(Pair \[Rule] ExpandScalarProduct\)\)], "Input", 
               CellTags -> {"ExpandScalarProduct", "ScalarProductExpand"}], 
              Cell[BoxData[FormBox[RowBox[{RowBox[{FormBox["p", 
                      "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                      "TraditionalForm"]}], "-", RowBox[{FormBox["p", 
                      "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                      "TraditionalForm"]}], "-", SuperscriptBox[FormBox["q", 
                     "TraditionalForm"], "2"], "+", RowBox[{FormBox["q", 
                      "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                      "TraditionalForm"]}]}], TraditionalForm]], "Output", 
               CellTags -> {"ExpandScalarProduct", "ScalarProductExpand"}]}, 
             Open]]}, Open]], Cell["Expand2", "ObjectName", 
         CellTags -> "Expand2"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Expand2"], 
           Cell["Expand2[exp, x] expands all sums containing x. Expand2[exp, \
{x1, x2, ...}]  expands all sums containing x1, x2, ....", "Text", 
            CellTags -> "Expand2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Expand2"], Cell[CellGroupData[{Cell[BoxData[
                \(Expand2[\(\(\(\((x1 + x2 + x3)\) \((\(2x1\) + \(3x2\))\)\) 
                       + \(\((y1 + y2 + y3)\) \((\(2y1\) + \(3y2\))\)\)\), 
                     \({x1, x2}\)\)]\)], "Input", CellTags -> "Expand2"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(2\ x1\^2\) + \(5\ x2\ x1\) + 
                     \(2\ x3\ x1\) + \(3\ x2\^2\) + \(3\ x2\ x3\) + 
                     \(\((\(2\ y1\) + \(3\ y2\))\)\ \((y1 + y2 + y3)\)\)\)\)]\
, "Output", CellTags -> "Expand2"]}, Open]]}, Open]], Cell["Explicit", 
         "ObjectName", CellTags -> "Explicit"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Explicit"], Cell[TextData[{"Explicit is an option \
for FieldStrength, GluonVertex, SUNF, and Twist2GluonOperator. If set to True \
the full form of the operator is inserted. ", 
              StyleBox["Explicit[exp]", 
                Rule[FontVariations, List[Rule["CompatibilityType", 0]]]], " \
inserts explicit expressions of GluonVertex, Twist2GluonOperator etc. in exp. \
SUNF's are replaced by SUNTrace objects."}], "Text", CellTags -> "Explicit"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["GluonVertex", RuleDelayed[ButtonData, 
                 "GluonVertex"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonVertex"]], ", ", 
              ButtonBox["Twist2GluonOperator", 
                RuleDelayed[ButtonData, "Twist2GluonOperator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Twist2GluonOperator"]], "."}], "Text", 
            CellTags -> "Explicit"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[Explicit]\)], "Input"], Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Gauge \[Rule] 1\), 
                      \(\[CapitalOmega] \[Rule] False\)}\)\)], "Output"]}, 
             Open]]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "Explicit"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(GluonPropagator[\(p, \[Mu], \[Nu]\)]\)], "Input"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\[CapitalPi]\_g\%\(\[Mu]\[Nu]\)(p)\)\)], 
               "Output"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Explicit[%]\)], "Input"], Cell[BoxData[
                \(TraditionalForm\`\(-\(\(\[ImaginaryI]\ g\^\(\[Mu]\[Nu]\)\)
                       \/p\^2\)\)\)], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Explicit[\(\(GluonPropagator[\(p, \[Mu], \[Nu]\)]\), 
                     \(Gauge \[Rule] \[Xi]\)\)]\)], "Input"], 
              Cell[BoxData[FormBox[FractionBox[RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"(", RowBox[{FractionBox[RowBox[{\((1 - \[Xi])\), 
                          " ", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], \(p\^2\)], "-", 
                        \(g\^\(\[Mu]\[Nu]\)\)}], ")"}]}], \(p\^2\)], 
                 TraditionalForm]], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(GluonVertex[\(p, \[Mu], a,\ q, \[Nu], b, r, \[Rho], c\)]\)]\
, "Input", CellTags -> "Explicit"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{SuperscriptBox["V", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]}]], "(", 
                     RowBox[{FormBox["p", "TraditionalForm"], \(,\ \), 
                       FormBox["q", "TraditionalForm"], \(,\ \), FormBox["r", 
                        "TraditionalForm"]}], ")"}], " ", SubscriptBox["f", 
                    RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Explicit"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Explicit[%]\)], "Input", CellTags -> 
                "Explicit"], Cell[BoxData[FormBox[RowBox[{\(g\_s\), " ", 
                   RowBox[{"(", RowBox[{RowBox[{RowBox[{"(", RowBox[
                          {SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "-", SuperscriptBox[FormBox[
                          "r", "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], ")"}], 
                         " ", \(g\^\(\[Nu]\[Rho]\)\)}], "+", RowBox[{
                         \(g\^\(\[Mu]\[Rho]\)\), " ", RowBox[{"(", RowBox[
                          {SuperscriptBox[FormBox["r", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], "-", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], ")"}]}], 
                       "+", RowBox[{\(g\^\(\[Mu]\[Nu]\)\), " ", RowBox[
                          {"(", RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], "-", 
                          SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}]}], ")"}], " ", 
                   SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Explicit"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Twist2GluonOperator[\(p, \[Mu], a, \[Nu], b\)]\)]
                , "Input", CellTags -> "Explicit"], Cell[BoxData[
                FormBox[RowBox[{\(1\/2\), " ", RowBox[{"(", RowBox[{FormBox[
                        \(\((\(-1\))\)\^m\), "TraditionalForm"], "+", "1"}], 
                     ")"}], " ", SubscriptBox["\[Delta]", RowBox[
                     {FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"]}]], " ", 
                   RowBox[{"(", RowBox[{SubsuperscriptBox["O", RowBox[
                         {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]}], "G2"], "(", FormBox["p", 
                        "TraditionalForm"], ")"}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "Explicit"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(Explicit[%]\)], 
               "Input", CellTags -> "Explicit"], Cell[BoxData[FormBox[RowBox[{
                   \(1\/2\), " ", RowBox[{"(", RowBox[{RowBox[{
                         \(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[FormBox[
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                       "-", RowBox[{RowBox[{"(", RowBox[{RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}]}], ")"}], 
                         " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"]}]}], ")"}], " ", 
                   RowBox[{"(", RowBox[{FormBox[\(\((\(-1\))\)\^m\), 
                        "TraditionalForm"], "+", "1"}], ")"}], " ", 
                   FormBox[SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                       ")"}], \(m - 2\)], "TraditionalForm"], " ", 
                   SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Explicit"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(FieldStrength[\(\[Mu], \[Nu], a\)]\)], "Input", 
               CellTags -> "Explicit"], Cell[BoxData[
                \(TraditionalForm\`F\_\(\[Mu]\[Nu]\)\%a\)], "Output", 
               CellTags -> "Explicit"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Explicit[%]\)], "Input", CellTags -> 
                "Explicit"], Cell[BoxData[FormBox[RowBox[{RowBox[
                    {SubscriptBox["\[PartialD]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]]}], "-", 
                   RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                        "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]]}], "+", 
                   RowBox[{\(g\_s\), " ", RowBox[{SubsuperscriptBox[FormBox[
                         "A", "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b1", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SubsuperscriptBox[FormBox[
                         "A", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c16", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c16", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "Explicit"]}, Open]]}, Open]], 
        Cell["ExplicitLorentzIndex", "ObjectName", CellTags -> 
          "ExplicitLorentzIndex"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "ExplicitLorentzIndex"], Cell["ExplicitLorentzIndex[ind] is an \
explicit Lorentz index, i.e., ind is an integer.", "Text", 
            CellTags -> "ExplicitLorentzIndex"], Cell[TextData[{"See also: ", 
              ButtonBox["LorentzIndex", 
                RuleDelayed[ButtonData, "LorentzIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LorentzIndex"]], ", ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              "."}], "Text", CellTags -> "ExplicitLorentzIndex"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ExplicitLorentzIndex"], Cell[CellGroupData[
             {Cell[BoxData[
                \(Pair[\(\(LorentzIndex[1]\), \(LorentzIndex[\[Mu]]\)\)]\)], 
               "Input", CellTags -> "ExplicitLorentzIndex"], Cell[BoxData[
                FormBox[SuperscriptBox["g", RowBox[{FormBox["1", 
                     "TraditionalForm"], "\[Mu]"}]], TraditionalForm]], 
               "Output", CellTags -> "ExplicitLorentzIndex"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "ExplicitLorentzIndex"], Cell[BoxData[
                \(Pair[\(\(ExplicitLorentzIndex[1]\), \(LorentzIndex[\[Mu]]\)
                    \)]\)], "Output", CellTags -> "ExplicitLorentzIndex"]}, 
             Open]]}, Open]], Cell["ExplicitPartialD", "ObjectName", 
         CellTags -> "ExplicitPartialD"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "ExplicitPartialD"], Cell["ExplicitPartialD[exp] inserts in exp \
the definition for LeftRightPartialD[z] (and LeftRightPartialD2[z]).", 
            "Text", CellTags -> "ExplicitPartialD"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["ExpandPartialD", 
                RuleDelayed[ButtonData, "ExpandPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandPartialD"]], ", ", 
              ButtonBox["LeftRightPartialD", 
                RuleDelayed[ButtonData, "LeftRightPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftRightPartialD"]], ", ", 
              ButtonBox["LeftRightPartialD2", 
                RuleDelayed[ButtonData, "LeftRightPartialD2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftRightPartialD2"]], "."}], "Text", 
            CellTags -> "ExplicitPartialD"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ExplicitPartialD"], Cell[CellGroupData[{Cell[BoxData[
                \(ExplicitPartialD[\ \(LeftRightPartialD[\[Mu]]\)\ ]\)], 
               "Input", CellTags -> "ExplicitPartialD"], Cell[BoxData[
                FormBox[RowBox[{\(1\/2\), " ", RowBox[{"(", RowBox[
                      {SubscriptBox[\(\[PartialD]\&\[RightArrow]\), FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], "-", SubscriptBox[
                        \(\[PartialD]\&\[LeftArrow]\), FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "ExplicitPartialD"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(ExplicitPartialD[\ \(LeftRightPartialD2[\[Mu]]\)\ ]\)], 
               "Input", CellTags -> "ExplicitPartialD"], Cell[BoxData[
                FormBox[RowBox[{SubscriptBox[\(\[PartialD]\&\[LeftArrow]\), 
                    FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], "+", SubscriptBox[
                    \(\[PartialD]\&\[RightArrow]\), FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "ExplicitPartialD"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(ExplicitPartialD[\ \(LeftRightPartialD[OPEDelta]\)\ ]\)], 
               "Input", CellTags -> "ExplicitPartialD"], Cell[BoxData[
                FormBox[RowBox[{\(1\/2\), " ", RowBox[{"(", RowBox[
                      {SubscriptBox[\(\[PartialD]\&\[RightArrow]\), FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]], "-", 
                       SubscriptBox[\(\[PartialD]\&\[LeftArrow]\), FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "ExplicitPartialD"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(16\ \(\(LeftRightPartialD[OPEDelta]\)^4\)\)], 
               "Input", CellTags -> "ExplicitPartialD"], Cell[BoxData[
                FormBox[RowBox[{"16", " ", SubsuperscriptBox[
                    \(\[PartialD]\&\[LeftRightArrow]\), FormBox[
                     "\[CapitalDelta]", "TraditionalForm"], "4"]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "ExplicitPartialD"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(ExplicitPartialD[%]\)], "Input", CellTags -> 
                "ExplicitPartialD"], Cell[BoxData[FormBox[SuperscriptBox[
                  RowBox[{"(", RowBox[{SubscriptBox[
                       \(\[PartialD]\&\[RightArrow]\), FormBox[
                        "\[CapitalDelta]", "TraditionalForm"]], "-", 
                      SubscriptBox[\(\[PartialD]\&\[LeftArrow]\), FormBox[
                        "\[CapitalDelta]", "TraditionalForm"]]}], ")"}], 
                  "4"], TraditionalForm]], "Output", CellTags -> 
                "ExplicitPartialD"]}, Open]]}, Open]], 
        Cell["ExplicitSUNIndex", "ObjectName", CellTags -> 
          "ExplicitSUNIndex"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "ExplicitSUNIndex"], Cell[TextData[
             {"ExplicitSUNIndex[ind] is a specific SU(", 
              StyleBox["N", Rule[FontSlant, "Italic"]], 
              ") index, i.e., ind is an integer."}], "Text", 
            CellTags -> "ExplicitSUNIndex"], Cell[TextData[{"See also: ", 
              ButtonBox["FCI", RuleDelayed[ButtonData, "FCI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCI"]], 
              ", ", 
              ButtonBox["SUNDelta", RuleDelayed[ButtonData, "SUNDelta"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNDelta"]], ", ", 
              ButtonBox["SUNF", RuleDelayed[ButtonData, "SUNF"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SUNF"]], 
              ", ", 
              ButtonBox["SUNIndex", RuleDelayed[ButtonData, "SUNIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNIndex"]], "."}], "Text", 
            CellTags -> "ExplicitSUNIndex"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ExplicitSUNIndex"], Cell[CellGroupData[{Cell[BoxData[
                \(ExplicitSUNIndex[1]\)], "Input", CellTags -> 
                "ExplicitSUNIndex"], Cell[BoxData[\(TraditionalForm\`1\)], 
               "Output", CellTags -> "ExplicitSUNIndex"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SUNDelta[\(1, a\)]\)//FCI\)//StandardForm\)], "Input"], 
              Cell[BoxData[
                \(SUNDelta[\(\(ExplicitSUNIndex[1]\), \(SUNIndex[a]\)\)]\)], 
               "Output"]}, Open]]}, Open]], Cell["ExtraFactor", "ObjectName", 
         CellTags -> "ExtraFactor"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "ExtraFactor"], 
           Cell["ExtraFactor is an option for FermionSpinSum. The setting \
ExtraFactor \[Rule] fa  multiplies the whole amplitude with the factor fa \
before squaring.", "Text", CellTags -> "ExtraFactor"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["FermionSpinSum", 
                RuleDelayed[ButtonData, "FermionSpinSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FermionSpinSum"]], "."}], "Text", 
            CellTags -> "ExtraFactor"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["ExtraVariables", "ObjectName", CellTags -> "ExtraVariables"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ExtraVariables"], Cell["ExtraVariables is an option \
for OneLoopSum; it may be set to a list of variables which are also bracketed \
out in the result, just like B0, C0, D0 and  PaVe.", "Text", 
            CellTags -> "ExtraVariables"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, ", ", 
              ButtonBox["OneLoopSum", RuleDelayed[ButtonData, "OneLoopSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSum"]], "."}], "Text", 
            CellTags -> "ExtraVariables"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["FactorFull", "ObjectName", CellTags -> "FactorFull"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FactorFull"], Cell[TextData[{"FactorFull is an \
option of Factor2 (default False). If set to False, products like (", 
              StyleBox["a", Rule[FontSlant, "Italic"]], "-", 
              StyleBox["b", Rule[FontSlant, "Italic"]], ") (", 
              StyleBox["a", Rule[FontSlant, "Italic"]], "+", 
              StyleBox["b", Rule[FontSlant, "Italic"]], 
              ") will be replaced by (", Cell[BoxData[
                \(TraditionalForm\`\(a\^2\)\)]], "-", Cell[BoxData[
                \(TraditionalForm\`\(b\^2\)\)]], ")."}], "Text", 
            CellTags -> "FactorFull"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Factor2", RuleDelayed[ButtonData, "Factor2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Factor2"]]\
, "."}], "Text", CellTags -> "FactorFull"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["Factoring", "ObjectName", CellTags -> "Factoring"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Factoring"], Cell["Factoring is an option for \
Collect2, Contract, Tr and more functions. If set to True, the result will be \
factored, using Factor2. If set to any function f, this function will be \
used.", "Text", CellTags -> "Factoring"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Collect2", RuleDelayed[ButtonData, "Collect2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Collect2"]], ", ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], ", ", 
              ButtonBox["Tr", RuleDelayed[ButtonData, "Tr"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Tr"]], 
              "."}], "Text", CellTags -> "Factoring"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["Factorout", "ObjectName", 
         CellTags -> "Factorout"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Factorout"], 
           Cell["Factorout is an option for OPEInt and OPEIntegrate.", 
            "Text", CellTags -> "Factorout"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["OPEInt", RuleDelayed[ButtonData, "OPEInt"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OPEInt"]], 
              ", ", 
              ButtonBox["OPEIntegrate", 
                RuleDelayed[ButtonData, "OPEIntegrate"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OPEIntegrate"]], "."}], "Text", 
            CellTags -> "Factorout"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["Factor1", "ObjectName", CellTags -> "Factor1"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Factor1"], Cell["Factor1[poly] factorizes common \
terms  in the summands of poly. It uses basically PolynomialGCD.", "Text", 
            CellTags -> "Factor1"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Factor2", RuleDelayed[ButtonData, "Factor2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Factor2"]]\
, "."}], "Text", CellTags -> "Factor1"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Factor1"], Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(\((a - x)\) \((b - x)\)\)\)], "Input", CellTags -> 
                "Factor1"], Cell[BoxData[
                \(TraditionalForm\`\(\((a - x)\)\ \((b - x)\)\)\)], "Output", 
               CellTags -> "Factor1"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(t2 = \({\(Factor1[t1]\),\ \(Factor[t1]\)}\)\)], 
               "Input", CellTags -> "Factor1"], Cell[BoxData[
                \(TraditionalForm\`\({\(\((a - x)\)\ \((b - x)\)\), 
                      \(\(-\((a - x)\)\)\ \((x - b)\)\)}\)\)], "Output", 
               CellTags -> "Factor1"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(t3 = \(Expand[\(\((a - b)\) \((a + b)\)\)]\)\)], 
               "Input", CellTags -> "Factor1"], Cell[BoxData[
                \(TraditionalForm\`\(a\^2 - b\^2\)\)], "Output", CellTags -> 
                "Factor1"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Factor[t3]\)], "Input", CellTags -> "Factor1"], 
              Cell[BoxData[\(TraditionalForm\`\(\((a - b)\)\ \((a + b)\)\)\)]
                , "Output", CellTags -> "Factor1"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Factor1[t3]\)], "Input", 
               CellTags -> "Factor1"], Cell[BoxData[
                \(TraditionalForm\`\(a\^2 - b\^2\)\)], "Output", CellTags -> 
                "Factor1"]}, Open]], Cell[BoxData[\(Clear[\(t1, t2, t3\)]\)], 
            "Input", CellTags -> "Factor1"]}, Open]], 
        Cell["Factor2", "ObjectName", CellTags -> "Factor2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Factor2"], Cell["Factor2[poly] factors a polynomial \
in a standard way. Factor2 works sometimes better than Factor on polynomials \
involving rationals with sums in the denominator. Factor2 uses Factor \
internally and is in general slower than Factor. There are four possible \
settings of the option Method (0,1,2,3). In general Factor will work faster \
than Factor2.", "Text", CellTags -> "Factor2"], Cell[CellGroupData[
             {Cell[BoxData[\(Options[Factor2]\)], "Input", CellTags -> 
                "Factor2"], Cell[BoxData[
                \(TraditionalForm\`\({\(HighEnergyPhysics`FeynCalc`FactorFul\
l`FactorFull \[Rule] False\), \(Method \[Rule] 3\)}\)\)], "Output", 
               CellTags -> "Factor2"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Collect2", RuleDelayed[ButtonData, "Collect2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Collect2"]], "."}], "Text", 
            CellTags -> "Factor2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Factor2"], Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(\((a - x)\) \((b - x)\)\)\)], "Input", CellTags -> 
                "Factor2"], Cell[BoxData[
                \(TraditionalForm\`\(\((a - x)\)\ \((b - x)\)\)\)], "Output", 
               CellTags -> "Factor2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(t2 = \({\(Factor2[t1]\),\ \(Factor[t1]\)}\)\)], 
               "Input", CellTags -> "Factor2"], Cell[BoxData[
                \(TraditionalForm\`\({\(\((a - x)\)\ \((b - x)\)\), 
                      \(\(-\((a - x)\)\)\ \((x - b)\)\)}\)\)], "Output", 
               CellTags -> "Factor2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(t3 = \(Expand[\(\((a - b)\) \((a + b)\)\)]\)\)], 
               "Input", CellTags -> "Factor2"], Cell[BoxData[
                \(TraditionalForm\`\(a\^2 - b\^2\)\)], "Output", CellTags -> 
                "Factor2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Factor[t3]\)], "Input", CellTags -> "Factor2"], 
              Cell[BoxData[\(TraditionalForm\`\(\((a - b)\)\ \((a + b)\)\)\)]
                , "Output", CellTags -> "Factor2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Factor2[t3]\)], "Input", 
               CellTags -> "Factor2"], Cell[BoxData[
                \(TraditionalForm\`\(a\^2 - b\^2\)\)], "Output", CellTags -> 
                "Factor2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Factor2[\(t3, \(FactorFull \[Rule] True\)\)]\)], "Input", 
               CellTags -> "Factor2"], Cell[BoxData[
                \(TraditionalForm\`\(\((a - b)\)\ \((a + b)\)\)\)], "Output", 
               CellTags -> "Factor2"]}, Open]], Cell[BoxData[
             \(Clear[\(t1, t2, t3\)]\)], "Input", CellTags -> "Factor2"]}, 
          Open]], Cell["FAD", "ObjectName", CellTags -> "FAD"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FAD"], Cell["FAD is the FeynCalc external form of \
FeynAmpDenominator and denotes an inverse propagator. FAD[q, q-p, ...] is \
1/(q^2 (q-p)^2 ...). FAD[{q1,m}, {q1-p,m}, q2, ...] is 1/( (q1^2 - m^2) ( \
(q1-p)^2 - m^2 ) q2^2 ... ). Translation into FeynCalc internal form is \
performed by FeynCalcInternal.", "Text", CellTags -> "FAD"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FAD", RuleDelayed[ButtonData, "FAD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FAD"]], 
              ", ", 
              ButtonBox["FCE", RuleDelayed[ButtonData, "FCE"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCE"]], 
              ", ", 
              ButtonBox["FCI", RuleDelayed[ButtonData, "FCI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCI"]], 
              ", ", 
              ButtonBox["FeynAmpDenominator", 
                RuleDelayed[ButtonData, "FeynAmpDenominator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynAmpDenominator"]], ", ", 
              ButtonBox["FeynAmpDenominatorSimplify", 
                RuleDelayed[ButtonData, "FeynAmpDenominatorSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynAmpDenominatorSimplify"]], ", ", 
              ButtonBox["PropagatorDenominator", 
                RuleDelayed[ButtonData, "PropagatorDenominator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PropagatorDenominator"]], "."}], "Text", 
            CellTags -> "FAD"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "FAD"], 
           Cell[CellGroupData[{Cell[BoxData[\(FAD[\(q, \(p - q\)\)]\)], 
               "Input", CellTags -> "FAD"], Cell[BoxData[
                \(TraditionalForm\`\(1\/\(
                      \((\*InterpretationBox[\(
                            "["\[InvisibleSpace] \((p - q)\)\^2 
                             \[InvisibleSpace]"]"\), 
                           SequenceForm["[", 
                            Power[Plus[p, Times[-1, q]], 2], "]"], 
                           Rule[Editable, False]])\)\ 
                       \((\*InterpretationBox[\(
                            "["\[InvisibleSpace] q\^2 \[InvisibleSpace]"]"\)\
, SequenceForm["[", Power[q, 2], "]"], Rule[Editable, False]]\
)\)\)\)\)], "Output", CellTags -> "FAD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(FAD[\(p, \({\(p - q\), m}\)\)]\)
                ], "Input", CellTags -> "FAD"], Cell[BoxData[
                \(TraditionalForm\`\(1\/\(
                      \((\*InterpretationBox[\(
                            "["\[InvisibleSpace] p\^2 \[InvisibleSpace]"]"\)\
, SequenceForm["[", Power[p, 2], "]"], Rule[Editable, False]]\
)\)\ \((\*InterpretationBox[\(
                            "["\[InvisibleSpace] \((p - q)\)\^2 
                             \[InvisibleSpace]"-"\[InvisibleSpace] m\^2 
                             \[InvisibleSpace]"]"\), 
                           SequenceForm["[", 
                            Power[Plus[p, Times[-1, q]], 2], "-", 
                            Power[m, 2], "]"], Rule[Editable, False]])\)\)\)\
\)], "Output", CellTags -> "FAD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(FAD[\(q, \(p - q\)\)]\)//FCI\)//FCE\)//StandardForm\)]\
, "Input", CellTags -> "FAD"], Cell[BoxData[\(FAD[\(q, \(p - q\)\)]\)], 
               "Output", CellTags -> "FAD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(FAD[\(q, \(p - q\)\)]\)//FCI\)//StandardForm\)], 
               "Input", CellTags -> "FAD"], Cell[BoxData[
                \(FeynAmpDenominator[\(\(
                      PropagatorDenominator[\(\(Momentum[\(q, D\)]\), 0\)]\),
                      \(PropagatorDenominator[
                       \(\(\(Momentum[\(p, D\)]\) - \(Momentum[\(q, D\)]\)\),
                          0\)]\)\)]\)], "Output", CellTags -> "FAD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(FAD[p]\)\ \(FAD[\(p - q\)]\)\)\ //\ 
                     FeynAmpDenominatorCombine\)//StandardForm\)], "Input", 
               CellTags -> "FAD"], Cell[BoxData[
                \(FeynAmpDenominator[\(\(
                      PropagatorDenominator[\(\(Momentum[\(p, D\)]\), 0\)]\),
                      \(PropagatorDenominator[
                       \(\(\(Momentum[\(p, D\)]\) - \(Momentum[\(q, D\)]\)\),
                          0\)]\)\)]\)], "Output", CellTags -> "FAD"]}, 
             Open]]}, Open]], Cell["FC", "ObjectName", CellTags -> "FC"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FC"], Cell["FC changes the output format to \
FeynCalcForm. To change to InputForm use FI.", "Text", CellTags -> "FC"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalcForm", 
                RuleDelayed[ButtonData, "FeynCalcForm"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcForm"]], ", ", 
              ButtonBox["FI", RuleDelayed[ButtonData, "FI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FI"]], 
              ", ", 
              ButtonBox["FeynCalcExternal", 
                RuleDelayed[ButtonData, "FeynCalcExternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcExternal"]], ", ", 
              ButtonBox["FeynCalcInternal", 
                RuleDelayed[ButtonData, "FeynCalcInternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcInternal"]], "."}], "Text", 
            CellTags -> "FC"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "FC"], 
           Cell[BoxData["FI"], "Input", CellTags -> "FC"], 
           Cell[CellGroupData[{Cell[BoxData[
                \({\(DiracGamma[5]\), \(DiracGamma[\(Momentum[p]\)]\)}\)], 
               "Input", CellTags -> "FC"], Cell[
               "{DiracGamma[5], DiracGamma[Momentum[p]]}", "Output", 
               CellTags -> "FC"]}, Open]], Cell[BoxData["FC"], "Input", 
            CellTags -> "FC"], Cell[CellGroupData[{Cell[BoxData[
                \({\(DiracGamma[5]\), \(DiracGamma[\(Momentum[p]\)]\)}\)], 
               "Input", CellTags -> "FC"], Cell[BoxData[FormBox[
                 RowBox[{"{", RowBox[{\(\[Gamma]\^5\), ",", RowBox[
                      {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["p", "TraditionalForm"]}]}], 
                   "}"}], TraditionalForm]], "Output", CellTags -> "FC"]}, 
             Open]]}, Open]], Cell["FCE", "ObjectName", CellTags -> "FCE"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FCE"], Cell["FCE[exp] translates exp from the \
internal FeynCalc representation to a short form.", "Text", 
            CellTags -> "FCE"], Cell[
            "FCE is equivalent to FeynCalcExternal.", "Text", 
            CellTags -> "FCE"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalcExternal", 
                RuleDelayed[ButtonData, "FeynCalcExternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcExternal"]], ", ", 
              ButtonBox["FCI", RuleDelayed[ButtonData, "FCI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCI"]], 
              ", ", 
              ButtonBox["FeynCalcInternal", 
                RuleDelayed[ButtonData, "FeynCalcInternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcInternal"]], "."}], "Text", 
            CellTags -> "FCE"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "FCE"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FCE[\({\(DiracGamma[5]\), \(DiracGamma[\(Momentum[p]\)]\)}
                    \)]\)], "Input", CellTags -> "FCE"], Cell[BoxData[
                \(TraditionalForm\`\({\[Gamma]\^5, 
                      \(\[Gamma] \[CenterDot] p\)}\)\)], "Output", 
               CellTags -> "FCE"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%//StandardForm\)], "Input", CellTags -> "FCE"], 
              Cell[BoxData[\({\(GA[5]\), \(GS[p]\)}\)], "Output", CellTags -> 
                "FCE"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \({\(GA[\[Mu]]\), \(GAD[\[Rho]]\), \(GS[p]\), 
                    \(SP[\(p, q\)]\), \(MT[\(\[Alpha], \[Beta]\)]\), 
                    \(FV[\(p, \[Mu]\)]\)}\)], "Input", CellTags -> "FCE"], 
              Cell[BoxData[FormBox[RowBox[{"{", RowBox[{\(\[Gamma]\^\[Mu]\), 
                     ",", \(\[Gamma]\^\[Rho]\), ",", 
                     \(\[Gamma] \[CenterDot] p\), ",", FormBox[RowBox[
                       {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                        FormBox["q", "TraditionalForm"]}], 
                      "TraditionalForm"], ",", \(g\^\(\[Alpha]\[Beta]\)\), 
                     ",", \(p\^\[Mu]\)}], "}"}], TraditionalForm]], "Output", 
               CellTags -> "FCE"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%//StandardForm\)], "Input", CellTags -> "FCE"], 
              Cell[BoxData[
                \({\(GA[\[Mu]]\), \(GAD[\[Rho]]\), \(GS[p]\), 
                    \(SP[\(p, q\)]\), \(MT[\(\[Alpha], \[Beta]\)]\), 
                    \(FV[\(p, \[Mu]\)]\)}\)], "Output", CellTags -> "FCE"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(%//FCI\)], "Input", 
               CellTags -> "FCE"], Cell[BoxData[FormBox[RowBox[{"{", 
                   RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                     ",", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        "\[Rho]", "TraditionalForm"], "TraditionalForm"]], 
                     ",", RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                     ",", RowBox[{FormBox["p", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                     ",", \(g\^\(\[Alpha]\[Beta]\)\), ",", SuperscriptBox[
                      FormBox["p", "TraditionalForm"], FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]]}], 
                   "}"}], TraditionalForm]], "Output", CellTags -> "FCE"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], 
               "Input", CellTags -> "FCE"], Cell[BoxData[
                \({\(DiracGamma[\(LorentzIndex[\[Mu]]\)]\), 
                    \(DiracGamma[\(\(LorentzIndex[\(\[Rho], D\)]\), D\)]\), 
                    \(DiracGamma[\(Momentum[p]\)]\), 
                    \(Pair[\(\(Momentum[p]\), \(Momentum[q]\)\)]\), 
                    \(Pair[\(\(LorentzIndex[\[Alpha]]\), 
                        \(LorentzIndex[\[Beta]]\)\)]\), 
                    \(Pair[\(\(LorentzIndex[\[Mu]]\), \(Momentum[p]\)\)]\)}\)]\
, "Output", CellTags -> "FCE"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(FCE[%]\)//StandardForm\)], "Input", CellTags -> "FCE"], 
              Cell[BoxData[
                \({\(GA[\[Mu]]\), \(GAD[\[Rho]]\), \(GS[p]\), 
                    \(SP[\(p, q\)]\), \(MT[\(\[Alpha], \[Beta]\)]\), 
                    \(FV[\(p, \[Mu]\)]\)}\)], "Output", CellTags -> "FCE"]}, 
             Open]]}, Open]], Cell["FCI", "ObjectName", CellTags -> "FCI"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FCI"], Cell["FCI[exp] translates exp into the \
internal FeynCalc (datatype-)representation.FCI is equivalent to \
FeynCalcInternal.", "Text", CellTags -> "FCI"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalcExternal", 
                RuleDelayed[ButtonData, "FeynCalcExternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcExternal"]], ", ", 
              ButtonBox["FeynCalcInternal", 
                RuleDelayed[ButtonData, "FeynCalcInternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcInternal"]], ", ", 
              ButtonBox["FCE", RuleDelayed[ButtonData, "FCE"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCE"]], 
              "."}], "Text", CellTags -> "FCI"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FCI"], Cell[CellGroupData[{Cell[BoxData[
                \({\(GA[\[Mu]]\), \(GAD[\[Rho]]\), \(GS[p]\), 
                    \(SP[\(p, q\)]\), \(MT[\(\[Alpha], \[Beta]\)]\), 
                    \(FV[\(p, \[Mu]\)]\)}\)], "Input", CellTags -> "FCI"], 
              Cell[BoxData[FormBox[RowBox[{"{", RowBox[{\(\[Gamma]\^\[Mu]\), 
                     ",", \(\[Gamma]\^\[Rho]\), ",", 
                     \(\[Gamma] \[CenterDot] p\), ",", FormBox[RowBox[
                       {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                        FormBox["q", "TraditionalForm"]}], 
                      "TraditionalForm"], ",", \(g\^\(\[Alpha]\[Beta]\)\), 
                     ",", \(p\^\[Mu]\)}], "}"}], TraditionalForm]], "Output", 
               CellTags -> "FCI"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%//StandardForm\)], "Input", CellTags -> "FCI"], 
              Cell[BoxData[
                \({\(GA[\[Mu]]\), \(GAD[\[Rho]]\), \(GS[p]\), 
                    \(SP[\(p, q\)]\), \(MT[\(\[Alpha], \[Beta]\)]\), 
                    \(FV[\(p, \[Mu]\)]\)}\)], "Output", CellTags -> "FCI"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(%//FCI\)], "Input", 
               CellTags -> "FCI"], Cell[BoxData[FormBox[RowBox[{"{", 
                   RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                     ",", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        "\[Rho]", "TraditionalForm"], "TraditionalForm"]], 
                     ",", RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                     ",", RowBox[{FormBox["p", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                     ",", \(g\^\(\[Alpha]\[Beta]\)\), ",", SuperscriptBox[
                      FormBox["p", "TraditionalForm"], FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]]}], 
                   "}"}], TraditionalForm]], "Output", CellTags -> "FCI"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], 
               "Input", CellTags -> "FCI"], Cell[BoxData[
                \({\(DiracGamma[\(LorentzIndex[\[Mu]]\)]\), 
                    \(DiracGamma[\(\(LorentzIndex[\(\[Rho], D\)]\), D\)]\), 
                    \(DiracGamma[\(Momentum[p]\)]\), 
                    \(Pair[\(\(Momentum[p]\), \(Momentum[q]\)\)]\), 
                    \(Pair[\(\(LorentzIndex[\[Alpha]]\), 
                        \(LorentzIndex[\[Beta]]\)\)]\), 
                    \(Pair[\(\(LorentzIndex[\[Mu]]\), \(Momentum[p]\)\)]\)}\)]\
, "Output", CellTags -> "FCI"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(FCE[%]\)//StandardForm\)], "Input", CellTags -> "FCI"], 
              Cell[BoxData[
                \({\(GA[\[Mu]]\), \(GAD[\[Rho]]\), \(GS[p]\), 
                    \(SP[\(p, q\)]\), \(MT[\(\[Alpha], \[Beta]\)]\), 
                    \(FV[\(p, \[Mu]\)]\)}\)], "Output", CellTags -> "FCI"]}, 
             Open]]}, Open]], Cell["FCIntegral", "ObjectName", 
         CellTags -> "FCIntegral"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "FCIntegral"], 
           Cell["FCIntegral is the head of integrals in a setting of the \
option IntegralTable of FeynAmpDenominatorSimplify. Currently implemented \
only for 2-loop integrals.", "Text", CellTags -> "FCIntegral"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["IntegralTable", 
                RuleDelayed[ButtonData, "IntegralTable"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "IntegralTable"]], ", ", 
              ButtonBox["FeynAmpDenominatorSimplify", 
                RuleDelayed[ButtonData, "FeynAmpDenominatorSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynAmpDenominatorSimplify"]], "."}], 
            "Text", CellTags -> "FCIntegral"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["FCIntegrate", "ObjectName", CellTags -> 
          "FCIntegrate"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "FCIntegrate"], Cell["FCIntegrate is \
an option of certain Feynman integral related functions. It determines which \
integration function is used to evaluate analytic integrals. Possible \
settings include Integrate, NIntegrate, (Dot[Integratedx@@#2, #1] &).", 
            "Text", CellTags -> "FCIntegrate"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FCNIntegrate", 
                RuleDelayed[ButtonData, "FCNIntegrate"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FCNIntegrate"]], "."}], "Text", 
            CellTags -> "FCIntegrate"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["FCNIntegrate", "ObjectName", CellTags -> "FCNIntegrate"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FCNIntegrate"], Cell["FCNIntegrate is an option of \
certain Feynman integral related functions which may return output containing \
both integrals that can be evaluated and integrals that can only be evaluated \
numerically. It then determines which integration function is used to \
evaluate numeric integrals. Possible settings include NIntegrate, (0*#1)&, \
(Dot[Integratedx@@#2, #1] &).", "Text", CellTags -> "FCNIntegrate"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FCIntegrate", RuleDelayed[ButtonData, 
                 "FCIntegrate"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FCIntegrate"]], "."}], "Text", 
            CellTags -> "FCNIntegrate"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["FC2RHI ", "ObjectName", CellTags -> "FC2RHI"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FC2RHI"], Cell["FC2RHI[exp, k1, k2] transforms all \
2-loop OPE-integrals in FeynAmpDenominator form to the RHI-integrals.  \
FC2RHI[exp] is equivalent to FC2RHI[exp,q1,q2]. The option IncludePair \
governs the inclusion  of scalar products p.k1, p.k2 and k1.k2 (setting \
True).", "Text", CellTags -> "FC2RHI"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[FC2RHI]\)], "Input", CellTags -> "FC2RHI"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] D\), 
                      \(IncludePair \[Rule] True\), \(Do \[Rule] True\)}\)\)]\
, "Output", CellTags -> "FC2RHI"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t = \(\(\(FAD[\(q1, \(q1 - q2\), \(q2 - p\)\)]\)\ 
                       \(\(SP[\(q1, OPEDelta\)]\)^OPEm\)\)//FCI\)\)], 
               "Input"], Cell[BoxData[FormBox[FractionBox[SuperscriptBox[
                   RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                        "TraditionalForm"], "\[CenterDot]", FormBox[
                        \(\(\*TagBox[StyleBox["\"q\"", 
                               Rule[FontSlant, "Italic"]], 
                              Function[StyleForm[Slot[1], 
                                Rule[FontSlant, "Italic"]]]]\)\_1\), 
                        "TraditionalForm"]}], ")"}], "m"], 
                  \(\(\*TagBox[StyleBox["\"q\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]]\)\_1\%2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1 - 
                         \(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2)\)\^2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\)]\
, TraditionalForm]], "Output"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(FC2RHI[\(t, q1, q2\)]\)], "Input"], Cell[BoxData[
                FormBox[SubsuperscriptBox[
                  StyleBox["T", Rule[FontFamily, "Times"], 
                    Rule[FontWeight, "Bold"]], 
                  StyleBox[\(10011\), Rule[FontColor, 
                     RGBColor[0.`, 0.`, 1.`]]], RowBox[{FormBox["m", 
                     "TraditionalForm"], FormBox["0", "TraditionalForm"], 
                    FormBox["0", "TraditionalForm"], FormBox["0", 
                     "TraditionalForm"], FormBox["0", "TraditionalForm"]}]], 
                 TraditionalForm]], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//InputForm\)], "Input"], 
              Cell["RHI[{0, 0, OPEm, 0, 0}, {0, 1, 1, 0, 1}]", "Output"]}, 
             Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["RHI", RuleDelayed[ButtonData, "RHI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "RHI"]], 
              "."}], "Text", CellTags -> "FC2RHI"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FC2RHI"], Cell[BoxData[""], "Input", 
            CellTags -> "FC2RHI"]}, Open]], Cell["FC2TLI ", "ObjectName", 
         CellTags -> "FC2TLI"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "FC2TLI"], 
           Cell["FC2TLI[exp, k1, k2] transforms all 2-loop OPE-integrals in \
FeynAmpDenominator form to the TLI-integrals.  The option IncludePair governs \
the inclusion  of scalar products p.k1, p.k2 and k1.k2 (setting True).", 
            "Text", CellTags -> "FC2TLI"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[FC2TLI]\)], "Input", CellTags -> "FC2TLI"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] D\), 
                      \(IncludePair \[Rule] True\), \(Do \[Rule] True\)}\)\)]\
, "Output", CellTags -> "FC2TLI"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(? FAD\)], "Input"], Cell[BoxData["\"FAD[q, q-p, ...] \
denotes 1/(q^2 (q-p)^2 ...). FAD[{q1,m}, {q1-p,m}, q2, ...] is 1/( (q1^2 - \
m^2) ( (q1-p)^2 - m^2 ) q2^2 ... ). (Translation into FeynCalc internal form \
is performed by FeynCalcInternal.)\""], "Print", CellTags -> 
                "Info3353009147-5915384"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t = \(\(FAD[\(\({q1, m1}\), \(q2 - q1\), \(q2 - p\)\)]\)\ 
                     \(\(SP[\(q1, OPEDelta\)]\)^OPEm\)\)\)], "Input"], 
              Cell[BoxData[FormBox[RowBox[{FormBox[
                    \(1\/\(\((\*InterpretationBox[\(
                              "["\[InvisibleSpace] 
                               \((\(\*TagBox[StyleBox["\"q\"", 
                                       Rule[FontSlant, "Italic"]], 
                                       Function[StyleForm[Slot[1], 
                                       Rule[FontSlant, "Italic"]]]]\)\_2 - p\
)\)\^2 \[InvisibleSpace]"]"\), 
                             SequenceForm["[", 
                              Power[Plus[Times[-1, p], q2], 2], "]"], 
                             Rule[Editable, False]])\)\ 
                         \((\*InterpretationBox[\(
                              "["\[InvisibleSpace] 
                               \((\(\*TagBox[StyleBox["\"q\"", 
                                       Rule[FontSlant, "Italic"]], 
                                       Function[StyleForm[Slot[1], 
                                       Rule[FontSlant, "Italic"]]]]\)\_2 - 
                                   \(\*TagBox[StyleBox["\"q\"", 
                                       Rule[FontSlant, "Italic"]], 
                                       Function[StyleForm[Slot[1], 
                                       Rule[FontSlant, "Italic"]]]]\)\_1)\)\
\^2 \[InvisibleSpace]"]"\), 
                             SequenceForm["[", 
                              Power[Plus[Times[-1, q1], q2], 2], "]"], 
                             Rule[Editable, False]])\)\ 
                         \((\*InterpretationBox[\(
                              "["\[InvisibleSpace] 
                               \(\*TagBox[StyleBox["\"q\"", 
                                    Rule[FontSlant, "Italic"]], 
                                   Function[StyleForm[Slot[1], 
                                     Rule[FontSlant, "Italic"]]]]\)\_1\%2 
                               \[InvisibleSpace]"-"\[InvisibleSpace] m1\^2 
                               \[InvisibleSpace]"]"\), 
                             SequenceForm["[", Power[q1, 2], "-", 
                              Power[m1, 2], "]"], Rule[Editable, False]])\)\)
                    \), "TraditionalForm"], " ", SuperscriptBox[RowBox[
                     {"(", FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], "TraditionalForm"], ")"}], 
                    "m"]}], TraditionalForm]], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(FC2TLI[\(t, q1, q2\)]\)], 
               "Input"], Cell[BoxData[FormBox[SubsuperscriptBox[
                  StyleBox["T", Rule[FontFamily, "Times"], 
                    Rule[FontWeight, "Bold"]], 
                  \(\*StyleBox["1", Rule[FontWeight, "Bold"], 
                       Rule[FontColor, RGBColor[1.`, 0.`, 0.`]]]\*
                      StyleBox["0", Rule[FontColor, RGBColor[0.`, 0.`, 1.`]]]
                  \*StyleBox["0", Rule[FontColor, RGBColor[0.`, 0.`, 1.`]]]\*
                      StyleBox["1", Rule[FontColor, RGBColor[0.`, 0.`, 1.`]]]
                  \*StyleBox["1", Rule[FontColor, RGBColor[0.`, 0.`, 1.`]]]\)\
, RowBox[{FormBox["m", "TraditionalForm"], FormBox["0", "TraditionalForm"], 
                    FormBox["0", "TraditionalForm"], FormBox["0", 
                     "TraditionalForm"], FormBox["0", "TraditionalForm"]}]], 
                 TraditionalForm]], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//InputForm\)], "Input"], 
              Cell["TLI[{OPEm, 0, 0, 0, 0}, {{1, m1}, 0, 0, 1, 1}]", 
               "Output"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(TLI2FC[%]\)], "Input"], Cell[BoxData[FormBox[FractionBox[
                  SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                        "\[CapitalDelta]", "TraditionalForm"], 
                       "\[CenterDot]", FormBox[
                        \(\(\*TagBox[StyleBox["\"q\"", 
                               Rule[FontSlant, "Italic"]], 
                              Function[StyleForm[Slot[1], 
                                Rule[FontSlant, "Italic"]]]]\)\_1\), 
                        "TraditionalForm"]}], ")"}], "m"], 
                  \(\((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_1\%2 - m1\^2)\)\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1 - 
                         \(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2)\)\^2\)], 
                 TraditionalForm]], "Output"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["TLI", RuleDelayed[ButtonData, "TLI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TLI"]], 
              "."}], "Text", CellTags -> "FC2TLI"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FC2TLI"], Cell[BoxData[""], "Input", 
            CellTags -> "FC2TLI"]}, Open]], Cell["FDS", "ObjectName", 
         CellTags -> "FDS"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "FDS"], 
           Cell["FDS is shorthand for FeynAmpDenominatorSimplify.", "Text", 
            CellTags -> "FDS"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynAmpDenominatorSimplify", 
                RuleDelayed[ButtonData, "FeynAmpDenominatorSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynAmpDenominatorSimplify"]], "."}], 
            "Text", CellTags -> "FDS"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["FermionSpinSum", "ObjectName", CellTags -> "FermionSpinSum"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FermionSpinSum"], Cell["FermionSpinSum[x] constructs \
the Traces out of squared ampliudes.", "Text", CellTags -> "FermionSpinSum"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[FermionSpinSum]\)], 
               "Input", CellTags -> "FermionSpinSum"], Cell[BoxData[
                \(TraditionalForm\`\({\(SpinPolarizationSum \[Rule] Identity
                       \), \(SpinorCollect \[Rule] False\), 
                      \(ExtraFactor \[Rule] 1\)}\)\)], "Output", CellTags -> 
                "FermionSpinSum"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Spinor", RuleDelayed[ButtonData, "Spinor"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Spinor"]], 
              ", ", 
              ButtonBox["ComplexConjugate", 
                RuleDelayed[ButtonData, "ComplexConjugate"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ComplexConjugate"]], ", ", 
              ButtonBox["DiracTrace", RuleDelayed[ButtonData, "DiracTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrace"]], ", ", 
              ButtonBox["Tr", RuleDelayed[ButtonData, "Tr"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Tr"]], 
              "."}], "Text", CellTags -> "FermionSpinSum"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FermionSpinSum"], Cell[TextData[
             {"Spinors of fermions of mass ", 
              StyleBox["m", Rule[FontSlant, "Italic"]], 
              " are normalized to have square 2 ", 
              StyleBox["m", Rule[FontSlant, "Italic"]], " or -2 ", 
              StyleBox["m", Rule[FontSlant, "Italic"]], "."}], "Text", 
            CellTags -> "FermionSpinSum"], Cell[CellGroupData[{Cell[BoxData[
                \(\(SpinorUBar[\(\(Momentum[p]\), m\)]\) . 
                   \(SpinorU[\(\(Momentum[p]\), m\)]\)\)], "Input", 
               CellTags -> "FermionSpinSum"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{FormBox[\("u"\&_\), "TraditionalForm"], "(", 
                     FormBox["p", "TraditionalForm"], ",", "m", ")"}], ".", 
                   RowBox[{"u", "(", FormBox["p", "TraditionalForm"], ",", 
                     "m", ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "FermionSpinSum"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(%//FCI\)//FermionSpinSum\)], "Input", CellTags -> 
                "FermionSpinSum"], Cell[BoxData[FormBox[RowBox[{"tr", "(", 
                   FormBox[RowBox[{"m", "+", RowBox[{FormBox["\"\[Gamma]\"", 
                         "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                         "TraditionalForm"]}]}], "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> "FermionSpinSum"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%/.\(DiracTrace \[Rule] TR\)\)], "Input", CellTags -> 
                "FermionSpinSum"], Cell[BoxData[\(TraditionalForm\`\(4\ m\)\)]
                , "Output", CellTags -> "FermionSpinSum"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SpinorVBar[\(\(Momentum[p]\), m\)]\) . 
                   \(SpinorV[\(\(Momentum[p]\), m\)]\)\)], "Input", 
               CellTags -> "FermionSpinSum"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{FormBox[\("v"\&_\), "TraditionalForm"], "(", 
                     FormBox["p", "TraditionalForm"], ",", "m", ")"}], ".", 
                   RowBox[{"v", "(", FormBox["p", "TraditionalForm"], ",", 
                     "m", ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "FermionSpinSum"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(%//FCI\)//FermionSpinSum\)], "Input", CellTags -> 
                "FermionSpinSum"], Cell[BoxData[FormBox[RowBox[{"tr", "(", 
                   FormBox[RowBox[{RowBox[{FormBox["\"\[Gamma]\"", 
                         "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                         "TraditionalForm"]}], "-", "m"}], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "FermionSpinSum"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%/.\(DiracTrace \[Rule] TR\)\)]
                , "Input", CellTags -> "FermionSpinSum"], Cell[BoxData[
                \(TraditionalForm\`\(\(-4\)\ m\)\)], "Output", CellTags -> 
                "FermionSpinSum"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t = \(\(Spinor[\(k1, m\)]\) . \(DiracSlash[p]\) . \(GA[5]\)
                      . \(Spinor[\(p1, m\)]\)\)\)], "Input", CellTags -> 
                "FermionSpinSum"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"\[CurlyPhi]", "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_1\), 
                      "TraditionalForm"], ",", "m", ")"}], ".", RowBox[
                    {"(", RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                     ")"}], ".", \(\[Gamma]\^5\), ".", RowBox[{"\[CurlyPhi]", 
                     "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_1\), 
                      "TraditionalForm"], ",", "m", ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "FermionSpinSum"]}, 
             Open]], Cell["Notice that SpinorUBar and SpinorU are only input \
functions. Internally they are converted to Spinor objects.", "Text", 
            CellTags -> "FermionSpinSum"], Cell[CellGroupData[{Cell[BoxData[
                \(ct = \(ComplexConjugate[t]\)\)], "Input", CellTags -> 
                "FermionSpinSum"], Cell[BoxData[FormBox[RowBox[{"-", 
                   RowBox[{RowBox[{"\[CurlyPhi]", "(", FormBox[
                        \(\(\*TagBox[StyleBox["\"p\"", 
                               Rule[FontSlant, "Italic"]], 
                              Function[StyleForm[Slot[1], 
                                Rule[FontSlant, "Italic"]]]]\)\_1\), 
                        "TraditionalForm"], ",", "m", ")"}], ".", 
                     \(\[Gamma]\^5\), ".", RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                         FormBox["p", "TraditionalForm"]}], ")"}], ".", 
                     RowBox[{"\[CurlyPhi]", "(", FormBox[
                        \(\(\*TagBox[StyleBox["\"k\"", 
                               Rule[FontSlant, "Italic"]], 
                              Function[StyleForm[Slot[1], 
                                Rule[FontSlant, "Italic"]]]]\)\_1\), 
                        "TraditionalForm"], ",", "m", ")"}]}]}], 
                 TraditionalForm]], "Output", CellTags -> "FermionSpinSum"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(FermionSpinSum[\(t\ ct\)]\)], "Input", CellTags -> 
                "FermionSpinSum"], Cell[BoxData[FormBox[RowBox[{"-", 
                   RowBox[{"tr", "(", FormBox[RowBox[{RowBox[{"(", RowBox[
                          {"m", "+", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"k\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], ")"}], ".", RowBox[
                         {"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], ".", \(\[Gamma]\^5\), 
                        ".", RowBox[{"(", RowBox[{"m", "+", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], ")"}], ".", \(\[Gamma]\^5\)
                        , ".", RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}]}], "TraditionalForm"], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "FermionSpinSum"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%\ /.\(DiracTrace \[Rule] TR\)\)], "Input", CellTags -> 
                "FermionSpinSum"], Cell[BoxData[FormBox[RowBox[{\(-4\), " ", 
                   RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], " ", \(m\^2\)}], "+", 
                       RowBox[{RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"k\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"]}], "-", RowBox[
                        {"2", " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"k\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "FermionSpinSum"]}, 
             Open]], Cell[BoxData[\(Clear[\(t,\ ct\)]\)], "Input", 
            CellTags -> "FermionSpinSum"]}, Open]], Cell["FeynAmp", 
         "ObjectName", CellTags -> "FeynAmp"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynAmp"], Cell["FeynAmp[q, amp] is the head of a \
Feynman amplitude, where amp denotes the analytical expression for the \
amplitude and q is the integration variable. FeynAmp[q1, q2, amp] denotes a \
two-loop amplitude.", "Text", CellTags -> "FeynAmp"], Cell["FeynAmp has no \
functional properties and serves just as a head. There are however special \
typesetting rules attached.", "Text", CellTags -> "FeynAmp"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Amplitude", RuleDelayed[ButtonData, "Amplitude"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Amplitude"]], "."}], "Text", 
            CellTags -> "FeynAmp"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynAmp"], Cell["This is a 1-loop gluon self-energy \
amplitude (ignoring factors of (2 \[Pi])).", "Text", CellTags -> "FeynAmp"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FeynAmp[\(q, \(\(GV[\(p, \[Mu], a,\ \(q - p\), \[Alpha], c,
                           \ \(-q\), \[Beta], e\)]\)\ 
                       \(GP[\(\(p - q\),\ \[Alpha], c,\ \[Rho], d\)]\) 
                       \(GV[\(\(-p\), \[Nu], b,\ \(p - q\), \[Rho], d,\ q, 
                           \[Sigma], f\)]\)\ 
                       \(GP[\(q,\ \[Beta], e,\ \[Sigma], f\)]\)\)\)]\)], 
               "Input", CellTags -> "FeynAmp"], Cell[BoxData[FormBox[
                 RowBox[{"\[Integral]", 
                   StyleBox[\(\[DifferentialD]\^D q\), 
                     Rule[ZeroWidthTimes, True]], "(", FormBox[RowBox[
                     {RowBox[{\(\[CapitalPi]\_\(cd\)\%\(\[Alpha]\[Rho]\)\), 
                        "(", FormBox[\(p - q\), "TraditionalForm"], ")"}], 
                      " ", \(\[CapitalPi]\_\(ef\)\%\(\[Beta]\[Sigma]\)(q)\), 
                      " ", RowBox[{SuperscriptBox["V", RowBox[{FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}]], "(", RowBox[{FormBox[\(-p\), 
                          "TraditionalForm"], \(,\ \), FormBox[\(p - q\), 
                          "TraditionalForm"], \(,\ \), FormBox["q", 
                          "TraditionalForm"]}], ")"}], " ", RowBox[
                       {SuperscriptBox["V", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Alpha]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Beta]", 
                          "TraditionalForm"], "TraditionalForm"]}]], "(", 
                        RowBox[{FormBox["p", "TraditionalForm"], \(,\ \), 
                          FormBox[\(q - p\), "TraditionalForm"], \(,\ \), 
                          FormBox[\(-q\), "TraditionalForm"]}], ")"}], " ", 
                      SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["e", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                      SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["f", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "FeynAmp"]}, Open]], 
           Cell["This is a generic 2-loop amplitude.", "Text", 
            CellTags -> "FeynAmp"], Cell[CellGroupData[{Cell[BoxData[
                \(FeynAmp[\(q\_1, q\_2, anyexpression\)]\)], "Input", 
               CellTags -> "FeynAmp"], Cell[BoxData[
                \(TraditionalForm\`\(\[Integral] 
                     \(\*StyleBox[\(\[DifferentialD]\^D q\_1\), 
                         Rule[ZeroWidthTimes, True]] \[Integral] 
                       \(\[DifferentialD]\^D q\_2\)\) (anyexpression)\)\)], 
               "Output", CellTags -> "FeynAmp"]}, Open]]}, Open]], 
        Cell["FeynAmpDenominator", "ObjectName", CellTags -> 
          "FeynAmpDenominator"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "FeynAmpDenominator"], Cell["FeynAmpDenominator[ \
PropagatorDenominator[ ... ], PropagatorDenominator[ ... ], ...] is the head \
of the denominators of the propagators, i.e., FeynAmpDenominator[x] is the \
representation of 1/x .", "Text", CellTags -> "FeynAmpDenominator"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FAD", RuleDelayed[ButtonData, "FAD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FAD"]], 
              ", ", 
              ButtonBox["FeynAmpDenominatorSimplify", 
                RuleDelayed[ButtonData, "FeynAmpDenominatorSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynAmpDenominatorSimplify"]], "."}], 
            "Text", CellTags -> "FeynAmpDenominator"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynAmpDenominator"], Cell[CellGroupData[
             {Cell[BoxData[
                \(FeynAmpDenominator[\(PropagatorDenominator[\(p, m\)]\)]\)], 
               "Input", CellTags -> "FeynAmpDenominator"], Cell[BoxData[
                \(TraditionalForm\`\(1\/\(p\^2 - m\^2\)\)\)], "Output", 
               CellTags -> "FeynAmpDenominator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FeynAmpDenominator[\(\(PropagatorDenominator[\(p, m\)]\), 
                     \(PropagatorDenominator[\(\(p - q\), m\)]\)\)]\)], 
               "Input", CellTags -> "FeynAmpDenominator"], Cell[BoxData[
                \(TraditionalForm\`\(1\/\(
                      \((p\^2 - m\^2)\) . \((\((p - q)\)\^2 - m\^2)\)\)\)\)], 
               "Output", CellTags -> "FeynAmpDenominator"]}, Open]], 
           Cell[BoxData[
             \(\(t = \(FeynAmpDenominator[\(PropagatorDenominator[\(p, m\)]\)
                    ]\)\) ;\)], "Input", CellTags -> "FeynAmpDenominator"], 
           Cell[CellGroupData[{Cell[BoxData[\(StandardForm[\(t//FCI\)]\)], 
               "Input", CellTags -> "FeynAmpDenominator"], Cell[BoxData[
                \(FeynAmpDenominator[\(PropagatorDenominator[
                     \(\(Momentum[\(p, D\)]\), m\)]\)]\)], "Output", 
               CellTags -> "FeynAmpDenominator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(StandardForm[\(t//FCE\)]\)], 
               "Input", CellTags -> "FeynAmpDenominator"], Cell[BoxData[
                \(FAD[\({p, m}\)]\)], "Output", CellTags -> 
                "FeynAmpDenominator"]}, Open]], Cell[BoxData[
             \(\(Clear[t]\) ;\)], "Input", CellTags -> 
             "FeynAmpDenominator"]}, Open]], 
        Cell["FeynAmpDenominatorCombine", "ObjectName", 
         CellTags -> "FeynAmpDenominatorCombine"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynAmpDenominatorCombine"], Cell["FeynAmpDenominato\
rCombine[expr] expands expr with respect to FeynAmpDenominator and combines \
products of FeynAmpDenominator in expr into one FeynAmpDenominator.", "Text", 
            CellTags -> "FeynAmpDenominatorCombine"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynAmpDenominatorSplit", 
                RuleDelayed[ButtonData, "FeynAmpDenominatorSplit"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynAmpDenominatorSplit"]], "."}], "Text", 
            CellTags -> "FeynAmpDenominatorCombine"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynAmpDenominatorCombine"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t\ =\ \(\(FAD[q]\)\ \(FAD[\(q - p\)]\)\)\)], "Input", 
               CellTags -> "FeynAmpDenominatorCombine"], Cell[BoxData[
                FormBox[RowBox[{FormBox[
                    \(1\/\*InterpretationBox[\(
                          "["\[InvisibleSpace] q\^2 \[InvisibleSpace]"]"\), 
                         SequenceForm["[", Power[q, 2], "]"], 
                         Rule[Editable, False]]\), "TraditionalForm"], " ", 
                   FormBox[
                    \(1\/\*InterpretationBox[\(
                          "["\[InvisibleSpace] \((q - p)\)\^2 
                           \[InvisibleSpace]"]"\), 
                         SequenceForm["[", Power[Plus[Times[-1, p], q], 2], 
                          "]"], Rule[Editable, False]]\), 
                    "TraditionalForm"]}], TraditionalForm]], "Output", 
               CellTags -> "FeynAmpDenominatorCombine"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(FeynAmpDenominatorCombine[%]\)//FCE\)//StandardForm\)], 
               "Input", CellTags -> "FeynAmpDenominatorCombine"], 
              Cell[BoxData[\(FAD[\(q, \(\(-p\) + q\)\)]\)], "Output", 
               CellTags -> "FeynAmpDenominatorCombine"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(FeynAmpDenominatorSplit[%]\)//FCE\)//StandardForm\)], 
               "Input", CellTags -> "FeynAmpDenominatorCombine"], 
              Cell[BoxData[\(\(FAD[q]\)\ \(FAD[\(\(-p\) + q\)]\)\)], 
               "Output", CellTags -> "FeynAmpDenominatorCombine"]}, Open]]}, 
          Open]], Cell["FeynAmpDenominatorSimplify", "ObjectName", 
         CellTags -> "FeynAmpDenominatorSimplify"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynAmpDenominatorSimplify"], Cell["FeynAmpDenominat\
orSimplify[exp] tries to simplify each PropagatorDenominator in a canonical \
way. FeynAmpDenominatorSimplify[exp, q1] simplifies all FeynAmpDenominator's \
in exp in a canonical way, including some translation of momenta. \
FeynAmpDenominatorSimplify[exp, q1, q2] additionally removes integrals with \
no mass scale.", "Text", CellTags -> "FeynAmpDenominatorSimplify"], 
           Cell["FDS can be used as an alias.", "Text", CellTags -> 
             "FeynAmpDenominatorSimplify"], Cell[CellGroupData[
             {Cell[BoxData["FDS"], "Input", CellTags -> 
                "FeynAmpDenominatorSimplify"], Cell[BoxData[
                \(TraditionalForm\`FeynAmpDenominatorSimplify\)], "Output", 
               CellTags -> "FeynAmpDenominatorSimplify"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoopSimplify", 
                RuleDelayed[ButtonData, "OneLoopSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSimplify"]], "."}], "Text", 
            CellTags -> "FeynAmpDenominatorSimplify"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynAmpDenominatorSimplify"], 
           Cell[TextData[
             {"The cornerstone of dimensional regularization is that ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\(\[Integral] 
                       \(d\^n k\ \(\(f(k)\)/k\^\(2m\)\)\)\) =\ \(0\ .\)\)\)]]}\
], "Text", CellTags -> "FeynAmpDenominatorSimplify"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FeynAmpDenominatorSimplify[
                   \(\(\(f[k]\)\ \(FAD[\(k, k\)]\)\), k\)]\)], "Input", 
               CellTags -> "FeynAmpDenominatorSimplify"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> 
                "FeynAmpDenominatorSimplify"]}, Open]], 
           Cell[TextData[{"This brings ", Cell[BoxData[
                \(TraditionalForm\`\(1/\(
                      (\((k - p\_1)\)\^2\ \((k - p\_2)\)\^2)\)\)\)]], 
              " into a standard form."}], "Text", CellTags -> 
             "FeynAmpDenominatorSimplify"], Cell[CellGroupData[{Cell[BoxData[
                \(FeynAmpDenominatorSimplify[
                   \(\(FAD[\(\(k - p\_1\), \(k - p\_2\)\)]\), k\)]\)], 
               "Input", CellTags -> "FeynAmpDenominatorSimplify"], 
              Cell[BoxData[FormBox[FractionBox["1", RowBox[{SuperscriptBox[
                     FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\), "+", \(p\_2\)}], 
                       ")"}], "2"]}]], TraditionalForm]], "Output", 
               CellTags -> "FeynAmpDenominatorSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FeynAmpDenominatorSimplify[
                   \(\(FAD[\(k, k, \(k - q\)\)]\), k\)]\)], "Input", 
               CellTags -> "FeynAmpDenominatorSimplify"], Cell[BoxData[
                FormBox[FractionBox["1", RowBox[{SuperscriptBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "2"], ".", SuperscriptBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "q"}], ")"}], "2"]}]], 
                 TraditionalForm]], "Output", CellTags -> 
                "FeynAmpDenominatorSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FeynAmpDenominatorSimplify[
                   \(\(\(f[k]\) \(FAD[\(k, \(k - q\), \(k - q\)\)]\)\), k\)]\
\)], "Input", CellTags -> "FeynAmpDenominatorSimplify"], Cell[BoxData[
                FormBox[FractionBox[RowBox[{"f", "(", RowBox[{"q", "-", 
                      FormBox[
                       TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]], 
                       "TraditionalForm"]}], ")"}], RowBox[{SuperscriptBox[
                     FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "2"], ".", SuperscriptBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "q"}], ")"}], "2"]}]], 
                 TraditionalForm]], "Output", CellTags -> 
                "FeynAmpDenominatorSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t = \(FeynAmpDenominatorSimplify[
                     \(\(\(FAD[\(\(k - p\_1\), \(k - p\_2\)\)]\)\ 
                         \(SPD[\(k, k\)]\)\), k\)]\)\)], "Input", CellTags -> 
                "FeynAmpDenominatorSimplify"], Cell[BoxData[FormBox[
                 RowBox[{FractionBox[SuperscriptBox[FormBox[FormBox[
                       TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                      "TraditionalForm"], "2"], RowBox[{SuperscriptBox[
                       FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\), "+", \(p\_2\)}], 
                         ")"}], "2"]}]], "+", FractionBox[RowBox[{"2", " ", 
                      RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(p\_2\), 
                         "TraditionalForm"]}]}], RowBox[{SuperscriptBox[
                       FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\), "+", \(p\_2\)}], 
                         ")"}], "2"]}]], "+", FractionBox[\(p\_2\%2\), 
                    RowBox[{SuperscriptBox[FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\), "+", \(p\_2\)}], 
                         ")"}], "2"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "FeynAmpDenominatorSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(r = \(SPC[\(t, k, \(FDS \[Rule] True\)\)]\)\)], "Input", 
               CellTags -> "FeynAmpDenominatorSimplify"], Cell[BoxData[
                FormBox[RowBox[{FractionBox[\(p\_2\%2\), RowBox[
                     {SuperscriptBox[FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\), "+", \(p\_2\)}], 
                         ")"}], "2"]}]], "-", FractionBox[RowBox[{"2", " ", 
                      RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(p\_2\), 
                         "TraditionalForm"]}]}], RowBox[{SuperscriptBox[
                       FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "+", \(p\_1\), "-", \(p\_2\)}], 
                         ")"}], "2"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "FeynAmpDenominatorSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(OneLoopSimplify[\(r, k\)]\)], 
               "Input", CellTags -> "FeynAmpDenominatorSimplify"], 
              Cell[BoxData[FormBox[RowBox[{FractionBox[RowBox[{"2", " ", 
                      RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(p\_2\), 
                         "TraditionalForm"]}]}], RowBox[{SuperscriptBox[
                       FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\), "+", \(p\_2\)}], 
                         ")"}], "2"]}]], "+", FractionBox[\(p\_2\%2\), 
                    RowBox[{SuperscriptBox[FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\), "+", \(p\_2\)}], 
                         ")"}], "2"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "FeynAmpDenominatorSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FDS[\(\(\(FAD[\(\(k - p1\), \(k - p2\)\)]\) 
                       \(\(SPD[\(k, OPEDelta\)]\)^2\)\), k\)]\)], "Input", 
               CellTags -> "FeynAmpDenominatorSimplify"], Cell[BoxData[
                FormBox[RowBox[{FractionBox[SuperscriptBox[FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox["\[CapitalDelta]", 
                         "TraditionalForm"]}], "TraditionalForm"], "2"], 
                    RowBox[{SuperscriptBox[FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", 
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), "+", 
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\)}], 
                         ")"}], "2"]}]], "+", FractionBox[RowBox[{"2", " ", 
                      RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox["\[CapitalDelta]", 
                         "TraditionalForm"]}], " ", RowBox[{FormBox[
                         "\[CapitalDelta]", "TraditionalForm"], 
                        "\[CenterDot]", FormBox[
                         \(\(\*TagBox[StyleBox["\"p\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2\), 
                         "TraditionalForm"]}]}], RowBox[{SuperscriptBox[
                       FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", 
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), "+", 
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\)}], 
                         ")"}], "2"]}]], "+", FractionBox[SuperscriptBox[
                     FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                         "TraditionalForm"], "\[CenterDot]", FormBox[
                         \(\(\*TagBox[StyleBox["\"p\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2\), 
                         "TraditionalForm"]}], "TraditionalForm"], "2"], 
                    RowBox[{SuperscriptBox[FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", 
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), "+", 
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\)}], 
                         ")"}], "2"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "FeynAmpDenominatorSimplify"]}, Open]], 
           Cell[BoxData[\(Clear[\(t, r\)]\)], "Input", CellTags -> 
             "FeynAmpDenominatorSimplify"]}, Open]], 
        Cell["FeynAmpDenominatorSplit", "ObjectName", 
         CellTags -> "FeynAmpDenominatorSplit"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynAmpDenominatorSplit"], Cell["FeynAmpDenominatorS\
plit[expr] splits all FeynAmpDenominator[a,b, ...] in expr into \
FeynAmpDenominator[a]*FeynAmpDenominator[b] ... . \
FeynAmpDenominatorSplit[expr, q1] splits all FeynAmpDenominator in expr into \
a product of two, one containing q1 and other momenta, the second without \
q1.", "Text", CellTags -> "FeynAmpDenominatorSplit"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynAmpDenominatorCombine", 
                RuleDelayed[ButtonData, "FeynAmpDenominatorCombine"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynAmpDenominatorCombine"]], "."}], 
            "Text", CellTags -> "FeynAmpDenominatorSplit"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynAmpDenominatorSplit"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t = \(\(FAD[\(q1, \(q1 - p\), \(q1 - q2\), q2, \(q2 - p\)\)
                       ]\)//FCI\)\)], "Input", CellTags -> 
                "FeynAmpDenominatorSplit"], Cell[BoxData[
                \(TraditionalForm\`\(1\/\(
                      \(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_1\%2 . 
                       \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^2\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1 - 
                           \(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2)\)\^2 . 
                       \(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_2\%2 . 
                       \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\
\)\)\)], "Output", CellTags -> "FeynAmpDenominatorSplit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(t//Head\)], "Input", 
               CellTags -> "FeynAmpDenominatorSplit"], Cell[BoxData[
                \(TraditionalForm\`FeynAmpDenominator\)], "Output", 
               CellTags -> "FeynAmpDenominatorSplit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(FeynAmpDenominatorSplit[t]\)], 
               "Input", CellTags -> "FeynAmpDenominatorSplit"], Cell[BoxData[
                \(TraditionalForm\`\(1\/\(
                      \(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_1\%2\ 
                       \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^2\
\ \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1 - 
                           \(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2)\)\^2\ 
                       \(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_2\%2\ 
                       \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\
\)\)\)], "Output", CellTags -> "FeynAmpDenominatorSplit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(%//FCE\)//StandardForm\)], 
               "Input", CellTags -> "FeynAmpDenominatorSplit"], Cell[BoxData[
                \(\(FAD[q1]\)\ \(FAD[\(\(-p\) + q1\)]\)\ \(FAD[\(q1 - q2\)]\)
                   \ \(FAD[q2]\)\ \(FAD[\(\(-p\) + q2\)]\)\)], "Output", 
               CellTags -> "FeynAmpDenominatorSplit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(FeynAmpDenominatorSplit[\(t, q1\)]\)//FCE\)//
                   StandardForm\)], "Input", CellTags -> 
                "FeynAmpDenominatorSplit"], Cell[BoxData[
                \(\(FAD[\(q2, \(\(-p\) + q2\)\)]\)\ 
                   \(FAD[\(q1, \(\(-p\) + q1\), \(q1 - q2\)\)]\)\)], 
               "Output", CellTags -> "FeynAmpDenominatorSplit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(FeynAmpDenominatorCombine[%]\)//FCE\)//StandardForm\)], 
               "Input", CellTags -> "FeynAmpDenominatorSplit"], Cell[BoxData[
                \(FAD[\(q1, q2, \(q1 - q2\), \(\(-p\) + q1\), \(\(-p\) + q2\)
                    \)]\)], "Output", CellTags -> 
                "FeynAmpDenominatorSplit"]}, Open]], Cell[BoxData[\(Clear[t]\)
             ], "Input", CellTags -> "FeynAmpDenominatorSplit"]}, Open]], 
        Cell["FeynAmpList", "ObjectName", CellTags -> "FeynAmpList"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynAmpList"], Cell["FeynAmpList[info][FeynAmp[...], \
FeynAmp[...], ...] is a head of a list of Feynman amplitudes.", "Text", 
            CellTags -> "FeynAmpList"], Cell["FeynAmpList has no functional \
properties and serves just as a head.", "Text", CellTags -> "FeynAmpList"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynAmp", RuleDelayed[ButtonData, "FeynAmp"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FeynAmp"]]\
, "."}], "Text", CellTags -> "FeynAmpList"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["FeynCalc", "ObjectName", CellTags -> "FeynCalc"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynCalc"], 
           Cell["FeynCalc is simply a symbol with a usage definition.", 
            "Text", CellTags -> "FeynCalc"], Cell[CellGroupData[{Cell[BoxData[
                \(? FeynCalc\)], "Input", CellTags -> "FeynCalc"], 
              Cell[BoxData["\"For installation notes visit \
www.feyncalc.org\\n For a list of availabe objects type $FeynCalcStuff, which \
contains a list of all functions and options in StringForm. You can get \
on-line information by ?function, e.g. ?Contract.\\n There are several useful \
functions for short input, type $FCS for a list of short commands. Then type, \
e.g., ?GA.\\n\\n To enable/disable start-up messages, put the line\\n \
$FeynCalcStartupMessages = True;\\n or\\n $FeynCalcStartupMessages = \
False;\\n  into your \\\"init.m\\\" file or into your \\\"FCConfig.m\\\" \
file.\""], "Print", CellTags -> {"FeynCalc", "Info3353009150-9818237"}]}, 
             Open]]}, Open]], Cell["FeynCalcExternal", "ObjectName", 
         CellTags -> "FeynCalcExternal"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "FeynCalcExternal"], Cell["FeynCalcExternal[exp] translates exp \
from the internal FeynCalc representation to a shorthand form.", "Text", 
            CellTags -> "FeynCalcExternal"], Cell[TextData[{"See also: ", 
              " ", 
              ButtonBox["FeynCalcInternal", 
                RuleDelayed[ButtonData, "FeynCalcInternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcInternal"]], "."}], "Text", 
            CellTags -> "FeynCalcExternal"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynCalcExternal"], Cell[CellGroupData[{Cell[BoxData[
                \(FeynCalcExternal[\(DiracGamma[5]\)]\)], "Input", 
               CellTags -> "FeynCalcExternal"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5\)\)], "Output", CellTags -> 
                "FeynCalcExternal"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(%//StandardForm\)], "Input", CellTags -> 
                "FeynCalcExternal"], Cell[BoxData[\(GA[5]\)], "Output", 
               CellTags -> "FeynCalcExternal"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \({\(GA[\[Mu]]\), \(GAD[\[Rho]]\), \(GS[p]\), 
                    \(SP[\(p, q\)]\), \(MT[\(\[Alpha], \[Beta]\)]\), 
                    \(FV[\(p, \[Mu]\)]\)}\)], "Input", CellTags -> 
                "FeynCalcExternal"], Cell[BoxData[FormBox[RowBox[
                  {"{", RowBox[{\(\[Gamma]\^\[Mu]\), ",", \(\[Gamma]\^\[Rho]\)
                     , ",", \(\[Gamma] \[CenterDot] p\), ",", FormBox[
                      RowBox[{FormBox["p", "TraditionalForm"], 
                        "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                      "TraditionalForm"], ",", \(g\^\(\[Alpha]\[Beta]\)\), 
                     ",", \(p\^\[Mu]\)}], "}"}], TraditionalForm]], "Output", 
               CellTags -> "FeynCalcExternal"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "FeynCalcExternal"], Cell[BoxData[
                \({\(GA[\[Mu]]\), \(GAD[\[Rho]]\), \(GS[p]\), 
                    \(SP[\(p, q\)]\), \(MT[\(\[Alpha], \[Beta]\)]\), 
                    \(FV[\(p, \[Mu]\)]\)}\)], "Output", CellTags -> 
                "FeynCalcExternal"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(%//FeynCalcInternal\)], "Input", CellTags -> 
                "FeynCalcExternal"], Cell[BoxData[FormBox[RowBox[
                  {"{", RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                     ",", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        "\[Rho]", "TraditionalForm"], "TraditionalForm"]], 
                     ",", RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                     ",", RowBox[{FormBox["p", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                     ",", \(g\^\(\[Alpha]\[Beta]\)\), ",", SuperscriptBox[
                      FormBox["p", "TraditionalForm"], FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]]}], 
                   "}"}], TraditionalForm]], "Output", CellTags -> 
                "FeynCalcExternal"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(%//StandardForm\)], "Input", CellTags -> 
                "FeynCalcExternal"], Cell[BoxData[
                \({\(DiracGamma[\(LorentzIndex[\[Mu]]\)]\), 
                    \(DiracGamma[\(\(LorentzIndex[\(\[Rho], D\)]\), D\)]\), 
                    \(DiracGamma[\(Momentum[p]\)]\), 
                    \(Pair[\(\(Momentum[p]\), \(Momentum[q]\)\)]\), 
                    \(Pair[\(\(LorentzIndex[\[Alpha]]\), 
                        \(LorentzIndex[\[Beta]]\)\)]\), 
                    \(Pair[\(\(LorentzIndex[\[Mu]]\), \(Momentum[p]\)\)]\)}\)]\
, "Output", CellTags -> "FeynCalcExternal"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(FeynCalcExternal[%]\)//StandardForm\)], "Input", 
               CellTags -> "FeynCalcExternal"], Cell[BoxData[
                \({\(GA[\[Mu]]\), \(GAD[\[Rho]]\), \(GS[p]\), 
                    \(SP[\(p, q\)]\), \(MT[\(\[Alpha], \[Beta]\)]\), 
                    \(FV[\(p, \[Mu]\)]\)}\)], "Output", CellTags -> 
                "FeynCalcExternal"]}, Open]]}, Open]], Cell["FeynCalcForm", 
         "ObjectName", CellTags -> "FeynCalcForm"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynCalcForm"], Cell[TextData[{"FeynCalcForm[expr] \
changes the printed output to a an easy-to-read form. It allows a readable \
output also when running a terminal based ", 
              StyleBox["Mathematica", Rule[FontSlant, "Italic"]], " session. \
Whether the result of FeynCalcForm[expr] is displayed or not, depends on the \
setting of $PrePrint. $PrePrint = FeynCalcForm forces displaying everything \
after applying FeynCalcForm. In order to change to the normal (internal) \
Mathematica OutputForm, do: ($PrePrint=.)."}], "Text", CellTags -> 
             "FeynCalcForm"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FC", RuleDelayed[ButtonData, "FC"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FC"]], 
              ", ", 
              ButtonBox["FeynCalcExternal", 
                RuleDelayed[ButtonData, "FeynCalcExternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcExternal"]], ", ", 
              ButtonBox["FeynCalcInternal", 
                RuleDelayed[ButtonData, "FeynCalcInternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcInternal"]], "."}], "Text", 
            CellTags -> "FeynCalcForm"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynCalcForm"], 
           Cell["This is the normal notebook display:", "Text", 
            CellTags -> "FeynCalcForm"], Cell[CellGroupData[{Cell[BoxData[
                \(SUNTrace[\(\(SUNT[a]\) . \(SUNT[b]\) . \(SUNT[c]\)\)]\)], 
               "Input", CellTags -> "FeynCalcForm"], Cell[BoxData[
                FormBox[RowBox[{"tr", "(", FormBox[RowBox[{SubscriptBox["T", 
                       FormBox[FormBox["a", "TraditionalForm"], 
                        "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                        FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                      ".", SubscriptBox["T", FormBox[FormBox["c", 
                         "TraditionalForm"], "TraditionalForm"]]}], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "FeynCalcForm"]}, Open]], Cell["This is the \
shorthand (terminal) display (easy-to-read form):", "Text", 
            CellTags -> "FeynCalcForm"], Cell[BoxData[
             \(\($PrePrint\ =\ FeynCalcForm\) ;\)], "Input", 
            CellTags -> "FeynCalcForm"], Cell[BoxData[
             \(\(SetOptions[\($FrontEnd, 
                    \(Evaluate[\(\((\(Options[
                             \($FrontEnd, "CommonDefaultFormatTypes"\)]\)/.
                           \(\(("Output" \[Rule] _)\) \[Rule] 
                             \(("Output" \[Rule] OutputForm)\)\))\)[\([1]\)]\
\)]\)\)]\) ;\)], "Input", CellTags -> "FeynCalcForm"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SUNTrace[\(\(SUNT[a]\) . \(SUNT[b]\) . \(SUNT[c]\)\)]\)], 
               "Input", CellTags -> "FeynCalcForm"], Cell[OutputFormData["SUN\
Trace[SUNT[SUNIndex[a]] . SUNT[SUNIndex[b]] . SUNT[SUNIndex[c]]]", 
                "tr[T[a] T[b] T[c]]"], "Output", CellTags -> 
                "FeynCalcForm"]}, Open]], 
           Cell["Reset to normal notebook display:", "Text", 
            CellTags -> "FeynCalcForm"], Cell[BoxData[\(\($PrePrint=.\) ;\)], 
            "Input", CellTags -> "FeynCalcForm"], Cell[BoxData[
             \(\(SetOptions[\($FrontEnd, 
                    \(Evaluate[\(\((\(Options[
                             \($FrontEnd, "CommonDefaultFormatTypes"\)]\)/.
                           \(\(("Output" \[Rule] _)\) \[Rule] 
                             \(("Output" \[Rule] TraditionalForm)\)\))\)[
                        \([1]\)]\)]\)\)]\) ;\)], "Input", 
            CellTags -> "FeynCalcForm"]}, Open]], Cell["FeynCalcInternal", 
         "ObjectName", CellTags -> "FeynCalcInternal"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynCalcInternal"], Cell["FeynCalcInternal[exp] \
translates exp into the internal FeynCalc (abstract data-type) \
representation.", "Text", CellTags -> "FeynCalcInternal"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalcExternal", 
                RuleDelayed[ButtonData, "FeynCalcExternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcExternal"]], ", ", 
              ButtonBox["FCI", RuleDelayed[ButtonData, "FCI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCI"]], 
              ", ", 
              ButtonBox["FCE", RuleDelayed[ButtonData, "FCE"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCE"]], 
              "."}], "Text", CellTags -> "FeynCalcInternal"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynCalcInternal"], Cell[CellGroupData[{Cell[BoxData[
                \({\(GA[\[Mu]]\), \(GAD[\[Rho]]\), \(GS[p]\), 
                    \(SP[\(p, q\)]\), \(MT[\(\[Alpha], \[Beta]\)]\), 
                    \(FV[\(p, \[Mu]\)]\)}\)], "Input", CellTags -> 
                "FeynCalcInternal"], Cell[BoxData[FormBox[RowBox[
                  {"{", RowBox[{\(\[Gamma]\^\[Mu]\), ",", \(\[Gamma]\^\[Rho]\)
                     , ",", \(\[Gamma] \[CenterDot] p\), ",", FormBox[
                      RowBox[{FormBox["p", "TraditionalForm"], 
                        "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                      "TraditionalForm"], ",", \(g\^\(\[Alpha]\[Beta]\)\), 
                     ",", \(p\^\[Mu]\)}], "}"}], TraditionalForm]], "Output", 
               CellTags -> "FeynCalcInternal"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "FeynCalcInternal"], Cell[BoxData[
                \({\(GA[\[Mu]]\), \(GAD[\[Rho]]\), \(GS[p]\), 
                    \(SP[\(p, q\)]\), \(MT[\(\[Alpha], \[Beta]\)]\), 
                    \(FV[\(p, \[Mu]\)]\)}\)], "Output", CellTags -> 
                "FeynCalcInternal"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(%//FeynCalcInternal\)], "Input", CellTags -> 
                "FeynCalcInternal"], Cell[BoxData[FormBox[RowBox[
                  {"{", RowBox[{SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                     ",", SuperscriptBox["\[Gamma]", FormBox[FormBox[
                        "\[Rho]", "TraditionalForm"], "TraditionalForm"]], 
                     ",", RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                     ",", RowBox[{FormBox["p", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                     ",", \(g\^\(\[Alpha]\[Beta]\)\), ",", SuperscriptBox[
                      FormBox["p", "TraditionalForm"], FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]]}], 
                   "}"}], TraditionalForm]], "Output", CellTags -> 
                "FeynCalcInternal"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(%//StandardForm\)], "Input", CellTags -> 
                "FeynCalcInternal"], Cell[BoxData[
                \({\(DiracGamma[\(LorentzIndex[\[Mu]]\)]\), 
                    \(DiracGamma[\(\(LorentzIndex[\(\[Rho], D\)]\), D\)]\), 
                    \(DiracGamma[\(Momentum[p]\)]\), 
                    \(Pair[\(\(Momentum[p]\), \(Momentum[q]\)\)]\), 
                    \(Pair[\(\(LorentzIndex[\[Alpha]]\), 
                        \(LorentzIndex[\[Beta]]\)\)]\), 
                    \(Pair[\(\(LorentzIndex[\[Mu]]\), \(Momentum[p]\)\)]\)}\)]\
, "Output", CellTags -> "FeynCalcInternal"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(FeynCalcExternal[%]\)//StandardForm\)], "Input", 
               CellTags -> "FeynCalcInternal"], Cell[BoxData[
                \({\(GA[\[Mu]]\), \(GAD[\[Rho]]\), \(GS[p]\), 
                    \(SP[\(p, q\)]\), \(MT[\(\[Alpha], \[Beta]\)]\), 
                    \(FV[\(p, \[Mu]\)]\)}\)], "Output", CellTags -> 
                "FeynCalcInternal"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(FCI[\({\(SD[\(a, b\)]\), \(SUND[\(a, b, c\)]\), 
                      \(SUNF[\(a, b, c\)]\), \(FAD[q]\), 
                      \(LC[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\)}\)]\)], 
               "Input", CellTags -> "FeynCalcInternal"], Cell[BoxData[
                FormBox[RowBox[{"{", RowBox[{SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]}]], ",", 
                     SubscriptBox["d", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"]}]], ",", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"]}]], ",", \(1\/q\^2\), ",", 
                     SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "}"}], TraditionalForm]], 
               "Output", CellTags -> "FeynCalcInternal"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "FeynCalcInternal"], Cell[BoxData[
                \({\(SUNDelta[\(\(SUNIndex[a]\), \(SUNIndex[b]\)\)]\), 
                    \(SUND[\(\(SUNIndex[a]\), \(SUNIndex[b]\), 
                        \(SUNIndex[c]\)\)]\), 
                    \(SUNF[\(\(SUNIndex[a]\), \(SUNIndex[b]\), 
                        \(SUNIndex[c]\)\)]\), 
                    \(FeynAmpDenominator[
                      \(PropagatorDenominator[\(\(Momentum[\(q, D\)]\), 0\)]
                       \)]\), \(Eps[\(\(LorentzIndex[\[Mu]]\), 
                        \(LorentzIndex[\[Nu]]\), \(LorentzIndex[\[Rho]]\), 
                        \(LorentzIndex[\[Sigma]]\)\)]\)}\)], "Output", 
               CellTags -> "FeynCalcInternal"]}, Open]]}, Open]], 
        Cell["FeynCalc2FORM", "ObjectName", CellTags -> "FeynCalc2FORM"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynCalc2FORM"], Cell["FeynCalc2FORM[expr] displays \
expr in FORM syntax. FeynCalc2FORM[file, x] writes x in FORM syntax to a \
file. FeynCalc2FORM[file, x==y] writes x=y to a file in FORM syntax.", 
            "Text", CellTags -> "FeynCalc2FORM"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FORM2FeynCalc", 
                RuleDelayed[ButtonData, "FORM2FeynCalc"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FORM2FeynCalc"]], "."}], "Text", 
            CellTags -> "FeynCalc2FORM"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[FeynCalc2FORM]\)], "Input", CellTags -> 
                "FeynCalc2FORM"], Cell[BoxData[
                \(TraditionalForm\`\({\(EpsDiscard \[Rule] False\), 
                      \(FORMEpilog \[Rule] ""\), 
                      \(FORMProlog \[Rule] "write statistics;"\), 
                      \(Replace \[Rule] \(
                         {\("\\[Alpha]" \[Rule] "al"\), 
                           \("\\[Beta]" \[Rule] "be"\), 
                           \("\\[Gamma]" \[Rule] "ga"\), 
                           \("\\[Delta]" \[Rule] "de"\), 
                           \("\\[Mu]" \[Rule] "mu"\), 
                           \("\\[Nu]" \[Rule] "nu"\), 
                           \("\\[Rho]" \[Rule] "ro"\), 
                           \("\\[Sigma]" \[Rule] "si"\)}\)\), 
                      \(TraceDimension \[Rule] 4\)}\)\)], "Output", 
               CellTags -> "FeynCalc2FORM"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynCalc2FORM"], Cell[CellGroupData[{Cell[BoxData[
                \(\(MT[\(\[Mu], \[Nu]\)]\) \(FV[\(p, \[Rho]\)]\)\ 
                   \(\(y^2\)/d\)\)], "Input", CellTags -> "FeynCalc2FORM"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(y\^2\ p\^\[Rho]\ g\^\(\[Mu]\[Nu]\)\)\/
                     d\)\)], "Output", CellTags -> "FeynCalc2FORM"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(FeynCalc2FORM[%]\) ;\)], 
               "Input", CellTags -> "FeynCalc2FORM"], 
              Cell["(y^2*d_(mu,nu)*p(ro))/d", "Print", CellTags -> 
                "FeynCalc2FORM"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\ \(LC[\(\[Alpha], \[Beta], \[Delta], \[Rho]\)]\)\)], 
               "Input", CellTags -> "FeynCalc2FORM"], Cell[BoxData[
                \(TraditionalForm\`\(\[Epsilon]\^
                     \(\[Alpha]\[Beta]\[Delta]\[Rho]\)\)\)], "Output", 
               CellTags -> "FeynCalc2FORM"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(FeynCalc2FORM[%]\) ;\)], 
               "Input", CellTags -> "FeynCalc2FORM"], 
              Cell["(-i_)*e_(al,be,de,ro)", "Print", CellTags -> 
                "FeynCalc2FORM"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DiracTrace[\(GA[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\)]\)], 
               "Input", CellTags -> "FeynCalc2FORM"], Cell[BoxData[
                FormBox[RowBox[{"tr", "(", FormBox[
                    \(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . \[Gamma]\^\[Rho] . 
                       \[Gamma]\^\[Sigma]\), "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> "FeynCalc2FORM"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(FeynCalc2FORM[%]\) ;\)], "Input", CellTags -> 
                "FeynCalc2FORM"], Cell["g_(0,mu)*g_(0,nu)*g_(0,ro)*g_(0,si)", 
               "Print", CellTags -> "FeynCalc2FORM"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(DiracTrace[\(GA[\(\[Mu], \[Nu]\)]\)]\) 
                   \(DiracTrace[\(GA[\(\[Mu], \[Rho]\)]\)]\)\)], "Input", 
               CellTags -> "FeynCalc2FORM"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{"tr", "(", FormBox[
                      \(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu]\), 
                      "TraditionalForm"], ")"}], " ", RowBox[{"tr", "(", 
                     FormBox[\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Rho]\), 
                      "TraditionalForm"], ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "FeynCalc2FORM"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(FeynCalc2FORM[%]\) ;\)], 
               "Input", CellTags -> "FeynCalc2FORM"], 
              Cell["g_(0,mu)*g_(0,nu)*g_(1,mu)*g_(1,ro)", "Print", 
               CellTags -> "FeynCalc2FORM"]}, Open]], Cell[BoxData[
             \(\(FeynCalc2FORM[\("fc2ftest.f", 
                    \(\(MT[\(\[Mu], \[Nu]\)]\) \(FV[\(p, \[Mu]\)]\)\)\)]\) ;\
\)], "Input", CellTags -> "FeynCalc2FORM"], Cell[CellGroupData[{Cell[BoxData[
                \(ReadList[\(\(\(If[\(\($OperatingSystem === "MacOS"
                            \), ":", ""\)]\) <> "fc2ftest.f"\), String\)]\)], 
               "Input", CellTags -> "FeynCalc2FORM"], Cell[BoxData[
                \(TraditionalForm\`\({"d_(mu,nu)*p(mu)"}\)\)], "Output", 
               CellTags -> "FeynCalc2FORM"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t = \(TR[\(\(GA[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\) . 
                       \(GS[\(p, q\)]\)\)]\)\)], "Input", CellTags -> 
                "FeynCalc2FORM"], Cell[BoxData[FormBox[RowBox[{"4", " ", 
                   RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(\[Rho]\[Sigma]\)\)}
                         ], "-", RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(\[Rho]\[Sigma]\)\)}
                         ], "+", RowBox[{\(g\^\(\[Mu]\[Nu]\)\), " ", RowBox[
                          {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["q", "TraditionalForm"]}], " ", 
                         \(g\^\(\[Rho]\[Sigma]\)\)}], "-", RowBox[
                        {SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(\[Nu]\[Sigma]\)\), 
                         " ", SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{
                         \(g\^\(\[Mu]\[Sigma]\)\), " ", SuperscriptBox[
                          FormBox["q", "TraditionalForm"], FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                         " ", SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          FormBox["p", "TraditionalForm"], FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                         " ", \(g\^\(\[Nu]\[Sigma]\)\), " ", SuperscriptBox[
                          FormBox["q", "TraditionalForm"], FormBox[FormBox[
                          "\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{
                         \(g\^\(\[Mu]\[Sigma]\)\), " ", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                         " ", SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          FormBox["q", "TraditionalForm"], FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                         " ", \(g\^\(\[Nu]\[Rho]\)\), " ", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{
                         \(g\^\(\[Mu]\[Rho]\)\), " ", SuperscriptBox[FormBox[
                          "q", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{
                         \(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[FormBox[
                          "q", "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          FormBox["p", "TraditionalForm"], FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                         " ", \(g\^\(\[Nu]\[Rho]\)\), " ", SuperscriptBox[
                          FormBox["q", "TraditionalForm"], FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{
                         \(g\^\(\[Mu]\[Rho]\)\), " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{
                         \(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{
                         \(g\^\(\[Mu]\[Sigma]\)\), " ", \(g\^\(\[Nu]\[Rho]\)\)
                         , " ", RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "-", RowBox[{
                         \(g\^\(\[Mu]\[Rho]\)\), " ", \(g\^\(\[Nu]\[Sigma]\)\)
                         , " ", RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "FeynCalc2FORM"]}, 
             Open]], Cell[BoxData[
             \(\(FeynCalc2FORM[\("fc2ftest.f", \(L\ == t\)\)]\) ;\)], 
            "Input", CellTags -> "FeynCalc2FORM"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TableForm[\(ReadList[\(
                      \(\(If[\(\($OperatingSystem === "MacOS"\), ":", ""\)]\)
                          <> "fc2ftest.f"\), String\)]\)]\)], "Input", 
               CellTags -> "FeynCalc2FORM"], Cell[BoxData[
                \(TraditionalForm\`\(\*InterpretationBox[GridBox[
                       {{"\"Indices \
\\\\[Mu],\\\\[Nu],\\\\[Rho],\\\\[Sigma];\""}, 
                        {"\"Vectors p,q;\""}, {"\"\""}, 
                        {"\"write statistics;\""}, {"\"\""}, 
                        {"\"Local L = ( \""}, 
                        {"\"4*(d_(mu,si)*d_(nu,ro)*q.p-d_(mu,ro)*d_(nu,si\
)*q.p+d_(mu,\
nu)*d_(ro,si)*q.p+\""}, 
                        {"\"d_(ro,si)*p(nu)*q(mu)-d_(nu,si)*p(ro)*q(mu)+d\
_(nu,ro)*p(s\
i)*q(mu)-\""}, 
                        {"\"d_(ro,si)*p(mu)*q(nu)+d_(mu,si)*p(ro)*q(nu)-d\
_(mu,ro)*p(s\
i)*q(nu)+\""}, 
                        {"\"d_(nu,si)*p(mu)*q(ro)-d_(mu,si)*p(nu)*q(ro)+d\
_(mu,nu)*p(s\
i)*q(ro)-\""}, 
                        {"\"d_(nu,ro)*p(mu)*q(si)+d_(mu,ro)*p(nu)*q(si)-d\
_(mu,nu)*p(r\
o)*q(si)) ); \""}, {"\"   \""}, 
                        {"\"Print; \""}, {"\".end\""}}, RowSpacings -> 1., 
                       ColumnSpacings -> 3., RowAlignments -> Baseline, 
                       ColumnAlignments -> {Left}], 
                      TableForm[List["Indices \
\\[Mu],\\[Nu],\\[Rho],\\[Sigma];", "Vectors p,q;", "", 
                        "write statistics;", "", "Local L = ( ", 
                        "4*(d_(mu,si)*d_(nu,ro)*q.p-d_(mu,ro)*d_(nu,si)*q.p+\
d_(mu,nu)*d_(ro,si)*q.p+", 
                        "d_(ro,si)*p(nu)*q(mu)-d_(nu,si)*p(ro)*q(mu)+d_(nu,r\
o)*p(si)*q(mu)-", "d_(ro,si)*p(mu)*q(nu)+d_(mu,si)*p(ro)*q(n\
u)-d_(mu,ro)*p(si)*q(nu)+", 
                        "d_(nu,si)*p(mu)*q(ro)-d_(mu,si)*p(nu)*q(ro)+d_(mu,n\
u)*p(si)*q(ro)-", "d_(nu,ro)*p(mu)*q(si)+d_(mu,ro)*p(nu)*q(s\
i)-d_(mu,nu)*p(ro)*q(si)) ); ", "   ", "Print; ", ".end"]]]\)
                \)], "Output", CellTags -> "FeynCalc2FORM"]}, Open]], 
           Cell[BoxData[
             \(\(If[\(\(\(FileNames["fc2ftest.f"]\) =!= \({}\)\), 
                    \(DeleteFile["fc2ftest.f"]\)\)]\) ;\)], "Input", 
            CellTags -> "FeynCalc2FORM"], Cell[BoxData[\(\(Clear[t]\) ;\)], 
            "Input", CellTags -> "FeynCalc2FORM"]}, Open]], 
        Cell["FeynCalcToLaTeX", "ObjectName", CellTags -> "FeynCalcToLaTeX"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynCalcToLaTeX"], Cell["FeynCalcToLaTeX[expr] \
generates LaTeX with line-breaking  for expr. \nFeynCalcToLaTeX[expr, 500] \
generates LaTeX for expr where 500 is the Window width  setting for the \
Mathematica frontend. Increasing its value will generate less line breaks.", 
            "Text", CellTags -> "FeynCalcToLaTeX"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonPropagator[\(p, 1, 2\)]\)//Explicit\)], "Input"], 
              Cell[BoxData[FormBox[RowBox[{"-", FractionBox[RowBox[
                     {"\[ImaginaryI]", " ", \(g\^\(li1li2\)\), " ", 
                      SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["ci1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["ci2", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], \(p\^2\)]}], 
                 TraditionalForm]], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(FeynCalcToLaTeX[%]\)], 
               "Input"], Cell[BoxData[
                \(TraditionalForm\`"%% AMS-LaTeX Created by Wolfram \
Mathematica \
5.2\\documentclass{article}\n\\usepackage{amsmath, amssymb, \
graphics}\\newcommand{\\mathsym}[1]{{}}\n\\newcommand{\\unic\
ode}{{}}\\begin{document}\\noindent\\(-\\frac{i \
g^{\\text{li1}\\text{li2}} \\delta \
_{\\text{ci1}\\text{ci2}}}{p^2}\\)"\)], "Output"]}, Open]]}, Open]], 
        Cell["FeynmanParameterNames", "ObjectName", CellTags -> 
          "FeynmanParameterNames"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "FeynmanParameterNames"], Cell["FeynmanParameterNames is an \
option for FeynmanParametrize and other functions.", "Text", 
            CellTags -> "FeynmanParameterNames"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynmanParametrize", 
                RuleDelayed[ButtonData, "FeynmanParametrize"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynmanParametrize"]], "."}], "Text", 
            CellTags -> "FeynmanParameterNames"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["FeynmanParametrize ***unfinished***", 
         "ObjectName", CellTags -> "FeynmanParametrize"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynmanParametrize"], Cell["FeynmanParametrize[exp,k\
] introduces feynman parameters for all one-loop integrals in exp (k = \
integration momentum).", "Text", CellTags -> "FeynmanParametrize"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[FeynmanParametrize]\)], 
               "Input", CellTags -> "FeynmanParametrize"], Cell[BoxData[
                \(TraditionalForm\`\({FeynmanParameterNames \[Rule] 
                      \({x, y, z}\)}\)\)], "Output", CellTags -> 
                "FeynmanParametrize"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynmanParametrize"], Cell[BoxData[""], "Input", 
            CellTags -> "FeynmanParametrize"]}, Open]], 
        Cell["FeynRule", "ObjectName", CellTags -> "FeynRule"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynRule"], Cell["FeynRule[lag, {fields}] derives \
the Feynman rule corresponding to the field configuration fields of the \
lagrangian lag.", "Text", CellTags -> "FeynRule"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[FeynRule]\)], "Input", 
               CellTags -> "FeynRule"], Cell[BoxData[
                \(TraditionalForm\`\({\(Anti5 \[Rule] \(-\[Infinity]\)\), 
                      \(Contract \[Rule] False\), \(Factor1 \[Rule] False\), 
                      \(FinalSubstitutions \[Rule] \({}\)\), 
                      \(PartialD \[Rule] RightPartialD\), 
                      \(Schouten \[Rule] False\), 
                      \(ZeroMomentumInsertion \[Rule] True\), 
                      \(InitialFunction \[Rule] PhiToFC\)}\)\)], "Output", 
               CellTags -> "FeynRule"]}, Open]], 
           Cell["FeynRule does not calculate propagator Feynman rules.", 
            "Text", CellTags -> "FeynRule"], Cell["The option \
ZeroMomentumInsertion can be used for twist-2 and higher twist operators.", 
            "Text", CellTags -> "FeynRule"], Cell[TextData[{"See also: ", 
              " ", 
              ButtonBox["Lagrangian", RuleDelayed[ButtonData, "Lagrangian"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Lagrangian"]], "."}], "Text", 
            CellTags -> "FeynRule"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynRule"], Cell[CellGroupData[{Cell[BoxData[
                \(gou = \(Lagrangian["ogu"]\)\)], "Input", CellTags -> 
                "FeynRule"], Cell[BoxData[FormBox[RowBox[{\(1\/2\), " ", 
                   \(\[ImaginaryI]\^\(m - 1\)\), " ", RowBox[
                    {SubsuperscriptBox["F", RowBox[{"\[Alpha]", FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]}], "a"], ".", 
                     SuperscriptBox[RowBox[{"(", SubsuperscriptBox["D", 
                         FormBox["\[CapitalDelta]", "TraditionalForm"], \(ab\)
                         ], ")"}], \(m - 2\)], ".", SubsuperscriptBox["F", 
                      RowBox[{"\[Alpha]", FormBox["\[CapitalDelta]", 
                         "TraditionalForm"]}], "b"]}]}], TraditionalForm]], 
               "Output", CellTags -> "FeynRule"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(gop = \(Lagrangian["ogp"]\)\)], 
               "Input", CellTags -> "FeynRule"], Cell[BoxData[FormBox[RowBox[{
                   \(1\/2\), " ", \(\[ImaginaryI]\^m\), " ", RowBox[
                    {SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Alpha]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Beta]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Gamma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]}]], ".", 
                     \(F\_\(\[Beta]\[Gamma]\)\%a\), ".", SuperscriptBox[
                      RowBox[{"(", SubsuperscriptBox["D", FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], \(ab\)], 
                        ")"}], \(m - 2\)], ".", SubsuperscriptBox["F", 
                      RowBox[{"\[Alpha]", FormBox["\[CapitalDelta]", 
                         "TraditionalForm"]}], "b"]}]}], TraditionalForm]], 
               "Output", CellTags -> "FeynRule"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Explicit[gop]\)], "Input", 
               CellTags -> "FeynRule"], Cell[BoxData[FormBox[RowBox[{\(1\/2\)
                   , " ", \(\[ImaginaryI]\^m\), " ", RowBox[{SuperscriptBox[
                      "\[Epsilon]", RowBox[{FormBox[FormBox["\[Alpha]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Beta]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Gamma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]}]], ".", 
                     RowBox[{"(", RowBox[{RowBox[{SubscriptBox["\[PartialD]", 
                          FormBox[FormBox["\[Beta]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox[FormBox["A", 
                          "TraditionalForm"], FormBox[FormBox["\[Gamma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Gamma]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                          SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                          FormBox[FormBox["\[Beta]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], "+", 
                         RowBox[{\(g\_s\), " ", RowBox[{SubsuperscriptBox[
                          FormBox["A", "TraditionalForm"], FormBox[FormBox[
                          "\[Beta]", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["b2", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubsuperscriptBox[FormBox[
                          "A", "TraditionalForm"], FormBox[FormBox[
                          "\[Gamma]", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["c17", "TraditionalForm"], 
                          "TraditionalForm"]]}], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b2", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c17", "TraditionalForm"], 
                          "TraditionalForm"]}]]}]}], ")"}], ".", 
                     SuperscriptBox[RowBox[{"(", SubsuperscriptBox["D", 
                         FormBox["\[CapitalDelta]", "TraditionalForm"], \(ab\)
                         ], ")"}], \(m - 2\)], ".", RowBox[{"(", RowBox[
                        {RowBox[{"QuantumField", "(", RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Alpha]", 
                          "TraditionalForm"], "TraditionalForm"]], ",", "A", 
                          ",", "\[CapitalDelta]", ",", FormBox["b", 
                          "TraditionalForm"]}], ")"}], "-", RowBox[
                          {SubscriptBox["\[PartialD]", FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]], 
                          SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                          FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], "+", 
                         RowBox[{\(g\_s\), " ", RowBox[{SubsuperscriptBox[
                          FormBox["A", "TraditionalForm"], FormBox[FormBox[
                          "\[Alpha]", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["b3", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubsuperscriptBox[FormBox[
                          "A", "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["c18", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b3", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c18", 
                          "TraditionalForm"], "TraditionalForm"]}]]}]}], 
                       ")"}]}]}], TraditionalForm]], "Output", CellTags -> 
                "FeynRule"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Cases2[\(%, QuantumField\)]\)], "Input", CellTags -> 
                "FeynRule"], Cell[BoxData[FormBox[RowBox[{"{", RowBox[
                    {SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b3", 
                        "TraditionalForm"], "TraditionalForm"]], ",", 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Beta]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b2", 
                        "TraditionalForm"], "TraditionalForm"]], ",", 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Gamma]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["c17", 
                        "TraditionalForm"], "TraditionalForm"]], ",", 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["c18", "TraditionalForm"], 
                       "TraditionalForm"]], ",", RowBox[{"QuantumField", "(", 
                       RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Alpha]", "TraditionalForm"], 
                          "TraditionalForm"]], ",", "A", ",", 
                         "\[CapitalDelta]", ",", FormBox["b", 
                          "TraditionalForm"]}], ")"}], ",", RowBox[
                      {SubscriptBox["\[PartialD]", FormBox[FormBox["\[Beta]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                        FormBox[FormBox["\[Gamma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], ",", 
                     RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Gamma]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox[FormBox["A", 
                         "TraditionalForm"], FormBox[FormBox["\[Beta]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"]]}], ",", RowBox[{SubscriptBox[
                        "\[PartialD]", FormBox["\[CapitalDelta]", 
                         "TraditionalForm"]], SubsuperscriptBox[FormBox["A", 
                         "TraditionalForm"], FormBox[FormBox["\[Alpha]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]]}]}], "}"}], TraditionalForm]], 
               "Output", CellTags -> "FeynRule"]}, Open]], 
           Cell["2-gluon Feynman rules (unpolarized)", "Text", 
            CellTags -> "FeynRule"], Cell[CellGroupData[{Cell[BoxData[
                \(fi = \({\(\(QuantumField[
                          \(GaugeField, \({\[Mu]}\), \({a}\)\)]\)[p]\), 
                      \(\(QuantumField[\(GaugeField, \({\[Nu]}\), \({b}\)\)]
                         \)[q]\)}\)\)], "Input", CellTags -> "FeynRule"], 
              Cell[BoxData[FormBox[RowBox[{"{", RowBox[{SubsuperscriptBox[
                      FormBox["A", "TraditionalForm"], FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"]], ",", SubsuperscriptBox[FormBox[
                       "A", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"]]}], "}"}], TraditionalForm]], 
               "Output", CellTags -> "FeynRule"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(f2u = \(FullSimplify/@\(
                      Factor2[\(FeynRule[
                         \(gou, fi, \(ZeroMomentumInsertion \[Rule] False\)\)
                         ]\)]\)\)\)], "Input", CellTags -> "FeynRule"], 
              Cell[BoxData[FormBox[FractionBox[RowBox[{RowBox[{"(", 
                      RowBox[{RowBox[{SuperscriptBox[FormBox[RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], "m"]}], "+", RowBox[
                         {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], "m"], " ", SuperscriptBox[FormBox[RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"]}]}], ")"}], " ", 
                    RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(\[Mu]\[Nu]\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                          {RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]}], ")"}]}]}], ")"}], " ", 
                    SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["b", "TraditionalForm"], 
                        "TraditionalForm"]}]]}], RowBox[{"2", " ", 
                    SuperscriptBox[FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                         "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                         "TraditionalForm"]}], "TraditionalForm"], "2"], " ", 
                    SuperscriptBox[FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                         "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                         "TraditionalForm"]}], "TraditionalForm"], "2"]}]], 
                 TraditionalForm]], "Output", CellTags -> "FeynRule"]}, 
             Open]], Cell["2-gluon Feynman rules (polarized)", "Text", 
            CellTags -> "FeynRule"], Cell[CellGroupData[{Cell[BoxData[
                \(fi = \({\(\(QuantumField[
                          \(GaugeField, \({\[Mu]}\), \({a}\)\)]\)[p]\), 
                      \(\(QuantumField[\(GaugeField, \({\[Nu]}\), \({b}\)\)]
                         \)[q]\)}\)\)], "Input", CellTags -> "FeynRule"], 
              Cell[BoxData[FormBox[RowBox[{"{", RowBox[{SubsuperscriptBox[
                      FormBox["A", "TraditionalForm"], FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"]], ",", SubsuperscriptBox[FormBox[
                       "A", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"]]}], "}"}], TraditionalForm]], 
               "Output", CellTags -> "FeynRule"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(f2p = \(FullSimplify/@\(
                      Factor2[\(FeynRule[
                         \(gop, fi, \(ZeroMomentumInsertion \[Rule] False\)\)
                         ]\)]\)\)\)], "Input", CellTags -> "FeynRule"], 
              Cell[BoxData[FormBox[RowBox[{"-", FractionBox[RowBox[
                     {"\[ImaginaryI]", " ", RowBox[{"(", RowBox[{RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], "m"], " ", RowBox[{"(", RowBox[{RowBox[
                          {SuperscriptBox["\[Epsilon]", RowBox[{FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}]}], ")"}], " ", 
                          SuperscriptBox[FormBox[RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"]}], "-", RowBox[
                          {SuperscriptBox[FormBox[RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], "m"], " ", RowBox[
                          {"(", RowBox[{RowBox[{SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "p", "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]}], ")"}]}]}], ")"}], " ", 
                      SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], RowBox[{SuperscriptBox[
                       FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                      " ", SuperscriptBox[FormBox[RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                        "TraditionalForm"], "2"]}]]}], TraditionalForm]], 
               "Output", CellTags -> "FeynRule"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Factor2[\(Calc[\(f2p/.\(p \[Rule] \(-q\)\)\)]\)]\)], 
               "Input", CellTags -> "FeynRule"], Cell[BoxData[FormBox[RowBox[{
                   \(-\[ImaginaryI]\), " ", \((1 - \((\(-1\))\)\^m)\), " ", 
                   SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox["q", "TraditionalForm"], 
                      FormBox["\[CapitalDelta]", "TraditionalForm"]}]], " ", 
                   SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                         "\[CapitalDelta]", "TraditionalForm"], 
                        "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                      ")"}], \(m - 1\)], " ", SubscriptBox["\[Delta]", 
                    RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"]}]]}], 
                 TraditionalForm]], "Output", CellTags -> "FeynRule"]}, 
             Open]], Cell["Compare with the Feynman rule tabulated in \
Twist2GluonOperator.", "Text", CellTags -> "FeynRule"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(q, \({\[Mu], a}\), \({\[Nu], b}\), 
                     \(Polarization \[Rule] 1\), \(Explicit \[Rule] True\)\)]
                \)], "Input", CellTags -> "FeynRule"], Cell[BoxData[
                FormBox[RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                    "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox["\[CapitalDelta]", 
                       "TraditionalForm"], FormBox["q", 
                       "TraditionalForm"]}]], " ", RowBox[{"(", RowBox[
                      {"1", "-", FormBox[\(\((\(-1\))\)\^m\), 
                        "TraditionalForm"]}], ")"}], " ", FormBox[
                    SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                       ")"}], \(m - 1\)], "TraditionalForm"], " ", 
                   SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "FeynRule"]}, Open]], 
           Cell["quark-quark Feynman rule (unpolarized)", "Text", 
            CellTags -> "FeynRule"], Cell[CellGroupData[{Cell[BoxData[
                \(qo = \(Lagrangian["oqu"]\)\)], "Input", CellTags -> 
                "FeynRule"], Cell[BoxData[FormBox[RowBox[{\(\[ImaginaryI]\^m\)
                   , " ", RowBox[{FormBox[\(\[Psi]\&_\), "TraditionalForm"], 
                     ".", RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]}], ")"}], 
                     ".", SuperscriptBox[SubscriptBox["D", FormBox[
                        "\[CapitalDelta]", "TraditionalForm"]], \(m - 1\)], 
                     ".", FormBox["\[Psi]", "TraditionalForm"]}]}], 
                 TraditionalForm]], "Output", CellTags -> "FeynRule"]}, 
             Open]], Cell[
            "quark-quark -gluon-gluon Feynman rule (unpolarized)", "Text", 
            CellTags -> "FeynRule"], Cell[CellGroupData[{Cell[BoxData[
                \(qo = \(Lagrangian["oqu"]\)\)], "Input", CellTags -> 
                "FeynRule"], Cell[BoxData[FormBox[RowBox[{\(\[ImaginaryI]\^m\)
                   , " ", RowBox[{FormBox[\(\[Psi]\&_\), "TraditionalForm"], 
                     ".", RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]}], ")"}], 
                     ".", SuperscriptBox[SubscriptBox["D", FormBox[
                        "\[CapitalDelta]", "TraditionalForm"]], \(m - 1\)], 
                     ".", FormBox["\[Psi]", "TraditionalForm"]}]}], 
                 TraditionalForm]], "Output", CellTags -> "FeynRule"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(qggf = \({\(\(QuantumField[QuarkField]\)[p]\), 
                      \(\(QuantumField[AntiQuarkField]\)[q]\), 
                      \(\(QuantumField[\(GaugeField, \({\[Mu]}\), \({a}\)\)]
                         \)[r]\), \(\(QuantumField[
                          \(GaugeField, \({\[Nu]}\), \({b}\)\)]\)[s]\)}\)\)], 
               "Input", CellTags -> "FeynRule"], Cell[BoxData[FormBox[
                 RowBox[{"{", RowBox[{FormBox["\[Psi]", "TraditionalForm"], 
                     ",", FormBox[\(\[Psi]\&_\), "TraditionalForm"], ",", 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]], ",", 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"]]}], "}"}], 
                 TraditionalForm]], "Output", CellTags -> "FeynRule"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(n4 = \(FeynRule[\(qo, qggf, 
                       \(ZeroMomentumInsertion \[Rule] True\), 
                       \(InitialFunction \[Rule] Identity\)\)]\)\)], "Input", 
               CellTags -> "FeynRule"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(g\_s\%2\), " ", RowBox[{SubscriptBox["T", FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                         FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"]], ".", RowBox[{"(", RowBox[
                          {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], ")"}]}], " ", RowBox[
                      {"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 3\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((j + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{\(\((\(-1\))\)\^j\), " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], \(\(-j\) + m - 3\)], 
                          " ", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], "i"], " ", SuperscriptBox[RowBox[{"(", 
                          RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)]}], 
                          "TraditionalForm"]}], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                       "\[CapitalDelta]", "TraditionalForm"], FormBox[
                       FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"]]}], "-", RowBox[{\(\((\(-1\))\)\^m\)
                     , " ", \(g\_s\%2\), " ", RowBox[{SubscriptBox["T", 
                        FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]], ".", RowBox[{"(", RowBox[
                          {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], ")"}]}], " ", RowBox[
                      {"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 3\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((j + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{\(\((\(-1\))\)\^j\), " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-j\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)]}], 
                          "TraditionalForm"]}], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                       "\[CapitalDelta]", "TraditionalForm"], FormBox[
                       FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"]]}]}], TraditionalForm]], "Output", 
               CellTags -> "FeynRule"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(t4 = \(Twist2QuarkOperator[
                     \(\({p}\), \({q}\), \({r, \[Mu], a}\), \({s, \[Nu], b}\)
                       , \(Polarization \[Rule] 0\)\)]\)\)], "Input", 
               CellTags -> "FeynRule"], Cell[BoxData[FormBox[RowBox[{
                   \(-\((\(-1\))\)\^m\), " ", \(g\_s\%2\), " ", RowBox[
                    {RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]}], ")"}], 
                     ".", RowBox[{"(", RowBox[{RowBox[{RowBox[{SubscriptBox[
                          "T", FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]]}], " ", RowBox[{"(", RowBox[
                          {FormBox[
                          TagBox[\(\[Sum]\+\(i = 0\)\%\(m - 3\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((i + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}]}], ")"}], 
                          \(\(-i\) + m - 3\)], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], "j"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], \(i - j\)]}], 
                          "TraditionalForm"]}], ")"}]}], "+", RowBox[
                          {RowBox[{SubscriptBox["T", FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SubscriptBox["T", FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          RowBox[{"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(i = 0\)\%\(m - 3\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((i + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}]}], ")"}], 
                          \(\(-i\) + m - 3\)], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], "j"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(i - j\)]}], 
                          "TraditionalForm"]}], ")"}]}]}], ")"}]}], " ", 
                   SuperscriptBox[FormBox["\[CapitalDelta]", 
                     "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SuperscriptBox[FormBox["\[CapitalDelta]", 
                     "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "FeynRule"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Calc[\(\(\(\(n4 - t4\)/.\(OPEm \[Rule] 5\)\)/.
                       \(s \[Rule] \(\(-p\) - q - r\)\)\)/.\(D \[Rule] 4\)\)]
                \)], "Input", CellTags -> "FeynRule"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> "FeynRule"]}, 
             Open]], Cell[" In general equality can be shown by \
Timing[Factor2[ \
FCE[Calc[ChangeDimension[FCE[OPESumExplicit[n4-t4]],4]/.s\[Rule]-p-q-r]]]] \
but it is a little bit slow ...", "Text", CellTags -> "FeynRule"], 
           Cell[BoxData[\(Clear[\(qggf, n2, n4\)]\)], "Input", 
            CellTags -> "FeynRule"], Cell["QCD vertices", "Text", 
            CellTags -> "FeynRule"], Cell[CellGroupData[{Cell[BoxData[
                \(fii = \({\(\(QuantumField[
                          \(GaugeField, \({\[Mu]}\), \({a}\)\)]\)[p]\), 
                      \(\(QuantumField[\(GaugeField, \({\[Nu]}\), \({b}\)\)]
                         \)[q]\), \(\(QuantumField[
                          \(GaugeField, \({\[Rho]}\), \({c}\)\)]\)[r]\)}\)\)]\
, "Input", CellTags -> "FeynRule"], Cell[BoxData[FormBox[RowBox[
                  {"{", RowBox[{SubsuperscriptBox[FormBox["A", 
                       "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     ",", SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"]], ",", 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"]]}], "}"}], 
                 TraditionalForm]], "Output", CellTags -> "FeynRule"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(g3 = \(FeynRule[\(\(Lagrangian["QCD"]\), fii\)]\)\)], 
               "Input", CellTags -> "FeynRule"], Cell[BoxData[FormBox[RowBox[{
                   \(g\_s\), " ", RowBox[{"(", RowBox[{RowBox[{RowBox[
                          {"(", RowBox[{SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], "-", 
                          SuperscriptBox[FormBox["r", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}], " ", 
                         \(g\^\(\[Nu]\[Rho]\)\)}], "-", RowBox[{
                         \(g\^\(\[Mu]\[Rho]\)\), " ", RowBox[{"(", RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], "-", SuperscriptBox[FormBox[
                          "r", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], ")"}]}], 
                       "+", RowBox[{\(g\^\(\[Mu]\[Nu]\)\), " ", RowBox[
                          {"(", RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], "-", 
                          SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}]}], ")"}], " ", 
                   SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "FeynRule"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(GluonVertex[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\), 
                     \({r, \[Rho], c}\), \(Explicit \[Rule] True\)\)]\)], 
               "Input", CellTags -> "FeynRule"], Cell[BoxData[FormBox[RowBox[{
                   \(g\_s\), " ", RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[
                          RowBox[{"(", FormBox[\(q - r\), "TraditionalForm"], 
                          ")"}], FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(\[Nu]\[Rho]\)\)}], 
                       "+", RowBox[{\(g\^\(\[Mu]\[Rho]\)\), " ", 
                         SuperscriptBox[RowBox[{"(", FormBox[\(r - p\), 
                          "TraditionalForm"], ")"}], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "+", 
                       RowBox[{\(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[
                          RowBox[{"(", FormBox[\(p - q\), "TraditionalForm"], 
                          ")"}], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]]}]}], ")"}], 
                   " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "FeynRule"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Calc[\(g3 - \(ChangeDimension[\(%, 4\)]\)\)]\)], 
               "Input", CellTags -> "FeynRule"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> "FeynRule"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(fi4 = \({\(\(QuantumField[
                          \(GaugeField, \({\[Mu]}\), \({a}\)\)]\)[p]\), 
                      \(\(QuantumField[\(GaugeField, \({\[Nu]}\), \({b}\)\)]
                         \)[q]\), \(\(QuantumField[
                          \(GaugeField, \({\[Rho]}\), \({c}\)\)]\)[r]\), 
                      \(\(QuantumField[\(GaugeField, \({\[Sigma]}\), \({d}\)
                           \)]\)[s]\)}\)\)], "Input", CellTags -> 
                "FeynRule"], Cell[BoxData[FormBox[RowBox[{"{", RowBox[
                    {SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]], ",", 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"]], ",", 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"]], ",", 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["d", 
                        "TraditionalForm"], "TraditionalForm"]]}], "}"}], 
                 TraditionalForm]], "Output", CellTags -> "FeynRule"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(g4 = \(FeynRule[\(\(Lagrangian["QCD"]\), fi4\)]\)\)], 
               "Input", CellTags -> "FeynRule"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{"\[ImaginaryI]", " ", 
                     \((\(g\^\(\[Mu]\[Rho]\)\ g\^\(\[Nu]\[Sigma]\)\) - 
                         \(g\^\(\[Mu]\[Nu]\)\ g\^\(\[Rho]\[Sigma]\)\))\), 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["d", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["si1", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["si1", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", \(g\_s\%2\)}], "+", 
                   RowBox[{"\[ImaginaryI]", " ", 
                     \((\(g\^\(\[Mu]\[Sigma]\)\ g\^\(\[Nu]\[Rho]\)\) - 
                         \(g\^\(\[Mu]\[Nu]\)\ g\^\(\[Rho]\[Sigma]\)\))\), 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["si1", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["si1", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", \(g\_s\%2\)}], "+", 
                   RowBox[{"\[ImaginaryI]", " ", 
                     \((\(g\^\(\[Mu]\[Sigma]\)\ g\^\(\[Nu]\[Rho]\)\) - 
                         \(g\^\(\[Mu]\[Rho]\)\ g\^\(\[Nu]\[Sigma]\)\))\), 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["si1", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["si1", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", \(g\_s\%2\)}]}], 
                 TraditionalForm]], "Output", CellTags -> "FeynRule"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(GluonVertex[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\), 
                     \({r, \[Rho], c}\), \({s, \[Sigma], d}\), 
                     \(Explicit \[Rule] True\)\)]\)], "Input", CellTags -> 
                "FeynRule"], Cell[BoxData[FormBox[RowBox[{\(-\[ImaginaryI]\), 
                   " ", \(g\_s\%2\), " ", RowBox[{"(", RowBox[{RowBox[{
                         \((\(g\^\(\[Mu]\[Nu]\)\ g\^\(\[Rho]\[Sigma]\)\) - 
                             \(g\^\(\[Mu]\[Rho]\)\ g\^\(\[Nu]\[Sigma]\)\))\), 
                         " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u8", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u8", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                       RowBox[{
                         \((\(g\^\(\[Mu]\[Nu]\)\ g\^\(\[Rho]\[Sigma]\)\) - 
                             \(g\^\(\[Mu]\[Sigma]\)\ g\^\(\[Nu]\[Rho]\)\))\), 
                         " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u8", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u8", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                       RowBox[{
                         \((\(g\^\(\[Mu]\[Rho]\)\ g\^\(\[Nu]\[Sigma]\)\) - 
                             \(g\^\(\[Mu]\[Sigma]\)\ g\^\(\[Nu]\[Rho]\)\))\), 
                         " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u8", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u8", 
                          "TraditionalForm"], "TraditionalForm"]}]]}]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "FeynRule"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Calc[\(g4 - \(ChangeDimension[\(%, 4\)]\)\)]\)], "Input", 
               CellTags -> "FeynRule"], Cell[BoxData[\(TraditionalForm\`0\)], 
               "Output", CellTags -> "FeynRule"]}, Open]], Cell[BoxData[
             \(Clear[\(f2p, f2u, f3, f32, fi, fi4, fii, g3, g4, gop, gou, n3,
                   nf3, n4, np2, npf3, p33, pf3, pn3, pqo, qf, qp, qgf, qo, 
                  t4\)]\)], "Input", CellTags -> "FeynRule"]}, Open]], 
        Cell["FI", "ObjectName", CellTags -> "FI"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FI"], Cell["FI changes the output format to \
InputForm. This is useful to see the internal representation of FeynCalc \
objects. To change back to FeynCalcForm use FC.", "Text", CellTags -> "FI"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalcForm", 
                RuleDelayed[ButtonData, "FeynCalcForm"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcForm"]], ", ", 
              ButtonBox["FC", RuleDelayed[ButtonData, "FC"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FC"]], 
              ", ", 
              ButtonBox["FeynCalcExternal", 
                RuleDelayed[ButtonData, "FeynCalcExternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcExternal"]], ", ", 
              ButtonBox["FeynCalcInternal", 
                RuleDelayed[ButtonData, "FeynCalcInternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcInternal"]], "."}], "Text", 
            CellTags -> "FI"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["FieldDerivative", "ObjectName", CellTags -> "FieldDerivative"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FieldDerivative"], Cell["FieldDerivative[f[x],x,li1,\
li2,...] is the derivative of f[x] with respect to space-time variables x and \
with Lorentz indices li1, li2, ..., where li1, li2, ... have head \
LorentzIndex. FieldDerivative[f[x],x,li1,li2,...] can be given as \
FieldDerivative[f[x],x,{l1,l2,...}], where l1 is li1 without the head, ... \
FieldDerivative is defined only for objects with head QuantumField[...]. If \
the space-time derivative of other objects is wanted, the corresponding rule \
must be specified.", "Text", CellTags -> "FieldDerivative"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["PartialD", RuleDelayed[ButtonData, "PartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PartialD"]], ", ", 
              ButtonBox["ExpandPartialD", 
                RuleDelayed[ButtonData, "ExpandPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandPartialD"]], "."}], "Text", 
            CellTags -> "FieldDerivative"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FieldDerivative"], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(QuantumField[\(A, \({\[Mu]}\)\)]\)[x]\) . 
                   \(\(QuantumField[\(B, \({\[Nu]}\)\)]\)[y]\) . 
                   \(\(QuantumField[\(C, \({\[Rho]}\)\)]\)[x]\) . 
                   \(\(QuantumField[\(D, \({\[Sigma]}\)\)]\)[y]\)\)], 
               "Input", CellTags -> "FieldDerivative"], Cell[BoxData[
                FormBox[RowBox[{\(A\_\[Mu]\), ".", \(B\_\[Nu]\), ".", 
                   SubscriptBox[FormBox["C", "TraditionalForm"], "\[Rho]"], 
                   ".", SubscriptBox[FormBox["D", "TraditionalForm"], 
                    "\[Sigma]"]}], TraditionalForm]], "Output", CellTags -> 
                "FieldDerivative"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(FieldDerivative[\(%, x, \({\[Mu]}\)\)]\)//DotExpand\)], 
               "Input", CellTags -> "FieldDerivative"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{\(A\_\[Mu]\), ".", \(B\_\[Nu]\), ".", 
                     RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox[FormBox["C", "TraditionalForm"], 
                        FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"], "\[Null]"]}], ".", SubscriptBox[
                      FormBox["D", "TraditionalForm"], "\[Sigma]"]}], "+", 
                   RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], "\[Null]"]}], ".", \(B\_\[Nu]\), 
                     ".", SubscriptBox[FormBox["C", "TraditionalForm"], 
                      "\[Rho]"], ".", SubscriptBox[FormBox["D", 
                       "TraditionalForm"], "\[Sigma]"]}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "FieldDerivative"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(FieldDerivative[\(%, y, \({\[Nu]}\)\)]\)//DotExpand\)], 
               "Input", CellTags -> "FieldDerivative"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{\(A\_\[Mu]\), ".", \(B\_\[Nu]\), ".", 
                     RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox[FormBox["C", "TraditionalForm"], 
                        FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"], "\[Null]"]}], ".", RowBox[
                      {SubscriptBox["\[PartialD]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox[FormBox["D", "TraditionalForm"], 
                        FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], "\[Null]"]}]}], "+", RowBox[{
                     \(A\_\[Mu]\), ".", RowBox[{SubscriptBox["\[PartialD]", 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["B", FormBox[
                         FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], "\[Null]"]}], ".", RowBox[
                      {SubscriptBox["\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox[FormBox["C", "TraditionalForm"], 
                        FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"], "\[Null]"]}], ".", SubscriptBox[
                      FormBox["D", "TraditionalForm"], "\[Sigma]"]}], "+", 
                   RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], "\[Null]"]}], ".", \(B\_\[Nu]\), 
                     ".", SubscriptBox[FormBox["C", "TraditionalForm"], 
                      "\[Rho]"], ".", RowBox[{SubscriptBox["\[PartialD]", 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox[FormBox["D", 
                         "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[Null]"]}]}], "+", RowBox[{RowBox[{SubscriptBox[
                        "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[Null]"]}], ".", RowBox[{SubscriptBox[
                        "\[PartialD]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox["B", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[Null]"]}], ".", SubscriptBox[FormBox["C", 
                       "TraditionalForm"], "\[Rho]"], ".", SubscriptBox[
                      FormBox["D", "TraditionalForm"], "\[Sigma]"]}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "FieldDerivative"]}, Open]]}, Open]], Cell["FieldStrength", 
         "ObjectName", CellTags -> "FieldStrength"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FieldStrength"], Cell[TextData[
             {"FieldStrength[\[Mu], \[Nu], a] is the field strength tensor ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\(\[PartialD]\_\[Mu] A\_\[Nu]\%a\) - 
                     \(\[PartialD]\_\[Nu] A\_\[Mu]\%a\) + 
                     \(g\_s\ A\_\[Mu]\%b1 A\_\[Nu]\%c1\)\)\)]], Cell[BoxData[
                \(TraditionalForm\`\(\ f\^\(a\ b1\ c1\)\)\)]], 
              ". FieldStrength[\[Mu], \[Nu]] is the field strength tensor ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\(\[PartialD]\_\[Mu] A\_\[Nu]\%\[Null]\)
                      - \(\(\[PartialD]\_\[Nu] A\_\[Mu]\%\[Null]\) .\)\)\)]], 
              " The name of the field (A) and the coupling constant (g) can \
be set through the options or by additional arguments. The first two indices \
are interpreted as type LorentzIndex, except OPEDelta, which is converted to \
Momentum[OPEDelta]."}], "Text", CellTags -> "FieldStrength"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[FieldStrength]\)], 
               "Input", CellTags -> "FieldStrength"], Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(Explicit \[Rule] False\), 
                      \(HighEnergyPhysics`fctools`IndexPosition`IndexPosition
                         \[Rule] \({0, 0}\)\), \(Symbol \[Rule] "F"\), 
                      \(QuantumField \[Rule] A\)}\)\)], "Output", CellTags -> 
                "FieldStrength"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["QuantumField", 
                RuleDelayed[ButtonData, "QuantumField"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "QuantumField"]], "."}], "Text", 
            CellTags -> "FieldStrength"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FieldStrength"], Cell[CellGroupData[{Cell[BoxData[
                \(FieldStrength[\(\[Mu], \[Nu]\)]\)], "Input", CellTags -> 
                "FieldStrength"], Cell[BoxData[
                \(TraditionalForm\`F\_\(\[Mu]\[Nu]\)\%\[Null]\)], "Output", 
               CellTags -> "FieldStrength"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FieldStrength[\(\[Mu], \[Nu], a\)]\)], "Input", CellTags -> 
                "FieldStrength"], Cell[BoxData[
                \(TraditionalForm\`F\_\(\[Mu]\[Nu]\)\%a\)], "Output", 
               CellTags -> "FieldStrength"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FieldStrength[\(\[Mu], \[Nu], \(Explicit \[Rule] True\)\)]
                  \)], "Input", CellTags -> "FieldStrength"], 
              Cell[BoxData[FormBox[RowBox[{RowBox[{SubscriptBox[
                      "\[PartialD]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], "\[Null]"]}], "-", RowBox[
                    {SubscriptBox["\[PartialD]", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"]], 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], "\[Null]"]}]}], TraditionalForm]], 
               "Output", CellTags -> "FieldStrength"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FieldStrength[\(\[Mu], \[Nu], a, \(Explicit \[Rule] True\)
                    \)]\)], "Input", CellTags -> "FieldStrength"], 
              Cell[BoxData[FormBox[RowBox[{RowBox[{SubscriptBox[
                      "\[PartialD]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]]}], "-", 
                   RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                        "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]]}], "+", 
                   RowBox[{\(g\_s\), " ", RowBox[{SubsuperscriptBox[FormBox[
                         "A", "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b12", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SubsuperscriptBox[FormBox[
                         "A", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c61", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(f\_\(ab12c61\)\)}]}], 
                 TraditionalForm]], "Output", CellTags -> "FieldStrength"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(FieldStrength[
                     \(\[Mu], \[Nu], \(Explicit \[Rule] True\)\)]\)]\)], 
               "Input", CellTags -> "FieldStrength"], Cell[BoxData[
                \(\(QuantumField[\(\(PartialD[\(LorentzIndex[\[Mu]]\)]\), 
                       GaugeField, \(LorentzIndex[\[Nu]]\)\)]\) - 
                   \(QuantumField[\(\(PartialD[\(LorentzIndex[\[Nu]]\)]\), 
                       GaugeField, \(LorentzIndex[\[Mu]]\)\)]\)\)], "Output", 
               CellTags -> "FieldStrength"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(FieldStrength[
                     \(\[Mu], OPEDelta, \(Explicit \[Rule] True\)\)]\)]\)], 
               "Input", CellTags -> "FieldStrength"], Cell[BoxData[
                \(\(QuantumField[\(\(PartialD[\(LorentzIndex[\[Mu]]\)]\), 
                       GaugeField, \(Momentum[OPEDelta]\)\)]\) - 
                   \(QuantumField[\(\(PartialD[\(Momentum[OPEDelta]\)]\), 
                       GaugeField, \(LorentzIndex[\[Mu]]\)\)]\)\)], "Output", 
               CellTags -> "FieldStrength"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FieldStrength[\(\[Mu], \[Nu], a, 
                     \(CouplingConstant \[Rule] \(-Gstrong\)\), 
                     \(Explicit \[Rule] True\)\)]\)], "Input", CellTags -> 
                "FieldStrength"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]]}], "-", 
                   RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                        "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]]}], "-", 
                   RowBox[{\(g\_s\), " ", RowBox[{SubsuperscriptBox[FormBox[
                         "A", "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b13", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SubsuperscriptBox[FormBox[
                         "A", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c62", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", \(f\_\(ab13c62\)\)}]}], 
                 TraditionalForm]], "Output", CellTags -> "FieldStrength"]}, 
             Open]]}, Open]], Cell["FinalFunction", "ObjectName", 
         CellTags -> "FinalFunction"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "FinalFunction"], 
           Cell["FinalFunction is an option for OneLoopSum.", "Text", 
            CellTags -> "FinalFunction"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoopSum", RuleDelayed[ButtonData, "OneLoopSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSum"]], "."}], "Text", 
            CellTags -> "FinalFunction"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["FinalSubstitutions", "ObjectName", 
         CellTags -> "FinalSubstitutions"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FinalSubstitutions"], Cell["FinalSubstitutions is an \
option for OneLoop and OneLoopSum and Write2. All substitutions indicated \
hereby are done at the end of the calculation.", "Text", CellTags -> 
             "FinalSubstitutions"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, ", ", 
              ButtonBox["OneLoopSum", RuleDelayed[ButtonData, "OneLoopSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSum"]], ", ", 
              ButtonBox["Write2", RuleDelayed[ButtonData, "Write2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Write2"]], 
              "."}], "Text", CellTags -> "FinalSubstitutions"], 
           Cell[BoxData[""], "Input"]}, Open]], Cell["FORM", "ObjectName", 
         CellTags -> "FORM"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "FORM"], 
           Cell["FORM is an option for RHI. If set to True a FORM file is \
generated and run from Mathematica (provided R. Hamberg's FORM-program is \
installed correctly ... ).", "Text", CellTags -> "FORM"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["RHI", RuleDelayed[ButtonData, "RHI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "RHI"]], 
              ", ", 
              ButtonBox["FeynCalc2FORM", 
                RuleDelayed[ButtonData, "FeynCalc2FORM"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalc2FORM"]], "."}], "Text", 
            CellTags -> "FORM"]}, Open]], Cell["FORMEpilog", "ObjectName", 
         CellTags -> "FORMEpilog"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "FORMEpilog"], 
           Cell["FORMEpilog is an option for FeynCalc2FORM. It may be set to \
a string which is put at the end of the FORM-file.", "Text", 
            CellTags -> "FORMEpilog"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalc2FORM", 
                RuleDelayed[ButtonData, "FeynCalc2FORM"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalc2FORM"]], ", ", 
              ButtonBox["FORMProlog", RuleDelayed[ButtonData, "FORMProlog"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FORMProlog"]], "."}], "Text", 
            CellTags -> "FORMEpilog"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["FORMProlog", "ObjectName", CellTags -> "FORMProlog"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FORMProlog"], Cell["FORMProlog is an option for \
FeynCalc2FORM. It may be set to a string which is put after the type \
declarations of the FORM-file.", "Text", CellTags -> "FORMProlog"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalc2FORM", 
                RuleDelayed[ButtonData, "FeynCalc2FORM"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalc2FORM"]], ", ", 
              ButtonBox["FORMEpilog", RuleDelayed[ButtonData, "FORMEpilog"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FORMEpilog"]], "."}], "Text", 
            CellTags -> "FORMProlog"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["FORM2FeynCalc", "ObjectName", CellTags -> "FORM2FeynCalc"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FORM2FeynCalc"], Cell["FORM2FeynCalc[expr] \
translates the FORM expr into FeynCalc notation. FORM2FeynCalc[file] \
translates the FORM expresssions in file into FeynCalcnotation. \
FORM2FeynCalc[file, x1, x2, ...] reads in a file in FORM-format and \
translates the assignments for the variables a, b, ... into FeynCalc syntax. \
If the option Set is True, the variables x1, x2 are assigned to the right \
hand sides defined in the FORM-file.", "Text", CellTags -> "FORM2FeynCalc"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalc2FORM", 
                RuleDelayed[ButtonData, "FeynCalc2FORM"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalc2FORM"]], "."}], "Text", 
            CellTags -> "FORM2FeynCalc"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[FORM2FeynCalc]\)], "Input", CellTags -> 
                "FORM2FeynCalc"], Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] 4\), 
                      \(FinalSubstitutions \[Rule] \({}\)\), 
                      \(Dot \[Rule] Dot\), \(HoldForm \[Rule] True\), 
                      \(LorentzIndex \[Rule] \({mu, nu, al, be}\)\), 
                      \(Set \[Rule] False\), \(Replace \[Rule] \({}\)\), 
                      \(Vectors \[Rule] Automatic\)}\)\)], "Output", 
               CellTags -> "FORM2FeynCalc"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FORM2FeynCalc"], Cell[CellGroupData[{Cell[BoxData[
                \(FORM2FeynCalc["p.q + 2*x m^2"]\)], "Input", CellTags -> 
                "FORM2FeynCalc"], Cell[BoxData[FormBox[RowBox[{
                   \(2\ \(x . m\^2\)\), "+", FormBox[RowBox[{FormBox["p", 
                       "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                       "TraditionalForm"]}], "TraditionalForm"]}], 
                 TraditionalForm]], "Output", CellTags -> "FORM2FeynCalc"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], 
               "Input", CellTags -> "FORM2FeynCalc"], Cell[BoxData[
                \(\(2\ \(x . m\^2\)\) + \(SP[\(p, q\)]\)\)], "Output", 
               CellTags -> "FORM2FeynCalc"]}, Open]], Cell["Functions are \
automatically converted right, but bracketed expressions need to be \
substituted explicitly.", "Text", CellTags -> "FORM2FeynCalc"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FORM2FeynCalc[\("x +f(z)+ log(x)^2+[li2(1-x)]", 
                     \(Replace \[Rule] \(
                        {"[li2(1-x)]" \[Rule] "PolyLog[2,1-x]"}\)\)\)]\)], 
               "Input", CellTags -> "FORM2FeynCalc"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(log\^2\)(x)\) + x + \(f(z)\) + 
                     \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(1 - x\))\)\)\)], "Output", CellTags -> "FORM2FeynCalc"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "FORM2FeynCalc"], Cell[BoxData[
                \(x + \(f[z]\) + \(Log[x]\)\^2 + 
                   \(PolyLog[\(2, \(1 - x\)\)]\)\)], "Output", CellTags -> 
                "FORM2FeynCalc"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(FORM2FeynCalc["x + [(1)]*y -[(-1)^m]"]\)], "Input", 
               CellTags -> "FORM2FeynCalc"], Cell[BoxData[
                \(TraditionalForm\`\(x + \(\(Hold[1]\) . y\) - 
                     \(Hold[\(\((\(-1\))\)\^m\)]\)\)\)], "Output", 
               CellTags -> "FORM2FeynCalc"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ReleaseHold[%]\)], "Input", 
               CellTags -> "FORM2FeynCalc"], Cell[BoxData[
                \(TraditionalForm\`\(x - \((\(-1\))\)\^m + \(1 . y\)\)\)], 
               "Output", CellTags -> "FORM2FeynCalc"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FORM2FeynCalc["p(mu)*q(nu)+d_(mu,nu)"]\)], "Input", 
               CellTags -> "FORM2FeynCalc"], Cell[BoxData[
                \(TraditionalForm\`\(\(p\^mu . q\^nu\) + g\^\(munu\)\)\)], 
               "Output", CellTags -> "FORM2FeynCalc"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "FORM2FeynCalc"], Cell[BoxData[
                \(\(\(FV[\(p, mu\)]\) . \(FV[\(q, nu\)]\)\) + 
                   \(MT[\(mu, nu\)]\)\)], "Output", CellTags -> 
                "FORM2FeynCalc"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(FORM2FeynCalc[\("p(mu)*q(nu)+d_(mu,nu)", 
                     \(Replace \[Rule] \(
                        {\(mu \[Rule] \[Mu]\), \(nu \[Rule] \[Nu]\)}\)\)\)]\)]\
, "Input", CellTags -> "FORM2FeynCalc"], Cell[BoxData[
                \(TraditionalForm\`\(\(p\^\[Mu] . q\^\[Nu]\) + 
                     g\^\(\[Mu]\[Nu]\)\)\)], "Output", CellTags -> 
                "FORM2FeynCalc"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(FORM2FeynCalc["i_*az*bz*aM^2*D1*[(1)]*b_G1 * ( \
4*eperp(mu,nu)*avec.bvec*blam )"]\)], "Input", CellTags -> "FORM2FeynCalc"], 
              Cell[BoxData[FormBox[RowBox[{\((4\ \[ImaginaryI])\), ".", "az", 
                   ".", "bz", ".", \(aM\^2\), ".", "D1", ".", \(Hold[1]\), 
                   ".", "b$G1", ".", \(eperp(mu, nu)\), ".", RowBox[
                    {"(", FormBox[RowBox[{FormBox["avec", "TraditionalForm"], 
                        "\[CenterDot]", FormBox["bvec", "TraditionalForm"]}], 
                      "TraditionalForm"], ")"}], ".", "blam"}], 
                 TraditionalForm]], "Output", CellTags -> "FORM2FeynCalc"]}, 
             Open]]}, Open]], Cell["FourDivergence", "ObjectName", 
         CellTags -> "FourDivergence"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "FourDivergence"], Cell["FourDivergence[exp, FourVector[p, mu]] \
calculates the partial derivative of exp w.r.t. p(mu). FourDivergence[exp, \
FourVector[p, mu], FourVector[p,nu], ...]gives the multiple derivative.", 
            "Text", CellTags -> "FourDivergence"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["RussianTrick", 
                RuleDelayed[ButtonData, "RussianTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "RussianTrick"]], "."}], "Text", 
            CellTags -> "FourDivergence"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FourDivergence"], Cell[CellGroupData[{Cell[BoxData[
                \(t = \(ScalarProduct[\(p, q\)]\)\)], "Input", CellTags -> 
                "FourDivergence"], Cell[BoxData[FormBox[RowBox[
                  {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                   FormBox["q", "TraditionalForm"]}], TraditionalForm]], 
               "Output", CellTags -> "FourDivergence"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FourDivergence[\(t, \(FourVector[\(q, \[Mu]\)]\)\)]\)], 
               "Input", CellTags -> "FourDivergence"], Cell[BoxData[
                FormBox[SuperscriptBox[FormBox["p", "TraditionalForm"], 
                  FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                   "TraditionalForm"]], TraditionalForm]], "Output", 
               CellTags -> "FourDivergence"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t = \(ScalarProduct[\(\(p - k\), q\)]\)\)], "Input", 
               CellTags -> "FourDivergence"], Cell[BoxData[FormBox[
                 RowBox[{"(", FormBox[RowBox[{"p", "-", FormBox[
                       TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]], 
                       "TraditionalForm"]}], "TraditionalForm"], ")", 
                   "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                 TraditionalForm]], "Output", CellTags -> "FourDivergence"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(FourDivergence[\(t, \(FourVector[\(\(k - p\), \[Mu]\)]\)\)]
                  \)], "Input", CellTags -> "FourDivergence"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> 
                "FourDivergence"]}, Open]], Cell[BoxData[\(Clear[t]\)], 
            "Input", CellTags -> "FourDivergence"]}, Open]], 
        Cell["FourLaplacian", "ObjectName", CellTags -> "FourLaplacian"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FourLaplacian"], Cell[TextData[
             {"FourLaplacian[exp, p, q] is ", Cell[BoxData[
                \(TraditionalForm\`\(\[PartialD]\(/\(\[PartialD] p\_\[Mu]\)\)
                     \ \)\)]], Cell[BoxData[
                \(TraditionalForm\`\(\[PartialD]\(/\(\[PartialD] q\_\[Mu]\)\)
                     \ \)\)]], "exp."}], "Text", CellTags -> 
             "FourLaplacian"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[FourLaplacian]\)], "Input", CellTags -> 
                "FourLaplacian"], Cell[BoxData[
                \(TraditionalForm\`\({Dimension \[Rule] D}\)\)], "Output", 
               CellTags -> "FourLaplacian"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FourDivergence", 
                RuleDelayed[ButtonData, "FourDivergence"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FourDivergence"]], ", ", 
              ButtonBox["RussianTrick", 
                RuleDelayed[ButtonData, "RussianTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "RussianTrick"]], "."}], "Text", 
            CellTags -> "FourLaplacian"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FourLaplacian"], Cell[CellGroupData[{Cell[BoxData[
                \(SP[\(q, q\)]\)], "Input", CellTags -> "FourLaplacian"], 
              Cell[BoxData[FormBox[SuperscriptBox[FormBox["q", 
                   "TraditionalForm"], "2"], TraditionalForm]], "Output", 
               CellTags -> "FourLaplacian"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(FourLaplacian[\(%, q, q\)]\)], 
               "Input", CellTags -> "FourLaplacian"], Cell[BoxData[
                \(TraditionalForm\`\(2\ D\)\)], "Output", CellTags -> 
                "FourLaplacian"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(SOD[q]\)^OPEm\)\(FAD[\(q, \(q - p\)\)]\)\)//FCI\)], 
               "Input", CellTags -> "FourLaplacian"], Cell[BoxData[
                FormBox[FractionBox[SuperscriptBox[RowBox[{"(", RowBox[
                      {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                       "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                     ")"}], "m"], \(q\^2 . \((q - p)\)\^2\)], 
                 TraditionalForm]], "Output", CellTags -> "FourLaplacian"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(FourLaplacian[\(%, q,\ q\)]\)], "Input", CellTags -> 
                "FourLaplacian"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"-", FractionBox[RowBox[{"4", " ", "m", " ", 
                        SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(m - 1\)], " ", RowBox[{"(", RowBox[
                          {RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "-", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], ")"}]}], 
                      \(q\^2 . \((q - p)\)\^2 . \((q - p)\)\^2\)]}], "-", 
                   FractionBox[RowBox[{"2", " ", "D", " ", SuperscriptBox[
                       RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], "m"]}], 
                    \(q\^2 . q\^2 . \((q - p)\)\^2\)], "-", FractionBox[
                    RowBox[{"4", " ", "m", " ", SuperscriptBox[RowBox[
                        {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], "m"]}], 
                    \(q\^2 . q\^2 . \((q - p)\)\^2\)], "+", FractionBox[
                    RowBox[{"12", " ", SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                         ")"}], "m"]}], \(q\^2 . q\^2 . \((q - p)\)\^2\)], 
                   "-", FractionBox[RowBox[{"2", " ", "D", " ", 
                      SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                         ")"}], "m"]}], 
                    \(q\^2 . \((q - p)\)\^2 . \((q - p)\)\^2\)], "+", 
                   FractionBox[RowBox[{"12", " ", SuperscriptBox[RowBox[
                        {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], "m"]}], 
                    \(q\^2 . \((q - p)\)\^2 . \((q - p)\)\^2\)], "-", 
                   FractionBox[RowBox[{"4", " ", SuperscriptBox[RowBox[
                        {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], "m"], " ", 
                      SuperscriptBox[FormBox["p", "TraditionalForm"], "2"]}], 
                    \(q\^2 . q\^2 . \((q - p)\)\^2 . \((q - p)\)\^2\)]}], 
                 TraditionalForm]], "Output", CellTags -> "FourLaplacian"]}, 
             Open]]}, Open]], Cell["FourVector", "ObjectName", 
         CellTags -> "FourVector"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "FourVector"], 
           Cell[TextData[{"FourVector[p, ", Cell[BoxData[
                \(TraditionalForm\`\[Mu]\)]], 
              "] is the four-dimensional vector p with Lorentz index ", 
              Cell[BoxData[\(TraditionalForm\`\[Mu]\)]], ". A vector with \
space-time Dimension D is obtained by supplying the option Dimension \[Rule] \
D."}], "Text", CellTags -> "FourVector"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FV", RuleDelayed[ButtonData, "FV"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FV"]], 
              ", ", 
              ButtonBox["FVD", RuleDelayed[ButtonData, "FVD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FVD"]], 
              ", ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              "."}], "Text", CellTags -> "FourVector"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FourVector"], Cell[CellGroupData[{Cell[BoxData[
                \(FourVector[\(p, \[Mu]\)]\)], "Input", CellTags -> 
                "FourVector"], Cell[BoxData[\(TraditionalForm\`p\_\[Mu]\)], 
               "Output", CellTags -> "FourVector"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FourVector[\(\(p - q\), \[Mu]\)]\)], "Input", CellTags -> 
                "FourVector"], Cell[BoxData[FormBox[SubscriptBox[
                  RowBox[{"(", FormBox[TagBox[\(p - q\), HoldForm], 
                     "TraditionalForm"], ")"}], "\[Mu]"], TraditionalForm]], 
               "Output", CellTags -> "FourVector"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(FourVector[\(p, \[Mu]\)]\)]\)], "Input", 
               CellTags -> "FourVector"], Cell[BoxData[
                \(FourVector[\(p, \[Mu]\)]\)], "Output", CellTags -> 
                "FourVector"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(FourVector[
                     \(p, \[Mu], \(Dimension \[Rule] D\)\)]\)]\)], "Input", 
               CellTags -> "FourVector"], Cell[BoxData[
                \(FourVector[\(p, \[Mu], \(Dimension \[Rule] D\)\)]\)], 
               "Output", CellTags -> "FourVector"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(FCE[\(FourVector[\(p, \[Mu]\)]\)]\)]\)], 
               "Input", CellTags -> "FourVector"], Cell[BoxData[
                \(FourVector[\(p, \[Mu]\)]\)], "Output", CellTags -> 
                "FourVector"]}, Open]], Cell["There is no special function to \
expand momenta in FourVector. Since FourVector is turned into Pair internally \
ExpandScalarProduct may be used.", "Text", CellTags -> "FourVector"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(ExpandScalarProduct[\(FourVector[\(\(p - q\), \[Mu]\)]\)]\)]\
, "Input", CellTags -> "FourVector"], Cell[BoxData[FormBox[SubscriptBox[
                  RowBox[{"(", FormBox[TagBox[\(p - q\), HoldForm], 
                     "TraditionalForm"], ")"}], "\[Mu]"], TraditionalForm]], 
               "Output", CellTags -> "FourVector"]}, Open]]}, Open]], 
        Cell["FreeIndex", "ObjectName", CellTags -> "FreeIndex"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FreeIndex"], Cell["FreeIndex is a datatype which is \
recognized by Contract. Possible use: DataType[mu, FreeIndex] = True.", 
            "Text", CellTags -> "FreeIndex"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], ", ", 
              ButtonBox["DataType", RuleDelayed[ButtonData, "DataType"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DataType"]], "."}], "Text", 
            CellTags -> "FreeIndex"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["FreeQ2", "ObjectName", CellTags -> "FreeQ2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FreeQ2"], Cell["FreeQ2[expr, {form1, form2, ...}] \
yields True if expr does not contain any occurence of form1, form2, ... and \
False otherwise. FreeQ2[expr, form] is the same as FreeQ[expr, form].", 
            "Text", CellTags -> "FreeQ2"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["SelectFree", RuleDelayed[ButtonData, "SelectFree"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SelectFree"]], ", ", 
              ButtonBox["SelectNotFree", 
                RuleDelayed[ButtonData, "SelectNotFree"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SelectNotFree"]], "."}], "Text", 
            CellTags -> "FreeQ2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FreeQ2"], Cell[CellGroupData[{Cell[BoxData[
                \(FreeQ2[\(\(x + \(f[x]\) + y\),\ \({a, x}\)\)]\)], "Input", 
               CellTags -> "FreeQ2"], Cell[BoxData[\(TraditionalForm\`False\)]
                , "Output", CellTags -> "FreeQ2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FreeQ2[\(\(x + \(f[x]\) + y\), \({a, b}\)\)]\)], "Input", 
               CellTags -> "FreeQ2"], Cell[BoxData[\(TraditionalForm\`True\)]
                , "Output", CellTags -> "FreeQ2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(FreeQ2[\(x,\ y\)]\)], "Input", 
               CellTags -> "FreeQ2"], Cell[BoxData[\(TraditionalForm\`True\)]
                , "Output", CellTags -> "FreeQ2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(FreeQ2[\(\(f[x]\),\ f\)]\)], 
               "Input", CellTags -> "FreeQ2"], Cell[BoxData[
                \(TraditionalForm\`False\)], "Output", CellTags -> 
                "FreeQ2"]}, Open]]}, Open]], Cell["FRH", "ObjectName", 
         CellTags -> "FRH"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "FRH"], Cell["FRH[exp_] := \
FixedPoint[ReleaseHold, exp], i.e., FRH removes all HoldForm and Hold in \
exp.", "Text", CellTags -> "FRH"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Isolate", RuleDelayed[ButtonData, "Isolate"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Isolate"]]\
, "."}], "Text", CellTags -> "FRH"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FRH"], Cell[CellGroupData[{Cell[BoxData[
                \(Hold[\(1 - 1\ -\ \(Hold[\(2 - 2\)]\)\)]\)], "Input", 
               CellTags -> "FRH"], Cell[BoxData[
                \(TraditionalForm\`\(Hold[
                     \(\(-\(Hold[\(2 - 2\)]\)\) + 1 - 1\)]\)\)], "Output", 
               CellTags -> "FRH"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(FRH[%]\)], "Input", CellTags -> "FRH"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> "FRH"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Isolate[\(\(Solve[\(\(\(x^3\) - x - 1\) == 0\)]\), x, 
                     \(IsolateNames \[Rule] hh\)\)]\)], "Input", CellTags -> 
                "FRH"], Cell[BoxData[
                \(TraditionalForm\`\({\({
                        x \[Rule] \*TagBox[\(hh(3)\), HoldForm]}\), 
                      \({x \[Rule] \*TagBox[\(hh(6)\), HoldForm]}\), 
                      \({x \[Rule] \*TagBox[\(hh(7)\), HoldForm]}\)}\)\)], 
               "Output", CellTags -> "FRH"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(FRH[\(hh[3]\)]\)], "Input", 
               CellTags -> "FRH"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/3\ \@\(27\/2 - \(3\ \@69\)\/2\)\%3
                      \) + \@\(1\/2\ \((9 + \@69)\)\)\%3\/3\^\(2/3\)\)\)], 
               "Output", CellTags -> "FRH"]}, Open]], Cell[BoxData[
             \(Clear[hh]\)], "Input", CellTags -> "FRH"]}, Open]], 
        Cell["FromTFI", "ObjectName", CellTags -> "FromTFI"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FromTFI"], Cell["FromTFI[expr, q1, q2, p] translates \
the TFI notatation from the TARCER package to the usual FeynCalc notation. \
See the TARCER documentation on TFI for details on the conventions.", "Text", 
            CellTags -> "FromTFI"], Cell[TextData[{"See also: ", 
              ButtonBox["ToTFI", RuleDelayed[ButtonData, "ToTFI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "ToTFI"]], 
              "."}], "Text", CellTags -> "FromTFI"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FromTFI"], Cell[CellGroupData[{Cell[BoxData[
                \(ToTFI[\(\(FAD[\(q1, \(q1 - p\), \({q2, M}\), 
                         \({\(q2 - p\), m}\), \(q1 - q2\)\)]\), q1, q2, p\)]\
\)], "Input", CellTags -> "FromTFI"], Cell[BoxData[FormBox[InterpretationBox[
                  SubsuperscriptBox[
                   StyleBox["F", Rule[SingleLetterItalics, False], 
                     Rule[FontWeight, "Bold"]], RowBox[{FormBox[\({1, 0}\), 
                      "TraditionalForm"], FormBox[\({1, M}\), 
                      "TraditionalForm"], FormBox[\({1, 0}\), 
                      "TraditionalForm"], FormBox[\({1, m}\), 
                      "TraditionalForm"], FormBox[\({1, 0}\), 
                      "TraditionalForm"]}], RowBox[{"(", FormBox["D", 
                      "TraditionalForm"], ")"}]], TFI[D, m^2, {{1, 0}, 
                    {1, M}, {1, 0}, {1, m}, {1, 0}}], Editable -> True], 
                 TraditionalForm]], "Output", CellTags -> "FromTFI"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(FromTFI[\(\(TFI[\(D, \(SPD[\(p, p\)]\), \(SOD[p]\), 
                         \({\({1, 0}\), \({1, M}\), \({1, 0}\), \({1, m}\), 
                            \({1, 0}\)}\)\)]\), q1, q2, p\)]\)], "Input", 
               CellTags -> "FromTFI"], Cell[BoxData[
                \(TraditionalForm\`\(1\/\(
                      \(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_2\%2 . 
                       \((\((\(\*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\
\^2 - M\^2)\) . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1 - 
                           \(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2)\)\^2 . 
                       \((\(\*TagBox[StyleBox["\"q\"", 
                               Rule[FontSlant, "Italic"]], 
                              Function[StyleForm[Slot[1], 
                                Rule[FontSlant, "Italic"]]]]\)\_1\%2 - m\^2)\
\)\)\)\)], "Output", CellTags -> "FromTFI"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FromTFI[\(\(TFI[\(D, \(SPD[\(p, p\)]\), \(SOD[p]\), 
                         \({0, 1}\), \({\({1, m}\), \({1, M}\), \({1, 0}\), 
                            \({1, m}\), \({1, 0}\)}\)\)]\), q1, q2, p\)]\)], 
               "Input", CellTags -> "FromTFI"], Cell[BoxData[FormBox[
                 FractionBox[RowBox[{FormBox["\[CapitalDelta]", 
                     "TraditionalForm"], "\[CenterDot]", FormBox[
                     \(\(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_2\), 
                     "TraditionalForm"]}], 
                  \(\((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1 - 
                         \(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2)\)\^2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_2\%2 - M\^2)\)\
 . \((\((\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\
 - m\^2)\) . \((\(\*TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_1\%2 - m\^2)\)\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^2\)]\
, TraditionalForm]], "Output", CellTags -> "FromTFI"]}, Open]]}, Open]], 
        Cell["FUNCTION", "ObjectName", CellTags -> "FUNCTION"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FUNCTION"], Cell["FUNCTION[exp, string] is a head of \
an expression to be declared a function (of type string), if used in Write2."\
, "Text", CellTags -> "FUNCTION"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Write2", RuleDelayed[ButtonData, "Write2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Write2"]], 
              "."}], "Text", CellTags -> "FUNCTION"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["FunctionalD", "ObjectName", 
         CellTags -> "FunctionalD"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "FunctionalD"], 
           Cell["FunctionalD[expr, {QuantumField[name, {mu}, {a}][p], ...}] \
calculates the functional derivative of expr with respect to the field list \
(with incoming momenta p etc.) and does the fourier transform. \
FunctionalD[expr, {QuantumField[name, {mu},{a}], ...}] calculates the \
functional derivative and does partial integration but omits the x-space \
delta functions.", "Text", CellTags -> "FunctionalD"], 
           Cell["FunctionalD is a low level function used in FeynRule.", 
            "Text", CellTags -> "FunctionalD"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynRule", RuleDelayed[ButtonData, "FeynRule"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynRule"]], ", ", 
              ButtonBox["QuantumField", 
                RuleDelayed[ButtonData, "QuantumField"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "QuantumField"]], "."}], "Text", 
            CellTags -> "FunctionalD"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FunctionalD"], Cell[TextData[
             {"Instead of the usual ", Cell[BoxData[
                \(TraditionalForm\`\(\(\(\[Delta]\[Phi](x)\)/
                       \(\[Delta]\[Phi](y)\)\) = 
                     \(\(\[Delta]\^\((D)\)\)(\(x - y\))\)\)\)]], " the \
arguments and the \[Delta] function are omitted, i.e., for the program for \
simplicity: ", Cell[BoxData[
                \(TraditionalForm\`\(\(\[Delta]\[Phi]/\[Delta]\[Phi]\) = 1\)
                  \)]]}], "Text", CellTags -> "FunctionalD"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FunctionalD[\(\(QuantumField[\[Phi]]\), 
                     \(QuantumField[\[Phi]]\)\)]\)], "Input", CellTags -> 
                "FunctionalD"], Cell[BoxData[\(TraditionalForm\`1\)], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FunctionalD[\(\(\(QuantumField[\[Phi]]\)^2\), 
                     \(QuantumField[\[Phi]]\)\)]\)], "Input", CellTags -> 
                "FunctionalD"], Cell[BoxData[
                \(TraditionalForm\`\(2\ \[Phi]\)\)], "Output", CellTags -> 
                "FunctionalD"]}, Open]], Cell[TextData[
             {"Instead of the usual ", Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                        (\[Delta]\ \(\[PartialD]\_\[Mu] \(\[Phi](x)\)\))\)/
                       \(\[Delta]\[Phi](y)\)\) = 
                     \(\[PartialD]\_\[Mu] 
                       \(\(\[Delta]\^\((D)\)\)(\(x - y\))\)\)\)\)]], 
              " the arguments are omitted, and the ", Cell[BoxData[
                \(TraditionalForm\`\[PartialD]\_\[Mu]\)]], "operator is \
specified by default to be an integration by parts operator, i.e., the right \
hand side will be just ", Cell[BoxData[FormBox[RowBox[{RowBox[{"-", FormBox[
                      \(\[PartialD]\_\[Mu]\), "TraditionalForm"]}], ","}], 
                 TraditionalForm]]], " or, more precisely (by default) ", 
              Cell[BoxData[FormBox[RowBox[{"-", SubscriptBox[
                    \(\[PartialD]\&\[RightArrow]\), FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]]], "."}], "Text", ZeroWidthTimes -> True, 
            CellTags -> "FunctionalD"], Cell[CellGroupData[{Cell[BoxData[
                \(FunctionalD[\(\(QuantumField[
                       \(\(PartialD[\[Mu]]\), \[Phi]\)]\), 
                     \(QuantumField[\[Phi]]\)\)]\)], "Input", CellTags -> 
                "FunctionalD"], Cell[BoxData[FormBox[RowBox[{"-", 
                   SubscriptBox[\(\[PartialD]\&\[RightArrow]\), FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "FunctionalD"]}, Open]], 
           Cell[TextData[Cell[BoxData[
               \(TraditionalForm\`\(\(S[\[Phi]]\)\ = 
                    \(\(1/2\) \(\[Integral]\ 
                        \(d\^D \(x\ [\ \(
                             \(\(\[PartialD]\_\[Mu] \(\[Phi](x)\)\)\ 
                                \(\[PartialD]\^\[Mu] \(\[Phi](x)\)\)\) - 
                              \(m\^2 \(\[Phi](x)\)\ \(\[Phi](y)\)\)\)]\)\)\)\
\)\)\)]]], "Text", ZeroWidthTimes -> True, CellTags -> "FunctionalD"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(s[\[Phi]]\) = \(\((\(
                         \(QuantumField[\(\(PartialD[\[Mu]]\), \[Phi]\)]\) . 
                          \(QuantumField[\(\(PartialD[\[Mu]]\), \[Phi]\)]\)\)\
 - \(\(m^2\)\ \(\(QuantumField[\[Phi]]\) . 
                            \(QuantumField[\[Phi]]\)\)\))\)/2\)\)], "Input", 
               CellTags -> "FunctionalD"], Cell[BoxData[FormBox[RowBox[{
                   \(1\/2\), " ", RowBox[{"(", RowBox[{RowBox[{RowBox[
                          {SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                          \(\[Phi]\_\[Null]\%\[Null]\)}], ".", RowBox[
                          {SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                          \(\[Phi]\_\[Null]\%\[Null]\)}]}], "-", 
                       \(m\^2\ \(\[Phi] . \[Phi]\)\)}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "FunctionalD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(FunctionalD[\(\(s[\[Phi]]\), \(QuantumField[\[Phi]]\)\)]\)]\
, "Input", CellTags -> "FunctionalD"], Cell[BoxData[FormBox[RowBox[{
                   \(\(-\[Phi]\)\ m\^2\), "-", RowBox[{RowBox[{FormBox[
                        SubscriptBox["\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                        "TraditionalForm"], FormBox[SubscriptBox[
                         "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                        "TraditionalForm"]}], \(\[Phi]\_\[Null]\%\[Null]\)}]}]
                     , TraditionalForm]], "Output", CellTags -> 
                "FunctionalD"]}, Open]], Cell[TextData[Cell[BoxData[
               \(TraditionalForm\`\(\(S[A]\)\ =\ 
                    \(-\(\[Integral]\ \(
                         d\^D x\ 1\/4\ \(F\_a\%\[Mu]\[Nu](x)\)\ 
                          \(F\_\[Mu]\[Nu]a(x)\)\)\)\)\)\)]]], "Text", 
            ZeroWidthTimes -> True, CellTags -> "FunctionalD"], Cell[TextData[
             StyleBox["First approach", Rule[FontWeight, "Bold"]]], "Text", 
            CellTags -> "FunctionalD"], Cell[CellGroupData[{Cell[BoxData[
                \(F1 = \(FieldStrength[\(
                      \[Mu], \[Nu], a, \({A, b, c}\), 1, 
                       \(Explicit \[Rule] True\)\)]\)\)], "Input", 
               CellTags -> "FunctionalD"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                       FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                       FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]]}], "-", 
                   RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                        "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"]]}], "+", RowBox[{RowBox[
                      {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SubsuperscriptBox["A", 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     \(f\_\(abc\)\)}]}], TraditionalForm]], "Output", 
               CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(F2 = \(FieldStrength[\(
                      \[Mu], \[Nu], a, \({A, d, e}\), 1, 
                       \(Explicit \[Rule] True\)\)]\)\)], "Input", 
               CellTags -> "FunctionalD"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                       FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                       FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]]}], "-", 
                   RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                        "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"]]}], "+", RowBox[{RowBox[
                      {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SubsuperscriptBox["A", 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["e", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     \(f\_\(ade\)\)}]}], TraditionalForm]], "Output", 
               CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(S[A]\) = \(\(-\(1/4\)\)\(F1 . F2\)\)\)], "Input", 
               CellTags -> "FunctionalD"], Cell[BoxData[FormBox[RowBox[{
                   \(-\(1\/4\)\), " ", RowBox[{RowBox[{"(", RowBox[
                        {RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                          SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                          SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{RowBox[
                          {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(f\_\(abc\)\)}]}], ")"}], ".", RowBox[{"(", 
                       RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                          SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{RowBox[
                          {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["e", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(f\_\(ade\)\)}]}], ")"}]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell[TextData[{"In order to derive the equation of motion the \
functional derivative of ", Cell[BoxData[\(TraditionalForm\`S\)]], 
              " with respect to ", Cell[BoxData[
                \(TraditionalForm\`A\_\[Sigma]\%g\)]], "has to be set to \
zero. Bearing in mind that for FeynCalc we have to be precise as to where \
which operators (coming from the substitution of the derivative of the \
\[Delta] function) act:, act with the functional derivative operator on the \
first field strength:"}], "Text", CellTags -> "FunctionalD"], 
           Cell[TextData[{Cell[BoxData[FormBox[RowBox[{RowBox[
                    {FormBox[RowBox[{FormBox[RowBox[{FormBox[RowBox[{"0", 
                          " ", "=", " ", RowBox[{FormBox[
                          \(\((\[Delta]S)\)/\((\[Delta] \(A\_\[Sigma]\%g(y)\)
                               )\)\), "TraditionalForm"], "=", \(-\(2/4\)\)}]}
                          ], "TraditionalForm"], \(\[Integral] \(d\^D x\)\)}]
                          , "TraditionalForm"], " ", 
                        \((\[Delta]/\((\[Delta] \(A\_\[Sigma]\%g(y)\))\)\)}], 
                      "TraditionalForm"], " ", \(F\_\[Mu]\[Nu]a(x)\)}], 
                   ")"}], TraditionalForm]]], Cell[BoxData[FormBox[
                 RowBox[{FormBox[\(\ F\_a\%\(, \[Mu]\[Nu]\)\), 
                    "TraditionalForm"], "(", "x", ")"}], 
                 TraditionalForm]]]}], "Text", ZeroWidthTimes -> True, 
            CellTags -> "FunctionalD"], Cell[TextData[
             Cell[BoxData[FormBox[RowBox[{"See", " ", "what", " ", "happens", 
                  " ", "with", " ", "just", RowBox[{FormBox[
                     \(\((\[Delta]\(S[A]\))\)/\((\[Delta] A\_\[Sigma]\%g)\)\)\
, "TraditionalForm"], "."}]}], TraditionalForm]]]], "Text", 
            CellTags -> "FunctionalD"], Cell[CellGroupData[{Cell[BoxData[
                \(Ag = \(QuantumField[\(A, \({\[Sigma]}\), \({g}\)\)]\)\)], 
               "Input", CellTags -> "FunctionalD"], Cell[BoxData[
                FormBox[SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                    "TraditionalForm"], "TraditionalForm"], FormBox[
                   FormBox["g", "TraditionalForm"], "TraditionalForm"]], 
                 TraditionalForm]], "Output", CellTags -> "FunctionalD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(FunctionalD[\(F1, Ag\)]\)\)], "Input", CellTags -> 
                "FunctionalD"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(-g\^\(\[Nu]\[Sigma]\)\), " ", SubscriptBox[
                      \(\[PartialD]\&\[RightArrow]\), FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{
                     \(g\^\(\[Mu]\[Sigma]\)\), " ", SubscriptBox[
                      \(\[PartialD]\&\[RightArrow]\), FormBox[FormBox[
                        "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{
                     \(g\^\(\[Nu]\[Sigma]\)\), " ", SubsuperscriptBox["A", 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{
                     \(g\^\(\[Mu]\[Sigma]\)\), " ", SubsuperscriptBox["A", 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell["In order to minimize the number of dummy indices, replace b \
\[Rule] c.", "Text", CellTags -> "FunctionalD"], Cell[CellGroupData[
             {Cell[BoxData[\(t1\ =\ \(t1\ /.\ \(b \[Rule] c\)\)\)], "Input", 
               CellTags -> "FunctionalD"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{\(-g\^\(\[Nu]\[Sigma]\)\), " ", SubscriptBox[
                      \(\[PartialD]\&\[RightArrow]\), FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{
                     \(g\^\(\[Mu]\[Sigma]\)\), " ", SubscriptBox[
                      \(\[PartialD]\&\[RightArrow]\), FormBox[FormBox[
                        "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{
                     \(g\^\(\[Nu]\[Sigma]\)\), " ", SubsuperscriptBox["A", 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{
                     \(g\^\(\[Mu]\[Sigma]\)\), " ", SubsuperscriptBox["A", 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell[TextData[
             {"Instead of inserting the definition for the second ", 
              Cell[BoxData[\(TraditionalForm\`F\_a\%\[Mu]\[Nu]\)]], ", \
introduce a QuantumField object with antisymmetry built into the Lorentz \
indices:"}], "Text", CellTags -> "FunctionalD"], Cell[BoxData[
             \(F/:\ \(QuantumField[\(pard___, F, \[Beta]_, \[Alpha]_, s_\)]\)
                 := \(\(-\(QuantumField[\(pard, F, \[Alpha], \[Beta], s\)]\)
                   \)/;\(! \(OrderedQ[\({\[Beta], \[Alpha]}\)]\)\)\)\)], 
            "Input", CellTags -> "FunctionalD"], Cell[CellGroupData[
             {Cell[BoxData[
                \(QuantumField[\(F, \({\[Mu], \[Nu]}\), \({a}\)\)]\)], 
               "Input", CellTags -> "FunctionalD"], Cell[BoxData[
                FormBox[SubsuperscriptBox["F", RowBox[{FormBox[FormBox[
                      "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                    FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"]}], FormBox[FormBox["a", 
                    "TraditionalForm"], "TraditionalForm"]], 
                 TraditionalForm]], "Output", CellTags -> "FunctionalD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%/.\({\(\[Mu] \[RuleDelayed] \[Nu]\), 
                      \(\[Nu] \[RuleDelayed] \[Mu]\)}\)\)], "Input", 
               CellTags -> "FunctionalD"], Cell[BoxData[FormBox[
                 RowBox[{"-", SubsuperscriptBox["F", RowBox[{FormBox[
                       FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"]}], FormBox[
                     FormBox["a", "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "FunctionalD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t2 = \(\(Contract[\(ExpandPartialD[
                         \(\(-\(1/2\)\)\ 
                           \(t1 . \(QuantumField[
                               \(F, \(LorentzIndex[\[Mu]]\), 
                                 \(LorentzIndex[\[Nu]]\), \(SUNIndex[a]\)\)]\
\)\)\)]\)]\)/.\(Dot \[Rule] Times\)\)\)], "Input", CellTags -> 
                "FunctionalD"], Cell[BoxData[FormBox[RowBox[{RowBox[{\(1\/2\)
                     , " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["F", 
                        RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]}], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]]}]}], "+", RowBox[{\(1\/2\), " ", 
                     RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox["F", RowBox[{FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}], FormBox[FormBox["g", 
                          "TraditionalForm"], "TraditionalForm"]]}]}], "-", 
                   RowBox[{\(1\/2\), " ", SubsuperscriptBox["A", FormBox[
                       FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     SubsuperscriptBox["F", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]}], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/2\), " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["F", RowBox[{FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]}], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t3\ =\ \(t2\ /.\ \(\[Nu] \[Rule] \[Mu]\)\)\)], "Input", 
               CellTags -> "FunctionalD"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                       FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], SubsuperscriptBox["F", RowBox[
                       {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]}], FormBox[
                       FormBox["g", "TraditionalForm"], 
                       "TraditionalForm"]]}], "-", RowBox[{SubsuperscriptBox[
                      "A", FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     SubsuperscriptBox["F", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]}], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t4 = \(\(FCE[t3]\)/.\ \(
                      \(SUNF[\(a, c, g\)]\) \[Rule] 
                       \(-\(SUNF[\(g, c, a\)]\)\)\)\)\)], "Input", 
               CellTags -> "FunctionalD"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                       FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], SubsuperscriptBox["F", RowBox[
                       {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]}], FormBox[
                       FormBox["g", "TraditionalForm"], 
                       "TraditionalForm"]]}], "+", RowBox[{SubsuperscriptBox[
                      "A", FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     SubsuperscriptBox["F", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]}], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     \(f\_\(gca\)\)}]}], TraditionalForm]], "Output", 
               CellTags -> "FunctionalD"]}, Open]], 
           Cell[TextData[
             {"Since the variational derivative vanishes t4 implies that 0 = \
", Cell[BoxData[\(TraditionalForm\`\(D\_\[Mu] F\_g\%\[Mu]\[Sigma]\)\)]], 
              " ."}], "Text", CellTags -> "FunctionalD"], Cell[TextData[
             StyleBox["Second approach", Rule[FontWeight, "Bold"]]], "Text", 
            CellTags -> "FunctionalD"], Cell["It is of course also possible \
to do the functional deriviate on the S[A] with both field strength tensors \
inserted.", "Text", CellTags -> "FunctionalD"], Cell[CellGroupData[
             {Cell[BoxData[\(S[A]\)], "Input", CellTags -> "FunctionalD"], 
              Cell[BoxData[FormBox[RowBox[{\(-\(1\/4\)\), " ", RowBox[
                    {RowBox[{"(", RowBox[{RowBox[{SubscriptBox["\[PartialD]", 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                          SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{RowBox[
                          {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(f\_\(abc\)\)}]}], ")"}], ".", RowBox[{"(", 
                       RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                          SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{RowBox[
                          {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["e", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          \(f\_\(ade\)\)}]}], ")"}]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(r1 = \(FunctionalD[\(\(S[A]\), Ag\)]\)\)], "Input", 
               CellTags -> "FunctionalD"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{\(1\/2\), " ", RowBox[{"(", RowBox[
                        {RowBox[{FormBox[SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                          SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                          "TraditionalForm"]}], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["g", 
                          "TraditionalForm"], "TraditionalForm"]]}], ")"}]}], 
                   "-", RowBox[{\(1\/2\), " ", RowBox[{"(", RowBox[
                        {RowBox[{FormBox[SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                          SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"]}], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["g", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}], "+", RowBox[{
                     \(1\/2\), " ", RowBox[{"(", RowBox[{RowBox[{FormBox[
                          SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                          "TraditionalForm"], FormBox[SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                          "TraditionalForm"]}], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["g", 
                          "TraditionalForm"], "TraditionalForm"]]}], ")"}]}], 
                   "-", RowBox[{\(1\/2\), " ", RowBox[{"(", RowBox[
                        {RowBox[{FormBox[SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                          SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"]}], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["g", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}], "-", RowBox[{
                     \(1\/4\), " ", RowBox[{SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{\(1\/4\), " ", 
                     RowBox[{SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]], ".", RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/4\), " ", 
                     RowBox[{SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"]], ".", RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{\(1\/4\), " ", 
                     RowBox[{SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"]], ".", RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/4\), " ", 
                     RowBox[{SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SubsuperscriptBox["A", 
                        FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{\(1\/4\), " ", 
                     RowBox[{SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SubsuperscriptBox["A", 
                        FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/4\), " ", 
                     RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], ".", 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{\(1\/4\), " ", 
                     RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], ".", 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/4\), " ", 
                     RowBox[{SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SubsuperscriptBox["A", 
                        FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/4\), " ", 
                     RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], ".", 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["e", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{\(1\/4\), " ", 
                     RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], ".", 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["e", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{\(1\/4\), " ", 
                     RowBox[{SubsuperscriptBox["A", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]], ".", SubsuperscriptBox["A", 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["e", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{\(1\/4\), " ", 
                     RowBox[{SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]], ".", RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/4\), " ", 
                     RowBox[{SubsuperscriptBox["A", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]], ".", RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{\(1\/4\), " ", 
                     RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], ".", 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/4\), " ", 
                     RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], ".", 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{\(1\/4\), " ", 
                     RowBox[{SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"]], ".", RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["e", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/4\), " ", 
                     RowBox[{SubsuperscriptBox["A", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"]], ".", RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["e", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{\(1\/4\), " ", 
                     RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]]}], ".", 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["e", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/4\), " ", 
                     RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]]}], ".", 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["e", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell["This is just funcional derivation and partial integration \
and simple contraction of indices. No attempt is made to rename dummy indices \
(since this is difficult in general).", "Text", CellTags -> "FunctionalD"], 
           Cell["With a general replacement rule only valid for commuting \
fields the color indices can be canonicalized a bit more. The idea is to use \
the commutative properties of the vector fields, and canonicalize the color \
indices by a trick. This function will work on any commuting product of \
fields.", "Text", CellTags -> "FunctionalD"], Cell[BoxData[
             \(\(Clear[symfun]\) ;\)], "Input", CellTags -> "FunctionalD"], 
           Cell[BoxData[
             \(\(symfun[\(z_, fieldname_Symbol\)]\) := 
                \(Expand[\(SUNSimplify[
                    \(FixedPoint[\(\(\(
                           Collect2[\(\(
                               \(\(DotSimplify[\(#1/.\(Times \[Rule] Dot\)\)]
                                   \)/.
                                  \(\((
                                   \((\((qi___)\) . 
                                   \(QuantumField[
                                   \(par1___, fieldname, li1_, sui1_\)]\) . 
                                   \(QuantumField[
                                   \(par2___, fieldname, li2_, sui2_\)]\) . 
                                   qf___\ )\) any_)\) \[RuleDelayed] 
                                   \(\(
                                   (\((
                                   qi . 
                                   \(QuantumField[\(par1, A, li1, sui2\)]\) .
                                    \(QuantumField[
                                   \(par2, fieldname, li2, sui1\)]\) . qf\ )\
\) \((any/.\({\(sui1 \[RuleDelayed] sui2\), 
                                   \(sui2 \[RuleDelayed] sui1\)}\))\))\)/;
                                   \(\(
                                   (\(! 
                                   \((\(FreeQ2[\(any, \({sui1, su2}\)\)]\))\)
             \))\) && \(! \((\(OrderedQ[\({sui1, sui2}\)]\))\)\)\)\)\)\)/.
                                \(Dot \[Rule] Times\)\), QuantumField\)]\) &\
\), z, 42\)]\)]\)]\)\)], "Input", CellTags -> "FunctionalD"], 
           Cell[CellGroupData[{Cell[BoxData[\(r2\ =\ \(symfun[\(r1, A\)]\)\)]
                , "Input", CellTags -> "FunctionalD"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{\(1\/2\), " ", RowBox[{"(", RowBox[
                        {RowBox[{FormBox[SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                          SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                          "TraditionalForm"]}], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["g", 
                          "TraditionalForm"], "TraditionalForm"]]}], ")"}]}], 
                   "-", RowBox[{\(1\/2\), " ", RowBox[{"(", RowBox[
                        {RowBox[{FormBox[SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                          SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"]}], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["g", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}], "+", RowBox[{
                     \(1\/2\), " ", RowBox[{"(", RowBox[{RowBox[{FormBox[
                          SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                          "TraditionalForm"], FormBox[SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                          "TraditionalForm"]}], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["g", 
                          "TraditionalForm"], "TraditionalForm"]]}], ")"}]}], 
                   "-", RowBox[{\(1\/2\), " ", RowBox[{"(", RowBox[
                        {RowBox[{FormBox[SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                          SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"]}], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["g", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}], "-", RowBox[{
                     \(1\/2\), " ", SubsuperscriptBox["A", FormBox[FormBox[
                        "\[Sigma]", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{SubscriptBox[
                        "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/2\), " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/2\), " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/2\), " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/4\), " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["e", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/2\), " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["e", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/4\), " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["e", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(r3 = \(r2/.\(\[Nu] \[Rule] \[Mu]\)\)\)], "Input", 
               CellTags -> "FunctionalD"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{RowBox[{FormBox[SubscriptBox["\[PartialD]", 
                         FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                        SubscriptBox["\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                        "TraditionalForm"]}], SubsuperscriptBox["A", 
                      FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["g", 
                        "TraditionalForm"], "TraditionalForm"]]}], "-", 
                   RowBox[{RowBox[{FormBox[SubscriptBox["\[PartialD]", 
                         FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                        SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"]}], 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["g", "TraditionalForm"], 
                       "TraditionalForm"]]}], "-", RowBox[{SubsuperscriptBox[
                      "A", FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{"2", " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(3\/4\), " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["e", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/4\), " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["e", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell[TextData[{"Inspection reveals that still terms are the same. \
Gather the terms with two ", Cell[BoxData[\(TraditionalForm\`\(f\ \)\)]], 
              "'s:"}], "Text", CellTags -> "FunctionalD"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(twof = \(Select[\(r3, \(
                        \(\(Count[\(#, \(SUNF[__]\)\)]\) === 2\) &\)\)]\)\)], 
               "Input", CellTags -> "FunctionalD"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{\(-\(3\/4\)\), " ", SubsuperscriptBox[
                      "A", FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["e", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/4\), " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["e", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(twofnew = \(\((\(twof \[LeftDoubleBracket] 1 
                          \[RightDoubleBracket]\) + 
                        \((\(twof[\([2]\)]\)/.
                           \({\(b \[RuleDelayed] c\), \(c \[RuleDelayed] b\)}
                            \))\))\)/.\({
                       \(a \[RuleDelayed] c\), \(c \[RuleDelayed] a\)}\)\)\)]\
, "Input", CellTags -> "FunctionalD"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"-", SubsuperscriptBox["A", FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"]]}], " ", SubsuperscriptBox["A", 
                    FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["b", 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["e", "TraditionalForm"], "TraditionalForm"]], 
                   " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["e", "TraditionalForm"], 
                       "TraditionalForm"]}]], " ", SubscriptBox["f", 
                    RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["g", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(r4\ =\ \(r3 - twof + twofnew\)\)
                ], "Input", CellTags -> "FunctionalD"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{RowBox[{FormBox[SubscriptBox[
                         "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                        "TraditionalForm"], FormBox[SubscriptBox[
                         "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                        "TraditionalForm"]}], SubsuperscriptBox["A", 
                      FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["g", 
                        "TraditionalForm"], "TraditionalForm"]]}], "-", 
                   RowBox[{RowBox[{FormBox[SubscriptBox["\[PartialD]", 
                         FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                        SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"]}], 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["g", "TraditionalForm"], 
                       "TraditionalForm"]]}], "-", RowBox[{SubsuperscriptBox[
                      "A", FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{"2", " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["e", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell["Check that this is now indeed the same as the t4 result from \
the first attempt.", "Text", CellTags -> "FunctionalD"], 
           Cell[CellGroupData[{Cell[BoxData["t4"], "Input", CellTags -> 
                "FunctionalD"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                     SubsuperscriptBox["F", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]}], FormBox[FormBox["g", 
                        "TraditionalForm"], "TraditionalForm"]]}], "+", 
                   RowBox[{SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["F", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]}], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     \(f\_\(gca\)\)}]}], TraditionalForm]], "Output", 
               CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(w0 = \(\(\(RightPartialD[\[Mu]]\) . 
                       \(FieldStrength[\(\[Mu], \[Sigma], g, \({A, a, b}\), 1
                          \)]\)\) + \(\(QuantumField[
                         \(A, \(LorentzIndex[\[Mu]]\), \(SUNIndex[c]\)\)]\) 
                       \(FieldStrength[\(\[Mu], \[Sigma], a, \({A, b, d}\), 1
                          \)]\) \(SUNF[\(g, c, a\)]\)\)\)\)], "Input", 
               CellTags -> "FunctionalD"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], ".", SubsuperscriptBox["F", 
                      \(\[Mu]\[Sigma]\), RowBox[{"g", FormBox[\({A, a, b}\), 
                         "TraditionalForm"], FormBox["1", 
                         "TraditionalForm"]}]]}], "+", RowBox[
                    {SubsuperscriptBox["F", \(\[Mu]\[Sigma]\), RowBox[
                       {"a", FormBox[\({A, b, d}\), "TraditionalForm"], 
                        FormBox["1", "TraditionalForm"]}]], " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", \(f\_\(gca\)\)}]}], TraditionalForm]], "Output", 
               CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(w1 = \(Explicit[w0]\)\)], 
               "Input", CellTags -> "FunctionalD"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{SubscriptBox[
                      \(\[PartialD]\&\[RightArrow]\), FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                     ".", RowBox[{"(", RowBox[{RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                          SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["g", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                          SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["g", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{RowBox[
                          {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["g", 
                          "TraditionalForm"], "TraditionalForm"]}]]}]}], 
                       ")"}]}], "-", RowBox[{SubsuperscriptBox["A", FormBox[
                       FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     RowBox[{"(", RowBox[{RowBox[{SubscriptBox["\[PartialD]", 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], "+", 
                         RowBox[{RowBox[{SubsuperscriptBox["A", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"]]}], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"]}]]}]}], ")"}], " ", SubscriptBox[
                      "f", RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(w2 = \(\(ExpandPartialD[w1]\)/.\(Dot \[Rule] Times\)\)\)], 
               "Input", CellTags -> "FunctionalD"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{RowBox[{FormBox[SubscriptBox[
                         "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                        "TraditionalForm"], FormBox[SubscriptBox[
                         "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                        "TraditionalForm"]}], SubsuperscriptBox["A", 
                      FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["g", 
                        "TraditionalForm"], "TraditionalForm"]]}], "-", 
                   RowBox[{RowBox[{FormBox[SubscriptBox["\[PartialD]", 
                         FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                        SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"]}], 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["g", "TraditionalForm"], 
                       "TraditionalForm"]]}], "+", RowBox[{SubsuperscriptBox[
                      "A", FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["d", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(dif1\ =\ \(w2 - r4\)\)], 
               "Input", CellTags -> "FunctionalD"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"-", RowBox[{"(", RowBox[
                        {RowBox[{FormBox[SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                          SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                          "TraditionalForm"]}], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["g", 
                          "TraditionalForm"], "TraditionalForm"]]}], ")"}]}], 
                   "+", RowBox[{RowBox[{FormBox[SubscriptBox["\[PartialD]", 
                         FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                        SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"]}], 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["g", "TraditionalForm"], 
                       "TraditionalForm"]]}], "+", RowBox[{RowBox[
                      {FormBox[SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                        "TraditionalForm"], FormBox[SubscriptBox[
                         "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                        "TraditionalForm"]}], SubsuperscriptBox["A", 
                      FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["g", 
                        "TraditionalForm"], "TraditionalForm"]]}], "-", 
                   RowBox[{RowBox[{FormBox[SubscriptBox["\[PartialD]", 
                         FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                        SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"]}], 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["g", "TraditionalForm"], 
                       "TraditionalForm"]]}], "+", RowBox[{SubsuperscriptBox[
                      "A", FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{"2", " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["d", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["e", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(dif2 = \(symfun[\(dif1, A\)]\)\)
                ], "Input", CellTags -> "FunctionalD"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"-", RowBox[{"(", RowBox[
                        {RowBox[{FormBox[SubscriptBox["\[PartialD]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                          SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                          "TraditionalForm"]}], SubsuperscriptBox["A", 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["g", 
                          "TraditionalForm"], "TraditionalForm"]]}], ")"}]}], 
                   "+", RowBox[{RowBox[{FormBox[SubscriptBox["\[PartialD]", 
                         FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                        SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"]}], 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["g", "TraditionalForm"], 
                       "TraditionalForm"]]}], "+", RowBox[{RowBox[
                      {FormBox[SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                        "TraditionalForm"], FormBox[SubscriptBox[
                         "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                        "TraditionalForm"]}], SubsuperscriptBox["A", 
                      FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["g", 
                        "TraditionalForm"], "TraditionalForm"]]}], "-", 
                   RowBox[{RowBox[{FormBox[SubscriptBox["\[PartialD]", 
                         FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"], FormBox[
                        SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], "TraditionalForm"]}], 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["g", "TraditionalForm"], 
                       "TraditionalForm"]]}], "+", RowBox[{SubsuperscriptBox[
                      "A", FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]]}], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{"2", " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{"2", " ", 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                     " ", RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Sigma]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["d", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[
                    {SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubsuperscriptBox["A", FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["d", "TraditionalForm"], "TraditionalForm"]], 
                     " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["g", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "FunctionalD"]}, Open]], 
           Cell["quod erat demonstrandum.", "Text", CellTags -> 
             "FunctionalD"], Cell[BoxData[
             \(\(Unset[\(s[\[Phi]]\)]\) ; \(Unset[\(S[A]\)]\) ; 
                \(Clear[\(Ag, F1, F2, t1, t2, t3, t4, F, r1, r2, r3, r4, 
                    symfun, twof, twofnew, w0, w1, w2, dif1, dif2, dif3\)]\)\
\)], "Input", CellTags -> "FunctionalD"]}, Open]], 
        Cell[CellGroupData[
          {Cell["Example of funcional differentiation as used in FeynRule", 
            "Subsubsection", CellTags -> "FunctionalD"], 
           Cell["This is a part of the QCD Lagrangian.", "Text", 
            CellTags -> "FunctionalD"], Cell[CellGroupData[{Cell[BoxData[
                \(\((Gstrong * \(\(QuantumField[
                          \(GaugeField,\ \(LorentzIndex[li1]\),\(\ \ \)
                            \(SUNIndex[si2]\)\)]\) .\(\ \ \)
                        \(QuantumField[\(
                           GaugeField,\ \(LorentzIndex[li2]\),\(\ \ \ \)
                            \(SUNIndex[si4]\)\)]\)\ .\(\ \ \)
                        \(QuantumField[\(
                           \(PartialD[\(LorentzIndex[li1]\)]\),\ GaugeField,
                            \(\ \ \ \)\(LorentzIndex[li2]\),\ 
                            \(SUNIndex[si1]\)\)]\)\) *\(\ \ \)
                      \(SUNF[\(\(SUNIndex[si1]\),\ \(SUNIndex[si2]\),\ 
                          \(SUNIndex[si4]\)\)]\))\)/4\)], "Input"], 
              Cell[BoxData[FormBox[RowBox[{\(1\/4\), " ", \(g\_s\), " ", 
                   RowBox[{SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["li1", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["si2", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                      FormBox[FormBox["li2", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["si4", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "li1", "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                        FormBox[FormBox["li2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["si1", 
                          "TraditionalForm"], "TraditionalForm"]]}]}], " ", 
                   SubscriptBox["f", RowBox[{FormBox[FormBox["si1", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["si2", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["si4", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], 
               "Output"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(FunctionalD[\(%,\ \({\(
                         \(QuantumField[\(GaugeField, \({\[Mu]}\), \({a}\)\)]
                           \)[p]\),\ \(\(
                           QuantumField[\(GaugeField, \({\[Nu]}\), \({b}\)\)]
                           \)[q]\),\ \(\(
                           QuantumField[\(GaugeField, \({\[Rho]}\), \({c}\)\)
                            ]\)[r]\)}\)\)]\)], "Input", CellTags -> 
                "FunctionalD"], Cell[BoxData[FormBox[RowBox[{\(1\/4\), " ", 
                   \(g\_s\), " ", RowBox[{"(", RowBox[{RowBox[{RowBox[
                          {"(", RowBox[{\(g\^\(li1\[Mu]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si2", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}], ".", RowBox[
                          {"(", RowBox[{\(g\^\(li2\[Nu]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "b", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si4", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}], ".", RowBox[
                          {"(", RowBox[{\(-\[ImaginaryI]\), " ", 
                          SuperscriptBox[FormBox["r", "TraditionalForm"], 
                          FormBox[FormBox["li1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(li2\[Rho]\)\), 
                          " ", SubscriptBox["\[Delta]", RowBox[{FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["si1", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], 
                          ")"}]}], "+", RowBox[{RowBox[{"(", RowBox[{
                          \(g\^\(li1\[Mu]\)\), " ", SubscriptBox["\[Delta]", 
                          RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["si2", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], ")"}], 
                         ".", RowBox[{"(", RowBox[{\(g\^\(li2\[Rho]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "c", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si4", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}], ".", RowBox[
                          {"(", RowBox[{\(-\[ImaginaryI]\), " ", 
                          SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["li1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(li2\[Nu]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "b", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si1", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}]}], "+", RowBox[
                        {RowBox[{"(", RowBox[{\(g\^\(li1\[Nu]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "b", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si2", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}], ".", RowBox[
                          {"(", RowBox[{\(g\^\(li2\[Mu]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si4", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}], ".", RowBox[
                          {"(", RowBox[{\(-\[ImaginaryI]\), " ", 
                          SuperscriptBox[FormBox["r", "TraditionalForm"], 
                          FormBox[FormBox["li1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(li2\[Rho]\)\), 
                          " ", SubscriptBox["\[Delta]", RowBox[{FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["si1", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], 
                          ")"}]}], "+", RowBox[{RowBox[{"(", RowBox[{
                          \(g\^\(li1\[Nu]\)\), " ", SubscriptBox["\[Delta]", 
                          RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["si2", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], ")"}], 
                         ".", RowBox[{"(", RowBox[{\(g\^\(li2\[Rho]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "c", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si4", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}], ".", RowBox[
                          {"(", RowBox[{\(-\[ImaginaryI]\), " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["li1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(li2\[Mu]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si1", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}]}], "+", RowBox[
                        {RowBox[{"(", RowBox[{\(g\^\(li1\[Rho]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "c", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si2", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}], ".", RowBox[
                          {"(", RowBox[{\(g\^\(li2\[Mu]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si4", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}], ".", RowBox[
                          {"(", RowBox[{\(-\[ImaginaryI]\), " ", 
                          SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["li1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(li2\[Nu]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "b", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si1", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}]}], "+", RowBox[
                        {RowBox[{"(", RowBox[{\(g\^\(li1\[Rho]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "c", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si2", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}], ".", RowBox[
                          {"(", RowBox[{\(g\^\(li2\[Nu]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "b", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si4", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}], ".", RowBox[
                          {"(", RowBox[{\(-\[ImaginaryI]\), " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["li1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(li2\[Mu]\)\), " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["si1", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}]}]}], ")"}], " ", 
                   SubscriptBox["f", RowBox[{FormBox[FormBox["si1", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["si2", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["si4", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "FunctionalD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(Calc[\(%//Calc\)]\)//Factor\)]
                , "Input", CellTags -> "FunctionalD"], Cell[BoxData[
                FormBox[RowBox[{\(1\/4\), " ", "\[ImaginaryI]", " ", \(g\_s\)
                   , " ", RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[
                          FormBox["q", "TraditionalForm"], FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                         " ", \(g\^\(\[Nu]\[Rho]\)\)}], "-", RowBox[
                        {SuperscriptBox[FormBox["r", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(\[Nu]\[Rho]\)\)}], 
                       "-", RowBox[{\(g\^\(\[Mu]\[Rho]\)\), " ", 
                         SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{
                         \(g\^\(\[Mu]\[Rho]\)\), " ", SuperscriptBox[FormBox[
                          "r", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "+", 
                       RowBox[{\(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], FormBox[FormBox[
                          "\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{
                         \(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[FormBox[
                          "q", "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]]}]}], ")"}], 
                   " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "FunctionalD"]}, Open]]}, Open]], 
        Cell["FV", "ObjectName", CellTags -> "FV"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FV"], Cell[TextData[{"FV[", 
              StyleBox["p", Rule[FontSlant, "Italic"]], ", ", Cell[BoxData[
                \(TraditionalForm\`\[Mu]\)]], 
              "] is the four-dimensional vector ", Cell[BoxData[
                \(TraditionalForm\`\(p\^\[Mu]\)\)]], ". "}], "Text", 
            CellTags -> "FV"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FCE", RuleDelayed[ButtonData, "FCE"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCE"]], 
              ", ", 
              ButtonBox["FCI", RuleDelayed[ButtonData, "FCI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCI"]], 
              ", ", 
              ButtonBox["FVD", RuleDelayed[ButtonData, "FVD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FVD"]], 
              ", ", 
              ButtonBox["FourVector", RuleDelayed[ButtonData, "FourVector"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FourVector"]], ", ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              "."}], "Text", CellTags -> "FV"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FV"], Cell[CellGroupData[{Cell[BoxData[
                \(FV[\(p, \[Mu]\)]\)], "Input", CellTags -> "FV"], 
              Cell[BoxData[\(TraditionalForm\`\(p\^\[Mu]\)\)], "Output", 
               CellTags -> "FV"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(FV[\(\(p - q\), \[Mu]\)]\)], "Input", CellTags -> "FV"], 
              Cell[BoxData[FormBox[SuperscriptBox[FormBox[\(p - q\), 
                   "TraditionalForm"], "\[Mu]"], TraditionalForm]], "Output", 
               CellTags -> "FV"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(FV[\(p, \[Mu]\)]\)//StandardForm\)], "Input", CellTags -> 
                "FV"], Cell[BoxData[\(FV[\(p, \[Mu]\)]\)], "Output", 
               CellTags -> "FV"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(FCI[\(FV[\(p, \[Mu]\)]\)]\)//StandardForm\)], "Input", 
               CellTags -> "FV"], Cell[BoxData[
                \(Pair[\(\(LorentzIndex[\[Mu]]\), \(Momentum[p]\)\)]\)], 
               "Output", CellTags -> "FV"]}, Open]], Cell["There is no \
special function to expand momenta in FV; ExpandScalarProduct does the job.", 
            "Text", CellTags -> "FV"], Cell[CellGroupData[{Cell[BoxData[
                \(ExpandScalarProduct[\(FV[\(\(p - q\), \[Mu]\)]\)]\)], 
               "Input", CellTags -> "FV"], Cell[BoxData[FormBox[
                 SuperscriptBox[FormBox[\(p - q\), "TraditionalForm"], 
                  "\[Mu]"], TraditionalForm]], "Output", CellTags -> "FV"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(StandardForm[%]\)], 
               "Input", CellTags -> "FV"], Cell[BoxData[
                \(FV[\(\(p - q\), \[Mu]\)]\)], "Output", CellTags -> "FV"]}, 
             Open]]}, Open]], Cell["FVD", "ObjectName", CellTags -> "FVD"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FVD"], Cell[TextData[{"FVD[", 
              StyleBox["p", Rule[FontSlant, "Italic"]], ", ", Cell[BoxData[
                \(TraditionalForm\`\[Mu]\)]], 
              "] is the D-dimensional vector ", 
              StyleBox["p", Rule[FontSlant, "Italic"]], 
              " with Lorentz index ", Cell[BoxData[\(TraditionalForm\`\[Mu]\)]
                ], "."}], "Text", CellTags -> "FVD"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FCE", RuleDelayed[ButtonData, "FCE"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCE"]], 
              ", ", 
              ButtonBox["FCI", RuleDelayed[ButtonData, "FCI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCI"]], 
              ", ", 
              ButtonBox["FV", RuleDelayed[ButtonData, "FV"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FV"]], 
              ", ", 
              ButtonBox["FourVector", RuleDelayed[ButtonData, "FourVector"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FourVector"]], ", ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              "."}], "Text", CellTags -> "FVD"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FVD"], Cell[CellGroupData[{Cell[BoxData[
                \(FVD[\(p, \[Mu]\)]\)], "Input", CellTags -> "FVD"], 
              Cell[BoxData[\(TraditionalForm\`\(p\^\[Mu]\)\)], "Output", 
               CellTags -> "FVD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(FVD[\(\(p - q\), \[Mu]\)]\)], "Input", CellTags -> "FVD"], 
              Cell[BoxData[FormBox[SuperscriptBox[FormBox[\(p - q\), 
                   "TraditionalForm"], "\[Mu]"], TraditionalForm]], "Output", 
               CellTags -> "FVD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(FVD[\(p, \[Mu]\)]\)//StandardForm\)], "Input", 
               CellTags -> "FVD"], Cell[BoxData[\(FVD[\(p, \[Mu]\)]\)], 
               "Output", CellTags -> "FVD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(FCI[\(FVD[\(p, \[Mu]\)]\)]\)//StandardForm\)], "Input", 
               CellTags -> "FVD"], Cell[BoxData[
                \(Pair[\(\(LorentzIndex[\(\[Mu], D\)]\), 
                     \(Momentum[\(p, D\)]\)\)]\)], "Output", CellTags -> 
                "FVD"]}, Open]], Cell[
            "There is no special function to expand momenta in FVD.", "Text", 
            CellTags -> "FVD"], Cell[CellGroupData[{Cell[BoxData[
                \(ExpandScalarProduct[\(FVD[\(\(p - q\), \[Mu]\)]\)]\)], 
               "Input", CellTags -> "FVD"], Cell[BoxData[FormBox[
                 SuperscriptBox[FormBox[\(p - q\), "TraditionalForm"], 
                  "\[Mu]"], TraditionalForm]], "Output", CellTags -> "FVD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(StandardForm[%]\)], 
               "Input", CellTags -> "FVD"], Cell[BoxData[
                \(FVD[\(\(p - q\), \[Mu]\)]\)], "Output", CellTags -> 
                "FVD"]}, Open]]}, Open]], Cell["GA", "ObjectName", 
         CellTags -> "GA"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "GA"], 
           Cell[TextData[{"GA[", Cell[BoxData[\(TraditionalForm\`\[Mu]\)]], 
              "] can be used as input for a 4-dimensional ", Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\(\[Mu]\ \)\)]], 
              "and is transformed into DiracGamma[LorentzIndex[", 
              Cell[BoxData[\(TraditionalForm\`\[Mu]\)]], 
              "]] by FeynCalcInternal (=FCI).GA[", Cell[BoxData[
                \(TraditionalForm\`\(\[Mu], \[Nu],\)\)]], 
              " ...] is a short form for GA[", Cell[BoxData[
                \(TraditionalForm\`\[Mu]\)]], "].GA[", Cell[BoxData[
                \(TraditionalForm\`\[Nu]\)]], "]. ... ."}], "Text", 
            CellTags -> "GA"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracMatrix", RuleDelayed[ButtonData, 
                 "DiracMatrix"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracMatrix"]], ", ", 
              ButtonBox["GAD", RuleDelayed[ButtonData, "GAD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GAD"]], 
              ", ", 
              ButtonBox["GS", RuleDelayed[ButtonData, "GS"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GS"]], 
              "."}], "Text", CellTags -> "GA"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "GA"], Cell[CellGroupData[{Cell[BoxData[\(GA[\[Mu]]\)]
                , "Input", CellTags -> "GA"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu]\)\)], "Output", 
               CellTags -> "GA"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GA[\(\[Mu], \[Nu]\)]\) - \(GA[\(\[Nu], \[Mu]\)]\)\)], 
               "Input", CellTags -> "GA"], Cell[BoxData[
                \(TraditionalForm\`\(\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu]\) - 
                     \(\[Gamma]\^\[Nu] . \[Gamma]\^\[Mu]\)\)\)], "Output", 
               CellTags -> "GA"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(FCI[\(GA[\[Mu]]\)]\)]\)], "Input", 
               CellTags -> "GA"], Cell[BoxData[
                \(DiracGamma[\(LorentzIndex[\[Mu]]\)]\)], "Output", 
               CellTags -> "GA"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(GA[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\)], "Input", 
               CellTags -> "GA"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . 
                     \[Gamma]\^\[Rho] . \[Gamma]\^\[Sigma]\)\)], "Output", 
               CellTags -> "GA"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(GA[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\)]\)]\
, "Input", CellTags -> "GA"], Cell[BoxData[
                \(\(GA[\[Mu]]\) . \(GA[\[Nu]]\) . \(GA[\[Rho]]\) . 
                   \(GA[\[Sigma]]\)\)], "Output", CellTags -> "GA"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(GA[\[Alpha]]\) . \((\(GS[p]\) + m)\) . \(GA[\[Beta]]\)\)]\
, "Input", CellTags -> "GA"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Alpha] . 
                     \((m + \(\[Gamma] \[CenterDot] p\))\) . 
                     \[Gamma]\^\[Beta]\)\)], "Output", CellTags -> "GA"]}, 
             Open]]}, Open]], Cell["GAD", "ObjectName", CellTags -> "GAD"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GAD"], Cell[TextData[{"GAD[", Cell[BoxData[
                \(TraditionalForm\`\[Mu]\)]], 
              "] can be used as input for a D-dimensional ", Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\(\[Mu]\ \)\)]], 
              "and is transformed into DiracGamma[LorentzIndex[", 
              Cell[BoxData[\(TraditionalForm\`\[Mu]\)]], 
              ",D],D] by FeynCalcInternal (=FCI).GAD[", Cell[BoxData[
                \(TraditionalForm\`\(\[Mu], \[Nu],\ ...\)\)]], 
              "] is a short form for GAD[", Cell[BoxData[
                \(TraditionalForm\`\[Mu]\)]], "].GAD[", Cell[BoxData[
                \(TraditionalForm\`\[Nu]\)]], "]. ... ."}], "Text", 
            CellTags -> "GAD"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracMatrix", RuleDelayed[ButtonData, 
                 "DiracMatrix"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracMatrix"]], ", ", 
              ButtonBox["GA", RuleDelayed[ButtonData, "GA"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GA"]], 
              ", ", 
              ButtonBox["GS", RuleDelayed[ButtonData, "GS"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GS"]], 
              "."}], "Text", CellTags -> "GAD"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "GAD"], Cell[CellGroupData[{Cell[BoxData[
                \(GAD[\[Mu]]\)], "Input", CellTags -> "GAD"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu]\)\)], "Output", 
               CellTags -> "GAD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GAD[\(\[Mu], \[Nu]\)]\) - \(GAD[\(\[Nu], \[Mu]\)]\)\)], 
               "Input", CellTags -> "GAD"], Cell[BoxData[
                \(TraditionalForm\`\(\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu]\) - 
                     \(\[Gamma]\^\[Nu] . \[Gamma]\^\[Mu]\)\)\)], "Output", 
               CellTags -> "GAD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(FCI[\(GAD[\[Mu]]\)]\)]\)], "Input", 
               CellTags -> "GAD"], Cell[BoxData[
                \(DiracGamma[\(\(LorentzIndex[\(\[Mu], D\)]\), D\)]\)], 
               "Output", CellTags -> "GAD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(GAD[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\)], "Input", 
               CellTags -> "GAD"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu] . 
                     \[Gamma]\^\[Rho] . \[Gamma]\^\[Sigma]\)\)], "Output", 
               CellTags -> "GAD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(GAD[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\)]\)]\
, "Input", CellTags -> "GAD"], Cell[BoxData[
                \(\(GAD[\[Mu]]\) . \(GAD[\[Nu]]\) . \(GAD[\[Rho]]\) . 
                   \(GAD[\[Sigma]]\)\)], "Output", CellTags -> "GAD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GAD[\[Alpha]]\) . \((\(GSD[p]\) + m)\) . \(GAD[\[Beta]]\)
                  \)], "Input", CellTags -> "GAD"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Alpha] . 
                     \((m + \(\[Gamma] \[CenterDot] p\))\) . 
                     \[Gamma]\^\[Beta]\)\)], "Output", CellTags -> "GAD"]}, 
             Open]]}, Open]], Cell["GammaEpsilon", "ObjectName", 
         CellTags -> "GammaEpsilon"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "GammaEpsilon"], 
           Cell["GammaEpsilon[exp] gives a series expansion of Gamma[exp] in \
Epsilon up to order 6 (where EulerGamma is neglected).", "Text", 
            CellTags -> "GammaEpsilon"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["GammaExpand", RuleDelayed[ButtonData, 
                 "GammaExpand"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GammaExpand"]], ", ", 
              ButtonBox["Series2", RuleDelayed[ButtonData, "Series2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Series2"]]\
, "."}], "Text", CellTags -> "GammaEpsilon"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "GammaEpsilon"], Cell["If the argument is of the form \
(1+a Epsilon) the result is not calculated but tabulated.", "Text", 
            CellTags -> "GammaEpsilon"], Cell[CellGroupData[{Cell[BoxData[
                \(GammaEpsilon[\(1 + \(a\ Epsilon\)\)]\)], "Input", 
               CellTags -> "GammaEpsilon"], Cell[BoxData[
                \(TraditionalForm\`\(\(C$1781\ 
                       \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^6\) + 
                     \(\((\(\(-\(1\/5\)\)\ 
                            \*TagBox[\(\[Zeta](
                                \(\*TagBox["5", Zeta, Rule[Editable, True]]
                                 \))\), InterpretTemplate[Function[
                                BoxForm`e$, Zeta[BoxForm`e$]]]]\ a\^5\) - 
                          \(1\/36\ \[Pi]\^2\ 
                            \*TagBox[\(\[Zeta](
                                \(\*TagBox["3", Zeta, Rule[Editable, True]]
                                 \))\), InterpretTemplate[Function[
                                BoxForm`e$, Zeta[BoxForm`e$]]]]\ a\^5\))\)\ 
                       \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^5\) + 
                     \(1\/160\ a\^4\ \[Pi]\^4\ 
                       \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^4\) - 
                     \(1\/3\ a\^3\ \*TagBox[\(
                          \[Zeta](\(\*TagBox["3", Zeta, 
                              Rule[Editable, True]]\))\), 
                         InterpretTemplate[Function[BoxForm`e$, 
                           Zeta[BoxForm`e$]]]]\ 
                       \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^3\) + 
                     \(1\/12\ a\^2\ \[Pi]\^2\ 
                       \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^2\) + 1\
\)\)], "Output", CellTags -> "GammaEpsilon"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(GammaEpsilon[\(1 - \(Epsilon/2\)\)]\)], "Input", 
               CellTags -> "GammaEpsilon"], Cell[BoxData[
                \(TraditionalForm\`\(\(C$1782\ 
                       \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^6\) + 
                     \(\((\(\[Pi]\^2\ \*TagBox[\(
                                \[Zeta](
                                 \(\*TagBox["3", Zeta, Rule[Editable, True]]
                                  \))\), 
                               InterpretTemplate[Function[BoxForm`e$, 
                                 Zeta[BoxForm`e$]]]]\)\/1152 + 
                          \*TagBox[\(\[Zeta](
                               \(\*TagBox["5", Zeta, Rule[Editable, True]]\)
                               )\), InterpretTemplate[Function[BoxForm`e$, 
                               Zeta[BoxForm`e$]]]]\/160)\)\ 
                       \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^5\) + 
                     \(\[Pi]\^4\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]
                         \^4\)\/2560 + \(
                      1\/24\ \*TagBox[\(
                          \[Zeta](\(\*TagBox["3", Zeta, 
                              Rule[Editable, True]]\))\), 
                         InterpretTemplate[Function[BoxForm`e$, 
                           Zeta[BoxForm`e$]]]]\ 
                       \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^3\) + 
                     \(\[Pi]\^2\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]
                         \^2\)\/48 + 1\)\)], "Output", CellTags -> 
                "GammaEpsilon"]}, Open]], 
           Cell["For other arguments the expansion is calculated.", "Text", 
            CellTags -> "GammaEpsilon"], Cell[CellGroupData[{Cell[BoxData[
                \(GammaEpsilon[Epsilon]\)], "Input", CellTags -> 
                "GammaEpsilon"], Cell[BoxData[FormBox[RowBox[{
                   \(C$1789\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^6
                     \), "+", 
                   \(\(\((\(21\/4\ \[Pi]\^4\ 
                             \(\*TagBox["\[Psi]", PolyGamma]\^\((2)\)(1)\)\) 
                           + \(\*TagBox["\[Psi]", PolyGamma]\^\((6)\)(1)\) - 
                           \(84\ \[Pi]\^2\ 
                             \*TagBox[\(\[Zeta](
                                 \*TagBox["5", Zeta, Rule[Editable, True]])\
\), InterpretTemplate[Function[BoxForm`e$, 
                                 Zeta[BoxForm`e$]]]]\))\)\ 
                        \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^6\)\/
                      5040\), "+", 
                   \(1\/720\ \((\(61\ \[Pi]\^6\)\/168 + 
                         \(10\ \(\*TagBox["\[Psi]", PolyGamma]\^\((2)\)(1)\)
                            \^2\))\)\ \*TagBox["\[CurlyEpsilon]", 
                         TraditionalForm]\^5\), "+", 
                   \(1\/120\ \((\(5\/3\ \[Pi]\^2\ 
                           \(\*TagBox["\[Psi]", PolyGamma]\^\((2)\)(1)\)\) - 
                         \(24\ \*TagBox[\(
                              \[Zeta](\*TagBox["5", Zeta, 
                                 Rule[Editable, True]])\), 
                             InterpretTemplate[Function[BoxForm`e$, 
                               Zeta[BoxForm`e$]]]]\))\)\ 
                      \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^4\), "+", 
                   \(\(\[Pi]\^4\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]
                         \^3\)\/160\), "+", 
                   \(1\/6\ \(\*TagBox["\[Psi]", PolyGamma]\^\((2)\)(1)\)\ 
                      \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^2\), "+", 
                   \(\(\[Pi]\^2\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]
                       \)\/12\), "+", FractionBox["1", FormBox[
                     TagBox["\[CurlyEpsilon]", TraditionalForm], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "GammaEpsilon"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(GammaEpsilon[x]\)], "Input", 
               CellTags -> "GammaEpsilon"], Cell[BoxData[
                \(TraditionalForm\`\(\[CapitalGamma](x)\)\)], "Output", 
               CellTags -> "GammaEpsilon"]}, Open]]}, Open]], 
        Cell["GammaExpand", "ObjectName", CellTags -> "GammaExpand"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GammaExpand"], Cell["GammaExpand[exp] rewrites \
Gamma[n + m] in exp (where n has Head Integer).", "Text", 
            CellTags -> "GammaExpand"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["GammaEpsilon", 
                RuleDelayed[ButtonData, "GammaEpsilon"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GammaEpsilon"]], "."}], "Text", 
            CellTags -> "GammaExpand"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "GammaExpand"], Cell[CellGroupData[{Cell[BoxData[
                \(GammaExpand[\(Gamma[\(2\ +\ Epsilon\)]\)]\)], "Input", 
               CellTags -> "GammaExpand"], Cell[BoxData[
                \(TraditionalForm\`\(\((\*
                         TagBox["\[CurlyEpsilon]", TraditionalForm] + 1)\)\ 
                     \(\[CapitalGamma](\(
                        \*TagBox["\[CurlyEpsilon]", TraditionalForm] + 1\))\)
                \)\)], "Output", CellTags -> "GammaExpand"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(GammaExpand[\(Gamma[\(\(-3\) + Epsilon\)]\)]\)], "Input", 
               CellTags -> "GammaExpand"], Cell[BoxData[
                \(TraditionalForm\`\(\(\[CapitalGamma](
                       \(\*TagBox["\[CurlyEpsilon]", TraditionalForm] + 1\))\
\)\/\(\((\*TagBox["\[CurlyEpsilon]", TraditionalForm] - 3)\)
                       \ \((\*TagBox["\[CurlyEpsilon]", TraditionalForm] - 2)
                        \)\ \((\*TagBox["\[CurlyEpsilon]", TraditionalForm] -
                           1)\)\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]
                \)\)\)], "Output", CellTags -> "GammaExpand"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(GammaExpand[\(Gamma[\(1\ +\ Epsilon\)]\)]\)], "Input", 
               CellTags -> "GammaExpand"], Cell[BoxData[
                \(TraditionalForm\`\(\[CapitalGamma](
                     \(\*TagBox["\[CurlyEpsilon]", TraditionalForm] + 1\))\)\
\)], "Output", CellTags -> "GammaExpand"]}, Open]]}, Open]], 
        Cell["Gamma1", "ObjectName", CellTags -> "Gamma1"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Gamma1"], Cell["Gamma1[al,ga, be,de] is a special \
product of Gamma functions expanded up to order Epsilon^2.", "Text", 
            CellTags -> "Gamma1"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Gamma2", RuleDelayed[ButtonData, "Gamma2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Gamma2"]], 
              ", ", 
              ButtonBox["Gamma3", RuleDelayed[ButtonData, "Gamma3"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Gamma3"]], 
              "."}], "Text", CellTags -> "Gamma1"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["Gamma2", "ObjectName", 
         CellTags -> "Gamma2"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Gamma2"], 
           Cell["Gamma2[x,y] is a special product of Gamma functions expanded \
up to order Epsilon^3 when positive integer arguments are given.", "Text", 
            CellTags -> "Gamma2"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Gamma1", RuleDelayed[ButtonData, "Gamma1"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Gamma1"]], 
              ", ", 
              ButtonBox["Gamma3", RuleDelayed[ButtonData, "Gamma3"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Gamma3"]], 
              "."}], "Text", CellTags -> "Gamma2"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["Gamma3", "ObjectName", 
         CellTags -> "Gamma3"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Gamma3"], 
           Cell["Gamma3[al,be,ga,ep] is a special product of Gamma functions \
expanded up to order Epsilon^n when positive integer arguments are given (the \
order n is determined by the option EpsilonOrder).", "Text", 
            CellTags -> "Gamma3"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Gamma1", RuleDelayed[ButtonData, "Gamma1"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Gamma1"]], 
              ", ", 
              ButtonBox["Gamma2", RuleDelayed[ButtonData, "Gamma2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Gamma2"]], 
              "."}], "Text", CellTags -> "Gamma3"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["Gauge", "ObjectName", 
         CellTags -> "Gauge"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Gauge"], 
           Cell["Gauge is an option for GluonProgagator. If set to 1 the 't \
Hooft Feynman gauge is used.", "Text", CellTags -> "Gauge"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["$Gauge", RuleDelayed[ButtonData, "$Gauge"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "$Gauge"]], 
              ", ", 
              ButtonBox["GluonProgagator", 
                RuleDelayed[ButtonData, "GluonProgagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonProgagator"]], "."}], "Text", 
            CellTags -> "Gauge"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["GaugeField", "ObjectName", CellTags -> "GaugeField"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GaugeField"], Cell["GaugeField is just a name. No \
functional properties are associated with it. GaugeField is used as default \
setting for the option QuantumField of FieldStrength.", "Text", 
            CellTags -> "GaugeField"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FieldStrength", 
                RuleDelayed[ButtonData, "FieldStrength"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FieldStrength"]], ", ", 
              ButtonBox["QuantumField", 
                RuleDelayed[ButtonData, "QuantumField"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "QuantumField"]], "."}], "Text", 
            CellTags -> "GaugeField"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "GaugeField"], Cell[CellGroupData[
             {Cell[BoxData["GaugeField"], "Input", CellTags -> "GaugeField"], 
              Cell[BoxData[\(TraditionalForm\`A\)], "Output", CellTags -> 
                "GaugeField"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(QuantumField[\(GaugeField, \(LorentzIndex[\[Mu]]\), 
                     \(SUNIndex[a]\)\)]\)], "Input", CellTags -> 
                "GaugeField"], Cell[BoxData[FormBox[SubsuperscriptBox[
                  FormBox["A", "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                    "TraditionalForm"], "TraditionalForm"], FormBox[
                   FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                 TraditionalForm]], "Output", CellTags -> "GaugeField"]}, 
             Open]]}, Open]], Cell["GaugeXi", "ObjectName", 
         CellTags -> "GaugeXi"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "GaugeXi"], 
           Cell["GaugeXi is a head for gauge parameters.", "Text", 
            CellTags -> "GaugeXi"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Gauge", RuleDelayed[ButtonData, "Gauge"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Gauge"]], 
              ", ", 
              ButtonBox["GaugeField", RuleDelayed[ButtonData, "GaugeField"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GaugeField"]], "."}], "Text", 
            CellTags -> "GaugeXi"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["GA5", "ObjectName", CellTags -> "GA5"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GA5"], Cell[
            "GA5 is equivalent to DiracGamma[5] and denotes gamma5.", "Text", 
            CellTags -> "GA5"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracGamma", RuleDelayed[ButtonData, "DiracGamma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGamma"]], ", ", 
              ButtonBox["GA", RuleDelayed[ButtonData, "GA"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GA"]], 
              ", ", 
              ButtonBox["GS", RuleDelayed[ButtonData, "GS"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GS"]], 
              "."}], "Text", CellTags -> "GA5"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "GA5"], Cell[CellGroupData[{Cell[BoxData["GA5"], 
               "Input", CellTags -> "GA5"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5\)\)], "Output", CellTags -> 
                "GA5"]}, Open]], Cell[CellGroupData[{Cell[BoxData[\(%//Tr\)], 
               "Input", CellTags -> "GA5"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> "GA5"]}, 
             Open]]}, Open]], Cell["GGV", "ObjectName", CellTags -> "GGV"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GGV"], Cell[
            "GGV is equivalent to GluonGhostVertex.", "Text", 
            CellTags -> "GGV"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["GluonGhostVertex", 
                RuleDelayed[ButtonData, "GluonGhostVertex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonGhostVertex"]], "."}], "Text", 
            CellTags -> "GGV"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["GhostPropagator", "ObjectName", CellTags -> "GhostPropagator"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GhostPropagator"], Cell[TextData[{"GhostPropagator[p\
, a, b] gives the ghost propagator where \"a\" and \"b\" are the color \
indices. GhostPropagator[p] omits the ", Cell[BoxData[
                \(TraditionalForm\`\(\[Delta]\_\(a\[NoBreak]b\) .\)\)]]}], 
            "Text", CellTags -> "GhostPropagator"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["GHP", RuleDelayed[ButtonData, "GHP"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GHP"]], 
              ", ", 
              ButtonBox["GluonPropagator", 
                RuleDelayed[ButtonData, "GluonPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonPropagator"]], ", ", 
              ButtonBox["GluonGhostVertex", 
                RuleDelayed[ButtonData, "GluonGhostVertex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonGhostVertex"]], "."}], "Text", 
            CellTags -> "GhostPropagator"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[GhostPropagator]\)], "Input"], Cell[BoxData[
                \(TraditionalForm\`\({Explicit \[Rule] False}\)\)], 
               "Output"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "GhostPropagator"], Cell[CellGroupData[{Cell[BoxData[
                \(GhostPropagator[\(p, a, b\)]\)], "Input", CellTags -> 
                "GhostPropagator"], Cell[BoxData[
                \(TraditionalForm\`\(\[CapitalPi]\_\(ab\)(p)\)\)], "Output", 
               CellTags -> "GhostPropagator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(GhostPropagator[\(p, a, b, \(Explicit \[Rule] True\)\)]\)], 
               "Input", CellTags -> "GhostPropagator"], Cell[BoxData[
                FormBox[FractionBox[RowBox[{"\[ImaginaryI]", " ", 
                    SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["b", "TraditionalForm"], 
                        "TraditionalForm"]}]]}], \(p\^2\)], 
                 TraditionalForm]], "Output", CellTags -> 
                "GhostPropagator"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(GhostPropagator[p]\)], "Input", CellTags -> 
                "GhostPropagator"], Cell[BoxData[
                \(TraditionalForm\`\(\[CapitalPi]\_u(p)\)\)], "Output", 
               CellTags -> "GhostPropagator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(GhostPropagator[\(p, 1, 2\)]\)//Explicit\)], "Input", 
               CellTags -> "GhostPropagator"], Cell[BoxData[FormBox[
                 FractionBox[RowBox[{"\[ImaginaryI]", " ", SubscriptBox[
                     "\[Delta]", RowBox[{FormBox[FormBox["ci1", 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["ci2", "TraditionalForm"], 
                        "TraditionalForm"]}]]}], \(p\^2\)], 
                 TraditionalForm]], "Output", CellTags -> 
                "GhostPropagator"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(GhostPropagator[\(\(-k\), 3, 4\)]\)//Explicit\)//\ 
                     FCE\)//StandardForm\)], "Input", CellTags -> 
                "GhostPropagator"], Cell[BoxData[
                \(\[ImaginaryI]\ \(FAD[k]\)\ \(SD[\(ci3, ci4\)]\)\)], 
               "Output", CellTags -> "GhostPropagator"]}, Open]]}, Open]], 
        Cell["GHP", "ObjectName", CellTags -> "GHP"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GHP"], Cell[TextData[{"GHP[p, a, b] gives the ghost \
propagator where \"a\" and \"b\" are the color indices. GHP[p] omits the ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\[Delta]\_\(a\[NoBreak]b\) .\)\)]]}], 
            "Text", CellTags -> "GHP"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["GhostPropagator", 
                RuleDelayed[ButtonData, "GhostPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GhostPropagator"]], ", ", 
              ButtonBox["GluonPropagator", 
                RuleDelayed[ButtonData, "GluonPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonPropagator"]], ", ", 
              ButtonBox["GluonGhostVertex", 
                RuleDelayed[ButtonData, "GluonGhostVertex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonGhostVertex"]], "."}], "Text", 
            CellTags -> "GHP"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "GHP"], 
           Cell[CellGroupData[{Cell[BoxData[\(GHP[\(p, a, b\)]\)], "Input", 
               CellTags -> "GHP"], Cell[BoxData[
                \(TraditionalForm\`\(\[CapitalPi]\_\(ab\)(p)\)\)], "Output", 
               CellTags -> "GHP"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GHP[p]\)//Explicit\)], "Input", CellTags -> "GHP"], 
              Cell[BoxData[\(TraditionalForm\`\(\[ImaginaryI]\/p\^2\)\)], 
               "Output", CellTags -> "GHP"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(GHP[\(p, 1, 2\)]\)], "Input", 
               CellTags -> "GHP"], Cell[BoxData[
                \(TraditionalForm\`\(\[CapitalPi]\_\(ci1ci2\)(p)\)\)], 
               "Output", CellTags -> "GHP"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(FCE[\(\(GHP[\(\(-k\), 3, 4\)]\)//Explicit\)]
                    \)]\)], "Input", CellTags -> "GHP"], Cell[BoxData[
                \(\[ImaginaryI]\ \(FAD[k]\)\ \(SD[\(ci3, ci4\)]\)\)], 
               "Output", CellTags -> "GHP"]}, Open]]}, Open]], 
        Cell["GluonField", "ObjectName", CellTags -> "GluonField"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GluonField"], 
           Cell["GluonField is a name of a gauge field.", "Text", 
            CellTags -> "GluonField"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["GaugeField", RuleDelayed[ButtonData, "GaugeField"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GaugeField"]], "."}], "Text", 
            CellTags -> "GluonField"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "GluonField"], Cell[CellGroupData[
             {Cell[BoxData["GluonField"], "Input", CellTags -> "GluonField"], 
              Cell[BoxData[\(TraditionalForm\`A\)], "Output", CellTags -> 
                "GluonField"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(QuantumField[\(GluonField, \(LorentzIndex[\[Mu]]\), 
                     \(SUNIndex[a]\)\)]\)], "Input", CellTags -> 
                "GluonField"], Cell[BoxData[FormBox[SubsuperscriptBox[
                  FormBox["A", "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                    "TraditionalForm"], "TraditionalForm"], FormBox[
                   FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                 TraditionalForm]], "Output", CellTags -> "GluonField"]}, 
             Open]]}, Open]], Cell["GluonGhostVertex", "ObjectName", 
         CellTags -> "GluonGhostVertex"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "GluonGhostVertex"], Cell["GluonGhostVertex[{p,mu,a}, {q,nu,b}, \
{k,rho,c}] or GluonGhostVertex[ p,mu,a , q,nu,b , k,rho,c ] yields the \
Gluon-Ghost vertex. The first argument represents the gluon and the third \
argument the outgoing ghost field (but incoming four-momentum). The dimension \
and the name of the coupling constant are determined by the options Dimension \
and CouplingConstant.", "Text", CellTags -> "GluonGhostVertex"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["GluonPropagator", 
                RuleDelayed[ButtonData, "GluonPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonPropagator"]], ", ", 
              ButtonBox["GluonSelfEnergy", 
                RuleDelayed[ButtonData, "GluonSelfEnergy"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonSelfEnergy"]], ", ", 
              ButtonBox["GhostPropagator", 
                RuleDelayed[ButtonData, "GhostPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GhostPropagator"]], ", ", 
              ButtonBox["GluonVertex", RuleDelayed[ButtonData, 
                 "GluonVertex"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonVertex"]], "."}], "Text", 
            CellTags -> "GluonGhostVertex"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[GluonGhostVertex]\)], "Input", CellTags -> 
                "GluonGhostVertex"], Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Explicit \[Rule] False\)}\)\
\)], "Output", CellTags -> "GluonGhostVertex"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "GluonGhostVertex"], Cell[CellGroupData[{Cell[BoxData[
                \(GluonGhostVertex[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\), 
                     \({k, \[Rho], c}\)\)]\)], "Input", CellTags -> 
                "GluonGhostVertex"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(\(\[CapitalLambda]\&~\)\^\[Mu]\), "(", FormBox[FormBox[
                       TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                      "TraditionalForm"], ")"}], " ", SubscriptBox["f", 
                    RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "GluonGhostVertex"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Explicit[%]\)], "Input"], 
              Cell[BoxData[FormBox[RowBox[{\(-g\_s\), " ", SuperscriptBox[
                    FormBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], 
               "Output"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(GluonGhostVertex[\(k, \[Mu]\)]\)], "Input"], 
              Cell[BoxData[FormBox[RowBox[{\(\(\[CapitalLambda]\&~\)\^\[Mu]\)
                   , "(", FormBox[FormBox[
                     TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                       Function[StyleForm[Slot[1], 
                         Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(Explicit[%]\)], 
               "Input"], Cell[BoxData[FormBox[RowBox[{\(-g\_s\), " ", 
                   SuperscriptBox[FormBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(%//Explicit\)//StandardForm\)]
                , "Input", CellTags -> "GluonGhostVertex"], Cell[BoxData[
                \(\(-Gstrong\)\ \(Pair[\(
                      \(LorentzIndex[\(\[Mu], D\)]\), \(Momentum[\(k, D\)]\)
                      \)]\)\)], "Output", CellTags -> "GluonGhostVertex"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(GluonGhostVertex[\(p, 1, q, 2, k, 3\)]\)], "Input", 
               CellTags -> "GluonGhostVertex"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{\(\(\[CapitalLambda]\&~\)\^li1\), "(", 
                     FormBox[FormBox[
                       TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                      "TraditionalForm"], ")"}], " ", SubscriptBox["f", 
                    RowBox[{FormBox[FormBox["ci1", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["ci2", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["ci3", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "GluonGhostVertex"]}, Open]]}, Open]], 
        Cell["GluonPropagator", "ObjectName", CellTags -> "GluonPropagator"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GluonPropagator"], Cell[TextData[{"GluonPropagator[p\
, {mu, a}, {nu, b}] or GluonPropagator[p, mu, a , nu, b ] yields the gluon \
propagator. GluonPropagator[p, {mu}, {nu}] or GluonPropagator[p, mu, nu] \
omits the SUNDelta. The gauge and the dimension is determined by the option \
Gauge and Dimension. The following settings of Gauge are possible: 1 for the \
Feynman gauge; ", Cell[BoxData[\(TraditionalForm\`\[Alpha]\)]], 
              " for the general covariant gauge; {Momentum[n] ,1} for the \
axial gauge."}], "Text", CellTags -> "GluonPropagator"], 
           Cell["GP can be used as an abbreviation of GluonPropagator.", 
            "Text", CellTags -> "GluonPropagator"], 
           Cell[CellGroupData[{Cell[BoxData["GP"], "Input", CellTags -> 
                "GluonPropagator"], Cell[BoxData[
                \(TraditionalForm\`GluonPropagator\)], "Output", CellTags -> 
                "GluonPropagator"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Options[GluonPropagator]\)], "Input", CellTags -> 
                "GluonPropagator"], Cell[BoxData[
                \(TraditionalForm\`\({\(CounterTerm \[Rule] False\), 
                      \(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Explicit \[Rule] False\), 
                      \(Gauge \[Rule] 1\), \(\[CapitalOmega] \[Rule] False\)}
                \)\)], "Output", CellTags -> "GluonPropagator"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["GluonSelfEnergy", 
                RuleDelayed[ButtonData, "GluonSelfEnergy"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonSelfEnergy"]], ", ", 
              ButtonBox["GluonVertex", RuleDelayed[ButtonData, 
                 "GluonVertex"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonVertex"]], ", ", 
              ButtonBox["GhostPropagator", 
                RuleDelayed[ButtonData, "GhostPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GhostPropagator"]], ", ", 
              ButtonBox["GluonGhostVertex", 
                RuleDelayed[ButtonData, "GluonGhostVertex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonGhostVertex"]], "."}], "Text", 
            CellTags -> "GluonPropagator"]}, Open]], 
        Cell[CellGroupData[{Cell[BoxData["Examples"], "Subsubsection", 
            CellTags -> "GluonPropagator"], Cell[CellGroupData[{Cell[BoxData[
                \(GluonPropagator[\(p, \[Mu], a, \[Nu], b\)]\)], "Input", 
               CellTags -> "GluonPropagator"], Cell[BoxData[
                \(TraditionalForm\`\(\[CapitalPi]\_\(ab\)\%\(\[Mu]\[Nu]\)(p)
                    \)\)], "Output", CellTags -> "GluonPropagator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonPropagator[\(p, \[Mu], a, \[Nu], b\)]\)//Explicit\)]\
, "Input"], Cell[BoxData[FormBox[RowBox[{"-", FractionBox[RowBox[
                     {"\[ImaginaryI]", " ", \(g\^\(\[Mu]\[Nu]\)\), " ", 
                      SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], \(p\^2\)]}], 
                 TraditionalForm]], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonPropagator[\(p, \[Mu], a, \[Nu], b, 
                       \(Gauge \[Rule] \[Alpha]\)\)]\)//Explicit\)], "Input", 
               CellTags -> "GluonPropagator"], Cell[BoxData[FormBox[
                 FractionBox[RowBox[{"\[ImaginaryI]", " ", RowBox[{"(", 
                      RowBox[{FractionBox[RowBox[{\((1 - \[Alpha])\), " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], \(p\^2\)]
                         , "-", \(g\^\(\[Mu]\[Nu]\)\)}], ")"}], " ", 
                    SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["b", "TraditionalForm"], 
                        "TraditionalForm"]}]]}], \(p\^2\)], 
                 TraditionalForm]], "Output", CellTags -> 
                "GluonPropagator"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonPropagator[\(p, \[Mu], a, \[Nu], b, 
                       \(Gauge \[Rule] \({\(Momentum[n]\), 1}\)\)\)]\)//
                   Explicit\)], "Input", CellTags -> "GluonPropagator"], 
              Cell[BoxData[FormBox[FractionBox[RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"(", RowBox[{\(-g\^\(\[Mu]\[Nu]\)\), "-", 
                        FractionBox[RowBox[{RowBox[{SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "n", "TraditionalForm"], "2"]}], "-", RowBox[
                          {SuperscriptBox[FormBox["n", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "n", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"]}]}], SuperscriptBox[FormBox[RowBox[{FormBox[
                          "n", "TraditionalForm"], "\[CenterDot]", FormBox[
                          "p", "TraditionalForm"]}], "TraditionalForm"], 
                          "2"]], "+", FractionBox[RowBox[{RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "n", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "+", 
                          RowBox[{SuperscriptBox[FormBox["n", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], RowBox[{FormBox["n", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]]}], ")"}], " ", SubscriptBox[
                     "\[Delta]", RowBox[{FormBox[FormBox["a", 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["b", "TraditionalForm"], 
                        "TraditionalForm"]}]]}], \(p\^2\)], 
                 TraditionalForm]], "Output", CellTags -> 
                "GluonPropagator"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonPropagator[\(p, \[Mu], \[Nu]\)]\)//Explicit\)], 
               "Input", CellTags -> "GluonPropagator"], Cell[BoxData[
                \(TraditionalForm\`\(-\(\(\[ImaginaryI]\ g\^\(\[Mu]\[Nu]\)\)
                       \/p\^2\)\)\)], "Output", CellTags -> 
                "GluonPropagator"]}, Open]], Cell["This is a convenient way \
to enter amplitudes by hand (GP is an abbreviation GluonPropagator).", 
            "Text", CellTags -> "GluonPropagator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Explicit[\(\(GP[\(p, 1, 2\)]\), \(Gauge \[Rule] \[Xi]\)\)]
                  \)], "Input", CellTags -> "GluonPropagator"], 
              Cell[BoxData[FormBox[FractionBox[RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"(", RowBox[{FractionBox[RowBox[{\((1 - \[Xi])\), 
                          " ", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["li1", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["li2", "TraditionalForm"], 
                          "TraditionalForm"]]}], \(p\^2\)], "-", 
                        \(g\^\(li1li2\)\)}], ")"}], " ", SubscriptBox[
                     "\[Delta]", RowBox[{FormBox[FormBox["ci1", 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["ci2", "TraditionalForm"], 
                        "TraditionalForm"]}]]}], \(p\^2\)], 
                 TraditionalForm]], "Output", CellTags -> 
                "GluonPropagator"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(GP[\(\(-k\), 3, 4\)]\)//Explicit\)//FCE\)//
                   StandardForm\)], "Input", CellTags -> "GluonPropagator"], 
              Cell[BoxData[
                \(\(-\[ImaginaryI]\)\ \(FAD[k]\)\ \(MTD[\(li3, li4\)]\)\ 
                   \(SD[\(ci3, ci4\)]\)\)], "Output", CellTags -> 
                "GluonPropagator"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonPropagator[\(p, \[Mu], a, \[Nu], b, 
                       \(CounterTerm \[Rule]\ 1\)\)]\)//Explicit\)], "Input", 
               CellTags -> "GluonPropagator"], Cell[BoxData[FormBox[
                 RowBox[{"-", FractionBox[RowBox[{"\[ImaginaryI]", " ", 
                      \(C\_A\), " ", \(g\_s\%2\), " ", \(S\_n\), " ", 
                      RowBox[{"(", RowBox[{FractionBox[RowBox[{"11", " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "3"], 
                          "-", RowBox[{\(19\/6\), " ", \(g\^\(\[Mu]\[Nu]\)\), 
                          " ", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"]}]}], ")"}], " ", 
                      SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], 
                    TagBox["\[CurlyEpsilon]", TraditionalForm]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "GluonPropagator"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonPropagator[\(p, \[Mu], a, \[Nu], b, 
                       \(CounterTerm \[Rule]\ 2\)\)]\)//Explicit\)], "Input", 
               CellTags -> "GluonPropagator"], Cell[BoxData[FormBox[
                 RowBox[{"-", FractionBox[RowBox[{"\[ImaginaryI]", " ", 
                      \(C\_A\), " ", \(g\_s\%2\), " ", \(S\_n\), " ", 
                      RowBox[{"(", RowBox[{RowBox[{\(-\(1\/3\)\), " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                          RowBox[{\(1\/6\), " ", \(g\^\(\[Mu]\[Nu]\)\), " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"]}]}], ")"}], " ", SubscriptBox["\[Delta]", 
                       RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], 
                    TagBox["\[CurlyEpsilon]", TraditionalForm]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "GluonPropagator"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonPropagator[\(p, \[Mu], a, \[Nu], b, 
                       \(CounterTerm \[Rule]\ 3\)\)]\)//Explicit\)], "Input", 
               CellTags -> "GluonPropagator"], Cell[BoxData[FormBox[
                 RowBox[{"-", FractionBox[RowBox[{"2", " ", "\[ImaginaryI]", 
                      " ", \(g\_s\%2\), " ", \(S\_n\), " ", \(T\_f\), " ", 
                      RowBox[{"(", RowBox[{RowBox[{\(4\/3\), " ", 
                          \(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"]}], "-", FractionBox[
                          RowBox[{"4", " ", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "3"]}], ")"}], " ", 
                      SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], 
                    TagBox["\[CurlyEpsilon]", TraditionalForm]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "GluonPropagator"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonPropagator[\(p, \[Mu], a, \[Nu], b, 
                       \(CounterTerm \[Rule]\ 4\)\)]\)//Explicit\)], "Input", 
               CellTags -> "GluonPropagator"], Cell[BoxData[FormBox[
                 RowBox[{"-", FractionBox[RowBox[{"\[ImaginaryI]", " ", 
                      \(C\_A\), " ", \(g\_s\%2\), " ", \(S\_n\), " ", 
                      RowBox[{"(", RowBox[{FractionBox[RowBox[{"10", " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "3"], 
                          "-", RowBox[{\(10\/3\), " ", \(g\^\(\[Mu]\[Nu]\)\), 
                          " ", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"]}]}], ")"}], " ", 
                      SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], 
                    TagBox["\[CurlyEpsilon]", TraditionalForm]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "GluonPropagator"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonPropagator[\(p, \[Mu], a, \[Nu], b, 
                       \(CounterTerm \[Rule]\ 5\)\)]\)//Explicit\)], "Input", 
               CellTags -> "GluonPropagator"], Cell[BoxData[FormBox[
                 RowBox[{FractionBox[RowBox[{"\[ImaginaryI]", " ", \(C\_A\), 
                      " ", \(S\_n\), " ", RowBox[{"(", RowBox[{FractionBox[
                          RowBox[{"10", " ", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "3"], "-", RowBox[{\(10\/3\)
                          , " ", \(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"]}]}], ")"}], 
                      " ", SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                         FormBox[FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\_s\%2\)}], 
                    TagBox["\[CurlyEpsilon]", TraditionalForm]], "+", 
                   FractionBox[RowBox[{"\[ImaginaryI]", " ", \(S\_n\), " ", 
                      \(T\_f\), " ", RowBox[{"(", RowBox[{RowBox[{\(4\/3\), 
                          " ", \(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"]}], "-", 
                          FractionBox[RowBox[{"4", " ", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                          " ", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "3"]}], 
                        ")"}], " ", SubscriptBox["\[Delta]", RowBox[
                        {FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                      \(g\_s\%2\)}], 
                    TagBox["\[CurlyEpsilon]", TraditionalForm]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "GluonPropagator"]}, Open]]}, Open]], Cell["GluonSelfEnergy", 
         "ObjectName", CellTags -> "GluonSelfEnergy"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GluonSelfEnergy"], Cell["GluonSelfEnergy[{mu, a}, \
{nu,b}] yields the 1-loop Gluon selfenergy.", "Text", CellTags -> 
             "GluonSelfEnergy"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[GluonSelfEnergy]\)], "Input", CellTags -> 
                "GluonSelfEnergy"], Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] D\), 
                      \(CouplingConstant \[Rule] g\_s\), 
                      \(FinalSubstitutions \[Rule] 
                        \({\(\(log(\(\[Mu]\^2\ _\))\) \[RuleDelayed] 0\), 
                           \(\*TagBox["\[DoubledGamma]", 
                               Function[List[], EulerGamma]] \[RuleDelayed] 
                             \(log(\(4\ \[Pi]\))\)\)}\)\), 
                      \(Gauge \[Rule] 1\), \(Momentum \[Rule] p\)}\)\)], 
               "Output", CellTags -> "GluonSelfEnergy"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["GluonPropagator", 
                RuleDelayed[ButtonData, "GluonPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonPropagator"]], ", ", 
              ButtonBox["GluonVertex", RuleDelayed[ButtonData, 
                 "GluonVertex"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonVertex"]], ", ", 
              ButtonBox["GhostPropagator", 
                RuleDelayed[ButtonData, "GhostPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GhostPropagator"]], ", ", 
              ButtonBox["GluonGhostVertex", 
                RuleDelayed[ButtonData, "GluonGhostVertex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonGhostVertex"]], "."}], "Text", 
            CellTags -> "GluonSelfEnergy"]}, Open]], 
        Cell[CellGroupData[{Cell[BoxData["Examples"], "Subsubsection", 
            CellTags -> "GluonSelfEnergy"], Cell[CellGroupData[{Cell[BoxData[
                \(GluonSelfEnergy[\(\({\[Mu], a}\), \({\[Nu], b}\)\)]\)], 
               "Input", CellTags -> "GluonSelfEnergy"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{\(1\/2\), " ", "\[ImaginaryI]", " ", 
                     \(C\_A\), " ", 
                     \((20\/\(3\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]
                           \) - 62\/9)\), " ", RowBox[{"(", RowBox[
                        {RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{
                          \(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"]}]}], ")"}], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", \(g\_s\%2\)}], "+", 
                   RowBox[{"\[ImaginaryI]", " ", 
                     \((20\/9 - 8\/\(3\ \*TagBox["\[CurlyEpsilon]", 
                              TraditionalForm]\))\), " ", \(T\_f\), " ", 
                     RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{
                          \(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"]}]}], ")"}], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", \(g\_s\%2\)}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "GluonSelfEnergy"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(GluonSelfEnergy[\(\({\[Mu], a}\), \({\[Nu], b}\), 
                     \(Gauge \[Rule] \[Xi]\)\)]\)], "Input", CellTags -> 
                "GluonSelfEnergy"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"\[ImaginaryI]", " ", 
                     \((20\/9 - 8\/\(3\ \*TagBox["\[CurlyEpsilon]", 
                              TraditionalForm]\))\), " ", \(T\_f\), " ", 
                     RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{
                          \(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"]}]}], ")"}], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", \(g\_s\%2\)}], "+", 
                   RowBox[{\(1\/2\), " ", "\[ImaginaryI]", " ", \(C\_A\), 
                     " ", 
                     \((\(\(-\(1\/2\)\)\ \((1 - \[Xi])\)\^2\) + 
                         \(2\ \((1 - \[Xi])\)\) + 
                         \(2\ \((13\/3 - \[Xi])\)\)\/
                          \*TagBox["\[CurlyEpsilon]", TraditionalForm] - 
                         62\/9)\), " ", RowBox[{"(", RowBox[{RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{\(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"]}]}], ")"}], 
                     " ", SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", \(g\_s\%2\)}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "GluonSelfEnergy"]}, Open]]}, Open]], Cell["GluonVertex", 
         "ObjectName", CellTags -> "GluonVertex"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GluonVertex"], 
           Cell["Note: All momenta are flowing into the vertex.", "Text", 
            CellTags -> "GluonVertex"], Cell["GluonVertex[{p,mu,a}, {q,nu,b}, \
{k,la,c}] or GluonVertex[p,mu,a , q,nu,b , k,la,c ] yields the 3-gluon \
vertex. GluonVertex[{p,mu}, {q,nu}, {k,la}] yields the 3-gluon vertex without \
color structure and the coupling constant. GluonVertex[{p,mu,a}, {q,nu,b}, \
{k,la,c}, {s,si,d}] or GluonVertex[{mu,a}, {nu,b}, {la,c}, {si,d}] or \
GluonVertex[p,mu,a , q,nu,b , k,la,c , s,si,d] or GluonVertex[ mu,a , nu,b , \
la,c , si,d ] yields the 4-gluon vertex. The dimension and the name of the \
coupling constant are determined by the options Dimension and \
CouplingConstant.", "Text", CellTags -> "GluonVertex"], 
           Cell["GV can be used as an abbreviation of GluonVertex.", "Text", 
            CellTags -> "GluonVertex"], Cell[CellGroupData[
             {Cell[BoxData["GV"], "Input", CellTags -> "GluonVertex"], 
              Cell[BoxData[\(TraditionalForm\`GluonVertex\)], "Output", 
               CellTags -> "GluonVertex"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[GluonVertex]\)], 
               "Input", CellTags -> "GluonVertex"], Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Explicit \[Rule] False\), 
                      \(\[CapitalOmega] \[Rule] False\)}\)\)], "Output", 
               CellTags -> "GluonVertex"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["GluonGhostVertex", 
                RuleDelayed[ButtonData, "GluonGhostVertex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonGhostVertex"]], ", ", 
              ButtonBox["GluonPropagator", 
                RuleDelayed[ButtonData, "GluonPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonPropagator"]], "."}], "Text", 
            CellTags -> "GluonVertex"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "GluonVertex"], Cell[CellGroupData[{Cell[BoxData[
                \(GluonVertex[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\), 
                     \({r, \[Rho], c}\)\)]\)], "Input", CellTags -> 
                "GluonVertex"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{SuperscriptBox["V", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]}]], "(", 
                     RowBox[{FormBox["p", "TraditionalForm"], \(,\ \), 
                       FormBox["q", "TraditionalForm"], \(,\ \), FormBox["r", 
                        "TraditionalForm"]}], ")"}], " ", SubscriptBox["f", 
                    RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "GluonVertex"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonVertex[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\), 
                       \({r, \[Rho], c}\)\)]\)//Explicit\)], "Input", 
               CellTags -> "GluonVertex"], Cell[BoxData[FormBox[RowBox[{
                   \(g\_s\), " ", RowBox[{"(", RowBox[{RowBox[{RowBox[
                          {"(", RowBox[{SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], "-", 
                          SuperscriptBox[FormBox["r", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}], " ", 
                         \(g\^\(\[Nu]\[Rho]\)\)}], "+", RowBox[{
                         \(g\^\(\[Mu]\[Rho]\)\), " ", RowBox[{"(", RowBox[
                          {SuperscriptBox[FormBox["r", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], "-", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], ")"}]}], 
                       "+", RowBox[{\(g\^\(\[Mu]\[Nu]\)\), " ", RowBox[
                          {"(", RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], "-", 
                          SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}]}], ")"}], " ", 
                   SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "GluonVertex"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(GluonVertex[\(\({p, \[Mu]}\), \({q, \[Nu]}\), 
                     \({r, \[Rho]}\)\)]\)], "Input", CellTags -> 
                "GluonVertex"], Cell[BoxData[
                \(TraditionalForm\`\(\(V\^\(\[Mu]\[Nu]\[Rho]\)\)(
                     \(p\(,\ \)q\(,\ \)r\))\)\)], "Output", CellTags -> 
                "GluonVertex"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonVertex[\(\({p, \[Mu]}\), \({q, \[Nu]}\), 
                       \({r, \[Rho]}\)\)]\)//Explicit\)], "Input", 
               CellTags -> "GluonVertex"], Cell[BoxData[FormBox[RowBox[{
                   \(g\_s\), " ", RowBox[{"(", RowBox[{RowBox[{RowBox[
                          {"(", RowBox[{SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], "-", 
                          SuperscriptBox[FormBox["r", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}], " ", 
                         \(g\^\(\[Nu]\[Rho]\)\)}], "+", RowBox[{
                         \(g\^\(\[Mu]\[Rho]\)\), " ", RowBox[{"(", RowBox[
                          {SuperscriptBox[FormBox["r", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], "-", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], ")"}]}], 
                       "+", RowBox[{\(g\^\(\[Mu]\[Nu]\)\), " ", RowBox[
                          {"(", RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], "-", 
                          SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], ")"}]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "GluonVertex"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(GluonVertex[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\), 
                     \({r, \[Rho], c}\), \({s, \[Sigma], d}\)\)]\)], "Input", 
               CellTags -> "GluonVertex"], Cell[BoxData[
                \(TraditionalForm\`\(V\_\(abcd\)\%
                      \(\[Mu]\[Nu]\[Rho]\[Sigma]\)(
                     \(p\(,\ \)q\(,\ \)r\(,\ \)s\))\)\)], "Output", 
               CellTags -> "GluonVertex"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonVertex[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\), 
                       \({r, \[Rho], c}\), \({s, \[Sigma], d}\)\)]\)//
                   Explicit\)], "Input"], Cell[BoxData[FormBox[RowBox[{
                   \(-\[ImaginaryI]\), " ", \(g\_s\%2\), " ", RowBox[
                    {"(", RowBox[{RowBox[{
                         \((\(g\^\(\[Mu]\[Nu]\)\ g\^\(\[Rho]\[Sigma]\)\) - 
                             \(g\^\(\[Mu]\[Rho]\)\ g\^\(\[Nu]\[Sigma]\)\))\), 
                         " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u9", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u9", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                       RowBox[{
                         \((\(g\^\(\[Mu]\[Nu]\)\ g\^\(\[Rho]\[Sigma]\)\) - 
                             \(g\^\(\[Mu]\[Sigma]\)\ g\^\(\[Nu]\[Rho]\)\))\), 
                         " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u9", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u9", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                       RowBox[{
                         \((\(g\^\(\[Mu]\[Rho]\)\ g\^\(\[Nu]\[Sigma]\)\) - 
                             \(g\^\(\[Mu]\[Sigma]\)\ g\^\(\[Nu]\[Rho]\)\))\), 
                         " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u9", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u9", 
                          "TraditionalForm"], "TraditionalForm"]}]]}]}], 
                     ")"}]}], TraditionalForm]], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(GluonVertex[\(\({\[Mu], a}\), \({\[Nu], b}\), 
                     \({\[Rho], c}\), \({\[Sigma], d}\)\)]\)], "Input", 
               CellTags -> "GluonVertex"], Cell[BoxData[
                \(TraditionalForm\`\(W\^\(abcd\)\)\)], "Output", CellTags -> 
                "GluonVertex"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GluonVertex[\(\[Mu], a, \[Nu], b, \[Rho], c, \[Sigma], d
                      \)]\)//Explicit\)], "Input", CellTags -> 
                "GluonVertex"], Cell[BoxData[FormBox[RowBox[{
                   \(-\[ImaginaryI]\), " ", \(g\_s\%2\), " ", RowBox[
                    {"(", RowBox[{RowBox[{
                         \((\(g\^\(\[Mu]\[Nu]\)\ g\^\(\[Rho]\[Sigma]\)\) - 
                             \(g\^\(\[Mu]\[Rho]\)\ g\^\(\[Nu]\[Sigma]\)\))\), 
                         " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u10", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u10", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                       RowBox[{
                         \((\(g\^\(\[Mu]\[Nu]\)\ g\^\(\[Rho]\[Sigma]\)\) - 
                             \(g\^\(\[Mu]\[Sigma]\)\ g\^\(\[Nu]\[Rho]\)\))\), 
                         " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u10", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u10", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                       RowBox[{
                         \((\(g\^\(\[Mu]\[Rho]\)\ g\^\(\[Nu]\[Sigma]\)\) - 
                             \(g\^\(\[Mu]\[Sigma]\)\ g\^\(\[Nu]\[Rho]\)\))\), 
                         " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u10", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u10", 
                          "TraditionalForm"], "TraditionalForm"]}]]}]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "GluonVertex"]}, Open]], Cell["A very convenient way to enter \
diagrams by hand is to label each line hitting a vertex by a number and put \
this number after the inflowing momentum.", "Text", CellTags -> 
             "GluonVertex"], Cell[CellGroupData[{Cell[BoxData[
                \(GV[\(p, 1, q, 2, r, 3\)]\)], "Input", CellTags -> 
                "GluonVertex"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{SuperscriptBox["V", RowBox[{FormBox[FormBox["li1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["li2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["li3", 
                          "TraditionalForm"], "TraditionalForm"]}]], "(", 
                     RowBox[{FormBox["p", "TraditionalForm"], \(,\ \), 
                       FormBox["q", "TraditionalForm"], \(,\ \), FormBox["r", 
                        "TraditionalForm"]}], ")"}], " ", SubscriptBox["f", 
                    RowBox[{FormBox[FormBox["ci1", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["ci2", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["ci3", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "GluonVertex"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(GV[\(p, 1, q, 2, r, 3, s, 4\)]\)//Explicit\)], "Input", 
               CellTags -> "GluonVertex"], Cell[BoxData[FormBox[RowBox[{
                   \(-\[ImaginaryI]\), " ", \(g\_s\%2\), " ", RowBox[
                    {"(", RowBox[{RowBox[{
                         \((\(g\^\(li1li2\)\ g\^\(li3li4\)\) - 
                             \(g\^\(li1li3\)\ g\^\(li2li4\)\))\), " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["ci1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["ci4", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u11", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["ci2", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["ci3", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u11", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                       RowBox[{
                         \((\(g\^\(li1li2\)\ g\^\(li3li4\)\) - 
                             \(g\^\(li1li4\)\ g\^\(li2li3\)\))\), " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["ci1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["ci3", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u11", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["ci2", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["ci4", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u11", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                       RowBox[{
                         \((\(g\^\(li1li3\)\ g\^\(li2li4\)\) - 
                             \(g\^\(li1li4\)\ g\^\(li2li3\)\))\), " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["ci1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["ci2", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u11", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["ci3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["ci4", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["u11", 
                          "TraditionalForm"], "TraditionalForm"]}]]}]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "GluonVertex"]}, Open]]}, Open]], Cell["GO", "ObjectName", 
         CellTags -> "GO"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "GO"], 
           Cell["GO is equivalent to Twist2GluonOperator.", "Text", 
            CellTags -> "GO"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Twist2GluonOperator", 
                RuleDelayed[ButtonData, "Twist2GluonOperator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Twist2GluonOperator"]], "."}], "Text", 
            CellTags -> "GO"]}, Open]], Cell["GP", "ObjectName", 
         CellTags -> "GP"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "GP"], 
           Cell["GP is equivalent to GluonPropagator.", "Text", 
            CellTags -> "GP"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["GluonPropagator", 
                RuleDelayed[ButtonData, "GluonPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonPropagator"]], "."}], "Text", 
            CellTags -> "GP"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["GrassmannParity", "ObjectName", CellTags -> "GrassmannParity"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GrassmannParity"], Cell["GrassmannParity is a data \
type. E.g. DataType[F, GrassmannParity] = 1 declares F to be of bosonic type \
and DataType[F, GrassmannParity] = -1 of fermionic one.", "Text", 
            CellTags -> "GrassmannParity"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DataType", RuleDelayed[ButtonData, "DataType"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DataType"]], "."}], "Text", 
            CellTags -> "GrassmannParity"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["GS", "ObjectName", CellTags -> "GS"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GS"], Cell[TextData[
             {"GS[p] can be used as input for a 4-dimensional ", Cell[BoxData[
                \(TraditionalForm\`\(p\(\ \[NegativeMediumSpace]\)
                     \[NegativeMediumSpace]\[NegativeMediumSpace]
                     \[NegativeMediumSpace]/\ 
                     \((\(= \(\[Gamma] . p\)\)\ =\ 
                        \(\[Gamma]\_\[Mu] p\^\[Mu]\))\)\)\)]], " and is \
transformed into DiracGamma[Momentum[p]] by FeynCalcInternal (=FCI). GS[p,q, \
...] is a short form for GS[p].GS[q]. ... ."}], "Text", CellTags -> "GS"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracGamma", RuleDelayed[ButtonData, "DiracGamma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGamma"]], ", ", 
              ButtonBox["DiracSlash", RuleDelayed[ButtonData, "DiracSlash"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSlash"]], ", ", 
              ButtonBox["GA", RuleDelayed[ButtonData, "GA"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GA"]], 
              ", ", 
              ButtonBox["GAD", RuleDelayed[ButtonData, "GAD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GAD"]], 
              "."}], "Text", CellTags -> "GS"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "GS"], Cell[CellGroupData[{Cell[BoxData[\(GS[p]\)], 
               "Input", CellTags -> "GS"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma] \[CenterDot] p\)\)], "Output", 
               CellTags -> "GS"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(GS[p]\)//FCI\)//StandardForm\)], "Input", CellTags -> 
                "GS"], Cell[BoxData[\(DiracGamma[\(Momentum[p]\)]\)], 
               "Output", CellTags -> "GS"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(GS[\(p, q, r, s\)]\)], "Input", 
               CellTags -> "GS"], Cell[BoxData[
                \(TraditionalForm\`\(\((\[Gamma] \[CenterDot] p)\) . 
                     \((\[Gamma] \[CenterDot] q)\) . 
                     \((\[Gamma] \[CenterDot] r)\) . 
                     \((\[Gamma] \[CenterDot] s)\)\)\)], "Output", 
               CellTags -> "GS"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GS[\(p, q, r, s\)]\)//StandardForm\)], "Input", 
               CellTags -> "GS"], Cell[BoxData[
                \(\(GS[p]\) . \(GS[q]\) . \(GS[r]\) . \(GS[s]\)\)], "Output", 
               CellTags -> "GS"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GS[q]\) . \((\(GS[p]\) + m)\) . \(GS[q]\)\)], "Input", 
               CellTags -> "GS"], Cell[BoxData[
                \(TraditionalForm\`\(\((\[Gamma] \[CenterDot] q)\) . 
                     \((m + \(\[Gamma] \[CenterDot] p\))\) . 
                     \((\[Gamma] \[CenterDot] q)\)\)\)], "Output", 
               CellTags -> "GS"]}, Open]]}, Open]], Cell["GSD", "ObjectName", 
         CellTags -> "GSD"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "GSD"], 
           Cell[TextData[{"GSD[p] can be used as input for a D-dimensional ", 
              Cell[BoxData[
                \(TraditionalForm\`\(p\(\ \[NegativeMediumSpace]\)
                     \[NegativeMediumSpace]\[NegativeMediumSpace]
                     \[NegativeMediumSpace]/\ 
                     \((\(= \(\[Gamma] . p\)\)\ =\ 
                        \(\[Gamma]\_\[Mu] p\^\[Mu]\))\)\)\)]], " and is \
transformed into DiracGamma[Momentum[p,D],D] by FeynCalcInternal (=FCI). \
GSD[p,q, ...] is a short form for GSD[p].GSD[q]. ... ."}], "Text", 
            CellTags -> "GSD"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracGamma", RuleDelayed[ButtonData, "DiracGamma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGamma"]], ", ", 
              ButtonBox["DiracSlash", RuleDelayed[ButtonData, "DiracSlash"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSlash"]], ", ", 
              ButtonBox["GA", RuleDelayed[ButtonData, "GA"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GA"]], 
              ", ", 
              ButtonBox["GAD", RuleDelayed[ButtonData, "GAD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GAD"]], 
              "."}], "Text", CellTags -> "GSD"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "GSD"], Cell[CellGroupData[{Cell[BoxData[\(GSD[p]\)], 
               "Input", CellTags -> "GSD"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma] \[CenterDot] p\)\)], "Output", 
               CellTags -> "GSD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(GSD[p]\)//FCI\)//StandardForm\)], "Input", CellTags -> 
                "GSD"], Cell[BoxData[
                \(DiracGamma[\(\(Momentum[\(p, D\)]\), D\)]\)], "Output", 
               CellTags -> "GSD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(GSD[\(p, q, r, s\)]\)], "Input", CellTags -> "GSD"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\((\[Gamma] \[CenterDot] p)\) . 
                     \((\[Gamma] \[CenterDot] q)\) . 
                     \((\[Gamma] \[CenterDot] r)\) . 
                     \((\[Gamma] \[CenterDot] s)\)\)\)], "Output", 
               CellTags -> "GSD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(GSD[\(p, q, r, s\)]\)//StandardForm\)], "Input", 
               CellTags -> "GSD"], Cell[BoxData[
                \(\(GSD[p]\) . \(GSD[q]\) . \(GSD[r]\) . \(GSD[s]\)\)], 
               "Output", CellTags -> "GSD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(GSD[q]\) . \((\(GSD[p]\) + m)\) . \(GSD[q]\)\)], "Input", 
               CellTags -> "GSD"], Cell[BoxData[
                \(TraditionalForm\`\(\((\[Gamma] \[CenterDot] q)\) . 
                     \((m + \(\[Gamma] \[CenterDot] p\))\) . 
                     \((\[Gamma] \[CenterDot] q)\)\)\)], "Output", 
               CellTags -> "GSD"]}, Open]]}, Open]], Cell["Gstrong", 
         "ObjectName", CellTags -> "Gstrong"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Gstrong"], Cell[
            "Gstrong denotes the strong coupling constant.", "Text", 
            CellTags -> "Gstrong"], Cell[TextData[{"See also: ", 
              ButtonBox["CovariantD", RuleDelayed[ButtonData, "CovariantD"], 
                Rule[ButtonStyle, "AddOnsLink"]], ", ", 
              ButtonBox["FieldStrength", 
                RuleDelayed[ButtonData, "FieldStrength"], 
                Rule[ButtonStyle, "AddOnsLink"]], ", ", 
              ButtonBox["GluonVertex", RuleDelayed[ButtonData, 
                 "GluonVertex"], Rule[ButtonStyle, "AddOnsLink"]], "."}], 
            "Text", CellTags -> "Gstrong"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Gstrong"], Cell["Gstrong has no functional \
properties. Only a typesetting rule is defined.", "Text", 
            CellTags -> "Gstrong"], Cell[CellGroupData[
             {Cell[BoxData["Gstrong"], "Input", CellTags -> "Gstrong"], 
              Cell[BoxData[\(TraditionalForm\`g\_s\)], "Output", CellTags -> 
                "Gstrong"]}, Open]]}, Open]], Cell["GTI", "ObjectName", 
         CellTags -> "GTI"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "GTI"], 
           Cell["GTI is like RHI, but with no functional properties.", 
            "Text", CellTags -> "GTI"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["RHI", RuleDelayed[ButtonData, "RHI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "RHI"]], 
              "."}], "Text", CellTags -> "GTI"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["GV", "ObjectName", CellTags -> "GV"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "GV"], Cell["GV is equivalent to GluonVertex.", 
            "Text", CellTags -> "GV"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["GluonVertex", RuleDelayed[ButtonData, 
                 "GluonVertex"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonVertex"]], "."}], "Text", 
            CellTags -> "GV"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["Hill", "ObjectName", CellTags -> "Hill"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Hill"], Cell["Hill[x, y] gives the Hill identity \
with arguments x and y. The returned object is 0.", "Text", 
            CellTags -> "Hill"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["SimplifyPolyLog", 
                RuleDelayed[ButtonData, "SimplifyPolyLog"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SimplifyPolyLog"]], "."}], "Text", 
            CellTags -> "Hill"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "Hill"], 
           Cell[CellGroupData[{Cell[BoxData[\(Hill[\(a, b\)]\)], "Input", 
               CellTags -> "Hill"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(log(a)\)\ 
                       \((\(log(\(1 - a\))\) - \(log(\(1 - b\))\))\)\) + 
                     \(\(log(\(\(1 - a\)\/\(1 - b\)\))\)\ 
                       \((\(-\(log(a)\)\) + \(log(\(1 - b\))\) - 
                          \(log(\(\(a - b\)\/a\))\) + 
                          \(log(\(\(a - b\)\/\(1 - b\)\))\))\)\) - 
                     \(\((\(log(\(1 - b\))\) - \(log(\(\(a - b\)\/a\))\) + 
                          \(log(\(\(a - b\)\/\(a\ \((1 - b)\)\)\))\))\)\ 
                       \(log(\(\(\((1 - a)\)\ b\)\/\(a\ \((1 - b)\)\)\))\)\) 
                     + \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(a)\) + \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(\(1 - a\)\/\(1 - b\)\))\) - 
                     \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(b)\) + \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(b\/a\))\) - \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(\(\((1 - a)\)\ b\)\/\(a\ \((1 - b)\)\)\))\) - 
                     \[Pi]\^2\/6\)\)], "Output", CellTags -> "Hill"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(%\ /.\ \(a \[RuleDelayed]\ .123\)\)\ /.\ 
                     \(b \[RuleDelayed]\ .656\)\)\ //\ Chop\)], "Input", 
               CellTags -> "Hill"], Cell[BoxData[\(TraditionalForm\`0\)], 
               "Output", CellTags -> "Hill"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(Hill[\(x, \(x\ y\)\)]\)//PowerExpand\)//
                     SimplifyPolyLog\)//Expand\)], "Input", CellTags -> 
                "Hill"], Cell[BoxData[
                \(TraditionalForm\`\(\(\[Zeta](2)\) - 
                     \(\(log(\(1 - y\))\)\ \(log(y)\)\) - 
                     \(\(log(x)\)\ \(log(\(1 - \(x\ y\)\))\)\) - 
                     \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(1 - x\))\) - \(\(\*
                          InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(1 - y\))\) - \(\(\*
                          InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(x\ y\))\) + \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(\(1 - x\)\/\(1 - \(x\ y\)\)\))\) - 
                     \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(\(\((1 - x)\)\ y\)\/\(1 - \(x\ y\)\)\))\)\)\)], "Output", CellTags -> 
                "Hill"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(%\ /.\ \(x \[RuleDelayed]\ .34\)\)/.\ 
                       \(y \[Rule]\ .6\)\)//N\)//Chop\)], "Input", 
               CellTags -> "Hill"], Cell[BoxData[\(TraditionalForm\`0\)], 
               "Output", CellTags -> "Hill"]}, Open]]}, Open]], 
        Cell["HypergeometricAC", "ObjectName", CellTags -> 
          "HypergeometricAC"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "HypergeometricAC"], Cell["HypergeometricAC[n][exp] analytically \
continues Hypergeometric2F1 functions in exp. The second argument n refers to \
the equation number (n) in chapter 2.10 of \"Higher Transcendental \
Functions\" by Ergelyi, Magnus, Oberhettinger, Tricomi. In case of eq. (6) \
(p.109) the last line is returned for HypergeometricAC[6][exp], while the \
first equality is given by HypergeometricAC[61][exp]. ((2.10.1) is identical \
to eq. (9.5.7) of \"Special Functions & their Applications\" by \
N.N.Lebedev).", "Text", CellTags -> "HypergeometricAC"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[HypergeometricAC]\)], 
               "Input", CellTags -> "HypergeometricAC"], Cell[BoxData[
                \(TraditionalForm\`\({Collect2 \[Rule] True}\)\)], "Output", 
               CellTags -> "HypergeometricAC"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["HypExplicit", RuleDelayed[ButtonData, 
                 "HypExplicit"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "HypExplicit"]], ", ", 
              ButtonBox["HypergeometricIR", 
                RuleDelayed[ButtonData, "HypergeometricIR"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "HypergeometricIR"]], ", ", 
              ButtonBox["HypergeometricSE", 
                RuleDelayed[ButtonData, "HypergeometricSE"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "HypergeometricSE"]], ", ", 
              ButtonBox["ToHypergeometric", 
                RuleDelayed[ButtonData, "ToHypergeometric"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ToHypergeometric"]], "."}], "Text", 
            CellTags -> "HypergeometricAC"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "HypergeometricAC"], 
           Cell["These are all transformation rules currently built in.", 
            "Text", CellTags -> "HypergeometricAC"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(HypergeometricAC[1]\)[
                   \(Hypergeometric2F1[\(\[Alpha], \[Beta], \[Gamma], z\)]\)]
                \)], "Input", CellTags -> "HypergeometricAC"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                         \[CapitalGamma](\(\[Alpha] + \[Beta] - \[Gamma]\))\)
                \ \(\[CapitalGamma](\[Gamma])\)\ 
                        \*TagBox[TagBox[\(
                            \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)
                              \) \[InvisibleApplication] 
                             \((\*TagBox[TagBox[\(
                                    \*TagBox[\(\[Gamma] - \[Alpha]\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(\[Gamma] - \[Beta]\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(
                                   \(-\[Alpha]\) - \[Beta] + \[Gamma] + 
                                   1\), Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1 - z\), Hypergeometric2F1, 
                                  Rule[Editable, True]])\)\), 
                           InterpretTemplate[Function[HypergeometricPFQ[
                              Slot[1], Slot[2], Slot[3]]]], 
                           Rule[Editable, False]], Hypergeometric2F1]\ 
                        \((1 - z)\)\^\(\(-\[Alpha]\) - \[Beta] + \[Gamma]\)\)
                \/\(\(\[CapitalGamma](\[Alpha])\)\ 
                        \(\[CapitalGamma](\[Beta])\)\) + 
                     \(\(\[CapitalGamma](\[Gamma])\)\ 
                        \(\[CapitalGamma](
                          \(\(-\[Alpha]\) - \[Beta] + \[Gamma]\))\)\ 
                        \*TagBox[TagBox[\(
                            \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)
                              \) \[InvisibleApplication] 
                             \((\*TagBox[TagBox[\(
                                    \*TagBox["\[Alpha]", 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox["\[Beta]", 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(
                                   \[Alpha] + \[Beta] - \[Gamma] + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1 - z\), Hypergeometric2F1, 
                                  Rule[Editable, True]])\)\), 
                           InterpretTemplate[Function[HypergeometricPFQ[
                              Slot[1], Slot[2], Slot[3]]]], 
                           Rule[Editable, False]], Hypergeometric2F1]\)\/
                      \(\(\[CapitalGamma](\(\[Gamma] - \[Alpha]\))\)\ 
                        \(\[CapitalGamma](\(\[Gamma] - \[Beta]\))\)\)\)\)], 
               "Output", CellTags -> "HypergeometricAC"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(HypergeometricAC[2]\)[
                   \(Hypergeometric2F1[\(\[Alpha], \[Beta], \[Gamma], z\)]\)]
                \)], "Input", CellTags -> "HypergeometricAC"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                         \[CapitalGamma](\(\[Beta] - \[Alpha]\))\)\ 
                        \(\[CapitalGamma](\[Gamma])\)\ 
                        \*TagBox[TagBox[\(
                            \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)
                              \) \[InvisibleApplication] 
                             \((\*TagBox[TagBox[\(
                                    \*TagBox["\[Alpha]", 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(\[Alpha] - \[Gamma] + 1
                                   \), Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(\[Alpha] - \[Beta] + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/z\), Hypergeometric2F1, 
                                  Rule[Editable, True]])\)\), 
                           InterpretTemplate[Function[HypergeometricPFQ[
                              Slot[1], Slot[2], Slot[3]]]], 
                           Rule[Editable, False]], Hypergeometric2F1]\ 
                        \((\(-z\))\)\^\(-\[Alpha]\)\)\/
                      \(\(\[CapitalGamma](\[Beta])\)\ 
                        \(\[CapitalGamma](\(\[Gamma] - \[Alpha]\))\)\) + 
                     \(\(\[CapitalGamma](\(\[Alpha] - \[Beta]\))\)\ 
                        \(\[CapitalGamma](\[Gamma])\)\ 
                        \*TagBox[TagBox[\(
                            \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)
                              \) \[InvisibleApplication] 
                             \((\*TagBox[TagBox[\(
                                    \*TagBox["\[Beta]", 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(\[Beta] - \[Gamma] + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(\(-\[Alpha]\) + \[Beta] + 1
                                   \), Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/z\), Hypergeometric2F1, 
                                  Rule[Editable, True]])\)\), 
                           InterpretTemplate[Function[HypergeometricPFQ[
                              Slot[1], Slot[2], Slot[3]]]], 
                           Rule[Editable, False]], Hypergeometric2F1]\ 
                        \((\(-z\))\)\^\(-\[Beta]\)\)\/
                      \(\(\[CapitalGamma](\[Alpha])\)\ 
                        \(\[CapitalGamma](\(\[Gamma] - \[Beta]\))\)\)\)\)], 
               "Output", CellTags -> "HypergeometricAC"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(HypergeometricAC[3]\)[
                   \(Hypergeometric2F1[\(\[Alpha], \[Beta], \[Gamma], z\)]\)]
                \)], "Input", CellTags -> "HypergeometricAC"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                         \[CapitalGamma](\(\[Beta] - \[Alpha]\))\)\ 
                        \(\[CapitalGamma](\[Gamma])\)\ 
                        \*TagBox[TagBox[\(
                            \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)
                              \) \[InvisibleApplication] 
                             \((\*TagBox[TagBox[\(
                                    \*TagBox["\[Alpha]", 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(\[Gamma] - \[Beta]\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(\[Alpha] - \[Beta] + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/\(1 - z\)\), Hypergeometric2F1, 
                                  Rule[Editable, True]])\)\), 
                           InterpretTemplate[Function[HypergeometricPFQ[
                              Slot[1], Slot[2], Slot[3]]]], 
                           Rule[Editable, False]], Hypergeometric2F1]\ 
                        \((1 - z)\)\^\(-\[Alpha]\)\)\/
                      \(\(\[CapitalGamma](\[Beta])\)\ 
                        \(\[CapitalGamma](\(\[Gamma] - \[Alpha]\))\)\) + 
                     \(\(\[CapitalGamma](\(\[Alpha] - \[Beta]\))\)\ 
                        \(\[CapitalGamma](\[Gamma])\)\ 
                        \*TagBox[TagBox[\(
                            \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)
                              \) \[InvisibleApplication] 
                             \((\*TagBox[TagBox[\(
                                    \*TagBox["\[Beta]", 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(\[Gamma] - \[Alpha]\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(\(-\[Alpha]\) + \[Beta] + 1
                                   \), Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/\(1 - z\)\), Hypergeometric2F1, 
                                  Rule[Editable, True]])\)\), 
                           InterpretTemplate[Function[HypergeometricPFQ[
                              Slot[1], Slot[2], Slot[3]]]], 
                           Rule[Editable, False]], Hypergeometric2F1]\ 
                        \((1 - z)\)\^\(-\[Beta]\)\)\/
                      \(\(\[CapitalGamma](\[Alpha])\)\ 
                        \(\[CapitalGamma](\(\[Gamma] - \[Beta]\))\)\)\)\)], 
               "Output", CellTags -> "HypergeometricAC"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(HypergeometricAC[4]\)[
                   \(Hypergeometric2F1[\(\[Alpha], \[Beta], \[Gamma], z\)]\)]
                \)], "Input", CellTags -> "HypergeometricAC"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(\[CapitalGamma](\[Gamma])\)\ 
                        \(\[CapitalGamma](
                          \(\(-\[Alpha]\) - \[Beta] + \[Gamma]\))\)\ 
                        \*TagBox[TagBox[\(
                            \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)
                              \) \[InvisibleApplication] 
                             \((\*TagBox[TagBox[\(
                                    \*TagBox["\[Alpha]", 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(\[Alpha] - \[Gamma] + 1
                                   \), Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(
                                   \[Alpha] + \[Beta] - \[Gamma] + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(-\(\(1 - z\)\/z\)\), Hypergeometric2F1, 
                                  Rule[Editable, True]])\)\), 
                           InterpretTemplate[Function[HypergeometricPFQ[
                              Slot[1], Slot[2], Slot[3]]]], 
                           Rule[Editable, False]], Hypergeometric2F1]\ 
                        z\^\(-\[Alpha]\)\)\/
                      \(\(\[CapitalGamma](\(\[Gamma] - \[Alpha]\))\)\ 
                        \(\[CapitalGamma](\(\[Gamma] - \[Beta]\))\)\) + 
                     \(\((1 - z)\)\^\(\(-\[Alpha]\) - \[Beta] + \[Gamma]\)\ 
                        \(\[CapitalGamma](\(\[Alpha] + \[Beta] - \[Gamma]\))
                         \)\ \(\[CapitalGamma](\[Gamma])\)\ 
                        \*TagBox[TagBox[\(
                            \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)
                              \) \[InvisibleApplication] 
                             \((\*TagBox[TagBox[\(
                                    \*TagBox[\(\[Gamma] - \[Alpha]\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(1 - \[Alpha]\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(
                                   \(-\[Alpha]\) - \[Beta] + \[Gamma] + 
                                   1\), Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                   InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                  Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(-\(\(1 - z\)\/z\)\), Hypergeometric2F1, 
                                  Rule[Editable, True]])\)\), 
                           InterpretTemplate[Function[HypergeometricPFQ[
                              Slot[1], Slot[2], Slot[3]]]], 
                           Rule[Editable, False]], Hypergeometric2F1]\ 
                        z\^\(\[Alpha] - \[Gamma]\)\)\/
                      \(\(\[CapitalGamma](\[Alpha])\)\ 
                        \(\[CapitalGamma](\[Beta])\)\)\)\)], "Output", 
               CellTags -> "HypergeometricAC"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(HypergeometricAC[6]\)[
                   \(Hypergeometric2F1[\(\[Alpha], \[Beta], \[Gamma], z\)]\)]
                \)], "Input", CellTags -> "HypergeometricAC"], Cell[BoxData[
                \(TraditionalForm\`\(\((1 - z)\)\^\(-\[Beta]\)\ 
                     \*TagBox[TagBox[\(\(
                           \(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["\[Beta]", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox[\(\[Gamma] - \[Alpha]\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["\[Gamma]", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(-\(z\/\(1 - z\)\)\), 
                               Hypergeometric2F1, Rule[Editable, True]])\)\
\), InterpretTemplate[Function[HypergeometricPFQ[Slot[1], 
                           Slot[2], Slot[3]]]], Rule[Editable, False]], 
                       Hypergeometric2F1]\)\)], "Output", CellTags -> 
                "HypergeometricAC"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(HypergeometricAC[61]\)[
                   \(Hypergeometric2F1[\(\[Alpha], \[Beta], \[Gamma], z\)]\)]
                \)], "Input", CellTags -> "HypergeometricAC"], Cell[BoxData[
                \(TraditionalForm\`\(\((1 - z)\)\^\(-\[Alpha]\)\ 
                     \*TagBox[TagBox[\(\(
                           \(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["\[Alpha]", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox[\(\[Gamma] - \[Beta]\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["\[Gamma]", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(-\(z\/\(1 - z\)\)\), 
                               Hypergeometric2F1, Rule[Editable, True]])\)\
\), InterpretTemplate[Function[HypergeometricPFQ[Slot[1], 
                           Slot[2], Slot[3]]]], Rule[Editable, False]], 
                       Hypergeometric2F1]\)\)], "Output", CellTags -> 
                "HypergeometricAC"]}, Open]]}, Open]], 
        Cell["HypergeometricIR", "ObjectName", CellTags -> 
          "HypergeometricIR"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "HypergeometricIR"], Cell["HypergeometricIR[exp, t] substitutes \
for all Hypergeometric2F1[a,b,c,z] in exp by its Euler integral reprentation. \
The factor Integratedx[t, 0, 1] can be omitted by setting the option \
Integratedx \[Rule] False.", "Text", CellTags -> "HypergeometricIR"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["HypergeometricAC", 
                RuleDelayed[ButtonData, "HypergeometricAC"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "HypergeometricAC"]], ", ", 
              ButtonBox["HypergeometricSE", 
                RuleDelayed[ButtonData, "HypergeometricSE"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "HypergeometricSE"]], ", ", 
              ButtonBox["ToHypergeometric", 
                RuleDelayed[ButtonData, "ToHypergeometric"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ToHypergeometric"]], "."}], "Text", 
            CellTags -> "HypergeometricIR"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[HypergeometricIR]\)], "Input", CellTags -> 
                "HypergeometricIR"], Cell[BoxData[
                \(TraditionalForm\`\({Integratedx \[Rule] False}\)\)], 
               "Output", CellTags -> "HypergeometricIR"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "HypergeometricIR"], Cell[CellGroupData[{Cell[BoxData[
                \(HypergeometricIR[\(\(Hypergeometric2F1[\(a, b, c, z\)]\), t
                    \)]\)], "Input", CellTags -> "HypergeometricIR"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(\((1 - t)\)\^\(\(-b\) + c - 1\)\ 
                       t\^\(b - 1\)\ \((1 - \(t\ z\))\)\^\(-a\)\ 
                       \(\[CapitalGamma](c)\)\)\/
                     \(\(\[CapitalGamma](b)\)\ \(\[CapitalGamma](\(c - b\))\)
                      \)\)\)], "Output", CellTags -> "HypergeometricIR"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ToHypergeometric[\(\(\(t^b\)\ \(\((1 - t)\)^c\)\ 
                       \(\((1 + \(t\ z\))\)^a\)\), t\)]\)], "Input", 
               CellTags -> "HypergeometricIR"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(\[CapitalGamma](\(b + 1\))\)\ 
                       \(\[CapitalGamma](\(c + 1\))\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(-a\), Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(b + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(b + c + 2\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(-z\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\/
                     \(\[CapitalGamma](\(b + c + 2\))\)\)\)], "Output", 
               CellTags -> "HypergeometricIR"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(HypergeometricIR[\(%, t\)]\)], 
               "Input", CellTags -> "HypergeometricIR"], Cell[BoxData[
                \(TraditionalForm\`\(\((1 - t)\)\^c\ t\^b\ 
                     \((\(t\ z\) + 1)\)\^a\)\)], "Output", CellTags -> 
                "HypergeometricIR"]}, Open]]}, Open]], 
        Cell["HypergeometricSE", "ObjectName", CellTags -> 
          "HypergeometricSE"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "HypergeometricSE"], Cell[TextData[{"HypergeometricSE[exp, ", 
              Cell[BoxData[\(TraditionalForm\`\[Nu]\)]], "] expresses \
Hypergeometric functions by their series expansion in terms of a sum (the Sum \
is omitted and ", Cell[BoxData[\(TraditionalForm\`\[Nu]\)]], 
              ", running from 0 to ", Cell[BoxData[
                \(TraditionalForm\`\[Infinity]\)]], 
              ", is the summation index)."}], "Text", CellTags -> 
             "HypergeometricSE"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[HypergeometricSE]\)], "Input", CellTags -> 
                "HypergeometricSE"], Cell[BoxData[
                \(TraditionalForm\`\({Simplify \[Rule] FullSimplify}\)\)], 
               "Output", CellTags -> "HypergeometricSE"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["HypergeometricIR", 
                RuleDelayed[ButtonData, "HypergeometricIR"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "HypergeometricIR"]], "."}], "Text", 
            CellTags -> "HypergeometricSE"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "HypergeometricSE"], Cell[CellGroupData[{Cell[BoxData[
                \(HypergeometricSE[\(\(Hypergeometric2F1[\(a, b, c, z\)]\), 
                     \[Nu]\)]\)], "Input", CellTags -> "HypergeometricSE"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(z\^\[Nu]\ \(\[CapitalGamma](c)\)\ 
                       \(\[CapitalGamma](\(a + \[Nu]\))\)\ 
                       \(\[CapitalGamma](\(b + \[Nu]\))\)\)\/
                     \(\(\[CapitalGamma](a)\)\ \(\[CapitalGamma](b)\)\ 
                       \(\[CapitalGamma](\(\[Nu] + 1\))\)\ 
                       \(\[CapitalGamma](\(c + \[Nu]\))\)\)\)\)], "Output", 
               CellTags -> "HypergeometricSE"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(HypergeometricSE[\(\(HypergeometricPFQ[
                       \(\({a, b, c}\), \({d, e}\), z\)]\), \[Nu]\)]\)], 
               "Input", CellTags -> "HypergeometricSE"], Cell[BoxData[
                \(TraditionalForm\`\(\(z\^\[Nu]\ \(\[CapitalGamma](d)\)\ 
                       \(\[CapitalGamma](e)\)\ 
                       \(\[CapitalGamma](\(a + \[Nu]\))\)\ 
                       \(\[CapitalGamma](\(b + \[Nu]\))\)\ 
                       \(\[CapitalGamma](\(c + \[Nu]\))\)\)\/
                     \(\(\[CapitalGamma](a)\)\ \(\[CapitalGamma](b)\)\ 
                       \(\[CapitalGamma](c)\)\ 
                       \(\[CapitalGamma](\(\[Nu] + 1\))\)\ 
                       \(\[CapitalGamma](\(d + \[Nu]\))\)\ 
                       \(\[CapitalGamma](\(e + \[Nu]\))\)\)\)\)], "Output", 
               CellTags -> "HypergeometricSE"]}, Open]]}, Open]], 
        Cell["HypExplicit", "ObjectName", CellTags -> "HypExplicit"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "HypExplicit"], Cell[TextData[{"HypExplicit[exp, ", 
              Cell[BoxData[\(TraditionalForm\`\[Nu]\)]], "] expresses \
Hypergeometric functions in exp by their definition in terms of a sum (the \
Sum is omitted and ", Cell[BoxData[\(TraditionalForm\`\[Nu]\)]], 
              " is the summation index)."}], "Text", CellTags -> 
             "HypExplicit"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["HypergeometricIR", 
                RuleDelayed[ButtonData, "HypergeometricIR"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "HypergeometricIR"]], "."}], "Text", 
            CellTags -> "HypExplicit"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "HypExplicit"], Cell[CellGroupData[{Cell[BoxData[
                \(Hypergeometric2F1[\(a, b, c, z\)]\)], "Input", CellTags -> 
                "HypExplicit"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                        \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                         \[InvisibleApplication] 
                         \((\*TagBox[TagBox[\(
                                \*TagBox["a", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                 \*TagBox["b", Hypergeometric2F1, 
                                   Rule[Editable, True]]\), 
                               InterpretTemplate[Function[List[
                                  SlotSequence[1]]]]], Hypergeometric2F1, 
                              Rule[Editable, False]] ; 
                            \*TagBox[TagBox[TagBox["c", 
                                Hypergeometric2F1, Rule[Editable, True]], 
                               InterpretTemplate[Function[List[
                                  SlotSequence[1]]]]], Hypergeometric2F1, 
                              Rule[Editable, False]] ; 
                            \*TagBox["z", Hypergeometric2F1, 
                              Rule[Editable, True]])\)\), 
                       InterpretTemplate[Function[HypergeometricPFQ[
                          Slot[1], Slot[2], Slot[3]]]], 
                       Rule[Editable, False]], Hypergeometric2F1]\)\)], 
               "Output", CellTags -> "HypExplicit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(HypExplicit[\(%, \[Nu]\)]\)], 
               "Input", CellTags -> "HypExplicit"], Cell[BoxData[
                \(TraditionalForm\`\(\(z\^\[Nu]\ \(\[CapitalGamma](c)\)\ 
                       \(\[CapitalGamma](\(a + \[Nu]\))\)\ 
                       \(\[CapitalGamma](\(b + \[Nu]\))\)\)\/
                     \(\(\[CapitalGamma](a)\)\ \(\[CapitalGamma](b)\)\ 
                       \(\[CapitalGamma](\(\[Nu] + 1\))\)\ 
                       \(\[CapitalGamma](\(c + \[Nu]\))\)\)\)\)], "Output", 
               CellTags -> "HypExplicit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(HypergeometricPFQ[\(\({a, b, c}\), \({d, e}\), z\)]\)], 
               "Input", CellTags -> "HypExplicit"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                        \(\(\[InvisiblePrefixScriptBase]\_3\) \(F\_2\)\) 
                         \[InvisibleApplication] 
                         \((\*TagBox[TagBox[\(
                                \*TagBox["a", HypergeometricPFQ, 
                                   Rule[Editable, True]], 
                                 \*TagBox["b", HypergeometricPFQ, 
                                   Rule[Editable, True]], 
                                 \*TagBox["c", HypergeometricPFQ, 
                                   Rule[Editable, True]]\), 
                               InterpretTemplate[Function[List[
                                  SlotSequence[1]]]]], HypergeometricPFQ, 
                              Rule[Editable, False]] ; 
                            \*TagBox[TagBox[\(
                                \*TagBox["d", HypergeometricPFQ, 
                                   Rule[Editable, True]], 
                                 \*TagBox["e", HypergeometricPFQ, 
                                   Rule[Editable, True]]\), 
                               InterpretTemplate[Function[List[
                                  SlotSequence[1]]]]], HypergeometricPFQ, 
                              Rule[Editable, False]] ; 
                            \*TagBox["z", HypergeometricPFQ, 
                              Rule[Editable, True]])\)\), 
                       InterpretTemplate[Function[HypergeometricPFQ[
                          Slot[1], Slot[2], Slot[3]]]], 
                       Rule[Editable, False]], HypergeometricPFQ]\)\)], 
               "Output", CellTags -> "HypExplicit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(HypExplicit[\(%, \[Nu]\)]\)], 
               "Input", CellTags -> "HypExplicit"], Cell[BoxData[
                \(TraditionalForm\`\(\(z\^\[Nu]\ \(\[CapitalGamma](d)\)\ 
                       \(\[CapitalGamma](e)\)\ 
                       \(\[CapitalGamma](\(a + \[Nu]\))\)\ 
                       \(\[CapitalGamma](\(b + \[Nu]\))\)\ 
                       \(\[CapitalGamma](\(c + \[Nu]\))\)\)\/
                     \(\(\[CapitalGamma](a)\)\ \(\[CapitalGamma](b)\)\ 
                       \(\[CapitalGamma](c)\)\ 
                       \(\[CapitalGamma](\(\[Nu] + 1\))\)\ 
                       \(\[CapitalGamma](\(d + \[Nu]\))\)\ 
                       \(\[CapitalGamma](\(e + \[Nu]\))\)\)\)\)], "Output", 
               CellTags -> "HypExplicit"]}, Open]]}, Open]], 
        Cell["HypInt", "ObjectName", CellTags -> "HypInt"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "HypInt"], Cell["HypInt[exp, t]  substitutes for all  \
Hypergeometric2F1[a,b,c,z] in exp Gamma[c]/(Gamma[b] Gamma[c-b]) \
Integratedx[t,0,1]  t^(b-1) (1-t)^(c-b-1) (1-t z)^(-a).", "Text", 
            CellTags -> "HypInt"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "HypInt"], Cell[CellGroupData[{Cell[BoxData[
                \(Hypergeometric2F1[\(a, b, c, z\)]\)], "Input", CellTags -> 
                "HypInt"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                        \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                         \[InvisibleApplication] 
                         \((\*TagBox[TagBox[\(
                                \*TagBox["a", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                 \*TagBox["b", Hypergeometric2F1, 
                                   Rule[Editable, True]]\), 
                               InterpretTemplate[Function[List[
                                  SlotSequence[1]]]]], Hypergeometric2F1, 
                              Rule[Editable, False]] ; 
                            \*TagBox[TagBox[TagBox["c", 
                                Hypergeometric2F1, Rule[Editable, True]], 
                               InterpretTemplate[Function[List[
                                  SlotSequence[1]]]]], Hypergeometric2F1, 
                              Rule[Editable, False]] ; 
                            \*TagBox["z", Hypergeometric2F1, 
                              Rule[Editable, True]])\)\), 
                       InterpretTemplate[Function[HypergeometricPFQ[
                          Slot[1], Slot[2], Slot[3]]]], 
                       Rule[Editable, False]], Hypergeometric2F1]\)\)], 
               "Output", CellTags -> "HypInt"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(HypInt[\(%, t\)]\)], "Input", 
               CellTags -> "HypInt"], Cell[BoxData[FormBox[FractionBox[
                  RowBox[{\(\((1 - t)\)\^\(\(-b\) + c - 1\)\), " ", 
                    \(t\^\(b - 1\)\), " ", \(\((1 - \(t\ z\))\)\^\(-a\)\), 
                    " ", \(\[CapitalGamma](c)\), " ", RowBox[
                     {SubsuperscriptBox["\[Integral]", FormBox["0", 
                        "TraditionalForm"], FormBox["1", "TraditionalForm"]], 
                      "\[DifferentialD]", TagBox[FormBox["t", 
                        "TraditionalForm"], TraditionalForm, Editable -> 
                        True], "\[VeryThinSpace]"}]}], 
                  \(\(\[CapitalGamma](b)\)\ \(\[CapitalGamma](c - b)\)\)], 
                 TraditionalForm]], "Output", CellTags -> "HypInt"]}, 
             Open]]}, Open]], Cell["IFPD", "ObjectName", CellTags -> "IFPD"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "IFPD"], Cell["IFPD[p, m] denotes (p^2 - m^2).", 
            "Text", CellTags -> "IFPD"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["PropagatorDenominator", 
                RuleDelayed[ButtonData, "PropagatorDenominator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PropagatorDenominator"]], "."}], "Text", 
            CellTags -> "IFPD"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["IFPDOff", "ObjectName", CellTags -> "IFPDOff"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "IFPDOff"], Cell["IFPDOff[exp_,q1_, q2_, ...] changes \
from IFPD representation to FeynAmpDenominator[ ...]. The q1, q2, ... are the \
integration momenta.", "Text", CellTags -> "IFPDOff"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["IFPD", RuleDelayed[ButtonData, "IFPD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "IFPD"]], 
              ", ", 
              ButtonBox["IFPDOn", RuleDelayed[ButtonData, "IFPDOn"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "IFPDOn"]], 
              "."}], "Text", CellTags -> "IFPDOff"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "IFPDOff"], Cell[CellGroupData[{Cell[BoxData[
                \(IFPD[\(\(Momentum[p]\), m\)]\)], "Input", CellTags -> 
                "IFPDOff"], Cell[BoxData[FormBox[RowBox[{FormBox["\"(\"", 
                    "TraditionalForm"], FormBox[\(p\^2\), "TraditionalForm"], 
                   FormBox["\" - \"", "TraditionalForm"], FormBox[\(m\^2\), 
                    "TraditionalForm"], FormBox["\")\"", 
                    "TraditionalForm"]}], TraditionalForm]], "Output", 
               CellTags -> "IFPDOff"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(%//StandardForm\)], "Input", CellTags -> 
                "IFPDOff"], Cell[BoxData[\(IFPD[\(\(Momentum[p]\), m\)]\)], 
               "Output", CellTags -> "IFPDOff"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(IFPDOff[\(%, p\)]\)], "Input", 
               CellTags -> "IFPDOff"], Cell[BoxData[FormBox[RowBox[
                  {SuperscriptBox[FormBox["p", "TraditionalForm"], "2"], "-", 
                   \(m\^2\)}], TraditionalForm]], "Output", CellTags -> 
                "IFPDOff"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%//StandardForm\)], "Input", CellTags -> "IFPDOff"], 
              Cell[BoxData[
                \(\(-m\^2\) + \(Pair[\(\(Momentum[p]\), \(Momentum[p]\)\)]\)
                  \)], "Output", CellTags -> "IFPDOff"]}, Open]]}, Open]], 
        Cell["IFPDOn", "ObjectName", CellTags -> "IFPDOn"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "IFPDOn"], Cell["IFPDOn[exp_,q1_, q2_, ...] changes \
from FeynAmpDenominator[ ...] representation to the IFPD one (Inverse Feynman \
Propagator Denominator). I.e., FeynAmpDenominator[PropagatorDenominator[a,b]] \
is replaced by 1/IFPD[a,b] and The q1, q2, ... are the integration momenta.", 
            "Text", CellTags -> "IFPDOn"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["IFPD", RuleDelayed[ButtonData, "IFPD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "IFPD"]], 
              ", ", 
              ButtonBox["IFPDOff", RuleDelayed[ButtonData, "IFPDOff"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "IFPDOff"]]\
, "."}], "Text", CellTags -> "IFPDOn"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["IncludePair", "ObjectName", CellTags -> "IncludePair"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "IncludePair"], Cell["IncludePair is an option for \
FC2RHI, FC2TLI and FeynAmpDenominatorSimplify. Possible settings are True and \
False.", "Text", CellTags -> "IncludePair"], Cell[TextData[{"See also: ", 
              " ", 
              ButtonBox["FC2RHI", RuleDelayed[ButtonData, "FC2RHI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FC2RHI"]], 
              ", ", 
              ButtonBox["FC2TLI", RuleDelayed[ButtonData, "FC2TLI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FC2TLI"]], 
              ", ", 
              ButtonBox["FeynAmpDenominatorSimplify", 
                RuleDelayed[ButtonData, "FeynAmpDenominatorSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynAmpDenominatorSimplify"]], "."}], 
            "Text", CellTags -> "IncludePair"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["IndexPosition", "ObjectName", 
         CellTags -> "IndexPosition"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "IndexPosition"], 
           Cell["IndexPosition is an option for FieldStrength.", "Text", 
            CellTags -> "IndexPosition"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FieldStrength", 
                RuleDelayed[ButtonData, "FieldStrength"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FieldStrength"]], "."}], "Text", 
            CellTags -> "IndexPosition"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["InitialFunction", "ObjectName", 
         CellTags -> "InitialFunction"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "InitialFunction"], Cell["InitialFunction is an option of \
FeynRule the setting of which is applied to the first argument of FeynRule \
before anything else", "Text", CellTags -> "InitialFunction"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynRule", RuleDelayed[ButtonData, "FeynRule"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynRule"]], "."}], "Text", 
            CellTags -> "InitialFunction"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["InitialSubstitutions", "ObjectName", 
         CellTags -> "InitialSubstitutions"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "InitialSubstitutions"], Cell["InitialSubstitutions \
is an option for OneLoop and OneLoopSum and Write2. All substitutions \
indicated hereby are done at the end of the calculation.", "Text", 
            CellTags -> "InitialSubstitutions"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, ", ", 
              ButtonBox["OneLoopSum", RuleDelayed[ButtonData, "OneLoopSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSum"]], ", ", 
              ButtonBox["Write2", RuleDelayed[ButtonData, "Write2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Write2"]], 
              "."}], "Text", CellTags -> "InitialSubstitutions"], 
           Cell[BoxData[""], "Input"]}, Open]], Cell["InsideDiracTrace", 
         "ObjectName", CellTags -> "InsideDiracTrace"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "InsideDiracTrace"], Cell["InsideDiracTrace is and \
option of DiracSimplify. If set to True, DiracSimplify assumes to operate \
inside a DiracTrace, i.e., products of an odd number of Dirac matrices are \
discarded. Furthermore simple traces are calculated (but divided by a factor \
4, i.e. :  DiracSimplify[DiracMatrix[a,b], InsideDiracTrace\[Rule]True]  \
yields ScalarProduct[a,b]) Traces involving more than four DiracGamma's and \
DiracGamma[5] are not performed.", "Text", CellTags -> "InsideDiracTrace"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["DiracTrace", RuleDelayed[ButtonData, "DiracTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrace"]], "."}], "Text", 
            CellTags -> "InsideDiracTrace"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["IntegralTable", "ObjectName", 
         CellTags -> "IntegralTable"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "IntegralTable"], 
           Cell["IntegralTable is an option of OneLoopSimplify, \
TwoLoopSimplify and FeynAmpDenominatorSimplify. It may be set to a list of \
the form : {FCIntegral[ ... ] \[RuleDelayed] bla, ...}.", "Text", 
            CellTags -> "IntegralTable"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoopSimplify", 
                RuleDelayed[ButtonData, "OneLoopSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSimplify"]], ", ", 
              ButtonBox["TwoLoopSimplify", 
                RuleDelayed[ButtonData, "TwoLoopSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "TwoLoopSimplify"]], ", ", 
              ButtonBox["FeynAmpDenominatorSimplify", 
                RuleDelayed[ButtonData, "FeynAmpDenominatorSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynAmpDenominatorSimplify"]], "."}], 
            "Text", CellTags -> "IntegralTable"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["IntegrateByParts", "ObjectName", 
         CellTags -> "IntegrateByParts"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "IntegrateByParts"], Cell["IntegrateByParts[(1-t)^(a Epsilon -1) \
g[t], deriv, t] does an integration by parts of the definite integral over t \
from 0 to 1.", "Text", CellTags -> "IntegrateByParts"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[IntegrateByParts]\)], 
               "Input", CellTags -> "IntegrateByParts"], Cell[BoxData[
                \(TraditionalForm\`\({Hold \[Rule] False}\)\)], "Output", 
               CellTags -> "IntegrateByParts"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "IntegrateByParts"], Cell[CellGroupData[{Cell[BoxData[
                \(IntegrateByParts[\(\(\(\((1 - t)\)^\((\(a\ Epsilon\) - 1)\)
                        \)\ \(g[t]\)\), \(
                      \((1 - t)\)^\((\(a\ Epsilon\) - 1)\)\), t\)]\)], 
               "Input", CellTags -> "IntegrateByParts"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                         \(\*SuperscriptBox["g", "\[Prime]", 
                             Rule[MultilineFunction, None]]\)(t)\)\ 
                        \((1 - t)\)\^\(a\ 
                           \*TagBox["\[CurlyEpsilon]", TraditionalForm]\)\)\/
                      \(a\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]\) + 
                     \(g(0)\)\/\(a\ \*TagBox["\[CurlyEpsilon]", 
                          TraditionalForm]\)\)\)], "Output", CellTags -> 
                "IntegrateByParts"]}, Open]]}, Open]], Cell["Integratedx", 
         "ObjectName", CellTags -> "Integratedx"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Integratedx"], Cell["Integratedx[x, low, up] is a \
variable representing the integration operator Integrate[#, {x,low,up}]&.", 
            "Text", CellTags -> "Integratedx"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynmanParametrize", 
                RuleDelayed[ButtonData, "FeynmanParametrize"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynmanParametrize"]], ", ", 
              ButtonBox["CalculateCounterTerm", 
                RuleDelayed[ButtonData, "CalculateCounterTerm"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CalculateCounterTerm"]], ", ", 
              ButtonBox["TimedIntegrate", 
                RuleDelayed[ButtonData, "TimedIntegrate"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "TimedIntegrate"]], ", ", 
              ButtonBox["HypergeometricIR", 
                RuleDelayed[ButtonData, "HypergeometricIR"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "HypergeometricIR"]], ", ", 
              ButtonBox["HypInt", RuleDelayed[ButtonData, "HypInt"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "HypInt"]], 
              ", ", 
              ButtonBox["TimedIntegrate", 
                RuleDelayed[ButtonData, "TimedIntegrate"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "TimedIntegrate"]], "."}], "Text", 
            CellTags -> "Integratedx"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["Integrate2", "ObjectName", CellTags -> "Integrate2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Integrate2"], Cell[TextData[{"Integrate2 is like \
Integrate, but : Integrate2[a_Plus, b__] := Map[Integrate2[#, b]&, a] ( more \
linear algebra and partial fraction decomposition is done) Integrate2[f[x] \
DeltaFunction[x], x] \[Rule] f[0] Integrate2[f[x] DeltaFunction[x0-x], x] \
\[Rule] f[x0]. Integrate2[f[x] DeltaFunction[a + b x], x] \[Rule] \
Integrate[f[x] (1/Abs[b]) DeltaFunction[a/b + x], x], where abs[b] \[Rule] b, \
if b is a Symbol, and if b = -c, then abs[-c] \[Rule] c, i.e., the variable \
contained in b is supposed to be positive. ", Cell[BoxData[
                \(TraditionalForm\`\(\ \[Pi]\^2\)\)]], " is replaced by 6 \
Zeta2. Integrate2[1/(1-y),{y,x,1}] is intepreted as distribution, i.e. as \
Integrate2[-1/(1-y)],{y, 0, x}] \[Rule] Log[1-y]. Integrate2[1/(1-x),{x,0,1}] \
\[Rule] 0."}], "Text", CellTags -> "Integrate2"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DeltaFunction", 
                RuleDelayed[ButtonData, "DeltaFunction"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeltaFunction"]], ", ", 
              ButtonBox["Integrate3", RuleDelayed[ButtonData, "Integrate3"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Integrate3"]], ", ", 
              ButtonBox["Integrate4", RuleDelayed[ButtonData, "Integrate4"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Integrate4"]], ", ", 
              ButtonBox["Integrate5", RuleDelayed[ButtonData, "Integrate5"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Integrate5"]], ", ", 
              ButtonBox["SumS", RuleDelayed[ButtonData, "SumS"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SumS"]], 
              ", ", 
              ButtonBox["SumT", RuleDelayed[ButtonData, "SumT"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SumT"]], 
              "."}], "Text", CellTags -> "Integrate2"], Cell["NOTE: Since \
Integrate2 does do a reordering and partial fraction decomposition before \
calling the integral table of Integrate3 it will in general be slower \
compared to Integrate3 for sums of integrals. I.e., if the integrand has \
already an expanded form and if partial fraction decomposition is not \
necessary it is more effective to use Integrate3.", "Text", 
            CellTags -> "Integrate2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Integrate2"], Cell[CellGroupData[{Cell[BoxData[
                \(\(Integrate2[\(\(\(Log[\(1 + x\)]\) 
                         \(\(Log[x]\)/\((1 - x)\)\)\), \({x, 0, 1}\)\)]\)//
                   Timing\)], "Input", CellTags -> "Integrate2"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(0.020000000000003126`\ Second\), 
                      \(\*TagBox[\(\[Zeta](
                            \(\*TagBox["3", Zeta, Rule[Editable, True]]\))\)\
, InterpretTemplate[Function[BoxForm`e$, Zeta[BoxForm`e$]]]] 
                        - \(3\/2\ \(\[Zeta](2)\)\ \(log(2)\)\)\)}\)\)], 
               "Output", CellTags -> "Integrate2"]}, Open]], 
           Cell[TextData[{"Since Integrate2 uses table-look-up methods it is \
much faster than ", StyleBox["Mathematica", Rule[FontSlant, "Italic"]], 
              "'s Integrate."}], "Text", CellTags -> "Integrate2"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(PolyLog[\(2, \(x^2\)\)]\), \({x, 0, 1}\)\)]
                  \)], "Input", CellTags -> "Integrate2"], Cell[BoxData[
                \(TraditionalForm\`\(\(\[Zeta](2)\) + \(4\ \(log(2)\)\) - 4\)
                  \)], "Output", CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(PolyLog[\(3, \(-x\)\)]\), \({x, 0, 1}\)\)]\)]\
, "Input", CellTags -> "Integrate2"], Cell[BoxData[
                \(TraditionalForm\`\(\(\[Zeta](2)\)\/2 - 
                     \(3\ \*TagBox[\(\[Zeta](
                            \(\*TagBox["3", Zeta, Rule[Editable, True]]\))\)\
, InterpretTemplate[Function[BoxForm`e$, Zeta[BoxForm`e$]]]]\
\)\/4 - \(2\ \(log(2)\)\) + 1\)\)], "Output", CellTags -> "Integrate2"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(PolyLog[\(3, \(1/\((1 + x)\)\)\)]\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> "Integrate2"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(\(-\(log(2)\)\)\ \(\[Zeta](2)\)\) + 
                     \(3\ \*TagBox[\(\[Zeta](
                            \(\*TagBox["3", Zeta, Rule[Editable, True]]\))\)\
, InterpretTemplate[Function[BoxForm`e$, Zeta[BoxForm`e$]]]]\
\)\/4 + \(\(log\^3\)(2)\)\/3 - \(\(log\^2\)(2)\) + 
                     \(2\ \(log(2)\)\)\)\)], "Output", CellTags -> 
                "Integrate2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(DeltaFunction[\(1 - x\)]\)\ \(f[x]\)\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> "Integrate2"], 
              Cell[BoxData[\(TraditionalForm\`\(f(1)\)\)], "Output", 
               CellTags -> "Integrate2"]}, Open]], 
           Cell[TextData[
             {"Integrate2 does integration in a Hadamard sense, i.e., ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\[Integral]\_0\%1 
                     \(\(f(x)\) \(\[DifferentialD] x\)\)\ \)\)]], 
              " means acutally expanding the result of ", Cell[BoxData[
                \(TraditionalForm\`\(\[Integral]\_\[Delta]\%\(1 - \[Delta]\) 
                     \(\(f(x)\) \(\[DifferentialD] x\)\)\ \)\)]], "up do ", 
              Cell[BoxData[\(TraditionalForm\`\(O(\[Delta])\)\)]], 
              " and neglecting all ", Cell[BoxData[
                \(TraditionalForm\`\[Delta]\)]], "-dependent terms. E.g. ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\(\[Integral]\_\[Delta]\%
                        \(1 - \[Delta]\) 
                       \(\(1/\((1 - x)\)\) \(\[DifferentialD] x\)\)\)\ =\ 
                     \(\(\(\(-log\) \((1 - x)\)\) 
                         \[VerticalSeparator]\_\[Delta]\%\(1 - \[Delta]\)\) =
                        \(\(\(-\(log(\[Delta])\)\) + \(log(1)\)\) \[Implies] 
                         0.\)\)\ \)\)]]}], "Text", ZeroWidthTimes -> False, 
            CellTags -> "Integrate2"], Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(1/\((1 - x)\)\), \({x, 0, 1}\)\)]\)], 
               "Input", CellTags -> "Integrate2"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> 
                "Integrate2"]}, Open]], Cell[TextData[{"In the physics \
literature sometimes the \"+\" notation is used. In FeynCalc the ", 
              Cell[BoxData[\(TraditionalForm\`\((1\/\(1 - x\))\)\_+\)]], 
              " is represented by ", Cell[BoxData[
                \(TraditionalForm\`\(PlusDistribution[\(1/\((1 - x)\)\)]\)\)]]\
, " or just ", Cell[BoxData[\(TraditionalForm\`\(1/\(\((1 - x)\)\ .\)\)\)]]}]
                , "Text", CellTags -> "Integrate2"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(PlusDistribution[\(1/\((1 - x)\)\)]\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> "Integrate2"], 
              Cell[BoxData[\(TraditionalForm\`0\)], "Output", CellTags -> 
                "Integrate2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(PolyLog[\(2, \(1 - x\)\)]\)/
                       \(\((1 - x)\)^2\)\), \({x, 0, 1}\)\)]\)], "Input", 
               CellTags -> "Integrate2"], Cell[BoxData[
                \(TraditionalForm\`\(2 - \(\[Zeta](2)\)\)\)], "Output", 
               CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\((\(Log[x]\)\ \(Log[\(1 + x\)]\))\)/
                       \((1 + x)\)\), \({x, 0, 1}\)\)]\)], "Input", 
               CellTags -> "Integrate2"], Cell[BoxData[
                \(TraditionalForm\`\(-\(\*
                        TagBox[\(\[Zeta](
                           \(\*TagBox["3", Zeta, Rule[Editable, True]]\))\), 
                         InterpretTemplate[Function[BoxForm`e$, 
                           Zeta[BoxForm`e$]]]]\/8\)\)\)], "Output", 
               CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(\(Log[x]\)^2\)/\((1 - x)\)\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> "Integrate2"], 
              Cell[BoxData[
                \(TraditionalForm\`\(2\ \*
                      TagBox[\(\[Zeta](\(
                          \*TagBox["3", Zeta, Rule[Editable, True]]\))\), 
                       InterpretTemplate[Function[BoxForm`e$, 
                         Zeta[BoxForm`e$]]]]\)\)], "Output", CellTags -> 
                "Integrate2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(PolyLog[\(2, \(-x\)\)]\)/\((1 + x)\)\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> "Integrate2"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[\(
                         \[Zeta](\(\*TagBox["3", Zeta, Rule[Editable, True]]
                           \))\), InterpretTemplate[Function[BoxForm`e$, 
                          Zeta[BoxForm`e$]]]]\/4 - 
                     \(1\/2\ \(\[Zeta](2)\)\ \(log(2)\)\)\)\)], "Output", 
               CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(Log[x]\)\ \(PolyLog[\(2, x\)]\)\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> "Integrate2"], 
              Cell[BoxData[\(TraditionalForm\`\(3 - \(2\ \(\[Zeta](2)\)\)\)\)]
                , "Output", CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(x\ \(PolyLog[\(3, x\)]\)\), \({x, 0, 1}\)\)]
                  \)], "Input", CellTags -> "Integrate2"], Cell[BoxData[
                \(TraditionalForm\`\(\(-\(\(\[Zeta](2)\)\/4\)\) + 
                     \*TagBox[\(\[Zeta](
                          \(\*TagBox["3", Zeta, Rule[Editable, True]]\))\), 
                        InterpretTemplate[Function[BoxForm`e$, 
                          Zeta[BoxForm`e$]]]]\/2 + 3\/16\)\)], "Output", 
               CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\((\(\(Log[x]\)^2\)\ \(Log[\(1 - x\)]\))\)/
                       \((1 + x)\)\), \({x, 0, 1}\)\)]\)], "Input", 
               CellTags -> "Integrate2"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(\(log\^2\)(2)\)\ \(\[Zeta](2)\)\) - 
                     \(4\ \(\(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_4(\(1\/2\))\)\) - \(\(log\^4\)(2)\)\/6 + \[Pi]\^4\/90\)\)], "Output", 
               CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(PolyLog[
                         \(2, \(\((\((\(x\ \((1 - z)\)\) + z)\)\ 
                                \((1 - x + \(x\ z\))\))\)/z\)\)]\)/
                       \((1 - x + \(x\ z\))\)\), \({x, 0, 1}\)\)]\)], 
               "Input", CellTags -> "Integrate2"], Cell[BoxData[
                FormBox[RowBox[{\(\(log\^3(z)\)\/\(6\ \((1 - z)\)\)\), "-", 
                   \(\(\(log(1 - z)\)\ \(log\^2(z)\)\)\/\(1 - z\)\), "-", 
                   \(\(\(log(z + 1)\)\ \(log\^2(z)\)\)\/\(1 - z\)\), "-", 
                   \(\(\[ImaginaryI]\ \[Pi]\ \(log\^2(z)\)\)\/
                      \(2\ \((1 - z)\)\)\), "-", 
                   \(\(\(\[Zeta](2)\)\ \(log(z)\)\)\/\(1 - z\)\), "+", 
                   \(\(4\ \(log(1 - z)\)\ \(log(z + 1)\)\ \(log(z)\)\)\/
                      \(1 - z\)\), "+", 
                   \(\(2\ \[ImaginaryI]\ \[Pi]\ \(log(z + 1)\)\ \(log(z)\)\)
                      \/\(1 - z\)\), "-", 
                   \(\(2\ \(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                   \)\_2(1 - z)\)\ \(log(z)\)\)\/\(1 - z\)\), "-", 
                   \(\(2\ \(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                   \)\_2(\(-z\))\)\ \(log(z)\)\)\/\(1 - z\)\), "-", 
                   \(\(2\ \(log\^3(z + 1)\)\)\/\(3\ \((1 - z)\)\)\), "+", 
                   \(\(\[ImaginaryI]\ \[Pi]\ \(\[Zeta](2)\)\)\/\(1 - z\)\), 
                   "+", \(\(2\ \(\[Zeta](2)\)\ \(log(1 - z)\)\)\/\(1 - z\)\), 
                   "+", \(\(2\ \(\[Zeta](2)\)\ \(log(z + 1)\)\)\/\(1 - z\)\), 
                   "-", FractionBox[RowBox[{"2", " ", RowBox[{SubscriptBox[
                         "S", RowBox[{FormBox["1", "TraditionalForm"], 
                          FormBox["2", "TraditionalForm"]}]], "(", FormBox[
                         \(1 - z\), "TraditionalForm"], ")"}]}], \(1 - z\)], 
                   "+", 
                   \(\(4\ \(log(1 - z)\)\ \(
                         \(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                   \)\_2(\(-z\))\)\)\/\(1 - z\)\), "+", 
                   \(\(2\ \[ImaginaryI]\ \[Pi]\ 
                        \(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                   \)\_2(\(-z\))\)\)\/\(1 - z\)\), "+", 
                   \(\(4\ \(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                   \)\_3(1 - z)\)\)\/\(1 - z\)\), "+", 
                   \(\(2\ \(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                   \)\_3(\(-z\))\)\)\/\(1 - z\)\), "+", 
                   \(\(4\ \(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                   \)\_3(1\/\(z + 1\))\)\)\/\(1 - z\)\), "+", 
                   \(\(4\ \(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                   \)\_3(\(-\(\(1 - z\)\/\(z + 1\)\)\))\)\)\/\(1 - z\)\), 
                   "-", 
                   \(\(4\ \(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                   \)\_3(\(1 - z\)\/\(z + 1\))\)\)\/\(1 - z\)\), "-", 
                   \(\(2\ \*TagBox[\(\[Zeta](
                            \*TagBox["3", Zeta, Rule[Editable, True]])\), 
                          InterpretTemplate[Function[BoxForm`e$, 
                            Zeta[BoxForm`e$]]]]\)\/\(1 - z\)\)}], 
                 TraditionalForm]], "Output", CellTags -> "Integrate2"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Apart[\(\(Integrate2[\(
                        \(\(x^\((OPEm - 1)\)\)\ \(PolyLog[\(3, \(1 - x\)\)]\)
                          \), \({x, 0, 1}\)\)]\), OPEm\)]\)], "Input", 
               CellTags -> "Integrate2"], Cell[BoxData[FormBox[RowBox[{
                   \(-\(\(\[Zeta](2)\)\/\(m - 1\)\)\), "-", 
                   \(\(\[Zeta](2)\)\/m\^2\), "+", FractionBox[RowBox[
                     {RowBox[{RowBox[{"-", RowBox[{\(S\_1\), "(", FormBox[
                          \(m - 2\), "TraditionalForm"], ")"}]}], " ", 
                        \(\[Zeta](2)\)}], "+", \(\[Zeta](2)\), "+", RowBox[{
                        \(S\_12\), "(", FormBox["m", "TraditionalForm"], 
                        ")"}], "+", 
                      TagBox[\(\[Zeta](\*TagBox["3", Zeta, 
                            Rule[Editable, True]])\), 
                        InterpretTemplate[Function[BoxForm`e$, 
                          Zeta[BoxForm`e$]]]]}], "m"]}], TraditionalForm]], 
               "Output", CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Integrate2[\(\(\(x^\((OPEm - 1)\)\)\ \(Log[\(1 - x\)]\)\ 
                         \(Log[x]\)\ \(Log[\(1 + x\)]\)\/\(1 + x\)\), 
                       \({x, 0, 1}\)\)]\)//Simplify\)], "Input", CellTags -> 
                "Integrate2"], Cell[BoxData[FormBox[RowBox[{\(1\/360\), " ", 
                   \(\((\(-1\))\)\^m\), " ", RowBox[{"(", RowBox[
                      {RowBox[{"90", " ", \(\[Zeta](2)\), " ", RowBox[{
                          \(S\_\(-1\)\%2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "+", RowBox[{"180", 
                         " ", 
                         \((\(\(\[Zeta](2)\)\ \(log(8)\)\) - 
                             \(2\ \*TagBox[\(\[Zeta](
                                   \*TagBox["3", Zeta, Rule[Editable, True]]
                                   )\), InterpretTemplate[Function[
                                   BoxForm`e$, Zeta[BoxForm`e$]]]]\))\), " ", 
                         RowBox[{\(S\_\(-1\)\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "-", RowBox[{"180", 
                         " ", RowBox[{\(S\_\(-2\)\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}], " ", RowBox[{"(", 
                          RowBox[{\(\[Zeta](2)\), "-", RowBox[{\(log(4)\), 
                          " ", RowBox[{\(S\_\(-1\)\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "-", \(log\^2(2)\)}], 
                          ")"}]}], "-", RowBox[{"540", " ", \(\[Zeta](2)\), 
                         " ", \(log(2)\), " ", RowBox[{\(S\_1\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], "+", 
                       RowBox[{"270", " ", \(\[Zeta](2)\), " ", RowBox[{
                          \(S\_2\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "-", RowBox[{"180", 
                         " ", \(log\^2(2)\), " ", RowBox[{\(S\_2\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                       "+", RowBox[{"360", " ", \(log(2)\), " ", RowBox[{
                          \(S\_3\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "-", RowBox[{"360", 
                         " ", \(log(2)\), " ", RowBox[{\(S\_\(-21\)\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                       "-", RowBox[{"360", " ", \(log(2)\), " ", RowBox[{
                          \(S\_\(-12\)\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "-", RowBox[{"360", 
                         " ", \(\[Zeta](2)\), " ", RowBox[{\(S\_\(1 - 1\)\), 
                          "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], "+", RowBox[{"360", " ", RowBox[{
                          \(S\_\(\(-2\) - 1 - 1\)\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "+", RowBox[{"360", 
                         " ", RowBox[{\(S\_\(\(-1\) - 2 - 1\)\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], "+", 
                       RowBox[{"360", " ", RowBox[{\(S\_\(\(-1\) - 1 - 2\)\), 
                          "(", FormBox[\(m - 1\), "TraditionalForm"], 
                          ")"}]}], "+", RowBox[{"360", " ", RowBox[{
                          \(S\_\(1 - 21\)\), "(", FormBox[\(m - 1\), 
                          "TraditionalForm"], ")"}]}], "+", RowBox[{"360", 
                         " ", RowBox[{\(S\_\(1 - 12\)\), "(", FormBox[
                          \(m - 1\), "TraditionalForm"], ")"}]}], "+", 
                       RowBox[{"360", " ", RowBox[{\(S\_\(2 - 11\)\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}]}], 
                       "+", RowBox[{"585", " ", RowBox[{\(S\_1\), "(", 
                          FormBox[\(m - 1\), "TraditionalForm"], ")"}], " ", 
                         TagBox[\(\[Zeta](\*TagBox["3", Zeta, 
                               Rule[Editable, True]])\), 
                           InterpretTemplate[Function[BoxForm`e$, 
                             Zeta[BoxForm`e$]]]]}], "-", 
                       \(945\ \(log(2)\)\ \*TagBox[\(
                             \[Zeta](\*TagBox["3", Zeta, 
                                Rule[Editable, True]])\), 
                            InterpretTemplate[Function[BoxForm`e$, 
                              Zeta[BoxForm`e$]]]]\), "-", 
                       \(720\ \(\(\*InterpretationBox["Li", PolyLog, 
                                Rule[Editable, False], 
                                Rule[Selectable, False]]\)\_4(1\/2)\)\), "-", 
                       \(30\ \(log\^4(2)\)\), "+", 
                       \(450\ \(\[Zeta](2)\)\ \(log\^2(2)\)\), "+", 
                       \(8\ \[Pi]\^4\)}], ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%\ /.\ \(OPEm \[Rule] 2\)\)], 
               "Input", CellTags -> "Integrate2"], Cell[BoxData[
                \(TraditionalForm\`\(1\/360\ 
                     \((\(450\ \(\(log\^2\)(2)\)\ \(\[Zeta](2)\)\) - 
                        \(540\ \(log(2)\)\ \(\[Zeta](2)\)\) + 
                        \(720\ \(\[Zeta](2)\)\) + 
                        \(180\ \((\(\[Zeta](2)\) + \(log(4)\) - 
                             \(\(log\^2\)(2)\))\)\) - 
                        \(180\ \((\(\(\[Zeta](2)\)\ \(log(8)\)\) - 
                             \(2\ \*TagBox[\(
                                  \[Zeta](
                                   \(\*TagBox["3", Zeta, 
                                     Rule[Editable, True]]\))\), 
                                 InterpretTemplate[Function[BoxForm`e$, 
                                   Zeta[BoxForm`e$]]]]\))\)\) - 
                        \(945\ \(log(2)\)\ 
                          \*TagBox[\(\[Zeta](
                              \(\*TagBox["3", Zeta, Rule[Editable, True]]\))
                \), InterpretTemplate[Function[BoxForm`e$, 
                              Zeta[BoxForm`e$]]]]\) + 
                        \(585\ \*TagBox[\(
                             \[Zeta](\(\*
                                TagBox["3", Zeta, Rule[Editable, True]]\))\)\
, InterpretTemplate[Function[BoxForm`e$, Zeta[BoxForm`e$]]]]\
\) - \(720\ \(\(\*InterpretationBox["Li", PolyLog, 
                                Rule[Editable, False], 
                                Rule[Selectable, False]]\)\_4(\(1\/2\))\)\) -
                         \(30\ \(\(log\^4\)(2)\)\) - 
                        \(180\ \(\(log\^2\)(2)\)\) + \(1080\ \(log(2)\)\) + 
                        \(8\ \[Pi]\^4\) - 2160)\)\)\)], "Output", CellTags -> 
                "Integrate2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(N[%]\)], "Input", CellTags -> "Integrate2"], Cell[BoxData[
                \(TraditionalForm\`0.05051383540274483`\)], "Output", 
               CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(NIntegrate[\ \(\(x\ \(Log[\(1 - x\)]\)\ \(Log[x]\)\ 
                       \(Log[\(1 + x\)]\)\/\(1 + x\)\), \({x, 0, 1}\)\)]\)], 
               "Input"], Cell[BoxData[
                \(TraditionalForm\`0.05051383539827197`\)], "Output"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(x^\((OPEm - 1)\)\)\ 
                       \((\(PolyLog[\(3, \(1 - x\)\/\(1 + x\)\)]\) - 
                          \(PolyLog[\(3, \(-\(\(1 - x\)\/\(1 + x\)\)\)\)]\))\
\)\), \({x, 0, 1}\)\)]\)], "Input", CellTags -> "Integrate2"], 
              Cell[BoxData[FormBox[RowBox[{FractionBox[RowBox[{
                      \(\((\(-1\))\)\^m\), " ", RowBox[{\(S\_\(-1\)\), "(", 
                        FormBox["m", "TraditionalForm"], ")"}], " ", 
                      \(\[Zeta](2)\)}], "m"], "-", FractionBox[RowBox[
                     {RowBox[{\(S\_\(-1\)\), "(", FormBox["m", 
                         "TraditionalForm"], ")"}], " ", \(\[Zeta](2)\)}], 
                    \(2\ m\)], "+", FractionBox[RowBox[{\(\((\(-1\))\)\^m\), 
                      " ", RowBox[{\(S\_1\), "(", FormBox["m", 
                         "TraditionalForm"], ")"}], " ", \(\[Zeta](2)\)}], 
                    \(2\ m\)], "-", FractionBox[RowBox[{RowBox[{\(S\_1\), 
                        "(", FormBox["m", "TraditionalForm"], ")"}], " ", 
                      \(\[Zeta](2)\)}], "m"], "+", 
                   \(\(3\ \((\(-1\))\)\^m\ \(log(2)\)\ \(\[Zeta](2)\)\)\/
                      \(2\ m\)\), "-", 
                   \(\(3\ \(log(2)\)\ \(\[Zeta](2)\)\)\/\(2\ m\)\), "+", 
                   FractionBox[RowBox[{\(\((\(-1\))\)\^m\), " ", RowBox[{
                        \(S\_\(-3\)\), "(", FormBox["m", "TraditionalForm"], 
                        ")"}]}], "m"], "+", FractionBox[RowBox[{
                      \(\((\(-1\))\)\^m\), " ", RowBox[{\(S\_\(-2\)\), "(", 
                        FormBox["m", "TraditionalForm"], ")"}], " ", RowBox[{
                        \(S\_1\), "(", FormBox["m", "TraditionalForm"], 
                        ")"}]}], "m"], "+", FractionBox[RowBox[{RowBox[{
                        \(S\_1\), "(", FormBox["m", "TraditionalForm"], 
                        ")"}], " ", RowBox[{\(S\_2\), "(", FormBox["m", 
                         "TraditionalForm"], ")"}]}], "m"], "+", FractionBox[
                    RowBox[{\(S\_3\), "(", FormBox["m", "TraditionalForm"], 
                      ")"}], "m"], "-", FractionBox[RowBox[{
                      \(\((\(-1\))\)\^m\), " ", RowBox[{\(S\_\(-21\)\), "(", 
                        FormBox["m", "TraditionalForm"], ")"}]}], "m"], "-", 
                   FractionBox[RowBox[{\(S\_\(\(-1\) - 2\)\), "(", FormBox[
                       "m", "TraditionalForm"], ")"}], "m"], "-", FractionBox[
                    RowBox[{\(\((\(-1\))\)\^m\), " ", RowBox[{\(S\_\(-12\)\), 
                        "(", FormBox["m", "TraditionalForm"], ")"}]}], "m"], 
                   "-", FractionBox[RowBox[{\(S\_21\), "(", FormBox["m", 
                       "TraditionalForm"], ")"}], "m"], "-", 
                   \(\(7\ \((\(-1\))\)\^m\ 
                        \*TagBox[\(\[Zeta](
                            \*TagBox["3", Zeta, Rule[Editable, True]])\), 
                          InterpretTemplate[Function[BoxForm`e$, 
                            Zeta[BoxForm`e$]]]]\)\/\(8\ m\)\), "+", 
                   \(\(21\ \*TagBox[\(\[Zeta](
                            \*TagBox["3", Zeta, Rule[Editable, True]])\), 
                          InterpretTemplate[Function[BoxForm`e$, 
                            Zeta[BoxForm`e$]]]]\)\/\(8\ m\)\)}], 
                 TraditionalForm]], "Output", CellTags -> "Integrate2"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%/.\(OPEm \[Rule] 3\)\)], "Input"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(-\(log(2)\)\)\ \(\[Zeta](2)\)\) - 
                     \(\[Zeta](2)\)\/2 + 
                     \(7\ \*TagBox[\(\[Zeta](
                            \(\*TagBox["3", Zeta, Rule[Editable, True]]\))\)\
, InterpretTemplate[Function[BoxForm`e$, Zeta[BoxForm`e$]]]]\
\)\/6 + 2\/3\)\)], "Output"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(N[%]\)], "Input"], Cell[BoxData[
                \(TraditionalForm\`0.1064179429525609`\)], "Output"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(NIntegrate[\(\(\(x^\((3 - 1)\)\)\ 
                       \((\(PolyLog[\(3, \(1 - x\)\/\(1 + x\)\)]\) - 
                          \(PolyLog[\(3, \(-\(\(1 - x\)\/\(1 + x\)\)\)\)]\))\
\)\), \({x, 0, 1}\)\)]\)], "Input"], Cell[BoxData[
                \(TraditionalForm\`0.10641794295771248`\)], "Output"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DataType[\(OPEm, PositiveInteger\)]\)], "Input", 
               CellTags -> "Integrate2"], Cell[BoxData[
                \(TraditionalForm\`True\)], "Output", CellTags -> 
                "Integrate2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(x^\((OPEm - 1)\)\)\ 
                       \(DeltaFunction[\(1 - x\)]\)\), \({x, 0, 1}\)\)]\)], 
               "Input", CellTags -> "Integrate2"], Cell[BoxData[
                \(TraditionalForm\`1\)], "Output", CellTags -> 
                "Integrate2"]}, Open]], Cell["This is the polarized \
non-singlet spin splitting function whose first moment vanishes.", "Text", 
            CellTags -> "Integrate2"], Cell[CellGroupData[{Cell[BoxData[
                \(t = \(SplittingFunction[PQQNS]\)\)], "Input", CellTags -> 
                "Integrate2"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{RowBox[{"(", RowBox[{
                         \(\(-4\)\ \((x + 1)\)\ \(log\^2(x)\)\), "-", 
                         \(8\ \((\(2\ x\) + 3\/\(1 - x\))\)\ \(log(x)\)\), 
                         "-", 
                         \(\(16\ \((x\^2 + 1)\)\ \(log(1 - x)\)\ \(log(x)\)\)
                            \/\(1 - x\)\), "-", \(40\ \((1 - x)\)\), "+", 
                         RowBox[{RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}], " ", 
                          \((\(\(-24\)\ \(\[Zeta](2)\)\) + 
                              \(48\ \*TagBox[\(
                                   \[Zeta](\*TagBox["3", Zeta, 
                                      Rule[Editable, True]])\), 
                                  InterpretTemplate[Function[BoxForm`e$, 
                                    Zeta[BoxForm`e$]]]]\) + 3)\)}]}], ")"}], 
                     " ", \(C\_F\%2\)}], "+", RowBox[{\(N\_f\), " ", 
                     RowBox[{"(", RowBox[{\(\(88\ x\)\/9\), "+", RowBox[{
                          \((\(-\(\(16\ \(\[Zeta](2)\)\)\/3\)\) - 2\/3)\), 
                          " ", RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}]}], "-", 
                         \(\(8\ \((x\^2 + 1)\)\ \(log(x)\)\)\/
                            \(3\ \((1 - x)\)\)\), "-", 
                         \(80\/9\ \(\((1\/\(1 - x\))\)\_+\)\), "-", \(8\/9\)}]
                         , ")"}], " ", \(C\_F\)}], "-", 
                   \(8\ \((C\_F - C\_A\/2)\)\ 
                      \((\(4\ \((1 - x)\)\) + \(2\ \((x + 1)\)\ \(log(x)\)\) 
                         + \(\((x\^2 + 1)\)\ 
                            \((\(log\^2(x)\) - 
                               \(4\ \(log(x + 1)\)\ \(log(x)\)\) - 
                               \(2\ \(\[Zeta](2)\)\) - 
                               \(4\ \(\(\*InterpretationBox["Li", PolyLog, 
                                       Rule[Editable, False], 
                                       Rule[Selectable, False]]\)\_2(\(-x\))\
\)\))\)\)\/\(x + 1\))\)\ C\_F\), "+", RowBox[{\(C\_A\), " ", RowBox[
                      {"(", RowBox[{
                         \(\(4\ \((x\^2 + 1)\)\ \(log\^2(x)\)\)\/\(1 - x\)\), 
                         "-", 
                         \(4\/3\ \((\(5\ x\) - 22\/\(1 - x\) + 5)\)\ 
                            \(log(x)\)\), "+", \(4\/9\ \((53 - \(187\ x\))\)\)
                         , "+", \(8\ \((x + 1)\)\ \(\[Zeta](2)\)\), "+", 
                         \(\((536\/9 - \(16\ \(\[Zeta](2)\)\))\)\ 
                            \(\((1\/\(1 - x\))\)\_+\)\), "+", RowBox[
                          {RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}], " ", 
                          \((\(88\ \(\[Zeta](2)\)\)\/3 - 
                              \(24\ \*TagBox[\(
                                   \[Zeta](\*TagBox["3", Zeta, 
                                      Rule[Editable, True]])\), 
                                  InterpretTemplate[Function[BoxForm`e$, 
                                    Zeta[BoxForm`e$]]]]\) + 17\/3)\)}]}], 
                       ")"}], " ", \(C\_F\)}]}], TraditionalForm]], "Output", 
               CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Integrate2[\(t, \({x, 0, 1}\)\)]\)//Timing\)], "Input", 
               CellTags -> "Integrate2"], Cell[BoxData[
                \(TraditionalForm\`\({\(0.24099999999999966`\ Second\), 0}\)
                  \)], "Output", CellTags -> "Integrate2"]}, Open]], 
           Cell["Expanding t with respect to x yields a form already suitable \
for Integrate3 and therefore the following is faster:", "Text", 
            CellTags -> "Integrate2"], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(Integrate3[\(\(Expand[\(t, x\)]\), \({x, 0, 1}\)\)]\)//
                     Expand\)//Timing\)], "Input", CellTags -> "Integrate2"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(0.04999999999999716`\ Second\), 0}\)
                  \)], "Output", CellTags -> "Integrate2"]}, Open]], 
           Cell[BoxData[\(\(Clear[t]\) ;\)], "Input", CellTags -> 
             "Integrate2"], Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(DeltaFunction[\(1 - x\)]\)\ \(f[x]\)\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> "Integrate2"], 
              Cell[BoxData[\(TraditionalForm\`\(f(1)\)\)], "Output", 
               CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(x\^5 \(\(Log[\(1 + x\)]\)^2\)\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> "Integrate2"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(-\(6959\/10800\)\) + 
                     \(46\ \(log(2)\)\)\/45\)\)], "Output", CellTags -> 
                "Integrate2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(N @ %\)], "Input", CellTags -> "Integrate2"], Cell[BoxData[
                \(TraditionalForm\`0.06419859938720329`\)], "Output", 
               CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(NIntegrate[\(\(x\^5 \(\(Log[\(1 + x\)]\)^2\)\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> "Integrate2"], 
              Cell[BoxData[\(TraditionalForm\`0.06419859938720235`\)], 
               "Output", CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(\(x^\((OPEm - 1)\)\) \(Log[\(1 + x\)]\)\^2\)
                     , \({x, 0, 1}\)\)]\)], "Input", CellTags -> 
                "Integrate2"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"-", FractionBox[RowBox[{"2", " ", 
                        \(\((\(-1\))\)\^m\), " ", RowBox[{\(S\_1\%2\), "(", 
                          FormBox["m", "TraditionalForm"], ")"}]}], "m"]}], 
                   "+", FractionBox[RowBox[{\(\((\(-1\))\)\^m\), " ", RowBox[{
                        \(S\_1\), "(", FormBox[\(\(m - 1\)\/2\), 
                         "TraditionalForm"], ")"}], " ", RowBox[{\(S\_1\), 
                        "(", FormBox["m", "TraditionalForm"], ")"}]}], "m"], 
                   "-", FractionBox[RowBox[{RowBox[{\(S\_1\), "(", FormBox[
                         \(\(m - 1\)\/2\), "TraditionalForm"], ")"}], " ", 
                      RowBox[{\(S\_1\), "(", FormBox["m", "TraditionalForm"], 
                        ")"}]}], "m"], "+", FractionBox[RowBox[{
                      \(\((\(-1\))\)\^m\), " ", RowBox[{\(S\_1\), "(", 
                        FormBox[\(m\/2\), "TraditionalForm"], ")"}], " ", 
                      RowBox[{\(S\_1\), "(", FormBox["m", "TraditionalForm"], 
                        ")"}]}], "m"], "+", FractionBox[RowBox[{RowBox[{
                        \(S\_1\), "(", FormBox[\(m\/2\), "TraditionalForm"], 
                        ")"}], " ", RowBox[{\(S\_1\), "(", FormBox["m", 
                         "TraditionalForm"], ")"}]}], "m"], "+", FractionBox[
                    RowBox[{"4", " ", \(\((\(-1\))\)\^m\), " ", \(log(2)\), 
                      " ", RowBox[{\(S\_1\), "(", FormBox["m", 
                         "TraditionalForm"], ")"}]}], "m"], "-", FractionBox[
                    RowBox[{\(\((\(-1\))\)\^m\), " ", \(log(2)\), " ", 
                      RowBox[{\(S\_1\), "(", FormBox[\(\(m - 1\)\/2\), 
                         "TraditionalForm"], ")"}]}], "m"], "+", FractionBox[
                    RowBox[{\(log(2)\), " ", RowBox[{\(S\_1\), "(", FormBox[
                         \(\(m - 1\)\/2\), "TraditionalForm"], ")"}]}], "m"], 
                   "-", FractionBox[RowBox[{\(\((\(-1\))\)\^m\), " ", 
                      \(log(2)\), " ", RowBox[{\(S\_1\), "(", FormBox[\(m\/2\)
                         , "TraditionalForm"], ")"}]}], "m"], "-", 
                   FractionBox[RowBox[{\(log(2)\), " ", RowBox[{\(S\_1\), 
                        "(", FormBox[\(m\/2\), "TraditionalForm"], ")"}]}], 
                    "m"], "+", FractionBox[RowBox[{\(\((\(-1\))\)\^m\), " ", 
                      RowBox[{\(S\_2\), "(", FormBox[\(\(m - 1\)\/2\), 
                         "TraditionalForm"], ")"}]}], \(2\ m\)], "-", 
                   FractionBox[RowBox[{\(S\_2\), "(", FormBox[\(\(m - 1\)\/2\)
                       , "TraditionalForm"], ")"}], \(2\ m\)], "+", 
                   FractionBox[RowBox[{\(\((\(-1\))\)\^m\), " ", RowBox[{
                        \(S\_2\), "(", FormBox[\(m\/2\), "TraditionalForm"], 
                        ")"}]}], \(2\ m\)], "+", FractionBox[RowBox[{\(S\_2\)
                      , "(", FormBox[\(m\/2\), "TraditionalForm"], ")"}], 
                    \(2\ m\)], "-", FractionBox[RowBox[{"2", " ", 
                      \(\((\(-1\))\)\^m\), " ", RowBox[{\(S\_2\), "(", 
                        FormBox["m", "TraditionalForm"], ")"}]}], "m"], "-", 
                   FractionBox[RowBox[{"2", " ", \(\((\(-1\))\)\^m\), " ", 
                      RowBox[{\(S\_\(-11\)\), "(", FormBox["m", 
                         "TraditionalForm"], ")"}]}], "m"], "-", 
                   \(\(\((\(-1\))\)\^m\ \(log\^2(2)\)\)\/m\), "+", 
                   \(\(log\^2(2)\)\/m\)}], TraditionalForm]], "Output", 
               CellTags -> "Integrate2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%/.\(OPEm \[Rule] 4\)\)], 
               "Input"], Cell[BoxData[
                \(TraditionalForm\`\(\(-\(241\/288\)\) + \(4\ \(log(2)\)\)\/3
                    \)\)], "Output"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(N[%]\)], "Input"], Cell[BoxData[
                \(TraditionalForm\`0.0873906851910381`\)], "Output"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(NIntegrate[\(\(\(x^\((4 - 1)\)\) \(Log[\(1 + x\)]\)\^2\), 
                     \({x, 0, 1}\)\)]\)], "Input"], Cell[BoxData[
                \(TraditionalForm\`0.08739068519103732`\)], "Output"]}, 
             Open]]}, Open]], Cell["Integrate3", "ObjectName", 
         CellTags -> "Integrate3"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Integrate3"], 
           Cell["Integrate3 contains the integral table used by Integrate2. \
Integration is performed in a distributional sense. Integrate3 works more \
effectively on a sum of expressions if they are expanded or collected with \
respect to the integration variable. See the examples in Integrate2.", 
            "Text", CellTags -> "Integrate3"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Integrate2", RuleDelayed[ButtonData, "Integrate2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Integrate2"]], "."}], "Text", 
            CellTags -> "Integrate3"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Integrate3"], Cell[CellGroupData[{Cell[BoxData[
                \(Integrate3[\(\(x\^OPEm\ \(Log[x]\)\), \({x, 0, 1}\)\)]\)], 
               "Input", CellTags -> "Integrate3"], Cell[BoxData[
                \(TraditionalForm\`\(-\(1\/\((m + 1)\)\^2\)\)\)], "Output", 
               CellTags -> "Integrate3"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate3[\(\(x\^OPEm\ \(Log[x]\)\ \(Log[\(1 - x\)]\)\)\/
                      \(1 - x\), \({x, 0, 1}\)\)]\)], "Input", CellTags -> 
                "Integrate3"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(\[Zeta](2)\), " ", RowBox[{\(S\_1\), "(", FormBox["m", 
                        "TraditionalForm"], ")"}]}], "-", RowBox[{\(S\_12\), 
                     "(", FormBox["m", "TraditionalForm"], ")"}], "-", 
                   RowBox[{\(S\_21\), "(", FormBox["m", "TraditionalForm"], 
                     ")"}], "+", 
                   TagBox[\(\[Zeta](\*TagBox["3", Zeta, 
                         Rule[Editable, True]])\), 
                     InterpretTemplate[Function[BoxForm`e$, 
                       Zeta[BoxForm`e$]]]]}], TraditionalForm]], "Output", 
               CellTags -> "Integrate3"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate3[\(\(\(a \(x\^OPEm\ \(Log[x]\)\ 
                            \(Log[\(1 - x\)]\)\)\/\(1 - x\)\) + 
                       \(b \(x\^OPEm \(PolyLog[\(3, \(-x\)\)]\)\)\/\(1 + x\)
                        \)\), \({x, 0, 1}\)\)]\)], "Input", CellTags -> 
                "Integrate3"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"a", " ", RowBox[{"(", RowBox[{RowBox[{
                          \(\[Zeta](2)\), " ", RowBox[{\(S\_1\), "(", FormBox[
                          "m", "TraditionalForm"], ")"}]}], "-", RowBox[{
                          \(S\_12\), "(", FormBox["m", "TraditionalForm"], 
                          ")"}], "-", RowBox[{\(S\_21\), "(", FormBox["m", 
                          "TraditionalForm"], ")"}], "+", 
                         TagBox[\(\[Zeta](\*TagBox["3", Zeta, 
                               Rule[Editable, True]])\), 
                           InterpretTemplate[Function[BoxForm`e$, 
                             Zeta[BoxForm`e$]]]]}], ")"}]}], "+", RowBox[{
                     \(\((\(-1\))\)\^m\), " ", "b", " ", RowBox[{"(", RowBox[{
                         \(\(\[Zeta](2)\)\^2\/8\), "+", RowBox[{\(1\/2\), 
                          " ", RowBox[{\(S\_\(-2\)\), "(", FormBox["m", 
                          "TraditionalForm"], ")"}], " ", \(\[Zeta](2)\)}], 
                         "+", RowBox[{\(log(2)\), " ", RowBox[{"(", RowBox[
                          {RowBox[{\(S\_3\), "(", FormBox["m", 
                          "TraditionalForm"], ")"}], "-", RowBox[{
                          \(S\_\(-3\)\), "(", FormBox["m", 
                          "TraditionalForm"], ")"}]}], ")"}]}], "+", RowBox[{
                          \(S\_\(3 - 1\)\), "(", FormBox["m", 
                          "TraditionalForm"], ")"}], "-", RowBox[{\(3\/4\), 
                          " ", RowBox[{\(S\_\(-1\)\), "(", FormBox["m", 
                          "TraditionalForm"], ")"}], " ", 
                          TagBox[\(\[Zeta](\*TagBox["3", Zeta, 
                                Rule[Editable, True]])\), 
                            InterpretTemplate[Function[BoxForm`e$, 
                              Zeta[BoxForm`e$]]]]}], "-", 
                         \(3\/4\ \(log(2)\)\ \*
                             TagBox[\(\[Zeta](
                                \*TagBox["3", Zeta, Rule[Editable, True]])\)\
, InterpretTemplate[Function[BoxForm`e$, 
                                Zeta[BoxForm`e$]]]]\)}], ")"}]}]}], 
                 TraditionalForm]], "Output", CellTags -> "Integrate3"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Integrate3[\(\(DeltaFunctionPrime[\(1 - x\)]\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> "Integrate3"], 
              Cell[BoxData[\(TraditionalForm\`0\)], "Output", CellTags -> 
                "Integrate3"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Integrate3[\(\(\(f[x]\)\ \(DeltaFunctionPrime[\(1 - x\)]\)
                      \), \({x, 0, 1}\)\)]\)], "Input", CellTags -> 
                "Integrate3"], Cell[BoxData[
                \(TraditionalForm\`\(\(\*
                       SuperscriptBox["f", "\[Prime]", 
                        Rule[MultilineFunction, None]]\)(1)\)\)], "Output", 
               CellTags -> "Integrate3"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate3[\(\(1/\((1 - x)\)\), \({x, 0, 1}\)\)]\)], 
               "Input", CellTags -> "Integrate3"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> 
                "Integrate3"]}, Open]]}, Open]], Cell["Integrate4", 
         "ObjectName", CellTags -> "Integrate4"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Integrate4"], Cell["Integrate4 is like Integrate5, \
but interruptable if $VeryVerbose > 2.", "Text", CellTags -> "Integrate4"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Integrate2", RuleDelayed[ButtonData, "Integrate2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Integrate2"]], ", ", 
              ButtonBox["Integrate5", RuleDelayed[ButtonData, "Integrate5"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Integrate5"]], "."}], "Text", 
            CellTags -> "Integrate4"], Cell[BoxData[""], "Input", 
            CellTags -> "Integrate4"]}, Open]], Cell["Integrate5", 
         "ObjectName", CellTags -> "Integrate5"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Integrate5"], Cell["Integrate5 is an alternative \
implementation along the lines of Integrate2.", "Text", CellTags -> 
             "Integrate5"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Integrate2", RuleDelayed[ButtonData, "Integrate2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Integrate2"]], ", ", 
              ButtonBox["Integrate4", RuleDelayed[ButtonData, "Integrate4"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Integrate4"]], "."}], "Text", 
            CellTags -> "Integrate5"], Cell[BoxData[""], "Input", 
            CellTags -> "Integrate5"]}, Open]], 
        Cell["IntermediateSubstitutions", "ObjectName", 
         CellTags -> "IntermediateSubstitutions"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "IntermediateSubstitutions"], Cell["IntermediateSubst\
itutions is an option for OneLoop. All substitutions indicated hereby are \
done at an intermediate stage of the calculation.", "Text", 
            CellTags -> "IntermediateSubstitutions"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, "."}], "Text", CellTags -> "IntermediateSubstitutions"], 
           Cell[BoxData[""], "Input"]}, Open]], Cell["InverseMellin", 
         "ObjectName", CellTags -> "InverseMellin"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "InverseMellin"], Cell[TextData[{"InverseMellin[exp, \
y] performs the inverse Mellin transform of polynomials in OPEm. The inverse \
transforms are not calculated but a table-lookup is done. WARNING: do not \
\"trust\" the results for the inverse Mellin transform involving SumT's; \
there is an unresolved inconsistency here (related to ", Cell[BoxData[
                \(TraditionalForm\`\(\(\((\(-1\))\)^m)\) .\)\)]]}], "Text", 
            CellTags -> "InverseMellin"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DeltaFunction", 
                RuleDelayed[ButtonData, "DeltaFunction"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeltaFunction"]], ", ", 
              ButtonBox["Integrate2", RuleDelayed[ButtonData, "Integrate2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Integrate2"]], ", ", 
              ButtonBox["OPEm", RuleDelayed[ButtonData, "OPEi"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SumS"]], 
              ", ", 
              ButtonBox["SumS", RuleDelayed[ButtonData, "SumS"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SumS"]], 
              ", ", 
              ButtonBox["SumT", RuleDelayed[ButtonData, "SumT"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SumT"]], 
              "."}], "Text", CellTags -> "InverseMellin"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "InverseMellin"], Cell[CellGroupData[{Cell[BoxData[
                \(InverseMellin[\(\(1/OPEm\), y\)]\)], "Input", CellTags -> 
                "InverseMellin"], Cell[BoxData[
                \(TraditionalForm\`\(y\^\(m - 1\)\)\)], "Output", CellTags -> 
                "InverseMellin"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(InverseMellin[\(\(1/\((OPEm + 3)\)\), y\)]\)], "Input", 
               CellTags -> "InverseMellin"], Cell[BoxData[
                \(TraditionalForm\`\(y\^\(m + 2\)\)\)], "Output", CellTags -> 
                "InverseMellin"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(InverseMellin[\(1, y\)]\)], "Input", CellTags -> 
                "InverseMellin"], Cell[BoxData[FormBox[RowBox[{
                   \(y\^\(m - 1\)\), " ", RowBox[{"\[Delta]", "(", FormBox[
                      \(1 - y\), "TraditionalForm"], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "InverseMellin"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(InverseMellin[\(\(1/\(OPEm^4\)\), y\)]\)], "Input", 
               CellTags -> "InverseMellin"], Cell[BoxData[
                \(TraditionalForm\`\(\(-\(1\/6\)\)\ y\^\(m - 1\)\ 
                     \(\(log\^3\)(y)\)\)\)], "Output", CellTags -> 
                "InverseMellin"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(InverseMellin[\(\(\(1/OPEm\) + 1\), y\)]\)], "Input", 
               CellTags -> "InverseMellin"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{RowBox[{"\[Delta]", "(", FormBox[\(1 - y\), 
                        "TraditionalForm"], ")"}], " ", \(y\^\(m - 1\)\)}], 
                   "+", \(y\^\(m - 1\)\)}], TraditionalForm]], "Output", 
               CellTags -> "InverseMellin"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(InverseMellin[\(\(\(1/i\) + 1\), y, i\)]\)], "Input", 
               CellTags -> "InverseMellin"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{RowBox[{"\[Delta]", "(", FormBox[\(1 - y\), 
                        "TraditionalForm"], ")"}], " ", \(y\^\(i - 1\)\)}], 
                   "+", \(y\^\(i - 1\)\)}], TraditionalForm]], "Output", 
               CellTags -> "InverseMellin"]}, Open]], Cell["The inverse \
operation to InverseMellin is done by Integrate2.", "Text", 
            CellTags -> "InverseMellin"], Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(InverseMellin[\(\(1/OPEm\), y\)]\), 
                     \({y, 0, 1}\)\)]\)], "Input", CellTags -> 
                "InverseMellin"], Cell[BoxData[\(TraditionalForm\`\(1\/m\)\)]
                , "Output", CellTags -> "InverseMellin"]}, Open]], 
           Cell["Below is a list of all built-in basic inverse Mellin \
transforms .", "Text", CellTags -> "InverseMellin"], Cell[BoxData[
             \(\(list = \({1, 1\/\(OPEm + n\), 1\/\(\(-OPEm\) + n\), 
                     \(PolyGamma[\(0, OPEm\)]\), 
                     \(SumS[\(1, \(\(-1\) + OPEm\)\)]\), 
                     \(SumS[\(1, \(\(-1\) + OPEm\)\)]\)\/\(OPEm - 1\), 
                     \(SumS[\(1, \(\(-1\) + OPEm\)\)]\)\/\(1 - OPEm\), 
                     \(SumS[\(1, \(\(-1\) + OPEm\)\)]\)\/\(OPEm + 1\), 
                     \(SumS[\(1, \(\(-1\) + OPEm\)\)]\)\/OPEm\^2, 
                     \(SumS[\(1, \(\(-1\) + OPEm\)\)]\)\/OPEm, 
                     \(SumS[\(1, \(\(-1\) + OPEm\)\)]\)\^2\/OPEm, 
                     \(SumS[\(2, \(\(-1\) + OPEm\)\)]\), 
                     \(SumS[\(2, \(\(-1\) + OPEm\)\)]\)\/OPEm, 
                     \(SumS[\(3, \(\(-1\) + OPEm\)\)]\), 
                     \(SumS[\(1, 1, \(\(-1\) + OPEm\)\)]\), 
                     \(SumS[\(1, \(OPEm - 1\)\)]\)\^2, 
                     \(SumS[\(1, 2, \(\(-1\) + OPEm\)\)]\), 
                     \(SumS[\(2, 1, \(\(-1\) + OPEm\)\)]\), 
                     \(SumS[\(1, \(\(-1\) + OPEm\)\)]\)\^3, 
                     \(\(SumS[\(1, \(\(-1\) + OPEm\)\)]\)\ 
                       \(SumS[\(2, \(\(-1\) + OPEm\)\)]\)\), 
                     \(SumS[\(1, 1, 1, \(\(-1\) + OPEm\)\)]\)}\)\) ;\)], 
            "Input", CellTags -> "InverseMellin"], Cell[BoxData[
             \(\(im[z_]\) := \(z\ \[LongRightArrow] 
                  \(InverseMellin[\(z, y\)]\)\)\)], "Input", 
            CellTags -> "InverseMellin"], Cell[CellGroupData[{Cell[BoxData[
                \(im[\(OPEm^\((\(-3\))\)\)]\)], "Input", CellTags -> 
                "InverseMellin"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/m\^3\) \[LongRightArrow] 
                     \((1\/2\ y\^\(m - 1\)\ \(\(log\^2\)(y)\))\)\)\)], 
               "Output", CellTags -> "InverseMellin"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(im[\(OPEm^\((\(-2\))\)\)]\)], 
               "Input", CellTags -> "InverseMellin"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/m\^2\) \[LongRightArrow] 
                     \((\(-y\^\(m - 1\)\)\ \(log(y)\))\)\)\)], "Output", 
               CellTags -> "InverseMellin"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(im[\(PolyGamma[\(0, OPEm\)]\)]\)
                ], "Input", CellTags -> "InverseMellin"], Cell[BoxData[
                FormBox[RowBox[{\(\*TagBox["\[Psi]", PolyGamma]\^\((0)\)(m)\)
                   , "\[LongRightArrow]", RowBox[{"(", RowBox[{RowBox[{
                         \(-\*TagBox["\[DoubledGamma]", 
                              Function[List[], EulerGamma]]\), " ", RowBox[
                          {"\[Delta]", "(", FormBox[\(1 - y\), 
                          "TraditionalForm"], ")"}], " ", \(y\^\(m - 1\)\)}], 
                       "-", \(\(\((1\/\(1 - y\))\)\_+\)\ y\^\(m - 1\)\)}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "InverseMellin"]}, Open]], Cell[BoxData[" "], "Input", 
            CellTags -> "InverseMellin"], Cell[CellGroupData[{Cell[BoxData[
                \(im[\(SumS[\(1, \(OPEm - 1\)\)]\)]\)], "Input", CellTags -> 
                "InverseMellin"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(S\_1\), "(", FormBox[\(m - 1\), "TraditionalForm"], 
                     ")"}], "\[LongRightArrow]", 
                   \((\(-y\^\(m - 1\)\)\ \(\((1\/\(1 - y\))\)\_+\))\)}], 
                 TraditionalForm]], "Output", CellTags -> "InverseMellin"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(im[\(\(SumS[\(1, \(OPEm - 1\)\)]\)/\((OPEm - 1)\)\)]\)], 
               "Input", CellTags -> "InverseMellin"], Cell[BoxData[
                FormBox[RowBox[{FractionBox[RowBox[{\(S\_1\), "(", FormBox[
                       \(m - 1\), "TraditionalForm"], ")"}], \(m - 1\)], 
                   "\[LongRightArrow]", 
                   \((\(-y\^\(m - 2\)\)\ \(log(1 - y)\))\)}], 
                 TraditionalForm]], "Output", CellTags -> "InverseMellin"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(im[\(\(SumS[\(1, \(OPEm - 1\)\)]\)/\((OPEm + 1)\)\)]\)], 
               "Input", CellTags -> "InverseMellin"], Cell[BoxData[
                FormBox[RowBox[{FractionBox[RowBox[{\(S\_1\), "(", FormBox[
                       \(m - 1\), "TraditionalForm"], ")"}], \(m + 1\)], 
                   "\[LongRightArrow]", 
                   \((\(-y\^\(m - 1\)\) - \(\(log(1 - y)\)\ y\^m\) + 
                       \(\(log(y)\)\ y\^m\) + y\^m)\)}], TraditionalForm]], 
               "Output", CellTags -> "InverseMellin"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(im[\(\(SumS[\(1, \(\(-1\) + OPEm\)\)]\)/\(OPEm^2\)\)]\)], 
               "Input", CellTags -> "InverseMellin"], Cell[BoxData[
                FormBox[RowBox[{FractionBox[RowBox[{\(S\_1\), "(", FormBox[
                       \(m - 1\), "TraditionalForm"], ")"}], \(m\^2\)], 
                   "\[LongRightArrow]", 
                   \((y\^\(m - 1\)\ \((\(\(-\(1\/2\)\)\ \(log\^2(y)\)\) + 
                          \(\[Zeta](2)\) - 
                          \(\(\*InterpretationBox["Li", PolyLog, 
                                Rule[Editable, False], 
                                Rule[Selectable, False]]\)\_2(y)\))\))\)}], 
                 TraditionalForm]], "Output", CellTags -> "InverseMellin"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(im[\(\(SumS[\(1, \(\(-1\) + OPEm\)\)]\)/OPEm\)]\)], 
               "Input", CellTags -> "InverseMellin"], Cell[BoxData[
                FormBox[RowBox[{FractionBox[RowBox[{\(S\_1\), "(", FormBox[
                       \(m - 1\), "TraditionalForm"], ")"}], "m"], 
                   "\[LongRightArrow]", 
                   \((y\^\(m - 1\)\ \((\(log(y)\) - \(log(1 - y)\))\))\)}], 
                 TraditionalForm]], "Output", CellTags -> "InverseMellin"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(im[\(\(\(SumS[\(1, \(\(-1\) + OPEm\)\)]\)^2\)/OPEm\)]\)], 
               "Input", CellTags -> "InverseMellin"], Cell[BoxData[
                FormBox[RowBox[{FractionBox[RowBox[{\(S\_1\%2\), "(", FormBox[
                       \(m - 1\), "TraditionalForm"], ")"}], "m"], 
                   "\[LongRightArrow]", 
                   \((y\^\(m - 1\)\ \((\(log\^2(1 - y)\) + \(log\^2(y)\)\/2 -
                           \(3\ \(\[Zeta](2)\)\) + 
                          \(\(\*InterpretationBox["Li", PolyLog, 
                                Rule[Editable, False], 
                                Rule[Selectable, False]]\)\_2(1 - y)\) + 
                          \(2\ \(\(\*InterpretationBox["Li", PolyLog, 
                                  Rule[Editable, False], 
                                  Rule[Selectable, False]]\)\_2(y)\)\))\))\)}]\
, TraditionalForm]], "Output", CellTags -> "InverseMellin"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(im[\(SumS[\(2, \(OPEm - 1\)\)]\)]\)], "Input", CellTags -> 
                "InverseMellin"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(S\_2\), "(", FormBox[\(m - 1\), "TraditionalForm"], 
                     ")"}], "\[LongRightArrow]", RowBox[{"(", RowBox[{
                       \(y\^\(m - 1\)\), " ", RowBox[{"(", RowBox[{RowBox[{
                          \(\[Zeta](2)\), " ", RowBox[{"\[Delta]", "(", 
                          FormBox[\(1 - y\), "TraditionalForm"], ")"}]}], 
                          "+", \(\(log(y)\)\/\(1 - y\)\)}], ")"}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "InverseMellin"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(im[\(\(SumS[\(2, \(OPEm - 1\)\)]\)/OPEm\)]\)], "Input", 
               CellTags -> "InverseMellin"], Cell[BoxData[FormBox[
                 RowBox[{FractionBox[RowBox[{\(S\_2\), "(", FormBox[\(m - 1\)
                       , "TraditionalForm"], ")"}], "m"], 
                   "\[LongRightArrow]", 
                   \((y\^\(m - 1\)\ \((\(\(-\(1\/2\)\)\ \(log\^2(y)\)\) + 
                          \(\[Zeta](2)\) - 
                          \(\(\*InterpretationBox["Li", PolyLog, 
                                Rule[Editable, False], 
                                Rule[Selectable, False]]\)\_2(1 - y)\))\))\)}]\
, TraditionalForm]], "Output", CellTags -> "InverseMellin"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(im[\(SumS[\(3, \(OPEm - 1\)\)]\)]\)], "Input", CellTags -> 
                "InverseMellin"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(S\_3\), "(", FormBox[\(m - 1\), "TraditionalForm"], 
                     ")"}], "\[LongRightArrow]", RowBox[{"(", RowBox[{
                       \(y\^\(m - 1\)\), " ", RowBox[{"(", RowBox[
                          {RowBox[{RowBox[{"\[Delta]", "(", FormBox[\(1 - y\)
                          , "TraditionalForm"], ")"}], " ", 
                          TagBox[\(\[Zeta](\*TagBox["3", Zeta, 
                                Rule[Editable, True]])\), 
                            InterpretTemplate[Function[BoxForm`e$, 
                              Zeta[BoxForm`e$]]]]}], "-", 
                          \(\(log\^2(y)\)\/\(2\ \((1 - y)\)\)\)}], ")"}]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "InverseMellin"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(im[\(SumS[\(1, 1, \(OPEm - 1\)\)]\)]\)], "Input", 
               CellTags -> "InverseMellin"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{\(S\_11\), "(", FormBox[\(m - 1\), 
                      "TraditionalForm"], ")"}], "\[LongRightArrow]", 
                   \((y\^\(m - 1\)\ \(\((\(log(1 - y)\)\/\(1 - y\))\)\_+\))\)}\
], TraditionalForm]], "Output", CellTags -> "InverseMellin"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\ \(im[\(SumS[\(1, 2, \(OPEm - 1\)\)]\)]\)\)], "Input", 
               CellTags -> "InverseMellin"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{\(S\_12\), "(", FormBox[\(m - 1\), 
                      "TraditionalForm"], ")"}], "\[LongRightArrow]", 
                   RowBox[{"(", RowBox[{\(y\^\(m - 1\)\), " ", RowBox[
                        {"(", RowBox[{RowBox[{
                          \(-\*TagBox[\(\[Zeta](
                                 \*TagBox["3", Zeta, Rule[Editable, True]])\
\), InterpretTemplate[Function[BoxForm`e$, 
                                 Zeta[BoxForm`e$]]]]\), " ", RowBox[
                          {"\[Delta]", "(", FormBox[\(1 - y\), 
                          "TraditionalForm"], ")"}]}], "-", 
                          \(\(\[Zeta](2)\)\ \(\((1\/\(1 - y\))\)\_+\)\), "+", 
                          \(\(\(\*InterpretationBox["Li", PolyLog, 
                                   Rule[Editable, False], 
                                   Rule[Selectable, False]]\)\_2(1 - y)\)\/
                             \(1 - y\)\)}], ")"}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "InverseMellin"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\ \(im[\(SumS[\(2, 1, \(OPEm - 1\)\)]\)]\)\)], "Input", 
               CellTags -> "InverseMellin"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{\(S\_21\), "(", FormBox[\(m - 1\), 
                      "TraditionalForm"], ")"}], "\[LongRightArrow]", 
                   RowBox[{"(", RowBox[{\(y\^\(m - 1\)\), " ", RowBox[
                        {"(", RowBox[{RowBox[{"2", " ", 
                          TagBox[\(\[Zeta](\*TagBox["3", Zeta, 
                                Rule[Editable, True]])\), 
                            InterpretTemplate[Function[BoxForm`e$, 
                              Zeta[BoxForm`e$]]]], " ", RowBox[{"\[Delta]", 
                          "(", FormBox[\(1 - y\), "TraditionalForm"], 
                          ")"}]}], "-", 
                          \(\(\[Zeta](2)\)\ \(\((1\/\(1 - y\))\)\_+\)\), "+", 
                          \(\(\(\*InterpretationBox["Li", PolyLog, 
                                   Rule[Editable, False], 
                                   Rule[Selectable, False]]\)\_2(y)\)\/
                             \(1 - y\)\)}], ")"}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "InverseMellin"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(im[\(SumS[\(1, 1, 1, \(OPEm - 1\)\)]\)]\)], "Input", 
               CellTags -> "InverseMellin"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{\(S\_111\), "(", FormBox[\(m - 1\), 
                      "TraditionalForm"], ")"}], "\[LongRightArrow]", 
                   \((\(-\(1\/2\)\)\ y\^\(m - 1\)\ 
                       \(\((\(log\^2(1 - y)\)\/\(1 - y\))\)\_+\))\)}], 
                 TraditionalForm]], "Output", CellTags -> "InverseMellin"]}, 
             Open]], Cell[BoxData[\(\(Clear[\(im, list\)]\) ;\)], "Input", 
            CellTags -> "InverseMellin"]}, Open]], Cell["Isolate", 
         "ObjectName", CellTags -> "Isolate"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Isolate"], Cell["Isolate[expr] substitutes \
abbreviations KK[i] for all Plus[...] (sub-sums) in expr. The inserted KK[i] \
have head HoldForm. Isolate[expr, varlist] substitutes KK[i] for all subsums \
in expr which are free of any occurence of a member of the list varlist. \
Instead of KK any other head or a list of names of the abbreviations may be \
specified with the option IsolateNames.", "Text", CellTags -> "Isolate"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[Isolate]\)], "Input", 
               CellTags -> "Isolate"], Cell[BoxData[
                \(TraditionalForm\`\({\(IsolateNames \[Rule] KK\), 
                      \(HighEnergyPhysics`FeynCalc`IsolatePrint`IsolatePrint 
                        \[Rule] False\), 
                      \(HighEnergyPhysics`FeynCalc`IsolateSplit`IsolateSplit 
                        \[Rule] \[Infinity]\)}\)\)], "Output", CellTags -> 
                "Isolate"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Isolate"], Cell[CellGroupData[{Cell[BoxData[
                \(t0 = \(Isolate[\(a + b\)]\)\)], "Input", CellTags -> 
                "Isolate"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[\(KK(1)\), HoldForm]\)\)], 
               "Output", CellTags -> "Isolate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(Isolate[\(\(\(\((a + b)\)\ f\)\ +\ 
                         \(\((c + d)\)\ f\)\ +\ e\), f\)]\)\)], "Input", 
               CellTags -> "Isolate"], Cell[BoxData[
                \(TraditionalForm\`\(e + \(f\ \*TagBox[\(KK(1)\), HoldForm]\)
                      + \(f\ \*TagBox[\(KK(2)\), HoldForm]\)\)\)], "Output", 
               CellTags -> "Isolate"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(StandardForm[t1]\)], "Input", CellTags -> 
                "Isolate"], Cell[BoxData[
                \(e + \(f\ \*TagBox[\(KK[1]\), HoldForm]\) + 
                   \(f\ \*TagBox[\(KK[2]\), HoldForm]\)\)], "Output", 
               CellTags -> "Isolate"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\({t0,\ t1,\ \(ReleaseHold[t1]\)}\)], "Input", 
               CellTags -> "Isolate"], Cell[BoxData[
                \(TraditionalForm\`\({\*TagBox[\(KK(1)\), HoldForm], 
                      \(e + \(f\ \*TagBox[\(KK(1)\), HoldForm]\) + 
                        \(f\ \*TagBox[\(KK(2)\), HoldForm]\)\), 
                      \(e + \(\((a + b)\)\ f\) + \(\((c + d)\)\ f\)\)}\)\)], 
               "Output", CellTags -> "Isolate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Isolate[\(\(\(\(a[z]\)\ \((b + \(c\ \((y + z)\)\))\)\) + 
                       \(\(d[z]\)\ \((y + z)\)\)\), \({a, d}\), 
                     \(IsolateNames \[Rule] fF\)\)]\)], "Input", CellTags -> 
                "Isolate"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(d(z)\)\ 
                       \*TagBox[\(fF(1)\), HoldForm]\) + 
                     \(\(a(z)\)\ \*TagBox[\(fF(2)\), HoldForm]\)\)\)], 
               "Output", CellTags -> "Isolate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(??fF\)], "Input", CellTags -> 
                "Isolate"], Cell["Global`fF", "Print", CellTags -> 
                {"Info3353009204-3117966", "Isolate"}], Cell[BoxData[
                InterpretationBox[GridBox[{{GridBox[{{\(
                         \(fF[1]\) = \(y + z\)\)}, {" "}, 
                       {\(\(fF[2]\) = \(
                           b + \(c\ \("HoldForm"[\(fF[1]\)]\)\)\)\)}}, 
                      GridBaseline -> {Baseline, {1, 1}}, 
                      ColumnWidths -> 0.9990000128746033, 
                      ColumnAlignments -> {Left}]}}, 
                   GridBaseline -> {Baseline, {1, 1}}, 
                   ColumnAlignments -> {Left}], Definition["fF"], 
                  Rule[Editable, False]]], "Print", CellTags -> 
                {"Info3353009204-3117966", "Isolate"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Isolate[\(\(a - b - c - d - e\), \(IsolateNames \[Rule] l\)
                     , \(IsolateSplit \[Rule] 15\)\)]\)], "Input", 
               CellTags -> "Isolate"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[\(l(3)\), HoldForm]\)\)], 
               "Output", CellTags -> "Isolate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\({\(l[2]\), \(l[1]\)}\)], 
               "Input", CellTags -> "Isolate"], Cell[BoxData[
                \(TraditionalForm\`\({\(a - b\), \(l(1)\)}\)\)], "Output", 
               CellTags -> "Isolate"]}, Open]], Cell[BoxData[
             \(Clear[\(t0, t1, l, fF\)]\)], "Input", CellTags -> "Isolate"]}, 
          Open]], Cell["IsolateNames", "ObjectName", 
         CellTags -> "IsolateNames"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "IsolateNames"], 
           Cell["IsolateNames is an option for Isolate and Collect2. Its \
default setting is KK. Instead of a symbol the setting may also be a list \
with the names of the abbrevations.", "Text", CellTags -> "IsolateNames"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Isolate", RuleDelayed[ButtonData, "Isolate"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Isolate"]]\
, ", ", 
              ButtonBox["Collect2", RuleDelayed[ButtonData, "Collect2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Collect2"]], "."}], "Text", 
            CellTags -> "IsolateNames"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["IsolatePrint", "ObjectName", CellTags -> "IsolatePrint"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "IsolatePrint"], Cell["IsolatePrint is an option of \
Isolate. If it is set to OutputForm (or any other *Form) the definitions of \
the abbreviations are printed during the operation of Isolate. The setting \
IsolatePrint \[Rule] False suppresses printing.", "Text", 
            CellTags -> "IsolatePrint"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Isolate", RuleDelayed[ButtonData, "Isolate"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Isolate"]]\
, "."}], "Text", CellTags -> "IsolatePrint"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["IsolateSplit", "ObjectName", 
         CellTags -> "IsolateSplit"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "IsolateSplit"], 
           Cell["IsolateSplit is an option for Isolate. Its setting \
determines the maximum number of characters of FortranForm[expr] which are \
abbreviated by Isolate. If the expression is larger than the indicated \
number, it is split into smaller pieces and onto each subsum Isolate is \
applied. With the default setting IsolateSplit \[Rule] Infinity no splitting \
is done.", "Text", CellTags -> "IsolateSplit"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Isolate", RuleDelayed[ButtonData, "Isolate"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Isolate"]]\
, "."}], "Text", CellTags -> "IsolateSplit"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["KK", "ObjectName", CellTags -> "KK"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "KK"], Cell["KK[i] is the default setting of \
IsolateNames, which is the head of abbreviations used by Isolate. A KK[i] \
returned by Isolate is given in HoldForm and can be recovered by \
ReleaseHold[KK[i]].", "Text", CellTags -> "KK"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Isolate", RuleDelayed[ButtonData, "Isolate"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Isolate"]]\
, ", ", 
              ButtonBox["IsolateNames", 
                RuleDelayed[ButtonData, "IsolateNames"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "IsolateNames"]], "."}], "Text", 
            CellTags -> "KK"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["Kummer", "ObjectName", CellTags -> "Kummer"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Kummer"], Cell["Kummer[i][exp] applies Kummer \
relation number i (i =1, ... 24, 94,95,96) to all Hypergeometric2F1 in exp. i \
= 94 corresponds to eq. 9.131.2, i = 95 to eq. 9.132.1 and i = 96 to eq. \
9.132.2 in Gradsteyn & Ryzhik.", "Text", CellTags -> "Kummer"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["HypergeometricAC", 
                RuleDelayed[ButtonData, "HypergeometricAC"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "HypergeometricAC"]], "."}], "Text", 
            CellTags -> "Kummer"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Kummer"], Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, z\)]\) == 
                   \(\(Kummer[2]\)[\(Hypergeometric2F1[\(a, b, c, z\)]\)]\)\)]\
, "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox["z", Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(\(-a\) - b + c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox["z", Hypergeometric2F1, Rule[Editable, True]])\
\)\), InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, z\)]\) == 
                   \(\(Kummer[3]\)[\(Hypergeometric2F1[\(a, b, c, z\)]\)]\)\)]\
, "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox["z", Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(-a\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(-\(z\/\(1 - z\)\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, z\)]\) == 
                   \(\(Kummer[4]\)[\(Hypergeometric2F1[\(a, b, c, z\)]\)]\)\)]\
, "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox["z", Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(-b\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(-\(z\/\(1 - z\)\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, \(1 - z\)\)]\) == 
                   \(\(Kummer[6]\)[\(Hypergeometric2F1[\(a, b, c, \(1 - z\)\)
                       ]\)]\)\)], "Input", CellTags -> "Kummer"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1 - z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(z\^\(\(-a\) - b + c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1 - z\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, \(a + b + 1 - c\), \(1 - z\)\)]
                    \) == \(\(Kummer[6]\)[
                     \(Hypergeometric2F1[
                       \(a, b, \(a + b + 1 - c\), \(1 - z\)\)]\)]\)\)], 
               "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(a + b - c + 1\), 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1 - z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(z\^\(1 - c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(a - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(b - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(a + b - c + 1\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1 - z\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, \(1 - z\)\)]\) == 
                   \(\(Kummer[7]\)[\(Hypergeometric2F1[\(a, b, c, \(1 - z\)\)
                       ]\)]\)\)], "Input", CellTags -> "Kummer"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1 - z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(z\^\(-a\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(-\(\(1 - z\)\/z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, \(a + b + 1 - c\), \(1 - z\)\)]
                    \) == \(\(Kummer[7]\)[
                     \(Hypergeometric2F1[
                       \(a, b, \(a + b + 1 - c\), \(1 - z\)\)]\)]\)\)], 
               "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(a + b - c + 1\), 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1 - z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(z\^\(-a\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(a - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(a + b - c + 1\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(-\(\(1 - z\)\/z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, \(1 - z\)\)]\) == 
                   \(\(Kummer[8]\)[\(Hypergeometric2F1[\(a, b, c, \(1 - z\)\)
                       ]\)]\)\)], "Input", CellTags -> "Kummer"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1 - z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(z\^\(-b\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(-\(\(1 - z\)\/z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, \(a + b + 1 - c\), \(1 - z\)\)]
                    \) == \(\(Kummer[8]\)[
                     \(Hypergeometric2F1[
                       \(a, b, \(a + b + 1 - c\), \(1 - z\)\)]\)]\)\)], 
               "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(a + b - c + 1\), 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1 - z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(z\^\(-b\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(b - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(a + b - c + 1\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(-\(\(1 - z\)\/z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, \(z^\((\(-1\))\)\)\)]\) == 
                   \(\(Kummer[10]\)[\(Hypergeometric2F1[
                       \(a, b, c, \(z^\((\(-1\))\)\)\)]\)]\)\)], "Input", 
               CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1\/z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(\(-a\) - b + c\)\ 
                       \((\(-z\))\)\^\(a + b - c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/z\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, \(a + 1 - c\), \(a + 1 - b\), 
                       \(z^\((\(-1\))\)\)\)]\) == 
                   \(\(Kummer[10]\)[\(Hypergeometric2F1[
                       \(a, \(a + 1 - c\), \(a + 1 - b\), \(z^\((\(-1\))\)\)
                        \)]\)]\)\)], "Input", CellTags -> "Kummer"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox[\(a - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(a - b + 1\), 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1\/z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(\(-a\) - b + c\)\ 
                       \((\(-z\))\)\^\(a + b - c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(1 - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(a - b + 1\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/z\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, \(z^\((\(-1\))\)\)\)]\) == 
                   \(\(Kummer[11]\)[\(Hypergeometric2F1[
                       \(a, b, c, \(z^\((\(-1\))\)\)\)]\)]\)\)], "Input", 
               CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1\/z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((\(-\(\(1 - z\)\/z\)\))\)\^\(-a\)\ 
                       \((\(-z\))\)\^a\ \*
                        TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/\(1 - z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, \(a + 1 - c\), \(a + 1 - b\), 
                       \(z^\((\(-1\))\)\)\)]\) == 
                   \(\(Kummer[11]\)[\(Hypergeometric2F1[
                       \(a, \(a + 1 - c\), \(a + 1 - b\), \(z^\((\(-1\))\)\)
                        \)]\)]\)\)], "Input", CellTags -> "Kummer"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox[\(a - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(a - b + 1\), 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1\/z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((\(-\(\(1 - z\)\/z\)\))\)\^\(-a\)\ 
                       \((\(-z\))\)\^a\ \*
                        TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(a - b + 1\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/\(1 - z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, \(z^\((\(-1\))\)\)\)]\) == 
                   \(\(Kummer[12]\)[\(Hypergeometric2F1[
                       \(a, b, c, \(z^\((\(-1\))\)\)\)]\)]\)\)], "Input", 
               CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1\/z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(-b\)\ 
                       \((\(-z\))\)\^\(b - a\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/\(1 - z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, \(a + 1 - c\), \(a + 1 - b\), 
                       \(z^\((\(-1\))\)\)\)]\) == 
                   \(\(Kummer[12]\)[\(Hypergeometric2F1[
                       \(a, \(a + 1 - c\), \(a + 1 - b\), \(z^\((\(-1\))\)\)
                        \)]\)]\)\)], "Input", CellTags -> "Kummer"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox[\(a - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(a - b + 1\), 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1\/z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(\(-a\) + c - 1\)\ 
                       \((\(-z\))\)\^\(1 - c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(a - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(1 - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(a - b + 1\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/\(1 - z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, \(z^\((\(-1\))\)\)\)]\) == 
                   \(\(Kummer[14]\)[\(Hypergeometric2F1[
                       \(a, b, c, \(z^\((\(-1\))\)\)\)]\)]\)\)], "Input", 
               CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1\/z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(\(-a\) - b + c\)\ 
                       \((\(-z\))\)\^\(a + b - c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/z\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(\(b + 1 - c\), b, \(b + 1 - a\), 
                       \(z^\((\(-1\))\)\)\)]\) == 
                   \(\(Kummer[14]\)[\(Hypergeometric2F1[
                       \(\(b + 1 - c\), b, \(b + 1 - a\), \(z^\((\(-1\))\)\)
                        \)]\)]\)\)], "Input", CellTags -> "Kummer"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox[\(b - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(\(-a\) + b + 1\), 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1\/z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(\(-a\) - b + c\)\ 
                       \((\(-z\))\)\^\(a + b - c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(1 - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(\(-a\) + b + 1\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/z\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, \(z^\((\(-1\))\)\)\)]\) == 
                   \(\(Kummer[15]\)[\(Hypergeometric2F1[
                       \(a, b, c, \(z^\((\(-1\))\)\)\)]\)]\)\)], "Input", 
               CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1\/z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(-b\)\ \((\(-z\))\)\^b\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/\(1 - z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(\(b + 1 - c\), b, \(b + 1 - a\), 
                       \(z^\((\(-1\))\)\)\)]\) == 
                   \(\(Kummer[15]\)[\(Hypergeometric2F1[
                       \(\(b + 1 - c\), b, \(b + 1 - a\), \(z^\((\(-1\))\)\)
                        \)]\)]\)\)], "Input", CellTags -> "Kummer"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox[\(b - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(\(-a\) + b + 1\), 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1\/z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(-b\)\ \((\(-z\))\)\^b\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(\(-a\) + b + 1\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/\(1 - z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, \(z^\((\(-1\))\)\)\)]\) == 
                   \(\(Kummer[16]\)[\(Hypergeometric2F1[
                       \(a, b, c, \(z^\((\(-1\))\)\)\)]\)]\)\)], "Input", 
               CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1\/z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(-a\)\ \((\(-z\))\)\^a\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/\(1 - z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(\(b + 1 - c\), b, \(b + 1 - a\), 
                       \(z^\((\(-1\))\)\)\)]\) == 
                   \(\(Kummer[16]\)[\(Hypergeometric2F1[
                       \(\(b + 1 - c\), b, \(b + 1 - a\), \(z^\((\(-1\))\)\)
                        \)]\)]\)\)], "Input", CellTags -> "Kummer"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox[\(b - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(\(-a\) + b + 1\), 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1\/z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(\(-b\) + c - 1\)\ 
                       \((\(-z\))\)\^\(b - c + 1\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(b - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(1 - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(\(-a\) + b + 1\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1\/\(1 - z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(\(a + 1 - c\), \(b + 1 - c\), 
                       \(2 - c\), z\)]\) == 
                   \(\(Kummer[18]\)[\(Hypergeometric2F1[
                       \(\(a + 1 - c\), \(b + 1 - c\), \(2 - c\), z\)]\)]\)\)]\
, "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox[\(a - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox[\(b - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(2 - c\), 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox["z", Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(\(-a\) - b + c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(1 - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(1 - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(2 - c\), Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox["z", Hypergeometric2F1, Rule[Editable, True]])\
\)\), InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, z\)]\) == 
                   \(\(Kummer[18]\)[\(Hypergeometric2F1[\(a, b, c, z\)]\)]\)\
\)], "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox["z", Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(\(-a\) - b + c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox["z", Hypergeometric2F1, Rule[Editable, True]])\
\)\), InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(\(a + 1 - c\), \(b + 1 - c\), 
                       \(2 - c\), z\)]\) == 
                   \(\(Kummer[19]\)[\(Hypergeometric2F1[
                       \(\(a + 1 - c\), \(b + 1 - c\), \(2 - c\), z\)]\)]\)\)]\
, "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox[\(a - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox[\(b - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(2 - c\), 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox["z", Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(\(-a\) + c - 1\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(a - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(1 - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(2 - c\), Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(z\/\(z - 1\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, z\)]\) == 
                   \(\(Kummer[19]\)[\(Hypergeometric2F1[\(a, b, c, z\)]\)]\)\
\)], "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox["z", Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(-a\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(z\/\(z - 1\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(\(a + 1 - c\), \(b + 1 - c\), 
                       \(2 - c\), z\)]\) == 
                   \(\(Kummer[20]\)[\(Hypergeometric2F1[
                       \(\(a + 1 - c\), \(b + 1 - c\), \(2 - c\), z\)]\)]\)\)]\
, "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox[\(a - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox[\(b - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(2 - c\), 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox["z", Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(\(-b\) + c - 1\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(b - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(1 - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(2 - c\), Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(z\/\(z - 1\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, z\)]\) == 
                   \(\(Kummer[20]\)[\(Hypergeometric2F1[\(a, b, c, z\)]\)]\)\
\)], "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox["z", Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(-b\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(z\/\(z - 1\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(\(c - a\), \(c - b\), 
                       \(c + 1 - a - b\), \(1 - z\)\)]\) == 
                   \(\(Kummer[22]\)[\(Hypergeometric2F1[
                       \(\(c - a\), \(c - b\), \(c + 1 - a - b\), \(1 - z\)\)
                       ]\)]\)\)], "Input", CellTags -> "Kummer"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox[\(c - a\), Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox[\(c - b\), Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(\(-a\) - b + c + 1
                                  \), Hypergeometric2F1, 
                                 Rule[Editable, True]], 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[\(1 - z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(z\^\(1 - c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(1 - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(1 - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(\(-a\) - b + c + 1\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1 - z\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, \(1 - z\)\)]\) == 
                   \(\(Kummer[22]\)[\(Hypergeometric2F1[
                       \(a, b, c, \(1 - z\)\)]\)]\)\)], "Input", CellTags -> 
                "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1 - z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(z\^\(\(-a\) - b + c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1 - z\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(\(c - a\), \(c - b\), 
                       \(c + 1 - a - b\), \(1 - z\)\)]\) == 
                   \(\(Kummer[23]\)[\(Hypergeometric2F1[
                       \(\(c - a\), \(c - b\), \(c + 1 - a - b\), \(1 - z\)\)
                       ]\)]\)\)], "Input", CellTags -> "Kummer"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox[\(c - a\), Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox[\(c - b\), Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(\(-a\) - b + c + 1
                                  \), Hypergeometric2F1, 
                                 Rule[Editable, True]], 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[\(1 - z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(a - c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(1 - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(\(-a\) - b + c + 1\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1 - 1\/\(1 - z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, \(1 - z\)\)]\) == 
                   \(\(Kummer[23]\)[\(Hypergeometric2F1[
                       \(a, b, c, \(1 - z\)\)]\)]\)\)], "Input", CellTags -> 
                "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1 - z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\((1 - z)\)\^\(-a\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(1 - 1\/\(1 - z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(\(c - a\), \(c - b\), 
                       \(c + 1 - a - b\), \(1 - z\)\)]\) == 
                   \(\(Kummer[24]\)[\(Hypergeometric2F1[
                       \(\(c - a\), \(c - b\), \(c + 1 - a - b\), \(1 - z\)\)
                       ]\)]\)\)], "Input", CellTags -> "Kummer"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox[\(c - a\), Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox[\(c - b\), Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox[\(\(-a\) - b + c + 1
                                  \), Hypergeometric2F1, 
                                 Rule[Editable, True]], 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[\(1 - z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(z\^\(b - c\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(1 - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(\(-a\) - b + c + 1\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(-\(\(1 - z\)\/z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, \(1 - z\)\)]\) == 
                   \(\(Kummer[24]\)[\(Hypergeometric2F1[
                       \(a, b, c, \(1 - z\)\)]\)]\)\)], "Input", CellTags -> 
                "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox[\(1 - z\), Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(z\^\(-b\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(-\(\(1 - z\)\/z\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\)\)], 
               "Output", CellTags -> "Kummer"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, z\)]\) == 
                   \(\(Kummer[94]\)[\(Hypergeometric2F1[\(a, b, c, z\)]\)]\)\
\)], "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox["z", Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\(\(\[CapitalGamma](\(a + b - c\))\)\ 
                          \(\[CapitalGamma](c)\)\ 
                          \*TagBox[TagBox[\(
                              \(\(\[InvisiblePrefixScriptBase]\_2\) 
                                 \(F\_1\)\) \[InvisibleApplication] 
                               \((\*TagBox[TagBox[\(
                                    \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                    InterpretTemplate[Function[
                                    List[SlotSequence[1]]]]], 
                                    Hypergeometric2F1, 
                                    Rule[Editable, False]] ; 
                                  \*TagBox[TagBox[TagBox[\(
                                   \(-a\) - b + c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    InterpretTemplate[Function[
                                    List[SlotSequence[1]]]]], 
                                    Hypergeometric2F1, 
                                    Rule[Editable, False]] ; 
                                  \*TagBox[\(1 - z\), Hypergeometric2F1, 
                                    Rule[Editable, True]])\)\), 
                             InterpretTemplate[Function[HypergeometricPFQ[
                                Slot[1], Slot[2], Slot[3]]]], 
                             Rule[Editable, False]], Hypergeometric2F1]\ 
                          \((1 - z)\)\^\(\(-a\) - b + c\)\)\/
                        \(\(\[CapitalGamma](a)\)\ \(\[CapitalGamma](b)\)\) + 
                       \(\(\[CapitalGamma](c)\)\ 
                          \(\[CapitalGamma](\(\(-a\) - b + c\))\)\ 
                          \*TagBox[TagBox[\(
                              \(\(\[InvisiblePrefixScriptBase]\_2\) 
                                 \(F\_1\)\) \[InvisibleApplication] 
                               \((\*TagBox[TagBox[\(
                                    \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                    InterpretTemplate[Function[
                                    List[SlotSequence[1]]]]], 
                                    Hypergeometric2F1, 
                                    Rule[Editable, False]] ; 
                                  \*TagBox[TagBox[TagBox[\(a + b - c + 1
                                   \), Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    InterpretTemplate[Function[
                                    List[SlotSequence[1]]]]], 
                                    Hypergeometric2F1, 
                                    Rule[Editable, False]] ; 
                                  \*TagBox[\(1 - z\), Hypergeometric2F1, 
                                    Rule[Editable, True]])\)\), 
                             InterpretTemplate[Function[HypergeometricPFQ[
                                Slot[1], Slot[2], Slot[3]]]], 
                             Rule[Editable, False]], Hypergeometric2F1]\)\/
                        \(\(\[CapitalGamma](\(c - a\))\)\ 
                          \(\[CapitalGamma](\(c - b\))\)\)\)\)\)], "Output", 
               CellTags -> "Kummer"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, z\)]\) == 
                   \(\(Kummer[95]\)[\(Hypergeometric2F1[\(a, b, c, z\)]\)]\)\
\)], "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox["z", Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\(\(\[CapitalGamma](\(b - a\))\)\ 
                          \(\[CapitalGamma](c)\)\ 
                          \*TagBox[TagBox[\(
                              \(\(\[InvisiblePrefixScriptBase]\_2\) 
                                 \(F\_1\)\) \[InvisibleApplication] 
                               \((\*TagBox[TagBox[\(
                                    \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - b\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                    InterpretTemplate[Function[
                                    List[SlotSequence[1]]]]], 
                                    Hypergeometric2F1, 
                                    Rule[Editable, False]] ; 
                                  \*TagBox[TagBox[TagBox[\(a - b + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    InterpretTemplate[Function[
                                    List[SlotSequence[1]]]]], 
                                    Hypergeometric2F1, 
                                    Rule[Editable, False]] ; 
                                  \*TagBox[\(1\/\(1 - z\)\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]])\)\), 
                             InterpretTemplate[Function[HypergeometricPFQ[
                                Slot[1], Slot[2], Slot[3]]]], 
                             Rule[Editable, False]], Hypergeometric2F1]\ 
                          \((1 - z)\)\^\(-a\)\)\/
                        \(\(\[CapitalGamma](b)\)\ 
                          \(\[CapitalGamma](\(c - a\))\)\) + 
                       \(\(\[CapitalGamma](\(a - b\))\)\ 
                          \(\[CapitalGamma](c)\)\ 
                          \*TagBox[TagBox[\(
                              \(\(\[InvisiblePrefixScriptBase]\_2\) 
                                 \(F\_1\)\) \[InvisibleApplication] 
                               \((\*TagBox[TagBox[\(
                                    \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(c - a\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                    InterpretTemplate[Function[
                                    List[SlotSequence[1]]]]], 
                                    Hypergeometric2F1, 
                                    Rule[Editable, False]] ; 
                                  \*TagBox[TagBox[TagBox[\(
                                   \(-a\) + b + 1\), Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    InterpretTemplate[Function[
                                    List[SlotSequence[1]]]]], 
                                    Hypergeometric2F1, 
                                    Rule[Editable, False]] ; 
                                  \*TagBox[\(1\/\(1 - z\)\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]])\)\), 
                             InterpretTemplate[Function[HypergeometricPFQ[
                                Slot[1], Slot[2], Slot[3]]]], 
                             Rule[Editable, False]], Hypergeometric2F1]\ 
                          \((1 - z)\)\^\(-b\)\)\/
                        \(\(\[CapitalGamma](a)\)\ 
                          \(\[CapitalGamma](\(c - b\))\)\)\)\)\)], "Output", 
               CellTags -> "Kummer"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(Hypergeometric2F1[\(a, b, c, z\)]\) == 
                   \(\(Kummer[96]\)[\(Hypergeometric2F1[\(a, b, c, z\)]\)]\)\
\)], "Input", CellTags -> "Kummer"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                         \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                          \[InvisibleApplication] 
                          \((\*TagBox[TagBox[\(
                                 \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                  \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                InterpretTemplate[Function[List[
                                   SlotSequence[1]]]]], Hypergeometric2F1, 
                               Rule[Editable, False]] ; 
                             \*TagBox[TagBox[TagBox["c", 
                                 Hypergeometric2F1, Rule[Editable, True]]\
, InterpretTemplate[Function[List[SlotSequence[1]]]]], 
                               Hypergeometric2F1, Rule[Editable, False]] ; 
                             \*TagBox["z", Hypergeometric2F1, 
                               Rule[Editable, True]])\)\), 
                        InterpretTemplate[Function[HypergeometricPFQ[
                           Slot[1], Slot[2], Slot[3]]]], 
                        Rule[Editable, False]], Hypergeometric2F1] 
                     \[LongEqual] \(\(\((\(-1\))\)\^a\ 
                          \(\[CapitalGamma](\(b - a\))\)\ 
                          \(\[CapitalGamma](c)\)\ 
                          \*TagBox[TagBox[\(
                              \(\(\[InvisiblePrefixScriptBase]\_2\) 
                                 \(F\_1\)\) \[InvisibleApplication] 
                               \((\*TagBox[TagBox[\(
                                    \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(a - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                    InterpretTemplate[Function[
                                    List[SlotSequence[1]]]]], 
                                    Hypergeometric2F1, 
                                    Rule[Editable, False]] ; 
                                  \*TagBox[TagBox[TagBox[\(a - b + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    InterpretTemplate[Function[
                                    List[SlotSequence[1]]]]], 
                                    Hypergeometric2F1, 
                                    Rule[Editable, False]] ; 
                                  \*TagBox[\(1\/z\), Hypergeometric2F1, 
                                    Rule[Editable, True]])\)\), 
                             InterpretTemplate[Function[HypergeometricPFQ[
                                Slot[1], Slot[2], Slot[3]]]], 
                             Rule[Editable, False]], Hypergeometric2F1]\ 
                          z\^\(-a\)\)\/\(
                         \(\[CapitalGamma](b)\)\ 
                          \(\[CapitalGamma](\(c - a\))\)\) + 
                       \(\((\(-1\))\)\^b\ \(\[CapitalGamma](\(a - b\))\)\ 
                          \(\[CapitalGamma](c)\)\ 
                          \*TagBox[TagBox[\(
                              \(\(\[InvisiblePrefixScriptBase]\_2\) 
                                 \(F\_1\)\) \[InvisibleApplication] 
                               \((\*TagBox[TagBox[\(
                                    \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(b - c + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                    InterpretTemplate[Function[
                                    List[SlotSequence[1]]]]], 
                                    Hypergeometric2F1, 
                                    Rule[Editable, False]] ; 
                                  \*TagBox[TagBox[TagBox[\(
                                   \(-a\) + b + 1\), Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    InterpretTemplate[Function[
                                    List[SlotSequence[1]]]]], 
                                    Hypergeometric2F1, 
                                    Rule[Editable, False]] ; 
                                  \*TagBox[\(1\/z\), Hypergeometric2F1, 
                                    Rule[Editable, True]])\)\), 
                             InterpretTemplate[Function[HypergeometricPFQ[
                                Slot[1], Slot[2], Slot[3]]]], 
                             Rule[Editable, False]], Hypergeometric2F1]\ 
                          z\^\(-b\)\)\/\(
                         \(\[CapitalGamma](a)\)\ 
                          \(\[CapitalGamma](\(c - b\))\)\)\)\)\)], "Output", 
               CellTags -> "Kummer"]}, Open]]}, Open]], 
        Cell["Lagrangian", "ObjectName", CellTags -> "Lagrangian"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Lagrangian"], Cell["Lagrangian[\"oqu\"] gives the \
unpolarized OPE quark operator. Lagrangian[\"oqp\"] gives the polarized quark \
OPE operator. Lagrangian[\"ogu\"] gives the unpolarized gluon OPE operator. \
Lagrangian[\"ogp\"] gives the polarized gluon OPE operator. \
Lagrangian[\"ogd\"] gives the sigma-term part of the QCD lagrangian. \
Lagrangian[\"QCD\"] gives the gluon self interaction part of the QCD \
lagrangian.", "Text", CellTags -> "Lagrangian"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynRule", RuleDelayed[ButtonData, "FeynRule"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynRule"]], "."}], "Text", 
            CellTags -> "Lagrangian"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Lagrangian"], Cell[CellGroupData[{Cell[BoxData[
                \(Lagrangian["QCD"]\)], "Input", CellTags -> "Lagrangian"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(-\(1\/4\)\)\ 
                     \(F\_\(\[Alpha]\[Beta]\)\%a . F\_\(\[Alpha]\[Beta]\)\%a
                      \)\)\)], "Output", CellTags -> "Lagrangian"]}, Open]], 
           Cell["Twist-2 operator product expansion operators", "Text", 
            CellTags -> "Lagrangian"], Cell[CellGroupData[{Cell[BoxData[
                \(Lagrangian["ogu"]\)], "Input", CellTags -> "Lagrangian"], 
              Cell[BoxData[FormBox[RowBox[{\(1\/2\), " ", 
                   \(\[ImaginaryI]\^\(m - 1\)\), " ", RowBox[
                    {SubsuperscriptBox["F", RowBox[{"\[Alpha]", FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]}], "a"], ".", 
                     SuperscriptBox[RowBox[{"(", SubsuperscriptBox["D", 
                         FormBox["\[CapitalDelta]", "TraditionalForm"], \(ab\)
                         ], ")"}], \(m - 2\)], ".", SubsuperscriptBox["F", 
                      RowBox[{"\[Alpha]", FormBox["\[CapitalDelta]", 
                         "TraditionalForm"]}], "b"]}]}], TraditionalForm]], 
               "Output", CellTags -> "Lagrangian"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Lagrangian["ogp"]\)], "Input", 
               CellTags -> "Lagrangian"], Cell[BoxData[FormBox[RowBox[{
                   \(1\/2\), " ", \(\[ImaginaryI]\^m\), " ", RowBox[
                    {SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Alpha]", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["\[Beta]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["\[Gamma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]}]], ".", 
                     \(F\_\(\[Beta]\[Gamma]\)\%a\), ".", SuperscriptBox[
                      RowBox[{"(", SubsuperscriptBox["D", FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], \(ab\)], 
                        ")"}], \(m - 2\)], ".", SubsuperscriptBox["F", 
                      RowBox[{"\[Alpha]", FormBox["\[CapitalDelta]", 
                         "TraditionalForm"]}], "b"]}]}], TraditionalForm]], 
               "Output", CellTags -> "Lagrangian"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Lagrangian["oqu"]\)], "Input", 
               CellTags -> "Lagrangian"], Cell[BoxData[FormBox[RowBox[{
                   \(\[ImaginaryI]\^m\), " ", RowBox[{FormBox[\(\[Psi]\&_\), 
                      "TraditionalForm"], ".", RowBox[{"(", RowBox[
                        {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], ")"}], ".", SuperscriptBox[
                      SubscriptBox["D", FormBox["\[CapitalDelta]", 
                        "TraditionalForm"]], \(m - 1\)], ".", FormBox[
                      "\[Psi]", "TraditionalForm"]}]}], TraditionalForm]], 
               "Output", CellTags -> "Lagrangian"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Lagrangian["oqp"]\)], "Input", 
               CellTags -> "Lagrangian"], Cell[BoxData[FormBox[RowBox[{
                   \(\[ImaginaryI]\^m\), " ", RowBox[{FormBox[\(\[Psi]\&_\), 
                      "TraditionalForm"], ".", \(\[Gamma]\^5\), ".", 
                     RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]}], ")"}], 
                     ".", SuperscriptBox[SubscriptBox["D", FormBox[
                        "\[CapitalDelta]", "TraditionalForm"]], \(m - 1\)], 
                     ".", FormBox["\[Psi]", "TraditionalForm"]}]}], 
                 TraditionalForm]], "Output", CellTags -> "Lagrangian"]}, 
             Open]]}, Open]], Cell["LC", "ObjectName", CellTags -> "LC"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "LC"], Cell["LC[m,n,r,s] evaluates to 4-dimensional \
LeviCivita[m,n,r,s] by virtue of applying FeynCalcInternal. LC[m,...][p, ...] \
evaluates to 4-dimensional LeviCivita[m,...][p,...] applying \
FeynCalcInternal.", "Text", CellTags -> "LC"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["LeviCivita", RuleDelayed[ButtonData, "LeviCivita"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeviCivita"]], ", ", 
              ButtonBox["LCD", RuleDelayed[ButtonData, "LCD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "LCD"]], 
              "."}], "Text", CellTags -> "LC"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "LC"], Cell[CellGroupData[{Cell[BoxData[
                \(LC[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\)], "Input", 
               CellTags -> "LC"], Cell[BoxData[
                \(TraditionalForm\`\(\[Epsilon]\^\(\[Mu]\[Nu]\[Rho]\[Sigma]\)
                    \)\)], "Output", CellTags -> "LC"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//FCI\)], "Input", CellTags -> 
                "LC"], Cell[BoxData[FormBox[SuperscriptBox["\[Epsilon]", 
                  RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["\[Rho]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                      "TraditionalForm"], "TraditionalForm"]}]], 
                 TraditionalForm]], "Output", CellTags -> "LC"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "LC"], Cell[BoxData[
                \(Eps[\(\(LorentzIndex[\[Mu]]\), \(LorentzIndex[\[Nu]]\), 
                     \(LorentzIndex[\[Rho]]\), \(LorentzIndex[\[Sigma]]\)\)]\
\)], "Output", CellTags -> "LC"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(LC[\(\[Mu], \[Nu]\)]\)[\(p, q\)]\)], "Input", CellTags -> 
                "LC"], Cell[BoxData[
                \(TraditionalForm\`\(\[Epsilon]\^\(\[Mu]\[Nu]pq\)\)\)], 
               "Output", CellTags -> "LC"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(%//FCI\)//StandardForm\)], 
               "Input", CellTags -> "LC"], Cell[BoxData[
                \(Eps[\(\(LorentzIndex[\[Mu]]\), \(LorentzIndex[\[Nu]]\), 
                     \(Momentum[\(p, D\)]\), \(Momentum[\(q, D\)]\)\)]\)], 
               "Output", CellTags -> "LC"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Contract[\(\(\(LC[\(\[Mu], \[Nu], \[Rho]\)]\)[p]\)\ 
                       \(\(LC[\(\[Mu], \[Nu], \[Rho]\)]\)[q]\)\)]\)\ \)], 
               "Input", CellTags -> "LC"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{"18", " ", RowBox[{FormBox["p", 
                        "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                        "TraditionalForm"]}]}], "-", RowBox[{"24", " ", 
                     RowBox[{FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                       FormBox["q", "TraditionalForm"]}]}]}], 
                 TraditionalForm]], "Output", CellTags -> "LC"]}, Open]]}, 
          Open]], Cell["LCD", "ObjectName", CellTags -> "LCD"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "LCD"], Cell["LCD[m,n,r,s] evaluates to D-dimensional \
LeviCivita[m,n,r,s] by virtue of FeynCalcInternal. LCD[m,...][p, ...] \
evaluates to D-dimensional LeviCivita[m,...][p,...] applying \
FeynCalcInternal.", "Text", CellTags -> "LCD"], Cell["You need to do \
SetOptions[Eps, Dimension\[Rule]D] before LCD can be used as D-dimensional \
Levi-Civita input function.", "Text", CellTags -> "LCD"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["LeviCivita", RuleDelayed[ButtonData, "LeviCivita"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeviCivita"]], ", ", 
              ButtonBox["LC", RuleDelayed[ButtonData, "LC"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "LC"]], 
              "."}], "Text", CellTags -> "LCD"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "LCD"], Cell[BoxData[
             \(\(SetOptions[\(Eps, \(Dimension \[Rule] D\)\)]\) ;\)], 
            "Input", CellTags -> "LCD"], Cell[CellGroupData[{Cell[BoxData[
                \(LCD[\(\[Mu], \[Nu], \[Rho], \[Sigma]\)]\)], "Input", 
               CellTags -> "LCD"], Cell[BoxData[
                \(TraditionalForm\`\(\[Epsilon]\^\(\[Mu]\[Nu]\[Rho]\[Sigma]\)
                    \)\)], "Output", CellTags -> "LCD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//FCI\)], "Input", CellTags -> 
                "LCD"], Cell[BoxData[FormBox[SuperscriptBox["\[Epsilon]", 
                  RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["\[Rho]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                      "TraditionalForm"], "TraditionalForm"]}]], 
                 TraditionalForm]], "Output", CellTags -> "LCD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "LCD"], Cell[BoxData[
                \(Eps[\(\(LorentzIndex[\(\[Mu], D\)]\), 
                     \(LorentzIndex[\(\[Nu], D\)]\), 
                     \(LorentzIndex[\(\[Rho], D\)]\), 
                     \(LorentzIndex[\(\[Sigma], D\)]\)\)]\)], "Output", 
               CellTags -> "LCD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(LCD[\(\[Mu], \[Nu]\)]\)[\(p, q\)]\)], "Input", 
               CellTags -> "LCD"], Cell[BoxData[
                \(TraditionalForm\`\(\[Epsilon]\^\(\[Mu]\[Nu]pq\)\)\)], 
               "Output", CellTags -> "LCD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(%//FCI\)//StandardForm\)], 
               "Input", CellTags -> "LCD"], Cell[BoxData[
                \(Eps[\(\(LorentzIndex[\(\[Mu], D\)]\), 
                     \(LorentzIndex[\(\[Nu], D\)]\), \(Momentum[\(p, D\)]\), 
                     \(Momentum[\(q, D\)]\)\)]\)], "Output", CellTags -> 
                "LCD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Factor2[\(Contract[\(\(\(LCD[\(\[Mu], \[Nu], \[Rho]\)]\)[p]
                        \)\ \(\(LCD[\(\[Mu], \[Nu], \[Rho]\)]\)[q]\)\)]\)]\)]\
, "Input", CellTags -> "LCD"], Cell[BoxData[FormBox[RowBox[{\((1 - D)\), " ", 
                   \((2 - D)\), " ", \((3 - D)\), " ", RowBox[{FormBox["p", 
                      "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                      "TraditionalForm"]}]}], TraditionalForm]], "Output", 
               CellTags -> "LCD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\(Eps, \(Dimension \[Rule] 4\)\)]\)], "Input", 
               CellTags -> "LCD"], Cell[BoxData[
                \(TraditionalForm\`\({Dimension \[Rule] 4}\)\)], "Output", 
               CellTags -> "LCD"]}, Open]]}, Open]], Cell["LeftPartialD", 
         "ObjectName", CellTags -> "LeftPartialD"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "LeftPartialD"], Cell[TextData[
             {"LeftPartialD[\[Mu]] denotes ", Cell[BoxData[FormBox[
                 SubscriptBox[\(\[PartialD]\&\[LeftArrow]\), FormBox[
                   FormBox["\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                 TraditionalForm]]], "acting to the left."}], "Text", 
            CellTags -> "LeftPartialD"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["ExpandPartialD", 
                RuleDelayed[ButtonData, "ExpandPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandPartialD"]], ", ", 
              ButtonBox["PartialD", RuleDelayed[ButtonData, "PartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PartialD"]], ", ", 
              ButtonBox["LeftRightPartialD", 
                RuleDelayed[ButtonData, "LeftRightPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftRightPartialD"]], ", ", 
              ButtonBox["RightPartialD", 
                RuleDelayed[ButtonData, "RightPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "RightPartialD"]], "."}], "Text", 
            CellTags -> "LeftPartialD"]}, Open]], 
        Cell[CellGroupData[{Cell[BoxData["Examples"], "Subsubsection", 
            CellTags -> "LeftPartialD"], Cell[CellGroupData[{Cell[BoxData[
                \(\(QuantumField[\(A, \(LorentzIndex[\[Mu]]\)\)]\) . 
                   \(LeftPartialD[\[Nu]]\)\)], "Input", CellTags -> 
                "LeftPartialD"], Cell[BoxData[FormBox[RowBox[{\(A\_\[Mu]\), 
                   ".", SubscriptBox[\(\[PartialD]\&\[LeftArrow]\), 
                    FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "LeftPartialD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ExpandPartialD[%]\)], "Input", 
               CellTags -> "LeftPartialD"], Cell[BoxData[FormBox[
                 RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]], 
                   SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"], "\[Null]"]}], 
                 TraditionalForm]], "Output", CellTags -> "LeftPartialD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(StandardForm[%]\)], 
               "Input", CellTags -> "LeftPartialD"], Cell[BoxData[
                \(QuantumField[\(\(PartialD[\(LorentzIndex[\[Nu]]\)]\), A, 
                     \(LorentzIndex[\[Mu]]\)\)]\)], "Output", CellTags -> 
                "LeftPartialD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(LeftPartialD[\[Mu]]\)]\)], "Input", 
               CellTags -> "LeftPartialD"], Cell[BoxData[
                \(LeftPartialD[\(LorentzIndex[\[Mu]]\)]\)], "Output", 
               CellTags -> "LeftPartialD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(QuantumField[\(A, \(LorentzIndex[\[Mu]]\)\)]\) . 
                   \(QuantumField[\(A, \(LorentzIndex[\[Nu]]\)\)]\) . 
                   \(LeftPartialD[\[Rho]]\)\)], "Input", CellTags -> 
                "LeftPartialD"], Cell[BoxData[FormBox[RowBox[{\(A\_\[Mu]\), 
                   ".", \(A\_\[Nu]\), ".", SubscriptBox[
                    \(\[PartialD]\&\[LeftArrow]\), FormBox[FormBox["\[Rho]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "LeftPartialD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(ExpandPartialD[%]\)], 
               "Input", CellTags -> "LeftPartialD"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{\(A\_\[Mu]\), ".", RowBox[
                      {SubscriptBox["\[PartialD]", FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[Null]"]}]}], "+", RowBox[{RowBox[{SubscriptBox[
                        "\[PartialD]", FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[Null]"]}], ".", \(A\_\[Nu]\)}]}], 
                 TraditionalForm]], "Output", CellTags -> "LeftPartialD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(StandardForm[%]\)], 
               "Input", CellTags -> "LeftPartialD"], Cell[BoxData[
                \(\(\(QuantumField[\(A, \(LorentzIndex[\[Mu]]\)\)]\) . 
                     \(QuantumField[\(\(PartialD[\(LorentzIndex[\[Rho]]\)]\),
                          A, \(LorentzIndex[\[Nu]]\)\)]\)\) + 
                   \(\(QuantumField[\(\(PartialD[\(LorentzIndex[\[Rho]]\)]\),
                          A, \(LorentzIndex[\[Mu]]\)\)]\) . 
                     \(QuantumField[\(A, \(LorentzIndex[\[Nu]]\)\)]\)\)\)], 
               "Output", CellTags -> "LeftPartialD"]}, Open]]}, Open]], 
        Cell["LeftRightPartialD", "ObjectName", CellTags -> 
          "LeftRightPartialD"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "LeftRightPartialD"], Cell[TextData[
             {"LeftRightPartialD[mu] denotes ", Cell[BoxData[FormBox[
                 SubscriptBox[\(\[PartialD]\&\[LeftRightArrow]\), 
                  FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                   "TraditionalForm"]], TraditionalForm]]], ", acting to the \
left and right. ExplicitPartialD[LeftRightPartialD[", Cell[BoxData[
                \(TraditionalForm\`\[Mu]\)]], "]] gives 1/2 (RightPartialD[", 
              Cell[BoxData[\(TraditionalForm\`\[Mu]\)]], "] - LeftPartialD[", 
              Cell[BoxData[\(TraditionalForm\`\[Mu]\)]], "])."}], "Text", 
            CellTags -> "LeftRightPartialD"], Cell[TextData[{"See also: ", 
              ButtonBox["ExplicitPartialD", 
                RuleDelayed[ButtonData, "ExplicitPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExplicitPartialD"]], ", ", 
              ButtonBox["ExpandPartialD", 
                RuleDelayed[ButtonData, "ExpandPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandPartialD"]], ", ", 
              ButtonBox["PartialD", RuleDelayed[ButtonData, "PartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PartialD"]], ", ", 
              ButtonBox["LeftPartialD", 
                RuleDelayed[ButtonData, "LeftPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftPartialD"]], ", ", 
              ButtonBox["LeftRightPartialD2", 
                RuleDelayed[ButtonData, "LeftRightPartialD2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftRightPartialD2"]], ", ", 
              ButtonBox["RightPartialD", 
                RuleDelayed[ButtonData, "RightPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "RightPartialD"]], "."}], "Text", 
            CellTags -> "LeftRightPartialD"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "LeftRightPartialD"], Cell[CellGroupData[
             {Cell[BoxData[\(LeftRightPartialD[\[Mu]]\)], "Input", 
               CellTags -> "LeftRightPartialD"], Cell[BoxData[FormBox[
                 SubscriptBox[\(\[PartialD]\&\[LeftRightArrow]\), 
                  FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                   "TraditionalForm"]], TraditionalForm]], "Output", 
               CellTags -> "LeftRightPartialD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ExplicitPartialD[%]\)], 
               "Input", CellTags -> "LeftRightPartialD"], Cell[BoxData[
                FormBox[RowBox[{\(1\/2\), " ", RowBox[{"(", RowBox[
                      {SubscriptBox[\(\[PartialD]\&\[RightArrow]\), FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"]], "-", SubscriptBox[
                        \(\[PartialD]\&\[LeftArrow]\), FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "LeftRightPartialD"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(LeftRightPartialD[\[Mu]]\) . 
                   \(QuantumField[\(A, \(LorentzIndex[\[Nu]]\)\)]\)\)], 
               "Input", CellTags -> "LeftRightPartialD"], Cell[BoxData[
                FormBox[RowBox[{SubscriptBox[
                    \(\[PartialD]\&\[LeftRightArrow]\), FormBox[FormBox[
                      "\[Mu]", "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(A\_\[Nu]\)}], TraditionalForm]], "Output", CellTags -> 
                "LeftRightPartialD"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(ExpandPartialD[%]\)], "Input", CellTags -> 
                "LeftRightPartialD"], Cell[BoxData[FormBox[RowBox[{\(1\/2\), 
                   " ", RowBox[{"(", RowBox[{RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                         SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[Null]"]}], "-", RowBox[{SubscriptBox[
                          \(\[PartialD]\&\[LeftArrow]\), FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                         ".", \(A\_\[Nu]\)}]}], ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "LeftRightPartialD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(QuantumField[\(A, \(LorentzIndex[\[Mu]]\)\)]\) . 
                   \(LeftRightPartialD[\[Nu]]\) . 
                   \(QuantumField[\(A, \(LorentzIndex[\[Rho]]\)\)]\)\)], 
               "Input", CellTags -> "LeftRightPartialD"], Cell[BoxData[
                FormBox[RowBox[{\(A\_\[Mu]\), ".", SubscriptBox[
                    \(\[PartialD]\&\[LeftRightArrow]\), FormBox[FormBox[
                      "\[Nu]", "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(A\_\[Rho]\)}], TraditionalForm]], "Output", CellTags -> 
                "LeftRightPartialD"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(ExpandPartialD[%]\)], "Input", CellTags -> 
                "LeftRightPartialD"], Cell[BoxData[FormBox[RowBox[{\(1\/2\), 
                   " ", RowBox[{"(", RowBox[{RowBox[{\(A\_\[Mu]\), ".", 
                         RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"]], 
                          SubsuperscriptBox["A", FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[Null]"]}]}], "-", RowBox[{RowBox[{SubscriptBox[
                          "\[PartialD]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                          SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[Null]"]}], ".", \(A\_\[Rho]\)}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "LeftRightPartialD"]}, Open]]}, Open]], 
        Cell["LeftRightPartialD2", "ObjectName", CellTags -> 
          "LeftRightPartialD2"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "LeftRightPartialD2"], Cell[TextData[
             {"LeftRightPartialD2[mu] denotes ", Cell[BoxData[FormBox[
                 SubscriptBox[\(\[PartialD]\&\[LeftRightArrow]\), 
                  FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                   "TraditionalForm"]], TraditionalForm]]], ", acting to the \
left and right. ExplicitPartialD[LeftRightPartialD2[", Cell[BoxData[
                \(TraditionalForm\`\[Mu]\)]], "]] gives (RightPartialD[", 
              Cell[BoxData[\(TraditionalForm\`\[Mu]\)]], "] + LeftPartialD[", 
              Cell[BoxData[\(TraditionalForm\`\[Mu]\)]], "])."}], "Text", 
            CellTags -> "LeftRightPartialD2"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["ExplicitPartialD", 
                RuleDelayed[ButtonData, "ExplicitPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExplicitPartialD"]], ", ", 
              ButtonBox["ExpandPartialD", 
                RuleDelayed[ButtonData, "ExpandPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandPartialD"]], ", ", 
              ButtonBox["PartialD", RuleDelayed[ButtonData, "PartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PartialD"]], ", ", 
              ButtonBox["LeftPartialD", 
                RuleDelayed[ButtonData, "LeftPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftPartialD"]], ", ", 
              ButtonBox["RightPartialD", 
                RuleDelayed[ButtonData, "RightPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "RightPartialD"]], "."}], "Text", 
            CellTags -> "LeftRightPartialD2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "LeftRightPartialD2"], Cell[CellGroupData[
             {Cell[BoxData[\(LeftRightPartialD2[\[Mu]]\)], "Input", 
               CellTags -> "LeftRightPartialD2"], Cell[BoxData[FormBox[
                 SubscriptBox[\(\[PartialD]\&\[LeftRightArrow]\), 
                  FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                   "TraditionalForm"]], TraditionalForm]], "Output", 
               CellTags -> "LeftRightPartialD2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ExplicitPartialD[%]\)], 
               "Input", CellTags -> "LeftRightPartialD2"], Cell[BoxData[
                FormBox[RowBox[{SubscriptBox[\(\[PartialD]\&\[LeftArrow]\), 
                    FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], "+", SubscriptBox[
                    \(\[PartialD]\&\[RightArrow]\), FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "LeftRightPartialD2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(LeftRightPartialD2[\[Mu]]\) . 
                   \(QuantumField[\(A, \(LorentzIndex[\[Nu]]\)\)]\)\)], 
               "Input", CellTags -> "LeftRightPartialD2"], Cell[BoxData[
                FormBox[RowBox[{SubscriptBox[
                    \(\[PartialD]\&\[LeftRightArrow]\), FormBox[FormBox[
                      "\[Mu]", "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(A\_\[Nu]\)}], TraditionalForm]], "Output", CellTags -> 
                "LeftRightPartialD2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(ExpandPartialD[%]\)], "Input", CellTags -> 
                "LeftRightPartialD2"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{SubscriptBox[\(\[PartialD]\&\[LeftArrow]\), 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], ".", \(A\_\[Nu]\)}], "+", 
                   RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                     SubsuperscriptBox["A", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], 
                      "\[Null]"]}]}], TraditionalForm]], "Output", 
               CellTags -> "LeftRightPartialD2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(QuantumField[\(A, \(LorentzIndex[\[Mu]]\)\)]\) . 
                   \(LeftRightPartialD2[\[Nu]]\) . 
                   \(QuantumField[\(A, \(LorentzIndex[\[Rho]]\)\)]\)\)], 
               "Input", CellTags -> "LeftRightPartialD2"], Cell[BoxData[
                FormBox[RowBox[{\(A\_\[Mu]\), ".", SubscriptBox[
                    \(\[PartialD]\&\[LeftRightArrow]\), FormBox[FormBox[
                      "\[Nu]", "TraditionalForm"], "TraditionalForm"]], ".", 
                   \(A\_\[Rho]\)}], TraditionalForm]], "Output", CellTags -> 
                "LeftRightPartialD2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(ExpandPartialD[%]\)], "Input", CellTags -> 
                "LeftRightPartialD2"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(A\_\[Mu]\), ".", RowBox[{SubscriptBox["\[PartialD]", 
                        FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Rho]", "TraditionalForm"], 
                         "TraditionalForm"], "\[Null]"]}]}], "+", 
                   RowBox[{RowBox[{SubscriptBox["\[PartialD]", FormBox[
                         FormBox["\[Nu]", "TraditionalForm"], 
                         "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                         FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], "\[Null]"]}], ".", \(A\_\[Rho]\)}
                     ]}], TraditionalForm]], "Output", CellTags -> 
                "LeftRightPartialD2"]}, Open]]}, Open]], 
        Cell["LeviCivita ", "ObjectName", CellTags -> "LeviCivita"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "LeviCivita"], Cell[TextData[{"LeviCivita[", 
              Cell[BoxData[
                \(TraditionalForm\`\(\[Mu],\ \[Nu],\ \[Rho],\ \[Sigma]\)\)]], 
              "] is an input function for the totally antisymmetric \
Levi-Civita tensor. It evaluates automatically to the internal representation \
Eps[LorentzIndex[", Cell[BoxData[\(TraditionalForm\`\[Mu]\)]], 
              "], LorentzIndex[", Cell[BoxData[\(TraditionalForm\`\[Nu]\)]], 
              "], LorentzIndex[", Cell[BoxData[FormBox[FormBox["\[Rho]", 
                  "TraditionalForm"], TraditionalForm]]], "], \
LorentzIndex[\[Sigma]]] (or with a second argument in LorentzIndex for the \
Dimension, if the option Dimension of LeviCivita is changed). LeviCivita[", 
              Cell[BoxData[\(TraditionalForm\`\(\[Mu],\ \(\[Nu]\ ...\)\)\)]], 
              "][ ", Cell[BoxData[\(TraditionalForm\`\(p,\ ..\)\)]], 
              ".] evaluates to Eps[LorentzIndex[", Cell[BoxData[
                \(TraditionalForm\`\[Mu]\)]], "], LorentzIndex[", 
              Cell[BoxData[\(TraditionalForm\`\[Nu]\)]], "], ..., Momentum[", 
              Cell[BoxData[\(TraditionalForm\`p\)]], "], ...]."}], "Text", 
            CellTags -> "LeviCivita"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[LeviCivita]\)], "Input", CellTags -> "LeviCivita"], 
              Cell[BoxData[\(TraditionalForm\`\({Dimension \[Rule] D}\)\)], 
               "Output", CellTags -> "LeviCivita"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Eps", RuleDelayed[ButtonData, "Eps"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Eps"]], 
              ", ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], ", ", 
              ButtonBox["LC", RuleDelayed[ButtonData, "LC"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "LC"]], 
              ", ", 
              ButtonBox["LCD", RuleDelayed[ButtonData, "LCD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "LCD"]], 
              "."}], "Text", CellTags -> "LeviCivita"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "LeviCivita"], Cell[CellGroupData[{Cell[BoxData[
                \(LeviCivita[\(\[Alpha], \[Beta], \[Gamma], \[Delta]\)]\)], 
               "Input", CellTags -> "LeviCivita"], Cell[BoxData[
                FormBox[SuperscriptBox["\[Epsilon]", RowBox[{FormBox[
                     FormBox["\[Alpha]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Beta]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["\[Gamma]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["\[Delta]", 
                      "TraditionalForm"], "TraditionalForm"]}]], 
                 TraditionalForm]], "Output", CellTags -> "LeviCivita"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(LeviCivita[\(\[Mu], \[Nu]\)]\)[\(OPEDelta, p\)]\)], 
               "Input", CellTags -> "LeviCivita"], Cell[BoxData[
                FormBox[SuperscriptBox["\[Epsilon]", RowBox[{FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                    FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox["\[CapitalDelta]", 
                     "TraditionalForm"], FormBox["p", "TraditionalForm"]}]], 
                 TraditionalForm]], "Output", CellTags -> "LeviCivita"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(LeviCivita[]\)[\(p, q, r, s\)]\)], "Input", CellTags -> 
                "LeviCivita"], Cell[BoxData[FormBox[SuperscriptBox[
                  "\[Epsilon]", RowBox[{FormBox["p", "TraditionalForm"], 
                    FormBox["q", "TraditionalForm"], FormBox["r", 
                     "TraditionalForm"], FormBox["s", "TraditionalForm"]}]], 
                 TraditionalForm]], "Output", CellTags -> "LeviCivita"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(LeviCivita[\(\[Alpha], \[Beta], \[Beta], \[Delta]\)]\)], 
               "Input", CellTags -> "LeviCivita"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> 
                "LeviCivita"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(LeviCivita[\(\[Mu], \[Nu]\)]\)[\(OPEDelta, p\)]\)//
                   StandardForm\)], "Input", CellTags -> "LeviCivita"], 
              Cell[BoxData[
                \(Eps[\(\(LorentzIndex[\[Mu]]\), \(LorentzIndex[\[Nu]]\), 
                     \(Momentum[OPEDelta]\), \(Momentum[p]\)\)]\)], "Output", 
               CellTags -> "LeviCivita"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t1\ =\ \(\(LeviCivita[\(\[Alpha], \[Beta], \[Gamma], \[Rho]
                        \)]\) . \(LeviCivita[
                       \(\[Alpha], \[Beta], \[Gamma], \[Rho]\)]\)\)\ \)], 
               "Input", CellTags -> "LeviCivita"], Cell[BoxData[
                FormBox[RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                     {FormBox[FormBox["\[Alpha]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Beta]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Gamma]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                        "TraditionalForm"], "TraditionalForm"]}]], ".", 
                   SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                        "\[Alpha]", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["\[Beta]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Gamma]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "LeviCivita"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Contract[t1]\)], "Input", 
               CellTags -> "LeviCivita"], Cell[BoxData[
                \(TraditionalForm\`\(-24\)\)], "Output", CellTags -> 
                "LeviCivita"]}, Open]], Cell[BoxData[
             \(\(SetOptions[\(LeviCivita, \(Dimension \[Rule] D\)\)]\) ; 
                \(SetOptions[\(Eps, \(Dimension \[Rule] D\)\)]\) ;\)], 
            "Input", CellTags -> "LeviCivita"], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(Contract[\ \(\(LeviCivita[
                         \(\[Alpha], \[Beta], \[Gamma], \[Rho]\)]\) . 
                       \(LeviCivita[\(\[Alpha], \[Beta], \[Gamma], \[Rho]\)]
                        \)\)]\)//Factor2\)], "Input", CellTags -> 
                "LeviCivita"], Cell[BoxData[
                \(TraditionalForm\`\(\((1 - D)\)\ \((2 - D)\)\ \((3 - D)\)\ D
                    \)\)], "Output", CellTags -> "LeviCivita"]}, Open]], 
           Cell[BoxData[
             \(\(SetOptions[\(LeviCivita, \(Dimension \[Rule] 4\)\)]\) ; 
                \(SetOptions[\(Eps, \(Dimension \[Rule] 4\)\)]\) ;\)], 
            "Input", CellTags -> "LeviCivita"], Cell[CellGroupData[
             {Cell[BoxData[\(LC[\(\[Alpha], \[Beta], \[Gamma], \[Delta]\)]\)]
                , "Input", CellTags -> "LeviCivita"], Cell[BoxData[
                \(TraditionalForm\`\(\[Epsilon]\^
                     \(\[Alpha]\[Beta]\[Gamma]\[Delta]\)\)\)], "Output", 
               CellTags -> "LeviCivita"]}, Open]], Cell[BoxData[\(Clear[t1]\)]
             , "Input", CellTags -> "LeviCivita"]}, Open]], 
        Cell["LeviCivitaSign", "ObjectName", CellTags -> "LeviCivitaSign"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "LeviCivitaSign"], Cell["LeviCivitaSign is an option \
for DiracTrace and EpsChisholm. It determines the sign in the result of a \
Dirac trace of four gamma matrices and gamma5.", "Text", CellTags -> 
             "LeviCivitaSign"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracTrace", RuleDelayed[ButtonData, "DiracTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrace"]], ", ", 
              ButtonBox["EpsChisholm", RuleDelayed[ButtonData, 
                 "EpsChisholm"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "EpsChisholm"]], "."}], "Text", 
            CellTags -> "LeviCivitaSign"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["Li2 ", "ObjectName", CellTags -> "Li2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Li2"], Cell[" Li2 is an abbreviation for the dilog \
function, i.e., Li2 = PolyLog[2, #]&.", "Text", CellTags -> "Li2"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["Li3", RuleDelayed[ButtonData, "Li3"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Li3"]], 
              "."}], "Text", CellTags -> "Li2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Li2"], Cell[CellGroupData[{Cell[BoxData[\(Li2[x]\)], 
               "Input", CellTags -> "Li2"], Cell[BoxData[
                \(TraditionalForm\`\(\(\*
                        InterpretationBox["Li", PolyLog, 
                         Rule[Editable, False], Rule[Selectable, False]]\)\_2\
(x)\)\)], "Output", CellTags -> "Li2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Li2//StandardForm\)], "Input", CellTags -> 
                "Li2"], Cell[BoxData[\(\(PolyLog[\(2, #1\)]\) &\)], "Output", 
               CellTags -> "Li2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(-\(\[Integral] \(\(Log[\(1 - x\)]\)\/x 
                       \(\[DifferentialD] x\)\)\)\)], "Input", CellTags -> 
                "Li2"], Cell[BoxData[
                \(TraditionalForm\`\(\(\*
                        InterpretationBox["Li", PolyLog, 
                         Rule[Editable, False], Rule[Selectable, False]]\)\_2\
(x)\)\)], "Output", CellTags -> "Li2"]}, Open]]}, Open]], 
        Cell["Li3 ", "ObjectName", CellTags -> "Li3"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Li3"], Cell[" Li3 is an abbreviation for the trilog \
function, i.e., Li3 = PolyLog[3, #]&.", "Text", CellTags -> "Li3"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["Li2", RuleDelayed[ButtonData, "Li2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Li2"]], 
              "."}], "Text", CellTags -> "Li3"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Li3"], Cell[CellGroupData[{Cell[BoxData[\(Li3[x]\)], 
               "Input", CellTags -> "Li3"], Cell[BoxData[
                \(TraditionalForm\`\(\(\*
                        InterpretationBox["Li", PolyLog, 
                         Rule[Editable, False], Rule[Selectable, False]]\)\_3\
(x)\)\)], "Output", CellTags -> "Li3"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Li3//StandardForm\)], "Input", CellTags -> 
                "Li3"], Cell[BoxData[\(\(PolyLog[\(3, #1\)]\) &\)], "Output", 
               CellTags -> "Li3"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(D[\(\(Li3[x]\), x\)]\)], "Input", CellTags -> "Li3"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                         \*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(x)\)\/x\)\)], "Output", CellTags -> "Li3"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\[Integral] \(\(Li2[x]\)\/x \(\[DifferentialD] x\)\)\)], 
               "Input", CellTags -> "Li3"], Cell[BoxData[
                \(TraditionalForm\`\(\(\*
                        InterpretationBox["Li", PolyLog, 
                         Rule[Editable, False], Rule[Selectable, False]]\)\_3\
(x)\)\)], "Output", CellTags -> "Li3"]}, Open]]}, Open]], 
        Cell["Loop", "ObjectName", CellTags -> "Loop"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Loop"], Cell["Loop is an option for functions \
related to FeynArts integration, indicating the number of (virtual) loops.", 
            "Text", CellTags -> "Loop"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["LorentzIndex", "ObjectName", CellTags -> "LorentzIndex"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "LorentzIndex"], Cell["LorentzIndex[mu] denotes a \
four dimensional Lorentz index. For other than four dimensions: \
LorentzIndex[mu, D] or LorentzIndex[mu] etc. LorentzIndex[mu, 4] simplifies \
to LorentzIndex[mu].", "Text", CellTags -> "LorentzIndex"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["ChangeDimension", 
                RuleDelayed[ButtonData, "ChangeDimension"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ChangeDimension"]], ", ", 
              ButtonBox["Momentum", RuleDelayed[ButtonData, "Momentum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Momentum"]], "."}], "Text", 
            CellTags -> "LorentzIndex"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "LorentzIndex"], 
           Cell["This denotes a four-dimensional Lorentz index.", "Text", 
            CellTags -> "LorentzIndex"], Cell[CellGroupData[{Cell[BoxData[
                \(LorentzIndex[\[Alpha]]\)], "Input", CellTags -> 
                "LorentzIndex"], Cell[BoxData[\(TraditionalForm\`\[Alpha]\)], 
               "Output", CellTags -> "LorentzIndex"]}, Open]], 
           Cell["An optional second argument can be given for a dimension \
different from 4.", "Text", CellTags -> "LorentzIndex"], 
           Cell[CellGroupData[{Cell[BoxData[\(LorentzIndex[\(\[Alpha], n\)]\)]
                , "Input", CellTags -> "LorentzIndex"], Cell[BoxData[
                \(TraditionalForm\`\[Alpha]\)], "Output", CellTags -> 
                "LorentzIndex"]}, Open]], Cell[CellGroupData[
             {Cell["LorentzIndex[ComplexIndex[\[Alpha]]]", "Input", 
               CellTags -> "LorentzIndex"], Cell[BoxData[
                \(TraditionalForm\`\(\[Alpha]\^*\)\)], "Output", CellTags -> 
                "LorentzIndex"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ComplexConjugate[\(LorentzIndex[\[Mu]]\)]\)], "Input", 
               CellTags -> "LorentzIndex"], Cell[BoxData[
                \(TraditionalForm\`\[Mu]\)], "Output", CellTags -> 
                "LorentzIndex"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ComplexConjugate[\(LorentzIndex[\(ComplexIndex[\[Beta]]\)]
                    \)]\)], "Input", CellTags -> "LorentzIndex"], 
              Cell[BoxData[\(TraditionalForm\`\(\[Beta]\^*\)\)], "Output", 
               CellTags -> "LorentzIndex"]}, Open]], Cell["Setting \
$LorentzIndices=True displays the dimension (if different from 4) as a \
subindex.", "Text", CellTags -> "LorentzIndex"], Cell[BoxData[
             \(\($LorentzIndices = True\) ;\)], "Input", CellTags -> 
             "LorentzIndex"], Cell[CellGroupData[{Cell[BoxData[
                \({\(LorentzIndex[\(\[Alpha], D\)]\), 
                    \(LorentzIndex[\(\[Nu], n\)]\), 
                    \(LorentzIndex[\(\[Beta], 4\)]\)}\)], "Input", 
               CellTags -> "LorentzIndex"], Cell[BoxData[FormBox[
                 RowBox[{"{", RowBox[{SubscriptBox[FormBox["\[Alpha]", 
                       "TraditionalForm"], FormBox["D", "TraditionalForm"]], 
                     ",", SubscriptBox[FormBox["\[Nu]", "TraditionalForm"], 
                      FormBox["n", "TraditionalForm"]], ",", "\[Beta]"}], 
                   "}"}], TraditionalForm]], "Output", CellTags -> 
                "LorentzIndex"]}, Open]], Cell[BoxData[
             \(\($LorentzIndices\ =\ False\) ;\)], "Input", 
            CellTags -> "LorentzIndex"]}, Open]], Cell["Lower", "ObjectName", 
         CellTags -> "Lower"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Lower"], 
           Cell["Lower may be used inside LorentzIndex to indicate a \
covariant LorentzIndex.", "Text", CellTags -> "Lower"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["LorentzIndex", 
                RuleDelayed[ButtonData, "LorentzIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LorentzIndex"]], ", ", 
              ButtonBox["Upper", RuleDelayed[ButtonData, "Upper"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Upper"]], 
              ", ", 
              ButtonBox["Contract1", RuleDelayed[ButtonData, "Contract1"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract1"]], "."}], "Text", 
            CellTags -> "Lower"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["MakeContext", "ObjectName", CellTags -> "MakeContext"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "MakeContext"], Cell["MakeContext[string] constructs \
the context path of string. MakeContext is invoked at startup of FeynCalc. \
MakeContext[a, b] construct the context path of b defined in the context of \
a.", "Text", CellTags -> "MakeContext"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalc", RuleDelayed[ButtonData, "FeynCalc"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalc"]], ", ", 
              ButtonBox["CheckContext", 
                RuleDelayed[ButtonData, "CheckContext"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CheckContext"]], ", ", 
              ButtonBox["$FeynCalcStuff", 
                RuleDelayed[ButtonData, "$FeynCalcStuff"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "$FeynCalcStuff"]], ", ", 
              ButtonBox["Load", RuleDelayed[ButtonData, "Load"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Load"]], 
              "."}], "Text", CellTags -> "MakeContext"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["Mandelstam", "ObjectName", 
         CellTags -> "Mandelstam"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Mandelstam"], 
           Cell["Mandelstam is an option for DiracTrace, OneLoop, OneLoopSum, \
Tr and TrickMandelstam.  A typical setting is Mandelstam \[Rule] {s, t, u, \
m1^2+m2^2+m3^2+m4^2}, which implies  s + t + u = m1^2+m2^2+m3^2+m4^2. If \
other than four-particle processes are calculated, the setting should be: \
Mandelstam \[Rule] {}.", "Text", CellTags -> "Mandelstam"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracTrace", RuleDelayed[ButtonData, "DiracTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrace"]], ", ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, ", ", 
              ButtonBox["OneLoopSum", RuleDelayed[ButtonData, "OneLoopSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSum"]], ", ", 
              ButtonBox["Tr", RuleDelayed[ButtonData, "Tr"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Tr"]], 
              ", ", 
              ButtonBox["TrickMandelstam", 
                RuleDelayed[ButtonData, "TrickMandelstam"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "TrickMandelstam"]], ", ", 
              ButtonBox["SetMandelstam", 
                RuleDelayed[ButtonData, "SetMandelstam"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SetMandelstam"]], "."}], "Text", 
            CellTags -> "Mandelstam"]}, Open]], Cell["Map2", "ObjectName", 
         CellTags -> "Map2"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Map2"], 
           Cell["Map2[f, exp] is equivalent to Map if Nterms[exp] > 0, \
otherwise Map2[f, exp] gives f[exp].", "Text", CellTags -> "Map2"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["NTerms", RuleDelayed[ButtonData, "NTerms"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "NTerms"]], 
              "."}], "Text", CellTags -> "Map2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Map2"], Cell[CellGroupData[{Cell[BoxData[
                \(Map2[\(f, \(a - b\)\)]\)], "Input", CellTags -> "Map2"], 
              Cell[BoxData[\(TraditionalForm\`\(\(f(a)\) + \(f(\(-b\))\)\)\)]
                , "Output", CellTags -> "Map2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Map2[\(f, x\)]\)], "Input", 
               CellTags -> "Map2"], Cell[BoxData[\(TraditionalForm\`\(f(x)\)\)
                ], "Output", CellTags -> "Map2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Map2[\(f, \({a, b, c}\)\)]\)], 
               "Input", CellTags -> "Map2"], Cell[BoxData[
                \(TraditionalForm\`\(f(\({a, b, c}\))\)\)], "Output", 
               CellTags -> "Map2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Map2[\(f, 1\)]\)], "Input", CellTags -> "Map2"], 
              Cell[BoxData[\(TraditionalForm\`\(f(1)\)\)], "Output", 
               CellTags -> "Map2"]}, Open]]}, Open]], Cell["MemoryAvailable", 
         "ObjectName", CellTags -> "MemoryAvailable"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "MemoryAvailable"], Cell["MemoryAvailable is an \
option of MemSet. It can be set to an integer n, where n is the available \
amount of main memory in Mega Byte. The default setting is $MemoryAvailable."\
, "Text", CellTags -> "MemoryAvailable"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["MemSet", RuleDelayed[ButtonData, "MemSet"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "MemSet"]], 
              ", ", 
              ButtonBox["$MemoryAvailable", 
                RuleDelayed[ButtonData, "$MemoryAvailable"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "$MemoryAvailable"]], "."}], "Text", 
            CellTags -> "MemoryAvailable"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["MemSet", "ObjectName", CellTags -> "MemSet"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "MemSet"], Cell[TextData[{"MemSet[f[x_], body] is \
like f[x_] := f[x] = body, but dependend on the value of the setting of \
MemoryAvailable \[Rule] memorycut (memorycut - MemoryInUse[]/", Cell[BoxData[
                \(TraditionalForm\`\(10\^6\)\)]], 
              ") MemSet[f[x_], body] may evaluate as f[x_] := body."}], 
            "Text", CellTags -> "MemSet"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["MemoryAvailable", 
                RuleDelayed[ButtonData, "MemoryAvailable"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MemoryAvailable"]], "."}], "Text", 
            CellTags -> "MemSet"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["MetricTensor", "ObjectName", CellTags -> "MetricTensor"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "MetricTensor"], Cell[TextData[{"MetricTensor[", 
              Cell[BoxData[\(TraditionalForm\`\(\[Mu],\ \[Nu]\)\)]], 
              "] is the metric tensor. The default dimension is 4."}], 
            "Text", CellTags -> "MetricTensor"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalcExternal", 
                RuleDelayed[ButtonData, "FeynCalcExternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcExternal"]], ", ", 
              ButtonBox["FCE", RuleDelayed[ButtonData, "FCE"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCE"]], 
              ", ", 
              ButtonBox["FCI", RuleDelayed[ButtonData, "FCI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCI"]], 
              ", ", 
              ButtonBox["MT", RuleDelayed[ButtonData, "MT"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "MT"]], 
              ", ", 
              ButtonBox["MTD", RuleDelayed[ButtonData, "MTD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "MTD"]], 
              "."}], "Text", CellTags -> "MetricTensor"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "MetricTensor"], Cell[CellGroupData[{Cell[BoxData[
                \(MetricTensor[\(\[Alpha], \[Beta]\)]\)], "Input", 
               CellTags -> "MetricTensor"], Cell[BoxData[
                \(TraditionalForm\`\(g\^\(\[Alpha]\[Beta]\)\)\)], "Output", 
               CellTags -> "MetricTensor"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Contract[\(%\ %\)]\)], "Input", 
               CellTags -> "MetricTensor"], Cell[BoxData[
                \(TraditionalForm\`4\)], "Output", CellTags -> 
                "MetricTensor"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(MetricTensor[\(\[Alpha], \[Beta], \(Dimension \[Rule] n\)\)
                   ]\)], "Input", CellTags -> "MetricTensor"], Cell[BoxData[
                \(TraditionalForm\`\(g\^\(\[Alpha]\[Beta]\)\)\)], "Output", 
               CellTags -> "MetricTensor"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Contract[\(%\ %\)]\)], "Input", 
               CellTags -> "MetricTensor"], Cell[BoxData[
                \(TraditionalForm\`n\)], "Output", CellTags -> 
                "MetricTensor"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(MetricTensor[\(a, b\)]\)]\)], "Input", 
               CellTags -> "MetricTensor"], Cell[BoxData[
                \(MetricTensor[\(a, b\)]\)], "Output", CellTags -> 
                "MetricTensor"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(MetricTensor[
                     \(a, b, \(Dimension \[Rule] D\)\)]\)]\)], "Input", 
               CellTags -> "MetricTensor"], Cell[BoxData[
                \(MetricTensor[\(a, b, \(Dimension \[Rule] D\)\)]\)], 
               "Output", CellTags -> "MetricTensor"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(FCE[\(MetricTensor[\(a, b\)]\)]\)]\)], 
               "Input", CellTags -> "MetricTensor"], Cell[BoxData[
                \(HighEnergyPhysics`fctools`FeynCalcExternal`Private`metricm\
ul[\(a, b\)]\)], "Output", CellTags -> "MetricTensor"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(FCE[\(MetricTensor[
                       \(a, b, \(Dimension \[Rule] D\)\)]\)]\)]\)], "Input", 
               CellTags -> "MetricTensor"], Cell[BoxData[
                \(HighEnergyPhysics`fctools`FeynCalcExternal`Private`metricm\
ul[\(a, b, \(Dimension \[Rule] D\)\)]\)], "Output", CellTags -> 
                "MetricTensor"]}, Open]]}, Open]], Cell["MLimit", 
         "ObjectName", CellTags -> "MLimit"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "MLimit"], Cell["MLimit[expr, lims] takes multiple \
limits of expr using the limits lims.", "Text", CellTags -> "MLimit"]}, 
          Open]], Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "MLimit"], Cell[CellGroupData[{Cell[BoxData[
                \(MLimit[\(\(\(y\ \(Log[y]\)\) + 
                       \(\(Sin[\(x - 1\)]\)/\((x - 1)\)\)\), \(x \[Rule] 1\),
                      \(y \[Rule] 0\)\)]\)], "Input", CellTags -> "MLimit"], 
              Cell[BoxData[
                \(TraditionalForm\`\(MLimit(
                     \(\(\(y\ \(log(y)\)\) - \(sin(\(1 - x\))\)\/\(x - 1\)\),
                        \(x \[Rule] 1\), \(y \[Rule] 0\)\))\)\)], "Output", 
               CellTags -> "MLimit"]}, Open]]}, Open]], 
        Cell["Momentum", "ObjectName", CellTags -> "Momentum"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Momentum"], Cell["Momentum[p] is the head of a four \
momentum (p). The internal representation of a four-dimensional p is \
Momentum[p]. For other than four dimensions: Momentum[p, dim]. Momentum[p, 4] \
simplifies to Momentum[p].", "Text", CellTags -> "Momentum"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracGamma", RuleDelayed[ButtonData, "DiracGamma"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracGamma"]], ", ", 
              ButtonBox["Eps", RuleDelayed[ButtonData, "Eps"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Eps"]], 
              ", ", 
              ButtonBox["LorentzIndex", 
                RuleDelayed[ButtonData, "LorentzIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LorentzIndex"]], ", ", 
              ButtonBox["MomentumExpand", 
                RuleDelayed[ButtonData, "MomentumExpand"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MomentumExpand"]], "."}], "Text", 
            CellTags -> "Momentum"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Momentum"], 
           Cell["This is a four dimensional momentum.", "Text", 
            CellTags -> "Momentum"], Cell[CellGroupData[{Cell[BoxData[
                \(Momentum[p]\)], "Input", CellTags -> "Momentum"], 
              Cell[BoxData[\(TraditionalForm\`p\)], "Output", CellTags -> 
                "Momentum"]}, Open]], Cell["As an optional second argument \
the dimension must be specified if it is different from 4.", "Text", 
            CellTags -> "Momentum"], Cell[CellGroupData[{Cell[BoxData[
                \(Momentum[\(p, D\)]\)], "Input", CellTags -> "Momentum"], 
              Cell[BoxData[\(TraditionalForm\`p\)], "Output", CellTags -> 
                "Momentum"]}, Open]], 
           Cell["The dimension index is supressed in the output.", "Text", 
            CellTags -> "Momentum"], Cell[CellGroupData[{Cell[BoxData[
                \(\(Momentum[\(p, d\)]\)//StandardForm\)], "Input", 
               CellTags -> "Momentum"], Cell[BoxData[\(Momentum[\(p, d\)]\)], 
               "Output", CellTags -> "Momentum"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(a1 = \(Momentum[\(-q\)]\)\)], 
               "Input", CellTags -> "Momentum"], Cell[BoxData[
                \(TraditionalForm\`\(-q\)\)], "Output", CellTags -> 
                "Momentum"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(a1//StandardForm\)], "Input", CellTags -> "Momentum"], 
              Cell[BoxData[\(-\(Momentum[q]\)\)], "Output", CellTags -> 
                "Momentum"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(a2\ =\ \(\(Momentum[\(p - q\)]\)\ +\ \(Momentum[\(2q\)]\)\)
                  \)], "Input", CellTags -> "Momentum"], Cell[BoxData[
                \(TraditionalForm\`\(\((p - q)\) + \(2\ q\)\)\)], "Output", 
               CellTags -> "Momentum"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(a2//StandardForm\)], "Input", CellTags -> 
                "Momentum"], Cell[BoxData[
                \(\(Momentum[\(p - q\)]\) + \(2\ \(Momentum[q]\)\)\)], 
               "Output", CellTags -> "Momentum"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(a2//MomentumExpand\)//StandardForm\)], "Input", 
               CellTags -> "Momentum"], Cell[BoxData[
                \(\(Momentum[p]\) + \(Momentum[q]\)\)], "Output", CellTags -> 
                "Momentum"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(a2//MomentumCombine\)//StandardForm\)], "Input", 
               CellTags -> "Momentum"], Cell[BoxData[
                \(\(Momentum[\(p - q\)]\) + \(2\ \(Momentum[q]\)\)\)], 
               "Output", CellTags -> "Momentum"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(ChangeDimension[\(\(Momentum[p]\), d\)]\)//StandardForm\)]\
, "Input", CellTags -> "Momentum"], Cell[BoxData[\(Momentum[\(p, d\)]\)], 
               "Output", CellTags -> "Momentum"]}, Open]], Cell[BoxData[
             \(Clear[\(a1, a2\)]\)], "Input", CellTags -> "Momentum"]}, 
          Open]], Cell["MomentumCombine", "ObjectName", 
         CellTags -> "MomentumCombine"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "MomentumCombine"], Cell["MomentumCombine[expr] is the inverse \
operation to MomentumExpand and ExpandScalarProduct. MomentumCombine combines \
also Pair`s.", "Text", CellTags -> "MomentumCombine"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[MomentumCombine]\)], 
               "Input", CellTags -> "MomentumCombine"], Cell[BoxData[
                \(TraditionalForm\`\({LeafCount \[Rule] 1000}\)\)], "Output", 
               CellTags -> "MomentumCombine"]}, Open]], 
           Cell[TextData[{"See also: ", 
              ButtonBox["ExpandScalarProduct", 
                RuleDelayed[ButtonData, "ExpandScalarProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandScalarProduct"]], ", ", 
              ButtonBox["Momentum", RuleDelayed[ButtonData, "Momentum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Momentum"]], ", ", 
              ButtonBox["MomentumExpand", 
                RuleDelayed[ButtonData, "MomentumExpand"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MomentumExpand"]], ", ", 
              ButtonBox["MomentumCombine2", 
                RuleDelayed[ButtonData, "MomentumCombine2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MomentumCombine2"]], "."}], "Text", 
            CellTags -> "MomentumCombine"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "MomentumCombine"], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(Momentum[p]\) - \(2\ \(Momentum[q]\)\)\ \)//\ 
                     MomentumCombine\)\ //\ StandardForm\)], "Input", 
               CellTags -> "MomentumCombine"], Cell[BoxData[
                \(\(Momentum[p]\) - \(2\ \(Momentum[q]\)\)\)], "Output", 
               CellTags -> "MomentumCombine"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(\(FV[\(p, \[Mu]\)]\)\ +\ \(2\ \(FV[\(q, \[Mu]\)]\)\)
                     \ \)\)], "Input", CellTags -> "MomentumCombine"], 
              Cell[BoxData[\(TraditionalForm\`\(p\^\[Mu] + \(2\ q\^\[Mu]\)\)\)
                ], "Output", CellTags -> "MomentumCombine"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(MomentumCombine[t1]\)], 
               "Input", CellTags -> "MomentumCombine"], Cell[BoxData[
                \(TraditionalForm\`\(p\^\[Mu] + \(2\ q\^\[Mu]\)\)\)], 
               "Output", CellTags -> "MomentumCombine"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(MomentumCombine[t1]\)//StandardForm\)], "Input", 
               CellTags -> "MomentumCombine"], Cell[BoxData[
                \(\(FV[\(p, \[Mu]\)]\) + \(2\ \(FV[\(q, \[Mu]\)]\)\)\)], 
               "Output", CellTags -> "MomentumCombine"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(MomentumCombine[t1]\)//ExpandScalarProduct\)], "Input", 
               CellTags -> "MomentumCombine"], Cell[BoxData[
                \(TraditionalForm\`\(p\^\[Mu] + \(2\ q\^\[Mu]\)\)\)], 
               "Output", CellTags -> "MomentumCombine"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(StandardForm[%]\)], "Input", 
               CellTags -> "MomentumCombine"], Cell[BoxData[
                \(\(FV[\(p, \[Mu]\)]\) + \(2\ \(FV[\(q, \[Mu]\)]\)\)\)], 
               "Output", CellTags -> "MomentumCombine"]}, Open]], 
           Cell[BoxData[\(Clear[t1]\)], "Input", CellTags -> 
             "MomentumCombine"]}, Open]], Cell["MomentumCombine2", 
         "ObjectName", CellTags -> "MomentumCombine2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "MomentumCombine2"], Cell["MomentumCombine2[expr]  is \
the inverse operation to MomentumExpand and ExpandScalarProduct. \
MomentumCombine2 combines also FourVectors.", "Text", CellTags -> 
             "MomentumCombine2"], Cell[TextData[{"See also: ", 
              ButtonBox["MomentumCombine", 
                RuleDelayed[ButtonData, "MomentumCombine"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MomentumCombine"]], ", ", 
              ButtonBox["MomentumExpand", 
                RuleDelayed[ButtonData, "MomentumExpand"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MomentumExpand"]], ", ", 
              ButtonBox["ExpandScalarProduct", 
                RuleDelayed[ButtonData, "ExpandScalarProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandScalarProduct"]], ", ", 
              ButtonBox["FourVector", RuleDelayed[ButtonData, "FourVector"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FourVector"]], "."}], "Text", 
            CellTags -> "MomentumCombine2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "MomentumCombine2"], Cell[CellGroupData[{Cell[BoxData[
                \(\(3\ \(Pair[\(\(LorentzIndex[\[Mu]]\), \(Momentum[p]\)\)]\)
                    \) + \(2\ \(Pair[\(\(LorentzIndex[\[Mu]]\), 
                         \(Momentum[q]\)\)]\)\)\)], "Input", CellTags -> 
                "MomentumCombine2"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"3", " ", SuperscriptBox[FormBox["p", 
                       "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]]}], "+", 
                   RowBox[{"2", " ", SuperscriptBox[FormBox["q", 
                       "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]]}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "MomentumCombine2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(\(MomentumCombine2[%]\)//StandardForm\)], 
               "Input", CellTags -> "MomentumCombine2"], Cell[BoxData[
                \(Pair[\(\(LorentzIndex[\[Mu]]\), 
                     \(Momentum[\(\(3\ p\) + \(2\ q\)\)]\)\)]\)], "Output", 
               CellTags -> "MomentumCombine2"]}, Open]]}, Open]], 
        Cell["MomentumExpand", "ObjectName", CellTags -> "MomentumExpand"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "MomentumExpand"], Cell["MomentumExpand[expr] expands \
Momentum[a+b+ ...] in expr into Momentum[a] + Momentum[b] + ... .", "Text", 
            CellTags -> "MomentumExpand"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["ExpandScalarProduct", 
                RuleDelayed[ButtonData, "ExpandScalarProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandScalarProduct"]], ", ", 
              ButtonBox["MomentumCombine", 
                RuleDelayed[ButtonData, "MomentumCombine"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MomentumCombine"]], "."}], "Text", 
            CellTags -> "MomentumExpand"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "MomentumExpand"], Cell[CellGroupData[{Cell[BoxData[
                \(\(MomentumExpand[\(Momentum[\(p + q\)]\)]\)//StandardForm\)]\
, "Input", CellTags -> "MomentumExpand"], Cell[BoxData[
                \(\(Momentum[p]\) + \(Momentum[q]\)\)], "Output", CellTags -> 
                "MomentumExpand"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ScalarProduct[\(\(p + q\), r\)]\)], "Input", CellTags -> 
                "MomentumExpand"], Cell[BoxData[FormBox[RowBox[{"(", FormBox[
                    \(p + q\), "TraditionalForm"], ")", "\[CenterDot]", 
                   FormBox["r", "TraditionalForm"]}], TraditionalForm]], 
               "Output", CellTags -> "MomentumExpand"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "MomentumExpand"], Cell[BoxData[
                \(Pair[\(\(Momentum[\(p + q\)]\), \(Momentum[r]\)\)]\)], 
               "Output", CellTags -> "MomentumExpand"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(MomentumExpand[\(ScalarProduct[\(\(p + q\), r\)]\)]\)], 
               "Input", CellTags -> "MomentumExpand"], Cell[BoxData[
                FormBox[RowBox[{"(", TagBox[FormBox[\(p + q\), 
                     "TraditionalForm"], TraditionalForm, Editable -> True], 
                   ")", ".", "(", TagBox[FormBox["r", "TraditionalForm"], 
                    TraditionalForm, Editable -> True], ")"}], 
                 TraditionalForm]], "Output", CellTags -> "MomentumExpand"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], 
               "Input", CellTags -> "MomentumExpand"], Cell[BoxData[
                \(Pair[\(\(\(Momentum[p]\) + \(Momentum[q]\)\), 
                     \(Momentum[r]\)\)]\)], "Output", CellTags -> 
                "MomentumExpand"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(MomentumExpand[\(ScalarProduct[\(\(p + q\), \(r - p\)\)]\)]
                  \)], "Input", CellTags -> "MomentumExpand"], 
              Cell[BoxData[FormBox[RowBox[{"(", TagBox[FormBox[\(p + q\), 
                     "TraditionalForm"], TraditionalForm, Editable -> True], 
                   ")", ".", "(", TagBox[FormBox[\(r - p\), 
                     "TraditionalForm"], TraditionalForm, Editable -> True], 
                   ")"}], TraditionalForm]], "Output", CellTags -> 
                "MomentumExpand"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%//StandardForm\)], "Input", CellTags -> "MomentumExpand"], 
              Cell[BoxData[
                \(Pair[\(\(\(Momentum[p]\) + \(Momentum[q]\)\), 
                     \(\(-\(Momentum[p]\)\) + \(Momentum[r]\)\)\)]\)], 
               "Output", CellTags -> "MomentumExpand"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Calc[%]\)], "Input", 
               CellTags -> "MomentumExpand"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{"-", SuperscriptBox[FormBox["p", 
                       "TraditionalForm"], "2"]}], "-", RowBox[{FormBox["p", 
                      "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                      "TraditionalForm"]}], "+", RowBox[{FormBox["p", 
                      "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                      "TraditionalForm"]}], "+", RowBox[{FormBox["q", 
                      "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                      "TraditionalForm"]}]}], TraditionalForm]], "Output", 
               CellTags -> "MomentumExpand"]}, Open]]}, Open]], 
        Cell["MT", "ObjectName", CellTags -> "MT"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "MT"], Cell[TextData[{"MT[", Cell[BoxData[
                \(TraditionalForm\`\(\[Mu],\ \[Nu]\)\)]], 
              "] is the metric tensor in 4 dimensions."}], "Text", 
            CellTags -> "MT"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalcExternal", 
                RuleDelayed[ButtonData, "FeynCalcExternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcExternal"]], ", ", 
              ButtonBox["FCE", RuleDelayed[ButtonData, "FCE"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCE"]], 
              ", ", 
              ButtonBox["FCI", RuleDelayed[ButtonData, "FCI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCI"]], 
              ", ", 
              ButtonBox["MetricTensor", 
                RuleDelayed[ButtonData, "MetricTensor"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MetricTensor"]], ", ", 
              ButtonBox["MTD", RuleDelayed[ButtonData, "MTD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "MTD"]], 
              "."}], "Text", CellTags -> "MT"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "MT"], Cell[CellGroupData[{Cell[BoxData[
                \(MT[\(\[Alpha], \[Beta]\)]\)], "Input", CellTags -> "MT"], 
              Cell[BoxData[\(TraditionalForm\`\(g\^\(\[Alpha]\[Beta]\)\)\)], 
               "Output", CellTags -> "MT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Contract[\(\(MT[\(\[Alpha], \[Beta]\)]\)\ 
                     \(MT[\(\[Alpha], \[Beta]\)]\)\)]\)], "Input", 
               CellTags -> "MT"], Cell[BoxData[\(TraditionalForm\`4\)], 
               "Output", CellTags -> "MT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(MT[\(a, b\)]\)//StandardForm\)
                ], "Input", CellTags -> "MT"], Cell[BoxData[\(MT[\(a, b\)]\)]
                , "Output", CellTags -> "MT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(FCI[\(MT[\(a, b\)]\)]\)//StandardForm\)], "Input", 
               CellTags -> "MT"], Cell[BoxData[
                \(Pair[\(\(LorentzIndex[a]\), \(LorentzIndex[b]\)\)]\)], 
               "Output", CellTags -> "MT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(FCE[\(FCI[\(MT[\(a, b\)]\)]\)]\)//StandardForm\)], 
               "Input", CellTags -> "MT"], Cell[BoxData[\(MT[\(a, b\)]\)], 
               "Output", CellTags -> "MT"]}, Open]]}, Open]], 
        Cell["MTD", "ObjectName", CellTags -> "MTD"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "MTD"], Cell[TextData[{"MTD[", Cell[BoxData[
                \(TraditionalForm\`\(\[Mu],\ \[Nu]\)\)]], 
              "] is the metric tensor in D dimensions."}], "Text", 
            CellTags -> "MTD"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalcExternal", 
                RuleDelayed[ButtonData, "FeynCalcExternal"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalcExternal"]], ", ", 
              ButtonBox["FCE", RuleDelayed[ButtonData, "FCE"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCE"]], 
              ", ", 
              ButtonBox["FCI", RuleDelayed[ButtonData, "FCI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCI"]], 
              ", ", 
              ButtonBox["MetricTensor", 
                RuleDelayed[ButtonData, "MetricTensor"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MetricTensor"]], ", ", 
              ButtonBox["MT", RuleDelayed[ButtonData, "MT"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "MT"]], 
              "."}], "Text", CellTags -> "MTD"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "MTD"], Cell[CellGroupData[{Cell[BoxData[
                \(MTD[\(\[Alpha], \[Beta]\)]\)], "Input", CellTags -> "MTD"], 
              Cell[BoxData[\(TraditionalForm\`\(g\^\(\[Alpha]\[Beta]\)\)\)], 
               "Output", CellTags -> "MTD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Contract[\(\(MTD[\(\[Alpha], \[Beta]\)]\)\ 
                     \(MTD[\(\[Alpha], \[Beta]\)]\)\)]\)], "Input", 
               CellTags -> "MTD"], Cell[BoxData[\(TraditionalForm\`D\)], 
               "Output", CellTags -> "MTD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(MTD[\(\[Alpha], \[Beta]\)]\)//StandardForm\)], "Input", 
               CellTags -> "MTD"], Cell[BoxData[\(MTD[\(\[Alpha], \[Beta]\)]\)
                ], "Output", CellTags -> "MTD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(FCI[\(MTD[\(\[Alpha], \[Beta]\)]\)]\)//StandardForm\)], 
               "Input", CellTags -> "MTD"], Cell[BoxData[
                \(Pair[\(\(LorentzIndex[\(\[Alpha], D\)]\), 
                     \(LorentzIndex[\(\[Beta], D\)]\)\)]\)], "Output", 
               CellTags -> "MTD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(FCE[\(FCI[\(MTD[\(\[Mu], \[Nu]\)]\)]\)]\)//StandardForm\)]\
, "Input", CellTags -> "MTD"], Cell[BoxData[\(MTD[\(\[Mu], \[Nu]\)]\)], 
               "Output", CellTags -> "MTD"]}, Open]]}, Open]], 
        Cell["NegativeInteger", "ObjectName", CellTags -> "NegativeInteger"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "NegativeInteger"], Cell["NegativeInteger is a data \
type. E.g. DataType[n, NegativeInteger] can be set to True.", "Text", 
            CellTags -> "NegativeInteger"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DataType", RuleDelayed[ButtonData, "DataType"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DataType"]], "."}], "Text", 
            CellTags -> "NegativeInteger"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["Nf", "ObjectName", CellTags -> "Nf"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Nf"], Cell["Nf denotes the number of flavors.", 
            "Text", CellTags -> "Nf"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Amplitude", RuleDelayed[ButtonData, "Amplitude"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Amplitude"]], ", ", 
              ButtonBox["CounterTerm", RuleDelayed[ButtonData, 
                 "CounterTerm"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CounterTerm"]], ", ", 
              ButtonBox["Convolute", RuleDelayed[ButtonData, "Convolute"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Convolute"]], ", ", 
              ButtonBox["AnomalousDimension", 
                RuleDelayed[ButtonData, "AnomalousDimension"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "AnomalousDimension"]], ", ", 
              ButtonBox["SplittingFunction", 
                RuleDelayed[ButtonData, "SplittingFunction"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SplittingFunction"]], "."}], "Text", 
            CellTags -> "Nf"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["Nielsen", "ObjectName", CellTags -> "Nielsen"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Nielsen"], Cell[
            "Nielsen[i,j, x] denotes Nielsen's polylogarithm.", "Text", 
            CellTags -> "Nielsen"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[Nielsen]\)], "Input", CellTags -> "Nielsen"], 
              Cell[BoxData[\(TraditionalForm\`\({PolyLog \[Rule] False}\)\)], 
               "Output", CellTags -> "Nielsen"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["SimplifyPolyLog", 
                RuleDelayed[ButtonData, "SimplifyPolyLog"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SimplifyPolyLog"]], "."}], "Text", 
            CellTags -> "Nielsen"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Nielsen"], Cell[CellGroupData[{Cell[BoxData[
                \(Nielsen[\(1, 2, x\)]\)], "Input", CellTags -> "Nielsen"], 
              Cell[BoxData[FormBox[RowBox[{SubscriptBox["S", RowBox[
                     {FormBox["1", "TraditionalForm"], FormBox["2", 
                       "TraditionalForm"]}]], "(", "x", ")"}], 
                 TraditionalForm]], "Output", CellTags -> "Nielsen"]}, 
             Open]], Cell["Numerical evaluation is done via \
N[Nielsen[n_,p_,x_]] := (-1)^(n+p-1)/(n-1)!/p! NIntegrate[Log[1-x t]^p \
Log[t]^(n-1)/t,{t,0,1}];", "Text", CellTags -> "Nielsen"], 
           Cell[CellGroupData[{Cell[BoxData[\(N[\(Nielsen[\(1, 2, .45\)]\)]\)]
                , "Input", CellTags -> "Nielsen"], Cell[BoxData[
                \(TraditionalForm\`0.07287162612104649`\)], "Output", 
               CellTags -> "Nielsen"]}, Open]], 
           Cell["Some special values are built in.", "Text", 
            CellTags -> "Nielsen"], Cell[CellGroupData[{Cell[BoxData[
                \({\(Nielsen[\(1, 2, 0\)]\), \(Nielsen[\(1, 2, \(-1\)\)]\), 
                    \(Nielsen[\(1, 2, \(1/2\)\)]\), \(Nielsen[\(1, 2, 1\)]\)}
                \)], "Input", CellTags -> "Nielsen"], Cell[BoxData[
                \(TraditionalForm\`\({0, 
                      \*TagBox[\(\[Zeta](
                           \(\*TagBox["3", Zeta, Rule[Editable, True]]\))\), 
                         InterpretTemplate[Function[BoxForm`e$, 
                           Zeta[BoxForm`e$]]]]\/8, 
                      \*TagBox[\(\[Zeta](
                           \(\*TagBox["3", Zeta, Rule[Editable, True]]\))\), 
                         InterpretTemplate[Function[BoxForm`e$, 
                           Zeta[BoxForm`e$]]]]\/8, 
                      \*TagBox[\(\[Zeta](
                          \(\*TagBox["3", Zeta, Rule[Editable, True]]\))\), 
                        InterpretTemplate[Function[BoxForm`e$, 
                          Zeta[BoxForm`e$]]]]}\)\)], "Output", CellTags -> 
                "Nielsen"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Nielsen[\(1, 2, x, \(PolyLog \[Rule] True\)\)]\)], "Input", 
               CellTags -> "Nielsen"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/2\ \(log(x)\)\ 
                       \(\(log\^2\)(\(1 - x\))\)\) + 
                     \(\(\(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_2(\(1 - x\))\)\ \(log(\(1 - x\))\)\) - 
                     \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_3(\(1 - x\))\) + \*TagBox[\(
                        \[Zeta](\(\*TagBox["3", Zeta, Rule[Editable, True]]
                          \))\), InterpretTemplate[Function[BoxForm`e$, 
                         Zeta[BoxForm`e$]]]]\)\)], "Output", CellTags -> 
                "Nielsen"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Nielsen[\(1, 3, x, \(PolyLog \[Rule] True\)\)]\)], "Input", 
               CellTags -> "Nielsen"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(-\(1\/6\)\)\ \(log(x)\)\ 
                       \(\(log\^3\)(\(1 - x\))\)\) - 
                     \(1\/2\ \(\(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_2(\(1 - x\))\)\ \(\(log\^2\)(\(1 - x\))\)\) + 
                     \(\(\(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_3(\(1 - x\))\)\ \(log(\(1 - x\))\)\) - 
                     \(\(\*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_4(\(1 - x\))\) + \[Pi]\^4\/90\)\)], "Output", CellTags -> "Nielsen"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Nielsen[\(3, 1, x, \(PolyLog \[Rule] True\)\)]\)], "Input", 
               CellTags -> "Nielsen"], Cell[BoxData[
                \(TraditionalForm\`\(\(\*
                        InterpretationBox["Li", PolyLog, 
                         Rule[Editable, False], Rule[Selectable, False]]\)\_4\
(x)\)\)], "Output", CellTags -> "Nielsen"]}, Open]]}, Open]], 
        Cell["NonCommFreeQ", "ObjectName", CellTags -> "NonCommFreeQ"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "NonCommFreeQ"], Cell["NonCommFreeQ[exp] yields True \
if exp contains no non-commutative objects (i.e. those objects which are \
listed in $NonComm) or only non-commutative objects inside DiracTrace's or \
SUNTrace's.", "Text", CellTags -> "NonCommFreeQ"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["$NonComm", RuleDelayed[ButtonData, "$NonComm"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "$NonComm"]], ", ", 
              ButtonBox["NonCommQ", RuleDelayed[ButtonData, "NonCommQ"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "NonCommQ"]], ", ", 
              ButtonBox["DiracTrace", RuleDelayed[ButtonData, "DiracTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrace"]], ", ", 
              ButtonBox["SUNTrace", RuleDelayed[ButtonData, "SUNTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNTrace"]], "."}], "Text", 
            CellTags -> "NonCommFreeQ"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["NonCommQ", "ObjectName", CellTags -> "NonCommQ"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "NonCommQ"], Cell["NonCommQ[exp] yields True if exp \
contains non-commutative objects (i.e. those objects which are listed in \
$NonComm) not inside DiracTrace's or SUNTrace's.", "Text", 
            CellTags -> "NonCommQ"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["$NonComm", RuleDelayed[ButtonData, "$NonComm"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "$NonComm"]], ", ", 
              ButtonBox["NonCommFreeQ", 
                RuleDelayed[ButtonData, "NonCommFreeQ"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "NonCommFreeQ"]], ", ", 
              ButtonBox["DiracTrace", RuleDelayed[ButtonData, "DiracTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrace"]], ", ", 
              ButtonBox["SUNTrace", RuleDelayed[ButtonData, "SUNTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNTrace"]], "."}], "Text", 
            CellTags -> "NonCommQ"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["NonCommutative", "ObjectName", CellTags -> "NonCommutative"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "NonCommutative"], Cell["NonCommutative is a data \
type which may be used, e.g.,  as: DataType[x, NonCommutative] = True.", 
            "Text", CellTags -> "NonCommutative"], 
           Cell[TextData[{"See also:", " ", 
              ButtonBox["DataType", RuleDelayed[ButtonData, "DataType"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DataType"]], ", ", 
              ButtonBox["DeclareNonCommutative", 
                RuleDelayed[ButtonData, "DeclareNonCommutative"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeclareNonCommutative"]], "."}], "Text", 
            CellTags -> "NonCommutative"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["NTerms", "ObjectName", CellTags -> "NTerms"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "NTerms"], Cell["NTerms[x] is equivalent to Length if \
x is a sum; otherwise NTerms[x] returns 1, except NTerms[0] \[Rule] 0.", 
            "Text", CellTags -> "NTerms"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "NTerms"], Cell[CellGroupData[{Cell[BoxData[
                \(NTerms[\(a - b\)]\)], "Input", CellTags -> "NTerms"], 
              Cell[BoxData[\(TraditionalForm\`2\)], "Output", CellTags -> 
                "NTerms"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(NTerms[\(a\ b\ c\)]\)], "Input", CellTags -> "NTerms"], 
              Cell[BoxData[\(TraditionalForm\`1\)], "Output", CellTags -> 
                "NTerms"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(NTerms[9]\)], "Input", CellTags -> "NTerms"], Cell[BoxData[
                \(TraditionalForm\`1\)], "Output", CellTags -> "NTerms"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(NTerms[0]\)], 
               "Input", CellTags -> "NTerms"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> "NTerms"]}, 
             Open]]}, Open]], Cell["NumberOfMetricTensors", "ObjectName", 
         CellTags -> "NumberOfMetricTensors"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "NumberOfMetricTensors"], 
           Cell["NumberOfMetricTensors is an option of Tdec.", "Text", 
            CellTags -> "NumberOfMetricTensors"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Tdec", RuleDelayed[ButtonData, "Tdec"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Tdec"]], 
              "."}], "Text", CellTags -> "NumberOfMetricTensors"], 
           Cell[BoxData[""], "Input"]}, Open]], Cell["NumericalFactor", 
         "ObjectName", CellTags -> "NumericalFactor"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "NumericalFactor"], Cell["NumericalFactor[expr] gives \
the overall numerical factor of expr.", "Text", CellTags -> 
             "NumericalFactor"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["NumericQ1", "ObjectName", CellTags -> "NumericQ1"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "NumericQ1"], Cell["NumericQ1[x,{a,b,..}] is like \
NumericQ, but assumes that {a,b,..} are numeric quantities.", "Text", 
            CellTags -> "NumericQ1"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "NumericQ1"], Cell[CellGroupData[{Cell[BoxData[
                \(NumericQ[\(\(3\ a\) + \(Log[b]\) + c\^2\)]\)], "Input", 
               CellTags -> "NumericQ1"], Cell[BoxData[
                \(TraditionalForm\`False\)], "Output", CellTags -> 
                "NumericQ1"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(NumericQ1[\(\(\(3\ a\) + \(Log[b]\) + c\^2\), \({}\)\)]\)], 
               "Input", CellTags -> "NumericQ1"], Cell[BoxData[
                \(TraditionalForm\`False\)], "Output", CellTags -> 
                "NumericQ1"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(NumericQ1[\(\(\(3\ a\) + \(Log[b]\) + c\^2\), \({a, b, c}\)
                    \)]\)], "Input", CellTags -> "NumericQ1"], Cell[BoxData[
                \(TraditionalForm\`True\)], "Output", CellTags -> 
                "NumericQ1"]}, Open]]}, Open]], Cell["OneLoop", "ObjectName", 
         CellTags -> "OneLoop"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "OneLoop"], 
           Cell[TextData[{"OneLoop[q, amplitude] calculates the one-loop \
Feynman diagram amplitude (", StyleBox["n", Rule[FontSlant, "Italic"]], 
              "-point, where ", StyleBox["n", Rule[FontSlant, "Italic"]], "\[\
LessEqual]4 and the highest tensor rank of the integration momenta (after \
cancellation of scalar products) may be up to 3; unless OneLoopSimplify is \
used)."}], "Text", CellTags -> "OneLoop"], Cell["The argument q denotes the \
integration variable, i.e., the loop momentum. OneLoop[name, q, amplitude] \
has as first argument a name of the amplitude. If the second argument has \
head FeynAmp then OneLoop[q, FeynAmp[name, k, expr]] and \
OneLoop[FeynAmp[name, k, expr]] tranform to OneLoop[name, k, expr].", "Text", 
            CellTags -> "OneLoop"], Cell[TextData[{"NOTICE: While OneLoop is \
restricted to 't Hooft Feynman gauge, the function ", 
              ButtonBox["OneLoopSimplify", 
                RuleDelayed[ButtonData, "OneLoopSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSimplify"]], 
              " does not have this restriction (but is usually slower)."}], 
            "Text", CellTags -> "OneLoop"], Cell[TextData[{"WARNING: If you \
encounter anomalies: The default setting of $West is True, i.e., the way ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\ \(
                      tr(\(\[Gamma]\^\[Mu] \[Gamma]\^\[Nu] \[Gamma]\^\[Rho] 
                         \[Gamma]\^\[Sigma] \[Gamma]\^\[Tau] 
                         \[Gamma]\^\[Lambda] \[Gamma]\^5\))\)\)\)]], " is \
calculated in D dimensions has changed compared to the old FeynCalc version. \
Please keep in mind that the issue of ", Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^5\)\)]], 
              "schemes is inherintly tricky."}], "Text", CellTags -> 
             "OneLoop"], Cell[CellGroupData[{Cell[BoxData[\(Options[OneLoop]\)
                ], "Input", CellTags -> "OneLoop"], Cell[BoxData[
                \(TraditionalForm\`\({\(Apart2 \[Rule] True\), 
                      \(CancelQP \[Rule] True\), 
                      \(DenominatorOrder \[Rule] False\), 
                      \(Dimension \[Rule] D\), 
                      \(FinalSubstitutions \[Rule] \({}\)\), 
                      \(Factoring \[Rule] False\), 
                      \(FormatType \[Rule] InputForm\), 
                      \(InitialSubstitutions \[Rule] \({}\)\), 
                      \(IntermediateSubstitutions \[Rule] \({}\)\), 
                      \(IsolateNames \[Rule] False\), 
                      \(Mandelstam \[Rule] \({}\)\), 
                      \(OneLoopSimplify \[Rule] False\), 
                      \(Prefactor \[Rule] 1\), \(ReduceGamma \[Rule] False\),
                       \(ReduceToScalars \[Rule] False\), 
                      \(SmallVariables \[Rule] \({}\)\), 
                      \(WriteOut \[Rule] False\), 
                      \(WriteOutPaVe \[Rule] False\), \(Sum \[Rule] True\)}\)
                \)], "Output", CellTags -> "OneLoop"]}, Open]], 
           Cell[TextData[{"See also:  ", 
              ButtonBox["B0", RuleDelayed[ButtonData, "B0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "B0"]], 
              ", ", 
              ButtonBox["C0", RuleDelayed[ButtonData, "C0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "C0"]], 
              ", ", 
              ButtonBox["D0", RuleDelayed[ButtonData, "D0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "D0"]], 
              ", ", 
              ButtonBox["OneLoopSimplify", 
                RuleDelayed[ButtonData, "OneLoopSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSimplify"]], ", ", 
              ButtonBox["TID", RuleDelayed[ButtonData, "TID"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TID"]], 
              ", ", 
              ButtonBox["TIDL", RuleDelayed[ButtonData, "TIDL"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TIDL"]], 
              ", ", 
              ButtonBox["$LimitTo4", RuleDelayed[ButtonData, "$LimitTo4"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "$LimitTo4"]], 
              ", the old FeynCalc documentation at ", 
              ButtonBox["http://www.mertig.com/oldfc/", 
                RuleDelayed[ButtonData, 
                 List[URL["http://www.mertig.com/oldfc/"], None]], 
                Rule[ButtonStyle, "Hyperlink"]], "."}], "Text", 
            CellTags -> "OneLoop"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "OneLoop"], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(-I\)/\(Pi^2\)\)\ \(FAD[\({q, m}\)]\)\)//FCI\)], 
               "Input", CellTags -> "OneLoop"], Cell[BoxData[
                \(TraditionalForm\`\(-\(\[ImaginaryI]\/
                       \(\[Pi]\^2\ \((q\^2 - m\^2)\)\)\)\)\)], "Output", 
               CellTags -> "OneLoop"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(OneLoop[\(q, %\)]\)], "Input", CellTags -> 
                "OneLoop"], Cell[BoxData[FormBox[RowBox[{FormBox[\("A"\_"0"\)
                    , "TraditionalForm"], "(", FormBox[\(m\^2\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "OneLoop"]}, Open]], Cell[BoxData[
             \(\(mf/:\(MakeBoxes[\(mf, TraditionalForm\)]\) = 
                  \(InterpretationBox[\(\(SubscriptBox[\("m", "f"\)]\), mf\)]
                   \)\) ;\)], "Input", CellTags -> "OneLoop"], 
           Cell[TextData[{"Remember that FAD[{q,mf},{q-k,mf}] is a fast \
possibility to enter ", Cell[BoxData[
                \(TraditionalForm\`\(1/\(
                      \((\ \((q\^2 - mf\^2)\)\ \((\ \((q - k)\)\^2 - mf\^2)\)
                         \ )\) .\)\)\)]]}], "Text", CellTags -> "OneLoop"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t = \(\(I\ el\^2\/\(16\ Pi\^4 \((1 - D)\)\) 
                       \(FAD[\(\({q, mf}\), \({\(q - k\), mf}\)\)]\) 
                       \(DiracTrace[\(\((mf + \(GS[\(q - k\)]\))\) . 
                           \(GA[\[Mu]]\) . \((mf + \(GS[q]\))\) . 
                           \(GA[\[Mu]]\)\)]\)\)\ //\ FCI\)\)], "Input", 
               CellTags -> "OneLoop"], Cell[BoxData[FormBox[FractionBox[
                  RowBox[{"\[ImaginaryI]", " ", \(el\^2\), " ", RowBox[
                     {"tr", "(", FormBox[RowBox[{RowBox[{"(", RowBox[{
                          InterpretationBox[\(m\_f\), mf], "+", RowBox[
                          {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                          "\[CenterDot]", "(", FormBox[RowBox[{"q", "-", 
                          FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"]}], "TraditionalForm"], ")"}]}], 
                          ")"}], ".", SuperscriptBox["\[Gamma]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], ".", RowBox[{"(", RowBox[{
                          InterpretationBox[\(m\_f\), mf], "+", RowBox[
                          {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], ".", SuperscriptBox[
                          "\[Gamma]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], 
                       "TraditionalForm"], ")"}]}], RowBox[{"16", " ", 
                    \((1 - D)\), " ", \(\[Pi]\^4\), " ", RowBox[{
                      \((q\^2 - \*InterpretationBox[\(m\_f\), mf]\^2)\), ".", 
                      RowBox[{"(", RowBox[{SuperscriptBox[RowBox[{"(", 
                          RowBox[{"q", "-", FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"]}], ")"}], "2"], "-", 
                          \(\*InterpretationBox[\(m\_f\), mf]\^2\)}], 
                        ")"}]}]}]], TraditionalForm]], "Output", CellTags -> 
                "OneLoop"]}, Open]], Cell["The input to OneLoop may be in 4 \
dimensions, since the function changes the dimension of the objects \
automatically to the setting of the Dimension option (D by default).", 
            "Text", CellTags -> "OneLoop"], Cell[CellGroupData[{Cell[BoxData[
                \(OneLoop[\(q, t\)]\)], "Input", CellTags -> "OneLoop"], 
              Cell[BoxData[FormBox[RowBox[{"-", FractionBox[RowBox[{\(el\^2\)
                      , " ", RowBox[{"(", RowBox[{RowBox[{\(-\(8\/3\)\), " ", 
                          RowBox[{\(B\_0\), "(", SuperscriptBox[FormBox[
                          FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], "2"], ",", 
                          \(\*InterpretationBox[\(m\_f\), mf]\^2\), ",", 
                          \(\*InterpretationBox[\(m\_f\), mf]\^2\), ")"}], 
                          " ", \(\*InterpretationBox[\(m\_f\), mf]\^2\)}], 
                          "-", 
                          \(\(8\ \*InterpretationBox[\(m\_f\), mf]\^2\)\/3\), 
                          "+", RowBox[{\(8\/3\), " ", RowBox[{FormBox[
                          \("A"\_"0"\), "TraditionalForm"], "(", FormBox[
                          \(\*InterpretationBox[\(m\_f\), mf]\^2\), 
                          "TraditionalForm"], ")"}]}], "-", RowBox[{\(4\/3\), 
                          " ", RowBox[{\(B\_0\), "(", SuperscriptBox[FormBox[
                          FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], "2"], ",", 
                          \(\*InterpretationBox[\(m\_f\), mf]\^2\), ",", 
                          \(\*InterpretationBox[\(m\_f\), mf]\^2\), ")"}], 
                          " ", SuperscriptBox[FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], "2"]}], 
                          "+", FractionBox[RowBox[{"4", " ", SuperscriptBox[
                          FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], "2"]}], 
                          "9"]}], ")"}]}], \(16\ \[Pi]\^2\)]}], 
                 TraditionalForm]], "Output", CellTags -> "OneLoop"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(FullSimplify[%]\)], 
               "Input", CellTags -> "OneLoop"], Cell[BoxData[FormBox[
                 FractionBox[RowBox[{\(el\^2\), " ", RowBox[{"(", RowBox[{
                        \(6\ \*InterpretationBox[\(m\_f\), mf]\^2\), "-", 
                        RowBox[{"6", " ", RowBox[{FormBox[\("A"\_"0"\), 
                          "TraditionalForm"], "(", FormBox[
                          \(\*InterpretationBox[\(m\_f\), mf]\^2\), 
                          "TraditionalForm"], ")"}]}], "-", SuperscriptBox[
                         FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], "2"], "+", 
                        RowBox[{"3", " ", RowBox[{\(B\_0\), "(", 
                          SuperscriptBox[FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], "2"], ",", 
                          \(\*InterpretationBox[\(m\_f\), mf]\^2\), ",", 
                          \(\*InterpretationBox[\(m\_f\), mf]\^2\), ")"}], 
                          " ", RowBox[{"(", RowBox[{
                          \(2\ \*InterpretationBox[\(m\_f\), mf]\^2\), "+", 
                          SuperscriptBox[FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], "2"]}], 
                          ")"}]}]}], ")"}]}], \(36\ \[Pi]\^2\)], 
                 TraditionalForm]], "Output", CellTags -> "OneLoop"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SP[\(k, r\)]\)\ \(FAD[\(\({k, m}\)\ ,\ \(k\ -\ p\)\)]\)
                    \)//FCI\)], "Input", CellTags -> "OneLoop"], 
              Cell[BoxData[FormBox[FractionBox[RowBox[{FormBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                     "TraditionalForm"]}], RowBox[{RowBox[{"(", RowBox[
                       {SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], "-", \(m\^2\)}], ")"}], 
                    ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "p"}], ")"}], "2"]}]], 
                 TraditionalForm]], "Output", CellTags -> "OneLoop"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(OneLoop[\(k, %\)]\)], 
               "Input", CellTags -> "OneLoop"], Cell[BoxData[FormBox[
                 RowBox[{"\[ImaginaryI]", " ", \(\[Pi]\^2\), " ", 
                   RowBox[{"(", RowBox[{RowBox[{"-", FractionBox[RowBox[{
                          \(B\_0 (0, m\^2, m\^2)\), " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], " ", \(m\^2\)}], RowBox[
                          {"2", " ", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"]}]]}], "+", FractionBox[
                        RowBox[{RowBox[{\(B\_0\), "(", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], ",", "0", ",", 
                          \(m\^2\), ")"}], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], " ", \(m\^2\)}], RowBox[
                         {"2", " ", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"]}]], "-", FractionBox[
                        RowBox[{RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          " ", \(m\^2\)}], RowBox[{"2", " ", SuperscriptBox[
                          FormBox["p", "TraditionalForm"], "2"]}]], "+", 
                       RowBox[{\(1\/2\), " ", RowBox[{\(B\_0\), "(", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], ",", "0", ",", \(m\^2\), ")"}], " ", RowBox[
                          {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["r", "TraditionalForm"]}]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "OneLoop"]}, 
             Open]], Cell[BoxData[\(Clear[t]\)], "Input", 
            CellTags -> "OneLoop"]}, Open]], Cell["OneLoopSimplify", 
         "ObjectName", CellTags -> "OneLoopSimplify"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "OneLoopSimplify"], Cell["OneLoopSimplify[amp, q] \
simplifies the one-loop amplitude amp. The second argument denotes the \
integration momentum.", "Text", CellTags -> "OneLoopSimplify"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[OneLoopSimplify]\)], 
               "Input", CellTags -> "OneLoopSimplify"], Cell[BoxData[
                \(TraditionalForm\`\({\(Collecting \[Rule] False\), 
                      \(Dimension \[Rule] D\), 
                      \(DimensionalReduction \[Rule] False\), 
                      \(DiracSimplify \[Rule] True\), 
                      \(FinalSubstitutions \[Rule] \({}\)\), 
                      \(IntegralTable \[Rule] \({}\)\), 
                      \(OPE1Loop \[Rule] False\), 
                      \(ScalarProductCancel \[Rule] True\), 
                      \(SUNNToCACF \[Rule] True\), \(SUNTrace \[Rule] False\)\
}\)\)], "Output", CellTags -> "OneLoopSimplify"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, ", ", 
              ButtonBox["TID", RuleDelayed[ButtonData, "TID"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TID"]], 
              ", ", 
              ButtonBox["TIDL", RuleDelayed[ButtonData, "TIDL"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TIDL"]], 
              "."}], "Text", CellTags -> "OneLoopSimplify"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "OneLoopSimplify"], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SP[\(k, r\)]\)\ \(FAD[\(\({k, m}\)\ ,\ \(k\ -\ p\)\)]\)
                    \)//FCI\)], "Input", CellTags -> "OneLoopSimplify"], 
              Cell[BoxData[FormBox[FractionBox[RowBox[{FormBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                     "TraditionalForm"]}], RowBox[{RowBox[{"(", RowBox[
                       {SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], "-", \(m\^2\)}], ")"}], 
                    ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "p"}], ")"}], "2"]}]], 
                 TraditionalForm]], "Output", CellTags -> 
                "OneLoopSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(OneLoopSimplify[\(%, k\)]\)], "Input", CellTags -> 
                "OneLoopSimplify"], Cell[BoxData[FormBox[FractionBox[
                  RowBox[{FormBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                     "TraditionalForm"]}], RowBox[{RowBox[{"(", RowBox[
                       {SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], "-", \(m\^2\)}], ")"}], 
                    ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "p"}], ")"}], "2"]}]], 
                 TraditionalForm]], "Output", CellTags -> 
                "OneLoopSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(OneLoopSimplify[\(\(%/.\(m \[Rule] 0\)\), k\)]\)], "Input", 
               CellTags -> "OneLoopSimplify"], Cell[BoxData[FormBox[
                 FractionBox[RowBox[{FormBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                     "TraditionalForm"]}], RowBox[{SuperscriptBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "p"}], ")"}], "2"]}]], 
                 TraditionalForm]], "Output", CellTags -> 
                "OneLoopSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(FAD[\(k, k,\ \(k\ -\ p\_1\),\ \(k\ -\ p\_2\)\)]\)\ 
                     \(FVD[\(k, \[Mu]\)]\)\)//FCI\)], "Input", CellTags -> 
                "OneLoopSimplify"], Cell[BoxData[FormBox[FractionBox[
                  SuperscriptBox[FormBox[FormBox[
                     TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                       Function[StyleForm[Slot[1], 
                         Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                    "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                     "TraditionalForm"], "TraditionalForm"]], RowBox[
                   {SuperscriptBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "2"], ".", SuperscriptBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\)}], ")"}], "2"], 
                    ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_2\)}], ")"}], 
                     "2"]}]], TraditionalForm]], "Output", CellTags -> 
                "OneLoopSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(OneLoopSimplify[\ \(%, k\)]\)], "Input", CellTags -> 
                "OneLoopSimplify"], Cell[BoxData[FormBox[RowBox[
                  {FractionBox[RowBox[{RowBox[{SubsuperscriptBox["p", 
                         FormBox["2", "TraditionalForm"], FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                        " ", \(p\_1\%2\)}], "-", RowBox[{SubsuperscriptBox[
                         "p", FormBox["1", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}]}]}], RowBox[{"2", " ", 
                      RowBox[{SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\)}], ")"}], "2"]}], 
                      " ", RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          "-", \(p\_1\%2\ p\_2\%2\)}], ")"}]}]], "+", 
                   FractionBox[RowBox[{RowBox[{SubsuperscriptBox["p", 
                         FormBox["2", "TraditionalForm"], FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                        " ", \(p\_1\%2\), " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}]}], "+", RowBox[
                       {SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        \(p\_2\%2\), " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}]}], "-", RowBox[
                       {SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        \(p\_1\%2\), " ", \(p\_2\%2\)}], "-", RowBox[
                       {SubsuperscriptBox["p", FormBox["2", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        \(p\_1\%2\), " ", \(p\_2\%2\)}]}], RowBox[{"2", " ", 
                      RowBox[{SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\)}], ")"}], "2"], 
                        ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_2\)}], ")"}], "2"]}], 
                      " ", RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          "-", \(p\_1\%2\ p\_2\%2\)}], ")"}]}]], "-", 
                   FractionBox[RowBox[{RowBox[{SubsuperscriptBox["p", 
                         FormBox["2", "TraditionalForm"], FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                        " ", RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[
                       {SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        \(p\_2\%2\)}]}], RowBox[{"2", " ", RowBox[
                       {SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_2\)}], ")"}], "2"]}], 
                      " ", RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          "-", \(p\_1\%2\ p\_2\%2\)}], ")"}]}]], "-", 
                   FractionBox[RowBox[{RowBox[{SubsuperscriptBox["p", 
                         FormBox["2", "TraditionalForm"], FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                        " ", \(p\_1\%2\)}], "-", RowBox[{SubsuperscriptBox[
                         "p", FormBox["1", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}]}], "-", RowBox[
                       {SubsuperscriptBox["p", FormBox["2", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[
                       {SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        \(p\_2\%2\)}]}], RowBox[{"2", " ", RowBox[
                       {SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\)}], ")"}], "2"], 
                        ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_2\)}], ")"}], "2"]}], 
                      " ", RowBox[{"(", RowBox[{SuperscriptBox[FormBox[
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          "-", \(p\_1\%2\ p\_2\%2\)}], ")"}]}]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "OneLoopSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(FCE[%]\)/.\(\(SPD[p\_1]\) \[Rule] 0\)\)//FCI\)], 
               "Input", CellTags -> "OneLoopSimplify"], Cell[BoxData[
                FormBox[RowBox[{FractionBox[RowBox[{SubsuperscriptBox["p", 
                       FormBox["1", "TraditionalForm"], FormBox[FormBox[
                         "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                      " ", \(p\_2\%2\)}], RowBox[{"2", " ", RowBox[
                       {SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\)}], ")"}], "2"], 
                        ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_2\)}], ")"}], "2"]}], 
                      " ", RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(p\_2\), 
                         "TraditionalForm"]}]}]], "-", FractionBox[
                    SubsuperscriptBox["p", FormBox["1", "TraditionalForm"], 
                     FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                      "TraditionalForm"]], RowBox[{"2", " ", RowBox[
                       {SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\)}], ")"}], "2"]}], 
                      " ", RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(p\_2\), 
                         "TraditionalForm"]}]}]], "-", FractionBox[
                    RowBox[{RowBox[{SubsuperscriptBox["p", FormBox["2", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[
                       {SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        \(p\_2\%2\)}]}], RowBox[{"2", " ", RowBox[
                       {SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_2\)}], ")"}], "2"]}], 
                      " ", SuperscriptBox[FormBox[RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], 
                       "2"]}]], "-", FractionBox[RowBox[{RowBox[
                       {RowBox[{"-", SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                        RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[
                       {SubsuperscriptBox["p", FormBox["2", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[
                       {SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        \(p\_2\%2\)}]}], RowBox[{"2", " ", RowBox[
                       {SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], ".", SuperscriptBox[
                         RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\)}], ")"}], "2"], 
                        ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_2\)}], ")"}], "2"]}], 
                      " ", SuperscriptBox[FormBox[RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], 
                       "2"]}]]}], TraditionalForm]], "Output", CellTags -> 
                "OneLoopSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(OneLoopSimplify[\(\(\(FAD[\(\(k - p\_1\), \(k - p\_2\)\)]\)
                       \ \(\(SP[\(k, l\)]\)^2\)\), k\)]\)], "Input", 
               CellTags -> "OneLoopSimplify"], Cell[BoxData[FormBox[
                 RowBox[{FractionBox[SuperscriptBox[FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox["l", "TraditionalForm"]}], 
                      "TraditionalForm"], "2"], RowBox[{SuperscriptBox[
                       FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\), "+", \(p\_2\)}], 
                         ")"}], "2"]}]], "+", FractionBox[RowBox[{"2", " ", 
                      RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox["l", "TraditionalForm"]}], 
                      " ", RowBox[{FormBox["l", "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(p\_2\), 
                         "TraditionalForm"]}]}], RowBox[{SuperscriptBox[
                       FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\), "+", \(p\_2\)}], 
                         ")"}], "2"]}]], "+", FractionBox[SuperscriptBox[
                     FormBox[RowBox[{FormBox["l", "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(p\_2\), 
                         "TraditionalForm"]}], "TraditionalForm"], "2"], 
                    RowBox[{SuperscriptBox[FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\), "+", \(p\_2\)}], 
                         ")"}], "2"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "OneLoopSimplify"]}, Open]]}, Open]], 
        Cell["OneLoopSum", "ObjectName", CellTags -> "OneLoopSum"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "OneLoopSum"], Cell["OneLoopSum[ FeynAmp[ ... ], \
FeynAmp[ ... ] , ...] will calculate a list of Feynman amplitudes by \
replacing FeynAmp step by step by OneLoop.", "Text", CellTags -> 
             "OneLoopSum"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, "."}], "Text", CellTags -> "OneLoopSum"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["OPE", "ObjectName", CellTags -> "OPE"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "OPE"], Cell["OPE is a convenience variable to \
separate OPE insertions.\nOPE is also an option of several input functions \
like GluonPropagator.", "Text", CellTags -> "OPE"], 
           Cell[
            "The OPE variable has the property to vanish for higher powers:", 
            "Text"], Cell[CellGroupData[{Cell["{OPE,OPE^2,OPE^3}", "Input"], 
              Cell[BoxData[\(TraditionalForm\`\({\[CapitalOmega], 0, 0}\)\)], 
               "Output"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OPE1Loop", RuleDelayed[ButtonData, "OPE1Loop"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OPE1Loop"]], "."}], "Text", 
            CellTags -> "OPE"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["OPEDelta", "ObjectName", CellTags -> "OPEDelta"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "OPEDelta"], Cell["OPEDelta is a lightlike axial \
vector as used e.g. in the operator product expansion in QCD.", "Text", 
            CellTags -> "OPEDelta"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Twist2QuarkOperator", 
                RuleDelayed[ButtonData, "Twist2QuarkOperator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Twist2QuarkOperator"]], "."}], "Text", 
            CellTags -> "OPEDelta"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "OPEDelta"], Cell[CellGroupData[{Cell[BoxData[
                \(FourVector[\(OPEDelta, \[Mu]\)]\)], "Input", CellTags -> 
                "OPEDelta"], Cell[BoxData[FormBox[SubscriptBox[FormBox[
                   "\[CapitalDelta]", "TraditionalForm"], "\[Mu]"], 
                 TraditionalForm]], "Output", CellTags -> "OPEDelta"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(Contract[\(%\ %\)]\)]
                , "Input", CellTags -> "OPEDelta"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> "OPEDelta"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SP[\(OPEDelta, OPEDelta\)]\)], "Input", CellTags -> 
                "OPEDelta"], Cell[BoxData[\(TraditionalForm\`0\)], "Output", 
               CellTags -> "OPEDelta"]}, Open]]}, Open]], 
        Cell["OPEi, OPEj, OPEk, OPEl, OPEm, OPEn, OPEo", "ObjectName", 
         CellTags -> "OPEi"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "OPEi"], 
           Cell["OPEi etc. are variables with DataType PositiveInteger which \
are used in functions relating to the operator product expansion.", "Text", 
            CellTags -> "OPEi"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "OPEi"], 
           Cell[CellGroupData[{Cell[BoxData["OPEi"], "Input", CellTags -> 
                "OPEi"], Cell[BoxData[\(TraditionalForm\`i\)], "Output", 
               CellTags -> "OPEi"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(DataType[\(OPEi,\ OPEj, OPEk, OPEl,\ OPEm,\ OPEn,\ OPEo,\ 
                     PositiveInteger\)]\)], "Input", CellTags -> "OPEi"], 
              Cell[BoxData[
                \(TraditionalForm\`\({True, True, True, True, True, True, 
                      True}\)\)], "Output", CellTags -> "OPEi"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PowerSimplify[\({\(\((\(-1\))\)^\((2OPEi)\)\), 
                      \(\((\(-1\))\)^\((2OPEj)\)\), 
                      \(\((\(-1\))\)^\((2OPEk)\)\), 
                      \(\((\(-1\))\)^\((2OPEl)\)\), 
                      \(\((\(-1\))\)^\((2OPEm)\)\), 
                      \(\((\(-1\))\)^\((2OPEn)\)\), 
                      \(\((\(-1\))\)^\((2OPEo)\)\)}\)]\)], "Input", 
               CellTags -> "OPEi"], Cell[BoxData[
                \(TraditionalForm\`\({1, 1, 1, 1, 1, 1, 1}\)\)], "Output", 
               CellTags -> "OPEi"]}, Open]], Cell["Re has been changed:", 
            "Text", CellTags -> "OPEi"], Cell[CellGroupData[{Cell[BoxData[
                \({\(\(Re[OPEi]\) > \(-3\)\),\ \(\(Re[OPEi]\) > \(-2\)\),\ 
                    \(\(Re[OPEi]\) > \(-1\)\),\(\ \ \ \)\(\(Re[OPEi]\) > 0\),
                    \ \(\(Re[OPEi]\) > 1\)}\)], "Input", CellTags -> "OPEi"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(\(Re(i)\) > \(-3\)\), 
                      \(\(Re(i)\) > \(-2\)\), \(\(Re(i)\) > \(-1\)\), 
                      \(\(Re(i)\) > 0\), \(\(Re(i)\) > 1\)}\)\)], "Output", 
               CellTags -> "OPEi"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \({\(\(Re[\(\(-OPEi\)\ +\ OPEm\)]\)\ >\ 0\),\ 
                    \(\(Re[\(\(-OPEi\)\ +\ OPEm\)]\)\ >\ 1\), 
                    \(\(Re[\(\(-OPEi\)\ +\ OPEm\)]\)\ >\ 2\)}\)], "Input", 
               CellTags -> "OPEi"], Cell[BoxData[
                \(TraditionalForm\`\({\(\(Re(\(m - i\))\) > 0\), 
                      \(\(Re(\(m - i\))\) > 1\), \(\(Re(\(m - i\))\) > 2\)}\)
                \)], "Output", CellTags -> "OPEi"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \({\(\(Re[OPEm]\) > \(-3\)\),\ \(\(Re[OPEm]\) > \(-2\)\),\ 
                    \(\(Re[OPEm]\) > \(-1\)\),\(\ \ \ \)\(\(Re[OPEm]\) > 0\),
                    \ \(\(Re[OPEm]\) > 1\)}\)], "Input", CellTags -> "OPEi"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(\(Re(m)\) > \(-3\)\), 
                      \(\(Re(m)\) > \(-2\)\), \(\(Re(m)\) > \(-1\)\), 
                      \(\(Re(m)\) > 0\), \(\(Re(m)\) > 1\)}\)\)], "Output", 
               CellTags -> "OPEi"]}, Open]]}, Open]], 
        Cell["OPEInt  ***unfinished***", "ObjectName", CellTags -> "OPEInt"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "OPEInt"], Cell["OPEInt[expr, q, p, x].  The \
dimension is changed to the one indicated by the option  Dimension. The \
setting of the option EpsContract determines  the dimension in which the \
Levi-Civita tensors are contracted.", "Text", CellTags -> "OPEInt"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["RHI", RuleDelayed[ButtonData, "RHI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "RHI"]], 
              "."}], "Text", CellTags -> "OPEInt"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "OPEInt"], Cell[BoxData[""], "Input", 
            CellTags -> "OPEInt"]}, Open]], 
        Cell["OPEIntegrate  ***unfinished***", "ObjectName", 
         CellTags -> "OPEIntegrate"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "OPEIntegrate"], 
           Cell["OPEIntegrate[expr, q, x].  The dimension is changed to the \
one indicated by the option  Dimension. The setting of the option EpsContract \
determines  the dimension in which the Levi-Civita tensors are contracted.", 
            "Text", CellTags -> "OPEIntegrate"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["RHI", RuleDelayed[ButtonData, "RHI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "RHI"]], 
              "."}], "Text", CellTags -> "OPEIntegrate"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "OPEIntegrate"], Cell[BoxData[""], "Input", 
            CellTags -> "OPEIntegrate"]}, Open]], 
        Cell["OPEIntegrateDelta  ***unfinished***", "ObjectName", 
         CellTags -> "OPEIntegrateDelta"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "OPEIntegrateDelta"], 
           Cell[TextData[{"OPEIntegrateDelta[expr, x, m] introduces the \
\[Delta](1-x) (DeltaFunction[1-x]). The ", 
              StyleBox["Mathematica", Rule[FontSlant, "Italic"]], " Integrate \
function is called and each integration  (from 0 to 1) is recorded for \
reference (and bug-checking) in the list $MIntegrate. \nNotice that the \
dimension specified by the option should also be the dimension used in expr. \
It is replaced in OPEIntegrateDelta by (4+Epsilon)."}], "Text", 
            CellTags -> "OPEIntegrateDelta"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["RHI", RuleDelayed[ButtonData, "RHI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "RHI"]], 
              "."}], "Text", CellTags -> "OPEIntegrateDelta"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "OPEIntegrateDelta"], Cell[BoxData[""], "Input", 
            CellTags -> "OPEIntegrateDelta"]}, Open]], Cell["OPESumExplicit", 
         "ObjectName", CellTags -> "OPESumExplicit"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "OPESumExplicit"], 
           Cell["OPESumExplicit[exp] calculates OPESum's.", "Text", 
            CellTags -> "OPESumExplicit"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OPESum", RuleDelayed[ButtonData, "OPESum"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OPESum"]], 
              ", ", 
              ButtonBox["OPESumSimplify", 
                RuleDelayed[ButtonData, "OPESumSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OPESumSimplify"]], "."}], "Text", 
            CellTags -> "OPESumExplicit"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "OPESumExplicit"], Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(OPESum[\(\(\(A^i\)\(B^\((m - i - 3)\)\)\), 
                       \({i, 0, \(m - 3\)}\)\)]\)\)], "Input", CellTags -> 
                "OPESumExplicit"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[\(
                       \[Sum]\+\(i = 0\)\%\(m - 3\) 
                        \(A\^i\ B\^\(\(-i\) + m - 3\)\)\), HoldForm]\)\)], 
               "Output", CellTags -> "OPESumExplicit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(OPESumExplicit[t1]\)], "Input", 
               CellTags -> "OPESumExplicit"], Cell[BoxData[FormBox[
                 RowBox[{FractionBox[FormBox[\(A\^\(m - 2\)\), 
                     "TraditionalForm"], \(A - B\)], "-", FractionBox[FormBox[
                     \(B\^\(m - 2\)\), "TraditionalForm"], \(A - B\)]}], 
                 TraditionalForm]], "Output", CellTags -> "OPESumExplicit"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t2\ =\ \(OPESum[\(\(\(a^i\)\(b^\((j - i)\)\) 
                         \(c^\((m - j - 4)\)\)\), \({i, 0, j}\), 
                       \({j, 0, \(m - 4\)}\)\)]\)\)], "Input", CellTags -> 
                "OPESumExplicit"], Cell[BoxData[FormBox[RowBox[{FormBox[
                    TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 4\) ""\), HoldForm], 
                    "TraditionalForm"], FormBox[\(""\ \((j + 1)\)\), 
                    "TraditionalForm"], FormBox[
                    \(a\^i\ b\^\(j - i\)\ c\^\(\(-j\) + m - 4\)\), 
                    "TraditionalForm"]}], TraditionalForm]], "Output", 
               CellTags -> "OPESumExplicit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(OPESumExplicit[t2]\)], "Input", 
               CellTags -> "OPESumExplicit"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{"-", FractionBox[RowBox[{"c", " ", FormBox[
                         \(a\^\(m - 2\)\), "TraditionalForm"]}], 
                      \(\((a - b)\)\ \((a - c)\)\ \((b - c)\)\)]}], "+", 
                   FractionBox[RowBox[{"b", " ", FormBox[\(a\^\(m - 2\)\), 
                       "TraditionalForm"]}], 
                    \(\((a - b)\)\ \((a - c)\)\ \((b - c)\)\)], "+", 
                   FractionBox[RowBox[{"c", " ", FormBox[\(b\^\(m - 2\)\), 
                       "TraditionalForm"]}], 
                    \(\((a - b)\)\ \((a - c)\)\ \((b - c)\)\)], "-", 
                   FractionBox[RowBox[{"a", " ", FormBox[\(b\^\(m - 2\)\), 
                       "TraditionalForm"]}], 
                    \(\((a - b)\)\ \((a - c)\)\ \((b - c)\)\)], "-", 
                   FractionBox[RowBox[{"b", " ", FormBox[\(c\^\(m - 2\)\), 
                       "TraditionalForm"]}], 
                    \(\((a - b)\)\ \((a - c)\)\ \((b - c)\)\)], "+", 
                   FractionBox[RowBox[{"a", " ", FormBox[\(c\^\(m - 2\)\), 
                       "TraditionalForm"]}], 
                    \(\((a - b)\)\ \((a - c)\)\ \((b - c)\)\)]}], 
                 TraditionalForm]], "Output", CellTags -> "OPESumExplicit"]}, 
             Open]], Cell[BoxData[\(\(Clear[\(t1, t2\)]\) ;\)], "Input", 
            CellTags -> "OPESumExplicit"]}, Open]], Cell["OPESum", 
         "ObjectName", CellTags -> "OPESum"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "OPESum"], Cell["OPESum[exp, {i, 0, m}] denotes a \
symbolic sum.The syntax is the same as for Sum.", "Text", 
            CellTags -> "OPESum"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OPESumExplicit", 
                RuleDelayed[ButtonData, "OPESumExplicit"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OPESumExplicit"]], ", ", 
              ButtonBox["OPESumSimplify", 
                RuleDelayed[ButtonData, "OPESumSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OPESumSimplify"]], "."}], "Text", 
            CellTags -> "OPESum"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "OPESum"], Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(OPESum[\(\(\(\(SO[p]\)^OPEi\)
                         \(\(SO[k]\)^\((OPEm - OPEi - 3)\)\)\), 
                       \({OPEi, 0, \(OPEm - 3\)}\)\)]\)\)], "Input", 
               CellTags -> "OPESum"], Cell[BoxData[FormBox[TagBox[RowBox[{
                    \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[{SuperscriptBox[
                       RowBox[{"(", RowBox[{FormBox["\"\[CapitalDelta]\"", 
                          "TraditionalForm"], FormBox["\"\[CenterDot]\"", 
                          "TraditionalForm"], FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"]}], ")"}], 
                       \(\(-i\) + m - 3\)], " ", SuperscriptBox[RowBox[
                        {"(", RowBox[{FormBox["\"\[CapitalDelta]\"", 
                          "TraditionalForm"], FormBox["\"\[CenterDot]\"", 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"]}], ")"}], "i"]}]}], HoldForm], 
                 TraditionalForm]], "Output", CellTags -> "OPESum"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(OPESumExplicit[t1]\)], "Input", 
               CellTags -> "OPESum"], Cell[BoxData[FormBox[RowBox[
                  {FractionBox[FormBox[SuperscriptBox[RowBox[{"(", RowBox[
                         {FormBox["\"\[CapitalDelta]\"", "TraditionalForm"], 
                          FormBox["\"\[CenterDot]\"", "TraditionalForm"], 
                          FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"]}], ")"}], 
                      \(m - 2\)], "TraditionalForm"], RowBox[{RowBox[
                       {FormBox["\"\[CapitalDelta]\"", "TraditionalForm"], 
                        FormBox["\"\[CenterDot]\"", "TraditionalForm"], 
                        FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"]}], "-", 
                      RowBox[{FormBox["\"\[CapitalDelta]\"", 
                         "TraditionalForm"], FormBox["\"\[CenterDot]\"", 
                         "TraditionalForm"], FormBox["p", 
                         "TraditionalForm"]}]}]], "-", FractionBox[FormBox[
                     SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\"\[CapitalDelta]\"", "TraditionalForm"], FormBox[
                          "\"\[CenterDot]\"", "TraditionalForm"], FormBox[
                          "p", "TraditionalForm"]}], ")"}], \(m - 2\)], 
                     "TraditionalForm"], RowBox[{RowBox[{FormBox[
                         "\"\[CapitalDelta]\"", "TraditionalForm"], FormBox[
                         "\"\[CenterDot]\"", "TraditionalForm"], FormBox[
                         FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"]}], "-", 
                      RowBox[{FormBox["\"\[CapitalDelta]\"", 
                         "TraditionalForm"], FormBox["\"\[CenterDot]\"", 
                         "TraditionalForm"], FormBox["p", 
                         "TraditionalForm"]}]}]]}], TraditionalForm]], 
               "Output", CellTags -> "OPESum"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t2\ =\ \(OPESum[\(\(\(a^i\)\(b^\((j - i)\)\) 
                         \(c^\((m - j - 4)\)\)\), \({i, 0, j}\), 
                       \({j, 0, \(m - 4\)}\)\)]\)\)], "Input", CellTags -> 
                "OPESum"], Cell[BoxData[FormBox[RowBox[{FormBox[
                    TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 4\) ""\), HoldForm], 
                    "TraditionalForm"], FormBox[\(""\ \((j + 1)\)\), 
                    "TraditionalForm"], FormBox[
                    \(a\^i\ b\^\(j - i\)\ c\^\(\(-j\) + m - 4\)\), 
                    "TraditionalForm"]}], TraditionalForm]], "Output", 
               CellTags -> "OPESum"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(OPESumExplicit[t2]\)], "Input", CellTags -> 
                "OPESum"], Cell[BoxData[FormBox[RowBox[{RowBox[{"-", 
                     FractionBox[RowBox[{"c", " ", FormBox[\(a\^\(m - 2\)\), 
                         "TraditionalForm"]}], 
                      \(\((a - b)\)\ \((a - c)\)\ \((b - c)\)\)]}], "+", 
                   FractionBox[RowBox[{"b", " ", FormBox[\(a\^\(m - 2\)\), 
                       "TraditionalForm"]}], 
                    \(\((a - b)\)\ \((a - c)\)\ \((b - c)\)\)], "+", 
                   FractionBox[RowBox[{"c", " ", FormBox[\(b\^\(m - 2\)\), 
                       "TraditionalForm"]}], 
                    \(\((a - b)\)\ \((a - c)\)\ \((b - c)\)\)], "-", 
                   FractionBox[RowBox[{"a", " ", FormBox[\(b\^\(m - 2\)\), 
                       "TraditionalForm"]}], 
                    \(\((a - b)\)\ \((a - c)\)\ \((b - c)\)\)], "-", 
                   FractionBox[RowBox[{"b", " ", FormBox[\(c\^\(m - 2\)\), 
                       "TraditionalForm"]}], 
                    \(\((a - b)\)\ \((a - c)\)\ \((b - c)\)\)], "+", 
                   FractionBox[RowBox[{"a", " ", FormBox[\(c\^\(m - 2\)\), 
                       "TraditionalForm"]}], 
                    \(\((a - b)\)\ \((a - c)\)\ \((b - c)\)\)]}], 
                 TraditionalForm]], "Output", CellTags -> "OPESum"]}, Open]], 
           Cell[BoxData[\(\ \(Clear[\(t1, t2\)]\)\)], "Input", 
            CellTags -> "OPESum"]}, Open]], Cell["OPESumSimplify", 
         "ObjectName", CellTags -> "OPESumSimplify"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "OPESumSimplify"], 
           Cell["OPESumSimplify[exp] simplifies OPESum's in exp.", "Text", 
            CellTags -> "OPESumSimplify"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OPESum", RuleDelayed[ButtonData, "OPESum"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OPESum"]], 
              ", ", 
              ButtonBox["OPESumExplicit", 
                RuleDelayed[ButtonData, "OPESumExplicit"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OPESumExplicit"]], "."}], "Text", 
            CellTags -> "OPESumSimplify"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "OPESumSimplify"], Cell[CellGroupData[
             {Cell["OPESum[(-SOD[p])^(OPEi+1) \
SOD[p-q]^(OPEm-OPEi-2),{OPEi,0,OPEm}]", "Input", CellTags -> 
                "OPESumSimplify"], Cell[BoxData[FormBox[TagBox[RowBox[{
                    \(\[Sum]\+\(i = 0\)\%m\), RowBox[{SuperscriptBox[
                       RowBox[{"(", RowBox[{"-", RowBox[{"(", RowBox[
                          {FormBox["\"\[CapitalDelta]\"", "TraditionalForm"], 
                          FormBox["\"\[CenterDot]\"", "TraditionalForm"], 
                          FormBox["p", "TraditionalForm"]}], ")"}]}], ")"}], 
                       \(i + 1\)], " ", SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\"\[CapitalDelta]\"", "TraditionalForm"], 
                          FormBox["\"\[CenterDot]\"", "TraditionalForm"], 
                          FormBox["\"(\"", "TraditionalForm"], FormBox[
                          \(p - q\), "TraditionalForm"], FormBox["\")\"", 
                          "TraditionalForm"]}], ")"}], \(\(-i\) + m - 2\)]}]}]
                       , HoldForm], TraditionalForm]], "Output", CellTags -> 
                "OPESumSimplify"]}, Open]], Cell[CellGroupData[
             {Cell["OPESumSimplify[%]", "Input", CellTags -> 
                "OPESumSimplify"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"-", FormBox[TagBox[RowBox[{
                         \(\[Sum]\+\(i = 0\)\%m\), RowBox[{\(\((\(-1\))\)\^i\)
                          , " ", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], "i"], " ", SuperscriptBox[RowBox[{"(", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", "(", FormBox[
                          \(p - q\), "TraditionalForm"], ")"}], ")"}], 
                          \(\(-i\) + m - 2\)]}]}], HoldForm], 
                      "TraditionalForm"]}], " ", RowBox[{FormBox[
                      "\[CapitalDelta]", "TraditionalForm"], "\[CenterDot]", 
                     FormBox["p", "TraditionalForm"]}]}], TraditionalForm]], 
               "Output", CellTags -> "OPESumSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(OPESumSimplify[\(\(OPESum[\({OPEi, 0, OPEm}\)]\)\ 
                     \(a^OPEi\)\)]\)], "Input", CellTags -> 
                "OPESumSimplify"], Cell[BoxData[FormBox[TagBox[RowBox[{
                    \(\[Sum]\+\(i = 0\)\%m\), FormBox[\(a\^i\), 
                     "TraditionalForm"]}], HoldForm], TraditionalForm]], 
               "Output", CellTags -> "OPESumSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(OPESumSimplify[\(\(OPESum[\(\({j, 0, i}\), \({i, 0, m}\)\)]
                      \)\ \(a^\((j - i)\)\)\ \(b^i\)\)]\)], "Input", 
               CellTags -> "OPESumSimplify"], Cell[BoxData[FormBox[
                 RowBox[{FormBox[TagBox[\(\[Sum]\+\(i = 0\)\%m ""\), HoldForm]
                    , "TraditionalForm"], FormBox[\(""\ \((i + 1)\)\), 
                    "TraditionalForm"], FormBox[\(a\^\(j - i\)\ b\^i\), 
                    "TraditionalForm"]}], TraditionalForm]], "Output", 
               CellTags -> "OPESumSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "OPESumSimplify"], Cell[BoxData[
                \(OPESum[\(\(a\^\(\(-i\) + j\)\ b\^i\), \({i, 0, m}\), 
                     \({j, 0, i}\)\)]\)], "Output", CellTags -> 
                "OPESumSimplify"]}, Open]]}, Open]], Cell["OPE1Loop ", 
         "ObjectName", CellTags -> "OPE1Loop"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "OPE1Loop"], Cell["OPE1Loop[q1, amp].  \
OPE1Loop[{q1,q2}, amp] does sub-loop  decomposition.", "Text", 
            CellTags -> "OPE1Loop"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OPESum", RuleDelayed[ButtonData, "OPESum"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OPESum"]], 
              "."}], "Text", CellTags -> "OPE1Loop"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "OPE1Loop"], Cell[BoxData[""], "Input", 
            CellTags -> "OPE1Loop"]}, Open]], 
        Cell["OPE2TID  ***unfinished***", "ObjectName", 
         CellTags -> "OPE2TID"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "OPE2TID"], 
           Cell["OPE2TID[exp, k1, k2, p]. The setting of the option \
EpsContract determines the dimension in which the Levi-Civita tensors are \
contracted.", "Text", CellTags -> "OPE2TID"], Cell[CellGroupData[
             {Cell[BoxData[\(Options[OPE2TID]\)], "Input", CellTags -> 
                "OPE2TID"], Cell[BoxData[
                \(TraditionalForm\`\({\(Uncontract \[Rule] False\), 
                      \(Contract \[Rule] True\), \(Dimension \[Rule] D\), 
                      \(EpsContract \[Rule] False\)}\)\)], "Output", 
               CellTags -> "OPE2TID"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["OPESum", RuleDelayed[ButtonData, "OPESum"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OPESum"]], 
              "."}], "Text", CellTags -> "OPE2TID"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "OPE2TID"], Cell[BoxData[""], "Input", 
            CellTags -> "OPE2TID"]}, Open]], Cell["OptionsSelect", 
         "ObjectName", CellTags -> "OptionsSelect"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "OptionsSelect"], Cell["OptionsSelect[function,opts] \
returns the option settings of opts accepted by function.  When an option \
occurs several times in opts, the first setting is selected.", "Text", 
            CellTags -> "OptionsSelect"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["Pair", "ObjectName", CellTags -> "Pair"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Pair"], Cell[TextData[{"Pair[x, y] is the head of a \
special pairing used in the internal representation: x and y may have heads \
LorentzIndex or Momentum. If both x and y have head LorentzIndex, the metric \
tensor is understood. If x and y have head Momentum, a scalar product is \
meant. If one of x and y has head LorentzIndex and the other Momentum, a \
Lorentz vector ", Cell[BoxData[\(TraditionalForm\`\(p\^\[Mu]\)\)]], 
              " is understood."}], "Text", CellTags -> "Pair"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FourVector", RuleDelayed[ButtonData, "FourVector"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FourVector"]], ", ", 
              ButtonBox["FV", RuleDelayed[ButtonData, "FV"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FV"]], 
              ", ", 
              ButtonBox["FVD", RuleDelayed[ButtonData, "FVD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FVD"]], 
              ", ", 
              ButtonBox["MetricTensor", 
                RuleDelayed[ButtonData, "MetricTensor"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "MetricTensor"]], ", ", 
              ButtonBox["MT", RuleDelayed[ButtonData, "MT"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "MT"]], 
              ", ", 
              ButtonBox["MTD", RuleDelayed[ButtonData, "MTD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "MTD"]], 
              ", ", 
              ButtonBox["ScalarProduct", 
                RuleDelayed[ButtonData, "ScalarProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ScalarProduct"]], ", ", 
              ButtonBox["SP", RuleDelayed[ButtonData, "SP"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SP"]], 
              ", ", 
              ButtonBox["SPD", RuleDelayed[ButtonData, "SPD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SPD"]], 
              "."}], "Text", CellTags -> "Pair"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Pair"], Cell[
            "This represents a four-dimensional metric tensor.", "Text", 
            CellTags -> "Pair"], Cell[CellGroupData[{Cell[BoxData[
                \(Pair[\(\(LorentzIndex[\[Alpha]]\), 
                     \(LorentzIndex[\[Beta]]\)\)]\)], "Input", CellTags -> 
                "Pair"], Cell[BoxData[
                \(TraditionalForm\`\(g\^\(\[Alpha]\[Beta]\)\)\)], "Output", 
               CellTags -> "Pair"]}, Open]], 
           Cell["This is a D-dimensional metric tensor.", "Text", 
            CellTags -> "Pair"], Cell[CellGroupData[{Cell[BoxData[
                \(Pair[\(\(LorentzIndex[\(\[Alpha], D\)]\), 
                     \(LorentzIndex[\(\[Beta], D\)]\)\)]\)], "Input", 
               CellTags -> "Pair"], Cell[BoxData[
                \(TraditionalForm\`\(g\^\(\[Alpha]\[Beta]\)\)\)], "Output", 
               CellTags -> "Pair"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Pair[\(\(LorentzIndex[\[Alpha]]\), \(Momentum[p]\)\)]\)], 
               "Input", CellTags -> "Pair"], Cell[BoxData[FormBox[
                 SuperscriptBox[FormBox["p", "TraditionalForm"], FormBox[
                   FormBox["\[Alpha]", "TraditionalForm"], 
                   "TraditionalForm"]], TraditionalForm]], "Output", 
               CellTags -> "Pair"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Pair[\(\(Momentum[q]\), \(Momentum[p]\)\)]\)], "Input", 
               CellTags -> "Pair"], Cell[BoxData[FormBox[RowBox[
                  {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                   FormBox["q", "TraditionalForm"]}], TraditionalForm]], 
               "Output", CellTags -> "Pair"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Pair[\(\(Momentum[p]\), \(Momentum[p]\)\)]\)], "Input", 
               CellTags -> "Pair"], Cell[BoxData[FormBox[SuperscriptBox[
                  FormBox["p", "TraditionalForm"], "2"], TraditionalForm]], 
               "Output", CellTags -> "Pair"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Pair[\(\(Momentum[\(p - q\)]\), \(Momentum[p]\)\)]\)], 
               "Input", CellTags -> "Pair"], Cell[BoxData[FormBox[
                 RowBox[{FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                   "(", FormBox[\(p - q\), "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> "Pair"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Pair[\(\(Momentum[p]\), \(Momentum[p]\)\)]\)^2\)], 
               "Input", CellTags -> "Pair"], Cell[BoxData[FormBox[
                 SuperscriptBox[FormBox["p", "TraditionalForm"], "4"], 
                 TraditionalForm]], "Output", CellTags -> "Pair"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Pair[\(\(Momentum[p]\), \(Momentum[p]\)\)]\)^3\)], 
               "Input", CellTags -> "Pair"], Cell[BoxData[FormBox[
                 SuperscriptBox[FormBox["p", "TraditionalForm"], "6"], 
                 TraditionalForm]], "Output", CellTags -> "Pair"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Pair[\(\(LorentzIndex[\(\[Alpha], \(n - 4\)\)]\), 
                       \(LorentzIndex[\[Beta]]\)\)]\)//Contract\)], "Input", 
               CellTags -> "Pair"], Cell[BoxData[\(TraditionalForm\`0\)], 
               "Output", CellTags -> "Pair"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(ExpandScalarProduct[\(Pair[
                     \(\(Momentum[\(p - q\)]\), \(Momentum[p]\)\)]\)]\)], 
               "Input", CellTags -> "Pair"], Cell[BoxData[FormBox[
                 RowBox[{SuperscriptBox[FormBox["p", "TraditionalForm"], 
                    "2"], "-", RowBox[{FormBox["p", "TraditionalForm"], 
                     "\[CenterDot]", FormBox["q", "TraditionalForm"]}]}], 
                 TraditionalForm]], "Output", CellTags -> "Pair"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Pair[\(\(Momentum[\(-q\)]\), \(Momentum[p]\)\)]\)\ +\ 
                   \(Pair[\(\(Momentum[q]\), \(Momentum[p]\)\)]\)\)], 
               "Input", CellTags -> "Pair"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> "Pair"]}, 
             Open]]}, Open]], Cell["PairCollect", "ObjectName", 
         CellTags -> "PairCollect"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "PairCollect"], 
           Cell["PairCollect is an option for DiracTrace specifying if the \
result is collected with respect to Pair's.", "Text", CellTags -> 
             "PairCollect"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracTrace", RuleDelayed[ButtonData, "DiracTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrace"]], ", ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              "."}], "Text", CellTags -> "PairCollect"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["PairContract", "ObjectName", 
         CellTags -> "PairContract"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "PairContract"], 
           Cell["PairContract is like Pair, but with (local) contraction \
properties.", "Text", CellTags -> "PairContract"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[PairContract]\)], 
               "Input"], Cell[BoxData[
                \(TraditionalForm\`\({Factoring \[Rule] False}\)\)], 
               "Output"]}, Open]], Cell[TextData[{"See also: ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              ", ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], "."}], "Text", 
            CellTags -> "PairContract"]}, Open]], Cell["PairContract2", 
         "ObjectName", CellTags -> "PairContract2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PairContract2"], Cell["PairContract2 is like Pair, \
but with local contraction properties among PairContract2's.", "Text", 
            CellTags -> "PairContract2"], Cell[TextData[{"See also: ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              ", ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], ", ", 
              ButtonBox["PairContract", 
                RuleDelayed[ButtonData, "PairContract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PairContract"]], "."}], "Text", 
            CellTags -> "PairContract2"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["PairContract3", "ObjectName", 
         CellTags -> "PairContract3"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "PairContract3"], 
           Cell["PairContract3 is like Pair, but with local contraction \
properties among PairContract3's.", "Text", CellTags -> "PairContract3"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              ", ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], ", ", 
              ButtonBox["PairContract", 
                RuleDelayed[ButtonData, "PairContract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PairContract"]], "."}], "Text", 
            CellTags -> "PairContract3"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["PartialD", "ObjectName", CellTags -> "PartialD"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PartialD"], Cell[TextData[{"PartialD[", Cell[BoxData[
                \(TraditionalForm\`\[Mu]\)]], 
              "] denotes the four-dimensional ", Cell[BoxData[FormBox[
                 RowBox[{SubscriptBox["\[PartialD]", FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], "."}], 
                 TraditionalForm]]], " PartialD is used to denote derivative \
fields. PartialD[LorentzIndex[", Cell[BoxData[
                \(TraditionalForm\`\(\[Mu], 
                     \*StyleBox["D", Rule[FontSlant, "Plain"]]\)\)]], 
              "]] denotes the ", Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["D", 
                      Rule[FontSlant, "Plain"]]\)\)]], "-dimensional ", 
              Cell[BoxData[FormBox[RowBox[{SubscriptBox["\[PartialD]", 
                    FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], "."}], TraditionalForm]]]}], 
            "Text", ZeroWidthTimes -> True, CellTags -> "PartialD"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["ExpandPartialD", 
                RuleDelayed[ButtonData, "ExpandPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandPartialD"]], ", ", 
              ButtonBox["LeftPartialD", 
                RuleDelayed[ButtonData, "LeftPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftPartialD"]], ", ", 
              ButtonBox["LeftRightPartialD", 
                RuleDelayed[ButtonData, "LeftRightPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftRightPartialD"]], ", ", 
              ButtonBox["RightPartialD", 
                RuleDelayed[ButtonData, "RightPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "RightPartialD"]], "."}], "Text", 
            CellTags -> "PartialD"]}, Open]], 
        Cell[CellGroupData[{Cell[BoxData["Examples"], "Subsubsection", 
            CellTags -> "PartialD"], Cell[CellGroupData[{Cell[BoxData[
                \(\(QuantumField[\(A, \({\[Mu]}\)\)]\) . 
                   \(LeftPartialD[\[Nu]]\)\)], "Input", CellTags -> 
                "PartialD"], Cell[BoxData[FormBox[RowBox[{\(A\_\[Mu]\), ".", 
                   SubscriptBox[\(\[PartialD]\&\[LeftArrow]\), FormBox[
                     FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "PartialD"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(ExpandPartialD[%]\)], "Input", CellTags -> 
                "PartialD"], Cell[BoxData[FormBox[RowBox[{SubscriptBox[
                    "\[PartialD]", FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]], 
                   SubsuperscriptBox["A", FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"], "\[Null]"]}], 
                 TraditionalForm]], "Output", CellTags -> "PartialD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(StandardForm[%]\)], 
               "Input", CellTags -> "PartialD"], Cell[BoxData[
                \(QuantumField[\(\(PartialD[\(LorentzIndex[\[Nu]]\)]\), A, 
                     \(LorentzIndex[\[Mu]]\)\)]\)], "Output", CellTags -> 
                "PartialD"]}, Open]]}, Open]], Cell["PartialDRelations", 
         "ObjectName", CellTags -> "PartialDRelations"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PartialDRelations"], Cell["PartialDRelations is an \
option for ExpandPartialD. It is a list of rules applied by ExpandPartialD at \
the end.", "Text", ZeroWidthTimes -> True, CellTags -> "PartialDRelations"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["PartialD", RuleDelayed[ButtonData, "PartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PartialD"]], ", ", 
              ButtonBox["ExpandPartialD", 
                RuleDelayed[ButtonData, "ExpandPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandPartialD"]], ", ", 
              ButtonBox["LeftPartialD", 
                RuleDelayed[ButtonData, "LeftPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftPartialD"]], ", ", 
              ButtonBox["LeftRightPartialD", 
                RuleDelayed[ButtonData, "LeftRightPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftRightPartialD"]], ", ", 
              ButtonBox["RightPartialD", 
                RuleDelayed[ButtonData, "RightPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "RightPartialD"]], "."}], "Text", 
            CellTags -> "PartialDRelations"]}, Open]], 
        Cell[CellGroupData[{Cell[BoxData["Examples"], "Subsubsection", 
            CellTags -> "PartialDRelations"], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(QuantumField[\(A, \({\[Mu]}\)\)]\) . 
                   \(QuantumField[\(B, \({\[Mu]}\)\)]\) . 
                   \(LeftPartialD[\[Nu]]\)\)], "Input", CellTags -> 
                "PartialDRelations"], Cell[BoxData[FormBox[RowBox[{
                   \(A\_\[Mu]\), ".", \(B\_\[Mu]\), ".", SubscriptBox[
                    \(\[PartialD]\&\[LeftArrow]\), FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "PartialDRelations"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(ExpandPartialD[\(%,\ \(
                      PartialDRelations \[Rule] \({A \[Rule] C}\)\)\)]\)], 
               "Input", CellTags -> "PartialDRelations"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{SubscriptBox[FormBox["C", 
                       "TraditionalForm"], "\[Mu]"], ".", RowBox[
                      {SubscriptBox["\[PartialD]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox["B", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[Null]"]}]}], "+", RowBox[{RowBox[{SubscriptBox[
                        "\[PartialD]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], 
                       SubsuperscriptBox[FormBox["C", "TraditionalForm"], 
                        FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], "\[Null]"]}], ".", \(B\_\[Mu]\)}]
                     }], TraditionalForm]], "Output", CellTags -> 
                "PartialDRelations"]}, Open]]}, Open]], 
        Cell["PartialFourVector", "ObjectName", CellTags -> 
          "PartialFourVector"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "PartialFourVector"], Cell["PartialFourVector[exp, FourVector[p, \
mu]]  calculates the partial derivative of exp w.r.t. p(mu). \
PartialFourVector[exp, FourVector[p, mu], FourVector[p,nu], ...]  gives the \
multiple derivative.", "Text", ZeroWidthTimes -> True, CellTags -> 
             "PartialFourVector"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FourVector", RuleDelayed[ButtonData, "FourVector"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FourVector"]], ", ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              ", ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], "."}], "Text", 
            CellTags -> "PartialFourVector"]}, Open]], 
        Cell[CellGroupData[{Cell[BoxData["Examples"], "Subsubsection", 
            CellTags -> "PartialFourVector"], Cell[CellGroupData[
             {Cell[BoxData[
                \(PartialFourVector[\(\(a\ 
                       \[ExponentialE]\^\(\(FourVector[\(p, \[Nu]\)]\)\^2\)\)\
, \(FourVector[\(p, \[Mu]\)]\)\)]\)], "Input", CellTags -> 
                "PartialFourVector"], Cell[BoxData[FormBox[RowBox[{"2", " ", 
                   "a", " ", SuperscriptBox["\[ExponentialE]", SuperscriptBox[
                     FormBox["p", "TraditionalForm"], "2"]], " ", 
                   SuperscriptBox[FormBox["p", "TraditionalForm"], FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "PartialFourVector"]}, Open]]}, Open]], 
        Cell["PartialIntegrate", "ObjectName", CellTags -> 
          "PartialIntegrate"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "PartialIntegrate"], Cell[" PartialIntegrate[exp, ap, t] does a \
partial integration of the definite integral Integrate[exp,{t,0,1}], with ap \
the factor that is to be integrated and exp/ap the factor that is to be \
differentiated.", "Text", ZeroWidthTimes -> True, CellTags -> 
             "PartialIntegrate"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[PartialIntegrate]\)], "Input", CellTags -> 
                "PartialIntegrate"], Cell[BoxData[
                \(TraditionalForm\`\({Integrate \[Rule] Integrate}\)\)], 
               "Output", CellTags -> "PartialIntegrate"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell[BoxData["Examples"], "Subsubsection", 
            CellTags -> "PartialIntegrate"], Cell[CellGroupData[{Cell[BoxData[
                \(PartialIntegrate[\(\(\(f[x]\) \(g[x]\)\), \(g[x]\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> 
                "PartialIntegrate"], Cell[BoxData[
                \(TraditionalForm\`\(\(-\(
                        (\*TagBox[\(\(\(f(x)\)\ 
                               \(\[Integral] 
                                 \(\(g(x)\) \(\[DifferentialD] x\)\)\)\)/.
                             \[InvisibleSpace]\(x \[Rule] 0\)\), HoldForm])\)
                \) + \((\*TagBox[\(\(\(f(x)\)\ 
                             \(\[Integral] 
                               \(\(g(x)\) \(\[DifferentialD] x\)\)\)\)/.
                           \[InvisibleSpace]\(x \[Rule] 1\)\), HoldForm])\) -
                      \(\[Integral]\_0\%1 
                       \(\(\((\[Integral] \(\(g(x)\) \(\[DifferentialD] x\)\)
                             )\)\ \(\(\*SuperscriptBox["f", "\[Prime]", 
                                Rule[MultilineFunction, None]]\)(x)\)\) 
                         \(\[DifferentialD] x\)\)\)\)\)], "Output", 
               CellTags -> "PartialIntegrate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//InputForm\)], "Input"], 
              Cell["-HoldForm[f[x]*Integrate[g[x], x] /. x -> 0] + \n \
HoldForm[f[x]*Integrate[g[x], x] /. x -> 1] - \n Integrate[Integrate[g[x], \
x]*Derivative[1][f][x], {x, 0, 1}]", "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(f[x_]\) = \(Integrate[\(\(Log[\(\(3x\) + 2\)]\), x\)]\)\)]\
, "Input", CellTags -> "PartialIntegrate"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/3\ \((\(\(-3\)\ x\) - 2)\)\) + 
                     \(1\/3\ \((\(3\ x\) + 2)\)\ \(log(\(\(3\ x\) + 2\))\)\)\
\)\)], "Output", CellTags -> "PartialIntegrate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(g[x_]\) = \(D[\(1\/\(Log[\(\(3x\) + 2\)]\), x\)]\)\)], 
               "Input", CellTags -> "PartialIntegrate"], Cell[BoxData[
                \(TraditionalForm\`\(-\(3\/
                       \(\((\(3\ x\) + 2)\)\ \(\(log\^2\)(\(\(3\ x\) + 2\))\)
                        \)\)\)\)], "Output", CellTags -> 
                "PartialIntegrate"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(Integrate[\(\(PartialIntegrate[
                         \(\(\(f[x]\) \(g[x]\)\), \(f[x]\), x\)]\), 
                       \({x, 0, 1}\)\)]\)//FullSimplify\)], "Input", 
               CellTags -> "PartialIntegrate"], Cell[BoxData[
                \(TraditionalForm\`\(-\(\(log(\(32\/25\))\)\/
                       \(\(log(5)\)\ \(log(8)\)\)\)\)\)], "Output", 
               CellTags -> "PartialIntegrate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Integrate[\(\(\(f[x]\) \(g[x]\)\), \({x, 0, 1}\)\)]\)//
                   Simplify\)], "Input", CellTags -> "PartialIntegrate"], 
              Cell[BoxData[
                \(TraditionalForm\`\(-\(\(log(\(32\/25\))\)\/
                       \(\(log(5)\)\ \(log(8)\)\)\)\)\)], "Output", 
               CellTags -> "PartialIntegrate"]}, Open]], Cell[BoxData[
             \(Clear[\(f, g\)]\)], "Input", CellTags -> "PartialIntegrate"]}, 
          Open]], Cell["PartitHead", "ObjectName", CellTags -> "PartitHead"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PartitHead"], Cell["PartitHead[expr, h] returns a \
list {ex1, h[ex2]} with ex1 free of expressions with head h, and h[ex2] \
having head h.", "Text", CellTags -> "PartitHead"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["PauliSigma", "ObjectName", 
         CellTags -> "PauliSigma"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "PauliSigma"], 
           Cell["PauliSigma denotes the vector of the 3 Pauli matrices. \
PauliSigma[1], PauliSigma[2], PauliSigma[3] give the explicit Pauli matrices. \
PauliSigma[] yields {PauliSigma[1], PauliSigma[2], PauliSigma[3]}.", "Text", 
            CellTags -> "PauliSigma"], Cell[CellGroupData[{Cell[BoxData[
                \(\(PauliSigma[]\)//TableForm\)], "Input", CellTags -> 
                "PauliSigma"], Cell[BoxData[
                \(TraditionalForm\`\(\*InterpretationBox[GridBox[
                       {{GridBox[{{"0"}, {"1"}}, RowSpacings -> 0.25, 
                          ColumnSpacings -> 1., 
                          RowAlignments -> Baseline, 
                          ColumnAlignments -> {Left}], 
                         GridBox[{{"1"}, {"0"}}, RowSpacings -> 0.25, 
                          ColumnSpacings -> 1., 
                          RowAlignments -> Baseline, 
                          ColumnAlignments -> {Left}]}, 
                        {GridBox[{{"0"}, {\(-\[ImaginaryI]\)}}, 
                          RowSpacings -> 0.25, ColumnSpacings -> 1., 
                          RowAlignments -> Baseline, 
                          ColumnAlignments -> {Left}], 
                         GridBox[{{"\[ImaginaryI]"}, {"0"}}, 
                          RowSpacings -> 0.25, ColumnSpacings -> 1., 
                          RowAlignments -> Baseline, 
                          ColumnAlignments -> {Left}]}, 
                        {GridBox[{{"1"}, {"0"}}, RowSpacings -> 0.25, 
                          ColumnSpacings -> 1., 
                          RowAlignments -> Baseline, 
                          ColumnAlignments -> {Left}], 
                         GridBox[{{"0"}, {\(-1\)}}, RowSpacings -> 0.25, 
                          ColumnSpacings -> 1., RowAlignments -> Baseline, 
                          ColumnAlignments -> {Left}]}}, RowSpacings -> 1., 
                       ColumnSpacings -> 3., RowAlignments -> Baseline, 
                       ColumnAlignments -> {Left}], 
                      TableForm[List[List[List[0, 1], List[1, 0]], 
                        List[List[0, Complex[0, -1]], 
                         List[Complex[0, 1], 0]], 
                        List[List[1, 0], List[0, -1]]]]]\)\)], "Output", 
               CellTags -> "PauliSigma"]}, Open]]}, Open]], 
        Cell["PaVe", "ObjectName", CellTags -> "PaVe"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PaVe"], Cell[" PaVe[ i,j,... {p10,p12,...},{m1^2, \
mw^2, ...} ] denotes the invariant (and scalar) Passarino-Veltman integrals, \
i.e. the coefficient functions of the tensor integral decomposition. Joining \
plist and mlist gives the same conventions as for A0, B0, C0, D0. Automatic \
simlifications are performed for the coefficient functions of two-point \
integrals and for the scalar integrals.", "Text", CellTags -> "PaVe"], 
           Cell[TextData[{"For a more detailed description see the manual (no \
changes from there basically): ", 
              ButtonBox["http://www.mertig.com/oldfc", 
                RuleDelayed[ButtonData, 
                 List[URL["http://www.mertig.com/oldfc"], None]], 
                Rule[ButtonStyle, "Hyperlink"]]}], "Text", 
            CellTags -> "PaVe"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["PaVeReduce", RuleDelayed[ButtonData, "PaVeReduce"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeReduce"]], "."}], "Text", 
            CellTags -> "PaVe"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "PaVe"], 
           Cell["Some of the PaVe's reduce to special cases.", "Text", 
            CellTags -> "PaVe"], Cell[CellGroupData[{Cell[BoxData[
                \(PaVe[\(0, \({a, b, c, d, e, f}\), \({m1, m2, m3, m4}\)\)]\)]\
, "Input", CellTags -> "PaVe"], Cell[BoxData[FormBox[RowBox[{FormBox[
                    \("D"\_"0"\), "TraditionalForm"], "(", "a", ",", "b", 
                   ",", "c", ",", "d", ",", "e", ",", "f", ",", "m1", ",", 
                   "m2", ",", "m3", ",", "m4", ")"}], TraditionalForm]], 
               "Output", CellTags -> "PaVe"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PaVe[\(0, 0, \({pp}\), \({\(m^2\), \(M^2\)}\)\)]\)], 
               "Input", CellTags -> "PaVe"], Cell[BoxData[FormBox[RowBox[{
                   \(1\/3\ \(B\_0 (pp, m\^2, M\^2)\)\ m\^2\), "+", 
                   \(1\/18\ \((\(3\ m\^2\) + \(3\ M\^2\) - pp)\)\), "+", 
                   RowBox[{\(1\/6\), " ", RowBox[{"(", RowBox[{RowBox[
                          {FormBox[\("A"\_"0"\), "TraditionalForm"], "(", 
                          FormBox[\(M\^2\), "TraditionalForm"], ")"}], "+", 
                         \(\((m\^2 - M\^2 + pp)\)\ 
                            \((\(\((M\^2 - m\^2)\)\ 
                                  \((\(B\_0 (pp, m\^2, M\^2)\) - 
                                     \(B\_0 (0, m\^2, M\^2)\))\)\)\/\(2\ pp\)\
 - \(1\/2\ \(B\_0 (pp, m\^2, M\^2)\)\))\)\)}], ")"}]}]}], TraditionalForm]], 
               "Output", CellTags -> "PaVe"]}, Open]]}, Open]], 
        Cell["PaVeOrderList", "ObjectName", CellTags -> "PaVeOrderList"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PaVeOrderList"], Cell["PaVeOrderList is an option \
for PaVeOrder and PaVeReduce, specifying in which order the arguments of D0 \
are to be permuted.", "Text", CellTags -> "PaVeOrderList"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["PaVeOrder", RuleDelayed[ButtonData, "PaVeOrder"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeOrder"]], ", ", 
              ButtonBox["PaVeReduce", RuleDelayed[ButtonData, "PaVeReduce"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeReduce"]], ", ", 
              ButtonBox["PaVe", RuleDelayed[ButtonData, "PaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "PaVe"]], 
              ", ", 
              ButtonBox["D0", RuleDelayed[ButtonData, "D0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "D0"]], 
              "."}], "Text", CellTags -> "PaVeOrderList"], 
           Cell[BoxData[""], "Input"]}, Open]], Cell["PaVeOrder", 
         "ObjectName", CellTags -> "PaVeOrder"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PaVeOrder"], Cell[TextData[{"PaVeOrder[expr] orders \
the arguments of all D0 in expr in a standard way. PaVeOrder[expr, \
PaVeOrderList \[Rule] { {..., s, u, ...}, {... ", Cell[BoxData[
                \(TraditionalForm\`\(\(m\_1\)\^2\)\)]], ", ", Cell[BoxData[
                \(TraditionalForm\`\(\(m\_2\)\^2\)\)]], " ...}, ...}] orders \
the arguments of all D0 in expr according to the specified ordering lists. \
The lists may contain only a subsequence of the D0-variables."}], "Text", 
            CellTags -> "PaVeOrder"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["PaVeReduce", RuleDelayed[ButtonData, "PaVeReduce"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeReduce"]], "."}], "Text", 
            CellTags -> "PaVeOrder"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "PaVeOrder"], Cell[CellGroupData[{Cell[BoxData[
                \(PaVeOrder[\(\(D0[\(me2, me2, mw2, mw2, t, s, me2, 0, me2, 0
                        \)]\), \(PaVeOrderList \[Rule] \({me2, me2, 0, 0}\)\)
                \)]\)], "Input", CellTags -> "PaVeOrder"], Cell[BoxData[
                FormBox[RowBox[{FormBox[\("D"\_"0"\), "TraditionalForm"], 
                   "(", "me2", ",", "s", ",", "mw2", ",", "t", ",", "mw2", 
                   ",", "me2", ",", "me2", ",", FormBox["0", 
                    "TraditionalForm"], ",", FormBox["0", "TraditionalForm"], 
                   ",", "me2", ")"}], TraditionalForm]], "Output", 
               CellTags -> "PaVeOrder"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PaVeOrder[\(\(D0[\(me2, me2, mw2, mw2, t, s, me2, 0, me2, 0
                        \)]\), \(PaVeOrderList \[Rule] \({me2, me2, 0, 0}\)\)
                \)]\)], "Input", CellTags -> "PaVeOrder"], Cell[BoxData[
                FormBox[RowBox[{FormBox[\("D"\_"0"\), "TraditionalForm"], 
                   "(", "me2", ",", "s", ",", "mw2", ",", "t", ",", "mw2", 
                   ",", "me2", ",", "me2", ",", FormBox["0", 
                    "TraditionalForm"], ",", FormBox["0", "TraditionalForm"], 
                   ",", "me2", ")"}], TraditionalForm]], "Output", 
               CellTags -> "PaVeOrder"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PaVeOrder[\(\(\(D0[\(a, b, c, d, e, f, m12, m22, m32, m42\)
                         ]\) + \(D0[\(me2, me2, mw2, mw2, t, s, me2, 0, me2, 
                           0\)]\)\), \(PaVeOrderList \[Rule] 
                       \({\({me2, me2, 0, 0}\), \({f, e}\)}\)\)\)]\)], 
               "Input", CellTags -> "PaVeOrder"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{FormBox[\("D"\_"0"\), "TraditionalForm"], 
                     "(", "a", ",", "d", ",", "c", ",", "b", ",", "f", ",", 
                     "e", ",", "m22", ",", "m12", ",", "m42", ",", "m32", 
                     ")"}], "+", RowBox[{FormBox[\("D"\_"0"\), 
                      "TraditionalForm"], "(", "me2", ",", "s", ",", "mw2", 
                     ",", "t", ",", "mw2", ",", "me2", ",", "me2", ",", 
                     FormBox["0", "TraditionalForm"], ",", FormBox["0", 
                      "TraditionalForm"], ",", "me2", ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "PaVeOrder"]}, 
             Open]]}, Open]], Cell["PaVeReduce", "ObjectName", 
         CellTags -> "PaVeReduce"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "PaVeReduce"], 
           Cell["PaVeReduce[expr] reduces all Passarino-Veltman integrals \
(i.e. all PaVe's) in expr down to scalar A0, B0, C0 and D0.", "Text", 
            CellTags -> "PaVeReduce"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[PaVeReduce]\)], "Input", CellTags -> "PaVeReduce"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] True\), 
                      \(IsolateNames \[Rule] False\), 
                      \(Mandelstam \[Rule] \({}\)\), 
                      \(PaVeOrderList \[Rule] \({}\)\), 
                      \(WriteOutPaVe \[Rule] False\)}\)\)], "Output", 
               CellTags -> "PaVeReduce"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FRH", RuleDelayed[ButtonData, "FRH"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FRH"]], 
              ", ", 
              ButtonBox["PaVeOrder", RuleDelayed[ButtonData, "PaVeOrder"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeOrder"]], "."}], "Text", 
            CellTags -> "PaVeReduce"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "PaVeReduce"], Cell[CellGroupData[{Cell[BoxData[
                \(PaVeReduce[\(\(PaVe[\(1, 2, \({s, \(m^2\), \(m^2\)}\), 
                         \({\(m^2\), \(m^2\), \(M^2\)}\)\)]\), 
                     \(IsolateNames \[Rule] FF\)\)]\)], "Input", CellTags -> 
                "PaVeReduce"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[\(FF(10)\), HoldForm]\)\)], 
               "Output", CellTags -> "PaVeReduce"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(FF[10]\)], "Input", CellTags -> 
                "PaVeReduce"], Cell[BoxData[
                \(TraditionalForm\`\(\(\*TagBox[\(FF(4)\), HoldForm]\ 
                        \*TagBox[\(FF(9)\), HoldForm]\ M\^2\)\/
                      \*TagBox[\(FF(5)\), HoldForm]\^2 + 
                     \(\*TagBox[\(FF(1)\), HoldForm]\ 
                        \*TagBox[\(FF(6)\), HoldForm]\)\/
                      \(2\ m\^2\ \*TagBox[\(FF(5)\), HoldForm]\) - 
                     \(\*TagBox[\(FF(2)\), HoldForm]\ 
                        \*TagBox[\(FF(7)\), HoldForm]\)\/
                      \(2\ m\^2\ \*TagBox[\(FF(5)\), HoldForm]\^2\) + 
                     \(\*TagBox[\(FF(3)\), HoldForm]\ 
                        \*TagBox[\(FF(8)\), HoldForm]\)\/
                      \(2\ \*TagBox[\(FF(5)\), HoldForm]\^2\) + 
                     1\/\(2\ \*TagBox[\(FF(5)\), HoldForm]\)\)\)], "Output", 
               CellTags -> "PaVeReduce"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(FRH[%]\)], "Input", CellTags -> 
                "PaVeReduce"], Cell[BoxData[FormBox[RowBox[{FractionBox[
                    RowBox[{\((\(8\ m\^2\) - \(3\ M\^2\) - \(2\ s\))\), " ", 
                      RowBox[{FormBox[\("C"\_"0"\), "TraditionalForm"], "(", 
                        FormBox[\(m\^2\), "TraditionalForm"], ",", FormBox[
                         \(m\^2\), "TraditionalForm"], ",", "s", ",", FormBox[
                         \(m\^2\), "TraditionalForm"], ",", FormBox[\(M\^2\), 
                         "TraditionalForm"], ",", FormBox[\(m\^2\), 
                         "TraditionalForm"], ")"}], " ", \(M\^2\)}], 
                    \(\((\(4\ m\^2\) - s)\)\^2\)], "+", 
                   \(\(\((m\^2 - M\^2)\)\ \(B\_0 (0, m\^2, M\^2)\)\)\/
                      \(2\ m\^2\ \((\(4\ m\^2\) - s)\)\)\), "-", 
                   \(\(\((\(8\ m\^4\) - \(10\ M\^2\ m\^2\) - \(2\ s\ m\^2\) +
                            \(M\^2\ s\))\)\ \(B\_0 (m\^2, m\^2, M\^2)\)\)\/
                      \(2\ m\^2\ \((\(4\ m\^2\) - s)\)\^2\)\), "+", 
                   \(\(\((\(4\ m\^2\) - \(6\ M\^2\) - s)\)\ 
                        \(B\_0 (s, m\^2, m\^2)\)\)\/
                      \(2\ \((\(4\ m\^2\) - s)\)\^2\)\), "+", 
                   \(1\/\(2\ \((\(4\ m\^2\) - s)\)\)\)}], TraditionalForm]], 
               "Output", CellTags -> "PaVeReduce"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PaVeReduce[\(\(PaVe[\(2, 
                         \({\(SmallVariable[me2]\), mw2, t}\), 
                         \({\(SmallVariable[me2]\), 0, mw2}\)\)]\), 
                     \(WriteOutPaVe \[Rule] "p"\)\)]\)], "Input", CellTags -> 
                "PaVeReduce"], Cell[BoxData[
                \(TraditionalForm\`\(\(B\_0 (0, mw2, mw2)\)\/\(mw2 - t\) - 
                     \(B\_0 (t, mw2, me2)\)\/\(mw2 - t\) + 2\/\(mw2 - t\)\)\)]\
, "Output", CellTags -> "PaVeReduce"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(TableForm[\(ReadList[\(
                      \(\(If[\(\($OperatingSystem === "MacOS"\), ":", ""\)]\)
                          <> "pPaVe2Csmame2mw2tCsmame20mw2.s"\), String\)]\)]
                \)], "Input", CellTags -> "PaVeReduce"], Cell[BoxData[
                \(TraditionalForm\`\(\*InterpretationBox[GridBox[
                       {{"\"( 2/(mw2 - t) + B0[0, mw2, mw2]/(mw2 - t) - \
B0[t, mw2, \
SmallVariable[me2]]/\""}, 
                        {"\"  (mw2 - t)\""}, {"\"  ) \""}}, 
                       RowSpacings -> 1., ColumnSpacings -> 3., 
                       RowAlignments -> Baseline, 
                       ColumnAlignments -> {Left}], 
                      TableForm[List["( 2/(mw2 - t) + B0[0, mw2, mw2]/(mw2 - \
t) - B0[t, mw2, SmallVariable[me2]]/", "  (mw2 - t)", "  ) "]\
]]\)\)], "Output", CellTags -> "PaVeReduce"]}, Open]], Cell[BoxData[
             \(\(DeleteFile/@\(FileNames["pPaVe2Csmame2mw2tCsmame20mw2.s"]\)
                 \) ;\)], "Input", CellTags -> "PaVeReduce"], Cell[BoxData[
             \(\(se = \(SmallVariable[ME2]\)\) ;\)], "Input", 
            CellTags -> "PaVeReduce"], Cell[CellGroupData[{Cell[BoxData[
                \(d122 = \(PaVeReduce[\(\(
                        PaVe[\(1, 2, 2, \({se, MW2, MW2, se, S, T}\), 
                           \({0, se, 0, se}\)\)]\), 
                       \(Mandelstam \[Rule] \({S, T, U, \(2\ MW2\)}\)\), 
                       \(IsolateNames \[Rule] F\)\)]\)\)], "Input", 
               CellTags -> "PaVeReduce"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[\(F(18)\), HoldForm]\)\)], 
               "Output", CellTags -> "PaVeReduce"]}, Open]], Cell[BoxData[
             \(\(Write2[\("fctd122.for", \(d122res == d122\), 
                    \(FormatType \[Rule] FortranForm\)\)]\) ;\)], "Input", 
            CellTags -> "PaVeReduce"], Cell[CellGroupData[{Cell[BoxData[
                \(TableForm[\(ReadList[\(
                      \(\(If[\(\($OperatingSystem === "MacOS"\), ":", ""\)]\)
                          <> "fctd122.for"\), String\)]\)]\)], "Input", 
               CellTags -> "PaVeReduce"], Cell[BoxData[
                \(TraditionalForm\`\(\*InterpretationBox[GridBox[
                       {{"\"        F(1)= F(1)\""}, 
                        {"\"        F(2)= F(2)\""}, 
                        {"\"        F(3)= B0(MW2,ME2,0D0)\""}, 
                        {"\"        F(4)= B0(S,0D0,0D0)\""}, 
                        {"\"        F(5)= B0(T,ME2,ME2)\""}, 
                        {"\"        F(6)= C0(MW2,MW2,T,ME2,0D0,ME2)\""}, 
                        {"\"        F(7)= C0(MW2,S,ME2,ME2,0D0,0D0)\""}, 
                        {"\"        F(8)= C0(T,ME2,ME2,ME2,ME2,0D0)\""}, 
                        {"\"        F(9)= \
D0(MW2,MW2,ME2,ME2,T,S,ME2,0D0,ME2,0D0)\""}, 
                        {"\"        F(10)= MW2 + S\""}, 
                        {"\"        F(11)= 4*MW2 - T\""}, 
                        {"\"        F(12)= MW2**2 - S*U\""}, 
                        {"\"        F(13)= MW2 - S\""}, 
                        {"\"        F(14)= 4*MW2**5 - 5*MW2**4*S - \
16*MW2**3*S**2 + \
\""}, 
                        {"\"     &  4*MW2**2*S**3 + 4*MW2*S**4 - MW2**4*U \
- \""}, {"\"     &  4*MW2**2*S**2*U + 8*MW2*S**3*U + \
4*MW2**2*S*U**2 \
+ \""}, 
                        {"\"     &  S**3*U**2 + S**2*U**3\""}, 
                        {"\"        F(15)= MW2**2 - 4*MW2*S + 2*S**2 + \
S*U\""}, {"\"        F(16)= 4*MW2**3 - 9*MW2**2*S + \
2*S**3 - MW2**2*U \
- \""}, 
                        {"\"     &  4*MW2*S*U + 5*S**2*U + 3*S*U**2\""}, 
                        {"\"        F(17)= 2*MW2**6 - 8*MW2**5*S + \
12*MW2**4*S**2 - \
\""}, 
                        {"\"     &  8*MW2**3*S**3 + 2*MW2**2*S**4 - \
2*MW2**5*T + \""}, {"\"     &  20*MW2**4*S*T - \
36*MW2**3*S**2*T + \
20*MW2**2*S**3*T - \""}, 
                        {"\"     &  2*MW2*S**4*T - 6*MW2**3*S*T**2 + \

                          6*MW2**2*S**2*T**2 - \""}, 
                        {"\"     &  6*MW2*S**3*T**2 + 4*MW2*S**2*T**3 - \
S**2*T**4\""}, {"\"        F(18)= \
-F(10)/(2D0*F(11)*F(12)) - \""}, 
                        {"\"     &  (S**2*T**2*F(8)*F(13))/(2D0*F(12)**3) \
+ \""}, {"\"     &  (S**3*T**2*F(9)*F(13))/(2D0*F(12)**3) \
+ \""}, {"\"     &  (S**2*T*F(7)*F(13)**2)/F(12)**3 - \
\""}, {"\"     &  \
(F(3)*F(14))/(2D0*F(11)**2*F(12)**2*F(13)) + \""}, 
                        {"\"     &  (S*F(4)*F(15))/(2D0*F(12)**2*F(13)) + \
\""}, {"\"     &  \
(F(5)*F(10)*F(16))/(2D0*F(11)**2*F(12)**2) - \""}, 
                        {"\"     &  \
(F(6)*F(10)*F(17))/(2D0*F(11)**2*F(12)**3)\""}, 
                        {"\"        d122res = F(18D1)\""}}, 
                       RowSpacings -> 1., ColumnSpacings -> 3., 
                       RowAlignments -> Baseline, 
                       ColumnAlignments -> {Left}], 
                      TableForm[List["        F(1)= F(1)", 
                        "        F(2)= F(2)", 
                        "        F(3)= B0(MW2,ME2,0D0)", 
                        "        F(4)= B0(S,0D0,0D0)", 
                        "        F(5)= B0(T,ME2,ME2)", 
                        "        F(6)= C0(MW2,MW2,T,ME2,0D0,ME2)", 
                        "        F(7)= C0(MW2,S,ME2,ME2,0D0,0D0)", 
                        "        F(8)= C0(T,ME2,ME2,ME2,ME2,0D0)", 
                        "        F(9)= \
D0(MW2,MW2,ME2,ME2,T,S,ME2,0D0,ME2,0D0)", 
                        "        F(10)= MW2 + S", 
                        "        F(11)= 4*MW2 - T", 
                        "        F(12)= MW2**2 - S*U", 
                        "        F(13)= MW2 - S", 
                        "        F(14)= 4*MW2**5 - 5*MW2**4*S - \
16*MW2**3*S**2 + ", "     &  4*MW2**2*S**3 + 4*MW2*S**4 - \
MW2**4*U - ", "     &  4*MW2**2*S**2*U + 8*MW2*S**3*U + \
4*MW2**2*S*U**2 + ", "     &  S**3*U**2 + S**2*U**3", 
                        "        F(15)= MW2**2 - 4*MW2*S + 2*S**2 + S*U", 
                        "        F(16)= 4*MW2**3 - 9*MW2**2*S + 2*S**3 - \
MW2**2*U - ", "     &  4*MW2*S*U + 5*S**2*U + 3*S*U**2", 
                        "        F(17)= 2*MW2**6 - 8*MW2**5*S + \
12*MW2**4*S**2 - ", "     &  8*MW2**3*S**3 + 2*MW2**2*S**4 - \
2*MW2**5*T + ", "     &  20*MW2**4*S*T - 36*MW2**3*S**2*T + \
20*MW2**2*S**3*T - ", "     &  2*MW2*S**4*T - \
6*MW2**3*S*T**2 + 6*MW2**2*S**2*T**2 - ", 
                        "     &  6*MW2*S**3*T**2 + 4*MW2*S**2*T**3 - \
S**2*T**4", "        F(18)= -F(10)/(2D0*F(11)*F(12)) - ", 
                        "     &  (S**2*T**2*F(8)*F(13))/(2D0*F(12)**3) + ", 
                        "     &  (S**3*T**2*F(9)*F(13))/(2D0*F(12)**3) + ", 
                        "     &  (S**2*T*F(7)*F(13)**2)/F(12)**3 - ", 
                        "     &  (F(3)*F(14))/(2D0*F(11)**2*F(12)**2*F(13)) \
+ ", "     &  (S*F(4)*F(15))/(2D0*F(12)**2*F(13)) + ", 
                        "     &  (F(5)*F(10)*F(16))/(2D0*F(11)**2*F(12)**2) \
- ", "     &  (F(6)*F(10)*F(17))/(2D0*F(11)**2*F(12)**3)", 
                        "        d122res = F(18D1)"]]]\)\)], "Output", 
               CellTags -> "PaVeReduce"]}, Open]], Cell[BoxData[
             \(\(DeleteFile/@\(FileNames["fctd122.for"]\)\) ; 
                \(Clear[\(d122, se\)]\) ;\)], "Input", CellTags -> 
             "PaVeReduce"]}, Open]], Cell["PD", "ObjectName", 
         CellTags -> "PD"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "PD"], 
           Cell["PD is an abbreviation for PropagatorDenominator.", "Text", 
            CellTags -> "PD"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["PropagatorDenominator", 
                RuleDelayed[ButtonData, "PropagatorDenominator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PropagatorDenominator"]], ", ", 
              ButtonBox["IFPD", RuleDelayed[ButtonData, "IFPD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "IFPD"]], 
              "."}], "Text", CellTags -> "PD"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["PlusDistribution", "ObjectName", 
         CellTags -> "PlusDistribution"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "PlusDistribution"], Cell["PlusDistribution[1/(1-x)] denotes a \
distribution (in the sense of the \"+\" prescription).", "Text", 
            CellTags -> "PlusDistribution"], Cell[TextData[{"See also: ", 
              " ", 
              ButtonBox["Integrate2", RuleDelayed[ButtonData, "Integrate2"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Integrate2"]], "."}], "Text", 
            CellTags -> "PlusDistribution"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "PlusDistribution"], Cell[CellGroupData[{Cell[BoxData[
                \(PlusDistribution[\(1/\((1 - x)\)\)]\)], "Input", 
               CellTags -> "PlusDistribution"], Cell[BoxData[
                \(TraditionalForm\`\((1\/\(1 - x\))\)\_+\)], "Output", 
               CellTags -> "PlusDistribution"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PlusDistribution[\(\(Log[\(1 - x\)]\)/\((1 - x)\)\)]\)], 
               "Input", CellTags -> "PlusDistribution"], Cell[BoxData[
                \(TraditionalForm\`\((\(log(\(1 - x\))\)\/\(1 - x\))\)\_+\)], 
               "Output", CellTags -> "PlusDistribution"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(PlusDistribution[\(1/\((1 - x)\)\)]\),\ 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> 
                "PlusDistribution"], Cell[BoxData[\(TraditionalForm\`0\)], 
               "Output", CellTags -> "PlusDistribution"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(PlusDistribution[
                       \(\(Log[\(1 - x\)]\)/\((1 - x)\)\)]\),\ \({x, 0, 1}\)\
\)]\)], "Input", CellTags -> "PlusDistribution"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> 
                "PlusDistribution"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Integrate2[\(\(PlusDistribution[
                       \(\(\(Log[\(1 - x\)]\)^2\)/\((1 - x)\)\)]\),\ 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> 
                "PlusDistribution"], Cell[BoxData[\(TraditionalForm\`0\)], 
               "Output", CellTags -> "PlusDistribution"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PlusDistribution[\(\(Log[\(x\ \((1 - x)\)\)]\)/\((1 - x)\)
                    \)]\)], "Input", CellTags -> "PlusDistribution"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(log(x)\)\/\(1 - x\) + 
                     \(\((\(log(\(1 - x\))\)\/\(1 - x\))\)\_+\)\)\)], 
               "Output", CellTags -> "PlusDistribution"]}, Open]]}, Open]], 
        Cell["Polarization", "ObjectName", CellTags -> "Polarization"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Polarization"], Cell["Polarization[k] = \
Polarization[k, I] is the head of a polarization momentum with (incoming) \
momentum k. A slashed polarization vector (e1(k) slash) has to be entered as \
DiracSlash[Polarization[k]]. The internal representation for a polarization \
vector e1 corresponding to a boson with four momentum k is: Momentum[ \
Polarization[ k, I ] ]. With this notation transversality of polarization \
vectors is provided, i.e. , Pair[ Momentum[k], Momentum[ Polarization[k, I] ] \
] yields 0. Polarization[k,-I] denotes the complex conjugate polarization. \
Polarization is also an option of various functions related to the operator \
product expansion. The setting 0 denotes the unpolarized and 1 the polarized \
case.", "Text", CellTags -> "Polarization"], Cell[TextData[{"See also: ", 
              " ", 
              ButtonBox["PolarizationVector", 
                RuleDelayed[ButtonData, "PolarizationVector"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PolarizationVector"]], ", ", 
              ButtonBox["PolarizationSum", 
                RuleDelayed[ButtonData, "PolarizationSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PolarizationSum"]], ", ", 
              ButtonBox["DoPolarizationSums", 
                RuleDelayed[ButtonData, "DoPolarizationSums"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DoPolarizationSums"]], "."}], "Text", 
            CellTags -> "Polarization"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Polarization"], Cell[CellGroupData[{Cell[BoxData[
                \(Polarization[k]\)], "Input", CellTags -> "Polarization"], 
              Cell[BoxData[FormBox[RowBox[{"\[CurlyEpsilon]", "(", 
                   FormBox[FormBox[
                     TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                       Function[StyleForm[Slot[1], 
                         Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "Polarization"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Polarization[k]\)//StandardForm\)], "Input", CellTags -> 
                "Polarization"], Cell[BoxData[
                \(Polarization[\(k, \[ImaginaryI]\)]\)], "Output", 
               CellTags -> "Polarization"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Polarization[k]\)//ComplexConjugate\)], "Input", 
               CellTags -> "Polarization"], Cell[BoxData[FormBox[
                 RowBox[{FormBox[
                    InterpretationBox[\("\[CurlyEpsilon]"\^"*"\), 
                      Superscript["\[CurlyEpsilon]", "*"], 
                      Rule[Editable, False]], "TraditionalForm"], "(", 
                   FormBox[FormBox[
                     TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                       Function[StyleForm[Slot[1], 
                         Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "Polarization"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(Polarization[k]\)//ComplexConjugate\)//StandardForm\)], 
               "Input", CellTags -> "Polarization"], Cell[BoxData[
                \(Polarization[\(k, \(-\[ImaginaryI]\)\)]\)], "Output", 
               CellTags -> "Polarization"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DiracSlash[\(Polarization[k]\)]\)], "Input", CellTags -> 
                "Polarization"], Cell[BoxData[FormBox[RowBox[
                  {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                   "\[CenterDot]", FormBox[RowBox[{"\[CurlyEpsilon]", "(", 
                      FormBox[FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "TraditionalForm"], ")"}], "TraditionalForm"]}], 
                 TraditionalForm]], "Output", CellTags -> "Polarization"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(DiracSlash[\(Polarization[k]\)]\)//StandardForm\)], 
               "Input", CellTags -> "Polarization"], Cell[BoxData[
                \(DiracSlash[\(Polarization[\(k, \[ImaginaryI]\)]\)]\)], 
               "Output", CellTags -> "Polarization"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Pair[\ \(\(Momentum[k]\),\ 
                     \(Momentum[\ \(Polarization[\(k,\ I\)]\)\ ]\)\)\ ]\)], 
               "Input", CellTags -> "Polarization"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> 
                "Polarization"]}, Open]]}, Open]], Cell["PolarizationSum", 
         "ObjectName", CellTags -> "PolarizationSum"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PolarizationSum"], Cell["PolarizationSum[ mu,nu, ... \
] defines (as abbreviations) several polarization sums. The first two \
arguments are the interpreted as Lorentz indices, all further ones are \
momenta. PolarizationSum performs no calculations.", "Text", 
            CellTags -> "PolarizationSum"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[PolarizationSum]\)], "Input", CellTags -> 
                "PolarizationSum"], Cell[BoxData[
                \(TraditionalForm\`\({Dimension \[Rule] 4}\)\)], "Output", 
               CellTags -> "PolarizationSum"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Polarization", 
                RuleDelayed[ButtonData, "Polarization"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Polarization"]], "."}], "Text", 
            CellTags -> "PolarizationSum"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "PolarizationSum"], Cell[CellGroupData[{Cell[BoxData[
                \(PolarizationSum[\(\[Mu], \[Nu]\)]\)], "Input", CellTags -> 
                "PolarizationSum"], Cell[BoxData[
                \(TraditionalForm\`\(-g\^\(\[Mu]\[Nu]\)\)\)], "Output", 
               CellTags -> "PolarizationSum"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PolarizationSum[\(\[Mu], \[Nu], k\)]\)], "Input", 
               CellTags -> "PolarizationSum"], Cell[BoxData[FormBox[
                 RowBox[{FractionBox[RowBox[{SuperscriptBox[FormBox[FormBox[
                         TagBox[StyleBox["\"k\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]], 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["\[Mu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                        FormBox[
                         TagBox[StyleBox["\"k\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]], 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["\[Nu]", "TraditionalForm"], 
                        "TraditionalForm"]]}], SuperscriptBox[FormBox[FormBox[
                       TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                      "TraditionalForm"], "2"]], "-", \(g\^\(\[Mu]\[Nu]\)\)}]
                   , TraditionalForm]], "Output", CellTags -> 
                "PolarizationSum"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(PolarizationSum[\(\[Mu], \[Nu], k, n\)]\)], "Input", 
               CellTags -> "PolarizationSum"], Cell[BoxData[FormBox[RowBox[{
                   \(-g\^\(\[Mu]\[Nu]\)\), "-", FractionBox[RowBox[
                     {SuperscriptBox[FormBox[FormBox[
                         TagBox[StyleBox["\"k\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]], 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["\[Mu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                        FormBox[
                         TagBox[StyleBox["\"k\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]], 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["\[Nu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", SuperscriptBox[FormBox["n", 
                        "TraditionalForm"], "2"]}], SuperscriptBox[FormBox[
                      RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox["n", "TraditionalForm"]}], 
                      "TraditionalForm"], "2"]], "+", FractionBox[RowBox[
                     {RowBox[{SuperscriptBox[FormBox["n", "TraditionalForm"], 
                         FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                         FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "n", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}]}], 
                    RowBox[{FormBox[FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "TraditionalForm"], "\[CenterDot]", FormBox["n", 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "PolarizationSum"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PolarizationSum[\(\[Mu], \[Nu], k, \(p\_1 - p\_2\)\)]\)], 
               "Input", CellTags -> "PolarizationSum"], Cell[BoxData[
                FormBox[RowBox[{\(-g\^\(\[Mu]\[Nu]\)\), "-", FractionBox[
                    RowBox[{SuperscriptBox[FormBox[FormBox[
                         TagBox[StyleBox["\"k\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]], 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["\[Mu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                        FormBox[
                         TagBox[StyleBox["\"k\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]], 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["\[Nu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", \(p\_1\%2\)}], 
                    SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{FormBox[
                          FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}], "-", RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], ")"}], "2"]], "+", 
                   FractionBox[RowBox[{"2", " ", SuperscriptBox[FormBox[
                        FormBox[
                         TagBox[StyleBox["\"k\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]], 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["\[Mu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                        FormBox[
                         TagBox[StyleBox["\"k\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]], 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["\[Nu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", RowBox[{FormBox[\(p\_1\), 
                         "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                         , "TraditionalForm"]}]}], SuperscriptBox[RowBox[
                      {"(", RowBox[{RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}], "-", RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], ")"}], "2"]], "-", 
                   FractionBox[RowBox[{SuperscriptBox[FormBox[FormBox[
                         TagBox[StyleBox["\"k\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]], 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["\[Mu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                        FormBox[
                         TagBox[StyleBox["\"k\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]], 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["\[Nu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", \(p\_2\%2\)}], 
                    SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{FormBox[
                          FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}], "-", RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], ")"}], "2"]], "+", 
                   FractionBox[RowBox[{RowBox[{SuperscriptBox[RowBox[{"(", 
                          FormBox[\(p\_1 - p\_2\), "TraditionalForm"], ")"}], 
                         FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                         FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[RowBox[
                          {"(", FormBox[\(p\_1 - p\_2\), "TraditionalForm"], 
                          ")"}], FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], RowBox[{RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(p\_1\), 
                         "TraditionalForm"]}], "-", RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(p\_2\), 
                         "TraditionalForm"]}]}]]}], TraditionalForm]], 
               "Output", CellTags -> "PolarizationSum"]}, Open]]}, Open]], 
        Cell["PolarizationUncontract", "ObjectName", 
         CellTags -> "PolarizationUncontract"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PolarizationUncontract"], Cell["PolarizationUncontra\
ct does Uncontract on scalar products involving polarization vectors.", 
            "Text", CellTags -> "PolarizationUncontract"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Polarization", 
                RuleDelayed[ButtonData, "Polarization"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Polarization"]], ", ", 
              ButtonBox["Uncontract", RuleDelayed[ButtonData, "Uncontract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Uncontract"]], "."}], "Text", 
            CellTags -> "PolarizationUncontract"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["PolarizationVector", "ObjectName", 
         CellTags -> "PolarizationVector"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PolarizationVector"], 
           Cell["PolarizationVector[p, mu] gives a polarization vector.", 
            "Text", CellTags -> "PolarizationVector"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["FourVector", RuleDelayed[ButtonData, "FourVector"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FourVector"]], ", ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              ", ", 
              ButtonBox["Polarization", 
                RuleDelayed[ButtonData, "Polarization"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Polarization"]], "."}], "Text", 
            CellTags -> "PolarizationVector"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "PolarizationVector"], Cell[CellGroupData[
             {Cell[BoxData[\(PolarizationVector[\(k, \[Mu]\)]\)], "Input", 
               CellTags -> "PolarizationVector"], Cell[BoxData[FormBox[
                 RowBox[{SubscriptBox["\[CurlyEpsilon]", FormBox[FormBox[
                      "\[Mu]", "TraditionalForm"], "TraditionalForm"]], "(", 
                   FormBox[FormBox[
                     TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                       Function[StyleForm[Slot[1], 
                         Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "PolarizationVector"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Conjugate[\(PolarizationVector[\(k, \[Mu]\)]\)]\)], 
               "Input", CellTags -> "PolarizationVector"], Cell[BoxData[
                FormBox[RowBox[{SubsuperscriptBox["\[CurlyEpsilon]", 
                    FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"], "*"], "(", FormBox[FormBox[
                     TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                       Function[StyleForm[Slot[1], 
                         Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "PolarizationVector"]}, Open]], 
           Cell[TextData[{"A polarization vector ", Cell[BoxData[
                \(TraditionalForm\`\(\[CurlyEpsilon]\_\[Mu](k)\)\)]], 
              "is a special four-vector."}], "Text", CellTags -> 
             "PolarizationVector"], Cell[CellGroupData[{Cell[BoxData[
                \(\(PolarizationVector[\(k, mu\)]\)//StandardForm\)], 
               "Input", CellTags -> "PolarizationVector"], Cell[BoxData[
                \(Pair[\(\(LorentzIndex[mu]\), 
                     \(Momentum[\(Polarization[\(k, \[ImaginaryI]\)]\)]\)\)]\
\)], "Output", CellTags -> "PolarizationVector"]}, Open]], 
           Cell[TextData[{"The transverality property ", Cell[BoxData[
                FormBox[RowBox[{RowBox[{SuperscriptBox[FormBox["k", 
                       "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     \(\[CurlyEpsilon]\_\[Mu](k)\)}], "=", "0"}], 
                 TraditionalForm]]], " is built in."}], "Text", 
            CellTags -> "PolarizationVector"], Cell[CellGroupData[
             {Cell[BoxData[
                \(a1\ =\ \(\(PolarizationVector[\(k, \[Mu]\)]\)\ 
                     \(FourVector[\(k, \[Mu]\)]\)\)\)], "Input", CellTags -> 
                "PolarizationVector"], Cell[BoxData[FormBox[RowBox[
                  {SubscriptBox[FormBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "TraditionalForm"], "\[Mu]"], " ", RowBox[{SubscriptBox[
                      "\[CurlyEpsilon]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], "(", 
                     FormBox[FormBox[
                       TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                      "TraditionalForm"], ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "PolarizationVector"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Contract[a1]\)], "Input", 
               CellTags -> "PolarizationVector"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> 
                "PolarizationVector"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(a2\ =\ \(\(PolarizationVector[\(\(k - p\), \[Mu]\)]\)\ 
                     \(FourVector[\(k, \[Mu]\)]\)\)\)], "Input", CellTags -> 
                "PolarizationVector"], Cell[BoxData[FormBox[RowBox[
                  {SubscriptBox[FormBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "TraditionalForm"], "\[Mu]"], " ", RowBox[{SubscriptBox[
                      "\[CurlyEpsilon]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], "(", 
                     FormBox[RowBox[{FormBox[
                         TagBox[StyleBox["\"k\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]], 
                         "TraditionalForm"], "-", "p"}], "TraditionalForm"], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "PolarizationVector"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Contract[a2]\)], "Input", CellTags -> 
                "PolarizationVector"], Cell[BoxData[FormBox[RowBox[
                  {FormBox[FormBox[
                     TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                       Function[StyleForm[Slot[1], 
                         Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                    "TraditionalForm"], "\[CenterDot]", "(", FormBox[
                    RowBox[{"\[CurlyEpsilon]", "(", FormBox[RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "p"}], "TraditionalForm"], 
                      ")"}], "TraditionalForm"], ")"}], TraditionalForm]], 
               "Output", CellTags -> "PolarizationVector"]}, Open]], 
           Cell[TextData[{"Depending on the alphabetical ordering of the \
momenta simplifcations are done, e.g., ", Cell[BoxData[FormBox[RowBox[
                  {RowBox[{SuperscriptBox[FormBox["p", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{
                       \(\[CurlyEpsilon]\_\[Mu]\), "(", FormBox[\(k - p\), 
                        "TraditionalForm"], ")"}]}], "=", RowBox[{RowBox[{
                       \(-\((k - p - k)\)\^\[Mu]\), RowBox[{
                         \(\[CurlyEpsilon]\_\[Mu]\), "(", FormBox[\(k - p\), 
                          "TraditionalForm"], ")"}]}], "=", RowBox[{RowBox[{
                         \(k\^\[Mu]\), RowBox[{\(\[CurlyEpsilon]\_\[Mu]\), 
                          "(", FormBox[\(k - p\), "TraditionalForm"], 
                          ")"}]}], "=", RowBox[{FormBox["k", 
                          "TraditionalForm"], "\[NoBreak]", "\[CenterDot]", 
                         "\[NoBreak]", RowBox[{RowBox[{"(", "\[NoBreak]", 
                          FormBox[RowBox[{"\[CurlyEpsilon]", "\[NoBreak]", 
                          "(", "\[NoBreak]", FormBox[\(k - p\), 
                          "TraditionalForm"], "\[NoBreak]", ")"}], 
                          "TraditionalForm"], "\[NoBreak]", ")"}], 
                          "."}]}]}]}]}], TraditionalForm]]]}], "Text", 
            CellTags -> "PolarizationVector"], Cell[CellGroupData[
             {Cell[BoxData[
                \(a3\ =\ \(\(PolarizationVector[\(\(k - p\), \[Mu]\)]\)\ 
                     \(FourVector[\(p, \[Mu]\)]\)\)\)], "Input", CellTags -> 
                "PolarizationVector"], Cell[BoxData[FormBox[RowBox[{
                   \(p\_\[Mu]\), " ", RowBox[{SubscriptBox["\[CurlyEpsilon]", 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], "(", FormBox[RowBox[{FormBox[
                         TagBox[StyleBox["\"k\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]], 
                         "TraditionalForm"], "-", "p"}], "TraditionalForm"], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "PolarizationVector"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Contract[a3]\)], "Input", CellTags -> 
                "PolarizationVector"], Cell[BoxData[FormBox[RowBox[
                  {FormBox[FormBox[
                     TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                       Function[StyleForm[Slot[1], 
                         Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                    "TraditionalForm"], "\[CenterDot]", "(", FormBox[
                    RowBox[{"\[CurlyEpsilon]", "(", FormBox[RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "p"}], "TraditionalForm"], 
                      ")"}], "TraditionalForm"], ")"}], TraditionalForm]], 
               "Output", CellTags -> "PolarizationVector"]}, Open]], 
           Cell[BoxData[\(Clear[\(a1, a2, a3\)]\)], "Input", 
            CellTags -> "PolarizationVector"]}, Open]], 
        Cell["PositiveInteger", "ObjectName", CellTags -> "PositiveInteger"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PositiveInteger"], Cell["PositiveInteger is a data \
type. E.g. DataType[OPEm, PositiveInteger] gives True.", "Text", 
            CellTags -> "PositiveInteger"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DataType", RuleDelayed[ButtonData, "DataType"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DataType"]], "."}], "Text", 
            CellTags -> "PositiveInteger"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["PositiveNumber", "ObjectName", 
         CellTags -> "PositiveNumber"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "PositiveNumber"], Cell["PositiveNumber is a data type. E.g. \
DataType[Epsilon, PositiveNumber] = True (by default). ", "Text", 
            CellTags -> "PositiveNumber"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DataType", RuleDelayed[ButtonData, "DataType"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DataType"]], "."}], "Text", 
            CellTags -> "PositiveNumber"]}, Open]], Cell["PowerFactor", 
         "ObjectName", CellTags -> "PowerFactor"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PowerFactor"], Cell[TextData[
             {"PowerFactor[exp] replaces ", Cell[BoxData[
                \(TraditionalForm\`\(x\^a\)\)]], Cell[BoxData[
                \(TraditionalForm\`\(y\^a\)\)]], "with ", Cell[BoxData[
                \(TraditionalForm\`\(\((x\ y)\)\^a\)\)]], "."}], "Text", 
            CellTags -> "PowerFactor"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["PowerSimplify", 
                RuleDelayed[ButtonData, "PowerSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PowerSimplify"]], "."}], "Text", 
            CellTags -> "PowerFactor"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "PowerFactor"], Cell[CellGroupData[{Cell[BoxData[
                \(x\^a y\^a\)], "Input", CellTags -> "PowerFactor"], 
              Cell[BoxData[\(TraditionalForm\`\(x\^a\ y\^a\)\)], "Output", 
               CellTags -> "PowerFactor"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(PowerFactor[%]\)], "Input", 
               CellTags -> "PowerFactor"], Cell[BoxData[
                \(TraditionalForm\`\(\((x\ y)\)\^a\)\)], "Output", 
               CellTags -> "PowerFactor"]}, Open]]}, Open]], 
        Cell["PowerSimplify", "ObjectName", CellTags -> "PowerSimplify"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PowerSimplify"], Cell[TextData[
             {"PowerSimplify[exp] simplifies", Cell[BoxData[
                \(TraditionalForm\`\(\ \((\(-x\))\)\^a\)\)]], " to ", 
              Cell[BoxData[\(TraditionalForm\`\(\((\(-1\))\)\^a\)\)]], " ", 
              Cell[BoxData[\(TraditionalForm\`\(x\^a\)\)]], " and ", 
              Cell[BoxData[\(TraditionalForm\`\(\((y - x)\)\^n\)\)]], " to ", 
              Cell[BoxData[\(TraditionalForm\`\(\((\(-1\))\)\^n\)\)]], " ", 
              Cell[BoxData[\(TraditionalForm\`\(\((x - y)\)\^n\)\)]], "; thus \
assuming that the exponent is an integer (even if it is symbolic). \
Furthermore ", Cell[BoxData[\(TraditionalForm\`\(\((\(-1\))\)\^\(a + n\)\)\)]]
                , " and ", Cell[BoxData[
                \(TraditionalForm\`\(\[ImaginaryI]\^\(a + n\)\)\)]], 
              " are expanded and ", Cell[BoxData[
                \(TraditionalForm\`\(\[ImaginaryI]\^\(2\ m\)\)\)]], 
              " \[Rule] ", Cell[BoxData[
                \(TraditionalForm\`\(\((\(-1\))\)\^m\)\)]], " and (-1)^(", 
              StyleBox["n", Rule[FontSlant, "Italic"]], " ", 
              StyleBox["m", Rule[FontSlant, "Italic"]], 
              ") \[Rule] 1 and (-1)^(", 
              StyleBox["n", Rule[FontSlant, "Italic"]], " ", 
              StyleBox["m", Rule[FontSlant, "Italic"]], ") \[Rule] ", 
              Cell[BoxData[FormBox[SuperscriptBox[FormBox[\((\(-1\))\), 
                   "TraditionalForm"], "m"], TraditionalForm]]], " for ", 
              StyleBox["n", Rule[FontSlant, "Italic"]], 
              " even and odd respectively and ", Cell[BoxData[
                \(TraditionalForm\`\(\((\(-1\))\)\^\(-n\)\)\)]], " \[Rule] ", 
              Cell[BoxData[\(TraditionalForm\`\(\((\(-1\))\)\^n\)\)]], 
              " and ", Cell[BoxData[
                \(TraditionalForm\`\(\[ExponentialE]\^
                     \*StyleBox[\(\[ImaginaryI]
                         \*StyleBox["m", Rule[FontSlant, "Italic"]]\[Pi]\)]\)
                \)]], " \[Rule] ", Cell[BoxData[
                \(TraditionalForm\`\(\((\(-1\))\)\^m\)\)]], "."}], "Text", 
            CellTags -> "PowerSimplify"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DataType", RuleDelayed[ButtonData, "DataType"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DataType"]], ", ", 
              ButtonBox["OPEm", RuleDelayed[ButtonData, "OPEi"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OPEm"]], 
              "."}], "Text", CellTags -> "PowerSimplify"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "PowerSimplify"], Cell[CellGroupData[{Cell[BoxData[
                \(PowerSimplify[\(\((\(-1\))\)^\((2OPEm)\)\)]\)], "Input", 
               CellTags -> "PowerSimplify"], Cell[BoxData[
                \(TraditionalForm\`1\)], "Output", CellTags -> 
                "PowerSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(PowerSimplify[\(\((\(-1\))\)^\((OPEm + 2)\)\)]\)], "Input", 
               CellTags -> "PowerSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\((\(-1\))\)\^m\)\)], "Output", 
               CellTags -> "PowerSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PowerSimplify[\(\((\(-1\))\)^\((OPEm - 2)\)\)]\)], "Input", 
               CellTags -> "PowerSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\((\(-1\))\)\^m\)\)], "Output", 
               CellTags -> "PowerSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PowerSimplify[\(I^\((2OPEm)\)\)]\)], "Input", CellTags -> 
                "PowerSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\((\(-1\))\)\^m\)\)], "Output", 
               CellTags -> "PowerSimplify"]}, Open]]}, Open]], 
        Cell["Power2", "ObjectName", CellTags -> "Power2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Power2"], Cell["Power2[x, y] represents x^y.  \
Sometimes Power2 is more useful than the Mathematica Power. Power2[-a,b] \
simplifies to (-1)^b Power2[a,b] (if no Epsilon is in b ...).", "Text", 
            CellTags -> "Power2"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["PowerFactor", RuleDelayed[ButtonData, 
                 "PowerFactor"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PowerFactor"]], "."}], "Text", 
            CellTags -> "Power2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Power2"], Cell[CellGroupData[{Cell[BoxData[
                \(Power[\(\(-a\), b\)]\)], "Input", CellTags -> "Power2"], 
              Cell[BoxData[\(TraditionalForm\`\(\((\(-a\))\)\^b\)\)], 
               "Output", CellTags -> "Power2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Power2[\(\(-a\), b\)]\)], 
               "Input", CellTags -> "Power2"], Cell[BoxData[FormBox[RowBox[{
                   \(\((\(-1\))\)\^b\), " ", FormBox[\(a\^b\), 
                    "TraditionalForm"]}], TraditionalForm]], "Output", 
               CellTags -> "Power2"]}, Open]]}, Open]], 
        Cell["PostFortranFile", "ObjectName", CellTags -> "PostFortranFile"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PostFortranFile"], Cell["PostFortranFile is an \
option for Write2 which may be set to a file name (or a list of file names) \
or a string,  which will be put at the end of the generated Fortran file.", 
            "Text", CellTags -> "PostFortranFile"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Write2", RuleDelayed[ButtonData, "Write2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Write2"]], 
              ", ", 
              ButtonBox["PreFortranFile", 
                RuleDelayed[ButtonData, "PreFortranFile"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PreFortranFile"]], "."}], "Text", 
            CellTags -> "PostFortranFile"]}, Open]], Cell["Prefactor", 
         "ObjectName", CellTags -> "Prefactor"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Prefactor"], Cell["Prefactor is an option for \
OneLoop and OneLoopSum. If set as option of OneLoop, the amplitude is \
multiplied by Prefactor before calculation; if specified as option of \
OneLoopSum, after calculation in the final result as a global factor.", 
            "Text", CellTags -> "Prefactor"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, ", ", 
              ButtonBox["OneLoopSum", RuleDelayed[ButtonData, "OneLoopSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSum"]], "."}], "Text", 
            CellTags -> "Prefactor"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["PreFortranFile", "ObjectName", CellTags -> "PreFortranFile"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PreFortranFile"], Cell["PreFortranFile is an option \
for Write2 which may be set to a file name (or a list of file names) or a \
string, which will be put at the beginning of the generated Fortran file.", 
            "Text", CellTags -> "PreFortranFile"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Write2", RuleDelayed[ButtonData, "Write2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Write2"]], 
              ", ", 
              ButtonBox["PostFortranFile", 
                RuleDelayed[ButtonData, "PostFortranFile"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PostFortranFile"]], "."}], "Text", 
            CellTags -> "PreFortranFile"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["PropagatorDenominator", "ObjectName", 
         CellTags -> "PropagatorDenominator"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PropagatorDenominator"], 
           Cell[TextData[{"PropagatorDenominator[q, m] is a factor of the \
denominator of a propagator. If p is supposed to be D-dimensional enter: \
PropagatorDenominator[Momentum[q, D], m]. What is meant is ", Cell[BoxData[
                \(TraditionalForm\`\(\ \(1/\((q^2\)\)\)\)]], " - ", 
              Cell[BoxData[\(TraditionalForm\`\(m^2\)\)]], "). \
PropagatorDenominator[p] evaluates to PropagatorDenominator[p, 0]. "}], 
            "Text", CellTags -> "PropagatorDenominator"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynAmpDenominator", 
                RuleDelayed[ButtonData, "FeynAmpDenominator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynAmpDenominator"]], ", ", 
              ButtonBox["PropagatorDenominatorExplicit", 
                RuleDelayed[ButtonData, "PropagatorDenominatorExplicit"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PropagatorDenominatorExplicit"]], ", ", 
              ButtonBox["IFPD", RuleDelayed[ButtonData, "IFPD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "IFPD"]], 
              "."}], "Text", CellTags -> "PropagatorDenominator"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "PropagatorDenominator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\ \(PropagatorDenominator[\(p, m\)]\)\)], "Input", 
               CellTags -> "PropagatorDenominator"], Cell[BoxData[
                \(TraditionalForm\`\(1\/\(p\^2 - m\^2\)\)\)], "Output", 
               CellTags -> "PropagatorDenominator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(PropagatorDenominator[p]\)], 
               "Input", CellTags -> "PropagatorDenominator"], Cell[BoxData[
                \(TraditionalForm\`\(1\/p\^2\)\)], "Output", CellTags -> 
                "PropagatorDenominator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(PropagatorDenominator[\(q, m\)]\)\ \)], "Input", 
               CellTags -> "PropagatorDenominator"], Cell[BoxData[
                \(TraditionalForm\`\(1\/\(q\^2 - m\^2\)\)\)], "Output", 
               CellTags -> "PropagatorDenominator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(StandardForm[\(FCI[t1]\)]\)], 
               "Input", CellTags -> "PropagatorDenominator"], Cell[BoxData[
                \(PropagatorDenominator[\(\(Momentum[\(q, D\)]\), m\)]\)], 
               "Output", CellTags -> "PropagatorDenominator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(StandardForm[\(ChangeDimension[\(t1, D\)]\)]\)], "Input", 
               CellTags -> "PropagatorDenominator"], Cell[BoxData[
                \(PropagatorDenominator[\(\(Momentum[\(q, D\)]\), m\)]\)], 
               "Output", CellTags -> "PropagatorDenominator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(PropagatorDenominatorExplicit[t1]\)], "Input", CellTags -> 
                "PropagatorDenominator"], Cell[BoxData[FormBox[FractionBox[
                  "1", RowBox[{SuperscriptBox[FormBox["q", 
                      "TraditionalForm"], "2"], "-", \(m\^2\)}]], 
                 TraditionalForm]], "Output", CellTags -> 
                "PropagatorDenominator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(StandardForm[%]\)], "Input", 
               CellTags -> "PropagatorDenominator"], Cell[BoxData[
                \(1\/\(\(-m\^2\) + \(Pair[
                       \(\(Momentum[q]\), \(Momentum[q]\)\)]\)\)\)], 
               "Output", CellTags -> "PropagatorDenominator"]}, Open]], 
           Cell[BoxData[\(Clear[t1]\)], "Input", CellTags -> 
             "PropagatorDenominator"]}, Open]], 
        Cell["PropagatorDenominatorExplicit", "ObjectName", 
         CellTags -> "PropagatorDenominatorExplicit"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "PropagatorDenominatorExplicit"], Cell["PropagatorDen\
ominatorExplicit[exp] changes each occurence of PropagatorDenominator[a,b] in \
exp into 1/(ScalarProduct[a,a]-b^2) and replaces FeynAmpDenominator by \
Identity.", "Text", CellTags -> "PropagatorDenominatorExplicit"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynAmpDenominator", 
                RuleDelayed[ButtonData, "FeynAmpDenominator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynAmpDenominator"]], ", ", 
              ButtonBox["PropagatorDenominator", 
                RuleDelayed[ButtonData, "PropagatorDenominator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PropagatorDenominator"]], "."}], "Text", 
            CellTags -> "PropagatorDenominatorExplicit"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "PropagatorDenominatorExplicit"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(FAD[\(\({q, m}\), \({\(q - p\), 0}\)\)]\)//FCI\)], 
               "Input", CellTags -> "PropagatorDenominatorExplicit"], 
              Cell[BoxData[
                \(TraditionalForm\`\(1\/\(\((q\^2 - m\^2)\) . \((q - p)\)\^2
                      \)\)\)], "Output", CellTags -> 
                "PropagatorDenominatorExplicit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(PropagatorDenominatorExplicit[%]\)//FCE\)], "Input", 
               CellTags -> "PropagatorDenominatorExplicit"], Cell[BoxData[
                FormBox[FractionBox["1", RowBox[{RowBox[{"(", RowBox[
                       {FormBox[SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], "2"], "TraditionalForm"], "-", 
                        \(m\^2\)}], ")"}], " ", RowBox[{"(", RowBox[{\(m\^2\)
                        , "-", RowBox[{"2", " ", FormBox[RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "TraditionalForm"]}], "+", 
                        FormBox[SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], "2"], "TraditionalForm"]}], 
                      ")"}]}]], TraditionalForm]], "Output", CellTags -> 
                "PropagatorDenominatorExplicit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "PropagatorDenominatorExplicit"], Cell[BoxData[
                \(1\/\(\((\(-m\^2\) + \(SPD[\(q, q\)]\))\)\ 
                     \((m\^2 - \(2\ \(SPD[\(p, q\)]\)\) + \(SPD[\(q, q\)]\))
                      \)\)\)], "Output", CellTags -> 
                "PropagatorDenominatorExplicit"]}, Open]]}, Open]], 
        Cell["QGV", "ObjectName", CellTags -> "QGV"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "QGV"], Cell[
            "QGV is equivalent to QuarkGluonVertex.", "Text", 
            CellTags -> "QGV"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["QuarkGluonVertex", 
                RuleDelayed[ButtonData, "QuarkGluonVertex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "QuarkGluonVertex"]], "."}], "Text", 
            CellTags -> "QGV"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["QO", "ObjectName", CellTags -> "QO"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "QO"], Cell[
            "QO is equivalent to Twist2QuarkOperator.", "Text", 
            CellTags -> "QO"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Twist2QuarkOperator", 
                RuleDelayed[ButtonData, "Twist2QuarkOperator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Twist2QuarkOperator"]], "."}], "Text", 
            CellTags -> "QO"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["QP", "ObjectName", CellTags -> "QP"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "QP"], Cell["QP is an alias for QuarkPropagator. \
QP[p] is the massless quark propagator. QP[{p,m}] gives the  quark propagator \
with mass m.", "Text", CellTags -> "QP"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["QuarkPropagator", 
                RuleDelayed[ButtonData, "QuarkPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "QuarkPropagator"]], "."}], "Text", 
            CellTags -> "QP"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["QuantumField", "ObjectName", CellTags -> "QuantumField"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "QuantumField"], Cell[TextData[{"QuantumField is the \
head of quantized fields and their derivatives. QuantumField[par, ftype, \
{lorind}, {sunind}] denotes a quantum field of type ftype with (possible) \
Lorentz-indices lorind and SU(", StyleBox["N", Rule[FontSlant, "Italic"]], ") \
indices sunind. The optional first argument par denotes a partial derivative \
acting on the field."}], "Text", CellTags -> "QuantumField"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynRule", RuleDelayed[ButtonData, "FeynRule"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynRule"]], ", ", 
              ButtonBox["PartialD", RuleDelayed[ButtonData, "PartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PartialD"]], ", ", 
              ButtonBox["ExpandPartialD", 
                RuleDelayed[ButtonData, "ExpandPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandPartialD"]], "."}], "Text", 
            CellTags -> "QuantumField"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "QuantumField"], Cell["This denotes a scalar field.", 
            "Text", CellTags -> "QuantumField"], Cell[CellGroupData[
             {Cell[BoxData[\(QuantumField[S]\)], "Input", CellTags -> 
                "QuantumField"], Cell[BoxData[\(TraditionalForm\`S\)], 
               "Output", CellTags -> "QuantumField"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(QuantumField[AntiQuarkField]\)]
                , "Input", CellTags -> "QuantumField"], Cell[BoxData[
                \(TraditionalForm\`\[Psi]\&_\)], "Output", CellTags -> 
                "QuantumField"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(QuantumField[QuarkField]\)], "Input", CellTags -> 
                "QuantumField"], Cell[BoxData[\(TraditionalForm\`\[Psi]\)], 
               "Output", CellTags -> "QuantumField"]}, Open]], 
           Cell["This is a field with a Lorentz index.", "Text", 
            CellTags -> "QuantumField"], Cell[CellGroupData[{Cell[BoxData[
                \(QuantumField[\(B, \({\[Mu]}\)\)]\)], "Input", CellTags -> 
                "QuantumField"], Cell[BoxData[\(TraditionalForm\`B\_\[Mu]\)], 
               "Output", CellTags -> "QuantumField"]}, Open]], 
           Cell["Color indices should be put after the Lorentz ones.", 
            "Text", CellTags -> "QuantumField"], Cell[CellGroupData[
             {Cell[BoxData[
                \(QuantumField[\(GaugeField, \({\[Mu]}\), \({a}\)\)]\)], 
               "Input", CellTags -> "QuantumField"], Cell[BoxData[
                FormBox[SubsuperscriptBox[FormBox["A", "TraditionalForm"], 
                  FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                   "TraditionalForm"], FormBox[FormBox["a", 
                    "TraditionalForm"], "TraditionalForm"]], 
                 TraditionalForm]], "Output", CellTags -> "QuantumField"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], 
               "Input", CellTags -> "QuantumField"], Cell[BoxData[
                \(QuantumField[\(GaugeField, \(LorentzIndex[\[Mu]]\), 
                     \(SUNIndex[a]\)\)]\)], "Output", CellTags -> 
                "QuantumField"]}, Open]], Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`A\_\[CapitalDelta]\%a\)]], 
              " is a short form for ", Cell[BoxData[
                \(TraditionalForm\`\(\(\[CapitalDelta]^\[Mu]\)\ 
                     \(A\_\[Mu]\%a .\)\)\)]], " "}], "Text", 
            CellTags -> "QuantumField"], Cell[CellGroupData[{Cell[BoxData[
                \(QuantumField[\(A, \({OPEDelta}\), \({a}\)\)]\)], "Input", 
               CellTags -> "QuantumField"], Cell[BoxData[FormBox[
                 SubsuperscriptBox["A", FormBox[FormBox["\[CapitalDelta]", 
                    "TraditionalForm"], "TraditionalForm"], FormBox[
                   FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                 TraditionalForm]], "Output", CellTags -> "QuantumField"]}, 
             Open]], Cell[" The first list of indices is usually interpreted \
as type LorentzIndex, except for OPEDelta, which gets converted to type \
Momentum. ", "Text", CellTags -> "QuantumField"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(QuantumField[\(A, \({OPEDelta}\), \({a}\)\)]\)//
                   StandardForm\)], "Input", CellTags -> "QuantumField"], 
              Cell[BoxData[
                \(QuantumField[\(A, \(LorentzIndex[OPEDelta]\), 
                     \(SUNIndex[a]\)\)]\)], "Output", CellTags -> 
                "QuantumField"]}, Open]], 
           Cell["Derivatives of fields are denoted as follows.", "Text", 
            CellTags -> "QuantumField"], Cell[CellGroupData[{Cell[BoxData[
                \(QuantumField[\(\(PartialD[\[Mu]]\), A, \({\[Mu]}\)\)]\)], 
               "Input", CellTags -> "QuantumField"], Cell[BoxData[
                FormBox[RowBox[{SubscriptBox["\[PartialD]", FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                    "\[Null]"]}], TraditionalForm]], "Output", CellTags -> 
                "QuantumField"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(QuantumField[\(\(PartialD[OPEDelta]\), S\)]\)], "Input", 
               CellTags -> "QuantumField"], Cell[BoxData[FormBox[
                 RowBox[{SubscriptBox["\[PartialD]", FormBox[
                     "\[CapitalDelta]", "TraditionalForm"]], 
                   \(S\_\[Null]\%\[Null]\)}], TraditionalForm]], "Output", 
               CellTags -> "QuantumField"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(QuantumField[\(\(PartialD[OPEDelta]\), A, \({OPEDelta}\), 
                     \({a}\)\)]\)], "Input", CellTags -> "QuantumField"], 
              Cell[BoxData[FormBox[RowBox[{SubscriptBox["\[PartialD]", 
                    FormBox["\[CapitalDelta]", "TraditionalForm"]], 
                   SubsuperscriptBox["A", FormBox[FormBox["\[CapitalDelta]", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["a", "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "QuantumField"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(QuantumField[\(\(\(PartialD[OPEDelta]\)^OPEm\), A, 
                     \({OPEDelta}\), \({a}\)\)]\)], "Input", CellTags -> 
                "QuantumField"], Cell[BoxData[FormBox[RowBox[
                  {SubsuperscriptBox["\[PartialD]", FormBox[
                     "\[CapitalDelta]", "TraditionalForm"], FormBox["m", 
                     "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                     FormBox["\[CapitalDelta]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox[FormBox["a", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "QuantumField"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(QuantumField[\(QuantumField[A]\)]\)\ ===\ 
                   \(QuantumField[A]\)\)], "Input", CellTags -> 
                "QuantumField"], Cell[BoxData[\(TraditionalForm\`True\)], 
               "Output", CellTags -> "QuantumField"]}, Open]]}, Open]], 
        Cell["QuarkField", "ObjectName", CellTags -> "QuarkField"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "QuarkField"], Cell["QuarkField is the name of a \
fermionic field. QuarkField is just a name with no functional properties. \
Only typesetting rules are attached.", "Text", CellTags -> "QuarkField"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["AntiQuarkField", 
                RuleDelayed[ButtonData, "AntiQuarkField"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "AntiQuarkField"]], ", ", 
              ButtonBox["QuantumField", 
                RuleDelayed[ButtonData, "QuantumField"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "QuantumField"]], "."}], "Text", 
            CellTags -> "QuarkField"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "QuarkField"], Cell[CellGroupData[
             {Cell[BoxData["QuarkField"], "Input", CellTags -> "QuarkField"], 
              Cell[BoxData[\(TraditionalForm\`\[Psi]\)], "Output", 
               CellTags -> "QuarkField"]}, Open]]}, Open]], 
        Cell["QuarkGluonVertex", "ObjectName", CellTags -> 
          "QuarkGluonVertex"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "QuarkGluonVertex"], Cell[TextData[{"QuarkGluonVertex[", 
              Cell[BoxData[
                \(TraditionalForm\`\(\[Mu],\ 
                     \*StyleBox["a", Rule[FontSlant, "Plain"]]\)\)]], 
              "] gives the Feynman rule for the quark-gluon vertex. "}], 
            "Text", CellTags -> "QuarkGluonVertex"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[QuarkGluonVertex]\)], 
               "Input", CellTags -> "QuarkGluonVertex"], Cell[BoxData[
                \(TraditionalForm\`\({\(CounterTerm \[Rule] False\), 
                      \(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Explicit \[Rule] False\), 
                      \(\[CapitalOmega] \[Rule] False\), 
                      \(Polarization \[Rule] 0\)}\)\)], "Output", CellTags -> 
                "QuarkGluonVertex"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["GluonVertex", RuleDelayed[ButtonData, 
                 "GluonVertex"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonVertex"]], "."}], "Text", 
            CellTags -> "QuarkGluonVertex"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "QuarkGluonVertex"], Cell[CellGroupData[{Cell[BoxData[
                \(QuarkGluonVertex[\(\[Mu], a\)]\)], "Input", CellTags -> 
                "QuarkGluonVertex"], Cell[BoxData[
                \(TraditionalForm\`Q\_a\%\[Mu]\)], "Output", CellTags -> 
                "QuarkGluonVertex"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(QuarkGluonVertex[\(\[Mu], a, \(CounterTerm\ \[Rule] 1\)\)]
                  \)], "Input", CellTags -> "QuarkGluonVertex"], Cell[BoxData[
                \(TraditionalForm\`Q\_a\%\[Mu]\)], "Output", CellTags -> 
                "QuarkGluonVertex"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(QuarkGluonVertex[\(\[Mu], a, \(CounterTerm\ \[Rule] 2\)\)]
                  \)], "Input", CellTags -> "QuarkGluonVertex"], Cell[BoxData[
                \(TraditionalForm\`Q\_a\%\[Mu]\)], "Output", CellTags -> 
                "QuarkGluonVertex"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(QuarkGluonVertex[\(\[Mu], a, \(CounterTerm\ \[Rule] 3\)\)]
                  \)], "Input", CellTags -> "QuarkGluonVertex"], Cell[BoxData[
                \(TraditionalForm\`Q\_a\%\[Mu]\)], "Output", CellTags -> 
                "QuarkGluonVertex"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(QuarkGluonVertex[\(\({p, \[Mu], a}\), \({q}\), \({k}\), 
                     \(OPE \[Rule] True\)\)]\)], "Input", CellTags -> 
                "QuarkGluonVertex"], Cell[BoxData[FormBox[RowBox[
                  {"QuarkGluonVertex", "(", RowBox[{\({p, \[Mu], a}\), ",", 
                     \({q}\), ",", RowBox[{"{", FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "}"}], ",", \(\[CapitalOmega] \[Rule] True\)}], ")"}], 
                 TraditionalForm]], "Output", CellTags -> 
                "QuarkGluonVertex"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(QuarkGluonVertex[\(\({p, \[Mu], a}\), \({q}\), \({k}\), 
                     \(OPE \[Rule] False\)\)]\)], "Input", CellTags -> 
                "QuarkGluonVertex"], Cell[BoxData[FormBox[RowBox[
                  {"QuarkGluonVertex", "(", RowBox[{\({p, \[Mu], a}\), ",", 
                     \({q}\), ",", RowBox[{"{", FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "}"}], ",", \(\[CapitalOmega] \[Rule] False\)}], 
                   ")"}], TraditionalForm]], "Output", CellTags -> 
                "QuarkGluonVertex"]}, Open]]}, Open]], 
        Cell["QuarkMass", "ObjectName", CellTags -> "QuarkMass"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "QuarkMass"], 
           Cell["QuarkMass is an option of Amplitude, CounterTerm and RTL.", 
            "Text", CellTags -> "QuarkMass"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Amplitude", RuleDelayed[ButtonData, "Amplitude"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Amplitude"]], ", ", 
              ButtonBox["CounterTerm", RuleDelayed[ButtonData, 
                 "CounterTerm"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CounterTerm"]], ", ", 
              ButtonBox["RTL", RuleDelayed[ButtonData, "RTL"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "RTL"]], 
              "."}], "Text", CellTags -> "QuarkMass"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["QuarkPropagator", "ObjectName", 
         CellTags -> "QuarkPropagator"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "QuarkPropagator"], Cell["QuarkPropagator[p] is the massless \
quark propagator. QuarkPropagator[{p,m}] or gives the quark propagator with \
mass m.", "Text", CellTags -> "QuarkPropagator"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[QuarkPropagator]\)], 
               "Input", CellTags -> "QuarkPropagator"], Cell[BoxData[
                \(TraditionalForm\`\({\(CounterTerm \[Rule] False\), 
                      \(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Explicit \[Rule] False\), 
                      \(Loop \[Rule] 0\), \(\[CapitalOmega] \[Rule] False\), 
                      \(Polarization \[Rule] 0\)}\)\)], "Output", CellTags -> 
                "QuarkPropagator"]}, Open]], Cell[TextData[{"See also: ", 
              " ", 
              ButtonBox["GluonPropagator", 
                RuleDelayed[ButtonData, "GluonPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonPropagator"]], ", ", 
              ButtonBox["QuarkGluonVertex", 
                RuleDelayed[ButtonData, "QuarkGluonVertex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "QuarkGluonVertex"]], "."}], "Text", 
            CellTags -> "QuarkPropagator"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "QuarkPropagator"], Cell[CellGroupData[{Cell[BoxData[
                \(QuarkPropagator[p]\)], "Input", CellTags -> 
                "QuarkPropagator"], Cell[BoxData[
                \(TraditionalForm\`\(\[CapitalPi]\_q(p)\)\)], "Output", 
               CellTags -> "QuarkPropagator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(QuarkPropagator[\({p, m}\)]\)], 
               "Input", CellTags -> "QuarkPropagator"], Cell[BoxData[
                \(TraditionalForm\`\(\[CapitalPi]\_q(p)\)\)], "Output", 
               CellTags -> "QuarkPropagator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(QuarkPropagator[\(p, 1, 2\)]\)]
                , "Input", CellTags -> "QuarkPropagator"], Cell[BoxData[
                \(TraditionalForm\`\(\[CapitalPi]\_q(p)\)\)], "Output", 
               CellTags -> "QuarkPropagator"]}, Open]]}, Open]], 
        Cell["ReduceGamma", "ObjectName", CellTags -> "ReduceGamma"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ReduceGamma"], Cell["ReduceGamma is an option of \
OneLoop. If set to True all DiracMatrix[6] and DiracMatrix[7] (i.e. all \
ChiralityProjector) are reduced to Gamma5.", "Text", CellTags -> 
             "ReduceGamma"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, "."}], "Text", CellTags -> "ReduceGamma"]}, Open]], Cell["ReduceToScalars", 
         "ObjectName", CellTags -> "ReduceToScalars"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ReduceToScalars"], Cell["ReduceToScalars is an \
option for OneLoop  and OneLoopSum that specifies whether the result will be \
reduced to scalar A0, B0, C0 and D0 scalar integrals.", "Text", 
            CellTags -> "ReduceToScalars"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, ", ", 
              ButtonBox["OneLoopSum", RuleDelayed[ButtonData, "OneLoopSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSum"]], "."}], "Text", 
            CellTags -> "ReduceToScalars"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["Rename", "ObjectName", CellTags -> "Rename"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Rename"], Cell["Rename is an option for Contract. If \
set to True, dummy indices in Eps are renamed, using $MU[i].", "Text", 
            CellTags -> "Rename"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], "."}], "Text", 
            CellTags -> "Rename"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["RHI  ***unfinished***", "ObjectName", CellTags -> "RHI"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "RHI"], Cell["RHI[{v,w,x,y,z},{a,b,c,d,e,f,g}, \
{al,be,ga,de,ep}]. (sn \[Rule] 1, mark1 \[Rule] 1, mark2 \[Rule] 1, mark3 \
\[Rule] 1, eph \[Rule] Epsilon/2 ). The exponents of the numerator scalar \
product are (dl = OPEDelta): \nv: k1.k1, w: k2.k2,  x: p.k1, y: p.k2, z: \
k1.k2. \na: dl.k1, b: dl.k2,  c: dl.(p-k1), d: dl.(p-k2), e: dl.(k1-k2), f: \
dl.(p+k1-k2), g: dl.(p-k1-k2) \nRHI[any___,{a,b,c,d,e,0,0}, {al,be,ga,de,ep}] \
simplifies to  RHI[any, {a,b,c,d,e}, {al,be,ga,de,ep}]; \
\nRHI[{0,0,0,0,0},{a,b,c,d,e}, {al,be,ga,de,ep}] simplifies to  \
RHI[{a,b,c,d,e}, {al,be,ga,de,ep}].", "Text", CellTags -> "RHI"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["RHI2FC", RuleDelayed[ButtonData, "RHI2FC"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "RHI2FC"]], 
              "."}], "Text", CellTags -> "RHI"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "RHI"], Cell[BoxData[""], "Input", 
            CellTags -> "RHI"]}, Open]], Cell["RHI2FC  ***unfinished***", 
         "ObjectName", CellTags -> "RHI2FC"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "RHI2FC"], Cell["RHI[{v,w,x,y,z},{a,b,c,d,e,f,g}, \
{al,be,ga,de,ep}]. (sn \[Rule] 1, mark1 \[Rule] 1, mark2 \[Rule] 1, mark3 \
\[Rule] 1, eph \[Rule] Epsilon/2 ). The exponents of the numerator scalar \
product are (dl = OPEDelta): \nv: k1.k1, w: k2.k2,  x: p.k1, y: p.k2, z: \
k1.k2. \na: dl.k1, b: dl.k2,  c: dl.(p-k1), d: dl.(p-k2), e: dl.(k1-k2), f: \
dl.(p+k1-k2), g: dl.(p-k1-k2) \nRHI[any___,{a,b,c,d,e,0,0}, {al,be,ga,de,ep}] \
simplifies to  RHI[any, {a,b,c,d,e}, {al,be,ga,de,ep}]; \
\nRHI[{0,0,0,0,0},{a,b,c,d,e}, {al,be,ga,de,ep}] simplifies to  \
RHI[{a,b,c,d,e}, {al,be,ga,de,ep}].", "Text", CellTags -> "RHI2FC"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["RHI2FC", RuleDelayed[ButtonData, "RHI2FC"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "RHI2FC"]], 
              "."}], "Text", CellTags -> "RHI2FC"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "RHI2FC"], Cell[BoxData[""], "Input", 
            CellTags -> "RHI2FC"]}, Open]], Cell["RHM  ***unfinished***", 
         "ObjectName", CellTags -> "RHM"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "RHM"], Cell[
            "RHM[] is like RHI[], gives Gamma functions.", "Text", 
            CellTags -> "RHM"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["RHI", RuleDelayed[ButtonData, "RHI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "RHI"]], 
              "."}], "Text", CellTags -> "RHM"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "RHM"], Cell[BoxData[""], "Input", 
            CellTags -> "RHM"]}, Open]], Cell["RHO  ***unfinished***", 
         "ObjectName", CellTags -> "RHO"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "RHO"], Cell["RHO[i] with i from 1 to 4 is an \
abbreviation for the 4 operators (eq. (3.2.17) -- (3.2.20)) defined in \
R.Hambergs thesis. The Lorentz indices are suppressed. The explicit \
expressions may be recovered by RHO[i, mu, nu, p].", "Text", 
            CellTags -> "RHO"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["RHI", RuleDelayed[ButtonData, "RHI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "RHI"]], 
              "."}], "Text", CellTags -> "RHO"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "RHO"], Cell[BoxData[""], "Input", 
            CellTags -> "RHO"]}, Open]], Cell["RHP  ", "ObjectName", 
         CellTags -> "RHP"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "RHP"], Cell["RHP[i, mu, nu, p] with \
i from 1 to 4 gives the projectors for RHO[i]. RHP[mu, nu, p] gives \
Sum[RHP[i,mu, nu, p] RHO[i], {i, 4}] collected with respect to mu and nu. See \
the thesis of Roelof Hamberg (but correcting a misprint).", "Text", 
            CellTags -> "RHP"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["RHO", RuleDelayed[ButtonData, "RHO"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "RHO"]], 
              "."}], "Text", CellTags -> "RHP"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "RHP"], Cell[CellGroupData[{Cell[BoxData[
                \(RHP[\(1, \[Mu], \[Nu], p\)]\)], "Input"], Cell[BoxData[
                FormBox[RowBox[{\(g\^\(\[Mu]\[Nu]\)\/\(D - 2\)\), "+", 
                   FractionBox[RowBox[{SuperscriptBox[FormBox[
                        "\[CapitalDelta]", "TraditionalForm"], FormBox[
                        FormBox["\[Mu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                        "\[CapitalDelta]", "TraditionalForm"], FormBox[
                        FormBox["\[Nu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", SuperscriptBox[FormBox["p", 
                        "TraditionalForm"], "2"]}], RowBox[{\((D - 2)\), " ", 
                      SuperscriptBox[FormBox[RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                        "TraditionalForm"], "2"]}]], "+", FractionBox[
                    RowBox[{RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "+", 
                      RowBox[{SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        SuperscriptBox[FormBox["p", "TraditionalForm"], 
                         FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], RowBox[{\((2 - D)\), " ", 
                      RowBox[{FormBox["\[CapitalDelta]", "TraditionalForm"], 
                        "\[CenterDot]", FormBox["p", 
                         "TraditionalForm"]}]}]]}], TraditionalForm]], 
               "Output"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(RHP[\(2, \[Mu], \[Nu], p\)]\)], "Input"], Cell[BoxData[
                FormBox[FractionBox[RowBox[{SuperscriptBox[FormBox[
                      "\[CapitalDelta]", "TraditionalForm"], FormBox[
                      FormBox["\[Mu]", "TraditionalForm"], 
                      "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                      "\[CapitalDelta]", "TraditionalForm"], FormBox[
                      FormBox["\[Nu]", "TraditionalForm"], 
                      "TraditionalForm"]], " ", SuperscriptBox[FormBox["p", 
                      "TraditionalForm"], "2"]}], SuperscriptBox[FormBox[
                    RowBox[{FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                    "TraditionalForm"], "2"]], TraditionalForm]], "Output"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(RHP[\(3, \[Mu], \[Nu], p\)]\)], "Input"], Cell[BoxData[
                FormBox[RowBox[{FractionBox[RowBox[{SuperscriptBox[FormBox[
                        "p", "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                         "TraditionalForm"], "TraditionalForm"]], " ", 
                      SuperscriptBox[FormBox["p", "TraditionalForm"], 
                       FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                        "TraditionalForm"]]}], SuperscriptBox[FormBox["p", 
                      "TraditionalForm"], "2"]], "-", FractionBox[RowBox[
                     {RowBox[{SuperscriptBox[FormBox["p", "TraditionalForm"], 
                         FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                         FormBox["\[CapitalDelta]", "TraditionalForm"], 
                         FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}]}], 
                    RowBox[{FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      "\[CenterDot]", FormBox["p", "TraditionalForm"]}]]}], 
                 TraditionalForm]], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(RHP[\(4, \[Mu], \[Nu], p\)]\)], 
               "Input"], Cell[BoxData[FormBox[FractionBox[RowBox[
                   {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                     FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                      "TraditionalForm"]], " ", SuperscriptBox[FormBox["p", 
                      "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                       "TraditionalForm"], "TraditionalForm"]]}], 
                  RowBox[{"2", " ", SuperscriptBox[FormBox["p", 
                      "TraditionalForm"], "2"]}]], TraditionalForm]], 
               "Output"]}, Open]], Cell[BoxData[""], "Input", 
            CellTags -> "RHP"]}, Open]], Cell["RTL  ***unfinished***", 
         "ObjectName", CellTags -> "RTL"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "RTL"], Cell["RTL[exp] inserts the list of known TLI \
integrals into exp, substitutes D\[RightArrow]4+Epsilon and expands around \
Epsilon up to the finite part.", "Text", CellTags -> "RTL"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["TLI", RuleDelayed[ButtonData, "TLI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TLI"]], 
              ", ", 
              ButtonBox["Epsilon", RuleDelayed[ButtonData, "Epsilon"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Epsilon"]]\
, "."}], "Text", CellTags -> "RTL"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "RTL"], Cell[BoxData[""], "Input", 
            CellTags -> "RTL"]}, Open]], Cell["RightPartialD", "ObjectName", 
         CellTags -> "RightPartialD"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "RightPartialD"], 
           Cell[TextData[{"RightPartialD[", Cell[BoxData[
                \(TraditionalForm\`\[Mu]\)]], "] denotes ", Cell[BoxData[
                \(TraditionalForm\`\[PartialD]\_\[Mu]\)]], 
              ", acting to the right."}], "Text", CellTags -> 
             "RightPartialD"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["ExpandPartialD", 
                RuleDelayed[ButtonData, "ExpandPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandPartialD"]], ", ", 
              ButtonBox["PartialD", RuleDelayed[ButtonData, "PartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PartialD"]], ", ", 
              ButtonBox["LeftPartialD", 
                RuleDelayed[ButtonData, "LeftPartialD"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LeftPartialD"]], "."}], "Text", 
            CellTags -> "RightPartialD"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "RightPartialD"], Cell[CellGroupData[{Cell[BoxData[
                \(RightPartialD[\[Mu]]\)], "Input", CellTags -> 
                "RightPartialD"], Cell[BoxData[FormBox[SubscriptBox[
                  \(\[PartialD]\&\[RightArrow]\), FormBox[FormBox["\[Mu]", 
                    "TraditionalForm"], "TraditionalForm"]], 
                 TraditionalForm]], "Output", CellTags -> "RightPartialD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(RightPartialD[\[Mu]]\) . 
                   \(QuantumField[\(A, \(LorentzIndex[\[Mu]]\)\)]\)\)], 
               "Input", CellTags -> "RightPartialD"], Cell[BoxData[
                FormBox[RowBox[{SubscriptBox[\(\[PartialD]\&\[RightArrow]\), 
                    FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", \(A\_\[Mu]\)}], 
                 TraditionalForm]], "Output", CellTags -> "RightPartialD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(ExpandPartialD[%]\)], 
               "Input", CellTags -> "RightPartialD"], Cell[BoxData[
                FormBox[RowBox[{SubscriptBox["\[PartialD]", FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], SubsuperscriptBox["A", FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                    "\[Null]"]}], TraditionalForm]], "Output", CellTags -> 
                "RightPartialD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%//StandardForm\)], "Input", CellTags -> "RightPartialD"], 
              Cell[BoxData[
                \(QuantumField[\(\(PartialD[\(LorentzIndex[\[Mu]]\)]\), A, 
                     \(LorentzIndex[\[Mu]]\)\)]\)], "Output", CellTags -> 
                "RightPartialD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(RightPartialD[\[Mu]]\)//StandardForm\)], "Input", 
               CellTags -> "RightPartialD"], Cell[BoxData[
                \(RightPartialD[\(LorentzIndex[\[Mu]]\)]\)], "Output", 
               CellTags -> "RightPartialD"]}, Open]]}, Open]], 
        Cell["RussianTrick", "ObjectName", CellTags -> "RussianTrick"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "RussianTrick"], Cell["RussianTrick[exp, k, \
{q1,q2,p}] (=RussianTrick[exp,p,p,{q1,q2,p}]) does the integration by parts \
where p is the external momentum. RussianTrick[exp, k,l, {q1,q2,p}] \
(=RussianTrick[exp,k,l]) does integration by parts where l is the momentum to \
be differentiated.", "Text", CellTags -> "RussianTrick"], 
           Cell["The result is an expression which is vanishing.", "Text", 
            CellTags -> "RussianTrick"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FourDivergence", 
                RuleDelayed[ButtonData, "FourDivergence"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FourDivergence"]], ", ", 
              ButtonBox["FourLaplacian", 
                RuleDelayed[ButtonData, "FourLaplacian"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FourLaplacian"]], "."}], "Text", 
            CellTags -> "RussianTrick"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "RussianTrick"], Cell[CellGroupData[{Cell[BoxData[
                \(t = \(RHI[\(\({OPEm, 0,\ 0, 0,\ 0}\),\ 
                       \({1,\ 1,\ 1,\ 1,\ 1}\)\)]\)\)], "Input", CellTags -> 
                "RussianTrick"], Cell[BoxData[FormBox[SubsuperscriptBox[
                  StyleBox["T", Rule[FontFamily, "Times"], 
                    Rule[FontWeight, "Bold"]], 
                  StyleBox[\(11111\), Rule[FontColor, 
                     RGBColor[0.`, 0.`, 1.`]]], RowBox[{FormBox["m", 
                     "TraditionalForm"], FormBox["0", "TraditionalForm"], 
                    FormBox["0", "TraditionalForm"], FormBox["0", 
                     "TraditionalForm"], FormBox["0", "TraditionalForm"]}]], 
                 TraditionalForm]], "Output", CellTags -> "RussianTrick"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(t//RHI2FC\)], 
               "Input", CellTags -> "RussianTrick"], Cell[BoxData[
                FormBox[FractionBox[SuperscriptBox[RowBox[{"(", RowBox[
                      {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                       "\[CenterDot]", FormBox[
                        \(\(\*TagBox[StyleBox["\"q\"", 
                               Rule[FontSlant, "Italic"]], 
                              Function[StyleForm[Slot[1], 
                                Rule[FontSlant, "Italic"]]]]\)\_1\), 
                        "TraditionalForm"]}], ")"}], "m"], 
                  \(\(\*TagBox[StyleBox["\"q\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]]\)\_1\%2 . 
                     \(\*TagBox[StyleBox["\"q\"", 
                          Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]]\)\_2\%2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1 - 
                         \(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2)\)\^2\)], 
                 TraditionalForm]], "Output", CellTags -> "RussianTrick"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(RussianTrick[\(\(%//RHI2FC\), q2\)]\)], "Input", 
               CellTags -> "RussianTrick"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{"-", FractionBox[SuperscriptBox[RowBox[
                        {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], ")"}], "m"], 
                      \(\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1\%2 . 
                         \((\(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^
                          2 . \((\(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^
                          2 . \((\(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_2 - 
                             \(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2 . 
                         \((\(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_2 - 
                             \(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2\)]}\
], "-", FractionBox[SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                         "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], ")"}], "m"], 
                    \(\(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_1\%2 . 
                       \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^2\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - 
                           \(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2 . 
                       \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\
\)], "-", FractionBox[RowBox[{\((4 - D)\), " ", SuperscriptBox[RowBox[
                        {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], ")"}], "m"]}], 
                    \(\(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_1\%2 . 
                       \(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_2\%2 . 
                       \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^2\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - 
                           \(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2 . 
                       \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\
\)], "+", FractionBox[SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                         "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], ")"}], "m"], 
                    \(\(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_2\%2 . 
                       \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^2\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - 
                           \(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2 . 
                       \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - 
                           \(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2\)], 
                   "+", FractionBox[RowBox[{SuperscriptBox[RowBox[{"(", 
                         RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], ")"}], "m"], " ", 
                      SuperscriptBox[FormBox["p", "TraditionalForm"], "2"]}], 
                    \(\(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_2\%2 . 
                       \(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_1\%2 . 
                       \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - 
                           \(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2 . 
                       \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^2\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\
\)]}], TraditionalForm]], "Output", CellTags -> "RussianTrick"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(FC2RHI[%]\)], "Input", 
               CellTags -> "RussianTrick"], Cell[BoxData[FormBox[
                 RowBox[{FormBox[SubsuperscriptBox[
                     StyleBox["T", Rule[FontFamily, "Times"], 
                       Rule[FontWeight, "Bold"]], 
                     StyleBox[\(01112\), Rule[FontColor, 
                        RGBColor[0.`, 0.`, 1.`]]], RowBox[{FormBox["m", 
                        "TraditionalForm"], FormBox["0", "TraditionalForm"], 
                       FormBox["0", "TraditionalForm"], FormBox["0", 
                        "TraditionalForm"], FormBox["0", 
                        "TraditionalForm"]}]], "TraditionalForm"], "-", 
                   FormBox[SubsuperscriptBox[
                     StyleBox["T", Rule[FontFamily, "Times"], 
                       Rule[FontWeight, "Bold"]], 
                     StyleBox[\(10112\), Rule[FontColor, 
                        RGBColor[0.`, 0.`, 1.`]]], RowBox[{FormBox["m", 
                        "TraditionalForm"], FormBox["0", "TraditionalForm"], 
                       FormBox["0", "TraditionalForm"], FormBox["0", 
                        "TraditionalForm"], FormBox["0", 
                        "TraditionalForm"]}]], "TraditionalForm"], "-", 
                   FormBox[SubsuperscriptBox[
                     StyleBox["T", Rule[FontFamily, "Times"], 
                       Rule[FontWeight, "Bold"]], 
                     StyleBox[\(10121\), Rule[FontColor, 
                        RGBColor[0.`, 0.`, 1.`]]], RowBox[{FormBox["m", 
                        "TraditionalForm"], FormBox["0", "TraditionalForm"], 
                       FormBox["0", "TraditionalForm"], FormBox["0", 
                        "TraditionalForm"], FormBox["0", 
                        "TraditionalForm"]}]], "TraditionalForm"], "+", 
                   RowBox[{\((D - 4)\), " ", FormBox[SubsuperscriptBox[
                       StyleBox["T", Rule[FontFamily, "Times"], 
                         Rule[FontWeight, "Bold"]], 
                       StyleBox[\(11111\), Rule[FontColor, 
                          RGBColor[0.`, 0.`, 1.`]]], RowBox[{FormBox["m", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"]}]], "TraditionalForm"]}], "+", 
                   RowBox[{SuperscriptBox[FormBox["p", "TraditionalForm"], 
                      "2"], " ", FormBox[SubsuperscriptBox[
                       StyleBox["T", Rule[FontFamily, "Times"], 
                         Rule[FontWeight, "Bold"]], 
                       StyleBox[\(11121\), Rule[FontColor, 
                          RGBColor[0.`, 0.`, 1.`]]], RowBox[{FormBox["m", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"]}]], "TraditionalForm"]}]}], 
                 TraditionalForm]], "Output", CellTags -> "RussianTrick"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(Solve2[\(%, t\)]\)], 
               "Input", CellTags -> "RussianTrick"], Cell[BoxData[
                FormBox[RowBox[{"{", RowBox[{FormBox[SubsuperscriptBox[
                       StyleBox["T", Rule[FontFamily, "Times"], 
                         Rule[FontWeight, "Bold"]], 
                       StyleBox[\(11111\), Rule[FontColor, 
                          RGBColor[0.`, 0.`, 1.`]]], RowBox[{FormBox["m", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"]}]], "TraditionalForm"], 
                     "\[Rule]", FractionBox[RowBox[{FormBox[SubsuperscriptBox[
                          StyleBox["T", Rule[FontFamily, "Times"], 
                            Rule[FontWeight, "Bold"]], 
                          StyleBox[\(01112\), Rule[FontColor, 
                             RGBColor[0.`, 0.`, 1.`]]], RowBox[{FormBox["m", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"]}]], "TraditionalForm"], "-", 
                        FormBox[SubsuperscriptBox[
                          StyleBox["T", Rule[FontFamily, "Times"], 
                            Rule[FontWeight, "Bold"]], 
                          StyleBox[\(10112\), Rule[FontColor, 
                             RGBColor[0.`, 0.`, 1.`]]], RowBox[{FormBox["m", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"]}]], "TraditionalForm"], "-", 
                        FormBox[SubsuperscriptBox[
                          StyleBox["T", Rule[FontFamily, "Times"], 
                            Rule[FontWeight, "Bold"]], 
                          StyleBox[\(10121\), Rule[FontColor, 
                             RGBColor[0.`, 0.`, 1.`]]], RowBox[{FormBox["m", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"]}]], "TraditionalForm"], "+", 
                        RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], " ", FormBox[
                          SubsuperscriptBox[
                          StyleBox["T", Rule[FontFamily, "Times"], 
                            Rule[FontWeight, "Bold"]], 
                          StyleBox[\(11121\), Rule[FontColor, 
                             RGBColor[0.`, 0.`, 1.`]]], RowBox[{FormBox["m", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"], FormBox["0", 
                          "TraditionalForm"]}]], "TraditionalForm"]}]}], 
                      \(4 - D\)]}], "}"}], TraditionalForm]], "Output", 
               CellTags -> "RussianTrick"]}, Open]], Cell[BoxData[\(Clear[t]\)
             ], "Input", CellTags -> "RussianTrick"]}, Open]], 
        Cell["ScalarGluonVertex", "ObjectName", CellTags -> 
          "ScalarGluonVertex"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "ScalarGluonVertex"], Cell["ScalarGluonVertex[{p}, {q}, {mu,a}] \
or ScalarGluonVertex[ p,  q,  mu, a ] yields the scalar-scalar-gluon vertex \
(p and q are incoming momenta).\nScalarGluonVertex[{mu,a}, {nu,b}] yields the \
scalar-scalar-gluon-gluon vertex (p and q are incoming momenta).\nThe \
dimension  and the name of the coupling constant are determined by the \
options Dimension and CouplingConstant.", "Text", CellTags -> 
             "ScalarGluonVertex"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[ScalarGluonVertex]\)], "Input", CellTags -> 
                "ScalarGluonVertex"], Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] D\), 
                      \(CouplingConstant \[Rule] g\_s\)}\)\)], "Output", 
               CellTags -> "ScalarGluonVertex"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ScalarGluonVertex"], Cell[CellGroupData[
             {Cell[BoxData[
                \(ScalarGluonVertex[\(\({p}\),\ \({q}\),\ \({mu,\ a}\)\)]\)], 
               "Input", CellTags -> "ScalarGluonVertex"], Cell[BoxData[
                FormBox[RowBox[{"\[ImaginaryI]", " ", \(g\_s\), " ", 
                   SuperscriptBox[RowBox[{"(", FormBox[\(p - q\), 
                       "TraditionalForm"], ")"}], FormBox[FormBox["mu", 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SubscriptBox["T", FormBox[FormBox["a", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "ScalarGluonVertex"]}, Open]]}, Open]], 
        Cell["ScalarProduct", "ObjectName", CellTags -> "ScalarProduct"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ScalarProduct"], Cell[TextData[{"ScalarProduct[p, q] \
is the input for scalar product. ScalarProduct[p] is equivalent to \
ScalarProduct[p, p]. Expansion of sums of momenta in ScalarProduct is done \
with ExpandScalarProduct. Scalar product may be set, e.g., ScalarProduct[a, \
b] = ", Cell[BoxData[\(TraditionalForm\`\(m^2\)\)]], 
              "; but a and b must not contain sums. Note that \
ScalarProduct[a, b] = ", Cell[BoxData[\(TraditionalForm\`\(m^2\)\)]], 
              " actually sets also: Pair[Momentum[a, ___], Momentum[b, ___]] \
= ", Cell[BoxData[\(TraditionalForm\`\(m^2\)\)]], 
              ". It is encouraged to always set ScalarProduct's ", 
              StyleBox["before", Rule[FontWeight, "Bold"]], 
              " any calculation. This improves the performance of FeynCalc ."}\
], "Text", CellTags -> "ScalarProduct"], Cell[TextData[{"See also: ", 
              ButtonBox["Calc", RuleDelayed[ButtonData, "Calc"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Calc"]], 
              ", ", 
              ButtonBox["ClearScalarProducts", 
                RuleDelayed[ButtonData, "ClearScalarProducts"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ClearScalarProducts"]], ", ", 
              ButtonBox["ExpandScalarProduct", 
                RuleDelayed[ButtonData, "ExpandScalarProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandScalarProduct"]], ", ", 
              ButtonBox["ScalarProductCancel", 
                RuleDelayed[ButtonData, "ScalarProductCancel"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ScalarProductCancel"]], ", ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              ", ", 
              ButtonBox["SP", RuleDelayed[ButtonData, "SP"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SP"]], 
              ", ", 
              ButtonBox["SPD", RuleDelayed[ButtonData, "SPD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SPD"]], 
              "."}], "Text", CellTags -> "ScalarProduct"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ScalarProduct"], Cell[CellGroupData[{Cell[BoxData[
                \(ScalarProduct[\(p, q\)]\)], "Input", CellTags -> 
                "ScalarProduct"], Cell[BoxData[FormBox[RowBox[
                  {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                   FormBox["q", "TraditionalForm"]}], TraditionalForm]], 
               "Output", CellTags -> "ScalarProduct"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(ScalarProduct[\(\(p + q\), \(-q\)\)]\)], "Input", 
               CellTags -> "ScalarProduct"], Cell[BoxData[FormBox[
                 RowBox[{"-", RowBox[{"(", RowBox[{FormBox["q", 
                        "TraditionalForm"], "\[CenterDot]", "(", FormBox[
                        \(p + q\), "TraditionalForm"], ")"}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "ScalarProduct"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ScalarProduct[\(p, p\)]\)], "Input", CellTags -> 
                "ScalarProduct"], Cell[BoxData[FormBox[SuperscriptBox[
                  FormBox["p", "TraditionalForm"], "2"], TraditionalForm]], 
               "Output", CellTags -> "ScalarProduct"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ScalarProduct[q]\)], "Input", 
               CellTags -> "ScalarProduct"], Cell[BoxData[FormBox[
                 SuperscriptBox[FormBox["q", "TraditionalForm"], "2"], 
                 TraditionalForm]], "Output", CellTags -> "ScalarProduct"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(ScalarProduct[\(p, q\)]\)//StandardForm\)], "Input", 
               CellTags -> "ScalarProduct"], Cell[BoxData[
                \(Pair[\(\(Momentum[p]\), \(Momentum[q]\)\)]\)], "Output", 
               CellTags -> "ScalarProduct"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(ScalarProduct[\(p, q, \(Dimension \[Rule] D\)\)]\)//
                   StandardForm\)], "Input", CellTags -> "ScalarProduct"], 
              Cell[BoxData[
                \(Pair[\(\(Momentum[\(p, D\)]\), \(Momentum[\(q, D\)]\)\)]\)]\
, "Output", CellTags -> "ScalarProduct"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(ScalarProduct[\(p\_1, p\_2\)]\)\ =\ \(s/2\)\)], "Input", 
               CellTags -> "ScalarProduct"], Cell[BoxData[
                \(TraditionalForm\`\(s\/2\)\)], "Output", CellTags -> 
                "ScalarProduct"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ExpandScalarProduct[\ \(
                    ScalarProduct[\(\(p\_1 - q\), \(p\_2 - k\)\)]\)]\)], 
               "Input", CellTags -> "ScalarProduct"], Cell[BoxData[
                FormBox[RowBox[{\(s\/2\), "+", RowBox[{FormBox[FormBox[
                       TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                      "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                      "TraditionalForm"]}], "-", RowBox[{FormBox[FormBox[
                       TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                      "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\), 
                      "TraditionalForm"]}], "-", RowBox[{FormBox["q", 
                      "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\), 
                      "TraditionalForm"]}]}], TraditionalForm]], "Output", 
               CellTags -> "ScalarProduct"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Calc[\ \(ScalarProduct[\(\(p\_1 - q\), \(p\_2 - k\)\)]\)]\)]\
, "Input", CellTags -> "ScalarProduct"], Cell[BoxData[FormBox[RowBox[{\(s\/2\)
                   , "+", RowBox[{FormBox[FormBox[
                       TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                      "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                      "TraditionalForm"]}], "-", RowBox[{FormBox[FormBox[
                       TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                      "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\), 
                      "TraditionalForm"]}], "-", RowBox[{FormBox["q", 
                      "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\), 
                      "TraditionalForm"]}]}], TraditionalForm]], "Output", 
               CellTags -> "ScalarProduct"]}, Open]], 
           Cell[BoxData["ClearScalarProducts"], "Input", CellTags -> 
             "ScalarProduct"]}, Open]], Cell["ScalarProductCancel", 
         "ObjectName", CellTags -> "ScalarProductCancel"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ScalarProductCancel"], Cell["ScalarProductCancel[exp\
, q1, q2, ...] cancels scalar products with propagators. \
ScalarProductCancel[exp] cancels simple cases.", "Text", CellTags -> 
             "ScalarProductCancel"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[ScalarProductCancel]\)], "Input", CellTags -> 
                "ScalarProductCancel"], Cell[BoxData[
                \(TraditionalForm\`\({\(ChangeDimension \[Rule] D\), 
                      \(Collecting \[Rule] True\), 
                      \(FeynAmpDenominatorSimplify \[Rule] False\), 
                      \(FeynAmpDenominatorCombine \[Rule] True\)}\)\)], 
               "Output", CellTags -> "ScalarProductCancel"]}, Open]], 
           Cell[TextData[{"See also: ", 
              ButtonBox["Calc", RuleDelayed[ButtonData, "Calc"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Calc"]], 
              ", ", 
              ButtonBox["ClearScalarProducts", 
                RuleDelayed[ButtonData, "ClearScalarProducts"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ClearScalarProducts"]], ", ", 
              ButtonBox["ExpandScalarProduct", 
                RuleDelayed[ButtonData, "ExpandScalarProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandScalarProduct"]], ", ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              ", ", 
              ButtonBox["SP", RuleDelayed[ButtonData, "SP"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SP"]], 
              ", ", 
              ButtonBox["SPC", RuleDelayed[ButtonData, "SPC"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SPC"]], 
              ", ", 
              ButtonBox["SPD", RuleDelayed[ButtonData, "SPD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SPD"]], 
              "."}], "Text", CellTags -> "ScalarProductCancel"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ScalarProductCancel"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynAmpDenominatorSimplify", 
                RuleDelayed[ButtonData, "FeynAmpDenominatorSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynAmpDenominatorSimplify"]], "."}], 
            "Text", CellTags -> "ScalarProductCancel"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t1\ =\ \(\(\(SPD[\(q, p\)]\)\ 
                       \(FAD[\(\({q, m}\), \({\(q - p\), 0}\)\)]\)\)//FCI\)\)]\
, "Input", CellTags -> "ScalarProductCancel"], Cell[BoxData[FormBox[
                 FractionBox[RowBox[{FormBox["p", "TraditionalForm"], 
                    "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                  \(\((q\^2 - m\^2)\) . \((q - p)\)\^2\)], TraditionalForm]], 
               "Output", CellTags -> "ScalarProductCancel"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ScalarProductCancel[\(t1, q\)]\)
                ], "Input", CellTags -> "ScalarProductCancel"], 
              Cell[BoxData[FormBox[RowBox[{
                   \(-\(1\/\(2\ \((q\^2 - m\^2)\)\)\)\), "+", 
                   \(1\/\(2\ \((q - p)\)\^2\)\), "+", FractionBox[RowBox[{
                      \(m\^2\/2\), "+", FractionBox[SuperscriptBox[FormBox[
                         "p", "TraditionalForm"], "2"], "2"]}], 
                    \(\((q\^2 - m\^2)\) . \((q - p)\)\^2\)]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "ScalarProductCancel"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(FeynAmpDenominatorSimplify[\(%, q\)]\)], 
               "Input", CellTags -> "ScalarProductCancel"], Cell[BoxData[
                FormBox[RowBox[{FractionBox[RowBox[{\(m\^2\/2\), "+", 
                      FractionBox[SuperscriptBox[FormBox["p", 
                         "TraditionalForm"], "2"], "2"]}], 
                    \(\((q\^2 - m\^2)\) . \((q - p)\)\^2\)], "-", 
                   \(1\/\(2\ \((q\^2 - m\^2)\)\)\)}], TraditionalForm]], 
               "Output", CellTags -> "ScalarProductCancel"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SPC[\(t1, q, \(FDS \[Rule] True\)\)]\)], "Input", 
               CellTags -> "ScalarProductCancel"], Cell[BoxData[
                FormBox[RowBox[{FractionBox[RowBox[{\(m\^2\/2\), "+", 
                      FractionBox[SuperscriptBox[FormBox["p", 
                         "TraditionalForm"], "2"], "2"]}], 
                    \(\((q\^2 - m\^2)\) . \((q - p)\)\^2\)], "-", 
                   \(1\/\(2\ \((q\^2 - m\^2)\)\)\)}], TraditionalForm]], 
               "Output", CellTags -> "ScalarProductCancel"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t2\ =\ \(\(\(SPD[\(q2, p\)]\) \(SPD[\(q1, p\)]\)\ 
                       \(FAD[\(\({q1, m}\), \({q2, m}\), \(q1 - p\), 
                           \(q2 - p\), \(q2 - q1\)\)]\)\)//FCI\)\)], "Input", 
               CellTags -> "ScalarProductCancel"], Cell[BoxData[
                FormBox[FractionBox[RowBox[{RowBox[{FormBox["p", 
                       "TraditionalForm"], "\[CenterDot]", FormBox[
                       \(\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1\), 
                       "TraditionalForm"]}], " ", RowBox[{FormBox["p", 
                       "TraditionalForm"], "\[CenterDot]", FormBox[
                       \(\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2\), 
                       "TraditionalForm"]}]}], 
                  \(\((\(\*TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_1\%2 - m\^2)\)\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_2\%2 - m\^2)\)\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2 - 
                         \(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2\)], 
                 TraditionalForm]], "Output", CellTags -> 
                "ScalarProductCancel"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SPC[\(t2, q1, q2, \(FDS \[Rule] True\)\)]\)], 
               "Input", CellTags -> "ScalarProductCancel"], Cell[BoxData[
                FormBox[RowBox[{
                   \(1\/\(4\ \(\((\(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_1\%2 - 
                             m\^2)\) . \((\(
                               \*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_2\%2 - 
                             m\^2)\) . \((\(
                                \*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_2 - 
                              \(\*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2\)
                   \)\), "-", 
                   \(1\/\(2\ \(\((\(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_1\%2 - 
                             m\^2)\) . \((\(
                                \*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\
\^2 . \((\(\*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_2 - 
                              \(\*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2\)
                   \)\), "+", FractionBox[RowBox[{\(-\(m\^2\/2\)\), "-", 
                      FractionBox[SuperscriptBox[FormBox["p", 
                         "TraditionalForm"], "2"], "2"]}], 
                    \(\((\(\*TagBox[StyleBox["\"q\"", 
                               Rule[FontSlant, "Italic"]], 
                              Function[StyleForm[Slot[1], 
                                Rule[FontSlant, "Italic"]]]]\)\_1\%2 - m\^2)\
\) . \((\(\*TagBox[StyleBox["\"q\"", 
                               Rule[FontSlant, "Italic"]], 
                              Function[StyleForm[Slot[1], 
                                Rule[FontSlant, "Italic"]]]]\)\_2\%2 - m\^2)\
\) . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^2\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - 
                           \(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2\)], 
                   "+", FractionBox[RowBox[{\(m\^2\/2\), "+", FractionBox[
                       SuperscriptBox[FormBox["p", "TraditionalForm"], "2"], 
                       "2"]}], 
                    \(\(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_1\%2 . 
                       \(\*TagBox[StyleBox["\"q\"", 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"]]]]\)\_2\%2 . 
                       \((\((\(\*TagBox[StyleBox["\"q\"", 
                                   Rule[FontSlant, "Italic"]], 
                                  Function[StyleForm[Slot[1], 
                                    Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\
\^2 - m\^2)\) . \((\(\*
                              TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - 
                           \(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2\)], 
                   "+", FractionBox[RowBox[{\(m\^4\/4\), "+", FractionBox[
                       RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], " ", \(m\^2\)}], "2"], 
                      "+", FractionBox[SuperscriptBox[FormBox["p", 
                         "TraditionalForm"], "4"], "4"]}], 
                    \(\((\(\*TagBox[StyleBox["\"q\"", 
                               Rule[FontSlant, "Italic"]], 
                              Function[StyleForm[Slot[1], 
                                Rule[FontSlant, "Italic"]]]]\)\_1\%2 - m\^2)\
\) . \((\(\*TagBox[StyleBox["\"q\"", 
                               Rule[FontSlant, "Italic"]], 
                              Function[StyleForm[Slot[1], 
                                Rule[FontSlant, "Italic"]]]]\)\_2\%2 - m\^2)\
\) . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^2\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\
 . \((\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2 - 
                           \(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1)\)\^2\)]}]\
, TraditionalForm]], "Output", CellTags -> "ScalarProductCancel"]}, Open]], 
           Cell[BoxData[\(\(Clear[\(t1, t2\)]\) ;\)], "Input", 
            CellTags -> "ScalarProductCancel"]}, Open]], 
        Cell["ScaleMu", "ObjectName", CellTags -> "ScaleMu"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ScaleMu"], Cell["ScaleMu is the mass scale used for \
dimensional regularization of loop integrals.", "Text", CellTags -> 
             "ScaleMu"], Cell[CellGroupData[{Cell[BoxData["ScaleMu"], 
               "Input"], Cell[BoxData[\(TraditionalForm\`\[Mu]\)], 
               "Output"]}, Open]]}, Open]], Cell["Schouten", "ObjectName", 
         CellTags -> "Schouten"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Schouten"], 
           Cell["Schouten[expr] applies the Schouten identity on at most 42 \
terms in a sum. If Schouten should operate on larger expression you can give \
a second argument, e.g.: Schouten[expr, 4711] which will work on sums with \
less than 4711 terms.\nSchouten is also an option of Contract and DiracTrace. \
It may be set to an integer indicating the maximum number of terms onto which \
the function Schouten will be applied .", "Text", CellTags -> "Schouten"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], ", ", 
              ButtonBox["DiracTrace", RuleDelayed[ButtonData, "DiracTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrace"]], "."}], "Text", 
            CellTags -> "Schouten"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Schouten"], Cell[CellGroupData[{Cell[BoxData[
                \(t = \(\(Sum[\(\(\[Sum]\+\(a = 1\)\%4 
                           \((\(SP[\(k, \(q[a]\)\)]\) 
                              \((1\/6 \(Eps[
                                   \(\(LorentzIndex[a]\), \(LorentzIndex[b]\)
                                     , \(LorentzIndex[c]\), 
                                     \(LorentzIndex[d]\)\)]\) 
                                 \(Eps[\(
                                    \(LorentzIndex[\[Mu]]\), 
                                     \(Momentum[\(q[b]\)]\), 
                                     \(Momentum[\(q[c]\)]\), 
                                     \(Momentum[\(q[d]\)]\)\)]\))\))\)\), 
                         \({b, 1, 4}\), \({c, 1, 4}\), \({d, 1, 4}\)\)]\) - 
                     \(\(Eps[\(\(Momentum[\(q[1]\)]\), \(Momentum[\(q[2]\)]\)
                           , \(Momentum[\(q[3]\)]\), \(Momentum[\(q[4]\)]\)\)\
]\) * \(Pair[\(\(LorentzIndex[\[Mu]]\), \(Momentum[k]\)\)]\)\
\)\)\)], "Input", CellTags -> "Schouten"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{RowBox[{"-", SuperscriptBox["\[Epsilon]", 
                        RowBox[{FormBox[\(q(1)\), "TraditionalForm"], FormBox[
                          \(q(2)\), "TraditionalForm"], FormBox[\(q(3)\), 
                          "TraditionalForm"], FormBox[\(q(4)\), 
                          "TraditionalForm"]}]]}], " ", SuperscriptBox[
                      FormBox[FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]]}], "+", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(1)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(1)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(1)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "+", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(1)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "+", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(1)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(1)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(2)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "+", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(2)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "+", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(2)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(2)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(2)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "+", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(2)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "+", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(3)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(3)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(3)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "+", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(3)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "+", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(3)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(4)\), 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(3)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(4)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "+", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(4)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "+", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(4)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(4)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(4)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}], "+", 
                   RowBox[{\(1\/6\), " ", SuperscriptBox["\[Epsilon]", 
                      RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[\(q(3)\), 
                         "TraditionalForm"], FormBox[\(q(2)\), 
                         "TraditionalForm"], FormBox[\(q(1)\), 
                         "TraditionalForm"]}]], " ", FormBox[RowBox[
                       {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                        "\[CenterDot]", FormBox[\(q(4)\), 
                         "TraditionalForm"]}], "TraditionalForm"]}]}], 
                 TraditionalForm]], "Output", CellTags -> "Schouten"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(t//Schouten\)], 
               "Input", CellTags -> "Schouten"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> "Schouten"]}, 
             Open]], Cell[BoxData[\(Clear[t]\)], "Input"]}, Open]], 
        Cell["SD", "ObjectName", CellTags -> "SD"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SD"], Cell[TextData[
             {"SD[i, j] is the (FeynCalc-external) Kronecker-delta for SU(", 
              StyleBox["N", Rule[FontSlant, "Italic"]], ") with color indices \
i and j. SD[i,j] is transformed into SUNDelta[SUNIndex[i],SUNIndex[j]] by \
FeynCalcInternal."}], "Text", CellTags -> "SD"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["SUNDelta", RuleDelayed[ButtonData, "SUNDelta"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNDelta"]], "."}], "Text", 
            CellTags -> "SD"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "SD"], 
           Cell[CellGroupData[{Cell[BoxData[\(SD[\(a, b\)]\)], "Input", 
               CellTags -> "SD"], Cell[BoxData[
                \(TraditionalForm\`\[Delta]\_\(ab\)\)], "Output", CellTags -> 
                "SD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(%//FCI\)//StandardForm\)], "Input", CellTags -> "SD"], 
              Cell[BoxData[\(SUNDelta[\(\(SUNIndex[a]\), \(SUNIndex[b]\)\)]\)]
                , "Output", CellTags -> "SD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(%//FCE\)//StandardForm\)], 
               "Input", CellTags -> "SD"], Cell[BoxData[\(SD[\(a, b\)]\)], 
               "Output", CellTags -> "SD"]}, Open]]}, Open]], 
        Cell["SelectFree", "ObjectName", CellTags -> "SelectFree"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SelectFree"], Cell["SelectFree[expr, a, b, ...] is \
equivalent to Select[expr, FreeQ2[#, {a,b, ...}]&], except the special cases: \
SelectFree[a, b] returns a and SelectFree[a,a] returns 1 (where a is not a \
product or a sum).", "Text", CellTags -> "SelectFree"], 
           Cell["SelectFree is equivalent to Select1.", "Text", 
            CellTags -> "SelectFree"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FreeQ2", RuleDelayed[ButtonData, "FreeQ2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FreeQ2"]], 
              ", ", 
              ButtonBox["SelectNotFree", 
                RuleDelayed[ButtonData, "SelectNotFree"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SelectNotFree"]], "."}], "Text", 
            CellTags -> "SelectFree"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SelectFree"], Cell[CellGroupData[{Cell[BoxData[
                \(SelectFree[\(\(a + b + \(f[a]\) + d\), a\)]\)], "Input", 
               CellTags -> "SelectFree"], Cell[BoxData[
                \(TraditionalForm\`\(b + d\)\)], "Output", CellTags -> 
                "SelectFree"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SelectFree[\(\(x\ y\),\ x\)]\)], "Input", CellTags -> 
                "SelectFree"], Cell[BoxData[\(TraditionalForm\`y\)], 
               "Output", CellTags -> "SelectFree"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SelectFree[\(\(2\ x\ y\ z\ \(f[x]\)\),\ \({x, y}\)\)]\)], 
               "Input", CellTags -> "SelectFree"], Cell[BoxData[
                \(TraditionalForm\`\(2\ z\)\)], "Output", CellTags -> 
                "SelectFree"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SelectFree[\(a, b\)]\)], "Input", CellTags -> 
                "SelectFree"], Cell[BoxData[\(TraditionalForm\`a\)], 
               "Output", CellTags -> "SelectFree"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SelectFree[\(a, a\)]\)], 
               "Input", CellTags -> "SelectFree"], Cell[BoxData[
                \(TraditionalForm\`1\)], "Output", CellTags -> 
                "SelectFree"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SelectFree[\(1, c\)]\)], "Input", CellTags -> 
                "SelectFree"], Cell[BoxData[\(TraditionalForm\`1\)], 
               "Output", CellTags -> "SelectFree"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SelectFree[\(\(f[x]\), x\)]\)], 
               "Input", CellTags -> "SelectFree"], Cell[BoxData[
                \(TraditionalForm\`1\)], "Output", CellTags -> 
                "SelectFree"]}, Open]]}, Open]], Cell["SelectGraphs", 
         "ObjectName", CellTags -> "SelectGraphs"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SelectGraphs"], Cell["SelectGraphs is an option for \
OneLoopSum indicating that only a slected set of graphs of the list provided \
to OneLoopSum is to be calculated. Possible settings are: \
SelectGraphs\[RightArrow]{ i, j,  ... } or SelectGraphs\[RightArrow]{ a, {b, \
c}, ... } which indicates the graphs to be taken from the list provided to \
OneLoopSum. In the second setting the list {b, c} indicates that all \
amplitudes from b to c should be taken.", "Text", CellTags -> 
             "SelectGraphs"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoopSum", RuleDelayed[ButtonData, "OneLoopSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSum"]], "."}], "Text", 
            CellTags -> "SelectGraphs"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["SelectNotFree", "ObjectName", CellTags -> "SelectNotFree"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SelectNotFree"], Cell["SelectNotFree[expr, x] \
returns that part of expr which is not free of any occurance of x.", "Text", 
            CellTags -> "SelectNotFree"], Cell["SelectNotFree[expr, a, b, \
...] is equivalent to Select[expr, !FreeQ2[#, {a, b, ...}]&], except the \
special cases: SelectNotFree[a, b] returns 1 and SelectNotFree[a, a] returns \
a (where a is not a product or a sum).", "Text", CellTags -> 
             "SelectNotFree"], Cell[
            "SelectNotFree is equivalent to Select2.", "Text", 
            CellTags -> "SelectNotFree"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FreeQ2", RuleDelayed[ButtonData, "FreeQ2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FreeQ2"]], 
              ", ", 
              ButtonBox["SelectFree", RuleDelayed[ButtonData, "SelectFree"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SelectFree"]], "."}], "Text", 
            CellTags -> "SelectNotFree"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SelectNotFree"], Cell[CellGroupData[{Cell[BoxData[
                \(SelectNotFree[\(\(a + b + \(f[a]\)\), a\)]\)], "Input", 
               CellTags -> "SelectNotFree"], Cell[BoxData[
                \(TraditionalForm\`\(a + \(f(a)\)\)\)], "Output", CellTags -> 
                "SelectNotFree"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SelectNotFree[\(\(2\ x\ y\ \(f[x]\)\ z\), \({x, y}\)\)]\)], 
               "Input", CellTags -> "SelectNotFree"], Cell[BoxData[
                \(TraditionalForm\`\(x\ y\ \(f(x)\)\)\)], "Output", 
               CellTags -> "SelectNotFree"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SelectNotFree[\(a, b\)]\)], 
               "Input", CellTags -> "SelectNotFree"], Cell[BoxData[
                \(TraditionalForm\`1\)], "Output", CellTags -> 
                "SelectNotFree"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SelectNotFree[\(\(a + x\), b\)]\)], "Input", CellTags -> 
                "SelectNotFree"], Cell[BoxData[\(TraditionalForm\`0\)], 
               "Output", CellTags -> "SelectNotFree"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SelectNotFree[\(a, a\)]\)], 
               "Input", CellTags -> "SelectNotFree"], Cell[BoxData[
                \(TraditionalForm\`a\)], "Output", CellTags -> 
                "SelectNotFree"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SelectNotFree[\(1, c\)]\)], "Input", CellTags -> 
                "SelectNotFree"], Cell[BoxData[\(TraditionalForm\`1\)], 
               "Output", CellTags -> "SelectNotFree"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SelectNotFree[\(\(f[x]\), x\)]\)
                ], "Input", CellTags -> "SelectNotFree"], Cell[BoxData[
                \(TraditionalForm\`\(f(x)\)\)], "Output", CellTags -> 
                "SelectNotFree"]}, Open]]}, Open]], Cell["SelectSplit", 
         "ObjectName", CellTags -> "SelectSplit"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SelectSplit"], Cell["SelectSplit[l, p] Construct \
list of mutually exclusive subsets from l in which every element li satisfies \
a criterium pj[li] with pj from p and appends the subset of remaining \
unmatched elements.", "Text", CellTags -> "SelectSplit"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SelectSplit"], Cell[CellGroupData[{Cell[BoxData[
                \(SelectSplit[\(\({a\^2, b\^3, c\^4, d\^5, e\^6, \(f + g\), 
                        h\^4}\), \({\(\(MatchQ[\(#, \(_^2\)\)]\) &\), 
                        \(\(MatchQ[\(#, \(_^4\)\)]\) &\), 
                        \(\(FreeQ[\(#, Power\)]\) &\)}\)\)]\)], "Input", 
               CellTags -> "SelectSplit"], Cell[BoxData[
                \(TraditionalForm\`\({\({a\^2}\), \({c\^4, h\^4}\), 
                      \({f + g}\), \({b\^3, d\^5, e\^6}\)}\)\)], "Output", 
               CellTags -> "SelectSplit"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SelectSplit[\(\({a\^2, b\^3, c\^4, d\^5, e\^6, \(f + g\), 
                        h\^4}\), \({\(\(FreeQ[\(#, Plus\)]\) &\), 
                        \(\(FreeQ[\(#, Power\)]\) &\)}\)\)]\)], "Input", 
               CellTags -> "SelectSplit"], Cell[BoxData[
                \(TraditionalForm\`\({\({a\^2, b\^3, c\^4, d\^5, e\^6, h\^4}
                       \), \({f + g}\), \({}\)}\)\)], "Output", CellTags -> 
                "SelectSplit"]}, Open]]}, Open]], Cell["Select1", 
         "ObjectName", CellTags -> "Select1"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Select1"], Cell["Select1[expr, a, b, ...] is \
equivalent to Select[expr, FreeQ2[#, {a,b, ...}]&], except the special cases: \
Select1[a, b] returns a and Select1[a,a] returns 1 (where a is not a product \
or a sum).", "Text", CellTags -> "Select1"], Cell[TextData[{"See also: ", 
              " ", 
              ButtonBox["Select2", RuleDelayed[ButtonData, "Select2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Select2"]]\
, "."}], "Text", CellTags -> "Select1"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["Select2", "ObjectName", CellTags -> "Select2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Select2"], Cell["Select2[expr, a, b, ...] is \
equivalent to Select[expr, !FreeQ2[#, {a,b, ...}]&], except the special \
cases: Select2[a, b] returns 1 and  Select2[a,a] returns a (where a is not a \
product or a sum).", "Text", CellTags -> "Select2"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Select1", RuleDelayed[ButtonData, "Select1"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Select1"]]\
, "."}], "Text", CellTags -> "Select2"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["Series2", "ObjectName", CellTags -> "Series2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Series2"], Cell[TextData[{" Series2 performs a \
series expansion around 0. Series2 is (up to the Gamma-bug in ", 
              StyleBox["Mathematica", Rule[FontSlant, "Italic"]], " versions \
smaller than 5.0) equivalent to Series, except that it applies Normal on the \
result and has an option FinalSubstitutions. Series2[f, e, n] is equivalent \
to Series2[f, {e, 0, n}]."}], "Text", CellTags -> "Series2"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[Series2]\)], "Input", 
               CellTags -> "Series2"], Cell[BoxData[
                \(TraditionalForm\`\({\(Collecting \[Rule] False\), 
                      \(Factoring \[Rule] True\), 
                      \(FinalSubstitutions \[Rule] 
                        \({\*TagBox["\[DoubledGamma]", 
                             Function[List[], EulerGamma]] \[Rule] 0}\)\), 
                      \(Print \[Rule] False\), 
                      \(SimplifyPolyLog \[Rule] True\)}\)\)], "Output", 
               CellTags -> "Series2"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Series2"], Cell[CellGroupData[{Cell[BoxData[
                \(Series2[\(\(\((x\ \((1 - x)\))\)^\((\[Delta]/2)\)\), 
                     \[Delta], 1\)]\)], "Input", CellTags -> "Series2"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(1\/2\ \[Delta]\ \(log(\(1 - x\))\)\) +
                      \(1\/2\ \[Delta]\ \(log(x)\)\) + 1\)\)], "Output", 
               CellTags -> "Series2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Series2[\(\(Gamma[x]\), x, 1\)]\)], "Input", 
               CellTags -> "Series2"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/2\ x\ \(\[Zeta](2)\)\) + 1\/x\)\)], 
               "Output", CellTags -> "Series2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Series[\(\(Gamma[x]\), \({x, 0, 1}\)\)]\)], "Input", 
               CellTags -> "Series2"], Cell[BoxData[
                \(TraditionalForm\`\(\*InterpretationBox[\(
                       1\/x - \*TagBox["\[DoubledGamma]", 
                          Function[List[], EulerGamma]] + 
                        \(1\/2\ \((\*TagBox["\[DoubledGamma]", 
                                Function[List[], EulerGamma]]\^2 + 
                             \[Pi]\^2\/6)\)\ x\) + 
                        \*InterpretationBox[\(O(\(x\^2\))\), 
                          SeriesData[x, 0, List[], -1, 2, 1], 
                          Rule[Editable, False]]\), 
                      SeriesData[x, 0, List[1, Times[-1, EulerGamma], 
                        Times[Rational[1, 2], 
                         Plus[Power[EulerGamma, 2], 
                          Times[Rational[1, 6], Power[Pi, 2]]]]], -1, 2, 1], 
                      Rule[Editable, False]]\)\)], "Output", CellTags -> 
                "Series2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Series2[\(\(Gamma[x]\), x, 2\)]\)], "Input", CellTags -> 
                "Series2"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(-\(1\/3\)\)\ 
                       \*TagBox[\(\[Zeta](
                           \(\*TagBox["3", Zeta, Rule[Editable, True]]\))\), 
                         InterpretTemplate[Function[BoxForm`e$, 
                           Zeta[BoxForm`e$]]]]\ x\^2\) + 
                     \(1\/2\ \(\[Zeta](2)\)\ x\) + 1\/x\)\)], "Output", 
               CellTags -> "Series2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(Series2[\(\(Gamma[x]\), x, 2, 
                       \(FinalSubstitutions \[Rule] \({}\)\)\)]\)//
                   FullSimplify\)], "Input", CellTags -> "Series2"], 
              Cell[BoxData[
                \(TraditionalForm\`\(1\/6\ 
                     \((\(\(-2\)\ \*TagBox[\(
                             \[Zeta](\(\*
                                TagBox["3", Zeta, Rule[Editable, True]]\))\)\
, InterpretTemplate[Function[BoxForm`e$, Zeta[BoxForm`e$]]]]\
\ x\^2\) - \(\*TagBox["\[DoubledGamma]", 
                             Function[List[], EulerGamma]]\^3\ x\^2\) + 
                        \(3\ \(\[Zeta](2)\)\ x\) + 
                        \(3\ \*TagBox["\[DoubledGamma]", 
                             Function[List[], EulerGamma]]\^2\ x\) - 
                        \(3\ \*TagBox["\[DoubledGamma]", 
                            Function[List[], EulerGamma]]\ 
                          \((\(\(\[Zeta](2)\)\ x\^2\) + 2)\)\) + 6\/x)\)\)\)]\
, "Output", CellTags -> "Series2"]}, Open]], Cell[TextData[{"In earlier ", 
              StyleBox["Mathematica", Rule[FontSlant, "Italic"]], " versions \
the Gamma functions was not expanded far enough, in 5.0 this got finally \
fixed:"}], "Text"], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(Series[\(\(Gamma[x]\), 
                           \({x, 0, \(If[\(\($VersionNumber < 5\), 4, 2\)]\)}
                            \)\)]\)//Normal\)//Expand\)//FullSimplify\)], 
               "Input", CellTags -> "Series2"], Cell[BoxData[
                \(TraditionalForm\`\(1\/12\ 
                     \((\(\(-2\)\ \*TagBox["\[DoubledGamma]", 
                             Function[List[], EulerGamma]]\^3\ x\^2\) + 
                        \(\((\[Pi]\^2 - \(
                              4\ x\ \*TagBox[\(
                                  \[Zeta](
                                   \(\*TagBox["3", Zeta, 
                                     Rule[Editable, True]]\))\), 
                                 InterpretTemplate[Function[BoxForm`e$, 
                                   Zeta[BoxForm`e$]]]]\))\)\ x\) + 
                        \(6\ \*TagBox["\[DoubledGamma]", 
                             Function[List[], EulerGamma]]\^2\ x\) - 
                        \(\*TagBox["\[DoubledGamma]", 
                            Function[List[], EulerGamma]]\ 
                          \((\(\[Pi]\^2\ x\^2\) + 12)\)\) + 12\/x)\)\)\)], 
               "Output", CellTags -> "Series2"]}, Open]], Cell["There is a \
table of expansions of special hypergeometric functions.", "Text", 
            CellTags -> "Series2"], Cell[CellGroupData[{Cell[BoxData[
                \(Series2[\(\(HypergeometricPFQ[
                       \(\({1, \(OPEm - 1\), \(\(Epsilon/2\) + OPEm\)}\), 
                         \({OPEm, \(OPEm + Epsilon\)}\), 1\)]\), Epsilon, 1\)\
]\)], "Input", CellTags -> "Series2"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/2\ 
                       \*TagBox["\[CurlyEpsilon]", TraditionalForm]\ 
                       \(\(\*TagBox["\[Psi]", PolyGamma]\^\((1)\)\)(m)\)\ m\)\
 + \(2\ m\)\/\*TagBox["\[CurlyEpsilon]", TraditionalForm] - 
                     \(1\/2\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]\ 
                       \(\(\*TagBox["\[Psi]", PolyGamma]\^\((1)\)\)(m)\)\) - 
                     2\/\*TagBox["\[CurlyEpsilon]", TraditionalForm] + 1\)\)]\
, "Output", CellTags -> "Series2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\ \(Series2[\(\(HypergeometricPFQ[
                         \(\({1,\ OPEm,\ \(\(Epsilon/2\)\ +\ OPEm\)}\),\ 
                           \({\(1\ +\ OPEm\),\ \(Epsilon\ +\ OPEm\)}\),
                           \(\ \ \)1\)]\), Epsilon, 1\)]\)\)], "Input", 
               CellTags -> "Series2"], Cell[BoxData[FormBox[RowBox[{
                   \(1\/4\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]\ m\ 
                      \(\*TagBox["\[Psi]", PolyGamma]\^\((0)\)(m)\)\^2\), 
                   "+", 
                   \(\(2\ m\)\/\*TagBox["\[CurlyEpsilon]", TraditionalForm]\)\
, "+", 
                   \(1\/4\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]\ m\ 
                      \(\[Zeta](2)\)\), "+", 
                   \(3\/4\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]\ m\ 
                      \(\*TagBox["\[Psi]", PolyGamma]\^\((1)\)(m)\)\), "-", 
                   RowBox[{\(1\/2\), " ", 
                     TagBox["\[CurlyEpsilon]", TraditionalForm], " ", "m", 
                     " ", RowBox[{\(S\_11\), "(", FormBox[\(m - 1\), 
                        "TraditionalForm"], ")"}]}]}], TraditionalForm]], 
               "Output", CellTags -> "Series2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Hypergeometric2F1[\(1,\ Epsilon,\ \(1\ +\ \(2\ Epsilon\)\),
                      x\)]\)], "Input", CellTags -> "Series2"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[TagBox[\(
                        \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\) 
                         \[InvisibleApplication] 
                         \((\*TagBox[TagBox[\(
                                \*TagBox["1", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                 \*TagBox[TagBox["\[CurlyEpsilon]", 
                                   TraditionalForm], Hypergeometric2F1, 
                                   Rule[Editable, True]]\), 
                               InterpretTemplate[Function[List[
                                  SlotSequence[1]]]]], Hypergeometric2F1, 
                              Rule[Editable, False]] ; 
                            \*TagBox[TagBox[TagBox[\(
                                 \(2\ \*
                                   TagBox["\[CurlyEpsilon]", 
                                   TraditionalForm]\) + 1\), 
                                Hypergeometric2F1, Rule[Editable, True]], 
                               InterpretTemplate[Function[List[
                                  SlotSequence[1]]]]], Hypergeometric2F1, 
                              Rule[Editable, False]] ; 
                            \*TagBox["x", Hypergeometric2F1, 
                              Rule[Editable, True]])\)\), 
                       InterpretTemplate[Function[HypergeometricPFQ[
                          Slot[1], Slot[2], Slot[3]]]], 
                       Rule[Editable, False]], Hypergeometric2F1]\)\)], 
               "Output", CellTags -> "Series2"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Series2[\(%, Epsilon, 3\)]\)], 
               "Input", CellTags -> "Series2"], Cell[BoxData[FormBox[RowBox[{
                   \(\(-\(1\/6\)\)\ \(log\^3(1 - x)\)\ 
                      \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^3\), "-", 
                   \(2\ \(log(1 - x)\)\ \(log\^2(x)\)\ 
                      \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^3\), "-", 
                   \(2\ \(\[Zeta](2)\)\ \(log(1 - x)\)\ 
                      \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^3\), "+", 
                   \(\(log\^2(1 - x)\)\ \(log(x)\)\ 
                      \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^3\), "+", 
                   \(4\ \(\[Zeta](2)\)\ \(log(x)\)\ 
                      \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^3\), "-", 
                   RowBox[{"4", " ", RowBox[{SubscriptBox["S", RowBox[
                         {FormBox["1", "TraditionalForm"], FormBox["2", 
                          "TraditionalForm"]}]], "(", FormBox[\(1 - x\), 
                        "TraditionalForm"], ")"}], " ", 
                     \(\*TagBox["\[CurlyEpsilon]", TraditionalForm]\^3\)}], 
                   "-", 
                   \(4\ \(log(x)\)\ \(\(\*InterpretationBox["Li", PolyLog, 
                            Rule[Editable, False], Rule[Selectable, False]]\)
                   \_2(1 - x)\)\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]
                       \^3\), "+", 
                   \(2\ \(\(\*InterpretationBox["Li", PolyLog, 
                            Rule[Editable, False], Rule[Selectable, False]]\)
                   \_3(1 - x)\)\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]
                       \^3\), "+", 
                   \(2\ \*TagBox[\(\[Zeta](
                          \*TagBox["3", Zeta, Rule[Editable, True]])\), 
                        InterpretTemplate[Function[BoxForm`e$, 
                          Zeta[BoxForm`e$]]]]\ 
                      \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^3\), "-", 
                   \(1\/2\ \(log\^2(1 - x)\)\ 
                      \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^2\), "-", 
                   \(2\ \(\[Zeta](2)\)\ \*TagBox["\[CurlyEpsilon]", 
                         TraditionalForm]\^2\), "+", 
                   \(2\ \(log(1 - x)\)\ \(log(x)\)\ 
                      \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^2\), "+", 
                   \(2\ \(\(\*InterpretationBox["Li", PolyLog, 
                            Rule[Editable, False], Rule[Selectable, False]]\)
                   \_2(1 - x)\)\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]
                       \^2\), "-", 
                   \(\(log(1 - x)\)\ \*TagBox["\[CurlyEpsilon]", 
                        TraditionalForm]\), "+", "1"}], TraditionalForm]], 
               "Output", CellTags -> "Series2"]}, Open]], 
           Cell[TextData[{"There are over 100 more special expansions of ", 
              Cell[BoxData[FormBox[RowBox[{"\[ThinSpace]", RowBox[
                    {SubscriptBox["", "2"], \(F\_1\)}]}], TraditionalForm]]], 
              " tabulated in Series2.m. The interested user can consult the \
source code (search for HYPERLIST)."}], "Text", CellTags -> "Series2"], 
           Cell[BoxData[""], "Input"]}, Open]], Cell["Series3", "ObjectName", 
         CellTags -> "Series3"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Series3"], 
           Cell["Series3 performs a series expansion around 0. Series3 is \
equivalent to Series, except that it applies Normal on the result and that \
some Series bugs are fixed. Series3[f, e, n] is equivalent to  Series3[f, {e, \
0, n}].", "Text", CellTags -> "Series3"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[Series3]\)], "Input", CellTags -> "Series3"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(Factoring \[Rule] True\), 
                      \(FinalSubstitutions \[Rule] \({}\)\)}\)\)], "Output", 
               CellTags -> "Series3"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Series2", RuleDelayed[ButtonData, "Series2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Series2"]]\
, "."}], "Text", CellTags -> "Series3"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Series3"], Cell[CellGroupData[{Cell[BoxData[
                \(Series3[\(\(\((x\ \((1 - x)\))\)^\((\[Delta]/2)\)\), 
                     \[Delta], 1\)]\)], "Input", CellTags -> "Series3"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(1\/2\ \[Delta]\ 
                       \(log(\(\((1 - x)\)\ x\))\)\) + 1\)\)], "Output", 
               CellTags -> "Series3"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(Series3[\(\(Gamma[x]\), x, 1\)]\)//FullSimplify\)], 
               "Input", CellTags -> "Series3"], Cell[BoxData[
                \(TraditionalForm\`\(\(-\*
                        TagBox["\[DoubledGamma]", 
                         Function[List[], EulerGamma]]\) + 1 + 1\/x\)\)], 
               "Output", CellTags -> "Series3"]}, Open]]}, Open]], 
        Cell["SetMandelstam", "ObjectName", CellTags -> "SetMandelstam"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SetMandelstam"], Cell["SetMandelstam[s, t, u, p1, \
p2, p3, p4, m1, m2, m3, m4] defines the Mandelstam variables  s=(p1+p2)^2, \
t=(p1+p3)^2, u=(p1+p4)^2 and sets the momenta on-shell: p1^2=m1^2, p2^2=m2^2, \
p3^2=m3^2, p4^2=m4^2. Notice that p1+p2+p3+p4 = 0 is \
assumed.\nSetMandelstam[x, {p1, p2, p3, p4, p5}, {m1, m2, m3, m4, m5}] \
defines x[i, j] = (pi+pj)^2 and sets the momenta on-shell. p1+p2+p3+p4 = 0 is \
assumed.", "Text", CellTags -> "SetMandelstam"], Cell[CellGroupData[
             {Cell[BoxData[\(Options[SetMandelstam]\)], "Input", CellTags -> 
                "SetMandelstam"], Cell[BoxData[FormBox[RowBox[{"{", 
                   RowBox[{"Dimension", "\[Rule]", RowBox[{"{", RowBox[
                        {"4", ",", "D", ",", FormBox[
                          TagBox[StyleBox["\"\[GothicCapitalD]\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"]}], "}"}]}], "}"}], 
                 TraditionalForm]], "Output", CellTags -> "SetMandelstam"]}, 
             Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Mandelstam", RuleDelayed[ButtonData, "Mandelstam"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Mandelstam"]], "."}], "Text", 
            CellTags -> "SetMandelstam"]}, Open]], 
        Cell["SimplifyDeltaFunction", "ObjectName", CellTags -> 
          "SimplifyDeltaFunction"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "SimplifyDeltaFunction"], Cell["SimplifyDeltaFunction[exp, x] \
simplifies f[x]*DeltaFunction[1-x] toLimit[f[x],x\[Rule]1] DeltaFunction[1-x] \
and applies a list of transformation rules for \
DeltaFunctionPrime[1-x]*x^(OPEm-1)*f[x] where x^(OPEm-1) is suppressed in \
exp.", "Text", CellTags -> "SimplifyDeltaFunction"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DeltaFunction", 
                RuleDelayed[ButtonData, "DeltaFunction"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeltaFunction"]], ", ", 
              ButtonBox["DeltaFunctionPrime", 
                RuleDelayed[ButtonData, "DeltaFunctionPrime"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeltaFunctionPrime"]], "."}], "Text", 
            CellTags -> "SimplifyDeltaFunction"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SimplifyDeltaFunction"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(g[x]\)\ \(DeltaFunction[\(1 - x\)]\)\)], "Input", 
               CellTags -> "SimplifyDeltaFunction"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                      "TraditionalForm"], ")"}], " ", \(g(x)\)}], 
                 TraditionalForm]], "Output", CellTags -> 
                "SimplifyDeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SimplifyDeltaFunction[\ \(%, x\)]\)], "Input", CellTags -> 
                "SimplifyDeltaFunction"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                      "TraditionalForm"], ")"}], " ", 
                   \((lim\+\(x \[Rule] 1\) \[ThinSpace]\(g(x)\))\)}], 
                 TraditionalForm]], "Output", CellTags -> 
                "SimplifyDeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(g[x]\) \(DeltaFunctionPrime[\(1 - x\)]\)\)], "Input", 
               CellTags -> "SimplifyDeltaFunction"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{\(\[Delta]\^\[Prime]\), "(", FormBox[
                      \(1 - x\), "TraditionalForm"], ")"}], " ", \(g(x)\)}], 
                 TraditionalForm]], "Output", CellTags -> 
                "SimplifyDeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SimplifyDeltaFunction[\ \(%, x\)]\)], "Input", CellTags -> 
                "SimplifyDeltaFunction"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{RowBox[{\(\[Delta]\^\[Prime]\), "(", FormBox[
                        \(1 - x\), "TraditionalForm"], ")"}], " ", 
                     \((lim\+\(x \[Rule] 1\) \[ThinSpace]\(g(x)\))\)}], "+", 
                   RowBox[{RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                        "TraditionalForm"], ")"}], " ", 
                     \((lim\+\(x \[Rule] 1\) \[ThinSpace] 
                         \(\*SuperscriptBox["g", "\[Prime]", 
                             Rule[MultilineFunction, None]](x)\))\)}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "SimplifyDeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(x\ \(Log[x]\)\ \(DeltaFunctionPrime[\(1 - x\)]\)\)], 
               "Input", CellTags -> "SimplifyDeltaFunction"], 
              Cell[BoxData[FormBox[RowBox[{"x", " ", RowBox[{
                     \(\[Delta]\^\[Prime]\), "(", FormBox[\(1 - x\), 
                      "TraditionalForm"], ")"}], " ", \(log(x)\)}], 
                 TraditionalForm]], "Output", CellTags -> 
                "SimplifyDeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SimplifyDeltaFunction[\ \(%, x\)]\)], "Input", CellTags -> 
                "SimplifyDeltaFunction"], Cell[BoxData[FormBox[RowBox[
                  {"\[Delta]", "(", FormBox[\(1 - x\), "TraditionalForm"], 
                   ")"}], TraditionalForm]], "Output", CellTags -> 
                "SimplifyDeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(PolyLog[\(2, \(1 - x\)\)]\)\ 
                   \(DeltaFunctionPrime[\(1 - x\)]\)\)], "Input", CellTags -> 
                "SimplifyDeltaFunction"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{\(\[Delta]\^\[Prime]\), "(", FormBox[\(1 - x\), 
                      "TraditionalForm"], ")"}], " ", 
                   \(\(\*InterpretationBox["Li", PolyLog, 
                          Rule[Editable, False], Rule[Selectable, False]]\)\_
                       2(1 - x)\)}], TraditionalForm]], "Output", CellTags -> 
                "SimplifyDeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SimplifyDeltaFunction[\ \(%, x\)]\)], "Input", CellTags -> 
                "SimplifyDeltaFunction"], Cell[BoxData[FormBox[RowBox[
                  {"-", RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                      "TraditionalForm"], ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "SimplifyDeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Log[x]\) \(PolyLog[\(2, \(1 - x\)\)]\)\ 
                   \(DeltaFunctionPrime[\(1 - x\)]\)\)], "Input", CellTags -> 
                "SimplifyDeltaFunction"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{\(\[Delta]\^\[Prime]\), "(", FormBox[\(1 - x\), 
                      "TraditionalForm"], ")"}], " ", \(log(x)\), " ", 
                   \(\(\*InterpretationBox["Li", PolyLog, 
                          Rule[Editable, False], Rule[Selectable, False]]\)\_
                       2(1 - x)\)}], TraditionalForm]], "Output", CellTags -> 
                "SimplifyDeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SimplifyDeltaFunction[\ \(%, x\)]\)], "Input", CellTags -> 
                "SimplifyDeltaFunction"], Cell[BoxData[\(TraditionalForm\`0\)]
                , "Output", CellTags -> "SimplifyDeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(PolyLog[\(3, \(1 - x\)\)]\)\ 
                   \(DeltaFunctionPrime[\(1 - x\)]\)\)], "Input", CellTags -> 
                "SimplifyDeltaFunction"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{\(\[Delta]\^\[Prime]\), "(", FormBox[\(1 - x\), 
                      "TraditionalForm"], ")"}], " ", 
                   \(\(\*InterpretationBox["Li", PolyLog, 
                          Rule[Editable, False], Rule[Selectable, False]]\)\_
                       3(1 - x)\)}], TraditionalForm]], "Output", CellTags -> 
                "SimplifyDeltaFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SimplifyDeltaFunction[\ \(%, x\)]\)], "Input", CellTags -> 
                "SimplifyDeltaFunction"], Cell[BoxData[FormBox[RowBox[
                  {"-", RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                      "TraditionalForm"], ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "SimplifyDeltaFunction"]}, Open]]}, 
          Open]], Cell["SimplifyGTI  ***unfinished***", "ObjectName", 
         CellTags -> "SimplifyGTI"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "SimplifyGTI"], 
           Cell["SimplifyGTI simplifies GTI's.", "Text", CellTags -> 
             "SimplifyGTI"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["GTI", RuleDelayed[ButtonData, "GTI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "GTI"]], 
              "."}], "Text", CellTags -> "SimplifyGTI"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SimplifyGTI"], Cell[BoxData[""], "Input", 
            CellTags -> "SimplifyGTI"]}, Open]], Cell["SimplifyPolyLog", 
         "ObjectName", CellTags -> "SimplifyPolyLog"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SimplifyPolyLog"], Cell["SimplifyPolyLog[y] performs \
several simplifications assuming that the variables occuring in the Log and \
PolyLog functions are between 0 and 1. ", "Text", CellTags -> 
             "SimplifyPolyLog"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Nielsen", RuleDelayed[ButtonData, "Nielsen"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Nielsen"]]\
, "."}], "Text", CellTags -> "SimplifyPolyLog"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SimplifyPolyLog"], Cell[BoxData[
             \(\(sip[y_]\)\ :=\ \(y\ ==\ \(SimplifyPolyLog[y]\)\)\)], 
            "Input", CellTags -> "SimplifyPolyLog"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(PolyLog[\(2, \(1/x\)\)]\)]\)], "Input", CellTags -> 
                "SimplifyPolyLog"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                         \*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(1\/x\))\) \[LongEqual] 
                     \(\(\(-\(1\/2\)\)\ \(\(log\^2\)(x)\)\) + 
                       \(\(log(\(1 - x\))\)\ \(log(x)\)\) + 
                       \(\[ImaginaryI]\ \[Pi]\ \(log(x)\)\) + \(\[Zeta](2)\) 
                       + \(\(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_2(\(1 - x\))\)\)\)\)], "Output", CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(sip[\(PolyLog[\(2, x\)]\)]\)], 
               "Input", CellTags -> "SimplifyPolyLog"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                         \*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(x)\) \[LongEqual] \(\(\[Zeta](2)\) - 
                       \(\(log(\(1 - x\))\)\ \(log(x)\)\) - 
                       \(\(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_2(\(1 - x\))\)\)\)\)], "Output", CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(PolyLog[\(2, \(1 - \(x^2\)\)\)]\)]\)], "Input", 
               CellTags -> "SimplifyPolyLog"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                         \*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(1 - x\^2\))\) \[LongEqual] 
                     \(\(-\(\[Zeta](2)\)\) - 
                       \(2\ \(log(x)\)\ \(log(\(x + 1\))\)\) + 
                       \(2\ \(\(\*InterpretationBox["Li", PolyLog, 
                               Rule[Editable, False], 
                               Rule[Selectable, False]]\)\_2(\(1 - x\))\)\) -
                        \(2\ \(\(\*InterpretationBox["Li", PolyLog, 
                               Rule[Editable, False], 
                               Rule[Selectable, False]]\)\_2(\(-x\))\)\)\)\)\
\)], "Output", CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(PolyLog[\(2, \(x^2\)\)]\)]\)], "Input", CellTags -> 
                "SimplifyPolyLog"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                         \*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(x\^2\))\) \[LongEqual] 
                     \(\(2\ \(\[Zeta](2)\)\) - 
                       \(2\ \(log(\(1 - x\))\)\ \(log(x)\)\) - 
                       \(2\ \(\(\*InterpretationBox["Li", PolyLog, 
                               Rule[Editable, False], 
                               Rule[Selectable, False]]\)\_2(\(1 - x\))\)\) +
                        \(2\ \(\(\*InterpretationBox["Li", PolyLog, 
                               Rule[Editable, False], 
                               Rule[Selectable, False]]\)\_2(\(-x\))\)\)\)\)\
\)], "Output", CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(PolyLog[\(2, \(-\(x/\((1 - x)\)\)\)\)]\)]\)], 
               "Input", CellTags -> "SimplifyPolyLog"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                         \*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(-\(x\/\(1 - x\)\)\))\) \[LongEqual] 
                     \(\(\(-\(1\/2\)\)\ \(\(log\^2\)(\(1 - x\))\)\) + 
                       \(\(log(x)\)\ \(log(\(1 - x\))\)\) - \(\[Zeta](2)\) + 
                       \(\(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_2(\(1 - x\))\)\)\)\)], "Output", CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(PolyLog[\(2, \(x/\((x - 1)\)\)\)]\)]\)], "Input", 
               CellTags -> "SimplifyPolyLog"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                         \*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_2(\(x\/\(x - 1\)\))\) \[LongEqual] 
                     \(\(\(-\(1\/2\)\)\ \(\(log\^2\)(\(1 - x\))\)\) + 
                       \(\(log(x)\)\ \(log(\(1 - x\))\)\) - \(\[Zeta](2)\) + 
                       \(\(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_2(\(1 - x\))\)\)\)\)], "Output", CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(Nielsen[\(1, 2, \(-\(x/\((1 - x)\)\)\)\)]\)]\)], 
               "Input", CellTags -> "SimplifyPolyLog"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{SubscriptBox["S", RowBox[
                       {FormBox["1", "TraditionalForm"], FormBox["2", 
                         "TraditionalForm"]}]], "(", FormBox[
                      \(-\(x\/\(1 - x\)\)\), "TraditionalForm"], ")"}], 
                   "\[LongEqual]", RowBox[{RowBox[{SubscriptBox["S", 
                        RowBox[{FormBox["1", "TraditionalForm"], FormBox["2", 
                          "TraditionalForm"]}]], "(", "x", ")"}], "-", 
                     \(1\/6\ \(log\^3(1 - x)\)\)}]}], TraditionalForm]], 
               "Output", CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(PolyLog[\(3, \(-\(1/x\)\)\)]\)]\)], "Input", 
               CellTags -> "SimplifyPolyLog"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(
                         \*InterpretationBox["Li", PolyLog, 
                           Rule[Editable, False], Rule[Selectable, False]]\)\
\_3(\(-\(1\/x\)\))\) \[LongEqual] 
                     \(\(\(log\^3\)(x)\)\/6 + \(\(\[Zeta](2)\)\ \(log(x)\)\) 
                       + \(\(\*InterpretationBox["Li", PolyLog, 
                             Rule[Editable, False], Rule[Selectable, False]]\
\)\_3(\(-x\))\)\)\)\)], "Output", CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(PolyLog[\(3, \(1 - x\)\)]\)]\)], "Input", CellTags -> 
                "SimplifyPolyLog"], Cell[BoxData[\(TraditionalForm\`True\)], 
               "Output", CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(PolyLog[\(3, \(x^2\)\)]\)]\)], "Input", CellTags -> 
                "SimplifyPolyLog"], Cell[BoxData[FormBox[RowBox[{
                   \(\(\*InterpretationBox["Li", PolyLog, 
                          Rule[Editable, False], Rule[Selectable, False]]\)\_
                       3(x\^2)\), "\[LongEqual]", RowBox[{
                     \(\(-2\)\ \(log(1 - x)\)\ \(log\^2(x)\)\), "+", 
                     \(4\ \(\[Zeta](2)\)\ \(log(x)\)\), "-", 
                     \(4\ \(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                     \)\_2(1 - x)\)\ \(log(x)\)\), "-", RowBox[{"4", " ", 
                       RowBox[{SubscriptBox["S", RowBox[{FormBox["1", 
                          "TraditionalForm"], FormBox["2", 
                          "TraditionalForm"]}]], "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}]}], "+", 
                     \(4\ \(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                     \)\_3(\(-x\))\)\), "+", 
                     \(4\ \*TagBox[\(\[Zeta](
                            \*TagBox["3", Zeta, Rule[Editable, True]])\), 
                          InterpretTemplate[Function[BoxForm`e$, 
                            Zeta[BoxForm`e$]]]]\)}]}], TraditionalForm]], 
               "Output", CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(PolyLog[\(3, \(-\(x/\((1 - x)\)\)\)\)]\)]\)], 
               "Input", CellTags -> "SimplifyPolyLog"], Cell[BoxData[
                FormBox[RowBox[{
                   \(\(\*InterpretationBox["Li", PolyLog, 
                          Rule[Editable, False], Rule[Selectable, False]]\)\_
                       3(\(-\(x\/\(1 - x\)\)\))\), "\[LongEqual]", RowBox[{
                     \(1\/6\ \(log\^3(1 - x)\)\), "-", 
                     \(1\/2\ \(log(x)\)\ \(log\^2(1 - x)\)\), "+", 
                     \(1\/2\ \(log\^2(x)\)\ \(log(1 - x)\)\), "+", 
                     \(\(\[Zeta](2)\)\ \(log(1 - x)\)\), "-", 
                     \(\(\[Zeta](2)\)\ \(log(x)\)\), "+", RowBox[
                      {SubscriptBox["S", RowBox[{FormBox["1", 
                          "TraditionalForm"], FormBox["2", 
                          "TraditionalForm"]}]], "(", FormBox[\(1 - x\), 
                        "TraditionalForm"], ")"}], "+", 
                     \(\(log(x)\)\ \(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                     \)\_2(1 - x)\)\), "-", 
                     \(\(\*InterpretationBox["Li", PolyLog, 
                            Rule[Editable, False], Rule[Selectable, False]]\)
                     \_3(1 - x)\)}]}], TraditionalForm]], "Output", 
               CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(PolyLog[\(3, \(1 - \(1/x\)\)\)]\)]\)], "Input", 
               CellTags -> "SimplifyPolyLog"], Cell[BoxData[FormBox[RowBox[{
                   \(\(\*InterpretationBox["Li", PolyLog, 
                          Rule[Editable, False], Rule[Selectable, False]]\)\_
                       3(1 - 1\/x)\), "\[LongEqual]", RowBox[{
                     \(\(log\^3(x)\)\/6\), "-", 
                     \(1\/2\ \(log\^2(1 - x)\)\ \(log(x)\)\), "+", 
                     \(\(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                     \)\_2(1 - x)\)\ \(log(x)\)\), "+", RowBox[{SubscriptBox[
                        "S", RowBox[{FormBox["1", "TraditionalForm"], 
                          FormBox["2", "TraditionalForm"]}]], "(", FormBox[
                        \(1 - x\), "TraditionalForm"], ")"}], "+", RowBox[
                      {SubscriptBox["S", RowBox[{FormBox["1", 
                          "TraditionalForm"], FormBox["2", 
                          "TraditionalForm"]}]], "(", "x", ")"}], "-", 
                     \(\(log(1 - x)\)\ \(\(\*
                             InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                     \)\_2(1 - x)\)\), "-", 
                     TagBox[\(\[Zeta](\*TagBox["3", Zeta, 
                           Rule[Editable, True]])\), 
                       InterpretTemplate[Function[BoxForm`e$, 
                         Zeta[BoxForm`e$]]]]}]}], TraditionalForm]], 
               "Output", CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(PolyLog[\(4, \(-\(x/\((1 - x)\)\)\)\)]\)]\)], 
               "Input", CellTags -> "SimplifyPolyLog"], Cell[BoxData[
                FormBox[RowBox[{
                   \(\(\*InterpretationBox["Li", PolyLog, 
                          Rule[Editable, False], Rule[Selectable, False]]\)\_
                       4(\(-\(x\/\(1 - x\)\)\))\), "\[LongEqual]", RowBox[{
                     \(\(-\(1\/24\)\)\ \(log\^4(1 - x)\)\), "+", 
                     \(1\/2\ \(log(x)\)\ \(log\^3(1 - x)\)\), "-", 
                     \(1\/2\ \(log\^2(x)\)\ \(log\^2(1 - x)\)\), "-", 
                     \(1\/2\ \(\[Zeta](2)\)\ \(log\^2(1 - x)\)\), "+", 
                     \(1\/2\ \(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                     \)\_2(1 - x)\)\ \(log\^2(1 - x)\)\), "+", 
                     \(\(\[Zeta](2)\)\ \(log(x)\)\ \(log(1 - x)\)\), "-", 
                     RowBox[{RowBox[{SubscriptBox["S", RowBox[{FormBox["1", 
                          "TraditionalForm"], FormBox["2", 
                          "TraditionalForm"]}]], "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}], " ", \(log(1 - x)\)}], 
                     "-", RowBox[{RowBox[{SubscriptBox["S", RowBox[
                          {FormBox["1", "TraditionalForm"], FormBox["2", 
                          "TraditionalForm"]}]], "(", "x", ")"}], " ", 
                       \(log(1 - x)\)}], "-", 
                     \(\(log(x)\)\ \(\(\*InterpretationBox["Li", PolyLog, 
                              Rule[Editable, False], Rule[Selectable, False]]
                     \)\_2(1 - x)\)\ \(log(1 - x)\)\), "+", 
                     \(\*TagBox[\(\[Zeta](\*
                             TagBox["3", Zeta, Rule[Editable, True]])\), 
                          InterpretTemplate[Function[BoxForm`e$, 
                            Zeta[BoxForm`e$]]]]\ \(log(1 - x)\)\), "-", 
                     RowBox[{SubscriptBox["S", RowBox[{FormBox["1", 
                          "TraditionalForm"], FormBox["3", 
                          "TraditionalForm"]}]], "(", "x", ")"}], "+", 
                     RowBox[{SubscriptBox["S", RowBox[{FormBox["2", 
                          "TraditionalForm"], FormBox["2", 
                          "TraditionalForm"]}]], "(", "x", ")"}], "-", 
                     \(\(\*InterpretationBox["Li", PolyLog, 
                            Rule[Editable, False], Rule[Selectable, False]]\)
                     \_4(x)\)}]}], TraditionalForm]], "Output", CellTags -> 
                "SimplifyPolyLog"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(Log[\(a + \(b/c\)\)]\)]\)], "Input", CellTags -> 
                "SimplifyPolyLog"], Cell[BoxData[
                \(TraditionalForm\`\(\(log(\(a + b\/c\))\) \[LongEqual] 
                     \(log(\(\(b + \(a\ c\)\)\/c\))\)\)\)], "Output", 
               CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(sip[\(Log[\(1/x\)]\)]\)], 
               "Input", CellTags -> "SimplifyPolyLog"], Cell[BoxData[
                \(TraditionalForm\`\(\(log(\(1\/x\))\) \[LongEqual] 
                     \(-\(log(x)\)\)\)\)], "Output", CellTags -> 
                "SimplifyPolyLog"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(sip[\(ArcTanh[x]\)]\)], "Input", CellTags -> 
                "SimplifyPolyLog"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(tanh\^\(-1\)\)(x)\) \[LongEqual] 
                     \(1\/2\ \(log(\(-\(\(x + 1\)\/\(1 - x\)\)\))\)\)\)\)], 
               "Output", CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(sip[\(ArcSinh[x]\)]\)], 
               "Input", CellTags -> "SimplifyPolyLog"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(sinh\^\(-1\)\)(x)\) \[LongEqual] 
                     \(log(\(x + \@\(x\^2 + 1\)\))\)\)\)], "Output", 
               CellTags -> "SimplifyPolyLog"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(sip[\(ArcCosh[x]\)]\)], 
               "Input", CellTags -> "SimplifyPolyLog"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(cosh\^\(-1\)\)(x)\) \[LongEqual] 
                     \(log(\(x + \@\(x\^2 - 1\)\))\)\)\)], "Output", 
               CellTags -> "SimplifyPolyLog"]}, Open]], Cell[BoxData[
             \(Clear[sip]\)], "Input", CellTags -> "SimplifyPolyLog"]}, 
          Open]], Cell["Simplify2  ***unfinished*** (examples missing)", 
         "ObjectName", CellTags -> "Simplify2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Simplify2"], Cell["Simplify2[exp] does some ordering \
on the expression exp with respect to Log, PlusDistribution, PolyLog, Zeta2, \
Epsilon and Deltafunction.", "Text", CellTags -> "Simplify2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Simplify2"], Cell[BoxData[""], "Input", 
            CellTags -> "Simplify2"]}, Open]], Cell["SmallDelta", 
         "ObjectName", CellTags -> "SmallDelta"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SmallDelta"], 
           Cell["SmallDelta denotes some small positive number.", "Text", 
            CellTags -> "SmallDelta"], Cell[CellGroupData[
             {Cell[BoxData["SmallDelta"], "Input"], Cell[BoxData[
                \(TraditionalForm\`\[Delta]\)], "Output"]}, Open]]}, Open]], 
        Cell["SmallEpsilon", "ObjectName", CellTags -> "SmallEpsilon"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SmallEpsilon"], 
           Cell["SmallEpsilon denotes some small positive number.", "Text", 
            CellTags -> "SmallEpsilon"], Cell[CellGroupData[
             {Cell[BoxData["SmallEpsilon"], "Input"], Cell[BoxData[
                \(TraditionalForm\`\[Epsilon]\)], "Output"]}, Open]]}, 
          Open]], Cell["SmallVariable", "ObjectName", 
         CellTags -> "SmallVariable"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "SmallVariable"], 
           Cell["SmallVariable[me] is the head of small (negligible) \
variables. This means any mass with this head can be neglected if it appears \
in a sum, but not as an argument of Passarino-Veltman (PaVe) functions or \
PropagatorDenominator.", "Text", CellTags -> "SmallVariable"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["PaVe", RuleDelayed[ButtonData, "PaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "PaVe"]], 
              ", ", 
              ButtonBox["PaVeReduce", RuleDelayed[ButtonData, "PaVeReduce"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeReduce"]], ", ", 
              ButtonBox["PropagatorDenominator", 
                RuleDelayed[ButtonData, "PropagatorDenominator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PropagatorDenominator"]], "."}], "Text", 
            CellTags -> "SmallVariable"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["SmallVariables", "ObjectName", 
         CellTags -> "SmallVariables"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "SmallVariables"], Cell["SmallVariables is an option for \
OneLoop. \"SmallVariables\[Rule]{Melectron}\" i.e. will substitute \
\"SmallVariable[Melectron]\"  for all Melectron's in the calculation.", 
            "Text", CellTags -> "SmallVariables"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, "."}], "Text", CellTags -> "SmallVariables"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["SMP", "ObjectName", CellTags -> "SMP"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SMP"], Cell["SMP[par] substitutes a symbol for the  \
Standard Model parameter par.  SMP[] gives the list of substitutions. par \
should be a string; e.g., SMP[\"SW\"] gives  sw (in the Global` context).", 
            "Text", CellTags -> "SMP"], Cell[CellGroupData[{Cell[BoxData[
                \(\(SMP[]\)//InputForm\)], "Input", CellTags -> "SMP"], 
              Cell["{\"EL\" :> e, \"CW\" :> cw, \"ME\" :> me, \"MH\" :> mh, \
\"MW\" :> mw, \"SW\" :> sw}", "Output", CellTags -> "SMP"]}, Open]], 
           Cell[TextData[{"See also: ", 
              ButtonBox["SMVertex", RuleDelayed[ButtonData, "SMVertex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SMVertex"]], "."}], "Text", 
            CellTags -> "SMP"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "SMP"], 
           Cell[CellGroupData[{Cell[BoxData[\(SMP["ME"]\)], "Input", 
               CellTags -> "SMP"], Cell[BoxData[\(TraditionalForm\`me\)], 
               "Output", CellTags -> "SMP"]}, Open]]}, Open]], 
        Cell["SMVertex", "ObjectName", CellTags -> "SMVertex"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SMVertex"], Cell["SMVertex[\"AWW\", p,mu, q,nu, \
k,rho] gives the photon-W-W vertex (p,mu correspond to the photon, q,nu to \
the (incoming) W+ and k,rho to the (incoming) W-. All momenta are flowing \
into the vertex.  SMVertex[\"HHH\", ___] give the three-higgs coupling. ", 
            "Text", CellTags -> "SMVertex"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[SMVertex]\)], "Input", CellTags -> "SMVertex"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] 4\), 
                      \(Explicit \[Rule] True\)}\)\)], "Output", CellTags -> 
                "SMVertex"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SMVertex"], Cell[CellGroupData[{Cell[BoxData[
                \(SMVertex[\("AWW", p, \[Mu],\ q, \[Nu],\ k, \[Rho]\)]\)], 
               "Input", CellTags -> "SMVertex"], Cell[BoxData[FormBox[RowBox[{
                   \(-\[ImaginaryI]\), " ", "e", " ", RowBox[{"(", RowBox[
                      {RowBox[{SuperscriptBox[RowBox[{"(", FormBox[RowBox[
                          {FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "q"}], "TraditionalForm"], 
                          ")"}], FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(\[Nu]\[Rho]\)\)}], 
                       "-", RowBox[{\(g\^\(\[Mu]\[Rho]\)\), " ", 
                         SuperscriptBox[RowBox[{"(", FormBox[RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "p"}], "TraditionalForm"], 
                          ")"}], FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{
                         \(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[RowBox[
                          {"(", FormBox[\(p - q\), "TraditionalForm"], ")"}], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "SMVertex"]}, 
             Open]]}, Open]], 
        Cell["Smu  ***unfinished*** (and usage definition missing)", 
         "ObjectName", CellTags -> "Smu"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Smu"], Cell["Smu  is ...", "Text", 
            CellTags -> "Smu"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["Sn", "ObjectName", CellTags -> "Sn"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Sn"], Cell[TextData[{"Sn is ", Cell[BoxData[
                \(TraditionalForm\`\(\[Pi]\^\(n/2\)\)\)]], "/", Cell[BoxData[
                \(TraditionalForm\`\(\((2\ \[Pi])\)\^n\)\)]], "."}], "Text", 
            CellTags -> "Sn"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["SO", "ObjectName", CellTags -> "SO"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SO"], Cell["SO[q] is a four-dimensional scalar \
product of OPEDelta with q. It is transformed into Pair[Momentum[q], \
Momentum[OPEDelta] by FCI.", "Text", CellTags -> "SO"], 
           Cell[TextData[{"See also: ", 
              ButtonBox["FCI", RuleDelayed[ButtonData, "FCI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FCI"]], 
              ", ", 
              ButtonBox["OPEDelta", RuleDelayed[ButtonData, "OPEDelta"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OPEDelta"]], ", ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              ", ", 
              ButtonBox["ScalarProduct", 
                RuleDelayed[ButtonData, "ScalarProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ScalarProduct"]], ", ", 
              ButtonBox["SOD", RuleDelayed[ButtonData, "SOD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SOD"]], 
              "."}], "Text", CellTags -> "SO"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SO"], Cell[CellGroupData[{Cell[BoxData[\(SO[p]\)], 
               "Input", CellTags -> "SO"], Cell[BoxData[FormBox[
                 RowBox[{FormBox["\"\[CapitalDelta]\"", "TraditionalForm"], 
                   FormBox["\"\[CenterDot]\"", "TraditionalForm"], 
                   FormBox["p", "TraditionalForm"]}], TraditionalForm]], 
               "Output", CellTags -> "SO"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SO[\(p - q\)]\)], "Input", 
               CellTags -> "SO"], Cell[BoxData[FormBox[RowBox[
                  {FormBox["\"\[CapitalDelta]\"", "TraditionalForm"], 
                   FormBox["\"\[CenterDot]\"", "TraditionalForm"], 
                   FormBox["\"(\"", "TraditionalForm"], FormBox[\(p - q\), 
                    "TraditionalForm"], FormBox["\")\"", 
                    "TraditionalForm"]}], TraditionalForm]], "Output", 
               CellTags -> "SO"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SO[p]\)//FCI\)//StandardForm\)], "Input", CellTags -> 
                "SO"], Cell[BoxData[
                \(Pair[\(\(Momentum[OPEDelta]\), \(Momentum[p]\)\)]\)], 
               "Output", CellTags -> "SO"]}, Open]]}, Open]], 
        Cell["SOD", "ObjectName", CellTags -> "SOD"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SOD"], Cell["SOD[q] is a D-dimensional scalar \
product of OPEDelta with q. It is transformed into Pair[Momentum[q,D], \
Momentum[OPEDelta,D] by FeynCalcInternal.", "Text", CellTags -> "SOD"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["OPEDelta", RuleDelayed[ButtonData, "OPEDelta"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OPEDelta"]], ", ", 
              ButtonBox["Pair", RuleDelayed[ButtonData, "Pair"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Pair"]], 
              ", ", 
              ButtonBox["ScalarProduct", 
                RuleDelayed[ButtonData, "ScalarProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ScalarProduct"]], ", ", 
              ButtonBox["SOD", RuleDelayed[ButtonData, "SOD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SOD"]], 
              "."}], "Text", CellTags -> "SOD"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SOD"], Cell[CellGroupData[{Cell[BoxData[\(SOD[p]\)], 
               "Input", CellTags -> "SOD"], Cell[BoxData[FormBox[
                 RowBox[{FormBox["\"\[CapitalDelta]\"", "TraditionalForm"], 
                   FormBox["\"\[CenterDot]\"", "TraditionalForm"], 
                   FormBox["p", "TraditionalForm"]}], TraditionalForm]], 
               "Output", CellTags -> "SOD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SOD[\(p - q\)]\)], "Input", 
               CellTags -> "SOD"], Cell[BoxData[FormBox[RowBox[
                  {FormBox["\"\[CapitalDelta]\"", "TraditionalForm"], 
                   FormBox["\"\[CenterDot]\"", "TraditionalForm"], 
                   FormBox["\"(\"", "TraditionalForm"], FormBox[\(p - q\), 
                    "TraditionalForm"], FormBox["\")\"", 
                    "TraditionalForm"]}], TraditionalForm]], "Output", 
               CellTags -> "SOD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SOD[p]\)//FCI\)//StandardForm\)], "Input", CellTags -> 
                "SOD"], Cell[BoxData[
                \(Pair[\(\(Momentum[\(OPEDelta, D\)]\), 
                     \(Momentum[\(p, D\)]\)\)]\)], "Output", CellTags -> 
                "SOD"]}, Open]]}, Open]], Cell["Solve2", "ObjectName", 
         CellTags -> "Solve2"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Solve2"], 
           Cell["Solve2 is equivalent to Solve, except that it works only for \
linear equations (and returns just a list) and accepts the options Factoring \
and FinalSubstitutions. Solve2 uses the \"high school algorithm\" and factors \
intermediate results. Therefore it can be drastically more useful than \
Solve.", "Text", CellTags -> "Solve2"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[Solve2]\)], "Input", CellTags -> "Solve2"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(Factoring \[Rule] Factor2\), 
                      \(FinalSubstitutions \[Rule] \({}\)\)}\)\)], "Output", 
               CellTags -> "Solve2"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Solve2"], Cell[CellGroupData[{Cell[BoxData[
                \(Solve2[\(\({\(\(2\ x\) == \(b - \(w/2\)\)\), 
                        \(\(y - d\) == p\)}\), \({x, y}\)\)]\)], "Input", 
               CellTags -> "Solve2"], Cell[BoxData[
                \(TraditionalForm\`\({\(x \[Rule] 
                        \(1\/4\ \((\(2\ b\) - w)\)\)\), 
                      \(y \[Rule] \(d + p\)\)}\)\)], "Output", CellTags -> 
                "Solve2"]}, Open]], Cell["If no equation sign is given the \
polynomials are supposed to be 0.", "Text", CellTags -> "Solve2"], 
           Cell[CellGroupData[{Cell[BoxData[\(Solve2[\(\(x + y\), x\)]\)], 
               "Input", CellTags -> "Solve2"], Cell[BoxData[
                \(TraditionalForm\`\({x \[Rule] \(-y\)}\)\)], "Output", 
               CellTags -> "Solve2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Solve2[\(\(x + y\), x, 
                     \(FinalSubstitutions \[Rule] \({y \[Rule] h}\)\)\)]\)], 
               "Input", CellTags -> "Solve2"], Cell[BoxData[
                \(TraditionalForm\`\({x \[Rule] \(-h\)}\)\)], "Output", 
               CellTags -> "Solve2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Solve2[\(\({\(\(2\ x\) == \(b - \(w/2\)\)\), 
                        \(\(y - d\) == p\)}\), \({x, y}\), 
                     \(Factoring \[Rule] Expand\)\)]\)], "Input", CellTags -> 
                "Solve2"], Cell[BoxData[
                \(TraditionalForm\`\({\(x \[Rule] \(b\/2 - w\/4\)\), 
                      \(y \[Rule] \(d + p\)\)}\)\)], "Output", CellTags -> 
                "Solve2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Solve[\(\({\(\(2\ x\) == \(b - \(w/2\)\)\), 
                        \(\(y - d\) == p\)}\), \({x, y}\)\)]\)], "Input", 
               CellTags -> "Solve2"], Cell[BoxData[
                \(TraditionalForm\`\({\({
                       \(x \[Rule] \(1\/4\ \((\(2\ b\) - w)\)\)\), 
                        \(y \[Rule] \(d + p\)\)}\)}\)\)], "Output", 
               CellTags -> "Solve2"]}, Open]]}, Open]], 
        Cell["Solve3", "ObjectName", CellTags -> "Solve3"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Solve3"], Cell["Solve3 is equivalent to Solve, \
except that it works only for linear equations (and returns just a list) and \
uses the \"high school algorithm\" and is sometimes better than Solve for \
systems involving rational polyonomials.", "Text", CellTags -> "Solve3"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[Solve3]\)], "Input", 
               CellTags -> "Solve3"], Cell[BoxData[
                \(TraditionalForm\`\({\(Factoring \[Rule] False\), 
                      \(FinalSubstitutions \[Rule] \({}\)\)}\)\)], "Output", 
               CellTags -> "Solve3"]}, Open]], Cell[TextData[{"See also: ", 
              ButtonBox["Solve2", RuleDelayed[ButtonData, "Solve2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Solve2"]], 
              "."}], "Text", CellTags -> "SMP"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Solve3"], Cell[CellGroupData[{Cell[BoxData[
                \(Solve3[\(\({\(\(2\ x\) == \(b - \(w/2\)\)\), 
                        \(\(y - d\) == p\)}\), \({x, y}\)\)]\)], "Input", 
               CellTags -> "Solve3"], Cell[BoxData[
                \(TraditionalForm\`\({\(x \[Rule] 
                        \(1\/4\ \((\(2\ b\) - w)\)\)\), 
                      \(y \[Rule] \(d + p\)\)}\)\)], "Output", CellTags -> 
                "Solve3"]}, Open]]}, Open]], Cell["SP", "ObjectName", 
         CellTags -> "SP"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "SP"], 
           Cell[TextData[{"SP[a, b] denotes a four-dimensional scalar \
product. SP[a, b] is transformed into ScalarProduct[a, b] by \
FeynCalcInternal. SP[p] is the same as SP[p, p] ", Cell[BoxData[
                \(TraditionalForm\`\((\(= p\^2\)\)\)]], ")."}], "Text", 
            CellTags -> "SP"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Calc", RuleDelayed[ButtonData, "Calc"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Calc"]], 
              ", ", 
              ButtonBox["ExpandScalarProduct", 
                RuleDelayed[ButtonData, "ExpandScalarProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandScalarProduct"]], ", ", 
              ButtonBox["ScalarProduct", 
                RuleDelayed[ButtonData, "ScalarProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ScalarProduct"]], "."}], "Text", 
            CellTags -> "SP"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "SP"], 
           Cell[CellGroupData[{Cell[BoxData[\(\(SP[\(p, q\)]\)\ +\ \(SP[q]\)\)
                ], "Input", CellTags -> "SP"], Cell[BoxData[FormBox[
                 RowBox[{FormBox[RowBox[{FormBox["p", "TraditionalForm"], 
                      "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                    "TraditionalForm"], "+", FormBox[SuperscriptBox[
                     FormBox["q", "TraditionalForm"], "2"], 
                    "TraditionalForm"]}], TraditionalForm]], "Output", 
               CellTags -> "SP"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SP[\(\(p - q\), \(q + \(2p\)\)\)]\)], "Input", CellTags -> 
                "SP"], Cell[BoxData[FormBox[RowBox[{"(", FormBox[\(p - q\), 
                    "TraditionalForm"], ")", "\[CenterDot]", "(", FormBox[
                    \(\(2\ p\) + q\), "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> "SP"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Calc[\ \(SP[\(\(p - q\), \(q + \(2p\)\)\)]\)\ ]\)], 
               "Input", CellTags -> "SP"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{"2", " ", SuperscriptBox[FormBox["p", 
                       "TraditionalForm"], "2"]}], "-", RowBox[{FormBox["p", 
                      "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                      "TraditionalForm"]}], "-", SuperscriptBox[FormBox["q", 
                     "TraditionalForm"], "2"]}], TraditionalForm]], "Output", 
               CellTags -> "SP"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ExpandScalarProduct[\(SP[\(p - q\)]\)]\)], "Input", 
               CellTags -> "SP"], Cell[BoxData[FormBox[SuperscriptBox[
                  RowBox[{"(", FormBox[\(p - q\), "TraditionalForm"], ")"}], 
                  "2"], TraditionalForm]], "Output", CellTags -> "SP"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(SP[\(a, b\)]\)//StandardForm\)], "Input", CellTags -> 
                "SP"], Cell[BoxData[\(SP[\(a, b\)]\)], "Output", CellTags -> 
                "SP"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SP[\(a, b\)]\)//FCI\)//StandardForm\)], "Input", 
               CellTags -> "SP"], Cell[BoxData[
                \(Pair[\(\(Momentum[a]\), \(Momentum[b]\)\)]\)], "Output", 
               CellTags -> "SP"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(SP[\(a, b\)]\)//FCI\)//FCE\)//StandardForm\)], 
               "Input", CellTags -> "SP"], Cell[BoxData[\(SP[\(a, b\)]\)], 
               "Output", CellTags -> "SP"]}, Open]]}, Open]], 
        Cell["SPC", "ObjectName", CellTags -> "SPC"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SPC"], Cell[
            "SPC is an abbreviation for ScalarProductCancel.", "Text", 
            CellTags -> "SPC"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["ScalarProductCancel", 
                RuleDelayed[ButtonData, "ScalarProductCancel"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ScalarProductCancel"]], "."}], "Text", 
            CellTags -> "SPC"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["SPD", "ObjectName", CellTags -> "SPD"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SPD"], Cell[TextData[{"SPD[a, b] denotes a \
D-dimensional scalar product. SPD[a, b] is transformed into ScalarProduct[a, \
b,Dimension\[Rule]D] by FeynCalcInternal. SPD[p] is the same as SPD[p,p] ", 
              Cell[BoxData[\(TraditionalForm\`\((\(= p\^2\)\)\)]], ")."}], 
            "Text", CellTags -> "SPD"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["PD", RuleDelayed[ButtonData, "PD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "PD"]], 
              ", ", 
              ButtonBox["Calc", RuleDelayed[ButtonData, "Calc"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Calc"]], 
              ", ", 
              ButtonBox["ExpandScalarProduct", 
                RuleDelayed[ButtonData, "ExpandScalarProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExpandScalarProduct"]], ", ", 
              ButtonBox["ScalarProduct", 
                RuleDelayed[ButtonData, "ScalarProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ScalarProduct"]], "."}], "Text", 
            CellTags -> "SPD"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "SPD"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SPD[\(p, q\)]\)\ +\ \(SPD[q]\)\)], "Input", CellTags -> 
                "SPD"], Cell[BoxData[FormBox[RowBox[{FormBox[RowBox[
                     {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                      FormBox["q", "TraditionalForm"]}], "TraditionalForm"], 
                   "+", FormBox[SuperscriptBox[FormBox["q", 
                      "TraditionalForm"], "2"], "TraditionalForm"]}], 
                 TraditionalForm]], "Output", CellTags -> "SPD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SPD[\(\(p - q\), \(q + \(2p\)\)\)]\)], "Input", CellTags -> 
                "SPD"], Cell[BoxData[FormBox[RowBox[{"(", FormBox[\(p - q\), 
                    "TraditionalForm"], ")", "\[CenterDot]", "(", FormBox[
                    \(\(2\ p\) + q\), "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> "SPD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Calc[\ \(SPD[\(\(p - q\), \(q + \(2p\)\)\)]\)\ ]\)], 
               "Input", CellTags -> "SPD"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{"2", " ", SuperscriptBox[FormBox["p", 
                       "TraditionalForm"], "2"]}], "-", RowBox[{FormBox["p", 
                      "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                      "TraditionalForm"]}], "-", SuperscriptBox[FormBox["q", 
                     "TraditionalForm"], "2"]}], TraditionalForm]], "Output", 
               CellTags -> "SPD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ExpandScalarProduct[\(SPD[\(p - q\)]\)]\)], "Input", 
               CellTags -> "SPD"], Cell[BoxData[FormBox[SuperscriptBox[
                  RowBox[{"(", FormBox[\(p - q\), "TraditionalForm"], ")"}], 
                  "2"], TraditionalForm]], "Output", CellTags -> "SPD"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(SPD[\(a, b\)]\)//StandardForm\)], "Input", CellTags -> 
                "SPD"], Cell[BoxData[\(SPD[\(a, b\)]\)], "Output", 
               CellTags -> "SPD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SPD[\(a, b\)]\)//FCI\)//StandardForm\)], "Input", 
               CellTags -> "SPD"], Cell[BoxData[
                \(Pair[\(\(Momentum[\(a, D\)]\), \(Momentum[\(b, D\)]\)\)]\)]\
, "Output", CellTags -> "SPD"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(SPD[\(a, b\)]\)//FCI\)//FCE\)//StandardForm\)], 
               "Input", CellTags -> "SPD"], Cell[BoxData[\(SPD[\(a, b\)]\)], 
               "Output", CellTags -> "SPD"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(FCE[\(ChangeDimension[\(\(SP[\(p, q\)]\),\ D\)]\)]\)//
                   StandardForm\)], "Input", CellTags -> "SPD"], Cell[BoxData[
                \(SPD[\(p, q\)]\)], "Output", CellTags -> "SPD"]}, Open]]}, 
          Open]], Cell["Spinor", "ObjectName", CellTags -> "Spinor"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Spinor"], Cell[TextData[{"Spinor[p, m, o] is the \
head of Dirac spinors. Which of the spinors ", 
              StyleBox["u", Rule[FontSlant, "Italic"]], ", ", 
              StyleBox["v", Rule[FontSlant, "Italic"]], ", ", Cell[BoxData[
                \(TraditionalForm\`u\&_\)]], " ", Cell[BoxData[
                \(TraditionalForm\`\(,\ \)\)]], "or ", Cell[BoxData[
                \(TraditionalForm\`v\&\(_\ \)\)]], "is understood, depends on \
the sign of the momentum (p) argument and the relative position of \
DiracSlash[p]: Spinor[sign p, mass] is that spinor which yields: \
sign*mass*Spinor[p, mass] if the Dirac equation is applied (by DiracEquation \
or DiracSimplify).\nThe optional argument o can be used for additional \
degrees of freedom. If no optional argument o is supplied, a 1 is subsituted \
in.\nSpinors of fermions of mass ", StyleBox["m", Rule[FontSlant, "Italic"]], 
              " are normalized to have square ", Cell[BoxData[
                \(TraditionalForm\`u\&_\)]], 
              StyleBox["u", Rule[FontSlant, "Italic"]], "=2 ", 
              StyleBox["m", Rule[FontSlant, "Italic"]], " and  ", 
              Cell[BoxData[\(TraditionalForm\`v\&\(_\ \)\)]], 
              StyleBox["v=", Rule[FontSlant, "Italic"]], "-2 ", 
              StyleBox["m", Rule[FontSlant, "Italic"]], "."}], "Text", 
            CellTags -> "Spinor"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FermionSpinSum", 
                RuleDelayed[ButtonData, "FermionSpinSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FermionSpinSum"]], ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["SpinorU", RuleDelayed[ButtonData, "SpinorU"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SpinorU"]]\
, ", ", 
              ButtonBox["SpinorV", RuleDelayed[ButtonData, "SpinorV"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SpinorV"]]\
, ", ", 
              ButtonBox["SpinorUBar", RuleDelayed[ButtonData, "SpinorUBar"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SpinorUBar"]], ", ", 
              ButtonBox["SpinorVBar", RuleDelayed[ButtonData, "SpinorVBar"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SpinorVBar"]], "."}], "Text", 
            CellTags -> "Spinor"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Spinor"], Cell[CellGroupData[{Cell[BoxData[
                \(Spinor[p]\)], "Input", CellTags -> "Spinor"], 
              Cell[BoxData[FormBox[RowBox[{"\[CurlyPhi]", "(", FormBox["p", 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "Spinor"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Spinor[\(p, m\)]\)], "Input", CellTags -> 
                "Spinor"], Cell[BoxData[FormBox[RowBox[{"\[CurlyPhi]", "(", 
                   FormBox["p", "TraditionalForm"], ",", "m", ")"}], 
                 TraditionalForm]], "Output", CellTags -> "Spinor"]}, Open]], 
           Cell["FeynCalc uses covariant normalization (as opposed to e.g. \
the normalization used in Bjorken&Drell).", "Text", CellTags -> "Spinor"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(Spinor[\(p, m\)]\) . \(Spinor[\(p, m\)]\)\)//
                   DiracSimplify\)], "Input", CellTags -> "Spinor"], 
              Cell[BoxData[\(TraditionalForm\`\(2\ m\)\)], "Output", 
               CellTags -> "Spinor"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(DiracSimplify[\(\(Spinor[\(\(-p\), m\)]\) . 
                     \(DiracSlash[p]\)\)]\)], "Input", CellTags -> "Spinor"], 
              Cell[BoxData[FormBox[RowBox[{\(-m\), " ", RowBox[
                    {"\[CurlyPhi]", "(", FormBox[\(-p\), "TraditionalForm"], 
                     ",", "m", ")"}]}], TraditionalForm]], "Output", 
               CellTags -> "Spinor"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(\(Spinor[p]\)//StandardForm\)], "Input", 
               CellTags -> "Spinor"], Cell[BoxData[
                \(Spinor[\(\(Momentum[p]\), 0, 1\)]\)], "Output", CellTags -> 
                "Spinor"]}, Open]], Cell["By convention, ChangeDimension does \
not operate on momenta in Spinor's (but on e.g.  DiracSlash[Momentum[p]]). ", 
            "Text", CellTags -> "Spinor"], Cell[CellGroupData[{Cell[BoxData[
                \(\(ChangeDimension[\(\(Spinor[p]\), D\)]\)//StandardForm\)], 
               "Input", CellTags -> "Spinor"], Cell[BoxData[
                \(Spinor[\(\(Momentum[p]\), 0, 1\)]\)], "Output", CellTags -> 
                "Spinor"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(Spinor[\(p, m\)]\)//StandardForm\)], "Input", CellTags -> 
                "Spinor"], Cell[BoxData[\(Spinor[\(\(Momentum[p]\), m, 1\)]\)]
                , "Output", CellTags -> "Spinor"]}, Open]], 
           Cell["SmallVariable's are discarded by Spinor.", "Text", 
            CellTags -> "Spinor"], Cell[CellGroupData[{Cell[BoxData[
                \(\(Spinor[\(p, \(SmallVariable[m]\)\)]\)//StandardForm\)], 
               "Input", CellTags -> "Spinor"], Cell[BoxData[
                \(Spinor[\(\(Momentum[p]\), 0, 1\)]\)], "Output", CellTags -> 
                "Spinor"]}, Open]]}, Open]], Cell["SpinorCollect", 
         "ObjectName", CellTags -> "SpinorCollect"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SpinorCollect"], Cell["SpinorCollect is an option \
for FermionSpinSum. If set to False the  argument of FermionSpinSum has to be \
already collected w.r.t. Spinor.", "Text", CellTags -> "SpinorCollect"], 
           Cell[TextData[{"See also:  ", 
              ButtonBox["FermionSpinSum", 
                RuleDelayed[ButtonData, "FermionSpinSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FermionSpinSum"]], ", ", 
              ButtonBox["Spinor", RuleDelayed[ButtonData, "Spinor"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Spinor"]], 
              "."}], "Text", CellTags -> "SpinorCollect"], 
           Cell[BoxData[""], "Input"]}, Open]], Cell["SpinorUBar", 
         "ObjectName", CellTags -> "SpinorUBar"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SpinorUBar"], Cell[TextData[
             {"SpinorUBar[p, m] denotes a ", Cell[BoxData[
                \(TraditionalForm\`u\&_\)]], "-spinor."}], "Text", 
            CellTags -> "SpinorUBar"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Spinor", RuleDelayed[ButtonData, "Spinor"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Spinor"]], 
              ", ", 
              ButtonBox["SpinorU", RuleDelayed[ButtonData, "SpinorU"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SpinorU"]]\
, ", ", 
              ButtonBox["SpinorV", RuleDelayed[ButtonData, "SpinorV"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SpinorV"]]\
, ", ", 
              ButtonBox["SpinorVBar", RuleDelayed[ButtonData, "SpinorVBar"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SpinorVBar"]], "."}], "Text", 
            CellTags -> "SpinorUBar"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SpinorUBar"], 
           Cell["One argument only assumes a massless spinor.", "Text", 
            CellTags -> "SpinorUBar"], Cell[CellGroupData[{Cell[BoxData[
                \(SpinorUBar[p]\)], "Input", CellTags -> "SpinorUBar"], 
              Cell[BoxData[FormBox[RowBox[{FormBox[\("u"\&_\), 
                    "TraditionalForm"], "(", "p", ")"}], TraditionalForm]], 
               "Output", CellTags -> "SpinorUBar"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SpinorUBar[\(p, m\)]\)], 
               "Input", CellTags -> "SpinorUBar"], Cell[BoxData[
                FormBox[RowBox[{FormBox[\("u"\&_\), "TraditionalForm"], "(", 
                   "p", ",", "m", ")"}], TraditionalForm]], "Output", 
               CellTags -> "SpinorUBar"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SpinorUBar[\(p, m\)]\)//StandardForm\)], "Input", 
               CellTags -> "SpinorUBar"], Cell[BoxData[
                \(SpinorUBar[\(p, m\)]\)], "Output", CellTags -> 
                "SpinorUBar"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SpinorUBar[\(p, m\)]\)//FCI\)//StandardForm\)], 
               "Input", CellTags -> "SpinorUBar"], Cell[BoxData[
                \(Spinor[\(\(Momentum[p]\), m, 1\)]\)], "Output", CellTags -> 
                "SpinorUBar"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(SpinorUBar[\(p, m\)]\)//FCI\)//FCE\)//StandardForm\)]\
, "Input", CellTags -> "SpinorUBar"], Cell[BoxData[
                \(Spinor[\(\(Momentum[p]\), m, 1\)]\)], "Output", CellTags -> 
                "SpinorUBar"]}, Open]]}, Open]], Cell["SpinorU", 
         "ObjectName", CellTags -> "SpinorU"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SpinorU"], Cell[
            "SpinorU[p, m, optarg] denotes a u-spinor.", "Text", 
            CellTags -> "SpinorU"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Spinor", RuleDelayed[ButtonData, "Spinor"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Spinor"]], 
              ", ", 
              ButtonBox["SpinorUBar", RuleDelayed[ButtonData, "SpinorUBar"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SpinorUBar"]], ", ", 
              ButtonBox["SpinorV", RuleDelayed[ButtonData, "SpinorV"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SpinorV"]]\
, ", ", 
              ButtonBox["SpinorVBar", RuleDelayed[ButtonData, "SpinorVBar"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SpinorVBar"]], "."}], "Text", 
            CellTags -> "SpinorU"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SpinorU"], Cell[CellGroupData[{Cell[BoxData[
                \(SpinorU[p]\)], "Input", CellTags -> "SpinorU"], 
              Cell[BoxData[\(TraditionalForm\`\(u(p)\)\)], "Output", 
               CellTags -> "SpinorU"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SpinorU[\(p, m\)]\)], "Input", CellTags -> 
                "SpinorU"], Cell[BoxData[\(TraditionalForm\`\(u (p, m)\)\)], 
               "Output", CellTags -> "SpinorU"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SpinorU[\(p, m\)]\)//StandardForm\)], "Input", 
               CellTags -> "SpinorU"], Cell[BoxData[\(SpinorU[\(p, m\)]\)], 
               "Output", CellTags -> "SpinorU"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SpinorU[\(p, m\)]\)//FCI\)//StandardForm\)], "Input", 
               CellTags -> "SpinorU"], Cell[BoxData[
                \(Spinor[\(\(Momentum[p]\), m, 1\)]\)], "Output", CellTags -> 
                "SpinorU"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(SpinorU[\(p, m\)]\)//FCI\)//FCE\)//StandardForm\)], 
               "Input", CellTags -> "SpinorU"], Cell[BoxData[
                \(Spinor[\(\(Momentum[p]\), m, 1\)]\)], "Output", CellTags -> 
                "SpinorU"]}, Open]]}, Open]], Cell["SpinorVBar", 
         "ObjectName", CellTags -> "SpinorVBar"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SpinorVBar"], Cell[TextData[
             {"SpinorVBar[p, m] denotes a ", Cell[BoxData[
                \(TraditionalForm\`v\&_\)]], "(p,m)-spinor."}], "Text", 
            CellTags -> "SpinorVBar"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Spinor", RuleDelayed[ButtonData, "Spinor"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Spinor"]], 
              ", ", 
              ButtonBox["SpinorU", RuleDelayed[ButtonData, "SpinorU"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SpinorU"]]\
, ", ", 
              ButtonBox["SpinorV", RuleDelayed[ButtonData, "SpinorV"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SpinorV"]]\
, ", ", 
              ButtonBox["SpinorUBar", RuleDelayed[ButtonData, "SpinorUBar"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SpinorUBar"]], "."}], "Text", 
            CellTags -> "SpinorVBar"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SpinorVBar"], Cell[CellGroupData[{Cell[BoxData[
                \(SpinorVBar[p]\)], "Input", CellTags -> "SpinorVBar"], 
              Cell[BoxData[FormBox[RowBox[{FormBox[\("v"\&_\), 
                    "TraditionalForm"], "(", "p", ")"}], TraditionalForm]], 
               "Output", CellTags -> "SpinorVBar"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SpinorVBar[\(p, m\)]\)], 
               "Input", CellTags -> "SpinorVBar"], Cell[BoxData[
                FormBox[RowBox[{FormBox[\("v"\&_\), "TraditionalForm"], "(", 
                   "p", ",", "m", ")"}], TraditionalForm]], "Output", 
               CellTags -> "SpinorVBar"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SpinorVBar[\(p, m\)]\)//StandardForm\)], "Input", 
               CellTags -> "SpinorVBar"], Cell[BoxData[
                \(SpinorVBar[\(p, m\)]\)], "Output", CellTags -> 
                "SpinorVBar"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SpinorVBar[\(p, m\)]\)//FCI\)//StandardForm\)], 
               "Input", CellTags -> "SpinorVBar"], Cell[BoxData[
                \(Spinor[\(\(-\(Momentum[p]\)\), m, 1\)]\)], "Output", 
               CellTags -> "SpinorVBar"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(SpinorVBar[\(p, m\)]\)//FCI\)//FCE\)//StandardForm\)]\
, "Input", CellTags -> "SpinorVBar"], Cell[BoxData[
                \(Spinor[\(\(-\(Momentum[p]\)\), m, 1\)]\)], "Output", 
               CellTags -> "SpinorVBar"]}, Open]]}, Open]], 
        Cell["SpinorV", "ObjectName", CellTags -> "SpinorV"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SpinorV"], Cell[
            "SpinorV[p, m, optarg] denotes a v-spinor.", "Text", 
            CellTags -> "SpinorV"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Spinor", RuleDelayed[ButtonData, "Spinor"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Spinor"]], 
              ", ", 
              ButtonBox["SpinorUBar", RuleDelayed[ButtonData, "SpinorUBar"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SpinorUBar"]], ", ", 
              ButtonBox["SpinorU", RuleDelayed[ButtonData, "SpinorU"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SpinorU"]]\
, ", ", 
              ButtonBox["SpinorVBar", RuleDelayed[ButtonData, "SpinorVBar"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SpinorVBar"]], "."}], "Text", 
            CellTags -> "SpinorV"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SpinorV"], Cell[CellGroupData[{Cell[BoxData[
                \(SpinorV[p]\)], "Input", CellTags -> "SpinorV"], 
              Cell[BoxData[\(TraditionalForm\`\(v(p)\)\)], "Output", 
               CellTags -> "SpinorV"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SpinorV[\(p, m\)]\)], "Input", CellTags -> 
                "SpinorV"], Cell[BoxData[\(TraditionalForm\`\(v (p, m)\)\)], 
               "Output", CellTags -> "SpinorV"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SpinorV[\(p, m\)]\)//StandardForm\)], "Input", 
               CellTags -> "SpinorV"], Cell[BoxData[\(SpinorV[\(p, m\)]\)], 
               "Output", CellTags -> "SpinorV"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SpinorV[\(p, m\)]\)//FCI\)//StandardForm\)], "Input", 
               CellTags -> "SpinorV"], Cell[BoxData[
                \(Spinor[\(\(-\(Momentum[p]\)\), m, 1\)]\)], "Output", 
               CellTags -> "SpinorV"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(\(\(SpinorV[\(p, m\)]\)//FCI\)//FCE\)//StandardForm\)], 
               "Input", CellTags -> "SpinorV"], Cell[BoxData[
                \(Spinor[\(\(-\(Momentum[p]\)\), m, 1\)]\)], "Output", 
               CellTags -> "SpinorV"]}, Open]]}, Open]], 
        Cell["SpinPolarizationSum", "ObjectName", CellTags -> 
          "SpinPolarizationSum"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "SpinPolarizationSum"], Cell["SpinPolarizationSum is an option \
for FermionSpinSum. The set (pure) function acts on the usual spin sum.", 
            "Text", CellTags -> "SpinPolarizationSum"], 
           Cell[TextData[{"See also:  ", 
              ButtonBox["FermionSpinSum", 
                RuleDelayed[ButtonData, "FermionSpinSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FermionSpinSum"]], "."}], "Text", 
            CellTags -> "SpinPolarizationSum"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["SPL", "ObjectName", CellTags -> "SPL"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SPL"], Cell[
            "SPL is an abbreviation for SimplifyPolyLog.", "Text", 
            CellTags -> "SPL"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["SimplifyPolyLog", 
                RuleDelayed[ButtonData, "SimplifyPolyLog"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SimplifyPolyLog"]], "."}], "Text", 
            CellTags -> "SPL"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["SplittingFunction", "ObjectName", CellTags -> 
          "SplittingFunction"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "SplittingFunction"], Cell[TextData[{"SplittingFunction[pxy] is \
a database of splitting functions in the ", Cell[BoxData[
                \(TraditionalForm\`MS\&_\)]], " scheme."}], "Text", 
            CellTags -> "SplittingFunction"], Cell[CellGroupData[
             {Cell[BoxData[\(Options[SplittingFunction]\)], "Input", 
               CellTags -> "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\({Polarization \[Rule] 1}\)\)], "Output", 
               CellTags -> "SplittingFunction"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["AnomalousDimension", 
                RuleDelayed[ButtonData, "AnomalousDimension"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "AnomalousDimension"]], "."}], "Text", 
            CellTags -> "SplittingFunction"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SplittingFunction"], Cell["Unpolarized case:", 
            "Text", CellTags -> "SplittingFunction"], Cell[BoxData[
             \(\(SetOptions[\(SplittingFunction, \(Polarization \[Rule] 0\)\)
                  ]\) ;\)], "Input", CellTags -> "SplittingFunction"], 
           Cell["In general the argument should be a string, but if the \
variables Pqq etc. have no value, you can omit the \"\".", "Text", 
            CellTags -> "SplittingFunction"], Cell[CellGroupData[
             {Cell[BoxData[\(SplittingFunction[Pqq]\)], "Input", CellTags -> 
                "SplittingFunction"], Cell[BoxData[FormBox[RowBox[{\(C\_F\), 
                   " ", RowBox[{"(", RowBox[{\(\(-4\)\ x\), "+", RowBox[
                        {"6", " ", RowBox[{"\[Delta]", "(", FormBox[\(1 - x\)
                          , "TraditionalForm"], ")"}]}], "+", 
                       \(8\ \(\((1\/\(1 - x\))\)\_+\)\), "-", "4"}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "SplittingFunction"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SplittingFunction[Pqg]\)], "Input", CellTags -> 
                "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\(T\_f\ \((\(16\ x\^2\) - \(16\ x\) + 8)\)
                    \)\)], "Output", CellTags -> "SplittingFunction"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SplittingFunction[Pgq]\)], "Input", CellTags -> 
                "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\(C\_F\ \((\(4\ x\) - 8 + 8\/x)\)\)\)], 
               "Output", CellTags -> "SplittingFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SplittingFunction[Pgg]\)], 
               "Input", CellTags -> "SplittingFunction"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{"8", " ", \(C\_A\), " ", RowBox[
                      {"(", RowBox[{\(-x\^2\), "+", "x", "+", RowBox[{
                          \(11\/12\), " ", RowBox[{"\[Delta]", "(", FormBox[
                          \(1 - x\), "TraditionalForm"], ")"}]}], "+", 
                         \(\((1\/\(1 - x\))\)\_+\), "-", "2", "+", \(1\/x\)}]
                         , ")"}]}], "-", RowBox[{\(8\/3\), " ", \(N\_f\), 
                     " ", \(T\_f\), " ", RowBox[{"\[Delta]", "(", FormBox[
                        \(1 - x\), "TraditionalForm"], ")"}]}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "SplittingFunction"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SplittingFunction[aqq]\)], "Input", CellTags -> 
                "SplittingFunction"], Cell[BoxData[FormBox[RowBox[{\(C\_F\), 
                   " ", RowBox[{"(", RowBox[{\(2\ x\), "+", RowBox[{
                         \((7 - \(4\ \(\[Zeta](2)\)\))\), " ", RowBox[
                          {"\[Delta]", "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}]}], "+", 
                       \(\((\(2\ x\) + 2)\)\ \(log(\((1 - x)\)\ x)\)\), "-", 
                       \(4\ \((\(log(x)\)\/\(1 - x\) + 
                             \(\((\(log(1 - x)\)\/\(1 - x\))\)\_+\))\)\), 
                       "-", "4"}], ")"}]}], TraditionalForm]], "Output", 
               CellTags -> "SplittingFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SplittingFunction[agq]\)], 
               "Input", CellTags -> "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\(C\_F\ 
                     \((\(\(-2\)\ x\) + \(
                         \((\(\(-2\)\ x\) + 4 - 4\/x)\)\ 
                          \(log(\(\((1 - x)\)\ x\))\)\) + 2 - 4\/x)\)\)\)], 
               "Output", CellTags -> "SplittingFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SplittingFunction[aqg]\)], 
               "Input", CellTags -> "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\(T\_f\ 
                     \((\(\((\(\(-8\)\ x\^2\) + \(8\ x\) - 4)\)\ 
                          \(log(\(\((1 - x)\)\ x\))\)\) - 4)\)\)\)], 
               "Output", CellTags -> "SplittingFunction"]}, Open]], 
           Cell[BoxData[\(SplittingFunction[agg]\)], "Input", 
            CellTags -> "SplittingFunction"], Cell["Polarized case:", "Text", 
            CellTags -> "SplittingFunction"], Cell[BoxData[
             \(\(SetOptions[\(SplittingFunction, \(Polarization \[Rule] 1\)\)
                  ]\) ;\)], "Input", CellTags -> "SplittingFunction"], 
           Cell[CellGroupData[{Cell[BoxData[\(SplittingFunction[Pqq]\)], 
               "Input", CellTags -> "SplittingFunction"], Cell[BoxData[
                FormBox[RowBox[{\(C\_F\), " ", RowBox[{"(", RowBox[{
                       \(\(-4\)\ x\), "+", RowBox[{"6", " ", RowBox[
                          {"\[Delta]", "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}]}], "+", 
                       \(8\ \(\((1\/\(1 - x\))\)\_+\)\), "-", "4"}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "SplittingFunction"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SplittingFunction[Pqg]\)], "Input", CellTags -> 
                "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\(T\_f\ \((\(16\ x\) - 8)\)\)\)], 
               "Output", CellTags -> "SplittingFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SplittingFunction[Pgq]\)], 
               "Input", CellTags -> "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\(C\_F\ \((8 - \(4\ x\))\)\)\)], "Output", 
               CellTags -> "SplittingFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SplittingFunction[Pgg]\)], 
               "Input", CellTags -> "SplittingFunction"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{\(C\_A\), " ", RowBox[{"(", RowBox[{
                         \(\(-16\)\ x\), "+", RowBox[{\(22\/3\), " ", RowBox[
                          {"\[Delta]", "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}]}], "+", 
                         \(8\ \(\((1\/\(1 - x\))\)\_+\)\), "+", "8"}], 
                       ")"}]}], "-", RowBox[{\(8\/3\), " ", \(N\_f\), " ", 
                     \(T\_f\), " ", RowBox[{"\[Delta]", "(", FormBox[\(1 - x\)
                        , "TraditionalForm"], ")"}]}]}], TraditionalForm]], 
               "Output", CellTags -> "SplittingFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SplittingFunction[aqq]\)], 
               "Input", CellTags -> "SplittingFunction"], Cell[BoxData[
                FormBox[RowBox[{\(C\_F\), " ", RowBox[{"(", RowBox[{
                       \(8\ \((1 - x)\)\), "+", \(2\ x\), "+", RowBox[{
                         \((7 - \(4\ \(\[Zeta](2)\)\))\), " ", RowBox[
                          {"\[Delta]", "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}]}], "+", 
                       \(\((\(2\ x\) + 2)\)\ \(log(\((1 - x)\)\ x)\)\), "-", 
                       \(4\ \(log(x)\)\ \(\((1\/\(1 - x\))\)\_+\)\), "-", 
                       \(4\ \(\((\(log(1 - x)\)\/\(1 - x\))\)\_+\)\), "-", 
                       "4"}], ")"}]}], TraditionalForm]], "Output", 
               CellTags -> "SplittingFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SplittingFunction[agq]\)], 
               "Input", CellTags -> "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\(C\_F\ 
                     \((\(\(-4\)\ x\) + \(
                         \((\(2\ x\) - 4)\)\ \(log(\(\((1 - x)\)\ x\))\)\) + 
                        2)\)\)\)], "Output", CellTags -> 
                "SplittingFunction"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SplittingFunction[agqd]\)], "Input", CellTags -> 
                "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\(C\_F\ 
                     \((\(\((\(2\ x\) - 4)\)\ \(log(\(\((1 - x)\)\ x\))\)\) -
                         2)\)\)\)], "Output", CellTags -> 
                "SplittingFunction"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SplittingFunction[aqg]\)], "Input", CellTags -> 
                "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\(T\_f\ 
                     \((\(\((4 - \(8\ x\))\)\ \(log(\(\((1 - x)\)\ x\))\)\) -
                         4)\)\)\)], "Output", CellTags -> 
                "SplittingFunction"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SplittingFunction[aqgd]\)], "Input", CellTags -> 
                "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\(T\_f\ 
                     \((\(\((4 - \(8\ x\))\)\ \(log(\(\((1 - x)\)\ x\))\)\) -
                         4)\)\)\)], "Output", CellTags -> 
                "SplittingFunction"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SplittingFunction[agg]\)], "Input", CellTags -> 
                "SplittingFunction"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(C\_A\), " ", RowBox[{"(", RowBox[{RowBox[{
                          \((67\/9 - \(4\ \(\[Zeta](2)\)\))\), " ", RowBox[
                          {"\[Delta]", "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}]}], "+", 
                         \(\((\(8\ x\) - 4)\)\ \(log(\((1 - x)\)\ x)\)\), 
                         "-", 
                         \(4\ \((\(log(x)\)\/\(1 - x\) + 
                               \(\((\(log(1 - x)\)\/\(1 - x\))\)\_+\))\)\), 
                         "+", "2"}], ")"}]}], "-", RowBox[{\(20\/9\), " ", 
                     \(T\_f\), " ", RowBox[{"\[Delta]", "(", FormBox[\(1 - x\)
                        , "TraditionalForm"], ")"}]}]}], TraditionalForm]], 
               "Output", CellTags -> "SplittingFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SplittingFunction[aggd]\)], 
               "Input", CellTags -> "SplittingFunction"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{\(C\_A\), " ", RowBox[{"(", RowBox[
                        {RowBox[{\((67\/9 - \(4\ \(\[Zeta](2)\)\))\), " ", 
                          RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}]}], "+", 
                         \(\((\(8\ x\) - 4)\)\ \(log(\((1 - x)\)\ x)\)\), 
                         "-", 
                         \(4\ \((\(log(x)\)\/\(1 - x\) + 
                               \(\((\(log(1 - x)\)\/\(1 - x\))\)\_+\))\)\), 
                         "+", "2"}], ")"}]}], "-", RowBox[{\(20\/9\), " ", 
                     \(T\_f\), " ", RowBox[{"\[Delta]", "(", FormBox[\(1 - x\)
                        , "TraditionalForm"], ")"}]}]}], TraditionalForm]], 
               "Output", CellTags -> "SplittingFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SplittingFunction[PQQS]\)], 
               "Input", CellTags -> "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\(C\_F\ T\_f\ 
                     \((\(\(-16\)\ \((x + 1)\)\ \(\(log\^2\)(x)\)\) + 
                        \(\((\(48\ x\) - 16)\)\ \(log(x)\)\) + 
                        \(16\ \((1 - x)\)\))\)\)\)], "Output", CellTags -> 
                "SplittingFunction"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SplittingFunction[PQQNS]\)], "Input", 
               CellTags -> "SplittingFunction"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{RowBox[{"(", RowBox[{
                         \(\(-4\)\ \((x + 1)\)\ \(log\^2(x)\)\), "-", 
                         \(8\ \((\(2\ x\) + 3\/\(1 - x\))\)\ \(log(x)\)\), 
                         "-", 
                         \(\(16\ \((x\^2 + 1)\)\ \(log(1 - x)\)\ \(log(x)\)\)
                            \/\(1 - x\)\), "-", \(40\ \((1 - x)\)\), "+", 
                         RowBox[{RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}], " ", 
                          \((\(\(-24\)\ \(\[Zeta](2)\)\) + 
                              \(48\ \*TagBox[\(
                                   \[Zeta](\*TagBox["3", Zeta, 
                                      Rule[Editable, True]])\), 
                                  InterpretTemplate[Function[BoxForm`e$, 
                                    Zeta[BoxForm`e$]]]]\) + 3)\)}]}], ")"}], 
                     " ", \(C\_F\%2\)}], "+", RowBox[{\(N\_f\), " ", 
                     RowBox[{"(", RowBox[{\(\(88\ x\)\/9\), "+", RowBox[{
                          \((\(-\(\(16\ \(\[Zeta](2)\)\)\/3\)\) - 2\/3)\), 
                          " ", RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}]}], "-", 
                         \(\(8\ \((x\^2 + 1)\)\ \(log(x)\)\)\/
                            \(3\ \((1 - x)\)\)\), "-", 
                         \(80\/9\ \(\((1\/\(1 - x\))\)\_+\)\), "-", \(8\/9\)}]
                         , ")"}], " ", \(C\_F\)}], "-", 
                   \(8\ \((C\_F - C\_A\/2)\)\ 
                      \((\(4\ \((1 - x)\)\) + \(2\ \((x + 1)\)\ \(log(x)\)\) 
                         + \(\((x\^2 + 1)\)\ 
                            \((\(log\^2(x)\) - 
                               \(4\ \(log(x + 1)\)\ \(log(x)\)\) - 
                               \(2\ \(\[Zeta](2)\)\) - 
                               \(4\ \(\(\*InterpretationBox["Li", PolyLog, 
                                       Rule[Editable, False], 
                                       Rule[Selectable, False]]\)\_2(\(-x\))\
\)\))\)\)\/\(x + 1\))\)\ C\_F\), "+", RowBox[{\(C\_A\), " ", RowBox[
                      {"(", RowBox[{
                         \(\(4\ \((x\^2 + 1)\)\ \(log\^2(x)\)\)\/\(1 - x\)\), 
                         "-", 
                         \(4\/3\ \((\(5\ x\) - 22\/\(1 - x\) + 5)\)\ 
                            \(log(x)\)\), "+", \(4\/9\ \((53 - \(187\ x\))\)\)
                         , "+", \(8\ \((x + 1)\)\ \(\[Zeta](2)\)\), "+", 
                         \(\((536\/9 - \(16\ \(\[Zeta](2)\)\))\)\ 
                            \(\((1\/\(1 - x\))\)\_+\)\), "+", RowBox[
                          {RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}], " ", 
                          \((\(88\ \(\[Zeta](2)\)\)\/3 - 
                              \(24\ \*TagBox[\(
                                   \[Zeta](\*TagBox["3", Zeta, 
                                      Rule[Editable, True]])\), 
                                  InterpretTemplate[Function[BoxForm`e$, 
                                    Zeta[BoxForm`e$]]]]\) + 17\/3)\)}]}], 
                       ")"}], " ", \(C\_F\)}]}], TraditionalForm]], "Output", 
               CellTags -> "SplittingFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SplittingFunction[PQG]\)], 
               "Input", CellTags -> "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\(\(4\ C\_F\ T\_f\ 
                       \((\(\((\(8\ x\) - 4)\)\ \(\(log\^2\)(\(1 - x\))\)\) +
                           \(\((16 - \(16\ x\))\)\ \(log(\(1 - x\))\)\) + 
                          \(\((8 - \(16\ x\))\)\ \(log(x)\)\ 
                            \(log(\(1 - x\))\)\) + 
                          \(\((\(4\ x\) - 2)\)\ \(\(log\^2\)(x)\)\) + 
                          \(54\ x\) - \(16\ x\ \(\[Zeta](2)\)\) + 
                          \(8\ \(\[Zeta](2)\)\) - \(18\ \(log(x)\)\) - 44)\)\
\) + \(4\ C\_A\ T\_f\ \((
                         \(\((4 - \(8\ x\))\)\ \(\(log\^2\)(\(1 - x\))\)\) + 
                          \(\((\(16\ x\) - 16)\)\ \(log(\(1 - x\))\)\) + 
                          \(\((\(\(-8\)\ x\) - 4)\)\ \(\(log\^2\)(x)\)\) - 
                          \(44\ x\) - \(8\ \(\[Zeta](2)\)\) + 
                          \(\((\(32\ x\) + 4)\)\ \(log(x)\)\) + 
                          \(\((\(\(-16\)\ x\) - 8)\)\ \(log(x)\)\ 
                            \(log(\(x + 1\))\)\) + 
                          \(\((\(\(-16\)\ x\) - 8)\)\ 
                            \(\(\*InterpretationBox["Li", PolyLog, 
                                  Rule[Editable, False], 
                                  Rule[Selectable, False]]\)\_2(\(-x\))\)\) +
                           48)\)\)\)\)], "Output", CellTags -> 
                "SplittingFunction"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SplittingFunction[PGQ]\)], "Input", CellTags -> 
                "SplittingFunction"], Cell[BoxData[
                \(TraditionalForm\`\(\(\((C\_A\ C\_F)\) . 
                       \((\(\((16 - \(8\ x\))\)\ \(\(log\^2\)(\(1 - x\))\)\) 
                          + \(\((\(8\ x\)\/3 + 80\/3)\)\ \(log(\(1 - x\))\)\)
                           + \(\((\(16\ x\) - 32)\)\ \(log(x)\)\ 
                            \(log(\(1 - x\))\)\) + 
                          \(\((\(8\ x\) + 16)\)\ \(\(log\^2\)(x)\)\) + 
                          \(280\ x\)\/9 + \(16\ x\ \(\[Zeta](2)\)\) + 
                          \(\((32 - \(104\ x\))\)\ \(log(x)\)\) + 
                          \(\((\(16\ x\) + 32)\)\ \(log(x)\)\ 
                            \(log(\(x + 1\))\)\) + 
                          \(\((\(16\ x\) + 32)\)\ 
                            \(\(\*InterpretationBox["Li", PolyLog, 
                                  Rule[Editable, False], 
                                  Rule[Selectable, False]]\)\_2(\(-x\))\)\) +
                           328\/9)\)\) + 
                     \(C\_F\%2 . \((\(\((\(8\ x\) - 16)\)\ 
                            \(\(log\^2\)(\(1 - x\))\)\) + 
                          \(\((\(\(-8\)\ x\) - 16)\)\ \(log(\(1 - x\))\)\) + 
                          \(\((8 - \(4\ x\))\)\ \(\(log\^2\)(x)\)\) + 
                          \(32\ x\) - \(\((\(32\ x\) + 64)\)\ \(log(x)\)\) + 
                          \(\((\(36\ x\) + 48)\)\ \(log(x)\)\) - 68)\)\) + 
                     \(\((C\_F\ T\_f)\) . 
                       \((\(-\(\(32\ x\)\/9\)\) + 
                          \(\((\(32\ x\)\/3 - 64\/3)\)\ \(log(\(1 - x\))\)\) 
                          - 128\/9)\)\)\)\)], "Output", CellTags -> 
                "SplittingFunction"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SplittingFunction[PGG]\)], "Input", CellTags -> 
                "SplittingFunction"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{RowBox[{"(", RowBox[{
                         \(\((\(-\(8\/\(x + 1\)\)\) + 32 + 8\/\(1 - x\))\)\ 
                            \(log\^2(x)\)\), "+", 
                         \(\((232\/3 - \(536\ x\)\/3)\)\ \(log(x)\)\), "+", 
                         \(\((\(64\ x\) - 32\/\(1 - x\) - 32)\)\ 
                            \(log(1 - x)\)\ \(log(x)\)\), "+", 
                         \(\((\(64\ x\) + 32\/\(x + 1\) + 32)\)\ 
                            \(log(x + 1)\)\ \(log(x)\)\), "-", 
                         \(\(388\ x\)\/9\), "+", RowBox[{\(64\/3\), " ", 
                          RowBox[{"\[Delta]", "(", FormBox[\(1 - x\), 
                          "TraditionalForm"], ")"}]}], "+", 
                         \(\(\[Zeta](2)\)\ \((
                              \(64\ x\) - \(16\ \(\((1\/\(1 - x\))\)\_+\)\) +
                                16\/\(x + 1\))\)\), "+", 
                         \(536\/9\ \(\((1\/\(1 - x\))\)\_+\)\), "+", 
                         \(\((\(64\ x\) + 32\/\(x + 1\) + 32)\)\ 
                            \(\(\*InterpretationBox["Li", PolyLog, 
                                  Rule[Editable, False], 
                                  Rule[Selectable, False]]\)\_2(\(-x\))\)\), 
                         "+", RowBox[{"24", " ", RowBox[{"\[Delta]", "(", 
                          FormBox[\(1 - x\), "TraditionalForm"], ")"}], " ", 
                          TagBox[\(\[Zeta](\*TagBox["3", Zeta, 
                                Rule[Editable, True]])\), 
                            InterpretTemplate[Function[BoxForm`e$, 
                              Zeta[BoxForm`e$]]]]}], "-", \(148\/9\)}], 
                       ")"}], " ", \(C\_A\%2\)}], "+", RowBox[{\(T\_f\), " ", 
                     RowBox[{"(", RowBox[{\(\(608\ x\)\/9\), "-", RowBox[{
                          \(32\/3\), " ", RowBox[{"\[Delta]", "(", FormBox[
                          \(1 - x\), "TraditionalForm"], ")"}]}], "+", 
                         \(\((\(-\(\(32\ x\)\/3\)\) - 32\/3)\)\ \(log(x)\)\), 
                         "-", \(160\/9\ \(\((1\/\(1 - x\))\)\_+\)\), "-", 
                         \(448\/9\)}], ")"}], " ", \(C\_A\)}], "+", RowBox[{
                     \(C\_F\), " ", \(T\_f\), " ", RowBox[{"(", RowBox[{
                         \(\((\(\(-16\)\ x\) - 16)\)\ \(log\^2(x)\)\), "+", 
                         \(\((\(16\ x\) - 80)\)\ \(log(x)\)\), "+", \(80\ x\)
                         , "-", RowBox[{"8", " ", RowBox[{"\[Delta]", "(", 
                          FormBox[\(1 - x\), "TraditionalForm"], ")"}]}], 
                         "-", "80"}], ")"}]}]}], TraditionalForm]], "Output", 
               CellTags -> "SplittingFunction"]}, Open]]}, Open]], 
        Cell["StandardMatrixElement", "ObjectName", CellTags -> 
          "StandardMatrixElement"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "StandardMatrixElement"], Cell["StandardMatrixElement[ ... ] is \
the head for matrix element abbreviations.", "Text", CellTags -> 
             "StandardMatrixElement"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, "."}], "Text", CellTags -> "StandardMatrixElement"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["SubContext", "ObjectName", 
         CellTags -> "SubContext"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "SubContext"], 
           Cell["SubContext[fun] gives the sub-directory (context) in \
HighEnergyPhysics.", "Text", CellTags -> "SubContext"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalc", RuleDelayed[ButtonData, "FeynCalc"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalc"]], ", ", 
              ButtonBox["Load", RuleDelayed[ButtonData, "Load"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Load"]], 
              "."}], "Text", CellTags -> "SubContext"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["SubLoop", "ObjectName", 
         CellTags -> "SubLoop"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "SubLoop"], 
           Cell["SubLoop is an option for OPE1Loop. If set to True, sub \
1-loop tensorintegral decomposition is performed.", "Text", 
            CellTags -> "SubLoop"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OPE1Loop", RuleDelayed[ButtonData, "OPE1Loop"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OPE1Loop"]], "."}], "Text", 
            CellTags -> "SubLoop"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["SumP", "ObjectName", CellTags -> "SumP"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SumP"], Cell[TextData[{"SumP[k, m] is ", 
              Cell[BoxData[
                \(TraditionalForm\`\(2\^\(
                       \*StyleBox["k", Rule[FontSlant, "Plain"]] - 1\) 
                     \(\[Sum]\_\(\*StyleBox["i", Rule[FontSlant, "Plain"]] = 
                          1\)\%\(2\*StyleBox["m", Rule[FontSlant, "Plain"]]\)\
 \(\((1 + \((\(-1\))\)\^\*
                              StyleBox["i", Rule[FontSlant, "Plain"]])\)/
                         \*StyleBox["i", Rule[FontSlant, "Plain"]]\^
                          \*StyleBox["k", Rule[FontSlant, "Plain"]]\)\)\)\)]]}\
], "Text", CellTags -> "SumP"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["SumS", RuleDelayed[ButtonData, "SumS"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SumS"]], 
              ", ", 
              ButtonBox["SumT", RuleDelayed[ButtonData, "SumT"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SumT"]], 
              "."}], "Text", CellTags -> "SumP"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SumP"], Cell[CellGroupData[{Cell[BoxData[
                \(SumP[\(1, \(m - 1\)\)]\)], "Input", CellTags -> "SumP"], 
              Cell[BoxData[FormBox[RowBox[{\(S\_1\%'\), "\[NoBreak]", "(", 
                   "\[NoBreak]", FormBox[\(m - 1\), "TraditionalForm"], 
                   "\[NoBreak]", ")"}], TraditionalForm]], "Output", 
               CellTags -> "SumP"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SumP[\(2, \(m - 1\)\)]\)], "Input", CellTags -> "SumP"], 
              Cell[BoxData[FormBox[RowBox[{\(S\_2\%'\), "\[NoBreak]", "(", 
                   "\[NoBreak]", FormBox[\(m - 1\), "TraditionalForm"], 
                   "\[NoBreak]", ")"}], TraditionalForm]], "Output", 
               CellTags -> "SumP"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SumP[\(1, m\)]\)], "Input", CellTags -> "SumP"], 
              Cell[BoxData[FormBox[RowBox[{\(S\_1\%'\), "\[NoBreak]", "(", 
                   "\[NoBreak]", FormBox["m", "TraditionalForm"], 
                   "\[NoBreak]", ")"}], TraditionalForm]], "Output", 
               CellTags -> "SumP"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SumP[\(1, 4\)]\)], "Input", CellTags -> "SumP"], 
              Cell[BoxData[\(TraditionalForm\`\(25\/12\)\)], "Output", 
               CellTags -> "SumP"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\[Sum]\+\(i = 1\)\%8 \(\((1 + \(\((\(-1\))\)^i\))\)/i\)\)], 
               "Input", CellTags -> "SumP"], Cell[BoxData[
                \(TraditionalForm\`\(25\/12\)\)], "Output", CellTags -> 
                "SumP"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Explicit[\(SumP[\(1, \(n/2\)\)]\)]\)], "Input", CellTags -> 
                "SumP"], Cell[BoxData[FormBox[RowBox[{RowBox[{\(1\/2\), " ", 
                     \((1 - \((\(-1\))\)\^n)\), " ", RowBox[{\(S\_1\), "(", 
                       FormBox[\(\(n - 1\)\/2\), "TraditionalForm"], ")"}]}], 
                   "+", RowBox[{\(1\/2\), " ", \((1 + \((\(-1\))\)\^n)\), 
                     " ", RowBox[{\(S\_1\), "(", FormBox[\(n\/2\), 
                        "TraditionalForm"], ")"}]}]}], TraditionalForm]], 
               "Output", CellTags -> "SumP"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%/.\(n \[Rule] 8\)\)], "Input", 
               CellTags -> "SumP"], Cell[BoxData[
                \(TraditionalForm\`\(25\/12\)\)], "Output", CellTags -> 
                "SumP"]}, Open]]}, Open]], Cell["SumS", "ObjectName", 
         CellTags -> "SumS"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "SumS"], 
           Cell[TextData[{"SumS[1, m] is the harmonic number ", Cell[BoxData[
                \(TraditionalForm\`\(\[Sum]\_
                      \(\*StyleBox["i", Rule[FontSlant, "Italic"]] = 1\)\%
                      \(\*StyleBox["m", Rule[FontSlant, "Italic"]]\)\*
                      StyleBox[" ", Rule[FontSlant, "Italic"]]\(
                      \*StyleBox["i", Rule[FontSlant, "Italic"]]^\((\(-1\))\)
                      \)\)\)]], " ", Cell[BoxData[
                \(TraditionalForm\`\(\((\(= \(S\_1(m)\)\)\ )\) .\)\)]], 
              " SumS[1,1,m] is ", Cell[BoxData[
                \(TraditionalForm\`\(\[Sum]\_
                      \(\*StyleBox["i", Rule[FontSlant, "Italic"]] = 1\)\%
                      \(\*StyleBox["m", Rule[FontSlant, "Italic"]]\) S\_1\)\)]\
], "(", StyleBox["i", Rule[FontSlant, "Italic"]], ")/", 
              StyleBox["i", Rule[FontSlant, "Italic"]], ". SumS[k,l,m] is ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\[Sum]\_\(i = 1\)\%m\ 
                     \(\(S\_l(i)\)/i\^k\)\)\)]], ". SumS[r, n] represents \
Sum[Sign[r]^i/i^Abs[r], {i, 1, n}]. SumS[r,s, n] is Sum[Sign[r]^k/k^Abs[r] \
Sign[s]^j/j^Abs[s], {k, 1, n}, {j, 1, k}] etc."}], "Text", 
            CellTags -> "SumS"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[SumS]\)], "Input", CellTags -> "SumS"], 
              Cell[BoxData[\(TraditionalForm\`\({Reduce \[Rule] False}\)\)], 
               "Output", CellTags -> "SumS"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["SumP", RuleDelayed[ButtonData, "SumP"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SumP"]], 
              ", ", 
              ButtonBox["SumT", RuleDelayed[ButtonData, "SumT"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SumT"]], 
              "."}], "Text", CellTags -> "SumS"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SumS"], Cell[CellGroupData[{Cell[BoxData[
                \(SumS[\(1, \(m - 1\)\)]\)], "Input", CellTags -> "SumS"], 
              Cell[BoxData[FormBox[RowBox[{\(S\_1\), "(", FormBox[\(m - 1\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "SumS"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SumS[\(2, \(m - 1\)\)]\)], "Input", CellTags -> "SumS"], 
              Cell[BoxData[FormBox[RowBox[{\(S\_2\), "(", FormBox[\(m - 1\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "SumS"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SumS[\(\(-1\), m\)]\)], "Input", CellTags -> "SumS"], 
              Cell[BoxData[\(TraditionalForm\`\(S\_\(-1\)(m)\)\)], "Output", 
               CellTags -> "SumS"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SumS[\(1, m, \(Reduce \[Rule] True\)\)]\)], "Input", 
               CellTags -> "SumS"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(S\_1\), "(", FormBox[\(m - 1\), "TraditionalForm"], 
                     ")"}], "+", \(1\/m\)}], TraditionalForm]], "Output", 
               CellTags -> "SumS"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SumS[\(3, \(m + 2\), \(Reduce \[Rule] True\)\)]\)], 
               "Input", CellTags -> "SumS"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{\(S\_3\), "(", FormBox[\(m + 1\), 
                      "TraditionalForm"], ")"}], "+", \(1\/\((m + 2)\)\^3\)}]
                   , TraditionalForm]], "Output", CellTags -> "SumS"]}, 
             Open]], Cell[BoxData[
             \(\(SetOptions[\(SumS, \(Reduce \[Rule] True\)\)]\) ;\)], 
            "Input", CellTags -> "SumS"], Cell[CellGroupData[{Cell[BoxData[
                \(SumS[\(3, \(m + 2\)\)]\)], "Input", CellTags -> "SumS"], 
              Cell[BoxData[FormBox[RowBox[{RowBox[{\(S\_3\), "(", FormBox[
                      \(m - 1\), "TraditionalForm"], ")"}], "+", \(1\/m\^3\), 
                   "+", \(1\/\((m + 1)\)\^3\), "+", \(1\/\((m + 2)\)\^3\)}], 
                 TraditionalForm]], "Output", CellTags -> "SumS"]}, Open]], 
           Cell[BoxData[
             \(\(SetOptions[\(SumS, \(Reduce \[Rule] False\)\)]\) ;\)], 
            "Input", CellTags -> "SumS"], Cell[CellGroupData[{Cell[BoxData[
                \(SumS[\(1, 4\)]\)], "Input", CellTags -> "SumS"], 
              Cell[BoxData[\(TraditionalForm\`\(25\/12\)\)], "Output", 
               CellTags -> "SumS"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\[Sum]\+\(i = 1\)\%4 \(1/i\)\)], "Input", CellTags -> 
                "SumS"], Cell[BoxData[\(TraditionalForm\`\(25\/12\)\)], 
               "Output", CellTags -> "SumS"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SumS[\(1, 2, \(m - 1\)\)]\)], 
               "Input", CellTags -> "SumS"], Cell[BoxData[FormBox[RowBox[{
                   \(S\_12\), "(", FormBox[\(m - 1\), "TraditionalForm"], 
                   ")"}], TraditionalForm]], "Output", CellTags -> "SumS"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SumS[\(1, 1, 1, 11\)]\)], "Input", CellTags -> "SumS"], 
              Cell[BoxData[
                \(TraditionalForm\`\(31276937512951\/4260000729600\)\)], 
               "Output", CellTags -> "SumS"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SumS[\(\(-1\), 4\)]\)], 
               "Input", CellTags -> "SumS"], Cell[BoxData[
                \(TraditionalForm\`\(-\(7\/12\)\)\)], "Output", CellTags -> 
                "SumS"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SumT[\(1, 4\)]\)], "Input", CellTags -> "SumS"], 
              Cell[BoxData[\(TraditionalForm\`\(-\(7\/12\)\)\)], "Output", 
               CellTags -> "SumS"]}, Open]]}, Open]], 
        Cell["SumT", "ObjectName", CellTags -> "SumT"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SumT"], Cell[TextData[
             {"SumT[1, m] is the alternative harmonic number ", Cell[BoxData[
                \(TraditionalForm\`\(\[Sum]\_\(i = 1\)\%m\ 
                     \(\(\((\(-1\))\)^i\)/\(i\ \)\)\)\)]], " SumT[r, n] \
represents Sum[(-1)^i/i^r, {i,1,n}], SumT[r,s, n] is Sum[1/k^r (-1)^j/j^s, \
{k, 1, n}, {j, 1, k}]."}], "Text", CellTags -> "SumT"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["SumP", RuleDelayed[ButtonData, "SumP"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SumP"]], 
              ", ", 
              ButtonBox["SumS", RuleDelayed[ButtonData, "SumS"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SumS"]], 
              "."}], "Text", CellTags -> "SumT"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SumT"], Cell[CellGroupData[{Cell[BoxData[
                \(SumT[\(1, \(m - 1\)\)]\)], "Input", CellTags -> "SumT"], 
              Cell[BoxData[FormBox[RowBox[{\(\(S\&~\)\_1\), "(", FormBox[
                    \(m - 1\), "TraditionalForm"], ")"}], TraditionalForm]], 
               "Output", CellTags -> "SumT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SumT[\(2, \(m - 1\)\)]\)], 
               "Input", CellTags -> "SumT"], Cell[BoxData[FormBox[RowBox[{
                   \(\(S\&~\)\_2\), "(", FormBox[\(m - 1\), 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "SumT"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SumT[\(1, m\)]\)], "Input", CellTags -> "SumT"], 
              Cell[BoxData[\(TraditionalForm\`\(\(S\&~\)\_1(m)\)\)], 
               "Output", CellTags -> "SumT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SumT[\(1, m, \(Reduce \[Rule] True\)\)]\)], "Input", 
               CellTags -> "SumT"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(\(S\&~\)\_1\), "(", FormBox[\(m - 1\), 
                      "TraditionalForm"], ")"}], "+", \(\((\(-1\))\)\^m\/m\)}]
                   , TraditionalForm]], "Output", CellTags -> "SumT"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(SumT[\(1, 4\)]\)], 
               "Input", CellTags -> "SumT"], Cell[BoxData[
                \(TraditionalForm\`\(-\(7\/12\)\)\)], "Output", CellTags -> 
                "SumT"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\[Sum]\+\(i = 1\)\%4 \(\(\((\(-1\))\)^i\)/i\)\)], "Input", 
               CellTags -> "SumT"], Cell[BoxData[
                \(TraditionalForm\`\(-\(7\/12\)\)\)], "Output", CellTags -> 
                "SumT"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SumT[\(1, 2, \(m - 1\)\)]\)], "Input", CellTags -> "SumT"], 
              Cell[BoxData[FormBox[RowBox[{\(\(S\&~\)\_12\), "(", FormBox[
                    \(m - 1\), "TraditionalForm"], ")"}], TraditionalForm]], 
               "Output", CellTags -> "SumT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SumT[\(1, 2, 42\)]\)], "Input", 
               CellTags -> "SumT"], Cell[BoxData[
                \(TraditionalForm\`\(-\(389879586970550133604898642987036214\
29610152138683927\/10512121660702378405316004964483761080879\
190528000000\)\)\)], "Output", CellTags -> "SumT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SumT[\(1, 4\)]\)], "Input", 
               CellTags -> "SumT"], Cell[BoxData[
                \(TraditionalForm\`\(-\(7\/12\)\)\)], "Output", CellTags -> 
                "SumT"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SumS[\(\(-1\), 4\)]\)], "Input", CellTags -> "SumT"], 
              Cell[BoxData[\(TraditionalForm\`\(-\(7\/12\)\)\)], "Output", 
               CellTags -> "SumT"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\[Sum]\+\(i = 1\)\%\(m - 1\) \(\(\((\(-1\))\)^i\)/i\)\)], 
               "Input", CellTags -> "SumT"], Cell[BoxData[
                \(TraditionalForm\`\(\(1\/2\ \((\(-1\))\)\^m\ 
                       \((\(\(\*TagBox["\[Psi]", PolyGamma]\^\((0)\)\)(
                            \(m\/2\))\) - 
                          \(\(\*TagBox["\[Psi]", PolyGamma]\^\((0)\)\)(
                            \(\(m + 1\)\/2\))\))\)\) - \(log(4)\)\/2\)\)], 
               "Output", CellTags -> "SumT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SumT[\(1, 2, 12\)]\)], "Input", 
               CellTags -> "SumT"], Cell[BoxData[
                \(TraditionalForm\`\(-\(57561743656913\/21300003648000\)\)\)]\
, "Output", CellTags -> "SumT"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SumS[\(1, \(-2\), 42\)]\)], "Input", CellTags -> "SumT"], 
              Cell[BoxData[
                \(TraditionalForm\`\(-\(389879586970550133604898642987036214\
29610152138683927\/10512121660702378405316004964483761080879\
190528000000\)\)\)], "Output", CellTags -> "SumT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Array[\(SumT, 6\)]\)], "Input", 
               CellTags -> "SumT"], Cell[BoxData[
                \(TraditionalForm\`\({\(-1\), \(-\(5\/8\)\), 
                      \(-\(179\/216\)\), \(-\(1207\/1728\)\), 
                      \(-\(170603\/216000\)\), \(-\(155903\/216000\)\)}\)\)], 
               "Output", CellTags -> "SumT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Array[\(\(\(SumS[\(\(-2\), 1, #1\)]\) &\), 6\)]\)], 
               "Input", CellTags -> "SumT"], Cell[BoxData[
                \(TraditionalForm\`\({\(-1\), \(-\(5\/8\)\), 
                      \(-\(179\/216\)\), \(-\(1207\/1728\)\), 
                      \(-\(170603\/216000\)\), \(-\(155903\/216000\)\)}\)\)], 
               "Output", CellTags -> "SumT"]}, Open]]}, Open]], 
        Cell["SUND", "ObjectName", CellTags -> "SUND"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SUND"], Cell[TextData[
             {"SUND[a,b,c] are the symmetric SU(", 
              StyleBox["N", Rule[FontSlant, "Italic"]], ") ", Cell[BoxData[
                \(TraditionalForm\`\(d\_abc .\)\)]]}], "Text", 
            CellTags -> "SUND"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["SUNDelta", RuleDelayed[ButtonData, "SUNDelta"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNDelta"]], ", ", 
              ButtonBox["SUNF", RuleDelayed[ButtonData, "SUNF"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SUNF"]], 
              ", ", 
              ButtonBox["SUNSimplify", RuleDelayed[ButtonData, 
                 "SUNSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNSimplify"]], "."}], "Text", 
            CellTags -> "SUND"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "SUND"], 
           Cell[CellGroupData[{Cell[BoxData[\(SUND[\(a, b, c\)]\)], "Input", 
               CellTags -> "SUND"], Cell[BoxData[
                \(TraditionalForm\`d\_\(abc\)\)], "Output", CellTags -> 
                "SUND"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(tt = \(SUND[\(a, b, c, \(Explicit \[Rule] True\)\)]\)\)], 
               "Input", CellTags -> "SUND"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{"2", " ", RowBox[{"tr", "(", FormBox[
                        RowBox[{SubscriptBox["T", FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SubscriptBox["T", FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SubscriptBox["T", FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"]]}], 
                        "TraditionalForm"], ")"}]}], "+", RowBox[{"2", " ", 
                     RowBox[{"tr", "(", FormBox[RowBox[{SubscriptBox["T", 
                          FormBox[FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"]]}], "TraditionalForm"], 
                       ")"}]}]}], TraditionalForm]], "Output", CellTags -> 
                "SUND"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUND[\(c, a, b\)]\)], "Input", CellTags -> "SUND"], 
              Cell[BoxData[\(TraditionalForm\`d\_\(abc\)\)], "Output", 
               CellTags -> "SUND"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUND[\(a, b, b\)]\)], "Input", CellTags -> "SUND"], 
              Cell[BoxData[\(TraditionalForm\`d\_\(abb\)\)], "Output", 
               CellTags -> "SUND"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(SUND[\(a, b, c\)]\)\ \(SUND[\(a, b, c\)]\)
                    \)]\)], "Input", CellTags -> "SUND"], Cell[BoxData[
                \(TraditionalForm\`\(\(-2\)\ \((4 - C\_A\%2)\)\ C\_F\)\)], 
               "Output", CellTags -> "SUND"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SUNSimplify[\(\(\(SUND[\(a, b, c\)]\)\ 
                         \(SUND[\(a, b, c\)]\)\), 
                       \(SUNNToCACF \[Rule] False\)\)]\)//Factor2\)], 
               "Input", CellTags -> "SUND"], Cell[BoxData[
                \(TraditionalForm\`\(\(\((1 - N\^2)\)\ \((4 - N\^2)\)\)\/N\)
                  \)], "Output", CellTags -> "SUND"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SUNSimplify[\(\(\(SUND[\(a, b, c\)]\)\ 
                         \(SUND[\(e, b, c\)]\)\), 
                       \(SUNNToCACF \[Rule] False\)\)]\)//Factor2\)], 
               "Input", CellTags -> "SUND"], Cell[BoxData[FormBox[
                 RowBox[{"-", FractionBox[RowBox[{\((4 - N\^2)\), " ", 
                      SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], "N"]}], TraditionalForm]], 
               "Output", CellTags -> "SUND"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SUND[\(a, b, c\)]\)//StandardForm\)], "Input", 
               CellTags -> "SUND"], Cell[BoxData[\(SUND[\(a, b, c\)]\)], 
               "Output", CellTags -> "SUND"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SUND[\(a, b, c\)]\)//FCI\)//StandardForm\)], "Input", 
               CellTags -> "SUND"], Cell[BoxData[
                \(SUND[\(\(SUNIndex[a]\), \(SUNIndex[b]\), \(SUNIndex[c]\)\)]
                  \)], "Output", CellTags -> "SUND"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(SUND[\(a, b, c\)]\)//FCI\)//FCE\)//StandardForm\)], 
               "Input", CellTags -> "SUND"], Cell[BoxData[
                \(SUND[\(a, b, c\)]\)], "Output", CellTags -> "SUND"]}, 
             Open]], Cell[BoxData[\(Clear[tt]\)], "Input", 
            CellTags -> "SUND"]}, Open]], Cell["SUNDelta", "ObjectName", 
         CellTags -> "SUNDelta"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "SUNDelta"], 
           Cell[TextData[{"SUNDelta[a, b] is the Kronecker-delta for SU(", 
              StyleBox["N", Rule[FontSlant, "Italic"]], 
              ") with color indices a and b."}], "Text", CellTags -> 
             "SUNDelta"], Cell[TextData[{"See also: ", 
              ButtonBox["ExplicitSUNIndex", 
                RuleDelayed[ButtonData, "ExplicitSUNIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExplicitSUNIndex"]], ", ", 
              ButtonBox["SD", RuleDelayed[ButtonData, "SD"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SD"]], 
              ", ", 
              ButtonBox["SUNF", RuleDelayed[ButtonData, "SUNF"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SUNF"]], 
              ", ", 
              ButtonBox["SUNIndex", RuleDelayed[ButtonData, "SUNIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNIndex"]], ", ", 
              ButtonBox["SUNSimplify", RuleDelayed[ButtonData, 
                 "SUNSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNSimplify"]], ", ", 
              ButtonBox["Trick", RuleDelayed[ButtonData, "Trick"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Trick"]], 
              "."}], "Text", CellTags -> "SUNDelta"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SUNDelta"], Cell[CellGroupData[{Cell[BoxData[
                \(SUNDelta[\(a, b\)]\)], "Input", CellTags -> "SUNDelta"], 
              Cell[BoxData[\(TraditionalForm\`\[Delta]\_\(ab\)\)], "Output", 
               CellTags -> "SUNDelta"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Trick[\ \(\(SUNDelta[\(a, b\)]\)\ \(SUNDelta[\(b, c\)]\)\)
                   \ ]\)], "Input", CellTags -> "SUNDelta"], Cell[BoxData[
                FormBox[SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["c", "TraditionalForm"], "TraditionalForm"]}]], 
                 TraditionalForm]], "Output", CellTags -> "SUNDelta"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNDelta[\(\(SUNIndex[a]\), \(SUNIndex[b]\)\)]\)], "Input", 
               CellTags -> "SUNDelta"], Cell[BoxData[FormBox[SubscriptBox[
                  "\[Delta]", RowBox[{FormBox[FormBox["a", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["b", "TraditionalForm"], "TraditionalForm"]}]], 
                 TraditionalForm]], "Output", CellTags -> "SUNDelta"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(SUNDelta[\(a, b\)]\)//StandardForm\)], "Input", 
               CellTags -> "SUNDelta"], Cell[BoxData[\(SUNDelta[\(a, b\)]\)], 
               "Output", CellTags -> "SUNDelta"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SUNDelta[\(a, b\)]\)//FCI\)//StandardForm\)], "Input", 
               CellTags -> "SUNDelta"], Cell[BoxData[
                \(SUNDelta[\(\(SUNIndex[a]\), \(SUNIndex[b]\)\)]\)], 
               "Output", CellTags -> "SUNDelta"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(SUNDelta[\(a, b\)]\)//FCI\)//FCE\)//StandardForm\)], 
               "Input", CellTags -> "SUNDelta"], Cell[BoxData[\(SD[\(a, b\)]\)
                ], "Output", CellTags -> "SUNDelta"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SD[\(a, b\)]\)//FCI\)//StandardForm\)], "Input", 
               CellTags -> "SUNDelta"], Cell[BoxData[
                \(SUNDelta[\(\(SUNIndex[a]\), \(SUNIndex[b]\)\)]\)], 
               "Output", CellTags -> "SUNDelta"]}, Open]], 
           Cell["Symbolic arguments to SUNDelta are transformed into the data \
type SUNIndex and integer arguments are transformed to ExplicitSUNIndex. The \
difference is that SUNSimplify will only sum over symbolic indices.", "Text", 
            CellTags -> "SUNDelta"], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SUNDelta[\(a, 2\)]\) \(SUNDelta[\(a, b\)]\) 
                     \(SUNDelta[\(c, 2\)]\)\)//SUNSimplify\)], "Input", 
               CellTags -> "SUNDelta"], Cell[BoxData[FormBox[RowBox[
                  {SubscriptBox["\[Delta]", RowBox[{FormBox["2", 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"]}]], " ", 
                   SubscriptBox["\[Delta]", RowBox[{FormBox["2", 
                       "TraditionalForm"], FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"]}]]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNDelta"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], 
               "Input", CellTags -> "SUNDelta"], Cell[BoxData[
                \(\(SUNDelta[\(\(ExplicitSUNIndex[2]\), \(SUNIndex[b]\)\)]\)
                   \ \(SUNDelta[\(\(ExplicitSUNIndex[2]\), \(SUNIndex[c]\)\)]
                    \)\)], "Output", CellTags -> "SUNDelta"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SUNDelta[\(1, 2\)]\)//FCI\)//StandardForm\)], "Input", 
               CellTags -> "SUNDelta"], Cell[BoxData[
                \(SUNDelta[\(\(ExplicitSUNIndex[1]\), \(ExplicitSUNIndex[2]\)
                    \)]\)], "Output", CellTags -> "SUNDelta"]}, Open]]}, 
          Open]], Cell["SUNDeltaContract", "ObjectName", 
         CellTags -> "SUNDeltaContract"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "SUNDeltaContract"], Cell[TextData[{"SUNDeltaContract[expr] \
substitues for all SUNDelta in expr SUNDeltaContract, contracts the SUN(N) \
indices and resubstitutes SUNDelta. SUNDeltaContract[i, j] is the \
Kronecker-delta for SU(", StyleBox["N", Rule[FontSlant, "Italic"]], ") with \
contraction properties. SUNDeltaContract wraps also the head SUNIndex around \
its arguments."}], "Text", CellTags -> "SUNDeltaContract"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["SUNDelta", RuleDelayed[ButtonData, "SUNDelta"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNDelta"]], ", ", 
              ButtonBox["SUNIndex", RuleDelayed[ButtonData, "SUNIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNIndex"]], "."}], "Text", 
            CellTags -> "SUNDeltaContract"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["SUNF", "ObjectName", CellTags -> "SUNF"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SUNF"], Cell[TextData[
             {"SUNF[a,b,c] are the structure constants of SU(", 
              StyleBox["N", Rule[FontSlant, "Italic"]], 
              "). The arguments a,b,c should be of symbolic type."}], "Text", 
            CellTags -> "SUNF"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[SUNF]\)], "Input", CellTags -> "SUNF"], 
              Cell[BoxData[\(TraditionalForm\`\({Explicit \[Rule] False}\)\)]
                , "Output", CellTags -> "SUNF"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["SUND", RuleDelayed[ButtonData, "SUND"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SUND"]], 
              ", ", 
              ButtonBox["SUNDelta", RuleDelayed[ButtonData, "SUNDelta"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNDelta"]], ", ", 
              ButtonBox["SUNIndex", RuleDelayed[ButtonData, "SUNIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNIndex"]], ", ", 
              ButtonBox["SUNSimplify", RuleDelayed[ButtonData, 
                 "SUNSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNSimplify"]], ", ", 
              ButtonBox["SUNT", RuleDelayed[ButtonData, "SUNT"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SUNT"]], 
              ", ", 
              ButtonBox["Trick", RuleDelayed[ButtonData, "Trick"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Trick"]], 
              "."}], "Text", CellTags -> "SUNF"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SUNF"], Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(\(\(SUNF[\(a, b, c\)]\) x\) + 
                     \(\(SUNF[\(b, a, c\)]\) y\)\)\)], "Input", CellTags -> 
                "SUNF"], Cell[BoxData[
                \(TraditionalForm\`\(\(x\ f\_\(abc\)\) + \(y\ f\_\(bac\)\)\)
                  \)], "Output", CellTags -> "SUNF"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Calc[t1]\)], "Input", 
               CellTags -> "SUNF"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"x", " ", SubscriptBox["f", RowBox[{FormBox[
                         FormBox["a", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "-", 
                   RowBox[{"y", " ", SubscriptBox["f", RowBox[{FormBox[
                         FormBox["a", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"]}]]}]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNF"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SUNSimplify[t1]\)], "Input", 
               CellTags -> "SUNF"], Cell[BoxData[FormBox[RowBox[{\((x - y)\), 
                   " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "SUNF"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNF[\(a, a, b\)]\)], "Input", CellTags -> "SUNF"], 
              Cell[BoxData[\(TraditionalForm\`f\_\(aab\)\)], "Output", 
               CellTags -> "SUNF"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(SUNF[\(a, a, b\)]\)//Calc\)], "Input", CellTags -> 
                "SUNF"], Cell[BoxData[\(TraditionalForm\`0\)], "Output", 
               CellTags -> "SUNF"]}, Open]], 
           Cell[TextData[{"This is a consequence of the usual choice for the \
normalization of the ", Cell[BoxData[
                \(TraditionalForm\`\(T\_a\ generatorsin\ 
                     \(\((see\(\ \ \)SUNT)\) .\)\)\)]]}], "Text", 
            CellTags -> "SUNF"], Cell[CellGroupData[{Cell[BoxData[
                \(SUNF[\(a, b, c, \(Explicit \[Rule] True\)\)]\)], "Input", 
               CellTags -> "SUNF"], Cell[BoxData[FormBox[RowBox[{"2", " ", 
                   "\[ImaginaryI]", " ", RowBox[{"(", RowBox[{RowBox[
                        {"tr", "(", FormBox[RowBox[{SubscriptBox["T", FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]]}], "TraditionalForm"], ")"}], 
                       "-", RowBox[{"tr", "(", FormBox[RowBox[{SubscriptBox[
                          "T", FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"]]}], "TraditionalForm"], ")"}]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "SUNF"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(SUNF[\(a, b, c\)]\)\ \(SUNF[\(a, b, d\)]\)
                    \)]\)], "Input", CellTags -> "SUNF"], Cell[BoxData[
                FormBox[RowBox[{\(C\_A\), " ", SubscriptBox["\[Delta]", 
                    RowBox[{FormBox[FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["d", 
                        "TraditionalForm"], "TraditionalForm"]}]]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNF"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(SUNF[\(a, b, c\)]\), 
                     \(Explicit \[Rule] True\)\)]\)], "Input", CellTags -> 
                "SUNF"], Cell[BoxData[FormBox[RowBox[{\(-2\), " ", 
                   "\[ImaginaryI]", " ", RowBox[{"(", RowBox[{RowBox[
                        {"tr", "(", FormBox[RowBox[{SubscriptBox["T", FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"]]}], "TraditionalForm"], ")"}], 
                       "-", RowBox[{"tr", "(", FormBox[RowBox[{SubscriptBox[
                          "T", FormBox[FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"]]}], "TraditionalForm"], ")"}]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "SUNF"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(SUNF[\(a, b, c\)]\)//StandardForm\)], "Input", 
               CellTags -> "SUNF"], Cell[BoxData[\(SUNF[\(a, b, c\)]\)], 
               "Output", CellTags -> "SUNF"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SUNF[\(a, b, c\)]\)//FCI\)//StandardForm\)], "Input", 
               CellTags -> "SUNF"], Cell[BoxData[
                \(SUNF[\(\(SUNIndex[a]\), \(SUNIndex[b]\), \(SUNIndex[c]\)\)]
                  \)], "Output", CellTags -> "SUNF"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(SUNF[\(a, b, c\)]\)//FCI\)//FCE\)//StandardForm\)], 
               "Input", CellTags -> "SUNF"], Cell[BoxData[
                \(SUNF[\(a, b, c\)]\)], "Output", CellTags -> "SUNF"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(SUNF[\(b, a, c\)]\)], 
               "Input", CellTags -> "SUNF"], Cell[BoxData[
                \(TraditionalForm\`f\_\(bac\)\)], "Output", CellTags -> 
                "SUNF"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(SUNF[\(b, a, c\)]\)//FCI\)], "Input", CellTags -> 
                "SUNF"], Cell[BoxData[FormBox[RowBox[{"-", SubscriptBox["f", 
                    RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "SUNF"]}, Open]]}, Open]], Cell["SUNFJacobi", 
         "ObjectName", CellTags -> "SUNFJacobi"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SUNFJacobi"], Cell["SUNFJacobi is an option for \
SUNSimplify, indicating whether the Jacobi identity should be used.", "Text", 
            CellTags -> "SUNFJacobi"], Cell[TextData[{"See also:  ", 
              ButtonBox["SUNF", RuleDelayed[ButtonData, "SUNF"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SUNF"]], 
              ", ", 
              ButtonBox["SUNSimplify", RuleDelayed[ButtonData, 
                 "SUNSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNSimplify"]], "."}], "Text", 
            CellTags -> "SUNFJacobi"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SUNFJacobi"], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SUNF[\(a, b, c\)]\) \(SUNF[\(e, f, c\)]\)\)//
                   \(\(SUNSimplify[\(#, \(SUNFJacobi \[Rule] False\)\)]\) &\)
                \)], "Input", CellTags -> "SUNFJacobi"], Cell[BoxData[
                FormBox[RowBox[{SubscriptBox["f", RowBox[{FormBox[FormBox[
                        "a", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"]}]], " ", 
                   SubscriptBox["f", RowBox[{FormBox[FormBox["c", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["e", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["f", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "SUNFJacobi"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SUNF[\(a, b, c\)]\) \(SUNF[\(e, f, c\)]\)\)//
                   \(\(SUNSimplify[\(#, \(SUNFJacobi \[Rule] True\)\)]\) &\)\
\)], "Input", CellTags -> "SUNFJacobi"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["f", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{SubscriptBox[
                      "f", RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["f", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "SUNFJacobi"]}, Open]]}, Open]], 
        Cell["SUNIndex", "ObjectName", CellTags -> "SUNIndex"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SUNIndex"], Cell[TextData[
             {"SUNIndex is the head of SU(", 
              StyleBox["N", Rule[FontSlant, "Italic"]], ") indices."}], 
            "Text", CellTags -> "SUNIndex"], Cell[TextData[{"See also: ", 
              ButtonBox["ExplicitSUNIndex", 
                RuleDelayed[ButtonData, "ExplicitSUNIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "ExplicitSUNIndex"]], ", ", 
              ButtonBox["SUNDelta", RuleDelayed[ButtonData, "SUNDelta"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNDelta"]], ", ", 
              ButtonBox["SUNF", RuleDelayed[ButtonData, "SUNF"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SUNF"]], 
              "."}], "Text", CellTags -> "SUNIndex"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SUNIndex"], Cell[CellGroupData[{Cell[BoxData[
                \(SUNIndex[i]\)], "Input", CellTags -> "SUNIndex"], 
              Cell[BoxData[\(TraditionalForm\`i\)], "Output", CellTags -> 
                "SUNIndex"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%//StandardForm\)], "Input", CellTags -> "SUNIndex"], 
              Cell[BoxData[\(SUNIndex[i]\)], "Output", CellTags -> 
                "SUNIndex"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SUNDelta[\(i, j\)]\)//FCI\)//StandardForm\)], "Input", 
               CellTags -> "SUNIndex"], Cell[BoxData[
                \(SUNDelta[\(\(SUNIndex[i]\), \(SUNIndex[j]\)\)]\)], 
               "Output", CellTags -> "SUNIndex"]}, Open]]}, Open]], 
        Cell["SUNIndexRename", "ObjectName", CellTags -> "SUNIndexRename"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SUNIndexRename"], Cell["SUNIndexRename is an option \
of SUNSimplify. If set to False, no automatic renaming of dummy indices is \
done.", "Text", CellTags -> "SUNIndexRename"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["SUNSimplify", RuleDelayed[ButtonData, 
                 "SUNSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNSimplify"]], ", ", 
              ButtonBox["SUNIndex", RuleDelayed[ButtonData, "SUNIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNIndex"]], "."}], "Text", 
            CellTags -> "SUNIndexRename"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["SUNN", "ObjectName", CellTags -> "SUNN"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SUNN"], Cell[TextData[{"SUNN denotes the number of \
colors. Trick[SUNDelta[a, a]] yields (", Cell[BoxData[
                \(TraditionalForm\`\(SUNN\^2\)\)]], " -1)."}], "Text", 
            CellTags -> "SUNN"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["SUNSimplify", RuleDelayed[ButtonData, 
                 "SUNSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNSimplify"]], ", ", 
              ButtonBox["Trick", RuleDelayed[ButtonData, "Trick"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Trick"]], 
              ", ", 
              ButtonBox["SUNIndex", RuleDelayed[ButtonData, "SUNIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNIndex"]], ", ", 
              ButtonBox["CA", RuleDelayed[ButtonData, "CA"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "CA"]], 
              ", ", 
              ButtonBox["CF", RuleDelayed[ButtonData, "CF"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "CF"]], 
              "."}], "Text", CellTags -> "SUNN"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SUNN"], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(SUNDelta[
                       \(\(SUNIndex[a]\),\ \(SUNIndex[a]\)\)]\), 
                     \(SUNNToCACF \[Rule] False\)\)]\)], "Input", CellTags -> 
                "SUNN"], Cell[BoxData[\(TraditionalForm\`\(N\^2 - 1\)\)], 
               "Output", CellTags -> "SUNN"]}, Open]]}, Open]], 
        Cell["SUNNToCACF", "ObjectName", CellTags -> "SUNNToCACF"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SUNNToCACF"], Cell["SUNNToCACF is an option of \
SUNSimplify and CalcColorFactor. If set to True, the Casimir operator \
eigenvalues CA (=N) and CF (=(N^2-1)/(2 N)) are introduced.", "Text", 
            CellTags -> "SUNNToCACF"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["CalcColorFactor", 
                RuleDelayed[ButtonData, "CalcColorFactor"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CalcColorFactor"]], ", ", 
              ButtonBox["SUNSimplify", RuleDelayed[ButtonData, 
                 "SUNSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNSimplify"]], ", ", 
              ButtonBox["Trick", RuleDelayed[ButtonData, "Trick"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Trick"]], 
              ", ", 
              ButtonBox["SUNN", RuleDelayed[ButtonData, "SUNN"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SUNN"]], 
              ", ", 
              ButtonBox["CA", RuleDelayed[ButtonData, "CA"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "CA"]], 
              ", ", 
              ButtonBox["CF", RuleDelayed[ButtonData, "CF"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "CF"]], 
              "."}], "Text", CellTags -> "SUNNToCACF"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SUNNToCACF"], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(SUNDelta[
                       \(\(SUNIndex[a]\),\ \(SUNIndex[a]\)\)]\), 
                     \(SUNNToCACF \[Rule] True\)\)]\)], "Input", CellTags -> 
                "SUNNToCACF"], Cell[BoxData[
                \(TraditionalForm\`\(2\ C\_A\ C\_F\)\)], "Output", 
               CellTags -> "SUNNToCACF"]}, Open]]}, Open]], 
        Cell["SUNSimplify", "ObjectName", CellTags -> "SUNSimplify"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SUNSimplify"], Cell["SUNSimplify simplifies products \
of SUNT (and complex conjugated) matrices. Basic renaming of dummy indices is \
done. If the option SUNTrace is set to False, then any SUNT-matrices are \
taken out of DiracTrace[...]; otherwise a color-trace is taken (by SUNTrace) \
before taking the SUN-objects in front of DiracTrace[...].", "Text", 
            CellTags -> "SUNSimplify"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[SUNSimplify]\)], "Input", CellTags -> 
                "SUNSimplify"], Cell[BoxData[
                \(TraditionalForm\`\({\(Expanding \[Rule] False\), 
                      \(Explicit \[Rule] False\), \(Factoring \[Rule] False\)
                      , \(SUNIndexRename \[Rule] True\), 
                      \(SUNFJacobi \[Rule] False\), 
                      \(SUNNToCACF \[Rule] True\), \(SUNTrace \[Rule] False\)\
}\)\)], "Output", CellTags -> "SUNSimplify"]}, Open]], 
           Cell[TextData[{"See also:  ", 
              ButtonBox["Trick", RuleDelayed[ButtonData, "Trick"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Trick"]], 
              ", ", 
              ButtonBox["CalcColorFactor", 
                RuleDelayed[ButtonData, "CalcColorFactor"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CalcColorFactor"]], "."}], "Text", 
            CellTags -> "SUNSimplify"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SUNSimplify"], Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(\(SUNDelta[\(a, b\)]\)\ \(SUNDelta[\(b, c\)]\)\)\)], 
               "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\[Delta]\_\(ab\)\ \[Delta]\_\(bc\)\)\)], 
               "Output", CellTags -> "SUNSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SUNSimplify[t1]\)], "Input", 
               CellTags -> "SUNSimplify"], Cell[BoxData[FormBox[SubscriptBox[
                  "\[Delta]", RowBox[{FormBox[FormBox["a", 
                      "TraditionalForm"], "TraditionalForm"], FormBox[
                     FormBox["c", "TraditionalForm"], "TraditionalForm"]}]], 
                 TraditionalForm]], "Output", CellTags -> "SUNSimplify"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t2 = \(\(SUNT[a]\) . \(SUNT[a]\)\)\)], "Input", CellTags -> 
                "SUNSimplify"], Cell[BoxData[FormBox[RowBox[{SubscriptBox[
                    "T", FormBox["a", "TraditionalForm"]], ".", SubscriptBox[
                    "T", FormBox["a", "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNSimplify"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(SUNSimplify[t2]\)], 
               "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                \(TraditionalForm\`C\_F\)], "Output", CellTags -> 
                "SUNSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(t2, \(SUNNToCACF \[Rule] False\)\)]\)], 
               "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\(N\^2 - 1\)\/\(2\ N\)\)\)], "Output", 
               CellTags -> "SUNSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t3 = \(\(SUNF[\(a, r, s\)]\) \(SUNF[\(b, r, s\)]\)\)\)], 
               "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(f\_\(ars\)\ f\_\(brs\)\)\)], "Output", 
               CellTags -> "SUNSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SUNSimplify[t3]\)], "Input", 
               CellTags -> "SUNSimplify"], Cell[BoxData[FormBox[RowBox[{
                   \(C\_A\), " ", SubscriptBox["\[Delta]", RowBox[
                     {FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"]}]]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNSimplify"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t4 = \(\(SUNF[\(a, b, c\)]\)\ .\ \(SUNF[\(a, b, c\)]\)\)\)]\
, "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(f\_\(abc\) . f\_\(abc\)\)\)], "Output", 
               CellTags -> "SUNSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SUNSimplify[t4]\)], "Input", 
               CellTags -> "SUNSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(2\ C\_A\%2\ C\_F\)\)], "Output", 
               CellTags -> "SUNSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t5 = \(\(SUNF[\(a, b, c\)]\)\ \(SUNF[\(d, b, c\)]\)\)\)], 
               "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(f\_\(abc\)\ f\_\(dbc\)\)\)], "Output", 
               CellTags -> "SUNSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SUNSimplify[t5]\)], "Input", 
               CellTags -> "SUNSimplify"], Cell[BoxData[FormBox[RowBox[{
                   \(C\_A\), " ", SubscriptBox["\[Delta]", RowBox[
                     {FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["d", 
                        "TraditionalForm"], "TraditionalForm"]}]]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNSimplify"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t6 = \(\(SUNF[\(a, b, c\)]\)\ \(SUND[\(d, b, c\)]\)\)\)], 
               "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(d\_\(bcd\)\ f\_\(abc\)\)\)], "Output", 
               CellTags -> "SUNSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(t6, \(Explicit \[Rule] True\)\)]\)], "Input", 
               CellTags -> "SUNSimplify"], Cell[BoxData[\(TraditionalForm\`0\)
                ], "Output", CellTags -> "SUNSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SUNSimplify[\(\(\(SUND[\(a, b, c\)]\)\ 
                         \(SUND[\(a, b, c\)]\)\), 
                       \(SUNNToCACF \[Rule] False\)\)]\)//Factor2\)], 
               "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\(\((1 - N\^2)\)\ \((4 - N\^2)\)\)\/N\)
                  \)], "Output", CellTags -> "SUNSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SUNSimplify[\(\(\(SUND[\(a, b, c\)]\)\ 
                         \(SUND[\(e, b, c\)]\)\), 
                       \(SUNNToCACF \[Rule] False\)\)]\)//FullSimplify\)], 
               "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                FormBox[FractionBox[RowBox[{\((N\^2 - 4)\), " ", SubscriptBox[
                     "\[Delta]", RowBox[{FormBox[FormBox["a", 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["e", "TraditionalForm"], 
                        "TraditionalForm"]}]]}], "N"], TraditionalForm]], 
               "Output", CellTags -> "SUNSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(SUNF[\(a, b, c\)]\), 
                     \(Explicit \[Rule] True\)\)]\)], "Input", CellTags -> 
                "SUNSimplify"], Cell[BoxData[FormBox[RowBox[{\(-2\), " ", 
                   "\[ImaginaryI]", " ", RowBox[{"(", RowBox[{RowBox[
                        {"tr", "(", FormBox[RowBox[{SubscriptBox["T", FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"]]}], "TraditionalForm"], ")"}], 
                       "-", RowBox[{"tr", "(", FormBox[RowBox[{SubscriptBox[
                          "T", FormBox[FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"]]}], "TraditionalForm"], ")"}]}], 
                     ")"}]}], TraditionalForm]], "Output", CellTags -> 
                "SUNSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(SUND[\(a, b, c\)]\), 
                     \(Explicit \[Rule] True\)\)]\)], "Input", CellTags -> 
                "SUNSimplify"], Cell[BoxData[FormBox[RowBox[{"2", " ", 
                   RowBox[{"(", RowBox[{RowBox[{"tr", "(", FormBox[RowBox[
                          {SubscriptBox["T", FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SubscriptBox["T", FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SubscriptBox["T", FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"]]}], 
                          "TraditionalForm"], ")"}], "+", RowBox[{"tr", "(", 
                         FormBox[RowBox[{SubscriptBox["T", FormBox[FormBox[
                          "b", "TraditionalForm"], "TraditionalForm"]], ".", 
                          SubscriptBox["T", FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SubscriptBox["T", FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"]]}], 
                          "TraditionalForm"], ")"}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNSimplify"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(SUNF[\(a, b, c\)]\)\ \(SUNT[\(c, b, a\)]\)
                    \)]\)], "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\(-\(1\/2\)\)\ \[ImaginaryI]\ C\_A\ C\_F
                    \)\)], "Output", CellTags -> "SUNSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t7 = \(\(\(SUNF[\(a, b, e\)]\) \(SUNF[\(c, d, e\)]\)\) + 
                     \(\(SUNF[\(a, b, z\)]\) \(SUNF[\(c, d, z\)]\)\)\)\)], 
               "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(\(f\_\(abe\)\ f\_\(cde\)\) + 
                     \(f\_\(abz\)\ f\_\(cdz\)\)\)\)], "Output", CellTags -> 
                "SUNSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(t7, \(Explicit \[Rule] False\)\)]\)], 
               "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                FormBox[RowBox[{"2", " ", SubscriptBox["f", RowBox[
                     {FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["e", "TraditionalForm"], 
                       "TraditionalForm"]}]], " ", SubscriptBox["f", 
                    RowBox[{FormBox[FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["d", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["e", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "SUNSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(t7, \(Explicit \[Rule] False\), 
                     \(SUNIndexRename \[Rule] False\)\)]\)], "Input", 
               CellTags -> "SUNSimplify"], Cell[BoxData[FormBox[
                 RowBox[{RowBox[{SubscriptBox["f", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["e", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["d", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["e", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", RowBox[{SubscriptBox[
                      "f", RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["z", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["f", 
                      RowBox[{FormBox[FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["z", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "SUNSimplify"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(1 - \(SUNDelta[\(i, i\)]\)\)]\)], "Input", 
               CellTags -> "SUNSimplify"], Cell[BoxData[
                \(TraditionalForm\`\(2 - C\_A\%2\)\)], "Output", CellTags -> 
                "SUNSimplify"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t8 = \(DiracTrace[\(\(f[\(SUNIndex[a]\)]\) 
                       \(\(DiracMatrix[\[Mu]]\) . \(DiracMatrix[\[Nu]]\)\)\)]
                \)\)], "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                FormBox[RowBox[{"tr", "(", FormBox[RowBox[{RowBox[
                       {SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                        SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                      RowBox[{"f", "(", FormBox["a", "TraditionalForm"], 
                        ")"}]}], "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> "SUNSimplify"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(t8, \(SUNTrace \[Rule] False\)\)]\)], 
               "Input", CellTags -> "SUNSimplify"], Cell[BoxData[
                FormBox[RowBox[{"tr", "(", FormBox[RowBox[{RowBox[
                       {SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                        SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                      RowBox[{"f", "(", FormBox["a", "TraditionalForm"], 
                        ")"}]}], "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> "SUNSimplify"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(t8, \(SUNTrace \[Rule] True\)\)]\)], "Input", 
               CellTags -> "SUNSimplify"], Cell[BoxData[FormBox[RowBox[{
                   \(C\_A\), " ", RowBox[{"tr", "(", FormBox[RowBox[
                       {SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                        SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], 
                      "TraditionalForm"], ")"}], " ", RowBox[{"f", "(", 
                     FormBox["a", "TraditionalForm"], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNSimplify"]}, 
             Open]], Cell[BoxData[
             \(Clear[\(t1, t2, t3, t4, t5, t6, t7, t8\)]\)], "Input", 
            CellTags -> "SUNSimplify"]}, Open]], Cell["SUNT", "ObjectName", 
         CellTags -> "SUNT"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "SUNT"], 
           Cell[TextData[{"SUNT[a] is the SU(", 
              StyleBox["N", Rule[FontSlant, "Italic"]], ") ", Cell[BoxData[
                \(TraditionalForm\`T\_a\)]], 
              " generator in the fundamental representation."}], "Text", 
            CellTags -> "SUNT"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["CA", RuleDelayed[ButtonData, "CA"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "CA"]], 
              ", ", 
              ButtonBox["CF", RuleDelayed[ButtonData, "CF"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "CF"]], 
              ", ", 
              ButtonBox["SUND", RuleDelayed[ButtonData, "SUND"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SUND"]], 
              ", ", 
              ButtonBox["SUNDelta", RuleDelayed[ButtonData, "SUNDelta"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNDelta"]], ", ", 
              ButtonBox["SUNF", RuleDelayed[ButtonData, "SUNF"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "SUNF"]], 
              ", ", 
              ButtonBox["SUNSimplify", RuleDelayed[ButtonData, 
                 "SUNSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNSimplify"]], "."}], "Text", 
            CellTags -> "SUNT"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "SUNT"], 
           Cell[CellGroupData[{Cell[BoxData[\(SUNT[a]\)], "Input", 
               CellTags -> "SUNT"], Cell[BoxData[FormBox[SubscriptBox["T", 
                  FormBox["a", "TraditionalForm"]], TraditionalForm]], 
               "Output", CellTags -> "SUNT"]}, Open]], 
           Cell[TextData[{"Since ", Cell[BoxData[\(TraditionalForm\`T\_a\)]], 
              " is a noncommutative object, products have to separated by a \
dot (.)."}], "Text", CellTags -> "SUNT"], Cell[CellGroupData[{Cell[BoxData[
                \(\(SUNT[a]\) .\ \(SUNT[b]\) .\ \(SUNT[c]\)\)], "Input", 
               CellTags -> "SUNT"], Cell[BoxData[FormBox[RowBox[
                  {SubscriptBox["T", FormBox["a", "TraditionalForm"]], ".", 
                   SubscriptBox["T", FormBox["b", "TraditionalForm"]], ".", 
                   SubscriptBox["T", FormBox["c", "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(SUNT[\(a, b, c, d\)]\)], 
               "Input", CellTags -> "SUNT"], Cell[BoxData[FormBox[
                 RowBox[{SubscriptBox["T", FormBox["a", "TraditionalForm"]], 
                   SubscriptBox["T", FormBox["b", "TraditionalForm"]], 
                   SubscriptBox["T", FormBox["c", "TraditionalForm"]], 
                   SubscriptBox["T", FormBox["d", "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(SUNT[\(a, b, a\)]\), 
                     \(SUNNToCACF \[Rule] False\)\)]\)], "Input", CellTags -> 
                "SUNT"], Cell[BoxData[FormBox[RowBox[{"-", FractionBox[
                    SubscriptBox["T", FormBox[FormBox["b", 
                       "TraditionalForm"], "TraditionalForm"]], \(2\ N\)]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(SUNT[\(a, b, b, a\)]\)]\)], "Input", 
               CellTags -> "SUNT"], Cell[BoxData[\(TraditionalForm\`C\_F\%2\)]
                , "Output", CellTags -> "SUNT"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(SUNT[\(a, b, a\)]\)]\)], "Input", CellTags -> 
                "SUNT"], Cell[BoxData[FormBox[RowBox[{\(-\(1\/2\)\), " ", 
                   \((C\_A - \(2\ C\_F\))\), " ", SubscriptBox["T", 
                    FormBox[FormBox["b", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "SUNT"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(SUNT[\(a, b, a\)]\), 
                     \(SUNNToCACF \[Rule] False\)\)]\)], "Input", CellTags -> 
                "SUNT"], Cell[BoxData[FormBox[RowBox[{"-", FractionBox[
                    SubscriptBox["T", FormBox[FormBox["b", 
                       "TraditionalForm"], "TraditionalForm"]], \(2\ N\)]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNT"]}, Open]], 
           Cell[TextData[{"The normalizaton of the generators is chosen in \
the standard way, therefore ", Cell[BoxData[
                \(TraditionalForm\`\(\(tr(\(T\_a T\_b\))\)\ =\ 
                     \(\(1/2\)\ \(\[Delta]\_ab .\)\)\)\)]]}], "Text", 
            CellTags -> "SUNT"], Cell[CellGroupData[{Cell[BoxData[
                \(SUNTrace[\(SUNT[\(a, b\)]\)]\)], "Input", CellTags -> 
                "SUNT"], Cell[BoxData[FormBox[FractionBox[SubscriptBox[
                   "\[Delta]", RowBox[{FormBox[FormBox["a", 
                       "TraditionalForm"], "TraditionalForm"], FormBox[
                      FormBox["b", "TraditionalForm"], "TraditionalForm"]}]], 
                  "2"], TraditionalForm]], "Output", CellTags -> "SUNT"]}, 
             Open]], Cell[TextData[{"In case you want ", Cell[BoxData[
                \(TraditionalForm\`T\_f\)]], 
              ", you need to include a factor 2Tf inside the trace."}], 
            "Text", CellTags -> "SUNT"], Cell[CellGroupData[{Cell[BoxData[
                \(SUNTrace[\(2\ Tf\ \(SUNT[\(a, b\)]\)\)]\)], "Input", 
               CellTags -> "SUNT"], Cell[BoxData[FormBox[RowBox[{\(T\_f\), 
                   " ", SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "SUNT"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(SUNTrace[\(SUNT[\(a, b\)]\)]\)//StandardForm\)], "Input", 
               CellTags -> "SUNT"], Cell[BoxData[
                \(1\/2\ \(SUNDelta[\(\(SUNIndex[a]\), \(SUNIndex[b]\)\)]\)\)]\
, "Output", CellTags -> "SUNT"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(SUNT[a]\)//FCI\)//StandardForm\)], "Input", CellTags -> 
                "SUNT"], Cell[BoxData[\(SUNT[\(SUNIndex[a]\)]\)], "Output", 
               CellTags -> "SUNT"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(\(SUNT[a]\)//FCI\)//FCE\)//StandardForm\)], "Input", 
               CellTags -> "SUNT"], Cell[BoxData[\(SUNT[a]\)], "Output", 
               CellTags -> "SUNT"]}, Open]]}, Open]], Cell["SUNTrace", 
         "ObjectName", CellTags -> "SUNTrace"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SUNTrace"], 
           Cell["SUNTrace[expr] calculates the color-trace.", "Text", 
            CellTags -> "SUNTrace"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[SUNTrace]\)], "Input", CellTags -> "SUNTrace"], 
              Cell[BoxData[\(TraditionalForm\`\({Explicit \[Rule] False}\)\)]
                , "Output", CellTags -> "SUNTrace"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["SUNSimplify", RuleDelayed[ButtonData, 
                 "SUNSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNSimplify"]], ", ", 
              ButtonBox["Tr", RuleDelayed[ButtonData, "Tr"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Tr"]], 
              "."}], "Text", CellTags -> "SUNTrace"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "SUNTrace"], Cell[CellGroupData[{Cell[BoxData[
                \(SUNTrace[\(SUNT[\(a, b\)]\)]\)], "Input", CellTags -> 
                "SUNTrace"], Cell[BoxData[FormBox[FractionBox[SubscriptBox[
                   "\[Delta]", RowBox[{FormBox[FormBox["a", 
                       "TraditionalForm"], "TraditionalForm"], FormBox[
                      FormBox["b", "TraditionalForm"], "TraditionalForm"]}]], 
                  "2"], TraditionalForm]], "Output", CellTags -> 
                "SUNTrace"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNTrace[\(SUNT[\(a, b, c\)]\)]\)], "Input", CellTags -> 
                "SUNTrace"], Cell[BoxData[FormBox[RowBox[{"tr", "(", 
                   FormBox[RowBox[{SubscriptBox["T", FormBox[FormBox["a", 
                         "TraditionalForm"], "TraditionalForm"]], ".", 
                      SubscriptBox["T", FormBox[FormBox["b", 
                         "TraditionalForm"], "TraditionalForm"]], ".", 
                      SubscriptBox["T", FormBox[FormBox["c", 
                         "TraditionalForm"], "TraditionalForm"]]}], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "SUNTrace"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(SUNTrace[\(\(SUNT[\(a, b, c\)]\), \(Explicit \[Rule] True\)
                    \)]\)], "Input", CellTags -> "SUNTrace"], 
              Cell[BoxData[FormBox[RowBox[{FractionBox[SubscriptBox["d", 
                     RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                        "TraditionalForm"], FormBox[FormBox["b", 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["c", "TraditionalForm"], 
                        "TraditionalForm"]}]], "4"], "+", RowBox[{\(1\/4\), 
                     " ", "\[ImaginaryI]", " ", SubscriptBox["f", RowBox[
                       {FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"]}]]}]}], TraditionalForm]], 
               "Output", CellTags -> "SUNTrace"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SUNTrace[\(SUNT[\(a, b, c, d\)]\)]\)], "Input", CellTags -> 
                "SUNTrace"], Cell[BoxData[FormBox[RowBox[{"tr", "(", 
                   FormBox[RowBox[{SubscriptBox["T", FormBox[FormBox["a", 
                         "TraditionalForm"], "TraditionalForm"]], ".", 
                      SubscriptBox["T", FormBox[FormBox["b", 
                         "TraditionalForm"], "TraditionalForm"]], ".", 
                      SubscriptBox["T", FormBox[FormBox["c", 
                         "TraditionalForm"], "TraditionalForm"]], ".", 
                      SubscriptBox["T", FormBox[FormBox["d", 
                         "TraditionalForm"], "TraditionalForm"]]}], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "SUNTrace"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(t1 = \(SUNTrace[\(\(SUNT[\(a, b, c, d\)]\), 
                       \(Explicit \[Rule] True\)\)]\)\)], "Input", 
               CellTags -> "SUNTrace"], Cell[BoxData[FormBox[RowBox[{RowBox[{
                     \(1\/8\), " ", SubscriptBox["d", RowBox[{"e", FormBox[
                         FormBox["a", "TraditionalForm"], "TraditionalForm"], 
                        FormBox[FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["d", 
                      RowBox[{"e", FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "-", 
                   RowBox[{\(1\/8\), " ", "\[ImaginaryI]", " ", SubscriptBox[
                      "f", RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], "e"}]], 
                     " ", SubscriptBox["d", RowBox[{"e", FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "-", RowBox[{\(1\/8\), " ", 
                     SubscriptBox["d", RowBox[{"e", FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["d", 
                      RowBox[{"e", FormBox[FormBox["b", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{\(1\/8\), " ", SubscriptBox["d", RowBox[{"e", 
                        FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["d", RowBox[{"e", FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["d", "TraditionalForm"], 
                         "TraditionalForm"]}]]}], "+", FractionBox[
                    RowBox[{SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "a", "TraditionalForm"], "TraditionalForm"], 
                         FormBox[FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox[
                       "\[Delta]", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], \(4\ N\)], "-", 
                   FractionBox[RowBox[{SubscriptBox["\[Delta]", RowBox[
                        {FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                      SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], \(4\ N\)], "+", 
                   FractionBox[RowBox[{SubscriptBox["\[Delta]", RowBox[
                        {FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                      SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], \(4\ N\)], "+", RowBox[{
                     \(1\/8\), " ", "\[ImaginaryI]", " ", SubscriptBox["d", 
                      RowBox[{"e", FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["c", "TraditionalForm"], "TraditionalForm"], 
                        "e"}]]}]}], TraditionalForm]], "Output", CellTags -> 
                "SUNTrace"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(t1, \(Explicit \[Rule] True\)\)]\)], "Input", 
               CellTags -> "SUNTrace"], Cell[BoxData[FormBox[RowBox[
                  {"tr", "(", FormBox[RowBox[{SubscriptBox["T", FormBox[
                        FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                      ".", SubscriptBox["T", FormBox[FormBox["b", 
                         "TraditionalForm"], "TraditionalForm"]], ".", 
                      SubscriptBox["T", FormBox[FormBox["c", 
                         "TraditionalForm"], "TraditionalForm"]], ".", 
                      SubscriptBox["T", FormBox[FormBox["d", 
                         "TraditionalForm"], "TraditionalForm"]]}], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "SUNTrace"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(t2 = \(SUNTrace[\(\(SUNT[\(a, b, c, d, e\)]\), 
                       \(Explicit \[Rule] True\)\)]\)\)], "Input", 
               CellTags -> "SUNTrace"], Cell[BoxData[FormBox[RowBox[
                  {FractionBox[RowBox[{SubscriptBox["\[Delta]", RowBox[
                        {FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                      RowBox[{"(", RowBox[{FractionBox[SubscriptBox["d", 
                          RowBox[{FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]], "4"], "+", RowBox[{\(1\/4\), 
                          " ", "\[ImaginaryI]", " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]]}]}], ")"}]}], \(2\ N\)], "+", 
                   RowBox[{\(1\/2\), " ", SubscriptBox["d", RowBox[{"c120", 
                        FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     RowBox[{"(", RowBox[{RowBox[{\(-\(1\/8\)\), " ", 
                          SubscriptBox["d", RowBox[{"c121", FormBox[FormBox[
                          "c", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox["d", 
                          RowBox[{"c121", FormBox[FormBox["c120", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], "+", RowBox[{\(1\/8\), 
                          " ", SubscriptBox["d", RowBox[{"c121", FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          SubscriptBox["d", RowBox[{"c121", FormBox[FormBox[
                          "c120", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], "+", RowBox[{\(1\/8\), 
                          " ", SubscriptBox["d", RowBox[{"c121", FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c120", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          SubscriptBox["d", RowBox[{"c121", FormBox[FormBox[
                          "d", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], "-", FractionBox[RowBox[
                          {SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "c", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox[
                          "\[Delta]", RowBox[{FormBox[FormBox["c120", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], \(4\ N\)], "+", 
                         FractionBox[RowBox[{SubscriptBox["\[Delta]", RowBox[
                          {FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "c120", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], \(4\ N\)], "+", 
                         FractionBox[RowBox[{SubscriptBox["\[Delta]", RowBox[
                          {FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c120", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "d", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], \(4\ N\)], "+", RowBox[{
                          \(1\/8\), " ", "\[ImaginaryI]", " ", SubscriptBox[
                          "d", RowBox[{"c121", FormBox[FormBox["c120", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "c121"}]]}], "-", RowBox[{\(1\/8\), " ", 
                          "\[ImaginaryI]", " ", SubscriptBox["d", RowBox[
                          {"c121", FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          SubscriptBox["f", RowBox[{FormBox[FormBox["c120", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"], "c121"}]]}]}], ")"}]}], "+", 
                   RowBox[{\(1\/2\), " ", "\[ImaginaryI]", " ", SubscriptBox[
                      "f", RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], "c120"}]], 
                     " ", RowBox[{"(", RowBox[{RowBox[{\(-\(1\/8\)\), " ", 
                          SubscriptBox["d", RowBox[{"c122", FormBox[FormBox[
                          "c", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox["d", 
                          RowBox[{"c122", FormBox[FormBox["c120", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], "+", RowBox[{\(1\/8\), 
                          " ", SubscriptBox["d", RowBox[{"c122", FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          SubscriptBox["d", RowBox[{"c122", FormBox[FormBox[
                          "c120", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], "+", RowBox[{\(1\/8\), 
                          " ", SubscriptBox["d", RowBox[{"c122", FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c120", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          SubscriptBox["d", RowBox[{"c122", FormBox[FormBox[
                          "d", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], "-", FractionBox[RowBox[
                          {SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "c", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox[
                          "\[Delta]", RowBox[{FormBox[FormBox["c120", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], \(4\ N\)], "+", 
                         FractionBox[RowBox[{SubscriptBox["\[Delta]", RowBox[
                          {FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "c120", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], \(4\ N\)], "+", 
                         FractionBox[RowBox[{SubscriptBox["\[Delta]", RowBox[
                          {FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c120", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox[
                          "d", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], \(4\ N\)], "+", RowBox[{
                          \(1\/8\), " ", "\[ImaginaryI]", " ", SubscriptBox[
                          "d", RowBox[{"c122", FormBox[FormBox["c120", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "c122"}]]}], "-", RowBox[{\(1\/8\), " ", 
                          "\[ImaginaryI]", " ", SubscriptBox["d", RowBox[
                          {"c122", FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          SubscriptBox["f", RowBox[{FormBox[FormBox["c120", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["e", "TraditionalForm"], 
                          "TraditionalForm"], "c122"}]]}]}], ")"}]}]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNTrace"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(t2, \(Explicit \[Rule] True\)\)]\)], "Input", 
               CellTags -> "SUNTrace"], Cell[BoxData[FormBox[RowBox[
                  {"tr", "(", FormBox[RowBox[{SubscriptBox["T", FormBox[
                        FormBox["a", "TraditionalForm"], "TraditionalForm"]], 
                      ".", SubscriptBox["T", FormBox[FormBox["b", 
                         "TraditionalForm"], "TraditionalForm"]], ".", 
                      SubscriptBox["T", FormBox[FormBox["c", 
                         "TraditionalForm"], "TraditionalForm"]], ".", 
                      SubscriptBox["T", FormBox[FormBox["d", 
                         "TraditionalForm"], "TraditionalForm"]], ".", 
                      SubscriptBox["T", FormBox[FormBox["e", 
                         "TraditionalForm"], "TraditionalForm"]]}], 
                    "TraditionalForm"], ")"}], TraditionalForm]], "Output", 
               CellTags -> "SUNTrace"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(SUNSimplify[\(\(SUNF[\(a, b, c\)]\)\ \(SUND[\(d, b, c\)]\)
                    \)]\)], "Input", CellTags -> "SUNTrace"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> "SUNTrace"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(SUNF[\(a, b, c\)]\)\ \(SUND[\(a, b, d\)]\)
                    \)]\)], "Input", CellTags -> "SUNTrace"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> "SUNTrace"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(SUNF[\(a, b, c\)]\)\ \(SUND[\(a, d, c\)]\)
                    \)]\)], "Input", CellTags -> "SUNTrace"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> "SUNTrace"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SUNSimplify[\(\(SUND[\(a, b, c\)]\)\ \(SUND[\(d, b, c\)]\)
                    \)]\)], "Input", CellTags -> "SUNTrace"], 
              Cell[BoxData[FormBox[RowBox[{\(-\((4 - C\_A\%2)\)\), " ", 
                   \((C\_A - \(2\ C\_F\))\), " ", SubscriptBox["\[Delta]", 
                    RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["d", 
                        "TraditionalForm"], "TraditionalForm"]}]]}], 
                 TraditionalForm]], "Output", CellTags -> "SUNTrace"]}, 
             Open]]}, Open]], Cell["SymbolicSum2", "ObjectName", 
         CellTags -> "SymbolicSum2"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "SymbolicSum2"], 
           Cell["SymbolicSum2 is similar to SymbolicSum \
(Algegra`SymbolicSum`SymbolicSum was a function to do symbolic summation. It \
was obsolete from version 3 - all functionality is now autoloaded by Sum), \
but extended to several double sums.", "Text", CellTags -> "SymbolicSum2"], 
           Cell[BoxData[""], "Input"]}, Open]], Cell["SymbolicSum3", 
         "ObjectName", CellTags -> "SymbolicSum3"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "SymbolicSum3"], Cell["SymbolicSymbolicSum3 is \
similar to SymbolicSum (Algegra`SymbolicSum`SymbolicSum was a function to do \
symbolic summation. It was obsolete from version 3 - all functionality is now \
autoloaded by Sum), but extended to several double sums.", "Text", 
            CellTags -> "SymbolicSum3"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["Symmetrize", "ObjectName", CellTags -> "Symmetrize"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Symmetrize"], Cell["Symmetrize[expr, {a1, a2, ...}] \
antisymmetrizes expr with respect to the variables a1,a2, ... ", "Text", 
            CellTags -> "Symmetrize"], Cell[TextData[{"See also: ", 
              ButtonBox["AntiSymmetrize", 
                RuleDelayed[ButtonData, "AntiSymmetrize"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "AntiSymmetrize"]], "."}], "Text", 
            CellTags -> "Symmetrize"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Symmetrize"], Cell[CellGroupData[{Cell[BoxData[
                \(Symmetrize[\(\(f[\(a, b\)]\), \({a, b}\)\)]\)], "Input", 
               CellTags -> "Symmetrize"], Cell[BoxData[
                \(TraditionalForm\`\(1\/2\ 
                     \((\(f(\(a, b\))\) + \(f(\(b, a\))\))\)\)\)], "Output", 
               CellTags -> "Symmetrize"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Symmetrize[\(\(f[\(x, y, z\)]\), \({x, y, z}\)\)]\)], 
               "Input", CellTags -> "Symmetrize"], Cell[BoxData[
                \(TraditionalForm\`\(1\/6\ 
                     \((\(f(\(x, y, z\))\) + \(f(\(x, z, y\))\) + 
                        \(f(\(y, x, z\))\) + \(f(\(y, z, x\))\) + 
                        \(f(\(z, x, y\))\) + \(f(\(z, y, x\))\))\)\)\)], 
               "Output", CellTags -> "Symmetrize"]}, Open]]}, Open]], 
        Cell["TBox, Tbox", "ObjectName", CellTags -> {"TBox", "Tbox"}], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> {"TBox", "Tbox"}], Cell["TBox[a, b, ...] or Tbox[a, \
b, ...] produces a RowBox[{a,b, ...}] where a, b, ... are boxed in \
TraditionalForm. TBox and Tbox are used internally by FeynCalc to produce the \
typeset output in TraditionalForm", "Text", CellTags -> {"TBox", "Tbox"}], 
           Cell[BoxData[""], "Input"]}, Open]], Cell["Tdec", "ObjectName", 
         CellTags -> "Tdec"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Tdec"], 
           Cell["Tdec[{q,mu}, {p}]; Tdec[{{qi, mu}, {qj, nu}, ...}, {p1, p2, \
...}] or Tdec[exp, {{qi, mu}, {qj, nu}, ...}, {p1, p2, ...}] calculates the \
tensorial decomposition formulas. The more common ones are saved in TIDL.", 
            "Text", CellTags -> "Tdec"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[Tdec]\)], "Input", CellTags -> "Tdec"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] D\), 
                      \(Factoring \[Rule] Factor2\), 
                      \(FeynCalcExternal \[Rule] True\), 
                      \(List \[Rule] True\), 
                      \(NumberOfMetricTensors \[Rule] \[Infinity]\)}\)\)], 
               "Output", CellTags -> "Tdec"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["TID", RuleDelayed[ButtonData, "TID"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TID"]], 
              ", ", 
              ButtonBox["TIDL", RuleDelayed[ButtonData, "TIDL"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TIDL"]], 
              ", ", 
              ButtonBox["OneLoopSimplify", 
                RuleDelayed[ButtonData, "OneLoopSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSimplify"]], "."}], "Text", 
            CellTags -> "Tdec"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "Tdec"], 
           Cell[TextData[{"Check that ", Cell[BoxData[
                \(TraditionalForm\`\(\(\[Integral] 
                       \(d\^D \(f(\(p, q\))\) q\^\[Mu]\)\) =\ 
                     \(p\^\[Mu]\/p\^2 \(\[Integral] 
                         \(d\^D \(f(\(p, q\))\) \(p \[CenterDot] q\)\)\)\)\)\
\)]]}], "Text", CellTags -> "Tdec"], Cell[CellGroupData[{Cell[BoxData[
                \(Tdec[\(\({q, \[Mu]}\), \({p}\)\)]\)], "Input", CellTags -> 
                "Tdec"], Cell[BoxData[FormBox[RowBox[{"{", RowBox[
                    {RowBox[{"{", RowBox[{\(X1 \[Rule] m\^2\), ",", RowBox[
                          {"X2", "\[Rule]", FormBox[RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "TraditionalForm"]}]}], 
                       "}"}], ",", \(\(X2\ p\^\[Mu]\)\/X1\)}], "}"}], 
                 TraditionalForm]], "Output", CellTags -> "Tdec"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(\(%[\([2]\)]\)/.\(%[\([1]\)]\)\)
                ], "Input", CellTags -> "Tdec"], Cell[BoxData[FormBox[
                 FractionBox[RowBox[{\(p\^\[Mu]\), " ", FormBox[RowBox[
                      {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                       FormBox["q", "TraditionalForm"]}], 
                     "TraditionalForm"]}], \(m\^2\)], TraditionalForm]], 
               "Output", CellTags -> "Tdec"]}, Open]], 
           Cell[TextData[{"This calculates integral transformation for any ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\[Integral] 
                     \(d\^D q\_1 d\^D q\_2 d\^D q\_3\)\)\)]], " ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\(f(\(p, \(q\_\(1,\) q\_2\), q\_3\))\)\ 
                     q\_1\%\[Mu] q\_2\%\[Nu] q\_3\%\[Rho]\)\)]], "."}], 
            "Text", CellTags -> "Tdec"], Cell[BoxData[
             \(\(t = \(Tdec[\(\({\({q\_1, \[Mu]}\), \({q\_2, \[Nu]}\), 
                         \({q\_3, \[Rho]}\)}\), \({p}\)\)]\)\) ;\)], "Input", 
            CellTags -> "Tdec"], Cell[CellGroupData[{Cell[BoxData[
                \(\(t[\([2]\)]\)/.\(t[\([1]\)]\)\)], "Input", CellTags -> 
                "Tdec"], Cell[BoxData[FormBox[RowBox[{FractionBox[RowBox[{
                      \((1 - D\^2)\), " ", \(p\^\[Rho]\), " ", 
                      \(g\^\(\[Mu]\[Nu]\)\), " ", FormBox[RowBox[{FormBox[
                          "p", "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(q\_3\), "TraditionalForm"]}], "TraditionalForm"], 
                      " ", RowBox[{"(", RowBox[{RowBox[{FormBox[RowBox[
                          {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(q\_1\), "TraditionalForm"]}], 
                          "TraditionalForm"], " ", FormBox[RowBox[{FormBox[
                          "p", "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(q\_2\), "TraditionalForm"]}], 
                          "TraditionalForm"]}], "-", RowBox[{\(m\^2\), " ", 
                          FormBox[RowBox[{FormBox[\(q\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"]}]}], 
                        ")"}]}], \(\((1 - D)\)\^2\ \((D + 1)\)\ m\^4\)], "+", 
                   FractionBox[RowBox[{\((1 - D\^2)\), " ", \(p\^\[Nu]\), 
                      " ", \(g\^\(\[Mu]\[Rho]\)\), " ", FormBox[RowBox[
                        {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                         FormBox[\(q\_2\), "TraditionalForm"]}], 
                       "TraditionalForm"], " ", RowBox[{"(", RowBox[
                         {RowBox[{FormBox[RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_1\)
                          , "TraditionalForm"]}], "TraditionalForm"], " ", 
                          FormBox[RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(q\_3\), 
                          "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                          RowBox[{\(m\^2\), " ", FormBox[RowBox[{FormBox[
                          \(q\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(q\_3\), "TraditionalForm"]}], 
                          "TraditionalForm"]}]}], ")"}]}], 
                    \(\((1 - D)\)\^2\ \((D + 1)\)\ m\^4\)], "+", FractionBox[
                    RowBox[{\((1 - D\^2)\), " ", \(p\^\[Mu]\), " ", 
                      \(g\^\(\[Nu]\[Rho]\)\), " ", FormBox[RowBox[
                        {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                         FormBox[\(q\_1\), "TraditionalForm"]}], 
                       "TraditionalForm"], " ", RowBox[{"(", RowBox[
                         {RowBox[{FormBox[RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], " ", 
                          FormBox[RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(q\_3\), 
                          "TraditionalForm"]}], "TraditionalForm"]}], "-", 
                          RowBox[{\(m\^2\), " ", FormBox[RowBox[{FormBox[
                          \(q\_2\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(q\_3\), "TraditionalForm"]}], 
                          "TraditionalForm"]}]}], ")"}]}], 
                    \(\((1 - D)\)\^2\ \((D + 1)\)\ m\^4\)], "-", FractionBox[
                    RowBox[{\((1 - D\^2)\), " ", \(p\^\[Mu]\), " ", 
                      \(p\^\[Nu]\), " ", \(p\^\[Rho]\), " ", RowBox[
                       {"(", RowBox[{RowBox[{RowBox[{"-", RowBox[{"(", 
                          FormBox[RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(q\_3\), 
                          "TraditionalForm"]}], "TraditionalForm"], ")"}]}], 
                          " ", FormBox[RowBox[{FormBox[\(q\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], " ", 
                          \(m\^2\)}], "-", RowBox[{FormBox[RowBox[{FormBox[
                          "p", "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(q\_2\), "TraditionalForm"]}], "TraditionalForm"], 
                          " ", FormBox[RowBox[{FormBox[\(q\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_3\)
                          , "TraditionalForm"]}], "TraditionalForm"], " ", 
                          \(m\^2\)}], "-", RowBox[{FormBox[RowBox[{FormBox[
                          "p", "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(q\_1\), "TraditionalForm"]}], "TraditionalForm"], 
                          " ", FormBox[RowBox[{FormBox[\(q\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_3\)
                          , "TraditionalForm"]}], "TraditionalForm"], " ", 
                          \(m\^2\)}], "+", RowBox[{"D", " ", FormBox[RowBox[
                          {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(q\_1\), "TraditionalForm"]}], 
                          "TraditionalForm"], " ", FormBox[RowBox[{FormBox[
                          "p", "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(q\_2\), "TraditionalForm"]}], "TraditionalForm"], 
                          " ", FormBox[RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_3\)
                          , "TraditionalForm"]}], "TraditionalForm"]}], "+", 
                          RowBox[{"2", " ", FormBox[RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_1\)
                          , "TraditionalForm"]}], "TraditionalForm"], " ", 
                          FormBox[RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(q\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], " ", 
                          FormBox[RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(q\_3\), 
                          "TraditionalForm"]}], "TraditionalForm"]}]}], 
                        ")"}]}], \(\((1 - D)\)\^2\ \((D + 1)\)\ m\^6\)]}], 
                 TraditionalForm]], "Output", CellTags -> "Tdec"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(Contract[\(\(%\ \(FVD[\(p, \[Mu]\)]\)\) 
                       \(FVD[\(p, \[Nu]\)]\)\ \(FVD[\(p, \[Rho]\)]\)\)]\)//
                   Factor\)], "Input", CellTags -> "Tdec"], Cell[BoxData[
                FormBox[RowBox[{\(1\/\(\((D - 1)\)\ m\^6\)\), RowBox[
                    {"(", RowBox[{SuperscriptBox[FormBox["p", 
                         "TraditionalForm"], "4"], " ", RowBox[{"(", RowBox[
                          {RowBox[{RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(q\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[\(q\_1\)
                          , "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(q\_2\), "TraditionalForm"]}], " ", \(m\^4\)}], 
                          "+", RowBox[{RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_2\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox[
                          \(q\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(q\_3\), "TraditionalForm"]}], " ", 
                          \(m\^4\)}], "+", RowBox[{RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_1\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox[
                          \(q\_2\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(q\_3\), "TraditionalForm"]}], " ", 
                          \(m\^4\)}], "-", RowBox[{"3", " ", RowBox[{FormBox[
                          "p", "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(q\_1\), "TraditionalForm"]}], " ", RowBox[
                          {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(q\_2\), "TraditionalForm"]}], " ", 
                          RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(q\_3\), 
                          "TraditionalForm"]}], " ", \(m\^2\)}], "-", RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], " ", RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(q\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[\(q\_1\)
                          , "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(q\_2\), "TraditionalForm"]}], " ", \(m\^2\)}], 
                          "-", RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_2\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox[
                          \(q\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(q\_3\), "TraditionalForm"]}], " ", 
                          \(m\^2\)}], "-", RowBox[{SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], " ", RowBox[
                          {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(q\_1\), "TraditionalForm"]}], " ", 
                          RowBox[{FormBox[\(q\_2\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(q\_3\), 
                          "TraditionalForm"]}], " ", \(m\^2\)}], "+", RowBox[
                          {"D", " ", SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], "2"], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_1\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_2\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_3\)
                          , "TraditionalForm"]}]}], "+", RowBox[{"2", " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], " ", RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(q\_1\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_2\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(q\_3\)
                          , "TraditionalForm"]}]}]}], ")"}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> "Tdec"]}, Open]], 
           Cell[BoxData[\(\(Clear[t]\) ;\)], "Input", CellTags -> "Tdec"]}, 
          Open]], Cell["TensorFunction", "ObjectName", 
         CellTags -> "TensorFunction"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "TensorFunction"], Cell["Tensorfunction[t, mu, nu, ...] \
transform into t[LorentzIndex[mu], LorentzIndex[nu], ...], i.e., it can be \
used as an unspecified tensoriell function t. A symmetric tensor can be \
obtained by Tensorfunction[{t, \"S\"}, mu, nu, ...], and an antisymmteric one \
by Tensorfunction[{t, \"A\"}, mu, nu, ...].", "Text", CellTags -> 
             "TensorFunction"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Symmetrize", RuleDelayed[ButtonData, "Symmetrize"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Symmetrize"]], "."}], "Text", 
            CellTags -> "TensorFunction"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "TensorFunction"], Cell[CellGroupData[{Cell[BoxData[
                \(Tensorfunction[\(t, \[Mu], \[Nu], \[Tau]\)]\)], "Input", 
               CellTags -> "TensorFunction"], Cell[BoxData[
                \(TraditionalForm\`\(Tensorfunction(
                     \(t, \[Mu], \[Nu], \[Tau]\))\)\)], "Output", CellTags -> 
                "TensorFunction"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%//StandardForm\)], "Input", CellTags -> "TensorFunction"], 
              Cell[BoxData[\(Tensorfunction[\(t, \[Mu], \[Nu], \[Tau]\)]\)], 
               "Output", CellTags -> "TensorFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Contract[\(\(FV[\(p, \[Mu]\)]\)\ %\)]\)], "Input", 
               CellTags -> "TensorFunction"], Cell[BoxData[FormBox[
                 RowBox[{SuperscriptBox[FormBox["p", "TraditionalForm"], 
                    FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], " ", 
                   \(Tensorfunction(t, \[Mu], \[Nu], \[Tau])\)}], 
                 TraditionalForm]], "Output", CellTags -> "TensorFunction"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], 
               "Input", CellTags -> "TensorFunction"], Cell[BoxData[
                \(\(Pair[\(\(LorentzIndex[\[Mu]]\), \(Momentum[p]\)\)]\)\ 
                   \(Tensorfunction[\(t, \[Mu], \[Nu], \[Tau]\)]\)\)], 
               "Output", CellTags -> "TensorFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Tensorfunction[\(\({f, "S"}\), \[Alpha], \[Beta]\)]\)], 
               "Input", CellTags -> "TensorFunction"], Cell[BoxData[
                \(TraditionalForm\`\(Tensorfunction(
                     \(\({f, "S"}\), \[Alpha], \[Beta]\))\)\)], "Output", 
               CellTags -> "TensorFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Tensorfunction[\(\({f, "S"}\), \[Beta], \[Alpha]\)]\)], 
               "Input", CellTags -> "TensorFunction"], Cell[BoxData[
                \(TraditionalForm\`\(Tensorfunction(
                     \(\({f, "S"}\), \[Beta], \[Alpha]\))\)\)], "Output", 
               CellTags -> "TensorFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "TensorFunction"], Cell[BoxData[
                \(Tensorfunction[\(\({f, "S"}\), \[Beta], \[Alpha]\)]\)], 
               "Output", CellTags -> "TensorFunction"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Attributes[f]\)], "Input", 
               CellTags -> "TensorFunction"], Cell[BoxData[
                \(TraditionalForm\`\({}\)\)], "Output", CellTags -> 
                "TensorFunction"]}, Open]], Cell[BoxData[
             \(ClearAttributes[\(f, Orderless\)]\)], "Input", 
            CellTags -> "TensorFunction"]}, Open]], Cell["Tf", "ObjectName", 
         CellTags -> "Tf"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "Tf"], 
           Cell[TextData[{"Tf is the color factor ", Cell[BoxData[
                \(TraditionalForm\`T\_f\)]], ". It is 1/2 for SU(", 
              StyleBox["N", Rule[FontSlant, "Italic"]], ")."}], "Text", 
            CellTags -> "Tf"], Cell[TextData[{"See also: ", 
              ButtonBox["Tr2", RuleDelayed[ButtonData, "Tr2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Tr2"]], 
              ", ", 
              ButtonBox["GluonPropagator", 
                RuleDelayed[ButtonData, "GluonPropagator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonPropagator"]], ", ", 
              ButtonBox["GluonSelfEnergy", 
                RuleDelayed[ButtonData, "GluonSelfEnergy"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "GluonSelfEnergy"]], "."}], "Text", 
            CellTags -> "Tf"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["ThreeVector", "ObjectName", CellTags -> "ThreeVector"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ThreeVector"], 
           Cell["ThreeVector[p] is the three dimensional vector p.", "Text", 
            CellTags -> "ThreeVector"], Cell[TextData[{"See also: ", 
              ButtonBox["DotProduct", RuleDelayed[ButtonData, "DotProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DotProduct"]], ", ", 
              ButtonBox["CrossProduct", 
                RuleDelayed[ButtonData, "CrossProduct"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "CrossProduct"]], "."}], "Text", 
            CellTags -> "ThreeVector"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["TID", "ObjectName", CellTags -> "TID"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "TID"], Cell[
            "TID[amp,q] performs a tensorial decomposition.", "Text", 
            CellTags -> "TID"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[TID]\)], "Input", CellTags -> "TID"], Cell[BoxData[
                \(TraditionalForm\`\({\(Collecting \[Rule] True\), 
                      \(Contract \[Rule] False\), \(Dimension \[Rule] D\), 
                      \(ChangeDimension \[Rule] D\), 
                      \(DimensionalReduction \[Rule] False\), 
                      \(FeynAmpDenominatorCombine \[Rule] True\), 
                      \(FeynAmpDenominatorSimplify \[Rule] False\), 
                      \(Isolate \[Rule] False\), 
                      \(ScalarProductCancel \[Rule] False\)}\)\)], "Output", 
               CellTags -> "TID"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoopSimplify", 
                RuleDelayed[ButtonData, "OneLoopSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSimplify"]], ", ", 
              ButtonBox["TIDL", RuleDelayed[ButtonData, "TIDL"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TIDL"]], 
              "."}], "Text", CellTags -> "TID"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "TID"], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(FAD[\(k,\ \(k\ -\ p\_1\),\ \(k\ -\ p\_2\)\)]\) 
                     \(FVD[\(k, \[Mu]\)]\)\)//FCI\)], "Input", CellTags -> 
                "TID"], Cell[BoxData[FormBox[FractionBox[SuperscriptBox[
                   FormBox[FormBox[
                     TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                       Function[StyleForm[Slot[1], 
                         Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                    "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                     "TraditionalForm"], "TraditionalForm"]], RowBox[
                   {SuperscriptBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\)}], ")"}], "2"], 
                    ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_2\)}], ")"}], 
                     "2"]}]], TraditionalForm]], "Output", CellTags -> 
                "TID"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(Factor/@\(TID[\(%, k\)]\)\)//FCE\)], "Input", CellTags -> 
                "TID"], Cell[BoxData[FormBox[RowBox[{FractionBox[RowBox[
                     {FormBox[FractionBox["1", RowBox[{RowBox[{"(", 
                          InterpretationBox[RowBox[{"\"[\"", 
                          "\[InvisibleSpace]", SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], "\[InvisibleSpace]", 
                          "\"]\""}], "["k^2"]", Editable -> False], ")"}], 
                          " ", RowBox[{"(", InterpretationBox[RowBox[
                          {"\"[\"", "\[InvisibleSpace]", SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\)}], ")"}], "2"], 
                          "\[InvisibleSpace]", "\"]\""}], "["(k - Subscript[
                          p, 1])^2"]", Editable -> False], ")"}], " ", 
                          RowBox[{"(", InterpretationBox[RowBox[{"\"[\"", 
                          "\[InvisibleSpace]", SuperscriptBox[RowBox[{"(", 
                          RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_2\)}], ")"}], "2"], 
                          "\[InvisibleSpace]", "\"]\""}], "["(k - Subscript[
                          p, 2])^2"]", Editable -> False], ")"}]}]], 
                       "TraditionalForm"], " ", FormBox[RowBox[{FormBox[
                          FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                         "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], " ", 
                      RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox["p", 
                          FormBox["2", "TraditionalForm"], "\[Mu]"], " ", 
                          FormBox[\(p\_1\%2\), "TraditionalForm"]}], "-", 
                          FractionBox[RowBox[{"s", " ", SubsuperscriptBox[
                          "p", FormBox["1", "TraditionalForm"], "\[Mu]"]}], 
                          "2"]}], ")"}]}], RowBox[{RowBox[{FormBox[\(p\_1\%2\)
                         , "TraditionalForm"], " ", FormBox[\(p\_2\%2\), 
                         "TraditionalForm"]}], "-", \(s\^2\/4\)}]], "+", 
                   FractionBox[RowBox[{FormBox[FractionBox["1", RowBox[
                         {RowBox[{"(", InterpretationBox[RowBox[{"\"[\"", 
                          "\[InvisibleSpace]", SuperscriptBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "2"], "\[InvisibleSpace]", 
                          "\"]\""}], "["k^2"]", Editable -> False], ")"}], 
                          " ", RowBox[{"(", InterpretationBox[RowBox[
                          {"\"[\"", "\[InvisibleSpace]", SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_1\)}], ")"}], "2"], 
                          "\[InvisibleSpace]", "\"]\""}], "["(k - Subscript[
                          p, 1])^2"]", Editable -> False], ")"}], " ", 
                          RowBox[{"(", InterpretationBox[RowBox[{"\"[\"", 
                          "\[InvisibleSpace]", SuperscriptBox[RowBox[{"(", 
                          RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", \(p\_2\)}], ")"}], "2"], 
                          "\[InvisibleSpace]", "\"]\""}], "["(k - Subscript[
                          p, 2])^2"]", Editable -> False], ")"}]}]], 
                       "TraditionalForm"], " ", FormBox[RowBox[{FormBox[
                          FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                         "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}], "TraditionalForm"], " ", 
                      RowBox[{"(", RowBox[{FractionBox[RowBox[{"s", " ", 
                          SubsuperscriptBox["p", FormBox["2", 
                          "TraditionalForm"], "\[Mu]"]}], "2"], "-", RowBox[
                          {SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], "\[Mu]"], " ", FormBox[
                          \(p\_2\%2\), "TraditionalForm"]}]}], ")"}]}], 
                    RowBox[{\(s\^2\/4\), "-", RowBox[{FormBox[\(p\_1\%2\), 
                         "TraditionalForm"], " ", FormBox[\(p\_2\%2\), 
                         "TraditionalForm"]}]}]]}], TraditionalForm]], 
               "Output", CellTags -> "TID"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(\(FAD[\(k,\ \(k\ -\ p\)\)]\) \(FVD[\(k, \[Mu]\)]\)\)//FCI
                  \)], "Input", CellTags -> "TID"], Cell[BoxData[
                FormBox[FractionBox[SuperscriptBox[FormBox[FormBox[
                     TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                       Function[StyleForm[Slot[1], 
                         Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                    "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                     "TraditionalForm"], "TraditionalForm"]], RowBox[
                   {SuperscriptBox[FormBox[
                      TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                     "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "p"}], ")"}], "2"]}]], 
                 TraditionalForm]], "Output", CellTags -> "TID"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(TID[\(%, k\)]\)], "Input", 
               CellTags -> "TID"], Cell[BoxData[FormBox[FractionBox[
                  RowBox[{SuperscriptBox[FormBox["p", "TraditionalForm"], 
                     FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                      "TraditionalForm"]], " ", RowBox[{FormBox[FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                       "TraditionalForm"]}]}], RowBox[{RowBox[{SuperscriptBox[
                       FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "p"}], ")"}], "2"]}], " ", 
                    SuperscriptBox[FormBox["p", "TraditionalForm"], "2"]}]], 
                 TraditionalForm]], "Output", CellTags -> "TID"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TID[\(%%, k, \(FeynAmpDenominatorSimplify \[Rule] True\)\)]
                  \)], "Input", CellTags -> "TID"], Cell[BoxData[
                FormBox[FractionBox[RowBox[{SuperscriptBox[FormBox["p", 
                      "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                       "TraditionalForm"], "TraditionalForm"]], " ", 
                    RowBox[{FormBox[FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                       "TraditionalForm"]}]}], RowBox[{RowBox[{SuperscriptBox[
                       FormBox[
                        TagBox[StyleBox["\"k\"", Rule[FontSlant, "Italic"]], 
                          Function[StyleForm[Slot[1], 
                            Rule[FontSlant, "Italic"]]]], "TraditionalForm"], 
                       "2"], ".", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "-", "p"}], ")"}], "2"]}], " ", 
                    SuperscriptBox[FormBox["p", "TraditionalForm"], "2"]}]], 
                 TraditionalForm]], "Output", CellTags -> "TID"]}, Open]]}, 
          Open]], Cell["TIDL", "ObjectName", CellTags -> "TIDL"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "TIDL"], Cell[
            " TIDL is a database of tensorial reduction formalae.", "Text", 
            CellTags -> "TIDL"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["TID", RuleDelayed[ButtonData, "TID"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TID"]]}], 
            "Text", CellTags -> "TIDL"]}, Open]], Cell["Examples", 
         "Subsubsection", CellTags -> "TIDL"], 
        Cell[CellGroupData[{Cell[TextData[Cell[BoxData[
               \(TraditionalForm\`\(B\_\[Mu] - type\)\)]]], "Subsubsection", 
            CellTags -> "TIDL"], Cell[TextData[
             {"In any n-dimensional integral ", Cell[BoxData[
                \(TraditionalForm\`\(\[Integral] 
                     \(d\^n \[NegativeVeryThinSpace] q\^\[Mu]\ 
                       \(f(\(q, p\))\)\ the\ q\^\[Mu]\)\ \)\)]], 
              "can be replaced by"}], "Text", CellTags -> "TIDL"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TIDL[\(\({q, \[Mu]}\), \({p}\)\)]\)], "Input", CellTags -> 
                "TIDL"], Cell[BoxData[FormBox[FractionBox[RowBox[
                   {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                     FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                      "TraditionalForm"]], " ", RowBox[{FormBox["p", 
                       "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                       "TraditionalForm"]}]}], SuperscriptBox[FormBox["p", 
                    "TraditionalForm"], "2"]], TraditionalForm]], "Output", 
               CellTags -> "TIDL"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell[TextData[Cell[BoxData[
               \(TraditionalForm\`\(B\_\[Mu]\[Nu] - type\)\)]]], 
            "Subsubsection", CellTags -> "TIDL"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TIDL[\(\({\({q, \[Mu]}\), \({q, \[Nu]}\)}\), \({p}\)\)]\)], 
               "Input", CellTags -> "TIDL"], Cell[BoxData[FormBox[
                 RowBox[{FractionBox[RowBox[{\(g\^\(\[Mu]\[Nu]\)\), " ", 
                      RowBox[{"(", RowBox[{SuperscriptBox[FormBox[RowBox[
                          {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["q", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"], "-", RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], " ", SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], "2"]}]}], ")"}]}], RowBox[{
                      \((1 - D)\), " ", SuperscriptBox[FormBox["p", 
                        "TraditionalForm"], "2"]}]], "-", FractionBox[
                    RowBox[{SuperscriptBox[FormBox["p", "TraditionalForm"], 
                       FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", SuperscriptBox[FormBox["p", 
                        "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                         "TraditionalForm"], "TraditionalForm"]], " ", 
                      RowBox[{"(", RowBox[{RowBox[{"D", " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"]}], "-", RowBox[
                          {SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          "2"], " ", SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], "2"]}]}], ")"}]}], RowBox[{
                      \((1 - D)\), " ", SuperscriptBox[FormBox["p", 
                        "TraditionalForm"], "4"]}]]}], TraditionalForm]], 
               "Output", CellTags -> "TIDL"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell[TextData[Cell[BoxData[
               \(TraditionalForm\`\(C\_\[Mu] - type\)\)]]], "Subsubsection", 
            CellTags -> "TIDL"], Cell[CellGroupData[{Cell[BoxData[
                \(TIDL[\(\({q, \[Mu]}\), \({p\_1, p\_2}\)\)]\)], "Input", 
               CellTags -> "TIDL"], Cell[BoxData[FormBox[RowBox[
                  {FractionBox[RowBox[{RowBox[{SubsuperscriptBox["p", 
                         FormBox["2", "TraditionalForm"], FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                        " ", RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[\(p\_1\)
                          , "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(p\_2\), "TraditionalForm"]}]}], "-", RowBox[
                       {SubsuperscriptBox["p", FormBox["2", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], " ", \(p\_1\%2\)}]}], 
                    RowBox[{SuperscriptBox[FormBox[RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                      "-", \(p\_1\%2\ p\_2\%2\)}]], "+", FractionBox[
                    RowBox[{RowBox[{SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[\(p\_1\)
                          , "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(p\_2\), "TraditionalForm"]}]}], "-", RowBox[
                       {SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                        RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}], " ", \(p\_2\%2\)}]}], 
                    RowBox[{SuperscriptBox[FormBox[RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                      "-", \(p\_1\%2\ p\_2\%2\)}]]}], TraditionalForm]], 
               "Output", CellTags -> "TIDL"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell[TextData[Cell[BoxData[
               \(TraditionalForm\`\(C\_\[Mu]\[Nu] - type\)\)]]], 
            "Subsubsection", CellTags -> "TIDL"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TIDL[\(\({\({q, \[Mu]}\), \({q, \[Nu]}\)}\), 
                     \({p\_1, p\_2}\)\)]\)], "Input", CellTags -> "TIDL"], 
              Cell[BoxData[FormBox[RowBox[{FractionBox[RowBox[{
                      \(g\^\(\[Mu]\[Nu]\)\), " ", RowBox[{"(", RowBox[
                         {RowBox[{\(p\_2\%2\), " ", SuperscriptBox[FormBox[
                          RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "-", RowBox[{"2", " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox[
                          \(p\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}], " ", 
                          RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["q", "TraditionalForm"], "2"], " ", 
                          SuperscriptBox[FormBox[RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "+", RowBox[{SuperscriptBox[FormBox[RowBox[
                          {FormBox["q", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}], 
                          "TraditionalForm"], "2"], " ", \(p\_1\%2\)}], "-", 
                          RowBox[{SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], "2"], " ", \(p\_1\%2\), " ", 
                          \(p\_2\%2\)}]}], ")"}]}], RowBox[{\((D - 2)\), " ", 
                      RowBox[{"(", RowBox[{SuperscriptBox[FormBox[RowBox[
                          {FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          "-", \(p\_1\%2\ p\_2\%2\)}], ")"}]}]], "+", 
                   RowBox[{FractionBox["1", RowBox[{\((D - 2)\), " ", 
                        SuperscriptBox[RowBox[{"(", RowBox[{SuperscriptBox[
                          FormBox[RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          "-", \(p\_1\%2\ p\_2\%2\)}], ")"}], "2"]}]], 
                     RowBox[{"(", RowBox[{SubsuperscriptBox["p", FormBox["2", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         SubsuperscriptBox["p", FormBox["2", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         RowBox[{"(", RowBox[{RowBox[{"D", " ", 
                          SuperscriptBox[FormBox[RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "-", RowBox[{"2", " ", SuperscriptBox[FormBox[
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "+", RowBox[{\(p\_1\%2\), " ", \(p\_2\%2\), " ", 
                          SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "-", RowBox[{"2", " ", "D", " ", RowBox[{FormBox[
                          "q", "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(p\_2\), "TraditionalForm"]}], " ", \(p\_1\%2\), 
                          " ", RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}]}], "+", RowBox[{"2", " ", 
                          RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], " ", \(p\_1\%2\), " ", RowBox[
                          {FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}]}], "+", RowBox[{"D", " ", 
                          SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", \(p\_1\%4\)}], "-", RowBox[{SuperscriptBox[
                          FormBox[RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", \(p\_1\%4\)}], "+", RowBox[{SuperscriptBox[
                          FormBox["q", "TraditionalForm"], "2"], " ", 
                          \(p\_1\%2\), " ", SuperscriptBox[FormBox[RowBox[
                          {FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "-", RowBox[{SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], "2"], " ", \(p\_1\%4\), " ", 
                          \(p\_2\%2\)}]}], ")"}]}], ")"}]}], "+", 
                   RowBox[{FractionBox["1", RowBox[{\((D - 2)\), " ", 
                        SuperscriptBox[RowBox[{"(", RowBox[{SuperscriptBox[
                          FormBox[RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          "-", \(p\_1\%2\ p\_2\%2\)}], ")"}], "2"]}]], 
                     RowBox[{"(", RowBox[{SubsuperscriptBox["p", FormBox["2", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         RowBox[{"(", RowBox[{RowBox[{RowBox[{"-", 
                          SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          "2"]}], " ", SuperscriptBox[FormBox[RowBox[{FormBox[
                          \(p\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}], 
                          "TraditionalForm"], "3"]}], "+", RowBox[{"D", " ", 
                          RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], " ", SuperscriptBox[FormBox[
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "-", RowBox[{"D", " ", SuperscriptBox[FormBox[
                          RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", \(p\_1\%2\), " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}]}], "+", RowBox[
                          {SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", \(p\_1\%2\), " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}]}], "-", RowBox[{"D", " ", 
                          SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", \(p\_2\%2\), " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}]}], "+", RowBox[
                          {SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", \(p\_2\%2\), " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}]}], "+", RowBox[
                          {SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          "2"], " ", \(p\_1\%2\), " ", \(p\_2\%2\), " ", 
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{"D", " ", 
                          RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], " ", \(p\_1\%2\), " ", 
                          \(p\_2\%2\)}], "-", RowBox[{"2", " ", RowBox[
                          {FormBox["q", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_1\), "TraditionalForm"]}], " ", RowBox[
                          {FormBox["q", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}], " ", 
                          \(p\_1\%2\), " ", \(p\_2\%2\)}]}], ")"}]}], 
                       ")"}]}], "+", RowBox[{FractionBox["1", RowBox[{
                        \((D - 2)\), " ", SuperscriptBox[RowBox[{"(", RowBox[
                          {SuperscriptBox[FormBox[RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          "-", \(p\_1\%2\ p\_2\%2\)}], ")"}], "2"]}]], 
                     RowBox[{"(", RowBox[{SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         SubsuperscriptBox["p", FormBox["2", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         RowBox[{"(", RowBox[{RowBox[{RowBox[{"-", 
                          SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          "2"]}], " ", SuperscriptBox[FormBox[RowBox[{FormBox[
                          \(p\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}], 
                          "TraditionalForm"], "3"]}], "+", RowBox[{"D", " ", 
                          RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], " ", SuperscriptBox[FormBox[
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "-", RowBox[{"D", " ", SuperscriptBox[FormBox[
                          RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", \(p\_1\%2\), " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}]}], "+", RowBox[
                          {SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", \(p\_1\%2\), " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}]}], "-", RowBox[{"D", " ", 
                          SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", \(p\_2\%2\), " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}]}], "+", RowBox[
                          {SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", \(p\_2\%2\), " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}]}], "+", RowBox[
                          {SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          "2"], " ", \(p\_1\%2\), " ", \(p\_2\%2\), " ", 
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{"D", " ", 
                          RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], " ", \(p\_1\%2\), " ", 
                          \(p\_2\%2\)}], "-", RowBox[{"2", " ", RowBox[
                          {FormBox["q", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_1\), "TraditionalForm"]}], " ", RowBox[
                          {FormBox["q", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}], " ", 
                          \(p\_1\%2\), " ", \(p\_2\%2\)}]}], ")"}]}], 
                       ")"}]}], "+", RowBox[{FractionBox["1", RowBox[{
                        \((D - 2)\), " ", SuperscriptBox[RowBox[{"(", RowBox[
                          {SuperscriptBox[FormBox[RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          "-", \(p\_1\%2\ p\_2\%2\)}], ")"}], "2"]}]], 
                     RowBox[{"(", RowBox[{SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         SubsuperscriptBox["p", FormBox["1", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         RowBox[{"(", RowBox[{RowBox[{"D", " ", 
                          SuperscriptBox[FormBox[RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "-", RowBox[{"2", " ", SuperscriptBox[FormBox[
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "+", RowBox[{\(p\_1\%2\), " ", \(p\_2\%2\), " ", 
                          SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "-", RowBox[{"2", " ", "D", " ", RowBox[{FormBox[
                          "q", "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(p\_1\), "TraditionalForm"]}], " ", RowBox[
                          {FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], " ", \(p\_2\%2\), " ", RowBox[
                          {FormBox["q", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}]}], "+", 
                          RowBox[{"2", " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox[
                          \(p\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}], " ", 
                          \(p\_2\%2\), " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}]}], "+", RowBox[{"D", " ", 
                          SuperscriptBox[FormBox[RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", \(p\_2\%4\)}], "-", RowBox[{SuperscriptBox[
                          FormBox[RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", \(p\_2\%4\)}], "-", RowBox[{SuperscriptBox[
                          FormBox["q", "TraditionalForm"], "2"], " ", 
                          \(p\_1\%2\), " ", \(p\_2\%4\)}], "+", RowBox[
                          {SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          "2"], " ", SuperscriptBox[FormBox[RowBox[{FormBox[
                          \(p\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}], 
                          "TraditionalForm"], "2"], " ", \(p\_2\%2\)}]}], 
                          ")"}]}], ")"}]}]}], TraditionalForm]], "Output", 
               CellTags -> "TIDL"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell[TextData[Cell[BoxData[
               \(TraditionalForm\`\(C\_\[Mu]\[Nu]\[Rho] - type\)\)]]], 
            "Subsubsection", CellTags -> "TIDL"], Cell[BoxData[
             \(\(TIDL[\(\({\({q, \[Mu]}\), \({q, \[Nu]}\), \({q, \[Rho]}\)}\)
                    , \({p, k}\)\)]\) ;\)], "Input", CellTags -> "TIDL"]}, 
          Open]], Cell[CellGroupData[{Cell[TextData[Cell[BoxData[
               \(TraditionalForm\`\(C\_\[Mu]\[Nu]\[Rho]\[Sigma] - type\)\)]]]\
, "Subsubsection", CellTags -> "TIDL"], Cell[BoxData[
             \(\(TIDL[\(\({\({q, \[Mu]}\), \({q, \[Nu]}\), \({q, \[Rho]}\), 
                       \({q, \[Sigma]}\)}\), \({p, k}\)\)]\) ;\)], "Input", 
            CellTags -> "TIDL"]}, Open]], Cell[CellGroupData[
          {Cell[TextData[Cell[BoxData[\(TraditionalForm\`\(D\_\[Mu] - type\)\)
               ]]], "Subsubsection", CellTags -> "TIDL"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TIDL[\(\({q, \[Mu]}\), \({p\_1, p\_2, p\_3}\)\)]\)], 
               "Input", CellTags -> "TIDL"], Cell[BoxData[FormBox[
                 RowBox[{FractionBox[RowBox[{SubsuperscriptBox["p", FormBox[
                        "3", "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                         "TraditionalForm"], "TraditionalForm"]], " ", 
                      RowBox[{"(", RowBox[{RowBox[{RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_3\)
                          , "TraditionalForm"]}], " ", SuperscriptBox[FormBox[
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "-", RowBox[{RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox[
                          \(p\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_3\), "TraditionalForm"]}], " ", 
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{RowBox[
                          {FormBox["q", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_1\), "TraditionalForm"]}], " ", 
                          RowBox[{FormBox[\(p\_2\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[\(p\_1\)
                          , "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(p\_2\), "TraditionalForm"]}]}], "-", RowBox[
                          {RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_3\), 
                          "TraditionalForm"]}], " ", \(p\_1\%2\), " ", 
                          \(p\_2\%2\)}], "+", RowBox[{RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox[
                          \(p\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_3\), "TraditionalForm"]}], " ", 
                          \(p\_2\%2\)}], "+", RowBox[{RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], " ", \(p\_1\%2\), " ", 
                          RowBox[{FormBox[\(p\_2\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_3\), 
                          "TraditionalForm"]}]}]}], ")"}]}], RowBox[{RowBox[{
                        \(p\_3\%2\), " ", SuperscriptBox[FormBox[RowBox[
                          {FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                      "-", RowBox[{"2", " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_3\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox[
                          \(p\_2\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_3\), "TraditionalForm"]}], " ", 
                        RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{\(p\_1\%2\), 
                        " ", SuperscriptBox[FormBox[RowBox[{FormBox[\(p\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_3\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                      "+", RowBox[{SuperscriptBox[FormBox[RowBox[{FormBox[
                          \(p\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_3\), "TraditionalForm"]}], 
                          "TraditionalForm"], "2"], " ", \(p\_2\%2\)}], "-", 
                      \(p\_1\%2\ p\_2\%2\ p\_3\%2\)}]], "-", FractionBox[
                    RowBox[{SubsuperscriptBox["p", FormBox["2", 
                        "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                         "TraditionalForm"], "TraditionalForm"]], " ", 
                      RowBox[{"(", RowBox[{RowBox[{RowBox[{"-", RowBox[{"(", 
                          RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], ")"}]}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_3\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "+", RowBox[{RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_3\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox[
                          \(p\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}], " ", 
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_3\), 
                          "TraditionalForm"]}]}], "+", RowBox[{RowBox[
                          {FormBox["q", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_1\), "TraditionalForm"]}], " ", 
                          RowBox[{FormBox[\(p\_2\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[\(p\_1\)
                          , "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(p\_3\), "TraditionalForm"]}]}], "-", RowBox[
                          {RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_3\), 
                          "TraditionalForm"]}], " ", \(p\_1\%2\), " ", 
                          RowBox[{FormBox[\(p\_2\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_3\), 
                          "TraditionalForm"]}]}], "+", RowBox[{RowBox[
                          {FormBox["q", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}], " ", 
                          \(p\_1\%2\), " ", \(p\_3\%2\)}], "-", RowBox[
                          {RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_1\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[\(p\_1\)
                          , "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(p\_2\), "TraditionalForm"]}], " ", \(p\_3\%2\)}]}]
                          , ")"}]}], RowBox[{RowBox[{\(p\_3\%2\), " ", 
                        SuperscriptBox[FormBox[RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                      "-", RowBox[{"2", " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_3\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox[
                          \(p\_2\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_3\), "TraditionalForm"]}], " ", 
                        RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{\(p\_1\%2\), 
                        " ", SuperscriptBox[FormBox[RowBox[{FormBox[\(p\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_3\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                      "+", RowBox[{SuperscriptBox[FormBox[RowBox[{FormBox[
                          \(p\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_3\), "TraditionalForm"]}], 
                          "TraditionalForm"], "2"], " ", \(p\_2\%2\)}], "-", 
                      \(p\_1\%2\ p\_2\%2\ p\_3\%2\)}]], "+", FractionBox[
                    RowBox[{SubsuperscriptBox["p", FormBox["1", 
                        "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                         "TraditionalForm"], "TraditionalForm"]], " ", 
                      RowBox[{"(", RowBox[{RowBox[{RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}], " ", SuperscriptBox[FormBox[
                          RowBox[{FormBox[\(p\_2\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_3\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                          "-", RowBox[{RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_3\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox[
                          \(p\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}], " ", 
                          RowBox[{FormBox[\(p\_2\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{RowBox[
                          {FormBox["q", "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}], " ", 
                          RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[\(p\_2\)
                          , "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(p\_3\), "TraditionalForm"]}]}], "+", RowBox[
                          {RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[\(p\_1\)
                          , "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(p\_3\), "TraditionalForm"]}], " ", \(p\_2\%2\)}], 
                          "+", RowBox[{RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_2\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox[
                          \(p\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_2\), "TraditionalForm"]}], " ", 
                          \(p\_3\%2\)}], "-", RowBox[{RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_1\)
                          , "TraditionalForm"]}], " ", \(p\_2\%2\), " ", 
                          \(p\_3\%2\)}]}], ")"}]}], RowBox[{RowBox[{
                        \(p\_3\%2\), " ", SuperscriptBox[FormBox[RowBox[
                          {FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                      "-", RowBox[{"2", " ", RowBox[{FormBox[\(p\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_3\)
                          , "TraditionalForm"]}], " ", RowBox[{FormBox[
                          \(p\_2\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_3\), "TraditionalForm"]}], " ", 
                        RowBox[{FormBox[\(p\_1\), "TraditionalForm"], 
                          "\[CenterDot]", FormBox[\(p\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{\(p\_1\%2\), 
                        " ", SuperscriptBox[FormBox[RowBox[{FormBox[\(p\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[\(p\_3\)
                          , "TraditionalForm"]}], "TraditionalForm"], "2"]}], 
                      "+", RowBox[{SuperscriptBox[FormBox[RowBox[{FormBox[
                          \(p\_1\), "TraditionalForm"], "\[CenterDot]", 
                          FormBox[\(p\_3\), "TraditionalForm"]}], 
                          "TraditionalForm"], "2"], " ", \(p\_2\%2\)}], "-", 
                      \(p\_1\%2\ p\_2\%2\ p\_3\%2\)}]]}], TraditionalForm]], 
               "Output", CellTags -> "TIDL"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell[TextData[Cell[BoxData[
               \(TraditionalForm\`\(D\_\[Mu]\[Nu] - type\)\)]]], 
            "Subsubsection", CellTags -> "TIDL"], Cell[BoxData[
             \(\(TIDL[\(\({\({q, \[Mu]}\), \({q, \[Nu]}\)}\), \({p, k, r}\)\)
                  ]\) ;\)], "Input", CellTags -> "TIDL"]}, Open]], 
        Cell[CellGroupData[{Cell[TextData[Cell[BoxData[
               \(TraditionalForm\`\(D\_\[Mu]\[Nu]\[Rho] - type\)\)]]], 
            "Subsubsection", CellTags -> "TIDL"], Cell[BoxData[
             \(\(TIDL[\(\({\({q, \[Mu]}\), \({q, \[Nu]}\), \({q, \[Rho]}\)}\)
                    , \({p, k, r}\)\)]\) ;\)], "Input", CellTags -> "TIDL"]}, 
          Open]], Cell[CellGroupData[{Cell[TextData[Cell[BoxData[
               \(TraditionalForm\`\(D\_\[Mu]\[Nu]\[Rho]\[Sigma] - type\)\)]]]\
, "Subsubsection", CellTags -> "TIDL"], Cell[BoxData[
             \(\(TIDL[\(\({\({q, \[Mu]}\), \({q, \[Nu]}\), \({q, \[Rho]}\), 
                       \({q, \[Sigma]}\)}\), \({p, k, r, s}\)\)]\) ;\)], 
            "Input", CellTags -> "TIDL"], Cell[CellGroupData[{Cell[BoxData[
                \({\(Length[%]\),\ \(LeafCount[%]\), \(ByteCount[%]\)}\)], 
               "Input", CellTags -> "TIDL"], Cell[BoxData[
                \(TraditionalForm\`\({4, 29, 424}\)\)], "Output", CellTags -> 
                "TIDL"]}, Open]]}, Open]], Cell["TimedIntegrate", 
         "ObjectName", CellTags -> "TimedIntegrate"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "TimedIntegrate"], Cell[" TimedIntegrate[exp, vars] \
is like Integrate, but stops after the number of seconds specified by the \
option Timing. Options of Integrate can be given and are passed on.", "Text", 
            CellTags -> "TimedIntegrate"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[TimedIntegrate]\)], "Input", CellTags -> 
                "TimedIntegrate"], Cell[BoxData[
                \(TraditionalForm\`\({\(Timing \[Rule] 10\), 
                      \(Assumptions \[Rule] 
                        \(\*TagBox["\[CurlyEpsilon]", TraditionalForm] > 0\)\
\), \(Integrate \[Rule] Integrate\), \(Expand \[Rule] True\)}
                \)\)], "Output", CellTags -> "TimedIntegrate"]}, Open]]}, 
          Open]], Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "TimedIntegrate"], 
           Cell["This should reach to be done", "Text", CellTags -> 
             "TimedIntegrate"], Cell[CellGroupData[{Cell[BoxData[
                \(TimedIntegrate[\(\(Log[\(x^5\)]\), \({x, 0, 1}\), 
                     \(Timing \[Rule] 1\)\)]\)], "Input", CellTags -> 
                "TimedIntegrate"], Cell[BoxData[\(TraditionalForm\`\(-5\)\)], 
               "Output", CellTags -> "TimedIntegrate"]}, Open]], 
           Cell["This shouldn't", "Text", CellTags -> "TimedIntegrate"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TimedIntegrate[\(\(Log[\(Cos[\(x^5\)]\)]\), \({x, 0, 1}\), 
                     \(Timing \[Rule] 10\), \(Integrate \[Rule] int\)\)]\)], 
               "Input", CellTags -> "TimedIntegrate"], Cell[BoxData[
                \(TraditionalForm\`\(int(
                     \(\(log(\(cos(\(x\^5\))\))\), \({x, 0, 1}\), 
                       \(Assumptions \[Rule] 
                         \(\*TagBox["\[CurlyEpsilon]", TraditionalForm] > 0\)
                \)\))\)\)], "Output", CellTags -> "TimedIntegrate"]}, 
             Open]]}, Open]], Cell["TLI  ***unfinished***", "ObjectName", 
         CellTags -> "TLI"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "TLI"], Cell["TLI[{v,w,x,y,z},{a,b,c\
,d,e}, {al,be,ga,de,ep}].  The exponents of the numerator scalar product are \
(dl = OPEDelta):  v: k1.k1, w: k2.k2,  x: p.k1, y: p.k2, z: k1.k2.  a: dl.k1, \
b: dl.k2,  c: dl.(p-k1), d: dl.(p-k2), e: dl.(k1-k2).\nTLI[{mu1, ...}, {nu1, \
...}][{v,w,x,y,z},{a,b,c,d,e}, {al,be,ga,de,ep}] is a tensor integral, where \
mu1 belongs to k1 and nu1 to k2.\nTLI[any___,{a,b,c,d,e,0,0}, \
{al,be,ga,de,ep}] simplifies to  TLI[any, {a,b,c,d,e}, \
{al,be,ga,de,ep}].\nTLI[{0,0,0,0,0},{a,b,c,d,e}, {al,be,ga,de,ep}] simplifies \
to  TLI[{a,b,c,d,e}, {al,be,ga,de,ep}].", "Text", CellTags -> "TLI"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[TLI]\)], "Input", 
               CellTags -> "TLI"], Cell[BoxData[
                \(TraditionalForm\`\({\(EpsilonOrder \[Rule] 0\), 
                      \(Momentum \[Rule] p\)}\)\)], "Output", CellTags -> 
                "TLI"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["TLI2FC", RuleDelayed[ButtonData, "TLI2FC"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TLI2FC"]], 
              "."}], "Text", CellTags -> "TLI"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "TLI"], Cell[BoxData[""], "Input", 
            CellTags -> "TLI"]}, Open]], 
        Cell["TLIFP  ***unfinished*** (examples missing)", "ObjectName", 
         CellTags -> "TLIFP"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "TLIFP"], 
           Cell["TLIFP[exp] does Feynman-Parametrizations of TLI's in exp.", 
            "Text", CellTags -> "TLIFP"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[TLIFP]\)], "Input", CellTags -> "TLIFP"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(FeynmanParameterNames \[Rule] 
                        \({x, t, u, s, y}\)\), \(GammaExpand \[Rule] True\), 
                      \(Momentum \[Rule] p\), \(Print \[Rule] True\)}\)\)], 
               "Output", CellTags -> "TLIFP"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["TLI", RuleDelayed[ButtonData, "TLI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TLI"]], 
              "."}], "Text", CellTags -> "TLIFP"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "TLIFP"], Cell[BoxData[""], "Input", 
            CellTags -> "TLIFP"]}, Open]], 
        Cell["TLIHYP  ***unfinished*** (examples missing)", "ObjectName", 
         CellTags -> "TLIHYP"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "TLIHYP"], 
           Cell["TLIHYP[exp] expresses TLI's in exp. in terms of \
hypergeometric functions, where possible.", "Text", CellTags -> "TLIHYP"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[TLIHYP]\)], "Input", 
               CellTags -> "TLIHYP"], Cell[BoxData[
                \(TraditionalForm\`\({\(FeynmanParameterNames \[Rule] x\), 
                      \(Momentum \[Rule] p\)}\)\)], "Output", CellTags -> 
                "TLIHYP"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["TLI", RuleDelayed[ButtonData, "TLI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TLI"]], 
              "."}], "Text", CellTags -> "TLIHYP"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "TLIHYP"], Cell[BoxData[""], "Input", 
            CellTags -> "TLIHYP"]}, Open]], Cell["TLI2", "ObjectName", 
         CellTags -> "TLI2"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "TLI2"], 
           Cell["like TLI, but without any functional properties.", "Text", 
            CellTags -> "TLI2"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["TLI", RuleDelayed[ButtonData, "TLI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TLI"]], 
              "."}], "Text", CellTags -> "TLI2"], Cell[BoxData[""], 
            "Input"]}, Open]], 
        Cell["TLI2FC  ***unfinished*** (examples missing)", "ObjectName", 
         CellTags -> "TLI2FC"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "TLI2FC"], 
           Cell[
            "TLI2FC[exp] transforms all TLI-integrals in exp to the FAD \
form.", "Text", CellTags -> "TLI2FC"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[TLI2FC]\)], "Input", CellTags -> "TLI2FC"], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] D\), 
                      \(FeynCalcExternal \[Rule] False\), 
                      \(Momentum \[Rule] 
                        \({\(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_1, 
                           \(\*TagBox[StyleBox["\"q\"", 
                                Rule[FontSlant, "Italic"]], 
                               Function[StyleForm[Slot[1], 
                                 Rule[FontSlant, "Italic"]]]]\)\_2, p}\)\)}\)
                \)], "Output", CellTags -> "TLI2FC"]}, Open]], 
           Cell[TextData[{"See also:  ", 
              ButtonBox["TLI", RuleDelayed[ButtonData, "TLI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "TLI"]], 
              ".  ", 
              ButtonBox["FC2TLI", RuleDelayed[ButtonData, "FC2TLI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FC2TLI"]], 
              "."}], "Text", CellTags -> "TLI2FC"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "TLI2FC"], Cell[BoxData[""], "Input", 
            CellTags -> "TLI2FC"]}, Open]], Cell["ToDistribution", 
         "ObjectName", CellTags -> "ToDistribution"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ToDistribution"], Cell["ToDistribution[exp,x] \
replaces (1-x)^(a Epsilon - 1) in exp by 1/(a Epsilon) DeltaFunction[1-x] + \
1/(1-x) + a Epsilon Log[1-x]/(1-x) + 1/2 a^2 Epsilon^2 Log[1-x]^2/(1-x)] and \
(1-x)^(a Epsilon - 2) in exp by -1/(a Epsilon) DeltaFunctionPrime[1-x] + \
1/(1-x)^2 + (a Epsilon) Log[1-x]/(1-x)^2 + a^2 Epsilon^2/2 Log[1-x]^2/(1-x)^2 \
+ a^3 Epsilon^3/6 Log[1-x]^3/(1-x)^2.", "Text", CellTags -> 
             "ToDistribution"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[ToDistribution]\)], "Input", CellTags -> 
                "ToDistribution"], Cell[BoxData[
                \(TraditionalForm\`\({PlusDistribution \[Rule] Identity}\)\)]\
, "Output", CellTags -> "ToDistribution"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["PlusDistribution", 
                RuleDelayed[ButtonData, "PlusDistribution"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PlusDistribution"]], "."}], "Text", 
            CellTags -> "ToDistribution"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ToDistribution"], Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\(ToDistribution, 
                     \(PlusDistribution \[Rule] PlusDistribution\)\)]\)], 
               "Input", CellTags -> "ToDistribution"], Cell[BoxData[
                \(TraditionalForm\`\({PlusDistribution \[Rule] 
                      PlusDistribution}\)\)], "Output", CellTags -> 
                "ToDistribution"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(ToDistribution[\(\(\((1 - x)\)^\((Epsilon - 1)\)\), x\)]\)]\
, "Input", CellTags -> "ToDistribution"], Cell[BoxData[FormBox[RowBox[{
                   \(1\/6\ \(\((\(log\^3(1 - x)\)\/\(1 - x\))\)\_+\)\ 
                      \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^3\), "+", 
                   \(1\/2\ \(\((\(log\^2(1 - x)\)\/\(1 - x\))\)\_+\)\ 
                      \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^2\), "+", 
                   \(\(\((\(log(1 - x)\)\/\(1 - x\))\)\_+\)\ 
                      \*TagBox["\[CurlyEpsilon]", TraditionalForm]\), "+", 
                   \(\((1\/\(1 - x\))\)\_+\), "+", FractionBox[RowBox[
                     {"\[Delta]", "(", FormBox[\(1 - x\), "TraditionalForm"], 
                      ")"}], TagBox["\[CurlyEpsilon]", TraditionalForm]]}], 
                 TraditionalForm]], "Output", CellTags -> "ToDistribution"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\(ToDistribution, 
                     \(PlusDistribution \[Rule] Identity\)\)]\)], "Input", 
               CellTags -> "ToDistribution"], Cell[BoxData[
                \(TraditionalForm\`\({PlusDistribution \[Rule] Identity}\)\)]\
, "Output", CellTags -> "ToDistribution"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(ToDistribution[\(\(\((1 - x)\)^\((Epsilon - 2)\)\), x\)]\)]\
, "Input", CellTags -> "ToDistribution"], Cell[BoxData[FormBox[RowBox[{
                   \(\(\*TagBox["\[CurlyEpsilon]", TraditionalForm]\^3\ 
                        \(log\^3(1 - x)\)\)\/\(6\ \((1 - x)\)\^2\)\), "+", 
                   \(\(\*TagBox["\[CurlyEpsilon]", TraditionalForm]\^2\ 
                        \(log\^2(1 - x)\)\)\/\(2\ \((1 - x)\)\^2\)\), "+", 
                   \(\(\*TagBox["\[CurlyEpsilon]", TraditionalForm]\ 
                        \(log(1 - x)\)\)\/\((1 - x)\)\^2\), "-", FractionBox[
                    RowBox[{\(\[Delta]\^\[Prime]\), "(", FormBox[\(1 - x\), 
                       "TraditionalForm"], ")"}], 
                    TagBox["\[CurlyEpsilon]", TraditionalForm]], "+", 
                   \(1\/\((1 - x)\)\^2\)}], TraditionalForm]], "Output", 
               CellTags -> "ToDistribution"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Series2[\(\(Integrate[\(
                        \((1 - x)\)\^\(Epsilon - 2\), \({x, 0, 1}\), 
                         \(GenerateConditions \[Rule] False\)\)]\), Epsilon, 
                     3\)]\)], "Input", CellTags -> "ToDistribution"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(-\*
                         TagBox["\[CurlyEpsilon]", TraditionalForm]\^3\) - 
                     \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^2 - 
                     \*TagBox["\[CurlyEpsilon]", TraditionalForm] - 1\)\)], 
               "Output", CellTags -> "ToDistribution"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Options @ Integrate\)], 
               "Input", CellTags -> "ToDistribution"], Cell[BoxData[
                \(TraditionalForm\`\({\(Assumptions \[RuleDelayed] 
                        $Assumptions\), \(GenerateConditions \[Rule] False\),
                       \(PrincipalValue \[Rule] False\)}\)\)], "Output", 
               CellTags -> "ToDistribution"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Integrate2[\(\(ToDistribution[
                       \(\(\((1 - x)\)^\((Epsilon - 2)\)\), x\)]\), 
                     \({x, 0, 1}\)\)]\)], "Input", CellTags -> 
                "ToDistribution"], Cell[BoxData[
                \(TraditionalForm\`\(\(-\*
                         TagBox["\[CurlyEpsilon]", TraditionalForm]\^3\) - 
                     \*TagBox["\[CurlyEpsilon]", TraditionalForm]\^2 - 
                     \*TagBox["\[CurlyEpsilon]", TraditionalForm] - 1\)\)], 
               "Output", CellTags -> "ToDistribution"]}, Open]]}, Open]], 
        Cell["ToHypergeometric", "ObjectName", CellTags -> 
          "ToHypergeometric"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "ToHypergeometric"], Cell[TextData[{"ToHypergeometric[", 
              Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["t", 
                        Rule[FontSlant, "Plain"]]\^
                      \*StyleBox["b", Rule[FontSlant, "Plain"]]\ 
                     \((1 - \*StyleBox["t", Rule[FontSlant, "Plain"]])\)\^
                      \*StyleBox["c", Rule[FontSlant, "Plain"]]\ 
                     \((1 + \(\*StyleBox["t", Rule[FontSlant, "Plain"]]\ 
                           \*StyleBox["z", Rule[FontSlant, "Plain"]]\))\)\^
                      \*StyleBox["a", Rule[FontSlant, "Plain"]]\)\)], 
               FontVariations -> {"CompatibilityType" -> 0}], ", ", "t", 
              "] returns ", Cell[BoxData[FormBox[RowBox[{
                   \(\[CapitalGamma](b + 1)\), " ", 
                   \(\(\[CapitalGamma](c + 1)\)/
                      \(\[CapitalGamma](b + c + 2)\)\), " ", FormBox[
                    \(\[Null]\_2 \(F\_1(\(\(-a\), \(b + 1\)\) ; \(b + c + 2\)
                           ; \(-z\))\)\), "TraditionalForm"]}], 
                 TraditionalForm]]], ". Remember that Re ", 
              StyleBox["b", Rule[FontSlant, "Italic"]], " >0 and Re (", 
              StyleBox["c", Rule[FontSlant, "Italic"]], "-", 
              StyleBox["b", Rule[FontSlant, "Italic"]], 
              ") > 0 should hold (need not be set in ", 
              StyleBox["Mathematica", Rule[FontSlant, "Italic"]], ")."}], 
            "Text", CellTags -> "ToHypergeometric"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["HypergeometricAC", 
                RuleDelayed[ButtonData, "HypergeometricAC"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "HypergeometricAC"]], ", ", 
              ButtonBox["HypergeometricIR", 
                RuleDelayed[ButtonData, "HypergeometricIR"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "HypergeometricIR"]], ", ", 
              ButtonBox["HypergeometricSE", 
                RuleDelayed[ButtonData, "HypergeometricSE"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "HypergeometricSE"]], "."}], "Text", 
            CellTags -> "ToHypergeometric"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ToHypergeometric"], Cell[CellGroupData[{Cell[BoxData[
                \(ToHypergeometric[\(\(t\^b\ \((1 - t)\)\^c\ 
                       \((1 + \(t\ z\))\)\^a\), t\)]\)], "Input", CellTags -> 
                "ToHypergeometric"], Cell[BoxData[
                \(TraditionalForm\`\(\(\(\[CapitalGamma](\(b + 1\))\)\ 
                       \(\[CapitalGamma](\(c + 1\))\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(-a\), Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(b + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(b + c + 2\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(-z\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\/
                     \(\[CapitalGamma](\(b + c + 2\))\)\)\)], "Output", 
               CellTags -> "ToHypergeometric"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(ToHypergeometric[\(\(w\ t\^\(b - 1\)\ 
                       \((1 - t)\)\^\(c - b - 1\)\ \((1 - \(t\ z\))\)\^\(-a\)
                \), t\)]\)], "Input", CellTags -> "ToHypergeometric"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(w\ \(\[CapitalGamma](b)\)\ 
                       \(\[CapitalGamma](\(c - b\))\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox["z", Hypergeometric2F1, Rule[Editable, True]])\
\)\), InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\/
                     \(\[CapitalGamma](c)\)\)\)], "Output", CellTags -> 
                "ToHypergeometric"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(ToHypergeometric[\(\(t\^b\ \((1 - t)\)\^c\ 
                       \((u + \(t\ z\))\)\^a\), t\)]\)], "Input", CellTags -> 
                "ToHypergeometric"], Cell[BoxData[
                \(TraditionalForm\`\(\(u\^a\ \(\[CapitalGamma](\(b + 1\))\)\ 
                       \(\[CapitalGamma](\(c + 1\))\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox[\(-a\), Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox[\(b + 1\), 
                                    Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox[\(b + c + 2\), 
                                   Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(-\(z\/u\)\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\/
                     \(\[CapitalGamma](\(b + c + 2\))\)\)\)], "Output", 
               CellTags -> "ToHypergeometric"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(ToHypergeometric[\(\(w\ t\^\(b - 1\)\ 
                       \((1 - t)\)\^\(c - b - 1\)\ \((u - \(t\ z\))\)\^\(-a\)
                \), t\)]\)], "Input", CellTags -> "ToHypergeometric"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(u\^\(-a\)\ w\ \(\[CapitalGamma](b)\)\ 
                       \(\[CapitalGamma](\(c - b\))\)\ 
                       \*TagBox[TagBox[\(
                           \(\(\[InvisiblePrefixScriptBase]\_2\) \(F\_1\)\)
                             \[InvisibleApplication] 
                            \((\*TagBox[TagBox[\(
                                   \*TagBox["a", Hypergeometric2F1, 
                                    Rule[Editable, True]], 
                                    \*TagBox["b", Hypergeometric2F1, 
                                    Rule[Editable, True]]\), 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[TagBox[TagBox["c", Hypergeometric2F1, 
                                   Rule[Editable, True]], 
                                  InterpretTemplate[Function[List[
                                    SlotSequence[1]]]]], 
                                 Hypergeometric2F1, Rule[Editable, False]]\
 ; \*TagBox[\(z\/u\), Hypergeometric2F1, 
                                 Rule[Editable, True]])\)\), 
                          InterpretTemplate[Function[HypergeometricPFQ[
                             Slot[1], Slot[2], Slot[3]]]], 
                          Rule[Editable, False]], Hypergeometric2F1]\)\/
                     \(\[CapitalGamma](c)\)\)\)], "Output", CellTags -> 
                "ToHypergeometric"]}, Open]]}, Open]], 
        Cell["ToLarin", "ObjectName", CellTags -> "ToLarin"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ToLarin"], Cell[TextData[
             {"ToLarin[exp] translates all ", Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu]\ \[Gamma]\^5\)\)]], 
              " in exp into ", Cell[BoxData[
                \(TraditionalForm\`\(\(\(-\[ImaginaryI]\)/6\)\ 
                     \[CurlyEpsilon]\^\[Mu]\[Nu]\[Lambda]\[Sigma] 
                     \[Gamma]\^\[Nu]\ \[Gamma]\^\[Lambda]\ 
                     \(\[Gamma]\^\[Sigma] .\)\)\)]]}], "Text", 
            CellTags -> "ToLarin"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Eps", RuleDelayed[ButtonData, "Eps"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Eps"]], 
              "."}], "Text", CellTags -> "ToLarin"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ToLarin"], Cell[CellGroupData[{Cell[BoxData[
                \(\(DiracMatrix[\[Nu]]\) . \(DiracMatrix[\[Mu]]\) . 
                   \(DiracMatrix[5]\)\)], "Input", CellTags -> "ToLarin"], 
              Cell[BoxData[FormBox[RowBox[{SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                    FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], ".", \(\[Gamma]\^5\)}], 
                 TraditionalForm]], "Output", CellTags -> "ToLarin"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(ToLarin[%]\)], 
               "Input", CellTags -> "ToLarin"], Cell[BoxData[FormBox[RowBox[{
                   \(-\(1\/6\)\), " ", "\[ImaginaryI]", " ", RowBox[
                    {SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     SuperscriptBox["\[Gamma]", FormBox[FormBox["du1", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     SuperscriptBox["\[Gamma]", FormBox[FormBox["du2", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     SuperscriptBox["\[Gamma]", FormBox[FormBox["du3", 
                        "TraditionalForm"], "TraditionalForm"]]}], " ", 
                   SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["du1", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["du2", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["du3", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "ToLarin"]}, Open]]}, Open]], 
        Cell["ToTFI", "ObjectName", CellTags -> "ToTFI"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "ToTFI"], Cell["ToTFI[expr, q1, q2, p] translates \
FeynCalc 2-loop self energy type integrals into the TFI notatation, which can \
be used as input for the function TarcerRecurse from the TARCER package. See \
the TARCER documenatation on TFI for details on the conventions.", "Text", 
            CellTags -> "ToTFI"], Cell[TextData[{"See also: ", 
              ButtonBox["FromTFI", RuleDelayed[ButtonData, "FromTFI"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "FromTFI"]]\
, "."}], "Text", CellTags -> "ToTFI"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "ToTFI"], Cell[CellGroupData[{Cell[BoxData[
                \(FAD[\(q1, \(q1 - p\), \({q2, M}\), \({\(q2 - p\), m}\), 
                     \(q1 - q2\)\)]\)], "Input", CellTags -> "ToTFI"], 
              Cell[BoxData[
                \(TraditionalForm\`\(1\/\(
                      \((\*InterpretationBox[\(
                            "["\[InvisibleSpace] 
                             \(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_1\%2 
                             \[InvisibleSpace]"]"\), 
                           SequenceForm["[", Power[q1, 2], "]"], 
                           Rule[Editable, False]])\)\ 
                       \((\*InterpretationBox[\(
                            "["\[InvisibleSpace] 
                             \((\(\*TagBox[StyleBox["\"q\"", 
                                    Rule[FontSlant, "Italic"]], 
                                     Function[StyleForm[Slot[1], 
                                     Rule[FontSlant, "Italic"]]]]\)\_1 - p)\
\)\^2 \[InvisibleSpace]"]"\), 
                           SequenceForm["[", 
                            Power[Plus[Times[-1, p], q1], 2], "]"], 
                           Rule[Editable, False]])\)\ 
                       \((\*InterpretationBox[\(
                            "["\[InvisibleSpace] 
                             \((\(\*TagBox[StyleBox["\"q\"", 
                                    Rule[FontSlant, "Italic"]], 
                                     Function[StyleForm[Slot[1], 
                                     Rule[FontSlant, "Italic"]]]]\)\_1 - 
                                 \(\*TagBox[StyleBox["\"q\"", 
                                    Rule[FontSlant, "Italic"]], 
                                     Function[StyleForm[Slot[1], 
                                     Rule[FontSlant, "Italic"]]]]\)\_2)\)\^2\
 \[InvisibleSpace]"]"\), 
                           SequenceForm["[", 
                            Power[Plus[q1, Times[-1, q2]], 2], "]"], 
                           Rule[Editable, False]])\)\ 
                       \((\*InterpretationBox[\(
                            "["\[InvisibleSpace] 
                             \(\*TagBox[StyleBox["\"q\"", 
                                  Rule[FontSlant, "Italic"]], 
                                 Function[StyleForm[Slot[1], 
                                   Rule[FontSlant, "Italic"]]]]\)\_2\%2 
                             \[InvisibleSpace]"-"\[InvisibleSpace] M\^2 
                             \[InvisibleSpace]"]"\), 
                           SequenceForm["[", Power[q2, 2], "-", 
                            Power[M, 2], "]"], Rule[Editable, False]])\)\ 
                       \((\*InterpretationBox[\(
                            "["\[InvisibleSpace] 
                             \((\(\*TagBox[StyleBox["\"q\"", 
                                    Rule[FontSlant, "Italic"]], 
                                     Function[StyleForm[Slot[1], 
                                     Rule[FontSlant, "Italic"]]]]\)\_2 - p)\
\)\^2 \[InvisibleSpace]"-"\[InvisibleSpace] m\^2 
                             \[InvisibleSpace]"]"\), 
                           SequenceForm["[", 
                            Power[Plus[Times[-1, p], q2], 2], "-", 
                            Power[m, 2], "]"], Rule[Editable, False]])\)\)\)\
\)], "Output", CellTags -> "ToTFI"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(ToTFI[\(%, q1, q2, p\)]\)], "Input", CellTags -> 
                "ToTFI"], Cell[BoxData[FormBox[InterpretationBox[
                  SubsuperscriptBox[
                   StyleBox["F", Rule[SingleLetterItalics, False], 
                     Rule[FontWeight, "Bold"]], RowBox[{FormBox[\({1, 0}\), 
                      "TraditionalForm"], FormBox[\({1, M}\), 
                      "TraditionalForm"], FormBox[\({1, 0}\), 
                      "TraditionalForm"], FormBox[\({1, m}\), 
                      "TraditionalForm"], FormBox[\({1, 0}\), 
                      "TraditionalForm"]}], RowBox[{"(", FormBox["D", 
                      "TraditionalForm"], ")"}]], TFI[D, m^2, {{1, 0}, 
                    {1, M}, {1, 0}, {1, m}, {1, 0}}], Editable -> True], 
                 TraditionalForm]], "Output", CellTags -> "ToTFI"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "ToTFI"], Cell[BoxData[InterpretationBox[
                 SubsuperscriptBox[
                  StyleBox["F", Rule[SingleLetterItalics, False], 
                    Rule[FontWeight, "Bold"]], RowBox[{FormBox[\({1, 0}\), 
                     "TraditionalForm"], FormBox[\({1, M}\), 
                     "TraditionalForm"], FormBox[\({1, 0}\), 
                     "TraditionalForm"], FormBox[\({1, m}\), 
                     "TraditionalForm"], FormBox[\({1, 0}\), 
                     "TraditionalForm"]}], RowBox[{"(", FormBox["D", 
                     "TraditionalForm"], ")"}]], TFI[D, m^2, {{1, 0}, {1, M}, 
                   {1, 0}, {1, m}, {1, 0}}], Editable -> True]], "Output", 
               CellTags -> "ToTFI"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(\(SOD[q1]\)\ \(SOD[q2]\) 
                     \(FAD[\(q1, \(q1 - p\), \({q2, M}\), \({\(q2 - p\), m}\)
                         , \(q1 - q2\)\)]\)\)//FCI\)], "Input", CellTags -> 
                "ToTFI"], Cell[BoxData[FormBox[FractionBox[RowBox[
                   {RowBox[{FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      "\[CenterDot]", FormBox[
                       \(\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1\), 
                       "TraditionalForm"]}], " ", RowBox[{FormBox[
                       "\[CapitalDelta]", "TraditionalForm"], "\[CenterDot]", 
                      FormBox[
                       \(\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2\), 
                       "TraditionalForm"]}]}], 
                  \(\(\*TagBox[StyleBox["\"q\"", Rule[FontSlant, "Italic"]], 
                         Function[StyleForm[Slot[1], 
                           Rule[FontSlant, "Italic"]]]]\)\_1\%2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1 - p)\)\^2 . 
                     \((\(\*TagBox[StyleBox["\"q\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_2\%2 - M\^2)\)\
 . \((\((\(\*TagBox[StyleBox["\"q\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2 - p)\)\^2\
 - m\^2)\) . \((\(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_1 - 
                         \(\*TagBox[StyleBox["\"q\"", 
                              Rule[FontSlant, "Italic"]], 
                             Function[StyleForm[Slot[1], 
                               Rule[FontSlant, "Italic"]]]]\)\_2)\)\^2\)], 
                 TraditionalForm]], "Output", CellTags -> "ToTFI"]}, Open]]}, 
          Open]], Cell["TR, Tr", "ObjectName", CellTags -> {"TR", "Tr"}], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> {"TR", "Tr"}], Cell[TextData[{"TR[exp] calculates the \
Dirac trace of exp. Depending on the setting of the option SUNTrace also a \
trace over SU(", StyleBox["N", Rule[FontSlant, "Italic"]], 
              ") objects is performed. The ", 
              StyleBox["Mathematica", Rule[FontSlant, "Italic"]], " build-in \
function Tr is overloaded to call TR if any of DiracGamma, DiracSlash, GA, \
GAD, GS or GSD are in the expression.\nTr[list] finds the trace of the matrix \
or tensor list. Tr[list, f] finds a generalized trace, combining terms with f \
instead of Plus. Tr[list, f, n] goes down to level n in list.\nTr[ expression \
] calculates the DiracTrace, i.e.,  TR[ expression ] if any of DiracGamma, \
DiracSlash, GA, GAD, GS or GSD is present in expression."}], "Text", 
            CellTags -> {"TR", "Tr"}], Cell[CellGroupData[{Cell[BoxData[
                \(Options[TR]\)], "Input", CellTags -> {"TR", "Tr"}], 
              Cell[BoxData[
                \(TraditionalForm\`\({\(DiracTraceEvaluate \[Rule] True\), 
                      \(Explicit \[Rule] True\), \(Factoring \[Rule] False\),
                       \(FeynCalcExternal \[Rule] False\), 
                      \(LeviCivitaSign \[RuleDelayed] $LeviCivitaSign\), 
                      \(Mandelstam \[Rule] \({}\)\), 
                      \(PairCollect \[Rule] False\), \(Schouten \[Rule] 442\)
                      , \(SUNTrace \[Rule] False\), \(TraceOfOne \[Rule] 4\),
                       \(SUNNToCACF \[Rule] False\)}\)\)], "Output", 
               CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[TextData[{"See also: ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["DiracTrace", RuleDelayed[ButtonData, "DiracTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrace"]], ", ", 
              ButtonBox["FermionSpinSum", 
                RuleDelayed[ButtonData, "FermionSpinSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FermionSpinSum"]], ", ", 
              ButtonBox["SUNTrace", RuleDelayed[ButtonData, "SUNTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNTrace"]], "."}], "Text", 
            CellTags -> {"TR", "Tr"}]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> {"TR", "Tr"}], Cell[CellGroupData[{Cell[BoxData[
                \(GA[\(\[Mu], \[Nu]\)]\)], "Input", CellTags -> 
                {"TR", "Tr"}], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu]\)\)], 
               "Output", CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(TR[%]\)], "Input", CellTags -> 
                {"TR", "Tr"}], Cell[BoxData[
                \(TraditionalForm\`\(4\ g\^\(\[Mu]\[Nu]\)\)\)], "Output", 
               CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(\((\(GSD[p]\) + m)\) . \(GAD[\[Mu]]\) . 
                     \((\(GSD[q]\) - m)\) . \(GAD[\[Nu]]\)\)]\)], "Input", 
               CellTags -> {"TR", "Tr"}], Cell[BoxData[FormBox[RowBox[
                  {"4", " ", RowBox[{"(", RowBox[{
                       \(\(-g\^\(\[Mu]\[Nu]\)\)\ m\^2\), "+", RowBox[
                        {SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "+", 
                       RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{
                         \(g\^\(\[Mu]\[Nu]\)\), " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> {"TR", "Tr"}]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(GA[\(\[Mu], \[Nu], \[Rho], \[Sigma], 5\)]\)]\)], 
               "Input", CellTags -> {"TR", "Tr"}], Cell[BoxData[
                FormBox[RowBox[{\(-4\), " ", "\[ImaginaryI]", " ", 
                   SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(GAD[\(\[Mu], \[Nu], \[Rho], \[Sigma], \[Tau], \[Xi], 5
                      \)]\)]\)], "Input", CellTags -> {"TR", "Tr"}], 
              Cell[BoxData[FormBox[RowBox[{"4", " ", RowBox[{"(", RowBox[
                      {RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Xi]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Mu]\[Nu]\)\)}]
                         , "-", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Mu]\[Xi]\)\)}]
                         , "+", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Xi]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Mu]\[Rho]\)\)}]
                         , "-", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Xi]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Mu]\[Sigma]\)\)
                         }], "+", RowBox[{"\[ImaginaryI]", " ", 
                         SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["\[Xi]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Mu]\[Tau]\)\)}]
                         , "+", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Nu]\[Xi]\)\)}]
                         , "-", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Xi]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Nu]\[Rho]\)\)}]
                         , "+", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Xi]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Nu]\[Sigma]\)\)
                         }], "-", RowBox[{"\[ImaginaryI]", " ", 
                         SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["\[Xi]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Nu]\[Tau]\)\)}]
                         , "-", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Xi]\[Rho]\)\)}]
                         , "+", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Xi]\[Sigma]\)\)
                         }], "-", RowBox[{"\[ImaginaryI]", " ", 
                         SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Xi]\[Tau]\)\)}]
                         , "+", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Xi]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Tau]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", 
                         \(g\^\(\[Rho]\[Sigma]\)\)}], "-", RowBox[
                        {"\[ImaginaryI]", " ", SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Xi]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", \(g\^\(\[Rho]\[Tau]\)\)}
                         ], "+", RowBox[{"\[ImaginaryI]", " ", SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Xi]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", 
                         \(g\^\(\[Sigma]\[Tau]\)\)}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> {"TR", "Tr"}]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData["$West"], "Input", 
               CellTags -> {"TR", "Tr"}], Cell[BoxData[
                \(TraditionalForm\`True\)], "Output", CellTags -> 
                {"TR", "Tr"}]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(? $West\)], "Input", CellTags -> {"TR", "Tr"}], 
              Cell[BoxData["\"If $West is set to True (which is the default), \
traces involving more than 4 Dirac matrices and gamma5 are calculated \
recursively according to formula (A.5) from Comp. Phys. Comm 77 (1993) \
286-298, which is based on the Breitenlohner Maison gamma5 - scheme.\""], 
               "Print", CellTags -> {"Info3353009298-8131286", "Tr", "TR"}]}, 
             Open]], Cell["$West=False should be set before any calculation \
is done (because intermediate results from trace calculations are cached).", 
            "Text", CellTags -> {"TR", "Tr"}], Cell[CellGroupData[
             {Cell[BoxData[\($West = False\)], "Input", CellTags -> 
                {"TR", "Tr"}], Cell[BoxData[\(TraditionalForm\`False\)], 
               "Output", CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(\(GAD[\(\[Nu]\_1, \[Nu]\_2, \[Nu]\_3, \[Nu]\_4, 
                         \[Nu]\_5, \[Nu]\_6\)]\) . \(GA[5]\)\)]\)], "Input", 
               CellTags -> {"TR", "Tr"}], Cell[BoxData[\(TraditionalForm\`0\)]
                , "Output", CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(TR[\(GS[\(p, q, r, s\)]\)]\)], 
               "Input", CellTags -> {"TR", "Tr"}], Cell[BoxData[
                FormBox[RowBox[{"4", " ", RowBox[{"(", RowBox[{RowBox[
                        {RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", "TraditionalForm"]}], 
                         " ", RowBox[{FormBox["q", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], "-", RowBox[{RowBox[
                          {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["r", "TraditionalForm"]}], " ", RowBox[
                          {FormBox["q", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["s", "TraditionalForm"]}]}], "+", RowBox[
                        {RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                         " ", RowBox[{FormBox["r", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> {"TR", "Tr"}]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(\(\((\(GS[p]\) + m)\) . \(GA[\[Mu]]\) . 
                       \((\(GS[q]\) + m)\) . \(GA[\[Mu]]\)\), 
                     \(Factoring \[Rule] True\)\)]\)], "Input", CellTags -> 
                {"TR", "Tr"}], Cell[BoxData[FormBox[RowBox[{"8", " ", 
                   RowBox[{"(", RowBox[{\(2\ m\^2\), "-", RowBox[{FormBox[
                          "p", "TraditionalForm"], "\[CenterDot]", FormBox[
                          "q", "TraditionalForm"]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> {"TR", "Tr"}]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(\(GA[\(\[Alpha], \[Beta]\)]\), \(FCE \[Rule] True\)\)]
                  \)], "Input", CellTags -> {"TR", "Tr"}], Cell[BoxData[
                \(TraditionalForm\`\(4\ g\^\(\[Alpha]\[Beta]\)\)\)], 
               "Output", CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> {"TR", "Tr"}], Cell[BoxData[
                \(4\ \(MT[\(\[Alpha], \[Beta]\)]\)\)], "Output", CellTags -> 
                {"TR", "Tr"}]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(\(\(GAD[\[Mu]]\) . \(GA[\[Alpha]]\) . \(GA[\[Beta]]
                        \) . \(GAD[\[Mu]]\)\), \(FCE \[Rule] True\)\)]\)], 
               "Input", CellTags -> {"TR", "Tr"}], Cell[BoxData[
                \(TraditionalForm\`\(4\ D\ g\^\(\[Alpha]\[Beta]\)\)\)], 
               "Output", CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> {"TR", "Tr"}], Cell[BoxData[
                \(4\ D\ \(MT[\(\[Alpha], \[Beta]\)]\)\)], "Output", 
               CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(t = \(\(GA[\(\[Mu], \[Nu]\)]\)\ 
                     \(\(SUNT[b]\) . \(SUNT[c]\)\)\ \(SUNDelta[\(c, b\)]\)\)\
\)], "Input", CellTags -> {"TR", "Tr"}], Cell[BoxData[FormBox[RowBox[{
                   \(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu]\), " ", RowBox[
                    {SubscriptBox["T", FormBox["b", "TraditionalForm"]], ".", 
                     SubscriptBox["T", FormBox["c", "TraditionalForm"]]}], 
                   " ", \(\[Delta]\_\(bc\)\)}], TraditionalForm]], "Output", 
               CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(t, \(SUNTrace \[Rule] False\), 
                     \(SUNNToCACF \[Rule] True\)\)]\)], "Input", CellTags -> 
                {"TR", "Tr"}], Cell[BoxData[
                \(TraditionalForm\`\(4\ C\_F\ g\^\(\[Mu]\[Nu]\)\)\)], 
               "Output", CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(t, \(SUNTrace \[Rule] True\), 
                     \(SUNNToCACF \[Rule] True\)\)]\)], "Input", CellTags -> 
                {"TR", "Tr"}], Cell[BoxData[
                \(TraditionalForm\`\(4\ C\_F\ g\^\(\[Mu]\[Nu]\)\)\)], 
               "Output", CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(1, \(SUNTrace \[Rule] False\), 
                     \(SUNNToCACF \[Rule] True\)\)]\)], "Input", CellTags -> 
                {"TR", "Tr"}], Cell[BoxData[\(TraditionalForm\`4\)], 
               "Output", CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(1, \(SUNTrace \[Rule] True\), 
                     \(SUNNToCACF \[Rule] True\)\)]\)], "Input", CellTags -> 
                {"TR", "Tr"}], Cell[BoxData[\(TraditionalForm\`4\)], 
               "Output", CellTags -> {"TR", "Tr"}]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Tr[\ \(GA[\(m, n\)]\)]\)], 
               "Input", CellTags -> "Tr"], Cell[BoxData[
                \(TraditionalForm\`\(4\ g\^\(mn\)\)\)], "Output", CellTags -> 
                "Tr"]}, Open]], Cell[BoxData[\(\(Clear[t]\) ;\)], "Input", 
            CellTags -> {"TR", "Tr"}]}, Open]], Cell["TraceDimension", 
         "ObjectName", CellTags -> "TraceDimension"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "TraceDimension"], Cell["TraceDimension is an option \
for FeynCalc2FORM. If set to 4: trace, if set to n: tracen.", "Text", 
            CellTags -> "TraceDimension"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynCalc2FORM", 
                RuleDelayed[ButtonData, "FeynCalc2FORM"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynCalc2FORM"]], "."}], "Text", 
            CellTags -> "TraceDimension"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["TraceOfOne", "ObjectName", CellTags -> "TraceOfOne"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "TraceOfOne"], Cell["TraceOfOne is an option for Tr \
and DiracTrace. Its setting determines the value of the unit trace.", "Text", 
            CellTags -> "TraceOfOne"], Cell[TextData[{"See also: ", 
              ButtonBox["TR", RuleDelayed[ButtonData, "TR"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Tr"]], 
              ", ", 
              ButtonBox["DiracTrace", RuleDelayed[ButtonData, "DiracTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrace"]], "."}], "Text", 
            CellTags -> "TraceOfOne"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "TraceOfOne"], Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(1, \(SUNTrace \[Rule] False\), 
                     \(SUNNToCACF \[Rule] True\), \(TraceOfOne \[Rule] tr1\)\
\)]\)], "Input", CellTags -> "TraceOfOne"], Cell[BoxData[
                \(TraditionalForm\`tr1\)], "Output", CellTags -> 
                "TraceOfOne"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(1, \(SUNTrace \[Rule] True\), 
                     \(SUNNToCACF \[Rule] True\), \(TraceOfOne \[Rule] tr2\)\
\)]\)], "Input", CellTags -> "TraceOfOne"], Cell[BoxData[
                \(TraditionalForm\`tr2\)], "Output", CellTags -> 
                "TraceOfOne"]}, Open]]}, Open]], Cell["Trick", "ObjectName", 
         CellTags -> "Trick"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Trick"], 
           Cell["Trick[exp] performs several basic simplifications without \
expansion. Trick[exp] uses Contract, DotSimplify and SUNDeltaContract.", 
            "Text", CellTags -> "Trick"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Calc", RuleDelayed[ButtonData, "Calc"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Calc"]], 
              ", ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], ", ", 
              ButtonBox["DiracTrick", RuleDelayed[ButtonData, "DiracTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrick"]], ", ", 
              ButtonBox["DotSimplify", RuleDelayed[ButtonData, 
                 "DotSimplify"], Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DotSimplify"]], ", ", 
              ButtonBox["DiracTrick", RuleDelayed[ButtonData, "DiracTrick"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrick"]], "."}], "Text", 
            CellTags -> "Trick"]}, Open]], 
        Cell[CellGroupData[{Cell[BoxData["Examples"], "Subsubsection", 
            CellTags -> "Trick"], Cell[TextData[{"This calculates ", 
              Cell[BoxData[
                \(TraditionalForm\`\(g\^\(\[Mu]\ \[Nu]\) \[Gamma]\_\[Mu]\)\)]]\
, "and ", Cell[BoxData[\(TraditionalForm\`g\_\[Nu]\%\[Nu]\)]], 
              " in D dimensions."}], "Text", ZeroWidthTimes -> True, 
            CellTags -> "Trick"], Cell[CellGroupData[{Cell[BoxData[
                \(Trick[\({\(\(GA[\[Mu]]\)\ \(MT[\(\[Mu], \[Nu]\)]\)\),\ 
                      \(MTD[\(\[Nu], \[Nu]\)]\)}\)]\)], "Input", CellTags -> 
                "Trick"], Cell[BoxData[FormBox[RowBox[{"{", RowBox[
                    {SuperscriptBox["\[Gamma]", FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"]], ",", "D"}], 
                   "}"}], TraditionalForm]], "Output", CellTags -> "Trick"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(FV[\(\(p + r\), \[Mu]\)]\)\ \(MT[\(\[Mu], \[Nu]\)]\)\ 
                   \(FV[\(\(q - p\), \[Nu]\)]\)\)], "Input", CellTags -> 
                "Trick"], Cell[BoxData[FormBox[RowBox[{RowBox[{"(", 
                     SuperscriptBox[FormBox[\(q - p\), "TraditionalForm"], 
                      "\[Nu]"], ")"}], " ", RowBox[{"(", SuperscriptBox[
                      FormBox[\(p + r\), "TraditionalForm"], "\[Mu]"], ")"}], 
                   " ", \(g\^\(\[Mu]\[Nu]\)\)}], TraditionalForm]], "Output", 
               CellTags -> "Trick"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Trick[%]\)], "Input", CellTags -> "Trick"], 
              Cell[BoxData[FormBox[RowBox[{RowBox[{"-", SuperscriptBox[
                      FormBox["p", "TraditionalForm"], "2"]}], "+", 
                   RowBox[{FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                     FormBox["q", "TraditionalForm"]}], "-", RowBox[
                    {FormBox["p", "TraditionalForm"], "\[CenterDot]", 
                     FormBox["r", "TraditionalForm"]}], "+", RowBox[
                    {FormBox["q", "TraditionalForm"], "\[CenterDot]", 
                     FormBox["r", "TraditionalForm"]}]}], TraditionalForm]], 
               "Output", CellTags -> "Trick"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Trick[\(c . b . a\ .\ \(GA[d]\) . \(GA[e]\)\)]\)], "Input", 
               CellTags -> "Trick"], Cell[BoxData[FormBox[RowBox[{"a", " ", 
                   "b", " ", "c", " ", RowBox[{SuperscriptBox["\[Gamma]", 
                      FormBox[FormBox["d", "TraditionalForm"], 
                       "TraditionalForm"]], ".", SuperscriptBox["\[Gamma]", 
                      FormBox[FormBox["e", "TraditionalForm"], 
                       "TraditionalForm"]]}]}], TraditionalForm]], "Output", 
               CellTags -> "Trick"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(\(%//FCE\)//StandardForm\)], "Input", 
               CellTags -> "Trick"], Cell[BoxData[
                \(a\ b\ c\ \(\(GA[d]\) . \(GA[e]\)\)\)], "Output", 
               CellTags -> "Trick"]}, Open]]}, Open]], Cell["TrickIntegrate", 
         "ObjectName", CellTags -> "TrickIntegrate"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "TrickIntegrate"], Cell[TextData[{" TrickIntegrate[", 
              Cell[BoxData[
                \(TraditionalForm\`\(\((1 - 
                        \*StyleBox["t", Rule[FontSlant, "Italic"]])\)\^
                     \(\(a\ Epsilon\) - 1\)\)\)]], " g[t], t] does an \
integration trick for the definite integral of (", Cell[BoxData[
                \(TraditionalForm\`\(\((1 - t)\)\^\(\(a\ Epsilon\) - 1\)\)\)]]\
, " g[t])  from 0 to 1, yielding  g[1]/a/Epsilon + Hold[Integrate][", 
              Cell[BoxData[
                \(TraditionalForm\`\(\((1 - t)\)\^\(\(a\ Epsilon\) - 1\)\)\)]]\
, " (g[t]-g[1]),{t,0,1}].\nTrickIntegrate[", Cell[BoxData[
                \(TraditionalForm\`\(t\^\(\(a\ Epsilon\) - 1\)\)\)]], 
              " g[t], t] gives ", Cell[BoxData[
                \(TraditionalForm\`\(\(g[0]\)\/\(a\ Epsilon\)\)\)]], 
              "+ Hold[Integrate][", Cell[BoxData[
                \(TraditionalForm\`\(t\^\(\(a\ Epsilon\) - 1\)\)\)]], 
              " (g[t]-g[0]),{t,0,1}], provided g[1] and g[0] exist."}], 
            "Text", CellTags -> "TrickIntegrate"], 
           Cell[TextData[{"See also:  ", 
              ButtonBox["Epsilon", RuleDelayed[ButtonData, "Epsilon"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Epsilon"]]\
, "."}], "Text", CellTags -> "TrickIntegrate"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "TrickIntegrate"], Cell[CellGroupData[{Cell[BoxData[
                \(TrickIntegrate[\(\(\(\((1 - t)\)^\((\(a\ Epsilon\) - 1)\)\)
                       \ \(g[t]\)\), t\)]\)], "Input", CellTags -> 
                "TrickIntegrate"], Cell[BoxData[
                \(TraditionalForm\`\(\(g(1)\)\/
                      \(a\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]\) + 
                     \(\(Hold[Integrate]\)[
                       \(\(\((1 - t)\)\^\(
                             \(a\ \*TagBox["\[CurlyEpsilon]", 
                                  TraditionalForm]\) - 1\)\ 
                           \((\(g(t)\) - \(g(1)\))\)\), \({t, 0, 1}\)\)]\)\)\
\)], "Output", CellTags -> "TrickIntegrate"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TrickIntegrate[\(\(\(t^\((\(a\ Epsilon\) - 1)\)\)\ \(g[t]\)
                      \), t\)]\)], "Input", CellTags -> "TrickIntegrate"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(g(0)\)\/
                      \(a\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]\) + 
                     \(\(Hold[Integrate]\)[
                       \(\(t\^\(\(a\ \*TagBox["\[CurlyEpsilon]", 
                                  TraditionalForm]\) - 1\)\ 
                           \((\(g(t)\) - \(g(0)\))\)\), \({t, 0, 1}\)\)]\)\)\
\)], "Output", CellTags -> "TrickIntegrate"]}, Open]]}, Open]], 
        Cell["TrickMandelstam", "ObjectName", CellTags -> "TrickMandelstam"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "TrickMandelstam"], Cell[TextData[
             {"TrickMandelstam[expr, {s, t, u, ", Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["m", 
                       Rule[FontSlant, "Plain"]]\)\_1\%2\)]], " + ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["m", 
                       Rule[FontSlant, "Plain"]]\)\_2\%2\)]], "+ ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["m", 
                       Rule[FontSlant, "Plain"]]\)\_3\%2\)]], "+ ", 
              Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["m", 
                       Rule[FontSlant, "Plain"]]\)\_4\%2\)]], "}] simplifies \
all sums in expr so that one of the Mandelstam variables s, t or u is \
eliminated by the relation ", StyleBox["s", Rule[FontSlant, "Italic"]], 
              " + ", StyleBox["t", Rule[FontSlant, "Italic"]], " + ", 
              StyleBox["u", Rule[FontSlant, "Italic"]], " = ", Cell[BoxData[
                \(TraditionalForm\`\(\*StyleBox["m", 
                       Rule[FontSlant, "Italic"]]\)\_1\%2\)]], " + ", 
              Cell[BoxData[\(TraditionalForm\`m\_2\%2\)]], "+ ", Cell[BoxData[
                \(TraditionalForm\`m\_3\%2\)]], "+ ", Cell[BoxData[
                \(TraditionalForm\`m\_4\%2\)]], " . The trick is that the \
resulting sum has the most short number of terms."}], "Text", 
            CellTags -> "TrickMandelstam"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "TrickMandelstam"], Cell[CellGroupData[{Cell[BoxData[
                \(\(TrickMandelstam[\(\(\((s + t - u)\)\ 
                         \((\(2 M\_W\%2\) - t - u)\)\), 
                       \({s, t, u, \(2 M\_W\%2\)}\)\)]\)//Factor2\)], 
               "Input", CellTags -> "TrickMandelstam"], Cell[BoxData[
                \(TraditionalForm\`\(\(-2\)\ s\ \((u - M\_W\%2)\)\)\)], 
               "Output", CellTags -> "TrickMandelstam"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TrickMandelstam[\(\(\(\(M^2\)\ s\)\ -\ \(s^2\)\ +\ 
                       \(\(M^2\)\ t\)\ -\ st\ +\ \(\(M^2\)\ u\)\ -\ su\),\ 
                     \({s, t, u, \(2\(M^2\)\)}\)\)]\)], "Input", CellTags -> 
                "TrickMandelstam"], Cell[BoxData[
                \(TraditionalForm\`\(\(2\ M\^4\) - s\^2 - st - su\)\)], 
               "Output", CellTags -> "TrickMandelstam"]}, Open]]}, Open]], 
        Cell["Tr2", "ObjectName", CellTags -> "Tr2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Tr2"], Cell["If exp contains DiracTrace's, Tr2[exp] \
simplifies exp and does the Dirac traces unless more that 4 gamma matrices \
and DiracGamma[5] occur. Tr2[exp] also separates the color-strucure, and \
takes the color trace if Tf occurs in exp. If exp does not contain \
DiracTrace's, Tr2[exp] takes the Dirac trace.", "Text", CellTags -> "Tr2"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[Tr2]\)], "Input", 
               CellTags -> "Tr2"], Cell[BoxData[
                \(TraditionalForm\`\({Factoring \[Rule] False}\)\)], 
               "Output", CellTags -> "Tr2"]}, Open]], 
           Cell[TextData[{"See also: ", 
              ButtonBox["Tr", RuleDelayed[ButtonData, "Tr"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Tr"]], 
              ", ", 
              ButtonBox["Tf", RuleDelayed[ButtonData, "Tf"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Tf"]], 
              ", ", 
              ButtonBox["DiracTrace", RuleDelayed[ButtonData, "DiracTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracTrace"]], ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], ", ", 
              ButtonBox["SUNTrace", RuleDelayed[ButtonData, "SUNTrace"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SUNTrace"]], "."}], "Text", 
            CellTags -> "Tr2"]}, Open]], Cell[CellGroupData[
          {Cell["Examples", "Subsubsection", CellTags -> "Tr2"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Tr2[\(DiracMatrix[\(a, b, c, d\)]\)]\)], "Input"], 
              Cell[BoxData[
                \(TraditionalForm\`\(4\ \(
                      (\(g\^\(ad\)\ g\^\(bc\)\) - \(g\^\(ac\)\ g\^\(bd\)\) + 
                        \(g\^\(ab\)\ g\^\(cd\)\))\)\)\)], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(TR[\(\(a\ Tf\), \(SUNTrace \[Rule] True\)\)]\)], "Input", 
               CellTags -> "Tr2"], Cell[BoxData[
                \(TraditionalForm\`\(4\ a\ T\_f\)\)], "Output", CellTags -> 
                "Tr2"]}, Open]]}, Open]], 
        Cell["Twist2AlienOperator  ***unfinished*** (unclear usage def.)", 
         "ObjectName", CellTags -> "Twist2AlienOperator"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Twist2AlienOperator"], Cell["Twist2AlienOperator[p, \
0] : (7);   Twist2AlienOperator[p1,p2,{p3,mu,a}, 0] (p1: incoming quark \
momentum, p3: incoming gluon (count1)).", "Text", CellTags -> 
             "Twist2AlienOperator"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Twist2AlienOperator"], Cell[CellGroupData[
             {Cell[BoxData[\(Twist2AlienOperator[\(p,\ 0\)]\)], "Input", 
               CellTags -> "Twist2AlienOperator"], Cell[BoxData[
                FormBox[FractionBox[RowBox[{"2", " ", \(C\_F\), " ", 
                    \(g\_s\%2\), " ", \((2\/m - 1\/\(m + 1\) - 2\/\(m - 1\))\)
                    , " ", \(S\_n\), " ", RowBox[{FormBox["\"\[Gamma]\"", 
                       "TraditionalForm"], "\[CenterDot]", FormBox[
                       "\[CapitalDelta]", "TraditionalForm"]}], " ", 
                    SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                       ")"}], \(m - 1\)]}], 
                  TagBox["\[CurlyEpsilon]", TraditionalForm]], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2AlienOperator"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2AlienOperator[\(p1, p2, \({p3, mu, a}\),\ 0\)]\)], 
               "Input", CellTags -> "Twist2AlienOperator"], Cell[BoxData[
                FormBox[FractionBox[RowBox[{"\[ImaginaryI]", " ", 
                    \((1 + \((\(-1\))\)\^m)\), " ", \(g\_s\%3\), " ", \(S\_n\)
                    , " ", RowBox[{SubscriptBox["T", FormBox[FormBox["a", 
                         "TraditionalForm"], "TraditionalForm"]], ".", 
                      RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]}], ")"}]}], 
                    " ", SuperscriptBox[FormBox["\[CapitalDelta]", 
                      "TraditionalForm"], FormBox[FormBox["mu", 
                       "TraditionalForm"], "TraditionalForm"]], " ", 
                    RowBox[{"(", RowBox[{RowBox[{\((1\/\(m - 1\) - 1\/m)\), 
                          " ", SuperscriptBox[RowBox[{"(", RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], ")"}]}], ")"}], \(m - 2\)]}], 
                        "+", RowBox[{\((2\/m - 1\/\(m + 1\) - 2\/\(m - 1\))\)
                          , " ", RowBox[{"(", RowBox[{FractionBox[
                          SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], ")"}], \(m - 1\)], RowBox[
                          {RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]], "-", FractionBox[
                          SuperscriptBox[RowBox[{"(", RowBox[{"-", RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], ")"}]}], ")"}], \(m - 1\)], 
                          RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]]}], ")"}]}]}], ")"}]}], 
                  TagBox["\[CurlyEpsilon]", TraditionalForm]], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2AlienOperator"]}, Open]]}, Open]], 
        Cell["Twist2CounterOperator  ***unfinished*** (unclear usage def.)", 
         "ObjectName", CellTags -> "Twist2CounterOperator"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Twist2CounterOperator"], Cell["Twist2CounterOperator\
[p,mu,nu,a,b,5]; Twist2CounterOperator[p, 7] : (7);  \
Twist2CounterOperator[p1,p2,{p3,mu,a}, 1] (p1: incoming quark momentum, p3: \
incoming gluon (count1)).", "Text", CellTags -> "Twist2CounterOperator"]}, 
          Open]], Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Twist2CounterOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2CounterOperator[\(p, mu, nu, a, b, 5\)]\)], "Input", 
               CellTags -> "Twist2CounterOperator"], Cell[BoxData[
                FormBox[RowBox[{"-", RowBox[{
                     \(1\/\(2\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]\)
                       \), RowBox[{"(", RowBox[{\((1 + \((\(-1\))\)\^m)\), 
                         " ", \(C\_A\), " ", \(g\_s\%2\), " ", \(S\_n\), " ", 
                         RowBox[{"(", RowBox[{RowBox[{
                          \((8\/m - 24\/\(m + 1\) + 24\/\(m + 2\) - 
                              4\/\(m - 1\))\), " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["mu", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["nu", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], \(m - 2\)]}], "+", 
                          RowBox[{
                          \((\(-\(6\/m\)\) + 16\/\(m + 1\) - 16\/\(m + 2\) + 
                              6\/\(m - 1\))\), " ", RowBox[{"(", RowBox[
                          {RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["mu", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["nu", 
                          "TraditionalForm"], "TraditionalForm"]]}], "+", 
                          RowBox[{SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["mu", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["nu", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], \(m - 1\)]}], "+", 
                          RowBox[{
                          \((8\/m - 12\/\(m + 1\) + 8\/\(m + 2\) - 
                              8\/\(m - 1\))\), " ", \(g\^\(munu\)\), " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], "m"]}]}], ")"}], " ", SubscriptBox[
                          "\[Delta]", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], ")"}]}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2CounterOperator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2CounterOperator[\(p, 7\)]\)], "Input", CellTags -> 
                "Twist2CounterOperator"], Cell[BoxData[FormBox[FractionBox[
                  RowBox[{\((1 + \((\(-1\))\)\^m)\), " ", \(C\_F\), " ", 
                    \(g\_s\%2\), " ", \((2\/m - 1\/\(m + 1\) - 2\/\(m - 1\))\)
                    , " ", \(S\_n\), " ", RowBox[{FormBox["\"\[Gamma]\"", 
                       "TraditionalForm"], "\[CenterDot]", FormBox[
                       "\[CapitalDelta]", "TraditionalForm"]}], " ", 
                    SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                       ")"}], \(m - 1\)]}], 
                  TagBox["\[CurlyEpsilon]", TraditionalForm]], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2CounterOperator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2CounterOperator[\(p1, p2, \({p3, mu, a}\), 1\)]\)], 
               "Input", CellTags -> "Twist2CounterOperator"], 
              Cell[BoxData[FormBox[RowBox[{"-", FractionBox[RowBox[{
                      \((1 + \((\(-1\))\)\^m)\), " ", \((C\_A - \(2\ C\_F\))\)
                      , " ", \(g\_s\%3\), " ", 
                      \((2\/m - 1\/\(m + 1\) - 2\/\(m - 1\))\), " ", \(S\_n\)
                      , " ", RowBox[{FormBox["\"\[Gamma]\"", 
                         "TraditionalForm"], "\[CenterDot]", FormBox[
                         "\[CapitalDelta]", "TraditionalForm"]}], " ", 
                      SuperscriptBox[FormBox["\[CapitalDelta]", 
                        "TraditionalForm"], FormBox[FormBox["mu", 
                         "TraditionalForm"], "TraditionalForm"]], " ", 
                      RowBox[{"(", RowBox[{FractionBox[SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], ")"}], \(m - 1\)], RowBox[
                          {RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}]], "-", FractionBox[
                          SuperscriptBox[RowBox[{"(", RowBox[{"-", RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}], ")"}]}], ")"}], \(m - 1\)], 
                          RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}]]}], ")"}], " ", SubscriptBox[
                       "T", FormBox[FormBox["a", "TraditionalForm"], 
                        "TraditionalForm"]]}], 
                    \(2\ \*TagBox["\[CurlyEpsilon]", TraditionalForm]\)]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2CounterOperator"]}, Open]]}, Open]], 
        Cell["Twist2GluonOperator", "ObjectName", CellTags -> 
          "Twist2GluonOperator"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "Twist2GluonOperator"], Cell["Twist2GluonOperator[{p, mu, a}, \
{nu, b}] or Twist2GluonOperator[p, {mu, a}, {nu, b}] or \
Twist2GluonOperator[p, mu,a, nu,b] yields the 2-gluon operator (p is ingoing \
momentum corresponding to Lorentz index mu). Twist2GluonOperator[{p,mu,a}, \
{q,nu,b}, {k,la,c}] or Twist2GluonOperator[ p,mu,a , q,nu,b , k,la,c ] gives \
the 3-gluon operator. Twist2GluonOperator[{p,mu,a}, {q,nu,b}, {k,la,c}, \
{s,si,d}] or Twist2GluonOperator[p,mu,a , q,nu,b , k,la,c , s,si,d] yields \
the 4-Gluon operator. The dimension is determined by the option and \
Dimension. The setting of the option Polarization (unpolarized: 0; polarized: \
1) determines whether the unpolarized or polarized feynman rule is returned. \
With the setting Explicit to False the color-structure and the (1+(-1)^OPEm) \
(for polarized: (1-(-1)^OPEm)) is extracted and the color indices are omitted \
in the arguments of Twist2GluonOperator.", "Text", CellTags -> 
             "Twist2GluonOperator"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Twist2QuarkOperator", 
                RuleDelayed[ButtonData, "Twist2QuarkOperator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Twist2QuarkOperator"]], "."}], "Text", 
            CellTags -> "Twist2GluonOperator"]}, Open]], 
        Cell[CellGroupData[{Cell["Polarized case, zero-momentum insertion ", 
            "Subsubsection", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\(Twist2GluonOperator,\ 
                     \(Polarization\ \[Rule]\ 1\), \(Explicit \[Rule] False\)
                     ,\ \(ZeroMomentumInsertion\ \[Rule]\ True\)\)]\)], 
               "Input", CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Polarization \[Rule] 1\), 
                      \(Explicit \[Rule] False\), 
                      \(ZeroMomentumInsertion \[Rule] True\)}\)\)], "Output", 
               CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell["2-gluon legs", "Text", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(p, \({\[Mu], a}\), \({\[Nu], b}\)\)]
                  \)], "Input", CellTags -> "Twist2GluonOperator"], 
              Cell[BoxData[FormBox[RowBox[{"\[ImaginaryI]", " ", RowBox[
                    {"(", RowBox[{"1", "-", FormBox[\(\((\(-1\))\)\^m\), 
                        "TraditionalForm"]}], ")"}], " ", SubscriptBox[
                    "\[Delta]", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"]}]], " ", RowBox[{"(", RowBox[
                      {SubsuperscriptBox["O", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                          "\[VeryThinSpace]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]}], "G2"], 
                       "(", FormBox["p", "TraditionalForm"], ")"}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2GluonOperator[\(p, \({\[Mu], a}\), \({\[Nu], b}\), 
                     \(Explicit \[Rule] True\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[
                  {"\[ImaginaryI]", " ", SuperscriptBox["\[Epsilon]", 
                    RowBox[{FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       "\[CapitalDelta]", "TraditionalForm"], FormBox["p", 
                       "TraditionalForm"]}]], " ", RowBox[{"(", RowBox[
                      {"1", "-", FormBox[\(\((\(-1\))\)\^m\), 
                        "TraditionalForm"]}], ")"}], " ", FormBox[
                    SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                       ")"}], \(m - 1\)], "TraditionalForm"], " ", 
                   SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(p, \({\[Mu]}\), \({\[Nu]}\)\)]\)], 
               "Input", CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                FormBox[RowBox[{SubsuperscriptBox["O", RowBox[{FormBox[
                       "\[Mu]", "TraditionalForm"], "\[VeryThinSpace]", 
                      FormBox["\[Nu]", "TraditionalForm"]}], "G2"], "(", 
                   FormBox["p", "TraditionalForm"], ")"}], TraditionalForm]], 
               "Output", CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(p, \({\[Mu]}\), \({\[Nu]}\), 
                     \(Explicit \[Rule] True\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[
                  {SuperscriptBox["\[Epsilon]", RowBox[{FormBox[FormBox[
                        "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox["\[CapitalDelta]", 
                       "TraditionalForm"], FormBox["p", 
                       "TraditionalForm"]}]], " ", FormBox[SuperscriptBox[
                     RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], \(m - 1\)], 
                    "TraditionalForm"]}], TraditionalForm]], "Output", 
               CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell["3-gluon legs", "Text", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\),
                      \({r, \[Rho], c}\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[{\(g\_s\)
                   , " ", RowBox[{"(", RowBox[{"1", "-", FormBox[
                        \(\((\(-1\))\)\^m\), "TraditionalForm"]}], ")"}], 
                   " ", SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]], " ", RowBox[{"(", RowBox[
                      {SubsuperscriptBox["O", RowBox[{FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"], 
                          "\[VeryThinSpace]", FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[VeryThinSpace]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]}], "G3"], 
                       "(", FormBox["q", "TraditionalForm"], ",", FormBox[
                        "r", "TraditionalForm"], ",", FormBox["p", 
                        "TraditionalForm"], ")"}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu]}\), \({q, \[Nu]}\), 
                     \({r, \[Rho]}\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[
                  {SubsuperscriptBox["O", RowBox[{FormBox["\[Nu]", 
                       "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                       "\[Rho]", "TraditionalForm"], "\[VeryThinSpace]", 
                      FormBox["\[Mu]", "TraditionalForm"]}], "G3"], "(", 
                   FormBox["q", "TraditionalForm"], ",", FormBox["r", 
                    "TraditionalForm"], ",", FormBox["p", "TraditionalForm"], 
                   ")"}], TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu]}\), \({q, \[Nu]}\), 
                     \({r, \[Rho]}\), \(Explicit \[Rule] True\)\)]\)], 
               "Input", CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{RowBox[{"-", RowBox[{"(", RowBox[
                          {RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "p", "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}]}], " ", 
                     SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                        ")"}], \(m - 2\)]}], "-", RowBox[{RowBox[{"(", 
                       RowBox[{RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", SuperscriptBox[
                      RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], \(m - 2\)]}], "-", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", SuperscriptBox[
                      RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], ")"}], \(m - 2\)]}], "+", 
                   RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[{
                          \(\((\(-1\))\)\^i\), " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)]}]}], HoldForm], 
                        "TraditionalForm"], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}]}], ")"}]}], "-", 
                   RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[{
                          \(\((\(-1\))\)\^i\), " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)]}]}], HoldForm], 
                        "TraditionalForm"], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}]}], ")"}]}], "-", 
                   RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[{
                          \(\((\(-1\))\)\^i\), " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)]}]}], HoldForm], 
                        "TraditionalForm"], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]}], ")"}]}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], Cell["4-gluon legs", "Text", 
            CellTags -> "Twist2GluonOperator"], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\),
                      \({r, \[Rho], c}\), \({s, \[Sigma], d}\)\)]\)], 
               "Input", CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                FormBox[RowBox[{"\[ImaginaryI]", " ", 
                   \((1 - \((\(-1\))\)\^m)\), " ", \(g\_s\%2\), " ", 
                   RowBox[{"(", RowBox[{RowBox[{RowBox[{"-", SubscriptBox[
                          "f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c137", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c137", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         RowBox[{"(", RowBox[{SubsuperscriptBox["O", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}], "G4"], "(", FormBox["p", 
                          "TraditionalForm"], ",", FormBox["q", 
                          "TraditionalForm"], ",", FormBox["r", 
                          "TraditionalForm"], ",", FormBox["s", 
                          "TraditionalForm"], ")"}], ")"}]}], "-", RowBox[
                        {SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c137", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c137", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         RowBox[{"(", RowBox[{SubsuperscriptBox["O", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}], "G4"], "(", FormBox["p", 
                          "TraditionalForm"], ",", FormBox["r", 
                          "TraditionalForm"], ",", FormBox["q", 
                          "TraditionalForm"], ",", FormBox["s", 
                          "TraditionalForm"], ")"}], ")"}]}], "+", RowBox[
                        {SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c137", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c137", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         RowBox[{"(", RowBox[{SubsuperscriptBox["O", RowBox[
                          {FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}], "G4"], "(", FormBox["r", 
                          "TraditionalForm"], ",", FormBox["q", 
                          "TraditionalForm"], ",", FormBox["p", 
                          "TraditionalForm"], ",", FormBox["s", 
                          "TraditionalForm"], ")"}], ")"}]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu]}\), \({q, \[Nu]}\), 
                     \({r, \[Rho]}\), \({s, \[Sigma]}\)\)]\)], "Input", 
               CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                FormBox[RowBox[{SubsuperscriptBox["O", RowBox[{FormBox[
                       "\[Mu]", "TraditionalForm"], "\[VeryThinSpace]", 
                      FormBox["\[Nu]", "TraditionalForm"], 
                      "\[VeryThinSpace]", FormBox["\[Rho]", 
                       "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                       "\[Sigma]", "TraditionalForm"]}], "G4"], "(", 
                   FormBox["p", "TraditionalForm"], ",", FormBox["q", 
                    "TraditionalForm"], ",", FormBox["r", "TraditionalForm"], 
                   ",", FormBox["s", "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu]}\), \({q, \[Nu]}\), 
                     \({r, \[Rho]}\), \({s, \[Sigma]}\), 
                     \(Explicit \[Rule] True\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", SuperscriptBox[
                      RowBox[{"(", RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(m - 2\)]}], "-", 
                   RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}]}], "-", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)]}]}], HoldForm], 
                        "TraditionalForm"], ")"}], " ", RowBox[{"(", 
                       RowBox[{RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["s", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["s", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"]]}], "+", RowBox[{RowBox[{"(", 
                       FormBox[TagBox[RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 3\)\)
                          , RowBox[{SuperscriptBox[RowBox[{"(", RowBox[
                          {RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], \(\(-i\) + m - 3\)], 
                          " ", SuperscriptBox[RowBox[{"(", RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"]}]}], 
                         HoldForm], "TraditionalForm"], ")"}], " ", 
                     RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"]]}], "-", RowBox[{RowBox[{"(", 
                       FormBox[TagBox[RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 3\)\)
                          , RowBox[{SuperscriptBox[RowBox[{"(", RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(\(-i\) + m - 3\)]}]
                          }], HoldForm], "TraditionalForm"], ")"}], " ", 
                     SuperscriptBox[FormBox["\[CapitalDelta]", 
                       "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}]}], "+", RowBox[
                    {RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{"-", RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(\(-i\) + m - 3\)]}]
                          }], HoldForm], "TraditionalForm"], ")"}], " ", 
                     SuperscriptBox[FormBox["\[CapitalDelta]", 
                       "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}]}], "-", RowBox[
                    {RowBox[{"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 4\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((j + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-j\) + m - 4\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{"-", RowBox[{"(", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], ")"}]}], "-", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{"-", RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"]}], 
                          "TraditionalForm"]}], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                       "\[CapitalDelta]", "TraditionalForm"], FormBox[
                       FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{RowBox[{"-", SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "p", "TraditionalForm"], FormBox["s", 
                          "TraditionalForm"]}]]}], " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["s", 
                          "TraditionalForm"]}]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}]}], ")"}]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 4\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((j + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-j\) + m - 4\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{"-", RowBox[{"(", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], ")"}]}], "-", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{"-", RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"]}], 
                          "TraditionalForm"]}], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                       "\[CapitalDelta]", "TraditionalForm"], FormBox[
                       FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{RowBox[{"-", SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "q", "TraditionalForm"], FormBox["s", 
                          "TraditionalForm"]}]]}], " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["s", 
                          "TraditionalForm"]}]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]}], ")"}]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 4\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((j + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-j\) + m - 4\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{"-", RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}]}], ")"}], "i"], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{RowBox[{"-", RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}]}], "-", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)]}], 
                          "TraditionalForm"]}], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                       "\[CapitalDelta]", "TraditionalForm"], FormBox[
                       FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{RowBox[{"-", SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "p", "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]]}], " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"]}]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}]}], "-", 
                   RowBox[{RowBox[{"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 4\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((j + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-j\) + m - 4\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{"-", RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}]}], ")"}], "i"], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{RowBox[{"-", RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}]}], "-", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)]}], 
                          "TraditionalForm"]}], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                       "\[CapitalDelta]", "TraditionalForm"], FormBox[
                       FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{RowBox[{"-", SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "q", "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]]}], " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}]}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Unpolarized case, zero-momentum insertion", 
            "Subsubsection", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\(Twist2GluonOperator, 
                     \(Polarization \[Rule] 0\), 
                     \(ZeroMomentumInsertion \[Rule] True\)\)]\)], "Input", 
               CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Polarization \[Rule] 0\), 
                      \(Explicit \[Rule] False\), 
                      \(ZeroMomentumInsertion \[Rule] True\)}\)\)], "Output", 
               CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell["2-gluon legs", "Text", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(p, \({\[Mu], a}\), \({\[Nu], b}\)\)]
                  \)], "Input", CellTags -> "Twist2GluonOperator"], 
              Cell[BoxData[FormBox[RowBox[{\(1\/2\), " ", RowBox[{"(", 
                     RowBox[{FormBox[\(\((\(-1\))\)\^m\), "TraditionalForm"], 
                       "+", "1"}], ")"}], " ", SubscriptBox["\[Delta]", 
                    RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"]}]], " ", 
                   RowBox[{"(", RowBox[{SubsuperscriptBox["O", RowBox[
                         {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]}], "G2"], "(", FormBox["p", 
                        "TraditionalForm"], ")"}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2GluonOperator[\(p, \({\[Mu], a}\), \({\[Nu], b}\), 
                     \(Explicit \[Rule] True\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[{\(1\/2\)
                   , " ", RowBox[{"(", RowBox[{RowBox[{\(g\^\(\[Mu]\[Nu]\)\), 
                         " ", SuperscriptBox[FormBox[RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"]}], "-", RowBox[
                        {RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "+", 
                          RowBox[{SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"]}]}], ")"}], " ", 
                   RowBox[{"(", RowBox[{FormBox[\(\((\(-1\))\)\^m\), 
                        "TraditionalForm"], "+", "1"}], ")"}], " ", 
                   FormBox[SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                       ")"}], \(m - 2\)], "TraditionalForm"], " ", 
                   SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(p, \({\[Mu]}\), \({\[Nu]}\)\)]\)], 
               "Input", CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                FormBox[RowBox[{SubsuperscriptBox["O", RowBox[{FormBox[
                       "\[Mu]", "TraditionalForm"], "\[VeryThinSpace]", 
                      FormBox["\[Nu]", "TraditionalForm"]}], "G2"], "(", 
                   FormBox["p", "TraditionalForm"], ")"}], TraditionalForm]], 
               "Output", CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(p, \({\[Mu]}\), \({\[Nu]}\), 
                     \(Explicit \[Rule] True\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"(", RowBox[{RowBox[{\(g\^\(\[Mu]\[Nu]\)\), " ", 
                         SuperscriptBox[FormBox[RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"]}], "-", RowBox[
                        {RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "+", 
                          RowBox[{SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], "2"]}]}], ")"}], " ", 
                   FormBox[SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                       ")"}], \(m - 2\)], "TraditionalForm"]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], Cell["3-gluon legs", "Text", 
            CellTags -> "Twist2GluonOperator"], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\),
                      \({r, \[Rho], c}\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[{
                   \(-\(1\/2\)\), " ", "\[ImaginaryI]", " ", \(g\_s\), " ", 
                   RowBox[{"(", RowBox[{FormBox[\(\((\(-1\))\)\^m\), 
                        "TraditionalForm"], "+", "1"}], ")"}], " ", 
                   SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], "TraditionalForm"], 
                      FormBox[FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]], " ", RowBox[{"(", RowBox[
                      {SubsuperscriptBox["O", RowBox[{FormBox[FormBox[
                          "\[Nu]", "TraditionalForm"], "TraditionalForm"], 
                          "\[VeryThinSpace]", FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[VeryThinSpace]", FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]}], "G3"], 
                       "(", FormBox["q", "TraditionalForm"], ",", FormBox[
                        "r", "TraditionalForm"], ",", FormBox["p", 
                        "TraditionalForm"], ")"}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu]}\), \({q, \[Nu]}\), 
                     \({r, \[Rho]}\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[
                  {SubsuperscriptBox["O", RowBox[{FormBox["\[Nu]", 
                       "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                       "\[Rho]", "TraditionalForm"], "\[VeryThinSpace]", 
                      FormBox["\[Mu]", "TraditionalForm"]}], "G3"], "(", 
                   FormBox["q", "TraditionalForm"], ",", FormBox["r", 
                    "TraditionalForm"], ",", FormBox["p", "TraditionalForm"], 
                   ")"}], TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu]}\), \({q, \[Nu]}\), 
                     \({r, \[Rho]}\), \(Explicit \[Rule] True\)\)]\)], 
               "Input", CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{"-", RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)]}]}], HoldForm], 
                        "TraditionalForm"], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(\[Mu]\[Nu]\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]}], ")"}]}], "+", 
                   RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{"-", RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}]}], ")"}], "i"]}]}], HoldForm], 
                        "TraditionalForm"], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{SuperscriptBox[FormBox["r", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(\[Mu]\[Rho]\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}]}], "+", 
                   RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{"-", RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)]}]}], HoldForm], 
                        "TraditionalForm"], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{SuperscriptBox[FormBox["r", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(\[Nu]\[Rho]\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "q", "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                          {RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                          RowBox[{SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}]}], "+", RowBox[
                          {RowBox[{"(", RowBox[{RowBox[{\(g\^\(\[Mu]\[Rho]\)\)
                          , " ", SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                          RowBox[{\(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}]}], ")"}], " ", FormBox[
                      SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                         ")"}], \(m - 2\)], "TraditionalForm"]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                          {RowBox[{SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          FormBox["q", "TraditionalForm"], FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"]], 
                          " ", SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]]}]}], 
                          ")"}]}], "+", RowBox[{RowBox[{"(", RowBox[{RowBox[{
                          \(g\^\(\[Mu]\[Nu]\)\), " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(\[Nu]\[Rho]\)\)}]}]
                          , ")"}], " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]}], ")"}], " ", FormBox[
                      SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                         ")"}], \(m - 2\)], "TraditionalForm"]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{RowBox[{"(", RowBox[
                          {RowBox[{SuperscriptBox[FormBox["r", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                          RowBox[{SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["r", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{RowBox[{"(", 
                          RowBox[{RowBox[{SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(\[Nu]\[Rho]\)\)}], 
                          "-", RowBox[{\(g\^\(\[Mu]\[Rho]\)\), " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}]}], ")"}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}], " ", FormBox[
                      SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                         ")"}], \(m - 2\)], "TraditionalForm"]}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], Cell["4-gluon legs", "Text", 
            CellTags -> "Twist2GluonOperator"], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\),
                      \({r, \[Rho], c}\), \({s, \[Sigma], d}\)\)]\)], 
               "Input", CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                FormBox[RowBox[{\(1\/2\), " ", \((1 + \((\(-1\))\)\^m)\), 
                   " ", \(g\_s\%2\), " ", RowBox[{"(", RowBox[{RowBox[
                        {RowBox[{"-", SubscriptBox["f", RowBox[{FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c138", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c138", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", RowBox[{"(", RowBox[
                          {SubsuperscriptBox["O", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                          "\[VeryThinSpace]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[VeryThinSpace]", FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[VeryThinSpace]", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]}], "G4"], 
                          "(", FormBox["p", "TraditionalForm"], ",", FormBox[
                          "q", "TraditionalForm"], ",", FormBox["r", 
                          "TraditionalForm"], ",", FormBox["s", 
                          "TraditionalForm"], ")"}], ")"}]}], "-", RowBox[
                        {SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c138", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c138", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         RowBox[{"(", RowBox[{SubsuperscriptBox["O", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}], "G4"], "(", FormBox["p", 
                          "TraditionalForm"], ",", FormBox["r", 
                          "TraditionalForm"], ",", FormBox["q", 
                          "TraditionalForm"], ",", FormBox["s", 
                          "TraditionalForm"], ")"}], ")"}]}], "+", RowBox[
                        {SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c138", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c138", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         RowBox[{"(", RowBox[{SubsuperscriptBox["O", RowBox[
                          {FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}], "G4"], "(", FormBox["r", 
                          "TraditionalForm"], ",", FormBox["q", 
                          "TraditionalForm"], ",", FormBox["p", 
                          "TraditionalForm"], ",", FormBox["s", 
                          "TraditionalForm"], ")"}], ")"}]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu]}\), \({q, \[Nu]}\), 
                     \({r, \[Rho]}\), \({s, \[Sigma]}\)\)]\)], "Input", 
               CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                FormBox[RowBox[{SubsuperscriptBox["O", RowBox[{FormBox[
                       "\[Mu]", "TraditionalForm"], "\[VeryThinSpace]", 
                      FormBox["\[Nu]", "TraditionalForm"], 
                      "\[VeryThinSpace]", FormBox["\[Rho]", 
                       "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                       "\[Sigma]", "TraditionalForm"]}], "G4"], "(", 
                   FormBox["p", "TraditionalForm"], ",", FormBox["q", 
                    "TraditionalForm"], ",", FormBox["r", "TraditionalForm"], 
                   ",", FormBox["s", "TraditionalForm"], ")"}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu]}\), \({q, \[Nu]}\), 
                     \({r, \[Rho]}\), \({s, \[Sigma]}\), 
                     \(Explicit \[Rule] True\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(\[Nu]\[Sigma]\)\), 
                          " ", SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{\(g\^\(\[Mu]\[Sigma]\)\), " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          \(g\^\(\[Nu]\[Rho]\)\), " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{
                          \(g\^\(\[Mu]\[Rho]\)\), " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", SuperscriptBox[
                      RowBox[{"(", RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(m - 2\)]}], "+", 
                   RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{"-", RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(\(-i\) + m - 3\)]}]
                          }], HoldForm], "TraditionalForm"], ")"}], " ", 
                     SuperscriptBox[FormBox["\[CapitalDelta]", 
                       "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{\(g\^\(\[Mu]\[Rho]\)\), " ", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          " ", SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["p", "TraditionalForm"], 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{
                          \(g\^\(\[Mu]\[Sigma]\)\), " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}]}], ")"}]}], "-", 
                   RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{"-", RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(\(-i\) + m - 3\)]}]
                          }], HoldForm], "TraditionalForm"], ")"}], " ", 
                     SuperscriptBox[FormBox["\[CapitalDelta]", 
                       "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "q", "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{\(g\^\(\[Nu]\[Rho]\)\), " ", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          " ", SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["q", "TraditionalForm"], 
                          FormBox[FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{
                          \(g\^\(\[Nu]\[Sigma]\)\), " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]}], ")"}]}], "+", 
                   RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], \(\(-i\) + m - 3\)], 
                          " ", SuperscriptBox[RowBox[{"(", RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"]}]}], 
                         HoldForm], "TraditionalForm"], ")"}], " ", 
                     SuperscriptBox[FormBox["\[CapitalDelta]", 
                       "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                        "TraditionalForm"], "TraditionalForm"]], " ", 
                     RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[FormBox["r", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["r", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(\[Nu]\[Rho]\)\), 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(\[Mu]\[Rho]\)\), " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}]}], "+", 
                   RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}]}], "-", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)]}]}], HoldForm], 
                        "TraditionalForm"], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{SuperscriptBox[FormBox["s", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                         RowBox[{SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["s", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(\[Nu]\[Sigma]\)\), 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(\[Mu]\[Sigma]\)\), " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}]}], ")"}]}], "-", 
                   RowBox[{RowBox[{"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 4\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((j + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-j\) + m - 4\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{"-", RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}]}], ")"}], "i"], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{RowBox[{"-", RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}]}], "-", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)]}], 
                          "TraditionalForm"]}], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                       "\[CapitalDelta]", "TraditionalForm"], FormBox[
                       FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{RowBox[{"-", SuperscriptBox[FormBox["r", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "+", RowBox[{
                          \(g\^\(\[Mu]\[Rho]\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 4\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((j + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-j\) + m - 4\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{"-", RowBox[{"(", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], ")"}]}], "-", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{"-", RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"]}], 
                          "TraditionalForm"]}], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                       "\[CapitalDelta]", "TraditionalForm"], FormBox[
                       FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{RowBox[{"-", SuperscriptBox[FormBox["s", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "+", RowBox[{
                          \(g\^\(\[Mu]\[Sigma]\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "p", "TraditionalForm"], FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}]}], ")"}]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 4\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((j + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-j\) + m - 4\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{"-", RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}]}], ")"}], "i"], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{RowBox[{"-", RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}]}], "-", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)]}], 
                          "TraditionalForm"]}], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                       "\[CapitalDelta]", "TraditionalForm"], FormBox[
                       FormBox["\[Sigma]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{RowBox[{"-", SuperscriptBox[FormBox["r", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "+", RowBox[{
                          \(g\^\(\[Nu]\[Rho]\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "q", "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}]}], "-", 
                   RowBox[{RowBox[{"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 4\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((j + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-j\) + m - 4\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{"-", RowBox[{"(", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], ")"}]}], "-", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{"-", RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"]}], 
                          "TraditionalForm"]}], ")"}], " ", SuperscriptBox[
                      FormBox["\[CapitalDelta]", "TraditionalForm"], 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                       "\[CapitalDelta]", "TraditionalForm"], FormBox[
                       FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                        {RowBox[{RowBox[{"-", SuperscriptBox[FormBox["s", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "+", RowBox[{
                          \(g\^\(\[Nu]\[Sigma]\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "q", "TraditionalForm"], FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}]}], ")"}]}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Advanced Examples", "Subsubsection", 
            CellTags -> "Twist2GluonOperator"], 
           Cell["The setting All for Explicit performs the sums.", "Text", 
            CellTags -> "Twist2GluonOperator"], Cell[BoxData[
             \(\(SetOptions[\(Twist2GluonOperator,\ 
                    \(Polarization\ \[Rule]\ 1\),\ \(Explicit \[Rule] All\)\)\
]\) ;\)], "Input", CellTags -> "Twist2GluonOperator"], Cell[BoxData[
             \(\(Twist2GluonOperator[\(
                   \({p, \[Mu], a}\), \({q, \[Nu], b}\), \({r, \[Rho], c}\)\)\
]\) ;\)], "Input", CellTags -> "Twist2GluonOperator"]}, Open]], 
        Cell[CellGroupData[
          {Cell["Polarized case, non-zero-momentum insertion", 
            "Subsubsection", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\(Twist2GluonOperator,\ 
                     \(Polarization\ \[Rule]\ 1\), 
                     \(ZeroMomentumInsertion \[Rule] False\)\)]\)], "Input", 
               CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Polarization \[Rule] 1\), 
                      \(Explicit \[Rule] All\), 
                      \(ZeroMomentumInsertion \[Rule] False\)}\)\)], 
               "Output", CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell["2-gluon legs", "Text", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, q}\), \({\[Mu], a}\), 
                     \({\[Nu], b}\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[{\(1\/2\)
                   , " ", "\[ImaginaryI]", " ", \((1 - \((\(-1\))\)\^m)\), 
                   " ", RowBox[{"(", RowBox[{RowBox[{RowBox[{"(", RowBox[
                          {RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}]}], ")"}], " ", FormBox[
                          SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(m - 2\)], "TraditionalForm"]}], "+", 
                       RowBox[{RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"]}]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", FormBox[
                          SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(m - 2\)], "TraditionalForm"]}]}], ")"}], 
                   " ", SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell["3-gluon legs", "Text", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\),
                      \({r, \[Rho], c}\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[{\(g\_s\)
                   , " ", RowBox[{"(", RowBox[{RowBox[{RowBox[{"-", 
                          SuperscriptBox["\[Epsilon]", RowBox[{FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"]}]]}], " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], \(m - 2\)]}], "+", 
                       RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], \(m - 2\)]}], "-", 
                       RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], ")"}], \(m - 2\)]}], "-", 
                       RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", RowBox[{"(", FormBox[
                          TagBox[RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 3\)\), 
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", RowBox[{"(", FormBox[
                          TagBox[RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 3\)\), 
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", RowBox[{"(", FormBox[
                          TagBox[RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 3\)\), 
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", RowBox[{"(", FormBox[
                          TagBox[RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 3\)\), 
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", RowBox[{"(", FormBox[
                          TagBox[RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 3\)\), 
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "-", RowBox[{SuperscriptBox[
                          "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", RowBox[{"(", FormBox[
                          TagBox[RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 3\)\), 
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{FractionBox[
                          "1", SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "2"]], RowBox[
                          {"(", RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "m"], "+", RowBox[
                          {RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "TraditionalForm"], "3"]}], 
                          "+", RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          " ", SuperscriptBox[FormBox[RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"]}], "+", RowBox[{"2", " ", 
                          RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]}], ")"}]}], ")"}]}], "-", 
                       RowBox[{FractionBox["1", SuperscriptBox[RowBox[{"(", 
                          RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "2"]], RowBox[
                          {"(", RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "m"], "+", RowBox[
                          {RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "TraditionalForm"], "3"]}], 
                          "+", RowBox[{"2", " ", RowBox[{"(", FormBox[TagBox[
                          RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          " ", SuperscriptBox[FormBox[RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"]}], "+", RowBox[{RowBox[
                          {"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]}], ")"}]}], ")"}]}], "-", 
                       RowBox[{FractionBox["1", SuperscriptBox[RowBox[{"(", 
                          RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "2"]], RowBox[
                          {"(", RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "m"], "+", RowBox[
                          {RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "TraditionalForm"], "3"]}], 
                          "+", RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          " ", SuperscriptBox[FormBox[RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"]}], "+", RowBox[{"2", " ", 
                          RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}]}], ")"}]}], "-", 
                       RowBox[{FractionBox["1", SuperscriptBox[RowBox[{"(", 
                          RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "2"]], RowBox[
                          {"(", RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "m"], "+", RowBox[
                          {RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], "TraditionalForm"], "3"]}], 
                          "+", RowBox[{"2", " ", RowBox[{"(", FormBox[TagBox[
                          RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          " ", SuperscriptBox[FormBox[RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"]}], "+", RowBox[{RowBox[
                          {"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}]}], ")"}]}], "-", 
                       RowBox[{FractionBox["1", SuperscriptBox[RowBox[{"(", 
                          RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "2"]], RowBox[
                          {"(", RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "m"], "+", RowBox[
                          {RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "TraditionalForm"], "3"]}], 
                          "+", RowBox[{RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          " ", SuperscriptBox[FormBox[RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"]}], "+", RowBox[{"2", " ", 
                          RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}]}], ")"}]}], "+", 
                       RowBox[{FractionBox["1", SuperscriptBox[RowBox[{"(", 
                          RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "2"]], RowBox[
                          {"(", RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "m"], "+", RowBox[
                          {RowBox[{"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], "TraditionalForm"], "3"]}], 
                          "+", RowBox[{"2", " ", RowBox[{"(", FormBox[TagBox[
                          RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          " ", SuperscriptBox[FormBox[RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          "TraditionalForm"], "2"]}], "+", RowBox[{RowBox[
                          {"(", FormBox[TagBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}]}], ")"}]}], "-", 
                       FractionBox[RowBox[{SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]}]], " ", 
                          RowBox[{"(", RowBox[{RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], "m"]}], "+", RowBox[
                          {RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], ")"}], "m"], " ", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], "m"], " ", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}]}], ")"}]}], RowBox[
                         {RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}]]}], ")"}], " ", SubscriptBox[
                    "f", RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["b", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["c", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell["4-gluon legs", "Text", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\),
                      \({r, \[Rho], c}\), \({s, \[Sigma], d}\), 
                     \(Explicit \[Rule] False\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[
                  {"\[ImaginaryI]", " ", \((1 - \((\(-1\))\)\^m)\), " ", 
                   \(g\_s\%2\), " ", RowBox[{"(", RowBox[{RowBox[
                        {RowBox[{"-", SubscriptBox["f", RowBox[{FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c139", "TraditionalForm"], 
                          "TraditionalForm"]}]]}], " ", SubscriptBox["f", 
                          RowBox[{FormBox[FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c139", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["d", "TraditionalForm"], 
                          "TraditionalForm"]}]], " ", RowBox[{"(", RowBox[
                          {SubsuperscriptBox["O", RowBox[{FormBox[FormBox[
                          "\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                          "\[VeryThinSpace]", FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[VeryThinSpace]", FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[VeryThinSpace]", FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]}], "G4"], 
                          "(", FormBox["p", "TraditionalForm"], ",", FormBox[
                          "q", "TraditionalForm"], ",", FormBox["r", 
                          "TraditionalForm"], ",", FormBox["s", 
                          "TraditionalForm"], ")"}], ")"}]}], "-", RowBox[
                        {SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c139", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c139", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         RowBox[{"(", RowBox[{SubsuperscriptBox["O", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}], "G4"], "(", FormBox["p", 
                          "TraditionalForm"], ",", FormBox["r", 
                          "TraditionalForm"], ",", FormBox["q", 
                          "TraditionalForm"], ",", FormBox["s", 
                          "TraditionalForm"], ")"}], ")"}]}], "+", RowBox[
                        {SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c139", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c139", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         RowBox[{"(", RowBox[{SubsuperscriptBox["O", RowBox[
                          {FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}], "G4"], "(", FormBox["r", 
                          "TraditionalForm"], ",", FormBox["q", 
                          "TraditionalForm"], ",", FormBox["p", 
                          "TraditionalForm"], ",", FormBox["s", 
                          "TraditionalForm"], ")"}], ")"}]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]]}, Open]], 
        Cell[CellGroupData[
          {Cell["Unpolarized case, non-zero-momentum insertion", 
            "Subsubsection", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\(Twist2GluonOperator,\ 
                     \(Polarization\ \[Rule]\ 0\), 
                     \(ZeroMomentumInsertion \[Rule] False\)\)]\)], "Input", 
               CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Polarization \[Rule] 0\), 
                      \(Explicit \[Rule] All\), 
                      \(ZeroMomentumInsertion \[Rule] False\)}\)\)], 
               "Output", CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell["2-gluon legs", "Text", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, q}\), \({\[Mu], a}\), 
                     \({\[Nu], b}\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[{
                   \(-\(1\/2\)\), " ", \((1 + \((\(-1\))\)\^m)\), " ", 
                   RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[FormBox["q", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "-", RowBox[{
                         \(g\^\(\[Mu]\[Nu]\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                         " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                          {RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox["p", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]}], ")"}]}]}], ")"}], " ", 
                   RowBox[{"(", RowBox[{FormBox[SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], \(m - 2\)], 
                        "TraditionalForm"], "+", FormBox[SuperscriptBox[
                         RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], \(m - 2\)], 
                        "TraditionalForm"]}], ")"}], " ", SubscriptBox[
                    "\[Delta]", RowBox[{FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["b", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell["3-gluon legs", "Text", CellTags -> "Twist2GluonOperator"], 
           Cell[BoxData[
             \(\(Twist2GluonOperator[\(
                   \({p, \[Mu], a}\), \({q, \[Nu], b}\), \({r, \[Rho], c}\)\)\
]\) ;\)], "Input", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu]}\), \({q, \[Nu]}\), 
                     \({r, \[Rho]}\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[{
                   \(-\(1\/2\)\), " ", \((1 + \((\(-1\))\)\^m)\), " ", 
                   RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[FormBox[
                          "\[Mu]", "TraditionalForm"], FormBox[FormBox["q", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["r", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                         RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "-", RowBox[{\(g\^\(qr\)\), 
                         " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[Mu]", "TraditionalForm"]}], " ", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["q", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                          {RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["r", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[Mu]", "TraditionalForm"]}]}], "-", RowBox[
                          {SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["r", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[Mu]", 
                          "TraditionalForm"]}]}]}], ")"}]}]}], ")"}], " ", 
                   RowBox[{"(", RowBox[{FormBox[SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], \(m - 2\)], 
                        "TraditionalForm"], "+", FormBox[SuperscriptBox[
                         RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[Mu]", "TraditionalForm"]}], ")"}], \(m - 2\)], 
                        "TraditionalForm"]}], ")"}], " ", SubscriptBox[
                    "\[Delta]", RowBox[{FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu]}\), \({q, \[Nu]}\), 
                     \({r, \[Rho]}\), \(Explicit \[Rule] True\)\)]\)], 
               "Input", CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                FormBox[RowBox[{\(-\(1\/2\)\), " ", \((1 + \((\(-1\))\)\^m)\)
                   , " ", RowBox[{"(", RowBox[{RowBox[{SuperscriptBox[
                          FormBox["\[Mu]", "TraditionalForm"], FormBox[
                          FormBox["q", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["r", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "-", RowBox[{\(g\^\(qr\)\), 
                         " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[Mu]", "TraditionalForm"]}], " ", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["q", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                          {RowBox[{SuperscriptBox[FormBox["p", 
                          "TraditionalForm"], FormBox[FormBox["r", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[Mu]", "TraditionalForm"]}]}], "-", RowBox[
                          {SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["r", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["p", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[Mu]", 
                          "TraditionalForm"]}]}]}], ")"}]}]}], ")"}], " ", 
                   RowBox[{"(", RowBox[{FormBox[SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], \(m - 2\)], 
                        "TraditionalForm"], "+", FormBox[SuperscriptBox[
                         RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[Mu]", "TraditionalForm"]}], ")"}], \(m - 2\)], 
                        "TraditionalForm"]}], ")"}], " ", SubscriptBox[
                    "\[Delta]", RowBox[{FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Rho]", "TraditionalForm"], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "Twist2GluonOperator"]}, Open]], 
           Cell["4-gluon legs", "Text", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2GluonOperator[\(\({p, \[Mu], a}\), \({q, \[Nu], b}\),
                      \({r, \[Rho], c}\), \({s, \[Sigma], d}\), 
                     \(Explicit \[Rule] False\)\)]\)], "Input", CellTags -> 
                "Twist2GluonOperator"], Cell[BoxData[FormBox[RowBox[{\(1\/2\)
                   , " ", \((1 + \((\(-1\))\)\^m)\), " ", \(g\_s\%2\), " ", 
                   RowBox[{"(", RowBox[{RowBox[{RowBox[{"-", SubscriptBox[
                          "f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c140", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["c", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c140", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         RowBox[{"(", RowBox[{SubsuperscriptBox["O", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}], "G4"], "(", FormBox["p", 
                          "TraditionalForm"], ",", FormBox["q", 
                          "TraditionalForm"], ",", FormBox["r", 
                          "TraditionalForm"], ",", FormBox["s", 
                          "TraditionalForm"], ")"}], ")"}]}], "-", RowBox[
                        {SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c140", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c140", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         RowBox[{"(", RowBox[{SubsuperscriptBox["O", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}], "G4"], "(", FormBox["p", 
                          "TraditionalForm"], ",", FormBox["r", 
                          "TraditionalForm"], ",", FormBox["q", 
                          "TraditionalForm"], ",", FormBox["s", 
                          "TraditionalForm"], ")"}], ")"}]}], "+", RowBox[
                        {SubscriptBox["f", RowBox[{FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c140", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["d", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         SubscriptBox["f", RowBox[{FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["c", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["c140", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                         RowBox[{"(", RowBox[{SubsuperscriptBox["O", RowBox[
                          {FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], "\[VeryThinSpace]", FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]}], "G4"], "(", FormBox["r", 
                          "TraditionalForm"], ",", FormBox["q", 
                          "TraditionalForm"], ",", FormBox["p", 
                          "TraditionalForm"], ",", FormBox["s", 
                          "TraditionalForm"], ")"}], ")"}]}]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], 
           Cell["Suppress the lengthy output.", "Text", CellTags -> 
             "Twist2GluonOperator"], Cell[CellGroupData[{Cell[BoxData[
                \(Short[\(\(Twist2GluonOperator[
                       \(\({p, \[Mu]}\), \({q, \[Nu]}\), \({r, \[Rho]}\), 
                         \({s, \[Sigma]}\), \(Explicit \[Rule] True\)\)]\), 6
                \)]\)], "Input", CellTags -> "Twist2GluonOperator"], 
              Cell[BoxData[FormBox[TagBox[RowBox[{RowBox[{RowBox[{"(", 
                        RowBox[{RowBox[{SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", \(g\^\(\[Nu]\[Sigma]\)\), 
                          " ", SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                          RowBox[{\(g\^\(\[Mu]\[Sigma]\)\), " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]]}], "-", 
                          RowBox[{SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          \(g\^\(\[Nu]\[Rho]\)\), " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", RowBox[{
                          \(g\^\(\[Mu]\[Rho]\)\), " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]]}]}], ")"}], " ", SuperscriptBox[
                       RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(m - 2\)]}], "+", 
                    \(\[LeftSkeleton] 8 \[RightSkeleton]\), "+", RowBox[
                     {RowBox[{"(", RowBox[{FormBox[
                          \(\[Sum]\+\(j = 0\)\%\(m - 4\) ""\), 
                          "TraditionalForm"], FormBox[\(""\ \((j + 1)\)\), 
                          "TraditionalForm"], FormBox[RowBox[{SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], \(\(-j\) + m - 4\)], 
                          " ", SuperscriptBox[RowBox[{"(", RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], ")"}]}], "-", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)]}], 
                          "TraditionalForm"]}], ")"}], " ", SuperscriptBox[
                       FormBox["\[CapitalDelta]", "TraditionalForm"], 
                       FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                        "\[CapitalDelta]", "TraditionalForm"], FormBox[
                        FormBox["\[Sigma]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                         {RowBox[{RowBox[{"-", SuperscriptBox[FormBox["r", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "+", RowBox[{
                          \(g\^\(\[Nu]\[Rho]\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "q", "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}]}], "-", RowBox[
                     {RowBox[{"(", RowBox[{FormBox[
                          \(\[Sum]\+\(j = 0\)\%\(m - 4\) ""\), 
                          "TraditionalForm"], FormBox[\(""\ \((j + 1)\)\), 
                          "TraditionalForm"], FormBox[RowBox[{SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], \(\(-j\) + m - 4\)], 
                          " ", SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                          {"-", RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}]}], "-", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{"-", RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}], ")"}]}], ")"}], "i"]}], 
                          "TraditionalForm"]}], ")"}], " ", SuperscriptBox[
                       FormBox["\[CapitalDelta]", "TraditionalForm"], 
                       FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                        "\[CapitalDelta]", "TraditionalForm"], FormBox[
                        FormBox["\[Rho]", "TraditionalForm"], 
                        "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                         {RowBox[{RowBox[{"-", SuperscriptBox[FormBox["s", 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          SuperscriptBox[FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox[FormBox["\[Sigma]", 
                          "TraditionalForm"], "TraditionalForm"]], " ", 
                          RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "+", RowBox[{
                          \(g\^\(\[Nu]\[Sigma]\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "q", "TraditionalForm"], FormBox[FormBox[
                          "\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Sigma]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox["q", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                          "TraditionalForm"]}]}]}], ")"}]}]}], 
                  Short[#1, 6] & ], TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]], 
           Cell["The setting Explicit \[Rule] All performs the sums.", 
            "Text", CellTags -> "Twist2GluonOperator"], Cell[BoxData[
             \(\(SetOptions[\(Twist2GluonOperator,\ 
                    \(Polarization\ \[Rule]\ 1\),\ \(Explicit \[Rule] All\)\)\
]\) ;\)], "Input", CellTags -> "Twist2GluonOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Short[\(\(Twist2GluonOperator[
                       \(\({p, \[Mu], a}\), \({q, \[Nu], b}\), 
                         \({r, \[Rho], c}\)\)]\), 5\)]\)], "Input", 
               CellTags -> "Twist2GluonOperator"], Cell[BoxData[
                FormBox[TagBox[RowBox[{\(g\_s\), " ", RowBox[{"(", RowBox[
                       {RowBox[{RowBox[{"-", SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"]}]]}], " ", SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], \(m - 2\)]}], "+", 
                        RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["q", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], \(m - 2\)]}], "-", 
                        RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], ")"}], \(m - 2\)]}], "-", 
                        RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Rho]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"], FormBox["r", 
                          "TraditionalForm"]}]], " ", RowBox[{"(", FormBox[
                          RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", 
                          \(\((\(\[LeftSkeleton] 1 \[RightSkeleton]\) + 
                                \(\[LeftSkeleton] 1 \[RightSkeleton]\))\)\^i\
\)}]}], "TraditionalForm"], ")"}], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"]]}], "+", 
                        \(\[LeftSkeleton] 15 \[RightSkeleton]\), "+", 
                        RowBox[{FractionBox["1", SuperscriptBox[RowBox[
                          {"(", RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "2"]], RowBox[
                          {"(", RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                          {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox["p", 
                          "TraditionalForm"]}]], " ", 
                          \(\[LeftSkeleton] 1 \[RightSkeleton]\), " ", 
                          RowBox[{"(", RowBox[{SuperscriptBox[RowBox[{"(", 
                          RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "m"], "+", RowBox[
                          {RowBox[{"(", FormBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", 
                          \(\((\[LeftSkeleton] 1 \[RightSkeleton])\)\^i\)}]}]\
, "TraditionalForm"], ")"}], " ", SuperscriptBox[FormBox[
                          \(\[LeftSkeleton] 1 \[RightSkeleton]\), 
                          "TraditionalForm"], "3"]}], "+", 
                          \(2\ \(\[LeftSkeleton] 2 \[RightSkeleton]\)\ 
                             \(\[LeftSkeleton] 1 \[RightSkeleton]\)\^2\), 
                          "+", RowBox[{RowBox[{"(", FormBox[RowBox[{
                          \(\[Sum]\+\(i = 0\)\%\(m - 3\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          ")"}], \(\(-i\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], 
                          "TraditionalForm"], ")"}], " ", SuperscriptBox[
                          FormBox[RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "TraditionalForm"], "2"], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]}], ")"}]}], ")"}]}], "-", 
                        FractionBox[RowBox[{SuperscriptBox["\[Epsilon]", 
                          RowBox[{FormBox[FormBox["\[Mu]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          FormBox["\[Nu]", "TraditionalForm"], 
                          "TraditionalForm"], FormBox[FormBox["\[Rho]", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]}]], " ", 
                          RowBox[{"(", RowBox[{RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], "m"]}], "+", RowBox[
                          {RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}], ")"}], "m"], " ", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], "m"], " ", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}]}], ")"}]}], RowBox[
                          {RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          " ", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}]}]]}], ")"}], " ", SubscriptBox[
                     "f", RowBox[{FormBox[FormBox["a", "TraditionalForm"], 
                        "TraditionalForm"], FormBox[FormBox["b", 
                         "TraditionalForm"], "TraditionalForm"], FormBox[
                        FormBox["c", "TraditionalForm"], 
                        "TraditionalForm"]}]]}], Short[#1, 5] & ], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2GluonOperator"]}, Open]]}, Open]], 
        Cell["Twist2QuarkOperator", "ObjectName", CellTags -> 
          "Twist2QuarkOperator"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "Twist2QuarkOperator"], Cell["Twist2QuarkOperator[p] or \
Twist2QuarkOperator[p,_,_] yields the quark-antiquark operator (p is momentum \
in the direction of the incoming quark). Twist2QuarkOperator[{p,q}] yields \
the 2-quark operator for non-zero momentum insertion (p is momentum in the \
direction of the incoming quark). Twist2QuarkOperator[{p1,___}, {p2,___}, \
{p3, mu, a}] or Twist2QuarkOperator[p1,_,_, p2,_,_, p3,mu,a] is the \
quark-antiquark-gluon operator, where p1 is the incoming quark, p2 the \
incoming antiquark and p3 denotes the incoming gluon momentum. \
Twist2QuarkOperator[{p1}, {p2}, {p3, mu, a}, {p4, nu, b}] or \
Twist2QuarkOperator[{p1,___}, {p2,___}, {p3, mu, a}, {p4, nu, b}] or \
Twist2QuarkOperator[p1,_,_, p2,_,_, p3,mu,a, p4, nu, b] gives the \
Quark-Quark-Gluon-Gluon-operator. The setting of the option Polarization \
(unpolarized: 0; polarized: 1) determines whether the unpolarized or \
polarized operator is returned", "Text", CellTags -> "Twist2QuarkOperator"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Twist2GluonOperator", 
                RuleDelayed[ButtonData, "Twist2GluonOperator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Twist2GluonOperator"]], "."}], "Text", 
            CellTags -> "Twist2QuarkOperator"]}, Open]], 
        Cell["Examples", "Subsubsection", CellTags -> "Twist2QuarkOperator"], 
        Cell[CellGroupData[{Cell["Polarized case, zero-momentum insertion", 
            "Subsubsection", CellTags -> "Twist2QuarkOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\(Twist2QuarkOperator, 
                     \(Polarization \[Rule] 1\), 
                     \(ZeroMomentumInsertion \[Rule] True\)\)]\)], "Input", 
               CellTags -> "Twist2QuarkOperator"], Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Explicit \[Rule] True\), 
                      \(Polarization \[Rule] 1\), 
                      \(ZeroMomentumInsertion \[Rule] True\)}\)\)], "Output", 
               CellTags -> "Twist2QuarkOperator"]}, Open]], 
           Cell["Quark-antiquark operator.", "Text", CellTags -> 
             "Twist2QuarkOperator"], Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(Twist2QuarkOperator[p]\)\)], "Input", CellTags -> 
                "Twist2QuarkOperator"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{"-", RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                          FormBox["\[CapitalDelta]", "TraditionalForm"]}], 
                         ")"}], ".", \(\[Gamma]\^5\)}]}], " ", SuperscriptBox[
                    RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                         "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                         "TraditionalForm"]}], ")"}], \(m - 1\)]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2QuarkOperator"]}, Open]], 
           Cell["Quark-antiquark-gluon operator.", "Text", 
            CellTags -> "Twist2QuarkOperator"], Cell[CellGroupData[
             {Cell[BoxData[
                \(t2 = \(Twist2QuarkOperator[
                     \(\({p}\), \({q}\), \({k, \[Mu], a}\)\)]\)\)], "Input", 
               CellTags -> "Twist2QuarkOperator"], Cell[BoxData[
                FormBox[RowBox[{\(-g\_s\), " ", RowBox[{RowBox[{"(", 
                       RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], ")"}], ".", \(\[Gamma]\^5\), 
                     ".", SubscriptBox["T", FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]]}], " ", 
                   RowBox[{"(", FormBox[TagBox[RowBox[{
                         \(\[Sum]\+\(i = 0\)\%\(m - 2\)\), RowBox[{
                          \(\((\(-1\))\)\^i\), " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], \(\(-i\) + m - 2\)], 
                          " ", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], "i"]}]}], HoldForm], "TraditionalForm"], 
                     ")"}], " ", SuperscriptBox[FormBox["\[CapitalDelta]", 
                     "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2QuarkOperator"]}, Open]], 
           Cell["Quark-antiquark-gluon-gluon operator.", "Text", 
            CellTags -> "Twist2QuarkOperator"], Cell[CellGroupData[
             {Cell[BoxData[
                \(t3 = \(Twist2QuarkOperator[
                     \(\({p}\), \({q}\), \({k, \[Mu], a}\), \({r, \[Nu], b}\)
                      \)]\)\)], "Input", CellTags -> "Twist2QuarkOperator"], 
              Cell[BoxData[FormBox[RowBox[{\(-g\_s\%2\), " ", RowBox[
                    {RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]}], ")"}], 
                     ".", \(\[Gamma]\^5\), ".", RowBox[{"(", RowBox[
                        {RowBox[{RowBox[{SubscriptBox["T", FormBox[FormBox[
                          "b", "TraditionalForm"], "TraditionalForm"]], ".", 
                          SubscriptBox["T", FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          RowBox[{"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 3\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((j + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{\(\((\(-1\))\)\^j\), " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], "i"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(\(-j\) + m - 3\)], " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)]}], 
                          "TraditionalForm"]}], ")"}]}], "-", RowBox[{
                          \(\((\(-1\))\)\^m\), " ", RowBox[{SubscriptBox["T", 
                          FormBox[FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]]}], " ", RowBox[{"(", RowBox[
                          {FormBox[
                          TagBox[\(\[Sum]\+\(j = 0\)\%\(m - 3\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((j + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{\(\((\(-1\))\)\^j\), " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], \(\(-j\) + m - 3\)], 
                          " ", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], "i"], " ", SuperscriptBox[RowBox[{"(", 
                          RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], \(j - i\)]}], 
                          "TraditionalForm"]}], ")"}]}]}], ")"}]}], " ", 
                   SuperscriptBox[FormBox["\[CapitalDelta]", 
                     "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SuperscriptBox[FormBox["\[CapitalDelta]", 
                     "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2QuarkOperator"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Unpolarized case, zero-momentum insertion", 
            "Subsubsection", CellTags -> "Twist2QuarkOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\(Twist2QuarkOperator,\ 
                     \(Polarization \[Rule] 0\), 
                     \(ZeroMomentumInsertion \[Rule] True\)\)]\)], "Input", 
               CellTags -> "Twist2QuarkOperator"], Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Explicit \[Rule] True\), 
                      \(Polarization \[Rule] 0\), 
                      \(ZeroMomentumInsertion \[Rule] True\)}\)\)], "Output", 
               CellTags -> "Twist2QuarkOperator"]}, Open]], 
           Cell["Quark-antiquark operator.", "Text", CellTags -> 
             "Twist2QuarkOperator"], Cell[CellGroupData[{Cell[BoxData[
                \(t4 = \(Twist2QuarkOperator[p]\)\)], "Input", CellTags -> 
                "Twist2QuarkOperator"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                     "\[CenterDot]", FormBox["\[CapitalDelta]", 
                      "TraditionalForm"]}], " ", SuperscriptBox[RowBox[
                     {"(", RowBox[{FormBox["\[CapitalDelta]", 
                         "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                         "TraditionalForm"]}], ")"}], \(m - 1\)]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2QuarkOperator"]}, Open]], 
           Cell["Quark-antiquark-gluon operator.", "Text", 
            CellTags -> "Twist2QuarkOperator"], Cell[CellGroupData[
             {Cell[BoxData[
                \(t5 = \(Twist2QuarkOperator[
                     \(\({p}\), \({q}\), \({k, \[Mu], a}\)\)]\)\)], "Input", 
               CellTags -> "Twist2QuarkOperator"], Cell[BoxData[
                FormBox[RowBox[{\(g\_s\), " ", RowBox[{RowBox[{"(", RowBox[
                        {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], ")"}], ".", SubscriptBox["T", 
                      FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"]]}], " ", RowBox[{"(", FormBox[
                      TagBox[RowBox[{\(\[Sum]\+\(i = 0\)\%\(m - 2\)\), 
                         RowBox[{\(\((\(-1\))\)\^i\), " ", SuperscriptBox[
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}], \(\(-i\) + m - 2\)], 
                          " ", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], "i"]}]}], HoldForm], "TraditionalForm"], 
                     ")"}], " ", SuperscriptBox[FormBox["\[CapitalDelta]", 
                     "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2QuarkOperator"]}, Open]], 
           Cell["Quark-antiquark-gluon-gluon operator.", "Text", 
            CellTags -> "Twist2QuarkOperator"], Cell[CellGroupData[
             {Cell[BoxData[
                \(t6 = \(Twist2QuarkOperator[
                     \(\({p}\), \({q}\), \({k, \[Mu], a}\), \({r, \[Nu], b}\)
                      \)]\)\)], "Input", CellTags -> "Twist2QuarkOperator"], 
              Cell[BoxData[FormBox[RowBox[{\(-\((\(-1\))\)\^m\), " ", 
                   \(g\_s\%2\), " ", RowBox[{RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                         FormBox["\[CapitalDelta]", "TraditionalForm"]}], 
                       ")"}], ".", RowBox[{"(", RowBox[{RowBox[{RowBox[
                          {SubscriptBox["T", FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SubscriptBox["T", FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          RowBox[{"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(i = 0\)\%\(m - 3\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((i + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}]}], ")"}], 
                          \(\(-i\) + m - 3\)], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], "j"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{FormBox[
                          FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], \(i - j\)]}], 
                          "TraditionalForm"]}], ")"}]}], "+", RowBox[
                          {RowBox[{SubscriptBox["T", FormBox[FormBox["b", 
                          "TraditionalForm"], "TraditionalForm"]], ".", 
                          SubscriptBox["T", FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          RowBox[{"(", RowBox[{FormBox[
                          TagBox[\(\[Sum]\+\(i = 0\)\%\(m - 3\) ""\), 
                            HoldForm], "TraditionalForm"], FormBox[
                          \(""\ \((i + 1)\)\), "TraditionalForm"], FormBox[
                          RowBox[{SuperscriptBox[RowBox[{"(", RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], ")"}]}], ")"}], 
                          \(\(-i\) + m - 3\)], " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], "j"], " ", 
                          SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], \(i - j\)]}], 
                          "TraditionalForm"]}], ")"}]}]}], ")"}]}], " ", 
                   SuperscriptBox[FormBox["\[CapitalDelta]", 
                     "TraditionalForm"], FormBox[FormBox["\[Mu]", 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SuperscriptBox[FormBox["\[CapitalDelta]", 
                     "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2QuarkOperator"]}, Open]], 
           Cell["This shows the FeynCalcExternal (FCE) form.", "Text", 
            CellTags -> "Twist2QuarkOperator"], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(\(Twist2QuarkOperator[p]\)//FCE\)//StandardForm\)], 
               "Input", CellTags -> "Twist2QuarkOperator"], Cell[BoxData[
                \(\(GSD[OPEDelta]\)\ \(SOD[p]\)\^\(\(-1\) + OPEm\)\)], 
               "Output", CellTags -> "Twist2QuarkOperator"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Twist2QuarkOperator[\(\({p}\), \({q}\), \({k, \[Mu], a}\), 
                     \(Explicit \[Rule] All\), \(Polarization \[Rule] 0\)\)]\
\)], "Input", CellTags -> "Twist2QuarkOperator"], Cell[BoxData[FormBox[
                 RowBox[{\(-g\_s\), " ", RowBox[{RowBox[{"(", RowBox[
                        {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], ")"}], ".", SubscriptBox["T", 
                      FormBox[FormBox["a", "TraditionalForm"], 
                       "TraditionalForm"]]}], " ", SuperscriptBox[FormBox[
                     "\[CapitalDelta]", "TraditionalForm"], FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], " ", RowBox[{"(", RowBox[
                      {FractionBox[SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(m - 1\)], RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]], "+", FractionBox[RowBox[{
                          \(\((\(-1\))\)\^m\), " ", SuperscriptBox[RowBox[
                          {"(", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], ")"}], \(m - 1\)]}], 
                        RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}]]}], ")"}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2QuarkOperator"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist2QuarkOperator[\(\({p}\), \({q}\), \({k, \[Mu], a}\), 
                     \({r, \[Nu], b}\), \(Explicit \[Rule] All\), 
                     \(Polarization \[Rule] 0\)\)]\)], "Input", CellTags -> 
                "Twist2QuarkOperator"], Cell[BoxData[FormBox[RowBox[{
                   \(-g\_s\%2\), " ", RowBox[{RowBox[{"(", RowBox[
                        {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], ")"}], ".", RowBox[{"(", 
                       RowBox[{RowBox[{RowBox[{SubscriptBox["T", FormBox[
                          FormBox["a", "TraditionalForm"], 
                          "TraditionalForm"]], ".", SubscriptBox["T", FormBox[
                          FormBox["b", "TraditionalForm"], 
                          "TraditionalForm"]]}], " ", RowBox[{"(", RowBox[
                          {FractionBox[RowBox[{FormBox[
                          \(\((\(-1\))\)\^\(m - 1\)\), "TraditionalForm"], 
                          " ", FormBox[SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(m - 1\)], "TraditionalForm"]}], RowBox[
                          {RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], " ", RowBox[{"(", 
                          RowBox[{RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}]}]], "-", FractionBox[
                          FormBox[SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(m - 1\)], "TraditionalForm"], RowBox[
                          {RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], " ", RowBox[{"(", RowBox[
                          {RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}]}]], "+", FractionBox[
                          FormBox[SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                          {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], \(m - 1\)], 
                          "TraditionalForm"], RowBox[{RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], " ", RowBox[{"(", RowBox[
                          {RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}]}]]}], ")"}]}], "+", 
                         RowBox[{RowBox[{SubscriptBox["T", FormBox[FormBox[
                          "b", "TraditionalForm"], "TraditionalForm"]], ".", 
                          SubscriptBox["T", FormBox[FormBox["a", 
                          "TraditionalForm"], "TraditionalForm"]]}], " ", 
                          RowBox[{"(", RowBox[{FractionBox[RowBox[{FormBox[
                          \(\((\(-1\))\)\^\(m - 1\)\), "TraditionalForm"], 
                          " ", FormBox[SuperscriptBox[RowBox[{"(", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          ")"}], \(m - 1\)], "TraditionalForm"]}], RowBox[
                          {RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], " ", RowBox[{"(", 
                          RowBox[{RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["p", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}]}]], "-", FractionBox[
                          FormBox[SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          ")"}], \(m - 1\)], "TraditionalForm"], RowBox[
                          {RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}]], "+", FractionBox[FormBox[
                          SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}], \(m - 1\)], 
                          "TraditionalForm"], RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", "TraditionalForm"]}], 
                          " ", RowBox[{"(", RowBox[{RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "+", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["r", 
                          "TraditionalForm"]}]}], ")"}]}]]}], ")"}]}]}], 
                       ")"}]}], " ", SuperscriptBox[FormBox[
                     "\[CapitalDelta]", "TraditionalForm"], FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                     "\[CapitalDelta]", "TraditionalForm"], FormBox[
                     FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"]], " ", FormBox[\(\((\(-1\))\)\^m\), 
                    "TraditionalForm"]}], TraditionalForm]], "Output", 
               CellTags -> "Twist2QuarkOperator"]}, Open]]}, Open]], 
        Cell[CellGroupData[
          {Cell["Polarized case, non-zero momentum insertion", 
            "Subsubsection", CellTags -> "Twist2QuarkOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\(Twist2QuarkOperator, 
                     \(Polarization \[Rule] 1\), 
                     \(ZeroMomentumInsertion \[Rule] False\)\)]\)], "Input", 
               CellTags -> "Twist2QuarkOperator"], Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Explicit \[Rule] True\), 
                      \(Polarization \[Rule] 1\), 
                      \(ZeroMomentumInsertion \[Rule] False\)}\)\)], 
               "Output", CellTags -> "Twist2QuarkOperator"]}, Open]], 
           Cell["With the setting ZeroMomentumInsertion \[Rule] False a \
non-zero momentum is assumed to flow into the operator vertex. ", "Text", 
            CellTags -> "Twist2QuarkOperator"], Cell["This is the Feynman \
rule associated with the quark-antiquark operator, where p is the momentum of \
the incoming quark and q the momentum of the antiquark. The momentum flowing \
into the operator vertex is thus -p-q.", "Text", CellTags -> 
             "Twist2QuarkOperator"], Cell[CellGroupData[{Cell[BoxData[
                \(t1 = \(Twist2QuarkOperator[\({p, q}\)]\)\)], "Input", 
               CellTags -> "Twist2QuarkOperator"], Cell[BoxData[
                FormBox[RowBox[{\(2\^\(1 - m\)\), " ", RowBox[{\(\[Gamma]\^5\)
                     , ".", RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]}], ")"}]}], 
                   " ", SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                         {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                        "-", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], \(m - 1\)]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2QuarkOperator"]}, Open]], 
           Cell["This is the quark-antiquark-gluon operator vertex.", "Text", 
            CellTags -> "Twist2QuarkOperator"], Cell[CellGroupData[
             {Cell[BoxData[
                \(t2 = \(Twist2QuarkOperator[
                     \(\({p}\), \({q}\), \({k, \[Mu], a}\)\)]\)\)], "Input", 
               CellTags -> "Twist2QuarkOperator"], Cell[BoxData[
                FormBox[RowBox[{\(2\^\(2 - m\)\), " ", \(g\_s\), " ", 
                   RowBox[{SubscriptBox["T", FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     \(\[Gamma]\^5\), ".", RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                         FormBox["\[CapitalDelta]", "TraditionalForm"]}], 
                       ")"}]}], " ", RowBox[{"(", FormBox[TagBox[RowBox[{
                         \(\[Sum]\+\(i = 0\)\%\(m - 2\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], ")"}]}], "+", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "-", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], \(\(-i\) + m - 2\)], 
                          " ", SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                          {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "-", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                      "TraditionalForm"], ")"}], " ", SuperscriptBox[
                    FormBox["\[CapitalDelta]", "TraditionalForm"], FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "Twist2QuarkOperator"]}, Open]], 
           Cell["This shows the FeynCalcExternal form.", "Text", 
            CellTags -> "Twist2QuarkOperator"], Cell[CellGroupData[
             {Cell[BoxData[\(StandardForm[\(FCE[t2]\)]\)], "Input", 
               CellTags -> "Twist2QuarkOperator"], Cell[BoxData[
                \(2\^\(2 - OPEm\)\ Gstrong\ 
                   \(\(SUNT[a]\) . \(GA[5]\) . \(GSD[OPEDelta]\)\)\ 
                   \(FVD[\(OPEDelta, \[Mu]\)]\)\ 
                   \(OPESum[\(\(\((\(-\(SOD[k]\)\) + \(SOD[p]\) - \(SOD[q]\))
                           \)\^\(\(-2\) - OPEi + OPEm\)\ 
                         \((\(SOD[k]\) + \(SOD[p]\) - \(SOD[q]\))\)\^OPEi\), 
                       \({OPEi, 0, \(\(-2\) + OPEm\)}\)\)]\)\)], "Output", 
               CellTags -> "Twist2QuarkOperator"]}, Open]]}, Open]], 
        Cell[CellGroupData[
          {Cell["Unpolarized case, non-zero momentum insertion", 
            "Subsubsection", CellTags -> "Twist2QuarkOperator"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(SetOptions[\(Twist2QuarkOperator, 
                     \(Polarization \[Rule] 1\), 
                     \(ZeroMomentumInsertion \[Rule] False\)\)]\)], "Input", 
               CellTags -> "Twist2QuarkOperator"], Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Explicit \[Rule] True\), 
                      \(Polarization \[Rule] 1\), 
                      \(ZeroMomentumInsertion \[Rule] False\)}\)\)], 
               "Output", CellTags -> "Twist2QuarkOperator"]}, Open]], 
           Cell["Quark-antiquark operator.", "Text", CellTags -> 
             "Twist2QuarkOperator"], Cell[CellGroupData[{Cell[BoxData[
                \(t4 = \(Twist2QuarkOperator[\({p, q}\)]\)\)], "Input", 
               CellTags -> "Twist2QuarkOperator"], Cell[BoxData[
                FormBox[RowBox[{\(2\^\(1 - m\)\), " ", RowBox[{\(\[Gamma]\^5\)
                     , ".", RowBox[{"(", RowBox[{FormBox["\"\[Gamma]\"", 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          "\[CapitalDelta]", "TraditionalForm"]}], ")"}]}], 
                   " ", SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                         {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                        "-", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], \(m - 1\)]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist2QuarkOperator"]}, Open]], 
           Cell["Quark-antiquark-gluon operator.", "Text", 
            CellTags -> "Twist2QuarkOperator"], Cell[CellGroupData[
             {Cell[BoxData[
                \(t5 = \(Twist2QuarkOperator[
                     \(\({p}\), \({q}\), \({k, \[Mu], a}\)\)]\)\)], "Input", 
               CellTags -> "Twist2QuarkOperator"], Cell[BoxData[
                FormBox[RowBox[{\(2\^\(2 - m\)\), " ", \(g\_s\), " ", 
                   RowBox[{SubscriptBox["T", FormBox[FormBox["a", 
                        "TraditionalForm"], "TraditionalForm"]], ".", 
                     \(\[Gamma]\^5\), ".", RowBox[{"(", RowBox[{FormBox[
                          "\"\[Gamma]\"", "TraditionalForm"], "\[CenterDot]", 
                         FormBox["\[CapitalDelta]", "TraditionalForm"]}], 
                       ")"}]}], " ", RowBox[{"(", FormBox[TagBox[RowBox[{
                         \(\[Sum]\+\(i = 0\)\%\(m - 2\)\), RowBox[
                          {SuperscriptBox[RowBox[{"(", RowBox[{RowBox[{"-", 
                          RowBox[{"(", RowBox[{FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], ")"}]}], "+", RowBox[
                          {FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "-", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], \(\(-i\) + m - 2\)], 
                          " ", SuperscriptBox[RowBox[{"(", RowBox[{RowBox[
                          {FormBox[FormBox[
                          TagBox[StyleBox["\"k\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], 
                          "TraditionalForm"], "TraditionalForm"], 
                          "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], "+", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                          "-", RowBox[{FormBox["\[CapitalDelta]", 
                          "TraditionalForm"], "\[CenterDot]", FormBox["q", 
                          "TraditionalForm"]}]}], ")"}], "i"]}]}], HoldForm], 
                      "TraditionalForm"], ")"}], " ", SuperscriptBox[
                    FormBox["\[CapitalDelta]", "TraditionalForm"], FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "Twist2QuarkOperator"]}, Open]], Cell[BoxData[
             \(\(Clear[\(t1, t2, t3, t4, t5, t6\)]\) ;\)], "Input", 
            CellTags -> "Twist2QuarkOperator"]}, Open]], 
        Cell["Twist3QuarkOperator", "ObjectName", CellTags -> 
          "Twist3QuarkOperator"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "Twist3QuarkOperator"], Cell["Twist3QuarkOperator[p] or  \
Twist3QuarkOperator[p,_,_]  yields the  2-quark operator (p is momentum in \
the direction of the fermion number flow). Twist3QuarkOperator[{p1,___}, \
{p2,___}, {p3, mu, a}] or Twist3QuarkOperator[p1,_,_,  p2,_,_,  p3,mu,a] \
Quark-Quark-Gluon-operator, where p1 is the incoming quark, p2 the incoming \
antiquark and p3 denotes the (incoming) gluon momentum.  \
Twist3QuarkOperator[{p1,___}, {p2,___}, {p3, mu, a}, {p4, nu, b}] or \
Twist3QuarkOperator[p1,_,_,  p2,_,_,  p3,mu,a, p4, nu, b]  gives the \
Quark-Quark-Gluon-Gluon-operator. The setting of the option Polarization \
(unpolarized: 0; polarized: 1) determines whether the uppolarized or \
polarized operator is returned.", "Text", CellTags -> "Twist3QuarkOperator"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[Twist3QuarkOperator]\)]
                , "Input", CellTags -> "Twist3QuarkOperator"], Cell[BoxData[
                \(TraditionalForm\`\({\(CouplingConstant \[Rule] g\_s\), 
                      \(Dimension \[Rule] D\), \(Polarization \[Rule] 1\)}\)\
\)], "Output", CellTags -> "Twist3QuarkOperator"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Twist2QuarkOperator", 
                RuleDelayed[ButtonData, "Twist2QuarkOperator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Twist2QuarkOperator"]], ", ", 
              ButtonBox["Twist2GluonOperator", 
                RuleDelayed[ButtonData, "Twist2GluonOperator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Twist2GluonOperator"]], "."}], "Text", 
            CellTags -> "Twist3QuarkOperator"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Twist3QuarkOperator"], Cell[CellGroupData[
             {Cell[BoxData[\(Twist3QuarkOperator[p]\)], "Input", CellTags -> 
                "Twist3QuarkOperator"], Cell[BoxData[FormBox[RowBox[{
                   \(\((\(-1\))\)\^m\), " ", RowBox[{RowBox[{"(", RowBox[
                        {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                         "\[CenterDot]", FormBox["\[CapitalDelta]", 
                          "TraditionalForm"]}], ")"}], ".", \(\[Gamma]\^5\)}]
                     , " ", SuperscriptBox[RowBox[{"(", RowBox[{FormBox[
                         "\[CapitalDelta]", "TraditionalForm"], 
                        "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                      ")"}], \(m - 1\)]}], TraditionalForm]], "Output", 
               CellTags -> "Twist3QuarkOperator"]}, Open]]}, Open]], 
        Cell["Twist4GluonOperator", "ObjectName", CellTags -> 
          "Twist4GluonOperator"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "Twist4GluonOperator"], Cell["Twist4GluonOperator[{oa, ob, oc, \
od}, {p1,la1,a1}, {p2,la2,a2}, {p3,la3,a3}, {p4,la4,a4}].", "Text", 
            CellTags -> "Twist4GluonOperator"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Twist2QuarkOperator", 
                RuleDelayed[ButtonData, "Twist2QuarkOperator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Twist2QuarkOperator"]], ", ", 
              ButtonBox["Twist3QuarkOperator", 
                RuleDelayed[ButtonData, "Twist3QuarkOperator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Twist3QuarkOperator"]], ", ", 
              ButtonBox["Twist2GluonOperator", 
                RuleDelayed[ButtonData, "Twist2GluonOperator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Twist2GluonOperator"]], "."}], "Text", 
            CellTags -> "Twist4GluonOperator"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Twist4GluonOperator"], Cell[CellGroupData[
             {Cell[BoxData[
                \(Twist4GluonOperator[\(\({oa,\ ob,\ oc,\ od}\), 
                     \({p1, la1, a1}\), \({p2, la2, a2}\), \({p3, la3, a3}\),
                      \({p4, la4, a4}\)\)]\)], "Input", CellTags -> 
                "Twist4GluonOperator"], Cell[BoxData[FormBox[RowBox[
                  {RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la2\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la3la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["od", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oc", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["ob", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oa", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la2\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la3la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oc", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["od", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["ob", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oa", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["od", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["ob", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oc", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oa", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["ob", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["od", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oc", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oa", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oc", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["ob", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["od", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oa", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["ob", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oc", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["od", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oa", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la2\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la3la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["od", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oc", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oa", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["ob", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la2\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la3la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oc", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["od", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oa", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["ob", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["od", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oa", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oc", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["ob", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oa", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["od", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oc", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["ob", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oc", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oa", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["od", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["ob", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oa", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oc", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["od", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["ob", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["od", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["ob", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oa", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oc", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["ob", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["od", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oa", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oc", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["od", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oa", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["ob", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oc", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oa", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["od", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["ob", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oc", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la2\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la3la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["ob", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oa", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["od", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oc", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la2\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la3la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oa", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["ob", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["od", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oc", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oc", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["ob", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oa", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["od", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["ob", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oc", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oa", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["od", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oc", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oa", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["ob", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["od", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la3\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la2la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oa", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oc", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["ob", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["od", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la2\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la3la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["ob", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["oa", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oc", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["od", 
                          "TraditionalForm"], "TraditionalForm"]}]]}], "+", 
                   RowBox[{RowBox[{"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "2", FormBox[
                          FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la1la2\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "1", FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la1", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la2", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_1\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_2\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", RowBox[
                      {"(", RowBox[{RowBox[{SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "4", FormBox[
                          FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "-", RowBox[{
                          \(g\^\(la3la4\)\), " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"]}]}], "+", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SubsuperscriptBox[
                          TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]], "3", FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], 
                          "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}], "-", RowBox[{SuperscriptBox[
                          FormBox["\[CapitalDelta]", "TraditionalForm"], 
                          FormBox[FormBox["la3", "TraditionalForm"], 
                          "TraditionalForm"]], " ", SuperscriptBox[FormBox[
                          "\[CapitalDelta]", "TraditionalForm"], FormBox[
                          FormBox["la4", "TraditionalForm"], 
                          "TraditionalForm"]], " ", RowBox[{FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_3\), 
                          "TraditionalForm"], "\[CenterDot]", FormBox[
                          \(\(\*TagBox[StyleBox["\"p\"", 
                                 Rule[FontSlant, "Italic"]], 
                                Function[StyleForm[Slot[1], 
                                  Rule[FontSlant, "Italic"]]]]\)\_4\), 
                          "TraditionalForm"]}]}]}], ")"}], " ", SubscriptBox[
                      "\[Delta]", RowBox[{FormBox[FormBox["a1", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oa", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a2", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["ob", 
                          "TraditionalForm"], "TraditionalForm"]}]], " ", 
                     SubscriptBox["\[Delta]", RowBox[{FormBox[FormBox["a3", 
                          "TraditionalForm"], "TraditionalForm"], FormBox[
                         FormBox["oc", "TraditionalForm"], 
                         "TraditionalForm"]}]], " ", SubscriptBox["\[Delta]", 
                      RowBox[{FormBox[FormBox["a4", "TraditionalForm"], 
                         "TraditionalForm"], FormBox[FormBox["od", 
                          "TraditionalForm"], "TraditionalForm"]}]]}]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "Twist4GluonOperator"]}, Open]]}, Open]], 
        Cell["TwoLoopSimplify  ***unfinished*** (examples missing)", 
         "ObjectName", CellTags -> "TwoLoopSimplify"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "TwoLoopSimplify"], Cell["TwoLoopSimplify[amplitude,{\
qu1,qu2}] simplifies the 2-loop amplitude (qu1 and qu2 denote the integration \
momenta). TwoLoopSimplify[amplitude] transforms to TwoLoopSimplify[amplitude, \
{Global`q1, Global`q2}], i.e., the integration momenta in amplitude must be \
named q1 and q2.", "Text", CellTags -> "TwoLoopSimplify"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["OneLoopSimplify", 
                RuleDelayed[ButtonData, "OneLoopSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSimplify"]], "."}], "Text", 
            CellTags -> "TwoLoopSimplify"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "TwoLoopSimplify"], Cell[BoxData[""], "Input", 
            CellTags -> "TwoLoopSimplify"]}, Open]], Cell["Uncontract", 
         "ObjectName", CellTags -> "Uncontract"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Uncontract"], Cell["Uncontract[exp, q1, q2, ...] \
uncontracts Eps and DiracGamma. Uncontract[exp, q1, q2, Pair \[Rule] {p}] \
uncontracts also p.q1 and p.q2; the option Pair \[Rule] All uncontracts all \
momenta except OPEDelta.", "Text", CellTags -> "Uncontract"], 
           Cell[CellGroupData[{Cell[BoxData[\(Options[Uncontract]\)], 
               "Input", CellTags -> "Uncontract"], Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] Automatic\), 
                      \(DimensionalReduction \[Rule] False\), 
                      \(Pair \[Rule] \({}\)\), \(Unique \[Rule] True\)}\)\)], 
               "Output", CellTags -> "Uncontract"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], "."}], "Text", 
            CellTags -> "Uncontract"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Uncontract"], Cell[CellGroupData[{Cell[BoxData[
                \(t1\ =\ \(\(LeviCivita[\(\[Mu], \[Nu]\)]\)[\(p, q\)]\)\)], 
               "Input", CellTags -> "Uncontract"], Cell[BoxData[
                FormBox[SuperscriptBox["\[Epsilon]", RowBox[{FormBox[
                     FormBox["\[Mu]", "TraditionalForm"], "TraditionalForm"], 
                    FormBox[FormBox["\[Nu]", "TraditionalForm"], 
                     "TraditionalForm"], FormBox["p", "TraditionalForm"], 
                    FormBox["q", "TraditionalForm"]}]], TraditionalForm]], 
               "Output", CellTags -> "Uncontract"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(Uncontract[\(t1,\ p\)]\)], 
               "Input", CellTags -> "Uncontract"], Cell[BoxData[
                FormBox[RowBox[{SuperscriptBox["\[Epsilon]", RowBox[
                     {FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox["\[Nu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox[\($AL$7531 \[InvisibleApplication] \((1)\)\), 
                        "TraditionalForm"], "TraditionalForm"], FormBox["q", 
                       "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                     "p", "TraditionalForm"], FormBox[FormBox[
                      \($AL$7531 \[InvisibleApplication] \((1)\)\), 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "Uncontract"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(t2 = \(DiracSlash[p]\)\)], "Input", CellTags -> 
                "Uncontract"], Cell[BoxData[FormBox[RowBox[
                  {FormBox["\"\[Gamma]\"", "TraditionalForm"], 
                   "\[CenterDot]", FormBox["p", "TraditionalForm"]}], 
                 TraditionalForm]], "Output", CellTags -> "Uncontract"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Uncontract[\(t2,\ p\)]\)], "Input", CellTags -> 
                "Uncontract"], Cell[BoxData[FormBox[RowBox[{SuperscriptBox[
                    "\[Gamma]", FormBox[FormBox[
                      \($AL$7532 \[InvisibleApplication] \((1)\)\), 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SuperscriptBox[FormBox["p", "TraditionalForm"], FormBox[
                     FormBox[\($AL$7532 \[InvisibleApplication] \((1)\)\), 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "Uncontract"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Uncontract[\(t1,\ p, q\)]\)], "Input", CellTags -> 
                "Uncontract"], Cell[BoxData[FormBox[RowBox[{SuperscriptBox[
                    "\[Epsilon]", RowBox[{FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox["\[Nu]", "TraditionalForm"], 
                       "TraditionalForm"], FormBox[FormBox[
                        \($AL$7534 \[InvisibleApplication] \((1)\)\), 
                        "TraditionalForm"], "TraditionalForm"], FormBox[
                       FormBox[\($AL$7533 \[InvisibleApplication] \((1)\)\), 
                        "TraditionalForm"], "TraditionalForm"]}]], " ", 
                   SuperscriptBox[FormBox["q", "TraditionalForm"], FormBox[
                     FormBox[\($AL$7533 \[InvisibleApplication] \((1)\)\), 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SuperscriptBox[FormBox["p", "TraditionalForm"], FormBox[
                     FormBox[\($AL$7534 \[InvisibleApplication] \((1)\)\), 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "Uncontract"]}, 
             Open]], Cell["By default scalar products are not uncontracted.", 
            "Text", CellTags -> "Uncontract"], Cell[CellGroupData[
             {Cell[BoxData[\(Uncontract[\(\(ScalarProduct[\(p, q\)]\),\ q\)]\)
                ], "Input", CellTags -> "Uncontract"], Cell[BoxData[
                FormBox[RowBox[{FormBox["p", "TraditionalForm"], 
                   "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                 TraditionalForm]], "Output", CellTags -> "Uncontract"]}, 
             Open]], Cell["With the option Pair\[Rule]All they are \
\[OpenCurlyDoubleQuote]uncontracted \[CloseCurlyDoubleQuote].", "Text", 
            CellTags -> "Uncontract"], Cell[CellGroupData[{Cell[BoxData[
                \(Uncontract[\(\(ScalarProduct[\(p, q\)]\), q, 
                     \(Pair \[Rule] All\)\)]\)], "Input", CellTags -> 
                "Uncontract"], Cell[BoxData[FormBox[RowBox[{SuperscriptBox[
                    FormBox["p", "TraditionalForm"], FormBox[FormBox[
                      \($AL$7536 \[InvisibleApplication] \((1)\)\), 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SuperscriptBox[FormBox["q", "TraditionalForm"], FormBox[
                     FormBox[\($AL$7536 \[InvisibleApplication] \((1)\)\), 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "Uncontract"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \(Uncontract[\(\(\(ScalarProduct[\(p, q\)]\)^2\), q, 
                     \(Pair \[Rule] All\)\)]\)], "Input", CellTags -> 
                "Uncontract"], Cell[BoxData[FormBox[RowBox[{SuperscriptBox[
                    FormBox["p", "TraditionalForm"], FormBox[FormBox[
                      \($AL$7537 \[InvisibleApplication] \((1)\)\), 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SuperscriptBox[FormBox["q", "TraditionalForm"], FormBox[
                     FormBox[\($AL$7537 \[InvisibleApplication] \((1)\)\), 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SuperscriptBox[FormBox["p", "TraditionalForm"], FormBox[
                     FormBox[\($AL$7537 \[InvisibleApplication] \((2)\)\), 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SuperscriptBox[FormBox["q", "TraditionalForm"], FormBox[
                     FormBox[\($AL$7537 \[InvisibleApplication] \((2)\)\), 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "Uncontract"]}, 
             Open]], Cell[BoxData[\(Clear[\(t1, t2\)]\)], "Input", 
            CellTags -> "Uncontract"]}, Open]], 
        Cell["UnDeclareNonCommutative", "ObjectName", 
         CellTags -> "UnDeclareNonCommutative"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "UnDeclareNonCommutative"], Cell["UnDeclareNonCommuta\
tive[a, b, ...] undeclares a,b, ... to be noncommutative, i.e., DataType[a,b, \
..., NonCommutative] is set to False.", "Text", CellTags -> 
             "UnDeclareNonCommutative"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["DataType", RuleDelayed[ButtonData, "DataType"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DataType"]], ", ", 
              ButtonBox["DeclareNonCommutative", 
                RuleDelayed[ButtonData, "DeclareNonCommutative"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DeclareNonCommutative"]], "."}], "Text", 
            CellTags -> "UnDeclareNonCommutative"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "UnDeclareNonCommutative"], Cell[BoxData[
             \(DeclareNonCommutative[x]\)], "Input", CellTags -> 
             "UnDeclareNonCommutative"], Cell["As a side-effect of \
DeclareNonCommutative x is declared to be of DataType NonCommutative.", 
            "Text", CellTags -> "UnDeclareNonCommutative"], 
           Cell[CellGroupData[{Cell["DataType[x,NonCommutative]", "Input", 
               CellTags -> "UnDeclareNonCommutative"], Cell[BoxData[
                \(TraditionalForm\`True\)], "Output", CellTags -> 
                "UnDeclareNonCommutative"]}, Open]], 
           Cell["The inverse operation is UnDeclareNonCommutative.", "Text", 
            CellTags -> "UnDeclareNonCommutative"], Cell[BoxData[
             \(UnDeclareNonCommutative[x]\)], "Input", CellTags -> 
             "UnDeclareNonCommutative"], Cell[CellGroupData[{Cell[BoxData[
                \(DataType[\(x, NonCommutative\)]\)], "Input", CellTags -> 
                "UnDeclareNonCommutative"], Cell[BoxData[
                \(TraditionalForm\`True\)], "Output", CellTags -> 
                "UnDeclareNonCommutative"]}, Open]], Cell[BoxData[
             \(DeclareNonCommutative[\(y, z\)]\)], "Input", 
            CellTags -> "UnDeclareNonCommutative"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DataType[\(y, z, NonCommutative\)]\)], "Input", CellTags -> 
                "UnDeclareNonCommutative"], Cell[BoxData[
                \(TraditionalForm\`\({True, True}\)\)], "Output", CellTags -> 
                "UnDeclareNonCommutative"]}, Open]], Cell[BoxData[
             \(UnDeclareNonCommutative[\(y, z\)]\)], "Input", 
            CellTags -> "UnDeclareNonCommutative"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(DataType[\(y, z, NonCommutative\)]\)], "Input", CellTags -> 
                "UnDeclareNonCommutative"], Cell[BoxData[
                \(TraditionalForm\`\({True, True}\)\)], "Output", CellTags -> 
                "UnDeclareNonCommutative"]}, Open]]}, Open]], 
        Cell["Upper", "ObjectName", CellTags -> "Upper"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Upper"], Cell["Upper may be used inside LorentzIndex \
to indicate an contravariant LorentzIndex.", "Text", CellTags -> "Upper"], 
           Cell[TextData[{"See also:  ", 
              ButtonBox["LorentzIndex", 
                RuleDelayed[ButtonData, "LorentzIndex"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "LorentzIndex"]], ", ", 
              ButtonBox["Lower", RuleDelayed[ButtonData, "Lower"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Lower"]], 
              ", ", 
              ButtonBox["Contract1", RuleDelayed[ButtonData, "Contract1"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract1"]], "."}], "Text", 
            CellTags -> "Upper"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["UVPart  ***unfinished*** (examples missing)", "ObjectName", 
         CellTags -> "UVPart"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "UVPart"], 
           Cell["UVPart[exp, q] discards ultraviolet finite integrals  (q = \
integration momentum).", "Text", CellTags -> "UVPart"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "UVPart"], Cell[BoxData[""], "Input", 
            CellTags -> "UVPart"]}, Open]], Cell["Vectors", "ObjectName", 
         CellTags -> "Vectors"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Vectors"], 
           Cell["Vectors is an option for FORM2FeynCalc. Its default setting \
is Automatic. It may be set to a list, if the FORM-file does not contain a \
V(ectors) statement.", "Text", CellTags -> "Vectors"], 
           Cell[TextData[{"See also:  ", 
              ButtonBox["FORM2FeynCalc", 
                RuleDelayed[ButtonData, "FORM2FeynCalc"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FORM2FeynCalc"]], "."}], "Text", 
            CellTags -> "Vectors"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["WriteOut", "ObjectName", CellTags -> "WriteOut"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "WriteOut"], Cell["WriteOut is an option for OneLoop. \
 If set to True, the result of OneLoop will be written to a file called \
\"name.res\", where name is the first argument of OneLoop.", "Text", 
            CellTags -> "WriteOut"], Cell[TextData[{"See also:  ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, "."}], "Text", CellTags -> "WriteOut"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["WriteOutPaVe", "ObjectName", 
         CellTags -> "WriteOutPaVe"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "WriteOutPaVe"], 
           Cell["WriteOutPaVe is an option for PaVeReduce and OneLoopSum. If \
set to a string, the results of all Passarino-Veltman PaVe's are stored in \
files with names generated from this string and the arguments of PaVe.", 
            "Text", CellTags -> "WriteOutPaVe"], 
           Cell[TextData[{"See also:  ", 
              ButtonBox["PaVeReduce", RuleDelayed[ButtonData, "PaVeReduce"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeReduce"]], ", ", 
              ButtonBox["PaVe", RuleDelayed[ButtonData, "PaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "PaVe"]], 
              ", ", 
              ButtonBox["OneLoopSum", RuleDelayed[ButtonData, "OneLoopSum"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OneLoopSum"]], "."}], "Text", 
            CellTags -> "WriteOutPaVe"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["Write2", "ObjectName", CellTags -> "Write2"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "Write2"], Cell["Write2[file, val1 = expr1, val2 = \
expr2, ...] writes the settings val1 = expr1, val2 = expr2 in sequence \
followed by a newline, to the specified output file. Setting the option \
FormatType of Write2 to FortranForm results in FORTRAN syntax output.", 
            "Text", CellTags -> "Write2"], Cell["The continuation character \
for FORTRAN output can be controlled by changing \
$FortranContinuationCharacter.", "Text", CellTags -> "Write2"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(FullForm[$FortranContinuationCharacter]\)], "Input", 
               CellTags -> "Write2"], Cell[BoxData[
                \(TraditionalForm\`\(\*TagBox[StyleBox["\"&\"", 
                       Rule[ShowSpecialCharacters, False], 
                       Rule[ShowStringCharacters, True], 
                       Rule[NumberMarks, True]], FullForm]\)\)], "Output", 
               CellTags -> "Write2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Options[Write2]\)], "Input", CellTags -> 
                "Write2"], Cell[BoxData[
                \(TraditionalForm\`\({\(D0Convention \[Rule] 0\), 
                      \(FinalSubstitutions \[Rule] \({}\)\), 
                      \(FormatType \[Rule] InputForm\), 
                      \(FortranFormatDoublePrecision \[Rule] True\), 
                      \(PageWidth \[Rule] 62\), 
                      \(PostFortranFile \[Rule] ""\), 
                      \(PreFortranFile \[Rule] ""\), 
                      \(StringReplace \[Rule] \({}\)\)}\)\)], "Output", 
               CellTags -> "Write2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(Attributes[Write2]\)], "Input", CellTags -> 
                "Write2"], Cell[BoxData[\(TraditionalForm\`\({HoldRest}\)\)], 
               "Output", CellTags -> "Write2"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Isolate", RuleDelayed[ButtonData, "Isolate"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Isolate"]]\
, ", ", 
              ButtonBox["PaVeReduce", RuleDelayed[ButtonData, "PaVeReduce"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeReduce"]], "."}], "Text", 
            CellTags -> "Write2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Write2"], Cell[CellGroupData[{Cell[BoxData[
                \(t = \(Collect[\(\((\((a - c)\)\^2 + \((a - b)\)\^2)\)\^
                        2, a, Factor\)]\)\)], "Input", CellTags -> "Write2"], 
              Cell[BoxData[
                \(TraditionalForm\`\(\(4\ a\^4\) - \(8\ \((b + c)\)\ a\^3\) +
                      \(8\ \((b\^2 + \(c\ b\) + c\^2)\)\ a\^2\) - 
                     \(4\ \((b + c)\)\ \((b\^2 + c\^2)\)\ a\) + 
                     \((b\^2 + c\^2)\)\^2\)\)], "Output", CellTags -> 
                "Write2"]}, Open]], Cell[BoxData[
             \(\(tempfilename = \(\(ToString[$SessionID]\) <> ".s"\)\) ;\)], 
            "Input", CellTags -> "Write2"], 
           Cell["This writes the assignment r=t to a file.", "Text", 
            CellTags -> "Write2"], Cell[BoxData[
             \(\(Write2[\(tempfilename, \(r = t\)\)]\) ;\)], "Input", 
            CellTags -> "Write2"], Cell[
            "This shows the contents of the file.", "Text", 
            CellTags -> "Write2"], Cell[CellGroupData[{Cell[BoxData[
                \(TableForm[\(ReadList[\(
                      \(\(If[\(\($OperatingSystem === "MacOS"\), ":", ""\)]\)
                          <> tempfilename\), String\)]\)]\)], "Input", 
               CellTags -> "Write2"], Cell[BoxData[
                \(TraditionalForm\`\(\*InterpretationBox[GridBox[
                       {{"\"r = ( 4*a^4 - 8*a^3*(b + c) - 4*a*(b + \
c)*(b^2 + c^2) + \
\""}, 
                        {"\" (b^2 + c^2)^2 + 8*a^2*(b^2 + b*c + c^2)\""}, 
                        {"\"       );\""}}, RowSpacings -> 1., 
                       ColumnSpacings -> 3., RowAlignments -> Baseline, 
                       ColumnAlignments -> {Left}], 
                      TableForm[List["r = ( 4*a^4 - 8*a^3*(b + c) - 4*a*(b + \
c)*(b^2 + c^2) + ", " (b^2 + c^2)^2 + 8*a^2*(b^2 + b*c + \
c^2)", "       );"]]]\)\)], "Output", CellTags -> "Write2"]}, Open]], 
           Cell[BoxData[
             \(DeleteFile[\(\(If[\(\($OperatingSystem === "MacOS"\), ":", ""
                     \)]\) <> tempfilename\)]\)], "Input", 
            CellTags -> "Write2"], Cell[CellGroupData[{Cell[BoxData[
                \(t2 = \(x + \(Isolate[\(t, a, \(IsolateNames \[Rule] w\)\)]
                      \)\)\)], "Input", CellTags -> "Write2"], Cell[BoxData[
                \(TraditionalForm\`\(\(4\ a\^4\) - 
                     \(8\ \*TagBox[\(w(3)\), HoldForm]\ a\^3\) + 
                     \(8\ \*TagBox[\(w(5)\), HoldForm]\ a\^2\) - 
                     \(4\ \*TagBox[\(w(3)\), HoldForm]\ 
                       \*TagBox[\(w(4)\), HoldForm]\ a\) + 
                     \*TagBox[\(w(4)\), HoldForm]\^2 + x\)\)], "Output", 
               CellTags -> "Write2"]}, Open]], Cell[BoxData[
             \(\(Write2[\(tempfilename, \(r = t2\)\)]\) ;\)], "Input", 
            CellTags -> "Write2"], Cell[CellGroupData[{Cell[BoxData[
                \(TableForm[\(ReadList[\(
                      \(\(If[\(\($OperatingSystem === "MacOS"\), ":", ""\)]\)
                          <> tempfilename\), String\)]\)]\)], "Input", 
               CellTags -> "Write2"], Cell[BoxData[
                \(TraditionalForm\`\(\*InterpretationBox[GridBox[
                       {{"\"w[3] = (b + c\""}, {"\"       );\""}, 
                        {"\"w[4] = (b^2 + c^2\""}, {"\"       );\""}, 
                        {"\"w[5] = (b^2 + b*c + c^2\""}, 
                        {"\"       );\""}, 
                        {"\"r = ( 4*a^4 + x - 8*a^3*HoldForm[w[3]] - \

                          4*a*HoldForm[w[3]]*\""}, 
                        {"\"  HoldForm[w[4]] + HoldForm[w[4]]^2 + \

                          8*a^2*HoldForm[w[5]]\""}, {"\"       );\""}}, 
                       RowSpacings -> 1., ColumnSpacings -> 3., 
                       RowAlignments -> Baseline, 
                       ColumnAlignments -> {Left}], 
                      TableForm[List["w[3] = (b + c", "       );", 
                        "w[4] = (b^2 + c^2", "       );", 
                        "w[5] = (b^2 + b*c + c^2", "       );", 
                        "r = ( 4*a^4 + x - 8*a^3*HoldForm[w[3]] - \
4*a*HoldForm[w[3]]*", "  HoldForm[w[4]] + HoldForm[w[4]]^2 + \
8*a^2*HoldForm[w[5]]", "       );"]]]\)\)], "Output", CellTags -> "Write2"]}, 
             Open]], Cell[BoxData[
             \(DeleteFile[\(\(If[\(\($OperatingSystem === "MacOS"\), ":", ""
                     \)]\) <> tempfilename\)]\)], "Input", 
            CellTags -> "Write2"], Cell[
            "This is how to write out the expression t2 in Fortran format.", 
            "Text", CellTags -> "Write2"], Cell[BoxData[
             \(\(Write2[\(tempfilename, \(r = t2\), 
                    \(FormatType \[Rule] FortranForm\)\)]\) ;\)], "Input", 
            CellTags -> "Write2"], Cell[CellGroupData[{Cell[BoxData[
                \(TableForm[\(ReadList[\(
                      \(\(If[\(\($OperatingSystem === "MacOS"\), ":", ""\)]\)
                          <> tempfilename\), String\)]\)]\)], "Input", 
               CellTags -> "Write2"], Cell[BoxData[
                \(TraditionalForm\`\(\*InterpretationBox[GridBox[
                       {{"\"        w(3D0)= w(3D0)\""}, 
                        {"\"        w(4D0)= w(4D0)\""}, 
                        {"\"        w(5D0)= w(5D0)\""}, 
                        {"\"        r = 4D0*a**4 + x - 8D0*a**3*w(3D0) - \
\""}, {"\"     &  4D0*a*w(3D0)*w(4D0) + w(4D0)**2 + \

                          8D0*a**2*w(5D0)\""}, {"\"                  \""}}, 
                       RowSpacings -> 1., ColumnSpacings -> 3., 
                       RowAlignments -> Baseline, 
                       ColumnAlignments -> {Left}], 
                      TableForm[List["        w(3D0)= w(3D0)", 
                        "        w(4D0)= w(4D0)", "        w(5D0)= w(5D0)", 
                        "        r = 4D0*a**4 + x - 8D0*a**3*w(3D0) - ", 
                        "     &  4D0*a*w(3D0)*w(4D0) + w(4D0)**2 + \
8D0*a**2*w(5D0)", "                  "]]]\)\)], "Output", CellTags -> 
                "Write2"]}, Open]], Cell[BoxData[
             \(\(DeleteFile[\(\(If[\(\($OperatingSystem === "MacOS"
                         \), ":", ""\)]\) <> tempfilename\)]\) ; 
                \(Clear[\(w, t, t2, r, tempfilename\)]\) ;\)], "Input", 
            CellTags -> "Write2"]}, Open]], Cell["XYT", "ObjectName", 
         CellTags -> "XYT"], Cell[CellGroupData[{Cell["Description", 
            "Subsubsection", CellTags -> "XYT"], 
           Cell[TextData[{"XYT[exp, x,y] transforms  ", Cell[BoxData[
                \(TraditionalForm\`\(\((x\ y)\)\^m\)\)]], " away ..."}], 
            "Text", CellTags -> "XYT"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["ZeroMomentumInsertion", "ObjectName", CellTags -> 
          "ZeroMomentumInsertion"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "ZeroMomentumInsertion"], Cell["ZeroMomentumInsertion is an \
option of FeynRule, Twist2GluonOperator and Twist2QuarkOperator.", "Text", 
            CellTags -> "ZeroMomentumInsertion"], 
           Cell[TextData[{"See also:  ", 
              ButtonBox["FeynRule", RuleDelayed[ButtonData, "FeynRule"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynRule"]], ", ", 
              ButtonBox["Twist2GluonOperator", 
                RuleDelayed[ButtonData, "Twist2GluonOperator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Twist2GluonOperator"]], ", ", 
              ButtonBox["Twist2QuarkOperator", 
                RuleDelayed[ButtonData, "Twist2QuarkOperator"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Twist2QuarkOperator"]], "."}], "Text", 
            CellTags -> "ZeroMomentumInsertion"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["Zeta2", "ObjectName", 
         CellTags -> "Zeta2"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "Zeta2"], 
           Cell["Zeta2 denotes Zeta[2]. N[Zeta[2]] evaluates to N[Zeta[2]].", 
            "Text", CellTags -> "Zeta2"], Cell[TextData[{"See also: ", 
              ButtonBox["SimplifyPolyLog", 
                RuleDelayed[ButtonData, "SimplifyPolyLog"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "SimplifyPolyLog"]], "."}], "Text", 
            CellTags -> "Zeta2"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "Zeta2"], Cell[CellGroupData[{Cell[BoxData["Zeta2"], 
               "Input", CellTags -> "Zeta2"], Cell[BoxData[
                \(TraditionalForm\`\(\[Zeta](2)\)\)], "Output", CellTags -> 
                "Zeta2"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(N[Zeta2]\)], "Input", CellTags -> "Zeta2"], Cell[BoxData[
                \(TraditionalForm\`1.6449340668482262`\)], "Output", 
               CellTags -> "Zeta2"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(SimplifyPolyLog[\(Pi^2\)]\)], "Input", 
               CellTags -> "Zeta2"], Cell[BoxData[
                \(TraditionalForm\`\(6\ \(\[Zeta](2)\)\)\)], "Output", 
               CellTags -> "Zeta2"]}, Open]]}, Open]], Cell["$Abbreviations", 
         "ObjectName", CellTags -> "$Abbreviations"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "$Abbreviations"], Cell["$Abbreviations are a list of \
string substitution rules used when generating names for storing intermediate \
results. It is used by OneLoop and PaVeReduce.The elements of the list should \
be of the form \"name\" \[Rule] \"abbreviation\".", "Text", 
            CellTags -> "$Abbreviations"], Cell[CellGroupData[{Cell[BoxData[
                \($Abbreviations//StandardForm\)], "Input", CellTags -> 
                "$Abbreviations"], Cell[BoxData[
                \({\("^" \[Rule] ""\), \("*" \[Rule] ""\), \("{" \[Rule] ""\)
                    , \("[" \[Rule] ""\), \("}" \[Rule] ""\), 
                    \("]" \[Rule] ""\), \("/" \[Rule] ""\), 
                    \("\n" \[Rule] ""\), \("\r" \[Rule] ""\), 
                    \(" " \[Rule] ""\), \(", " \[Rule] ""\), 
                    \("AxialVector" \[Rule] "AV"\), \("Fermion" \[Rule] "F"\)
                    , \("Momentum" \[Rule] ""\), \("Pair" \[Rule] ""\), 
                    \("ParticleMass" \[Rule] "m"\), 
                    \("PseudoScalar" \[Rule] "PS"\), 
                    \("RenormalizationState" \[Rule] ""\), 
                    \("Scalar" \[Rule] "S"\), 
                    \("SmallVariable" \[Rule] "sma"\), 
                    \("Subscript" \[Rule] "su"\), \("Vector" \[Rule] "V"\)}\)]\
, "Output", CellTags -> "$Abbreviations"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Abbreviation", 
                RuleDelayed[ButtonData, "Abbreviation"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Abbreviation"]], ", ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, ", ", 
              ButtonBox["PaVeReduce", RuleDelayed[ButtonData, "PaVeReduce"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeReduce"]], ", ", 
              ButtonBox["WriteOut", RuleDelayed[ButtonData, "WriteOut"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "WriteOut"]], ", ", 
              ButtonBox["WriteOutPaVe", 
                RuleDelayed[ButtonData, "WriteOutPaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "WriteOutPaVe"]], "."}], "Text", 
            CellTags -> "$Abbreviations"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["$AL", "ObjectName", CellTags -> "$AL"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "$AL"], Cell["$AL is the head for dummy indices which \
may be introduced by Amputate and Uncontract. By default it is unset, but may \
be set to anything.", "Text", CellTags -> "$AL"], 
           Cell[CellGroupData[{Cell[BoxData["$AL"], "Input", CellTags -> 
                "$AL"], Cell[BoxData[\(TraditionalForm\`$AL\)], "Output", 
               CellTags -> "$AL"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "$AL"], Cell[CellGroupData[{Cell[BoxData[
                \(Uncontract[\(\(ScalarProduct[\(p, q\)]\), q, 
                     \(Pair \[Rule] All\)\)]\)], "Input", CellTags -> "$AL"], 
              Cell[BoxData[FormBox[RowBox[{SuperscriptBox[FormBox["p", 
                     "TraditionalForm"], FormBox[FormBox[
                      \($AL$7538 \[InvisibleApplication] \((1)\)\), 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SuperscriptBox[FormBox["q", "TraditionalForm"], FormBox[
                     FormBox[\($AL$7538 \[InvisibleApplication] \((1)\)\), 
                      "TraditionalForm"], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> "$AL"]}, Open]], 
           Cell[BoxData[\(\($AL = \[Mu]\) ;\)], "Input", CellTags -> "$AL"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(Uncontract[\(\(ScalarProduct[\(p, q\)]\), q, 
                     \(Pair \[Rule] All\)\)]\)], "Input", CellTags -> "$AL"], 
              Cell[BoxData[FormBox[RowBox[{SuperscriptBox[FormBox["p", 
                     "TraditionalForm"], FormBox[FormBox[\(\[Mu]$7539(1)\), 
                      "TraditionalForm"], "TraditionalForm"]], " ", 
                   SuperscriptBox[FormBox["q", "TraditionalForm"], FormBox[
                     FormBox[\(\[Mu]$7539(1)\), "TraditionalForm"], 
                     "TraditionalForm"]]}], TraditionalForm]], "Output", 
               CellTags -> "$AL"]}, Open]], Cell[BoxData[\(\($AL=.\) ;\)], 
            "Input", CellTags -> "$AL"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Amputate", RuleDelayed[ButtonData, "Amputate"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Amputate"]], ", ", 
              ButtonBox["Uncontract", RuleDelayed[ButtonData, "Uncontract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Uncontract"]], "."}], "Text", 
            CellTags -> "$AL"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["$BreitMaison", "ObjectName", CellTags -> "$BreitMaison"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "$BreitMaison"], Cell[TextData[
             {"The Breitenlohner-Maison ", Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_5\)]], " scheme is currently not \
supported by the Dirac algebra functions.Use Tracer if you need it (PHI \
supplies the functions FCToTracer and TracerToFC)."}], "Text", 
            CellTags -> "$BreitMaison"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Tr", RuleDelayed[ButtonData, "Tr"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Tr"]], 
              ", ", 
              ButtonBox["$Larin", RuleDelayed[ButtonData, "$Larin"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "$Larin"]], 
              ", ", 
              ButtonBox["$West", RuleDelayed[ButtonData, "$West"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "$West"]], 
              "."}], "Text", CellTags -> "$BreitMaison"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["$Color", "ObjectName", 
         CellTags -> "$Color"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "$Color"], 
           Cell["$Color is False by default. If set to True, some special \
variables will be colored.", "Text", CellTags -> "$Color"], 
           Cell[BoxData[""], "Input"]}, Open]], Cell["$Covariant", 
         "ObjectName", CellTags -> "$Covariant"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "$Covariant"], Cell["The boolean setting of \
$Covariant determines whether Lorentz indices are displayed as lower indices \
(True) or as upper ones (False).", "Text", CellTags -> "$Covariant"], 
           Cell[CellGroupData[{Cell[BoxData["$Covariant"], "Input", 
               CellTags -> "$Covariant"], Cell[BoxData[
                \(TraditionalForm\`False\)], "Output", CellTags -> 
                "$Covariant"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(GA[\[Mu]]\)], "Input", CellTags -> "$Covariant"], 
              Cell[BoxData[\(TraditionalForm\`\(\[Gamma]\^\[Mu]\)\)], 
               "Output", CellTags -> "$Covariant"]}, Open]], Cell[BoxData[
             \(\($Covariant = True\) ;\)], "Input", CellTags -> 
             "$Covariant"], Cell[CellGroupData[{Cell[BoxData[\(GA[\[Mu]]\)], 
               "Input", CellTags -> "$Covariant"], Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_\[Mu]\)], "Output", CellTags -> 
                "$Covariant"]}, Open]], Cell[BoxData[
             \(\($Covariant = False\) ;\)], "Input", CellTags -> 
             "$Covariant"]}, Open]], Cell["$FCS", "ObjectName", 
         CellTags -> "$FCS"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "$FCS"], 
           Cell["$FCS is a list of functions with a short name. E.g. GA[nu] \
can be used instead of DiracGamma[nu].", "Text", CellTags -> "$FCS"], 
           Cell[CellGroupData[{Cell[BoxData["$FCS"], "Input", CellTags -> 
                "$FCS"], Cell[BoxData[
                \(TraditionalForm\`\({"CDr", "FAD", "FC", "FCE", "FCI", "FDr"
                      , "FI", "FV", "FVD", "GA", "GA5", "GGV", "GP", "GS",\
 "GSD", "LC", "LCD", "MT", "MTD", "QGV", "QO", "SD", "SOD",\
 "SP", "SPC", "SPD", "SPL", PMV}\)\)], "Output", CellTags -> "$FCS"]}, 
             Open]]}, Open]], Cell["$FCT", "ObjectName", CellTags -> "$FCT"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "$FCT"], Cell["Setting the global variable $FCT to \
True changes the default typesetting rules for the noncommutative \
multiplication operator Dot[].", "Text", CellTags -> "$FCT"], Cell[BoxData[
             \(\($FCT\ =\ True\) ;\)], "Input", CellTags -> "$FCT"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(GA[\[Mu]]\)\ .\ \(GA[\[Nu]]\)\)], "Input", CellTags -> 
                "$FCT"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu]\ \[Gamma]\^\[Nu]\)\)], 
               "Output", CellTags -> "$FCT"]}, Open]], Cell[BoxData[
             \(\($FCT\ =\ False\) ;\)], "Input", CellTags -> "$FCT"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(GA[\[Mu]]\)\ .\ \(GA[\[Nu]]\)\)], "Input", CellTags -> 
                "$FCT"], Cell[BoxData[
                \(TraditionalForm\`\(\[Gamma]\^\[Mu] . \[Gamma]\^\[Nu]\)\)], 
               "Output", CellTags -> "$FCT"]}, Open]]}, Open]], 
        Cell["$FeynCalcStuff", "ObjectName", CellTags -> "$FeynCalcStuff"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "$FeynCalcStuff"], 
           Cell["$FeynCalcStuff is the list of availabe stuff in FeynCalc.", 
            "Text", CellTags -> "$FeynCalcStuff"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["$FeynCalcVersion", "ObjectName", 
         CellTags -> "$FeynCalcVersion"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "$FeynCalcVersion"], Cell["$FeynCalcVersion is a string that \
represents the version of FeynCalc.", "Text", CellTags -> 
             "$FeynCalcVersion"], Cell[CellGroupData[
             {Cell[BoxData["$FeynCalcVersion"], "Input", CellTags -> 
                "$FeynCalcVersion"], Cell[BoxData[\(TraditionalForm\`"5.1.0"\)
                ], "Output", CellTags -> "$FeynCalcVersion"]}, Open]]}, 
          Open]], Cell["$FortranContinuationCharacter", "ObjectName", 
         CellTags -> "$FortranContinuationCharacter"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "$FortranContinuationCharacter"], Cell["$FortranConti\
nuationCharacter is the continuation character used in Write2.", "Text", 
            CellTags -> "$FortranContinuationCharacter"], 
           Cell[CellGroupData[{Cell[BoxData["$FortranContinuationCharacter"], 
               "Input", CellTags -> "$FortranContinuationCharacter"], 
              Cell[BoxData[\(TraditionalForm\`"&"\)], "Output", CellTags -> 
                "$FortranContinuationCharacter"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Write2", RuleDelayed[ButtonData, "Write2"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Write2"]], 
              "."}], "Text", CellTags -> "$FortranContinuationCharacter"], 
           Cell[BoxData[""], "Input"]}, Open]], Cell["$Gauge", "ObjectName", 
         CellTags -> "$Gauge"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "$Gauge"], 
           Cell["$Gauge(= 1/xi) is a constant specifying the gauge fixing \
parameter of QED in Lorentz gauge.  The usual choice is Feynman gauge, \
$Gauge=1. Notice that $Gauge is used by some functions, the option Gauge by \
others.", "Text", CellTags -> "$Gauge"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Gauge", RuleDelayed[ButtonData, "Gauge"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Gauge"]], 
              "."}], "Text", CellTags -> "$Gauge"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["$Larin", "ObjectName", 
         CellTags -> "$Larin"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "$Larin"], 
           Cell[TextData[
             {"If set to True, the Larin-Gorishny-Atkyampo-DelBurgo-scheme \
for ", Cell[BoxData[\(TraditionalForm\`\[Gamma]\_5\)]], " in ", 
              StyleBox["D", Rule[FontSlant, "Italic"]], "-dimensions is used, \
i.e. before evaluating traces (but after moving ", Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_5\)]], " anticommuting in all \
dimensions to the right of the Dirac string) a product  gamma[mu].gamma5 is \
substituted to  -I/6 Eps[mu,al,be,si] gamma[al,be,si], where all indices live \
in ", StyleBox["D", Rule[FontSlant, "Italic"]], 
              "-dimensions now. Especially the Levic-Civita tensor is taken \
to be ", StyleBox["D", Rule[FontSlant, "Italic"]], 
              "-dimensional, i.e., contraction of two Eps's results in ", 
              StyleBox["D", Rule[FontSlant, "Italic"]], "'s. This has (FOR \
ONE AXIAL-VECTOR-CURRENT ONLY, it is not so clear if this scheme also works \
for more than one fermion line involving ", Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_5\)]], ") the same effect as the \
Breitenlohner-Maison-'t Hooft-Veltman scheme."}], "Text", 
            CellTags -> "$Larin"], Cell[CellGroupData[
             {Cell[BoxData["$Larin"], "Input", CellTags -> "$Larin"], 
              Cell[BoxData[\(TraditionalForm\`False\)], "Output", CellTags -> 
                "$Larin"]}, Open]], Cell[TextData[{"See also:  ", 
              ButtonBox["Tr", RuleDelayed[ButtonData, "Tr"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Tr"]], 
              ", ", 
              ButtonBox["$BreitMaison", 
                RuleDelayed[ButtonData, "$BreitMaison"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "$BreitMaison"]], ", ", 
              ButtonBox["$West", RuleDelayed[ButtonData, "$West"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "$West"]], 
              "."}], "Text", CellTags -> "$Larin"], Cell[BoxData[""], 
            "Input"]}, Open]], Cell["$LimitTo4", "ObjectName", 
         CellTags -> "$LimitTo4"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "$LimitTo4"], 
           Cell["$LimitTo4 is a variable with default setting True. If set to \
False, no limit Dimension \[Rule] 4 is performed after tensor integral \
decomposition.", "Text", CellTags -> "$LimitTo4"], 
           Cell[CellGroupData[{Cell[BoxData["$LimitTo4"], "Input", 
               CellTags -> "$LimitTo4"], Cell[BoxData[
                \(TraditionalForm\`True\)], "Output", CellTags -> 
                "$LimitTo4"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["PaVe", RuleDelayed[ButtonData, "PaVe"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "PaVe"]], 
              ", ", 
              ButtonBox["PaVeReduce", RuleDelayed[ButtonData, "PaVeReduce"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "PaVeReduce"]], ", ", 
              ButtonBox["OneLoop", RuleDelayed[ButtonData, "OneLoop"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "OneLoop"]]\
, "."}], "Text", CellTags -> "$LimitTo4"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["$LorentzIndices", "ObjectName", 
         CellTags -> "$LorentzIndices"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "$LorentzIndices"], Cell["$LorentzIndices is a global variable. \
If set to True the dimension of LorentzIndex is displayed as an index.", 
            "Text", CellTags -> "$LorentzIndices"], Cell[BoxData[
             \(\($LorentzIndices = True\) ;\)], "Input", CellTags -> 
             "$LorentzIndices"], Cell[CellGroupData[{Cell[BoxData[
                \(\(MetricTensor[\(\[Alpha], \[Beta], \(Dimension \[Rule] n\)
                      \)]\) \(DiracMatrix[
                     \(\[Alpha], \(Dimension \[Rule] n\)\)]\)\)], "Input", 
               CellTags -> "$LorentzIndices"], Cell[BoxData[FormBox[
                 RowBox[{SuperscriptBox["\[Gamma]", FormBox[SubscriptBox[
                      FormBox["\[Alpha]", "TraditionalForm"], FormBox["n", 
                       "TraditionalForm"]], "TraditionalForm"]], " ", 
                   SuperscriptBox["g", RowBox[{FormBox[SubscriptBox[FormBox[
                         "\[Alpha]", "TraditionalForm"], FormBox["n", 
                         "TraditionalForm"]], "TraditionalForm"], FormBox[
                       SubscriptBox[FormBox["\[Beta]", "TraditionalForm"], 
                        FormBox["n", "TraditionalForm"]], 
                       "TraditionalForm"]}]]}], TraditionalForm]], "Output", 
               CellTags -> "$LorentzIndices"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//StandardForm\)], "Input", 
               CellTags -> "$LorentzIndices"], Cell[BoxData[
                \(\(DiracGamma[\(\(LorentzIndex[\(\[Alpha], n\)]\), n\)]\)\ 
                   \(MetricTensor[\(\[Alpha], \[Beta], 
                       \(Dimension \[Rule] n\)\)]\)\)], "Output", CellTags -> 
                "$LorentzIndices"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(\(MTD[\(\[Alpha], \[Beta]\)]\)\ \(FVD[\(p, \[Beta]\)]\) 
                     \(GAD[\[Mu]]\)\)//FCI\)], "Input", CellTags -> 
                "$LorentzIndices"], Cell[BoxData[FormBox[RowBox[
                  {SuperscriptBox["\[Gamma]", FormBox[SubscriptBox[FormBox[
                       "\[Mu]", "TraditionalForm"], FormBox["D", 
                       "TraditionalForm"]], "TraditionalForm"]], " ", 
                   SuperscriptBox["g", RowBox[{FormBox[SubscriptBox[FormBox[
                         "\[Alpha]", "TraditionalForm"], FormBox["D", 
                         "TraditionalForm"]], "TraditionalForm"], FormBox[
                       SubscriptBox[FormBox["\[Beta]", "TraditionalForm"], 
                        FormBox["D", "TraditionalForm"]], 
                       "TraditionalForm"]}]], " ", SuperscriptBox[FormBox[
                     "p", "TraditionalForm"], FormBox[SubscriptBox[FormBox[
                       "\[Beta]", "TraditionalForm"], FormBox["D", 
                       "TraditionalForm"]], "TraditionalForm"]]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "$LorentzIndices"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(%//StandardForm\)], "Input", CellTags -> 
                "$LorentzIndices"], Cell[BoxData[
                \(\(DiracGamma[\(\(LorentzIndex[\(\[Mu], D\)]\), D\)]\)\ 
                   \(Pair[\(\(LorentzIndex[\(\[Alpha], D\)]\), 
                       \(LorentzIndex[\(\[Beta], D\)]\)\)]\)\ 
                   \(Pair[\(\(LorentzIndex[\(\[Beta], D\)]\), 
                       \(Momentum[\(p, D\)]\)\)]\)\)], "Output", CellTags -> 
                "$LorentzIndices"]}, Open]], Cell[BoxData[
             \(\($LorentzIndices = False\) ;\)], "Input", 
            CellTags -> "$LorentzIndices"]}, Open]], Cell["$MIntegrate", 
         "ObjectName", CellTags -> "$MIntegrate"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "$MIntegrate"], Cell[TextData[
             {"$MIntegrate is a list of integrations done by ", 
              StyleBox["Mathematica", Rule[FontSlant, "Italic"]], 
              " inside OPEIntegrateDelta."}], "Text", CellTags -> 
             "$MIntegrate"], Cell[CellGroupData[{Cell[BoxData["$MIntegrate"], 
               "Input", CellTags -> "$MIntegrate"], Cell[BoxData[
                \(TraditionalForm\`\({}\)\)], "Output", CellTags -> 
                "$MIntegrate"]}, Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["OPEIntegrateDelta", 
                RuleDelayed[ButtonData, "OPEIntegrateDelta"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "OPEIntegrateDelta"]], "."}], "Text", 
            CellTags -> "$MIntegrate"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["$MU", "ObjectName", CellTags -> "$MU"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "$MU"], Cell["$MU is the head of dummy indices which \
may be introduced by Chisholm, Contract, DiracSimplify, FermionSpinSum and \
various QCD functions. By default it is unset, but can be set to anything.", 
            "Text", CellTags -> "$MU"], Cell[CellGroupData[
             {Cell[BoxData["$MU"], "Input", CellTags -> "$MU"], Cell[BoxData[
                \(TraditionalForm\`$MU\)], "Output", CellTags -> "$MU"]}, 
             Open]], Cell[TextData[{"See also: ", " ", 
              ButtonBox["Chisholm", RuleDelayed[ButtonData, "Chisholm"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Chisholm"]], ", ", 
              ButtonBox["Contract", RuleDelayed[ButtonData, "Contract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Contract"]], ", ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], "."}], "Text", 
            CellTags -> "$MU"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["$MemoryAvailable", "ObjectName", CellTags -> 
          "$MemoryAvailable"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> 
             "$MemoryAvailable"], Cell[TextData[{"$MemoryAvailable is  a \
global variable which is set to an integer ", 
              StyleBox["n", Rule[FontSlant, "Italic"]], ", where ", 
              StyleBox["n", Rule[FontSlant, "Italic"]], " is the available \
amount of main memory in MB. The default is 128. It should be increased if \
possible. The higher $MemoryAvailable can be, the more intermediate steps do \
not have to be repeated by FeynCalc."}], "Text", CellTags -> 
             "$MemoryAvailable"], Cell[CellGroupData[
             {Cell[BoxData["$MemoryAvailable"], "Input", CellTags -> 
                "$MemoryAvailable"], Cell[BoxData[\(TraditionalForm\`256\)], 
               "Output", CellTags -> "$MemoryAvailable"]}, Open]]}, Open]], 
        Cell["$NonComm", "ObjectName", CellTags -> "$NonComm"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "$NonComm"], 
           Cell[
            "$NonComm contains a list of all non-commutative heads present.", 
            "Text", CellTags -> "$NonComm"], Cell[CellGroupData[
             {Cell[BoxData["$NonComm"], "Input", CellTags -> "$NonComm"], 
              Cell[BoxData[
                \(TraditionalForm\`\({ChiralityProjector, DiracGamma, 
                      DiracGammaT, DiracMatrix, DiracSigma, DiracSlash, 
                      Spinor, GAD, GA, GSD, GS, LeftPartialD, 
                      LeftRightPartialD2, LeftRightPartialD, PartialD, 
                      PauliSigma, QuantumField, RightPartialD, SpinorUBar, 
                      SpinorU, SpinorVBar, SpinorV, SUNT, FieldStrength, 
                      QuarkGluonVertex, QuarkPropagator, C, 
                      Twist2QuarkOperator, CovariantD, OPESum, 
                      \*TagBox[StyleBox["\"\[ScriptCapitalU]\"", 
                         Rule[FontWeight, "Bold"], 
                         Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"], 
                          Rule[FontWeight, "Bold"]]]], 
                      \*TagBox[StyleBox["\"\[ScriptU]\"", 
                         Rule[FontWeight, "Bold"], 
                         Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"], 
                          Rule[FontWeight, "Bold"]]]], 
                      \*TagBox[StyleBox["\"\[Chi]\"", 
                         Rule[FontWeight, "Bold"], 
                         Rule[FontSlant, "Italic"]], 
                        Function[StyleForm[Slot[1], 
                          Rule[FontSlant, "Italic"], 
                          Rule[FontWeight, "Bold"]]]], 
                      \(\(\*TagBox[StyleBox["\"\[Chi]\"", 
                            Rule[FontWeight, "Bold"], 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"], 
                             Rule[FontWeight, "Bold"]]]]\)\_-\), 
                      \(\(\*TagBox[StyleBox["\"\[Chi]\"", 
                            Rule[FontWeight, "Bold"], 
                            Rule[FontSlant, "Italic"]], 
                           Function[StyleForm[Slot[1], 
                             Rule[FontSlant, "Italic"], 
                             Rule[FontWeight, "Bold"]]]]\)\_+\), UFMinus, 
                      UFPlus, UGamma, UMatrix, USmall, WFFactor1, 
                      Twist2AlienOperator, Twist2CounterOperator}\)\)], 
               "Output", CellTags -> "$NonComm"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["NonCommQ", RuleDelayed[ButtonData, "NonCommQ"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "NonCommQ"]], ", ", 
              ButtonBox["NonCommutative", 
                RuleDelayed[ButtonData, "NonCommutative"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "NonCommutative"]], "."}], "Text", 
            CellTags -> "$NonComm"], Cell[BoxData[""], "Input"]}, Open]], 
        Cell["$PairBrackets", "ObjectName", CellTags -> "$PairBrackets"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "$PairBrackets"], Cell["$PairBrackets determines \
whether brackets are drawn around scalar products in the notebook interface."\
, "Text", CellTags -> "$PairBrackets"], Cell[CellGroupData[
             {Cell[BoxData["$PairBrackets"], "Input", CellTags -> 
                "$PairBrackets"], Cell[BoxData[\(TraditionalForm\`False\)], 
               "Output", CellTags -> "$PairBrackets"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(SP[\(p, q\)]\) \(SP[\(r, s\)]\)\)], "Input", CellTags -> 
                "$PairBrackets"], Cell[BoxData[FormBox[RowBox[
                  {FormBox[RowBox[{FormBox["p", "TraditionalForm"], 
                      "\[CenterDot]", FormBox["q", "TraditionalForm"]}], 
                    "TraditionalForm"], " ", FormBox[RowBox[{FormBox["r", 
                       "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                       "TraditionalForm"]}], "TraditionalForm"]}], 
                 TraditionalForm]], "Output", CellTags -> "$PairBrackets"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\($PairBrackets = True\)
                ], "Input", CellTags -> "$PairBrackets"], Cell[BoxData[
                \(TraditionalForm\`True\)], "Output", CellTags -> 
                "$PairBrackets"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(\(SP[\(p, q\)]\) \(SP[\(r, s\)]\)\)], "Input", CellTags -> 
                "$PairBrackets"], Cell[BoxData[FormBox[RowBox[
                  {FormBox[RowBox[{"(", FormBox["p", "TraditionalForm"], 
                      "\[CenterDot]", FormBox["q", "TraditionalForm"], ")"}], 
                    "TraditionalForm"], " ", FormBox[RowBox[{"(", FormBox[
                       "r", "TraditionalForm"], "\[CenterDot]", FormBox["s", 
                       "TraditionalForm"], ")"}], "TraditionalForm"]}], 
                 TraditionalForm]], "Output", CellTags -> "$PairBrackets"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[
                \($PairBrackets = False\)], "Input", CellTags -> 
                "$PairBrackets"], Cell[BoxData[\(TraditionalForm\`False\)], 
               "Output", CellTags -> "$PairBrackets"]}, Open]]}, Open]], 
        Cell["$SpinorMinimal", "ObjectName", CellTags -> "$SpinorMinimal"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "$SpinorMinimal"], Cell["$SpinorMinimal is a global \
switch for an additional simplification attempt in DiracSimplify for more \
than one Spinor-line. The default is False, since otherwise it costs too much \
time.", "Text", CellTags -> "$SpinorMinimal"], Cell[CellGroupData[
             {Cell[BoxData["$SpinorMinimal"], "Input", CellTags -> 
                "$SpinorMinimal"], Cell[BoxData[\(TraditionalForm\`False\)], 
               "Output", CellTags -> "$SpinorMinimal"]}, Open]], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["DiracSimplify", 
                RuleDelayed[ButtonData, "DiracSimplify"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "DiracSimplify"]], "."}], "Text", 
            CellTags -> "$SpinorMinimal"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["$VeryVerbose", "ObjectName", 
         CellTags -> "$VeryVerbose"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "$VeryVerbose"], 
           Cell["$VeryVerbose is a global variable with default setting 0. If \
set to 1, 2, ..., less and more intermediate comments and informations are \
displayed during calculations.", "Text", CellTags -> "$VeryVerbose"], 
           Cell[CellGroupData[{Cell[BoxData["$VeryVerbose"], "Input", 
               CellTags -> "$VeryVerbose"], Cell[BoxData[
                \(TraditionalForm\`0\)], "Output", CellTags -> 
                "$VeryVerbose"]}, Open]], Cell[BoxData[
             \(\($VeryVerbose\ =\ 3\) ;\)], "Input", CellTags -> 
             "$VeryVerbose"], Cell[CellGroupData[{Cell[BoxData[
                \(\(Collect2[\(\(Expand[\(\((x - y - z)\)^6\)]\), x\)]\) ;\)]\
, "Input", CellTags -> "$VeryVerbose"], Cell[
               "expanding. inhomogeneous part; LeafCount = 43; factored. \
#1#2#3#4#5#6", "Print", CellTags -> "$VeryVerbose"], Cell[BoxData[
                \(TraditionalForm\`\(\*InterpretationBox[\(
                       "length "\[InvisibleSpace]21\[InvisibleSpace]"."\), 
                      SequenceForm["length ", 21, "."], 
                      Rule[Editable, False]]\)\)], "Print", CellTags -> 
                "$VeryVerbose"], Cell[BoxData[
                \(TraditionalForm\`\(\*InterpretationBox[\(
                       "collecting "\[InvisibleSpace]6\[InvisibleSpace]" \
terms."\), SequenceForm["collecting ", 6, " terms."], 
                      Rule[Editable, False]]\)\)], "Print", CellTags -> 
                "$VeryVerbose"]}, Open]], Cell[BoxData[
             \(\($VeryVerbose = 0\) ;\)], "Input", CellTags -> 
             "$VeryVerbose"], Cell[TextData[{"See also: ", " ", 
              ButtonBox["$V0", RuleDelayed[ButtonData, "$V0"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "$V0"]], 
              "."}], "Text", CellTags -> "$V0"], Cell[BoxData[""], "Input"]}, 
          Open]], Cell["$West", "ObjectName", CellTags -> "$West"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "$West"], Cell[TextData[{"If $West is set to True \
(which is the default), traces involving more than 4 Dirac matrices and ", 
              Cell[BoxData[\(TraditionalForm\`\[Gamma]\_5\)]], " are \
calculated recursively according to formula (A.5) from Comp. Phys. Comm 77 \
(1993) 286-298, which is based on the Breitenlohner Maison ", Cell[BoxData[
                \(TraditionalForm\`\[Gamma]\_5\)]], "-scheme."}], "Text", 
            CellTags -> "$West"], Cell[TextData[{"See examples in ", 
              ButtonBox["Tr", RuleDelayed[ButtonData, "Tr"], 
                Rule[ButtonStyle, "AddOnsLink"], Rule[ButtonNote, "Tr"]], 
              "."}], "Text", CellTags -> "$West"], 
           Cell["Evaluation time and memory usage", "Commentary"], 
           Cell[CellGroupData[{Cell[BoxData[
                \(\(AbsoluteTime[]\) - absolutestarttime\)], "Input"], 
              Cell[BoxData[\(TraditionalForm\`235.138112`9.822868020280772\)]
                , "Output"]}, Open]], Cell[CellGroupData[{Cell[BoxData[
                \(MemoryInUse[]\)], "Input"], Cell[BoxData[
                \(TraditionalForm\`29841504\)], "Output"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(MaxMemoryUsed[]\)], "Input"], 
              Cell[BoxData[\(TraditionalForm\`29963808\)], "Output"]}, 
             Open]], Cell[CellGroupData[{Cell[BoxData[\(TimeUsed[]\)], 
               "Input"], Cell[BoxData[\(TraditionalForm\`87.52400000000027`\)]
                , "Output"]}, Open]]}, Open]]}, Open]], 
     Cell[CellGroupData[{Cell["Functions (experimental)", "Section", 
         CellTags -> "Experimental"], Cell["DoPolarizationSums", 
         "ObjectName", CellTags -> "DoPolarizationSums"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "DoPolarizationSums"], Cell["***EXPERIMENTAL***\nDoPo\
larizationSums[exp] sums over vector polarizations for expressions with a \
factor of the form\nPair[LorentzIndex[rho1_], Momentum[Polarization[p_, \
-I]]]*\nPair[LorentzIndex[rho2_], Momentum[Polarization[p_, I]]].", "Text", 
            CellTags -> "DoPolarizationSums"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["Polarization", 
                RuleDelayed[ButtonData, "Polarization"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Polarization"]], ", ", 
              ButtonBox["Uncontract", RuleDelayed[ButtonData, "Uncontract"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "Uncontract"]], "."}], "Text", 
            CellTags -> "DoPolarizationSums"]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "DoPolarizationSums"], Cell["In the following (and \
indeed everywhere else within FeynCalc), notice that Lorentz indices written \
as super or subscripts are not to be taken as such. Instead, by convention, \
when two indices are contracted one is always lower and the other upper.", 
            "Text", CellTags -> "DoPolarizationSums"], Cell["FeynCalc uses \
the following normalization of Polarization vectors:", "Text", 
            CellTags -> "DoPolarizationSums"], Cell[CellGroupData[
             {Cell[BoxData[
                \(\(Pair[\(\(LorentzIndex[\[Mu]]\), 
                       \(Momentum[\(Polarization[\(p4, \(-\[ImaginaryI]\)\)]
                          \)]\)\)]\)\ \(Pair[
                     \(\(LorentzIndex[\[Mu]]\), 
                       \(Momentum[\(Polarization[\(p4, \[ImaginaryI]\)]\)]\)\
\)]\)\)], "Input", CellTags -> "DoPolarizationSums"], Cell[BoxData[
                FormBox[RowBox[{RowBox[{SubsuperscriptBox["\[CurlyEpsilon]", 
                      FormBox[FormBox["\[Mu]", "TraditionalForm"], 
                       "TraditionalForm"], "*"], "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_4\), 
                      "TraditionalForm"], ")"}], " ", RowBox[{SubscriptBox[
                      "\[CurlyEpsilon]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_4\), 
                      "TraditionalForm"], ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "DoPolarizationSums"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(%//Contract\)], "Input", 
               CellTags -> "DoPolarizationSums"], Cell[BoxData[
                \(TraditionalForm\`\(-1\)\)], "Output", CellTags -> 
                "DoPolarizationSums"]}, Open]], 
           Cell[TextData[{"DoPolarizationSums is chosen in such a way as to \
be consistent with this normalization and with ", Cell[BoxData[
                \(TraditionalForm\`\[Sum]\+Polarizations\)]], 
              Cell[BoxData[FormBox[RowBox[{RowBox[{SubscriptBox[
                      "\[CurlyEpsilon]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"]], "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_4\), 
                      "TraditionalForm"], ")"}], " ", RowBox[{SubscriptBox[
                      \((\[CurlyEpsilon]\^\[Nu])\), FormBox["", 
                       "TraditionalForm"]], "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_4\), 
                      "TraditionalForm"], ")"}]}], TraditionalForm]]], "=", 
              Cell[BoxData[FormBox[RowBox[{"-", FormBox[SuperscriptBox[
                     \(g\_\[Mu]\), RowBox[{"\[NoBreak]", FormBox["\[Nu]", 
                        "TraditionalForm"]}]], "TraditionalForm"]}], 
                 TraditionalForm]]], ":"}], "Text", CellTags -> 
             "DoPolarizationSums"], Cell[TextData[{"We can choose e.g. the \
following polarization vectors, labeled with a subscript, {", Cell[BoxData[
                \(TraditionalForm\`e\_1\)]], ",", Cell[BoxData[
                \(TraditionalForm\`e\_2\)]], ",", Cell[BoxData[
                \(TraditionalForm\`e\_3\)]], ",", Cell[BoxData[
                \(TraditionalForm\`e\_4\)]], "} = {(\[ImaginaryI],0,0,0), \
(0,\[ImaginaryI],0,0), (0,0,\[ImaginaryI],0), (0,0,0,\[ImaginaryI])}."}], 
            "Text", CellTags -> "DoPolarizationSums"], Cell[BoxData[
             \(Clear[\(ee, tt\)]\)], "Input", CellTags -> 
             "DoPolarizationSums"], Cell[BoxData[
             \(\(\(ev[i_]\) := \(ReplacePart[\(\({0, 0, 0, 0}\), I, i\)]\)
                 \) ;\)], "Input", CellTags -> "DoPolarizationSums"], 
           Cell[CellGroupData[{Cell[BoxData[
                \({\(ev[1]\), \(ev[2]\), \(ev[3]\), \(ev[4]\)}\)], "Input", 
               CellTags -> "DoPolarizationSums"], Cell[BoxData[
                \(TraditionalForm\`\((\[NoBreak] 
                     \*GridBox[{{"\[ImaginaryI]", "0", "0", "0"}, 
                        {"0", "\[ImaginaryI]", "0", "0"}, 
                        {"0", "0", "\[ImaginaryI]", "0"}, 
                        {"0", "0", "0", "\[ImaginaryI]"}}, 
                       RowSpacings -> 1., ColumnSpacings -> 1., 
                       ColumnAlignments -> {Left}] \[NoBreak])\)\)], 
               "Output", CellTags -> "DoPolarizationSums"]}, Open]], 
           Cell[TextData[{StyleBox["ee[i][\[Mu]]", "Input"], " is ", 
              Cell[BoxData[\(TraditionalForm\`\(\(e\_i\)\^\[Mu]\)\)]], ":"}], 
            "Text", CellTags -> "DoPolarizationSums"], Cell[BoxData[
             \(\(\(\(ee[i_]\)[mu_]\) := \(\(ev[i]\)[\([mu]\)]\)\) ;\)], 
            "Input", CellTags -> "DoPolarizationSums"], Cell[BoxData[
             \(\(tt[\(i_, j_, mu_, nu_\)]\) := 
                \(\(\(ee[i]\)[mu]\) \(\(ee[j]\)[nu]\)\)\)], "Input", 
            CellTags -> "DoPolarizationSums"], Cell[TextData[{
              StyleBox["tt[i,j,\[Mu],\[Nu]]", "Input"], " is ", Cell[BoxData[
                \(TraditionalForm\`\(\(e\_i\)\^\[Mu]\)\)]], Cell[BoxData[
                \(TraditionalForm\`\(\(e\_j\)\^\[Nu]\)\)]], ":"}], "Text", 
            CellTags -> "DoPolarizationSums"], Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`\[Sum]\+\(i, j\)\)]], Cell[BoxData[
                FormBox[RowBox[{" ", RowBox[{FormBox[\(\(e\_i\)\^\[Mu]\), 
                      "TraditionalForm"], FormBox[\(e\_\(j, \[Nu]\)\), 
                      "TraditionalForm"]}]}], TraditionalForm]]], "=", 
              Cell[BoxData[FormBox[RowBox[{"-", FormBox[SuperscriptBox[
                     \(g\_\[Mu]\), RowBox[{"\[NoBreak]", FormBox["\[Nu]", 
                        "TraditionalForm"]}]], "TraditionalForm"]}], 
                 TraditionalForm]]], ":"}], "Text", CellTags -> 
             "DoPolarizationSums"], Cell[CellGroupData[{Cell[BoxData[
                \(Table[\(\(\[Sum]\+\(i = 1\)\%4 \(tt[\(i, i, mu, nu\)]\)\), 
                     \({mu, 1, 4}\), \({nu, 1, 4}\)\)]\)], "Input", 
               CellTags -> "DoPolarizationSums"], Cell[BoxData[
                \(TraditionalForm\`\((\[NoBreak] 
                     \*GridBox[{{\(-1\), "0", "0", "0"}, 
                        {"0", \(-1\), "0", "0"}, {"0", "0", \(-1\), "0"}, 
                        {"0", "0", "0", \(-1\)}}, RowSpacings -> 1., 
                       ColumnSpacings -> 1., ColumnAlignments -> {Left}] 
                     \[NoBreak])\)\)], "Output", CellTags -> 
                "DoPolarizationSums"]}, Open]], Cell[TextData[{Cell[BoxData[
                \(TraditionalForm\`\[Sum]\+\(\[Mu], \[Nu]\)\)]], 
              Cell[BoxData[FormBox[RowBox[{" ", RowBox[{FormBox[
                      \(\(e\_i\)\^\[Mu]\), "TraditionalForm"], FormBox[
                      \(e\_\(j, \[Nu]\)\), "TraditionalForm"]}]}], 
                 TraditionalForm]]], "=", Cell[BoxData[FormBox[RowBox[
                  {"-", FormBox[\(\(g\_i\)\^j\), "TraditionalForm"]}], 
                 TraditionalForm]]], ":"}], "Text", CellTags -> 
             "DoPolarizationSums"], Cell[CellGroupData[{Cell[BoxData[
                \(Table[\(\(\[Sum]\+\(mu = 1\)\%4 \(tt[\(i, j, mu, mu\)]\)\),
                      \({i, 1, 4}\), \({j, 1, 4}\)\)]\)], "Input", 
               CellTags -> "DoPolarizationSums"], Cell[BoxData[
                \(TraditionalForm\`\((\[NoBreak] 
                     \*GridBox[{{\(-1\), "0", "0", "0"}, 
                        {"0", \(-1\), "0", "0"}, {"0", "0", \(-1\), "0"}, 
                        {"0", "0", "0", \(-1\)}}, RowSpacings -> 1., 
                       ColumnSpacings -> 1., ColumnAlignments -> {Left}] 
                     \[NoBreak])\)\)], "Output", CellTags -> 
                "DoPolarizationSums"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[
                \(ptest = \(\(Pair[\(\(LorentzIndex[\[Mu]]\), 
                         \(LorentzIndex[\(ComplexIndex[\[Mu]]\)]\)\)]\)\ 
                     \(Pair[\(\(LorentzIndex[\[Mu]]\), 
                         \(Momentum[\(Polarization[\(p4, \(-\[ImaginaryI]\)\)
                             ]\)]\)\)]\)\ 
                     \(Pair[\(\(LorentzIndex[\(ComplexIndex[\[Mu]]\)]\), 
                         \(Momentum[\(Polarization[\(p4, \[ImaginaryI]\)]\)]
                          \)\)]\)\)\)], "Input", CellTags -> 
                "DoPolarizationSums"], Cell[BoxData[FormBox[RowBox[
                  {SuperscriptBox["g", RowBox[{"\[Mu]", FormBox[\(\[Mu]\^*\), 
                       "TraditionalForm"]}]], " ", RowBox[{SubsuperscriptBox[
                      "\[CurlyEpsilon]", FormBox[FormBox["\[Mu]", 
                        "TraditionalForm"], "TraditionalForm"], "*"], "(", 
                     FormBox[
                      \(\(\*TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_4\), 
                      "TraditionalForm"], ")"}], " ", RowBox[{SubscriptBox[
                      "\[CurlyEpsilon]", FormBox[FormBox[\(\[Mu]\^*\), 
                        "TraditionalForm"], "TraditionalForm"]], "(", FormBox[
                      \(\(\*TagBox[StyleBox["\"p\"", 
                             Rule[FontSlant, "Italic"]], 
                            Function[StyleForm[Slot[1], 
                              Rule[FontSlant, "Italic"]]]]\)\_4\), 
                      "TraditionalForm"], ")"}]}], TraditionalForm]], 
               "Output", CellTags -> "DoPolarizationSums"]}, Open]], 
           Cell[CellGroupData[{Cell[BoxData[\(ptest//DoPolarizationSums\)], 
               "Input", CellTags -> "DoPolarizationSums"], Cell[BoxData[
                FormBox[RowBox[{"-", SuperscriptBox[FormBox[SuperscriptBox[
                      "g", RowBox[{"\[Mu]", FormBox[\(\[Mu]\^*\), 
                         "TraditionalForm"]}]], "TraditionalForm"], "2"]}], 
                 TraditionalForm]], "Output", CellTags -> 
                "DoPolarizationSums"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(%//Contract\)], "Input", CellTags -> 
                "DoPolarizationSums"], Cell[BoxData[
                \(TraditionalForm\`\(-4\)\)], "Output", CellTags -> 
                "DoPolarizationSums"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(ptest//Contract\)], "Input", CellTags -> 
                "DoPolarizationSums"], Cell[BoxData[
                \(TraditionalForm\`\(-1\)\)], "Output", CellTags -> 
                "DoPolarizationSums"]}, Open]], Cell[CellGroupData[
             {Cell[BoxData[\(%//DoPolarizationSums\)], "Input", CellTags -> 
                "DoPolarizationSums"], Cell[BoxData[
                \(TraditionalForm\`\(-4\)\)], "Output", CellTags -> 
                "DoPolarizationSums"]}, Open]], Cell[BoxData[
             \(Clear[\(ee, tt, ev, ptest\)]\)], "Input", CellTags -> 
             "DoPolarizationSums"]}, Open]], 
        Cell["FeynmanDoIntegrals ***unfinished***", "ObjectName", 
         CellTags -> "FeynmanDoIntegrals"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynmanDoIntegrals"], Cell["***EXPERIMENTAL***\n \
FeynmanDoIntegrals[exp, moms, vars] attempts to evaluate integrals over \
Feynman parameters vars in an expression exp as produced e.g. with \
FeynmanReduce. The variables given must be atomic quantities (AtomQ). If vars \
is omitted all variables in the integrals will be integrated. If vars is \
given, only the variables in vars will be integrated. moms is a list of all \
external momenta. The integrals in exp must be given in the form \
Integratedx[x, low, up].int, where x is the integration variable, low and up \
are the integration limits and int the integrand. The interval [low,up] is \
assumed to include integration bounds put by possible DeltaFunctions and \
moreover it is assumed that up \[GreaterEqual] 0 and that up > low. The two \
options FCIntegrate and FCNIntegrate determine which integration will be \
applied to integrals judged respectively analytically and numerically doable. \
This judging is a very rough one. Using (TimedIntegrate[##, \
Integrate\[Rule]Integrate]&) or (TimedIntegrate[##, \
Integrate\[Rule]NIntegrate]&) as the setting of one or both allows for finer \
judging. Those that are judged neither analytically nor numerically doable \
are left unevaluated, but can of course be attempted evaluated by a simple \
sustitution. Beside the explicit options of FeynmanDoIntegrals options of the \
integration functions specified (FCIntegrate and FCNIntegrate) may be given \
and are passed on to these.", "Text", CellTags -> "FeynmanDoIntegrals"], 
           Cell[TextData[{"See also: ", " ", 
              ButtonBox["FeynmanReduce", 
                RuleDelayed[ButtonData, "FeynmanReduce"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynmanReduce"]], ", ", 
              ButtonBox["FeynmanParametrize1", 
                RuleDelayed[ButtonData, "FeynmanParametrize1"], 
                Rule[ButtonStyle, "AddOnsLink"], 
                Rule[ButtonNote, "FeynmanParametrize1"]], "."}], "Text", 
            CellTags -> "FeynmanDoIntegrals"], Cell[CellGroupData[
             {Cell[BoxData[\(Options[FeynmanDoIntegrals]\)], "Input", 
               CellTags -> "FeynmanDoIntegrals"], Cell[BoxData[
                \(TraditionalForm\`\({\(NIntegrate \[Rule] False\), 
                      \(Dimension \[Rule] D\), 
                      \(EpsilonOrder \[Rule] \({\(-2\), 0}\)\), 
                      \(FCIntegrate \[Rule] TimedIntegrate\), 
                      \(Simplify \[Rule] True\), \(Expand \[Rule] True\), 
                      \(Series \[Rule] True\), 
                      \(FCNIntegrate \[Rule] 
                        \((\(\(DOT(\(\(Sequence @@ 
                                  \(\((\(
                                     \(HighEnergyPhysics`fcdevel`FeynmanDoIn\
tegrals`Private`Integratedx @@ #1\) &\))\)/@\({##2}\)\)\), #1
                \))\) &\))\)\)}\)\)], "Output", CellTags -> 
                "FeynmanDoIntegrals"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynmanDoIntegrals"], Cell[BoxData[""], "Input", 
            CellTags -> "FeynmanDoIntegrals"]}, Open]], 
        Cell["FeynmanParametrize1 ***unfinished***", "ObjectName", 
         CellTags -> "FeynmanParametrize1"], 
        Cell[CellGroupData[{Cell["Description", "Subsubsection", 
            CellTags -> "FeynmanParametrize1"], Cell["***EXPERIMENTAL***\n \
FeynmanParametrize1[exp,k,Method->Denominator] introduces Feynman parameters \
for all one-loop integrals in exp (k = integration momentum) using formula \
(11.A.1) from \"The Quantum Theory of Fields\" vol. 1 by Steven Weinberg.  \
FeynmanParametrize1[exp,k,Method->Exp] introduces Feynman parameters for all \
one-loop integrals in exp (k = integration momentum) using 1/(A-I eps) = I \
Integrate[Exp[-I x (A-I eps)],{x,0,Infinity}, \
Assumptions->{Arg[A]==0,Arg[eps]==0}]. In this case, when the option \
Integrate is set to True, odd factors of k-tensors are dropped and even \
factors are replaced according to Itzykson&Zuber (8-117).", "Text", 
            CellTags -> "FeynmanParametrize1"], Cell[CellGroupData[
             {Cell[BoxData[\(Options[FeynmanParametrize1]\)], "Input", 
               CellTags -> "FeynmanParametrize1"], Cell[BoxData[
                \(TraditionalForm\`\({\(FeynmanParameterNames \[Rule] 
                        \({a, b, c, d, e}\)\), \(Method \[Rule] Denominator\)
                      , \(Integrate \[Rule] True\), \(Flatten \[Rule] True\),
                       \(CompleteSquare \[Rule] True\)}\)\)], "Output", 
               CellTags -> "FeynmanParametrize1"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynmanParametrize1"], Cell[BoxData[""], "Input", 
            CellTags -> "FeynmanParametrize1"]}, Open]], 
        Cell["FeynmanReduce ***unfinished***", "ObjectName", 
         CellTags -> "FeynmanReduce"], Cell[CellGroupData[
          {Cell["Description", "Subsubsection", CellTags -> "FeynmanReduce"], 
           Cell["***EXPERIMENTAL***\n FeynmanReduce[exp,params] takes a \
Feynman parameterized expression exp (as e.g. generated with \
FeynmanParametrize1) and a list of Feynman parameters as input and attempts \
to simplify the expression. If no parameters are given, Integratedx variables \
in the expression will be used. Currently, reduction of exponentials is \
implemented. This will work on terms of the form \
E^p1[a,b,c,...]*p2[a,b,c,...], where p1 and p2 are fractions of polynomials \
in the Feynman parameters a,b,c,... If the option Expand is set to True, \
FeynmanReduce will attempt to bring the expression exp into a sum of such \
terms and operate on the terms one by one.", "Text", CellTags -> 
             "FeynmanReduce"], Cell[CellGroupData[{Cell[BoxData[
                \(Options[FeynmanReduce]\)], "Input", CellTags -> 
                "FeynmanReduce"], Cell[BoxData[
                \(TraditionalForm\`\({\(Dimension \[Rule] D\), 
                      \(Flatten \[Rule] True\), \(Expand \[Rule] True\)}\)\)]\
, "Output", CellTags -> "FeynmanReduce"]}, Open]]}, Open]], 
        Cell[CellGroupData[{Cell["Examples", "Subsubsection", 
            CellTags -> "FeynmanReduce"], Cell[BoxData[""], "Input", 
            CellTags -> "FeynmanReduce"], Cell["Other objects that are \
considered to be ok or under active development:", "Text", 
            CellTags -> "Experimental"], Cell[CellGroupData[{Cell[BoxData[
                \({ChargeConjugationMatrix,\ DiracGammaT,\ SquareAmplitude}\)]\
, "Input", CellTags -> "Experimental"], Cell[BoxData[
                \(TraditionalForm\`\({C, DiracGammaT, SquareAmplitude}\)\)], 
               "Output", CellTags -> "Experimental"]}, Open]], 
           Cell["Objects that are under consideration for being discarded:", 
            "Text", CellTags -> "Experimental"], Cell[CellGroupData[
             {Cell[BoxData[
                \({$OPEWard, $AchmedRoss, Contract2, SpinSumExternalMomentum,
                     SelectedGraphs}\)], "Input", CellTags -> 
                "Experimental"], Cell[BoxData[
                \(TraditionalForm\`\({False, False, Contract2, 
                      SpinSumExternalMomentum, SelectedGraphs}\)\)], 
               "Output", CellTags -> "Experimental"]}, Open]], 
           Cell[CellGroupData[{Cell["AbsoluteTime[]-absolutestarttime", 
               "Input"], Cell[BoxData[
                \(TraditionalForm\`237.1309776`9.826533285230221\)], 
               "Output"]}, Open]], Cell[BoxData["\[IndentingNewLine]"], 
            "Input"]}, Open]]}, Open]]}, Open]]}, 
 ScreenRectangle -> {{0., 1024.}, {0., 723.}}, 
 ScreenStyleEnvironment -> "AllBrackets", WindowToolbars -> "EditBar", 
 WindowSize -> {767., 643.}, WindowMargins -> 
  {{41., Automatic}, {Automatic, 0.}}, PrintingStartingPageNumber -> 1, 
 PrintingPageRange -> {Automatic, Automatic}, 
 PageHeaders -> {{Inherited, Cell[TextData[ValueBox["FileName"]], "Header"], 
    Inherited}, {Inherited, Cell[TextData[ValueBox["FileName"]], "Header"], 
    Inherited}}, PageFooters -> 
  {{Inherited, Cell[TextData[ValueBox["DateLong"]], "Footer"], Inherited}, 
   {Inherited, Cell[TextData[ValueBox["DateLong"]], "Footer"], Inherited}}, 
 PrintingOptions -> {"PrintingMargins" -> {{54., 54.}, {72., 72.}}, 
   "PaperSize" -> {597.5625, 842.375}, "PaperOrientation" -> "Portrait", 
   "PrintCellBrackets" -> False, "PrintSelectionHighlighting" -> False, 
   "PrintRegistrationMarks" -> True, "PrintMultipleHorizontalPages" -> False, 
   "FirstPageHeader" -> False, "FirstPageFooter" -> True, 
   "FacingPages" -> True, "FirstPageFace" -> Left, 
   "GraphicsPrintingFormat" -> "Automatic", "Magnification" -> 1.}, 
 PrivateNotebookOptions -> {"ShortBoxForm" -> False}, ShowSelection -> True, 
 TaggingRules :> {"MakeContentsNonDefaultOptions" -> 
    {AutomaticCellTagging -> FromContent, PageNumbers -> False, 
     SaveOptions -> True, SelectCellStyles -> {"Section", "Subsection"}, 
     TOCCellStyles -> {"Contents", "Index"}}}, CellLabelAutoDelete -> True, 
 ShowCellTags -> True, Magnification -> 1., 
 StyleDefinitions -> "HelpBrowser.nb"]
